(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)































BeginPackage[ "adMath`Unit`" ];



If[$VersionNumber\[LessEqual]4.9999, 
    CellPrint @ 
      Cell[BoxData[
          StyleBox[
            "This version of Unit package is designed for run in Mathematica \
5.0. To obtain an earlier version contact me at alvarodiazfalconi@yahoo.com", 
            "Message",FontWeight\[Rule]"Bold"]], "Output"]];



Unprotect["adMath`Unit`*"];
ClearAll@@Complement[Names["adMath`Unit`*"],{"AutoLoadUnitPalette"}];
ClearAll["adMath`Unit`Private`*"];



{Unit,$Unit,UnitQ,
    UnitD,UnitN,UnitK,UnitS,UnitI,
    UnitConvert,UnitSimplify,
    UnitFullSimplify,UnitPowerExpand,UnitComplexExpand,
    UnitDIM,UnitMKS,UnitCGS,UnitFPS,
    Temperature,Angle,
    Base,Derived,Combined,
    Equivalence,System,
    Author};





Unit::"usage"="
X = Unit[x] represent the unit named x.\n
Setting Utilities: (SYS = UnitMKS|UnitCGS|UnitFPS):\n
> Unit[Set, All]        Restore original definitions.\n
> Unit[Set, SYS]        Set SYS as default (or $Unit = SYS)\n
> Unit[Set, a \[Rule] b]      Set b as default otput for a.\n
Dimension Utilities:    See UnitD, UnitN.\n
Information Utilities:  See UnitI.\n
See Also: UnitConvert, UnitSimplify.";



UnitI::"usage"="
Unit package Information Utilities:\n
> UnitI[ X ]       Information about the unit X.\n
> UnitI[ SYS ]     Information about the unit system named SYS.\n
> UnitI[ Names ]   List of avaibles units.\n
> UnitI[ Prefix ]  List of avaibles prefixes.\n
> UnitI[ D ]       List of Base dimensions.\n
> UnitI[ N ]       List of avaibles dimensions names.\n
> UnitI[ Author ]  Information about the Author.\n\n
See Also: Unit, UnitCGS, UnitFPS, UnitMKS, UnitConvert, UnitSimplify.";



UnitQ::usage="UnitQ[x] is simplelly !FreeQ[x,Unit]. See Also: Unit.";



$Unit::"usage"=
    "$Unit = SYS  (SYS = UnitMKS|UnitCGS|UnitFPS) changes the output to the \
specified unit system. See Also: Unit." ;



UnitD::"usage"="UnitD[X] give the dimensions of X. See UnitI[D] for a list of \
defined dimensions. See Also: Unit."



UnitN::"usage"="UnitN[x] give the dimensions names of x. See UnitI[N] for a \
list of defined dimensions names. See Also: Unit."



UnitK::"usage"="
UnitK[expr] substitute in expr symbols of defined constants with constants \
values. See Also: Unit.";



UnitS::"usage"="
UnitS[expr] substitute in expr symbols of defined units with unit definition. \
By default, UnitS only substitute units names larger than 4 letters. \
UnitS[expr, length] do the substitution with the specified length. See Also: \
Unit.";



UnitConvert::usage="UnitConvert[ newsys ] [ oldunits ] convert oldunits to \
the unit system newsys.\nUnitConvert[ newunit ] [ oldunit ] convert oldunits \
to newunit. See Also: Unit."



UnitSimplify::"usage"=
    "UnitSimplify[expr] simplify expr involving units. \
UnitSimplify[expr,assum] works like Simplify. See Also: Unit.";



UnitFullSimplify::"usage"=
    "UnitFullSimplify[expr] simplify expr involving units. \
UnitFullSimplify[expr,assum] works like UnitFullSimplify. See Also: Unit.";



UnitPowerExpand::"usage"=
    "UnitPowerExpand[expr] expands all powers of products and powers. See \
Also: Unit.";



UnitComplexExpand::"usage"=
    "UnitComplexExpand[expr] expands expr assuming that all variables are \
real. UnitComplexExpand[expr, {x1, x2, ... }] expands expr assuming that \
variables matching any of the xi are complex. See Also: Unit.";



UnitDIM::usage=
  "UnitDIM is the symbol to refer for unit package dimensions names.\n    See \
Also: Unit."



Unit::"gshadw"=
    "The symbol '`1`' has been cleaned from the global context by the Unit \
package.";

UnitConvert::"badUnit"="Can't convert `1` to `2`.";
UnitConvert::"badPlus"="Can't add `1`.";



Begin["`Private`"];



unitPublicFunctions=("Global`"<>#&)/@{
        "Unit","UnitQ","UnitI","UnitK","UnitS",
        "UnitConvert","UnitSimplify",
        "UnitFullSimplify","UnitPowerExpand","UnitComplexExpand",
        "UnitDIM","UnitMKS","UnitCGS","UnitFPS"};

With[{toclean=(Names["Global`*"])\[Intersection]unitPublicFunctions},
  If[toclean=!={},
    (Message[Unit::"gshadw",#1]&)/@
      (StringDrop[#1,7]&)/@toclean;
    Unprotect/@toclean;
    ClearAll/@toclean;
    Remove/@toclean;]]

End[(*`Private`*)];





Begin["`Private`"];

(* This symbols can be preserve for better use *)
Unit[Base,x___]:=Unit["Base",x];
Unit[Derived,x___]:=Unit["Derived",x];
Unit[Combined,x___]:=Unit["Combined",x];
Unit[Equivalence,x___]:=Unit["Equivalence",x];
Unit[System,x___]:=Unit["System",x];
Unit[Temperature,x___]:=Unit["Temperature",x];
Unit[Angle,x___]:=Unit["Angle",x];
UnitI[Author]:=UnitI["Author"];



myTable[X_]:=
    StandardForm@TableForm[DeleteCases[X,Null],TableAlignments\[Rule]Left];



Attributes[ts]={HoldFirst}
ts[x_]:=ToString[Unevaluated@x,InputForm];
ts[x_,y_]:=Sequence[
      ToString[Unevaluated@x,InputForm],
      ToString[Unevaluated@y,InputForm]];

\!\(Attributes[tsN] = {HoldFirst}\[IndentingNewLine]
  \(tsN[p_Symbol\_q__] := ToString[p\_q, StandardForm];\)\)



Attributes[UnitE]={HoldFirst};
UnitE[x_]:=Unit[Evaluate@x];



(* --- ListToRules *)
ListToRules[x_]:=(*Dispatch@*)
    List@@(Unevaluated@@x//.
            {a_,b_,c__}\[RuleDelayed]Sequence[{a,b},{b,c}]/.{a_,
              b_}\[RuleDelayed]a\[Rule]b);



(* --- ReverseRule *)
rr[t_]:=Reverse[t/.\[InvisibleSpace](a_\[Rule]b_)\[RuleDelayed]b\[Rule]a];
rrf[t_]:=Reverse[
      t/.\[InvisibleSpace](a_\[Rule]b_)\[RuleDelayed]rrF[b]\[Rule]a];





(* --- dpe *)

dpe[x_,n_]:=Block[{$Messages},Rationalize[PowerExpand[x/n],0]];





(* Unit D&N are Listable and Constants *)
Attributes[UnitD]=Attributes[UnitN]={Listable,Constant};



(* --- Find Unit Dimensions *)
UnitD[x_/;!UnitQ[x]]:=1;
UnitD[x_/;UnitQ[x]]:=
    Module[{\[ScriptA],\[ScriptX]},x/.
        \[ScriptA]_. Unit[\[ScriptX]_]\[RuleDelayed]
          Module[{X=\[ScriptX],u,T="Temperature",all=Unit["System",All]},
              
              X=X//.{"\[Degree]\[DoubleStruckCapitalC]"\[Rule]T,
                    "\[Degree]\[DoubleStruckCapitalF]"\[Rule]T,
                    "\[Degree]\[DoubleStruckCapitalK]"\[Rule]T,
                    "\[Degree]\[DoubleStruckCapitalR]"\[Rule]T};
              X=X//.Times[a__,s_String]\[RuleDelayed]s/;!UnitQ[a,String];
              
              X=X//.\[InvisibleSpace]table//.\[InvisibleSpace]Unit[Names,
                    All];
              
              Do[X=X//.\[InvisibleSpace]Unit["Derived",
                      all\[LeftDoubleBracket]k\[RightDoubleBracket]],{k,
                  Length@all}];
              X=X//.Unit["Equivalence",All];
              X=X//.rr@Unit["Base",UnitDIM];
              n=X//.s_String\[RuleDelayed]1;
              X=dpe[X,n];
              UnitE[X]]/;!UnitQ[\[ScriptA]]];



(* --- Find Unit Dimension Name. *)
UnitN[x_]:=Module[{u,t},
      UnitD[x]/.Unit[t_]\[RuleDelayed]u[rrF[t]]//.
            rrf@Unit["Derived",UnitDIM]//.
          rrF[t_]\[RuleDelayed]t/.u\[RuleDelayed]Unit];





uN[x_]:=x//.Unit[_]\[RuleDelayed]1;



uS[x_]:=x//.Unit[u_]\[RuleDelayed]u;





(* --- Internal UnitConverter *)

uc[x_]:=uc[x,$unit];
uc[x_,UnitMKS]:=
    Module[{X=x,n,s,t,all=Unit["System",All]},
      X=X//.\[InvisibleSpace]table//.\[InvisibleSpace]Unit[Names,All];
      Do[X=
          X//.\[InvisibleSpace]Unit["Derived",
              a\[LeftDoubleBracket]k\[RightDoubleBracket]],{k,Length@a}];
      X=X//.\[InvisibleSpace]Unit["Equivalence",All];
      n=X//.\[InvisibleSpace]s_String\[RuleDelayed]1;
      X=dpe[X,n];
      X=X//.\[InvisibleSpace]rr[Unit["Base",UnitMKS]];
      X=rrF[X]//.\[InvisibleSpace]rrf[Unit["Derived",UnitDIM]]//.rrF[
              t_]\[RuleDelayed]t;
      X=X//.\[InvisibleSpace]Unit[Dimensions,UnitMKS];
      X=X//.\[InvisibleSpace]Unit["Derived",UnitDIM]//.\[InvisibleSpace]Unit[
            "Base",UnitDIM];
      X=X//.\[InvisibleSpace]Unit[Rule,All];
      {n,X}];
uc[x_,sys_Symbol]:=
    Module[{X=x,y,n,s,t,all=Unit["System",All]},
      X=X//.Unit["Derived",UnitDIM]//.Unit["Base",sys]//.Unit["Base",
            UnitMKS];
      X=X//.\[InvisibleSpace]table//.\[InvisibleSpace]Unit[Names,All];
      Do[X=
          X//.\[InvisibleSpace]Unit["Derived",
              a\[LeftDoubleBracket]k\[RightDoubleBracket]],{k,Length@a}];
      X=X//.\[InvisibleSpace]Unit["Equivalence",All];
      n=X//.\[InvisibleSpace]s_String\[RuleDelayed]1;
      y=X=dpe[X,n];
      X=X//.\[InvisibleSpace]rr[Unit["Base",UnitMKS]];
      X=rrF[X]//.\[InvisibleSpace]rrf[Unit["Derived",UnitDIM]]//.rrF[
              t_]\[RuleDelayed]t;
      X=X//.\[InvisibleSpace]Unit[Dimensions,sys];
      X=X//.\[InvisibleSpace]Unit["Derived",UnitDIM]//.\[InvisibleSpace]Unit[
              "Base",sys]//.\[InvisibleSpace]Unit["Base",UnitDIM];
      X=X//.\[InvisibleSpace]Unit[Rule,All];
      X=X//.\[InvisibleSpace]Unit[Dimensions,sys]//.Unit[Dimensions,UnitMKS];
      y=y/X//.\[InvisibleSpace]table//.\[InvisibleSpace]Unit[Names,All];
      Do[y=
          y//.\[InvisibleSpace]Unit["Derived",
              a\[LeftDoubleBracket]k\[RightDoubleBracket]],{k,Length@a}];
      y=y//.\[InvisibleSpace]Unit["Equivalence",All];
      {y n,X}];





(* --- UnitSimplify *)

us[x_]:=us[x,$unit];
us[x_/;!UnitQ[x],___]:=x;
us[x_/;UnitQ[x],sys_Symbol]:=x/.
      Unit[u_]\[RuleDelayed]UnitE[Times@@uc[u,sys]];







\!\(\(\( (*\ \(--\(-\ 
        uPlus\)\)\ *) \)\(\[IndentingNewLine]\)\(\[IndentingNewLine]\)\(uPlus[
        X_] := \(X //. \[IndentingNewLine]HoldPattern[
              a_.  Unit[x_] + b_. \ Unit[x_]] \[RuleDelayed] \((a + b)\) 
              Unit[x]\) //. \[IndentingNewLine]\((a_. \ Unit[x_])\)\^n_ \
\[RuleDelayed] \(a\^n\) Unit[x]\^n;\)\)\)





(* --- nUnit *)

numerical[x_]:=
    With[{n=N/.Options[Unit]},
      If[n===True,N[x],N[x,n]]];





(* ========= NORMAL UNIT ========= *)

Unprotect[Normal];
Normal[x_?UnitQ]:=Normal[uN@x];
Protect[Normal];





\!\(\(\( (*\ \(===\)\(===\)\(===\)\(\ \)\(UnitQ\)\(\ \)\(===\)\(===\)\(===\)\ \
*) \)\(\[IndentingNewLine]\)\(\[IndentingNewLine]\)\( (*\ 
    Discussion : \[IndentingNewLine]UnitQ\ is\ not\ very\ sophisticated . \ 
          We\ need\ the\ question\ \[IndentingNewLine]in\ this\ form\ to\ \
recognize\ the\ word\ Unit, \ 
    not\ if\ x\ have\ units . \ 
        The\ other\ forms\ are\ only\ for\ test\ \(\(purposes\)\(.\)\)\ *) \)\
\(\[IndentingNewLine]\)\(\[IndentingNewLine]\)\( (*\ \(--\(-\ 
        Basic\)\)\ *) \)\(\[IndentingNewLine]\)\(\(UnitQ[
        x_] := \(! FreeQ[x, 
          Unit]\);\)\[IndentingNewLine]\[IndentingNewLine] (*\ \(--\(-\ \
\(Utitlity : \ f\)\)\)\  = \ And, \ Or\ *) \[IndentingNewLine]
  \(UnitQ[x_, f_[cmd__]] := 
      f @@ \(UnitQ[
            x, #] /@ {cmd}\);\)\[IndentingNewLine]\[IndentingNewLine] (*\ \(\
--\(-\ Names\)\)\  = \ any\ Unit\ *) \[IndentingNewLine]
  \(UnitQ[x_, Names] := 
      MemberQ[UnitI[Names], x];\)\n\[IndentingNewLine] (*\ \(--\(-\ 
        Real\)\)\ *) \[IndentingNewLine]
  \(UnitQ[x_, 
        Real] := \[Not] FreeQ[
          x, _Real];\)\[IndentingNewLine]\[IndentingNewLine] (*\ \(--\(-\ 
        Rational\)\)\ *) \[IndentingNewLine]
  \(UnitQ[x_, Rational] := \[IndentingNewLine]If[
        FreeQ[x, _Integer], \[IndentingNewLine]If[
          FreeQ[x, _Rational], \[IndentingNewLine]False, \
\[IndentingNewLine]True], \[IndentingNewLine]True];\)\[IndentingNewLine]\
\[IndentingNewLine] (*\ \(--\(-\ String\)\)\ *) \[IndentingNewLine]
  \(UnitQ[x_, 
        String] := \[Not] FreeQ[
          x, _String];\)\[IndentingNewLine]\[IndentingNewLine] (*\ \(--\(-\ 
        System\)\)\ *) \[IndentingNewLine]
  \(UnitQ[x_Symbol, "\<System\>"] := 
      MemberQ[Unit["\<System\>", All], 
        x];\)\[IndentingNewLine]\[IndentingNewLine] (*\ \(--\(-\ 
        Variables\)\)\ *) \[IndentingNewLine]
  \(UnitQ[x_, 
        Variables] := \[IndentingNewLine]\(! Cases[
            Flatten@{x}, _Symbol?\((\((\[InvisibleSpace]\(! NumericQ[#]\))\)\ \
 && \ AtomQ[#] &)\), \[Infinity]] === {}\);\)\[IndentingNewLine]\
\[IndentingNewLine] (*\ \(--\(-\ \(Format : \ 
          Times\ and\ Powers\ of\ Strings\)\)\)\ *) \[IndentingNewLine]
  \(UnitQ[s_, Format] := 
      Module[{q, x, y, m}, \[IndentingNewLine]q[x_String] := 
          True; \[IndentingNewLine]q[x_String\^m_] := 
          UnitQ[m, Rational]; \[IndentingNewLine]q[x_\ y_] := 
          q[x] \[And] q[y]; \[IndentingNewLine]TrueQ@q[s]];\)\)\)\)





Attributes[UnitI]={HoldFirst}

(* --- Little Information Utilities *)
UnitI["Author"]:={"(c) 2004","Alvaro Diaz Falconi",
      "alvarodiazfalconi@yahoo.com"};
UnitI[Names]:=
    Union@Cases[{Unit[Rule,All],Unit[Names,All],Unit[Table,All]},
        _String,{0,\[Infinity]}];
UnitI[N]:=
    Union@Cases[Unit["Derived",UnitDIM]/.(a_\[Rule]b_)\[RuleDelayed]a,
        _String,{0,\[Infinity]}];
UnitI[D]:=
    Union@Cases[Unit["Derived",UnitDIM]/.(a_\[Rule]b_)\[RuleDelayed]b,
        _String,{0,\[Infinity]}];

\!\(\(\( (*\ \(===\)\(===\)\(\ \)\(INFORMATION\ Prefixes\)\ *) \)\(\
\[IndentingNewLine]\)\(\[IndentingNewLine]\)\(UnitI[Prefix] = 
      myTable@\(N@\n{"\<Prefixes\>", "\<=====================\>", \
\[IndentingNewLine]{{"\<Percent\>" \[Rule] 1/100}, {"\<Gross\>" \[Rule] 
                  144}, {"\<Dozen\>" \[Rule] 12}, {"\<BakersDozen\>" \[Rule] 
                  13}}, \[IndentingNewLine]{{"\<Mole\>" \[Rule] \("\<mol\>" \
\[Rule] 6.0221367\ 10\^23\)}, {"\<Yotta\>" \[Rule] \("\<\[ScriptCapitalY]\>" \
\[Rule] 10\^24\)}, {"\<Zetta\>" \[Rule] \("\<\[ScriptCapitalZ]\>" \[Rule] 
                    10\^21\)}, {"\<Exa\>" \[Rule] \("\<\[ScriptCapitalE]\>" \
\[Rule] 10\^18\)}}, \[IndentingNewLine]{{"\<Peta\>" \[Rule] \("\<\
\[ScriptCapitalP]\>" \[Rule] 
                    10\^15\)}, {"\<Tera\>" \[Rule] \("\<\[ScriptCapitalT]\>" \
\[Rule] 10\^12\)}, {"\<Giga\>" \[Rule] \("\<\[ScriptCapitalG]\>" \[Rule] 
                    10\^9\)}, {"\<Mega\>" \[Rule] \("\<\[ScriptCapitalM]\>" \
\[Rule] 10\^6\)}}, \[IndentingNewLine]{{"\<Kilo\>" \[Rule] \("\<\[ScriptK]\>" \
\[Rule] 10\^3\)}, {"\<Hecto\>" \[Rule] \("\<\[ScriptH]\>" \[Rule] 
                    100\)}, {"\<Deca\>" \[Rule] \("\<\[ScriptD]\[ScriptA]\>" \
\[Rule] 10\)}, {"\<Deci\>" \[Rule] \("\<\[ScriptD]\>" \[Rule] 
                    10\^\(-1\)\)}}, \[IndentingNewLine]{{"\<Centi\>" \[Rule] \
\("\<\[ScriptC]\>" \[Rule] 
                    10\^\(-2\)\)}, {"\<Milli\>" \[Rule] \("\<\[ScriptM]\>" \
\[Rule] 10\^\(-3\)\)}, {"\<Micro\>" \[Rule] \("\<\[Mu]\>" \[Rule] 
                    10\^\(-6\)\)}, {"\<Nano\>" \[Rule] \("\<\[ScriptN]\>" \
\[Rule] 10\^\(-9\)\)}}, \[IndentingNewLine]{{"\<Pico\>" \[Rule] \("\<\
\[ScriptP]\>" \[Rule] 
                    10\^\(-12\)\)}, {"\<Femto\>" \[Rule] \("\<\[ScriptF]\>" \
\[Rule] 10\^\(-15\)\)}, {"\<Atto\>" \[Rule] \("\<\[ScriptA]\>" \[Rule] 
                    10\^\(-18\)\)}, {"\<Zepto\>" \[Rule] \("\<\[ScriptZ]\>" \
\[Rule] 10\^\(-21\)\)}}, \[IndentingNewLine]{"\<Yocto\>" \[Rule] \("\<\
\[ScriptY]\>" \[Rule] 10\^\(-24\)\)}}\);\)\)\)

\!\(\(\( (*\ \(===\)\(===\)\(\ \)\(INFORMATION\ UNIT\)\ *) \)\(\
\[IndentingNewLine]\)\(\[IndentingNewLine]\)\(\(UnitI[
        a__ . \ Unit[p_Symbol\_q__]] := 
      UnitI[a\ ToString[p\_q, StandardForm]] /; \(! UnitQ[
            a]\);\)\[IndentingNewLine]
  \(UnitI[a__ . \ Unit[x_Symbol]] := 
      UnitI[a\ ts@x] /; \(! UnitQ[a]\);\)\[IndentingNewLine]
  \(UnitI[a__ . \ Unit[x_]] := 
      UnitI[a\ x] /; \(! UnitQ[
            a]\);\)\[IndentingNewLine] (*\(UnitI[\[ScriptU]_?UnitQ] := 
        UnitI[uS@\[ScriptU]];\)*) \[IndentingNewLine]\[IndentingNewLine]
  \(UnitI[\[ScriptU]_] := 
      Module[{X, x, a, b, all, unf, M, uD, uN, uND, xn, xs, f, g, h, u, p, q, 
            m, cInfo, 
            list}, \[IndentingNewLine]x = \[ScriptU] // 
              uS //. \[InvisibleSpace]a___\ t_Symbol\^m_. \ b___ \
\[RuleDelayed] a\ ts[t]\^m\ b; \[IndentingNewLine]a = 
            x //. \[InvisibleSpace]_String \[Rule] 1; \[IndentingNewLine]x = 
            dpe[x, a]; \[IndentingNewLine]X = 
            UnitE[a\ x]; \[IndentingNewLine]\[IndentingNewLine]hu = \(Hold[\
\[ScriptU]] /. Unit \[Rule] Hold\) //. 
              Hold[x_] \[Rule] x; \[IndentingNewLine]cInfo = 
            If[NumericQ @@ 
                UCR[hu], \[IndentingNewLine]{"\<Relative Uncertainty\>", 
                g @@ UCR[
                    hu]}, \[IndentingNewLine]Null]; \[IndentingNewLine]\
\[IndentingNewLine]f[sys_] := 
            Module[{h = N@sys[X]}, \[IndentingNewLine]If[
                h == X && 
                  Head[x] === 
                    String, \[IndentingNewLine]If[\(! FreeQ[
                      Unit["\<Base\>", sys], x]\), \[IndentingNewLine]h = 
                    x <> "\< is a Base Unit.\>", \[IndentingNewLine]h = 
                    x <> "\< is a Derived Unit.\>"], \[IndentingNewLine]h = 
                  g[h]]; h]; \[IndentingNewLine]g[u_] := 
            ToString[u, StandardForm]; \[IndentingNewLine]all = 
            Unit[Names, All] \[Union] \[IndentingNewLine]Flatten[
                Cases[Unit[Table, All], \[IndentingNewLine]HoldPattern[
                    p_String \[Rule] 
                      q_String], {0, \[Infinity]}]]; \[IndentingNewLine]\
\[IndentingNewLine]uN = UnitN[X]; 
          uD = UnitD[X]; \[IndentingNewLine]If[{x} === 
              List @@ uD, \[IndentingNewLine]If[
              MemberQ[\[IndentingNewLine]Complement[\[IndentingNewLine]Cases[
                    Unit[Definition, 
                      UnitDIM], _String, {0, \[Infinity]}], \
\[IndentingNewLine]{"\<Base\>", "\<Derived\>"}], \[IndentingNewLine]x], \
\[IndentingNewLine]Return[
                g[uD] <> "\< is a dimension.\>"]]]; \[IndentingNewLine]\
\[IndentingNewLine]uND = 
            If[uN === uD, g[uN], 
              g[g[uN] \[Rule] g[uD]]]; \[IndentingNewLine]unf[t_] := 
            Flatten[Select[
                  all, \(! FreeQ[#1, t]\) &] /. \[InvisibleSpace]Rule \[Rule] 
                  List]; \[IndentingNewLine]un = 
            unf[x]; \[IndentingNewLine]un = 
            Complement[
              Union[Flatten[\((unf[#1] &)\) /@ 
                    un]], {x}]; \
\[IndentingNewLine]\[IndentingNewLine]myTable[{\[IndentingNewLine]{"\<\
Information About: \>", 
                g[X] <> If[
                    NumericQ @@ 
                      UCR[hu], "\< (Constant)\>", "\<\>"]}, \
\[IndentingNewLine]{"\< \>", "\<------------------------------\>"}, \
\[IndentingNewLine]cInfo, \[IndentingNewLine]{"\<Dimensions:        \>", 
                uND}, \[IndentingNewLine]{"\<Other Names:       \>", 
                g[un]}, \[IndentingNewLine]Sequence @@ \(\(({g[#1] <> "\< \
Equivalent:\>", f[#1]} &)\) /@ Unit["\<System\>", All]\)}]] /; \(! UnitQ[a, 
            String]\);\)\)\)\)







T0=27315/100;

(* ========= AUTOMATIC CONVERTION ========= *)

Unit/: a_. Unit["\[Degree]\[DoubleStruckCapitalC]"]:=
    uct[a,"\[Degree]\[DoubleStruckCapitalC]",$unit];
Unit/: a_. Unit["\[Degree]\[DoubleStruckCapitalK]"]:=
    uct[a,"\[Degree]\[DoubleStruckCapitalK]",$unit];
Unit/: a_. Unit["\[Degree]\[DoubleStruckCapitalF]"]:=
    uct[a,"\[Degree]\[DoubleStruckCapitalF]",$unit];
Unit/: a_. Unit["\[Degree]\[DoubleStruckCapitalR]"]:=
    uct[a,"\[Degree]\[DoubleStruckCapitalR]",$unit];

(* ========= SCALE Temperature Converter ========= *)

(* --- Very basic question *)
uct[n_,"\[Degree]\[DoubleStruckCapitalK]","\[Degree]\[DoubleStruckCapitalK]"]:=
    n Unit["\[DoubleStruckCapitalK]"];
uct[n_,"\[Degree]\[DoubleStruckCapitalR]","\[Degree]\[DoubleStruckCapitalR]"]:=
    n Unit["\[DoubleStruckCapitalR]"];

(* --- UNITS and SYSTEM Converter *)
uct[n_,"\[Degree]\[DoubleStruckCapitalC]",y_]:=
    uct[n+T0,"\[Degree]\[DoubleStruckCapitalK]",y];
uct[n_,"\[Degree]\[DoubleStruckCapitalF]",y_]:=
    uct[(n-32) 5/9+T0,"\[Degree]\[DoubleStruckCapitalK]",y];
uct[n_,"\[Degree]\[DoubleStruckCapitalR]",y_]:=
    uct[n 5/9,"\[Degree]\[DoubleStruckCapitalK]",y];

(* --- SYSTEM Converter *)
uct[n_,x_String,sys_Symbol]:=
    uct[n,x,"\[Degree]"<>("Temperature"/.Unit["Base",sys])]/;
      MemberQ[Unit["System",All],sys];

(* --- UNIT: Converter *)
uct[n_,"\[Degree]\[DoubleStruckCapitalK]",
      "\[Degree]\[DoubleStruckCapitalC]"]:=(n-T0)Unit[
        "\[DoubleStruckCapitalC]"];
uct[n_,"\[Degree]\[DoubleStruckCapitalK]",
      "\[Degree]\[DoubleStruckCapitalF]"]:=(n-T0) 9/5+32 Unit[
          "\[DoubleStruckCapitalF]"];
uct[n_,"\[Degree]\[DoubleStruckCapitalK]","\[Degree]\[DoubleStruckCapitalR]"]:=
    n 9/5 Unit["\[DoubleStruckCapitalR]"];

(* ====== NOT FORGET ====== *)

(* --- Only the defined values *)
uct[n_,x_,y_]:=n Unit[x];



\!\(\(\( (*\ \(--\(-\ 
          Temperature\)\)\ problem\ \
*) \)\(\[IndentingNewLine]\)\(\(\(UnitConvert[
          Unit["\<\[Degree]\[DoubleStruckCapitalC]\>"]]\)[
        x_ /; UnitQ[x]] := \(UnitConvert[
          Unit["\<\[DoubleStruckCapitalC]\>"]]\)[x];\)\[IndentingNewLine]
  \(\(UnitConvert[Unit["\<\[Degree]\[DoubleStruckCapitalK]\>"]]\)[
        x_ /; UnitQ[x]] := \(UnitConvert[
          Unit["\<\[DoubleStruckCapitalK]\>"]]\)[x];\)\[IndentingNewLine]
  \(\(UnitConvert[Unit["\<\[Degree]\[DoubleStruckCapitalF]\>"]]\)[
        x_ /; UnitQ[x]] := \(UnitConvert[
          Unit["\<\[DoubleStruckCapitalF]\>"]]\)[x];\)\[IndentingNewLine]
  \(\(UnitConvert[Unit["\<\[Degree]\[DoubleStruckCapitalR]\>"]]\)[
        x_ /; UnitQ[x]] := \(UnitConvert[
          Unit["\<\[DoubleStruckCapitalR]\>"]]\)[
        x];\)\[IndentingNewLine]\[IndentingNewLine] (*\ \(--\(-\ 
          Nothing\)\)\ to\ do\ *) \[IndentingNewLine]
  \(\(UnitConvert[_]\)[x_ /; \(! UnitQ[x]\)] := 
      x;\)\[IndentingNewLine]\[IndentingNewLine] (*\ \(--\(-\ 
          Listable\)\)\ on\ 2  nd\ arg\ *) \[IndentingNewLine]
  \(\(UnitConvert[y_]\)[x_List] := 
      UnitConvert[y] /@ 
        x;\)\[IndentingNewLine]\[IndentingNewLine] (*\ \(--\(-\ 
          Convertions\)\)\ between\ unit\ systems\ *) \[IndentingNewLine]
  \(\(UnitConvert[sys_Symbol:  $unit]\)[
        x_ /; UnitQ[x]] := \[IndentingNewLine]Module[{old, 
            u}, \[IndentingNewLine]old = $Unit; \[IndentingNewLine]$Unit = 
            UnitMKS; \[IndentingNewLine]u = 
            us[uPlus@x, 
              sys]; \[IndentingNewLine]If[\(! FreeQ[UnitN[u], Plus]\) \[And] 
              NumericQ[uN[x]], \[IndentingNewLine]Message[
              UnitConvert::"\<badPlus\>", 
              HoldForm[x]]]; \[IndentingNewLine]$Unit = 
            old; \[IndentingNewLine]u] /; 
        UnitQ[sys, "\<System\>"];\)\[IndentingNewLine]\[IndentingNewLine] (*\ \
\(--\(-\ Convertions\)\)\ between\ units\ *) \[IndentingNewLine]
  \(\(UnitConvert[y_Unit]\)[
        x_ /; UnitQ[x]] := \[IndentingNewLine]us[uPlus@\(us@x\)\/y]\ y /; 
        UnitN[x] == UnitN[y];\)\[IndentingNewLine]
  \(\(UnitConvert[y_Unit]\)[
        x_ /; UnitQ[x]] := \((\[IndentingNewLine]Message[
            UnitConvert::"\<badUnit\>", HoldForm@x, HoldForm@y]; 
          x)\) /; \[IndentingNewLine]UnitN[x] =!= UnitN[y] \[And] 
          NumericQ[uN@x];\)\)\)\)





(* ========= UnitSimplify ========= *)

Options[UnitSimplify]={Assumptions\[RuleDelayed]$Assumptions,
      ComplexityFunction\[Rule]Automatic,TimeConstraint\[Rule]300,
      TransformationFunctions\[Rule]Automatic,Trig\[Rule]True};
Options[UnitFullSimplify]={Assumptions\[RuleDelayed]$Assumptions,
      ComplexityFunction\[Rule]Automatic,ExcludedForms\[Rule]{},
      TimeConstraint\[Rule]\[Infinity],
      TransformationFunctions\[Rule]Automatic,Trig\[Rule]True};

UnitSimplify[x_,opt___]:=US[Simplify,x,opt];
UnitFullSimplify[x_,opt___]:=US[FullSimplify,x,opt];
UnitPowerExpand[x_]:=US[PowerExpand,x];
UnitComplexExpand[x_,opt___]:=US[ComplexExpand,x,opt];

US[F_,\[ScriptX]_/;!UnitQ[\[ScriptX]],opt___]:=
    F[Refine[\[ScriptX]],opt];

US[F_,\[ScriptX]_?UnitQ,opt___]:=
    
    Module[{X,x,y},
      
      (* --- Convert *)
      X=UnitConvert[$unit][\[ScriptX]];
      
      (* --- Modifiy some Unit definitions *)
      Unprotect[Unit];
      Unit/:Unit[_]\[Element]Reals=.;
      Unit/:Unit[_]>0=.;
      Unit/:Unit[_]\[GreaterEqual]0=.;
      Unit/:Unit[_]<0=.;
      Unit/:Unit[_]\[LessEqual]0=.;
      Protect[Unit];
      
      (* --- Call Simplify *)
      
      Assuming[
        
        Thread[Greater[#,0]&[Union@Cases[X,Unit[_],{0,\[Infinity]}]]],
        
        (* --- CoDomain of Unit function *)
        X=X//.a_. x_Unit\[Element]Reals\[RuleDelayed]a\[Element]Reals;
        
        (* --- Numerical Functions *)
        X=X//.Abs[a_.x_Unit]\[RuleDelayed]Abs[a]x;
        X=X//.Sign[a_.x_Unit]\[RuleDelayed]Sign[a];
        X=X//.Round[a_.x_Unit]\[RuleDelayed]Round[a] x;
        X=X//.IntegerPart[a_.x_Unit]\[RuleDelayed]IntegerPart[a] x;
        X=X//.FractionalPart[a_.x_Unit]\[RuleDelayed]FractionalPart[a] x;
        X=X//.Ceiling[a_.x_Unit]\[RuleDelayed]Ceiling[a] x;
        X=X//.Floor[a_.x_Unit]\[RuleDelayed]Floor[a] x;
        X=X//.Re[a_.x_Unit]\[RuleDelayed]Re[a] x;
        X=X//.Conjugate[a_.x_Unit]\[RuleDelayed]Conjugate[a] x;
        X=X//.Im[a_.x_Unit]\[RuleDelayed]Im[a]x;
        X=X//.Arg[a_.x_Unit]\[RuleDelayed]Arg[a];
        
        (* --- Vectorial Functions *)
        X=X//.Norm[a_.x_Unit]\[RuleDelayed]Norm[a]x;
        X=X//.Dot[y_,a_.x_Unit]\[RuleDelayed]Dot[y,a] x;
        X=X//.Dot[a_.x_Unit,y_]\[RuleDelayed]Dot[a,y] x;
        X=X//.Cross[y_,a_.x_Unit]\[RuleDelayed]Cross[y,a] x;
        X=X//.Cross[a_.x_Unit,y_]\[RuleDelayed]Cross[a,y] x;
        
        X=F[Refine[X],opt]];
      
      (* --- Restore Unit definitions *)
      Unprotect[Unit];
      Unit/:Unit[_]\[Element]Reals=True;
      Unit/:Unit[_]>0=True;
      Unit/:Unit[_]\[GreaterEqual]0=True;
      Unit/:Unit[_]<0=False;
      Unit/:Unit[_]\[LessEqual]0=False;
      Protect[Unit];
      
      X];





\!\(\(UnitK[
        X_] := \[IndentingNewLine]us[\(X /. 
            p_Symbol\_q__ \[RuleDelayed] 
              Unit[p\_q] /; 
                NumericQ @@ 
                  UCR[tsN@
                      p\_q]\) /. \[IndentingNewLine]x_Symbol \[RuleDelayed] 
            Unit@\(ts@x\) /; NumericQ @@ UCR[ts@x]];\)\)





Options[UnitS]={StringLength\[Rule]3};
UnitS[X_,opt___?OptionQ]:=UnitK[X/.x_Symbol\[RuleDelayed]Unit@ts@x/;
            MemberQ[Select[
                UnitI[Names],
                
                StringLength[#]>(StringLength/.Flatten@{opt}/.Options[
                          UnitS])&],
              ts@x]];





Attributes[Unit]={HoldFirst,Constant};

Options[Unit]={
      Automatic\[Rule]False,
      N\[Rule]False,
      StyleBox\[Rule]{FontColor\[Rule]GrayLevel[0.5]}};

(* Initialize *)
Unit[Rule,All]=
    Unit["System",All]=
      Unit[Names,All]=
        Unit[Table,All]={};

(* Convertion *)
Unit[x_?UnitQ,y_?UnitQ]:=x/y;



\!\(\(\( (*\ \(--\(-\ Convert\)\)\ Unit[
        x]\ to\ Unit["\<x\>"]\ and\ Simplify\ \
*) \)\(\[IndentingNewLine]\)\(\(Unit[p_Symbol\_q__] := 
      us@\(Unit@\(Evaluate@tsN[p\_q]\)\)\ ;\)\[IndentingNewLine]
  \(Unit[a___\ x_Symbol\^m_. \ b___] := 
      Unit[Times@a]\ Unit[x]\^m\ Unit[Times@b];\)\[IndentingNewLine]
  \(Unit[x_Symbol\^m_. ] := 
      us[Unit@\(Evaluate@ts[x]\)]\^m;\)\[IndentingNewLine]\[IndentingNewLine] \
(*\ \(--\(-\ \(UpValue : \ Unit\ of\ Powers\)\)\)\ *) \[IndentingNewLine]
  \(Unit /: Unit[x_]\^m_?NumericQ := 
      us[Unit[x\^m]];\)\[IndentingNewLine]\[IndentingNewLine] (*\ \(--\(-\ \
\(UpValue : \ Unit\ of\ Times\ of\ Units\)\)\)\ *) \[IndentingNewLine]
  \(Unit /: a_. \ \ Unit[x_]\ Unit[y_] := 
      a\ us@Unit[x\ y];\)\[IndentingNewLine]
  \(Unit /: a_. \ x_Unit\ y_Unit\^n_?NumericQ := 
      a\ us@Unit[
            x\[LeftDoubleBracket]1\[RightDoubleBracket]\ \
y\[LeftDoubleBracket]1\[RightDoubleBracket]\^n];\)\[IndentingNewLine]
  \(Unit /: 
      Times[a_ /; UnitQ[a], 
        Unit[x_]] := \[IndentingNewLine]With[{n = 
            uN[a]}, \[IndentingNewLine]With[{A = 
                dpe[uS[a], n]}, \[IndentingNewLine]n\ us[
                  Unit[A\ x]] /; \[IndentingNewLine]\(! UnitQ[A, 
                    Variables]\) \[And] 
                UnitQ[A, Format]] /; \[IndentingNewLine]\(! UnitQ[n, 
              String]\)];\)\[IndentingNewLine]\[IndentingNewLine] (*\ \(--\(-\
\ Out\)\)\ Numbers\ *) \[IndentingNewLine]
  \(Unit[x_] := Rationalize[x, 0] /; NumericQ[x];\)\[IndentingNewLine]
  \(Unit[a_\ x_] := 
      Rationalize[a, 0]\ Unit[x] /; 
        NumericQ[a] \[And] 
          UnitQ[x, String];\)\n\[IndentingNewLine] (*\ \(--\(-\ 
          Convert\)\)\ Reals\ Numbers\ inside\ Unit\ to\ Rationals\ \
*) \[IndentingNewLine]
  \(Unit[x_ /; 
          UnitQ[x, Real]] := \[IndentingNewLine]With[{a = 
            Rationalize[x, 0]}, \[IndentingNewLine]Unit@\(Evaluate@
              a\) /; \(! UnitQ[a, 
              Real]\)];\)\[IndentingNewLine]\n (*\ \(--\(-\ 
          Out\)\)\ Unit\ from\ Unit\ \((Flatten\ on\ 1  
          st\ var)\)\ *) \[IndentingNewLine]
  \(Unit[x_?UnitQ] := 
      us@\(EUnit@\(uS@
            x\)\);\)\[IndentingNewLine]\[IndentingNewLine] (*\ \(--\(-\ 
          Unit\)\)\ Listable\ on\ 1  st\ arg\ *) \[IndentingNewLine]
  \(Unit[x_List] := us[Unit /@ x];\)\)\)\)



(* --- UpValue: Make reals *)
Unit/:Times[a_/;UnitQ[a,Rational],Unit[x_]]:=
    numerical[a] Unit[x]/;(N/.Options[Unit])=!=False;



(* --- Unit Automatic - Simplify Unit["x"] *)
Unit[x_/;UnitQ[x,String]]:=With[{X=uc[x,$unit]},
        Unit@Evaluate[Times@@X]/;
          X\[LeftDoubleBracket]2\[RightDoubleBracket]=!=
            x]/;(Automatic/.Options[Unit])===True;



Unit[TagBox,StyleBox]:=Block[{},
      
      Unprotect[Unit];
      
      (* --- Unit Format *)
      Unit/:MakeBoxes[Unit[x_],StandardForm]:=
        TagBox[StyleBox[
            ToBoxes[Unevaluated[x],StandardForm],
            FontSlant\[Rule]Plain,ShowStringCharacters\[Rule]False,
            Sequence@@(StyleBox/.Options[Unit])],
          Unit];
      Unit/:MakeBoxes[Unit[x_],TraditionalForm]:=
        TagBox[StyleBox[
            ToBoxes[Unevaluated[x],TraditionalForm],
            FontSlant\[Rule]Plain,ShowStringCharacters\[Rule]False,
            Sequence@@(StyleBox/.Options[Unit])],
          Unit];
      
      Protect[Unit];
      
      "Notation for Unit set to InterpretationBox."];



Unit[Set,All]:=Block[{},
      Unit[TagBox,StyleBox];
      Unit[Unset,All];
      Unit[Set,UnitDIM];
      Unit[Set,UnitFPS];Unit[Set,UnitCGS];Unit[Set,UnitMKS]];



(* --- Attaching Rules *)

Unit[Set,{p__Rule}]:=Unit[Set,p];
Unit[Set,p__Rule]:=
    (Unit[Set,#]&/@{p};
      "Rules "<>ToString[{p},StandardForm]<>" attached.");

Unit[Set,a_\[Rule]b_]:=
    Module[{M=a\[Rule]b,v},
      v=Cases[Variables@{a,b},_Symbol];
      M={M}//.Thread@Rule[v,(ToString[#,InputForm]&)/@v];
      Unprotect[Unit];
      Unit[Rule,All]=Union[Unit[Rule,All],M];
      Protect[Unit];
      "Rule "<>ToString[M,StandardForm]<>" attached."];

(* --- Set Unit System *)

Unit[Set,system_Symbol,\[ScriptCapitalM]_List:{}]:=
    
    Module[{s,x,y,X,Y,f,g,h,M,\[GothicCapitalM],v,
        union,all,list,a,b,c,m,
        n,\[ScriptCapitalB],\[ScriptCapitalC],\[ScriptCapitalD],\
\[ScriptCapitalN],Q},
      
      Unprotect[Unit];
      s=ToString[Unevaluated@@system,InputForm];
      
      (* SYS[x] - Converter *)
      Unprotect[Evaluate@s];ClearAll[Evaluate@s];
      Evaluate[system][x_]:=
        With[{X=UnitConvert[system][x]},X/;
            FreeQ[X,UnitConvert]];
      If[system=!=UnitDIM,
        Evaluate[system]::usage=
          
          s<>" is a symbol for one unit system.\n    See Also: UnitI[ "<>s<>
            " ].\n"<>s<>"[x] convert the units in x.\n    See Also: Unit."];
      Attributes[Evaluate@system]={Listable,Protected,ReadProtected};
      
      If[\[ScriptCapitalM]==={},
        M=Unit[Definition,system],
        If[VectorQ[\[ScriptCapitalM]],
          M=Union[Unit[Definition,system],{\[ScriptCapitalM]}],
          M=\[ScriptCapitalM]];
        v=Cases[Variables@\[ScriptCapitalM],_Symbol];
        M=M//.Thread@Rule[v,(ToString[#,InputForm]&)/@v];
        If[FreeQ[{UnitDIM,UnitMKS,UnitCGS,UnitFPS},system],
          Unit[Definition,system]=M]];
      
      (* Auxiliar *)
      union[x_,all_:Unit["System",All]]:=
        Module[{Q={},m},
          
          Do[Q=Union[Q,
                Unit[Evaluate@x,
                  all\[LeftDoubleBracket]m\[RightDoubleBracket]]],
            {m,Length[all]}];Q];
      
      (* Equivalence,All *)
      Unit["Equivalence",All]=
        union["Equivalence",
            Complement[Unit["System",All],{system}]]/.
          (a_\[Rule]b_)\[RuleDelayed]Module[{n,x},
              n=b/.x_String\[RuleDelayed]1;
              Rationalize[b/n\[Rule]a/n,0]];
      
      (* Names *)
      \[ScriptCapitalN]=Unit[Names,system]=
          List@@(list@@Reverse@
                              Select[M,\[Not]FreeQ[#,"Base"|"Derived"]&]//.
                          {"Base",a_,b__,c_}\[RuleDelayed]{b,c}//.
                        {"Derived",a_,b__,
                            c_}\[RuleDelayed]{b}//.{x_}\[Rule]Sequence[]//.
                    {a_,b_,c__}\[RuleDelayed]Sequence[{a,b},{b,c}]/.
                  {a_,b_}\[RuleDelayed]a\[Rule]b)//.
            ("Derived"\[Rule]b_)\[RuleDelayed]Sequence[];
      \[GothicCapitalM]=M//. (* quito names *)
            {"Base",a_,X__,b_}\[RuleDelayed]{"Base",a,b}//.
          {"Derived",a_,X___,b_,c_}\[RuleDelayed]{"Derived",a,b,c};
      
      (* Auxiliar *)
      g[x_]:=Module[{y,Y},
          y=list@@Select[\[GothicCapitalM],MemberQ[#,x]&]/.
                {a__,b_,c_}\[RuleDelayed]{b,c}/.list\[Rule]List;
          Y={};
          Do[Do[
              
              AppendTo[Y,
                y\[LeftDoubleBracket]n,
                    m\[RightDoubleBracket]\[Rule]y\[LeftDoubleBracket]n,
                    m+1\[RightDoubleBracket]],
              {m,Length[y\[LeftDoubleBracket]n\[RightDoubleBracket]]-1}],{n,
              Length[y]}];
          Unit[x,system]=Union@Y];
      
      (* Assignaments *)
      \[ScriptCapitalB]=g["Base"];
      \[ScriptCapitalC]=g["Combined"];
      \[ScriptCapitalD]=g["Derived"];
      Q=g["Equivalence"];
      Unit[Dimensions,
          system]=\[ScriptCapitalB]\[Union]\[ScriptCapitalC]\[Union]
            (list@@Reverse@Select[\[GothicCapitalM],
                          MemberQ[#,"Derived"]&]//.
                    {a_,b_,X___,c_,d_}\[RuleDelayed]{b,c}/.
                  {a_,b_}\[RuleDelayed]a\[Rule]b/.
                list\[Rule]List)/.
          {"Derived",a_,b_}\[RuleDelayed]a\[Rule]b;
      
      (* Others All *)
      If[system=!=UnitDIM,
        Unit["System",All]=Union[Unit["System",All],{system}];
        $Unit=system;
        Unit[Names,All]=Union[Unit[Names,All],\[ScriptCapitalN]]];
      
      Protect[Unit];
      
      Unprotect[UnitI];
      h[x_,y_:system]:=ToString[Unit[Evaluate@x,y],StandardForm];
      UnitI[Evaluate@system]:=
        myTable[{
            {"Rules for: "<>s,""},
            {"--------------------- ",""},
            {"Unit[Base,"<>s<>"]",h["Base"]},
            {"Unit[Derived,"<>s<>"]",h["Derived"]},
            {"Unit[Combined,"<>s<>"]",h["Combined"]},
            {"Unit[Equivalence,"<>s<>"]",h["Equivalence"]},
            {"Unit[Names,"<>s<>"]",h[Names]},
            {"Unit[Dimensions,"<>s<>"]",h[Dimensions]},
            {"--------------------- ",""},
            {"Avaibles Systems:",h["System",All]},
            {"Default System:",h["System",Default]},
            {"--------------------- ",""}}];
      Protect[UnitI];
      
      UnitI[system]];



(* --- Deattaching Rules *)

Unit[Unset,{p__Rule}]:=Unit[Unset,p];
Unit[Unset,p__Rule]:=
    (Unit[Unset,#]&/@{p};
      "Rules "<>ToString[{p},StandardForm]<>" deattached.");

Unit[Unset,a_\[Rule]b_]:=
    Module[{M=a\[Rule]b,v},
      v=Cases[Variables@{a,b},_Symbol];
      M={M}//.Thread@Rule[v,(ToString[#,InputForm]&)/@v];
      Unprotect[Unit];
      Unit[Rule,All]=Complement[Unit[Rule,All],M];
      Protect[Unit];
      "Rule "<>ToString[M,StandardForm]<>" deattached."];

(* --- Uniting All *)

Unit[Unset,All]:=Module[{sys,g,m,x},
      
      Unprotect[Unit];
      
      (* sys *)
      sys=Unit["System",All];
      g[x_]:=Block[{$Messages},
          Do[
            Unit[x,sys\[LeftDoubleBracket]m\[RightDoubleBracket]]=.;
            Unprotect[Evaluate[sys]];
            Evaluate[sys]::usage=.,
            {m,Length[sys]}]];
      g/@{Names,"Base","Derived","Combined","Equivalence",Dimensions};
      
      (* All *)
      Unit[Rule,All]=Unit["System",All]=Unit[Names,All]={};
      $Unit=.;
      
      Protect[Unit];
      
      "All units systems are cleared."];

(* --- Unseting system *)

Unit[Unset,system_Symbol]:=
    
    Module[{def,all,sys},
      
      all=Unit["System",All];
      def=$unit;
      If[def\[Congruent]system,
        def=Complement[all,{def}]\[LeftDoubleBracket]1\[RightDoubleBracket]];
      sys=Complement[Unit["System",All],{system}\[Union]{def}];
      Unit[Unset,All];
      Unit[Set,#]&/@sys;
      Unit[Set,def];
      ToString@system<>" system are cleared."];



\!\(\(Unit[Definition, 
        UnitDIM] = \[IndentingNewLine]Module[{L, M, t, T, e, A, S, 
          i}, {\[IndentingNewLine]{"\<Base\>", "\<Length\>", "\<m\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<Mass\>", "\<kg\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<Time\>", "\<s\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<ElectricCurrent\>", "\<A\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<Temperature\>", "\<\[DoubleStruckCapitalK]\
\>"}, \[IndentingNewLine]{"\<Base\>", "\<Substance\>", "\<mol\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<LuminousIntensity\>", "\<cd\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<Angle\>", "\<rad\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<SolidAngle\>", "\<sr\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<Information\>", "\<bit\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<Money\>", "\<$\>"}, \
\[IndentingNewLine]{"\<Derived\>", "\<Acceleration\>", 
              L\/t\^2}, \[IndentingNewLine]{"\<Derived\>", "\<Action\>", \
\(L\^2\ M\)\/t}, \[IndentingNewLine]{"\<Derived\>", \
"\<AngularAcceleration\>", 
              A\/t\^2}, \[IndentingNewLine]{"\<Derived\>", \
"\<AngularSpeed\>", A\/t}, \[IndentingNewLine]{"\<Derived\>", "\<Area\>", 
              L\^2}, \[IndentingNewLine]{"\<Derived\>", \
"\<DynamicViscosity\>", 
              M\/\(L\ t\)}, \[IndentingNewLine]{"\<Derived\>", \
"\<ElectricCapacitance\>", \(e\^2\ t\^4\)\/\(L\^2\ M\)}, \
\[IndentingNewLine]{"\<Derived\>", "\<ElectricCharge\>", 
              t\ e}, \[IndentingNewLine]{"\<Derived\>", \
"\<ElectricConductance\>", \(e\^2\ t\^3\)\/\(L\^2\ M\)}, \
\[IndentingNewLine]{"\<Derived\>", "\<ElectricDipoleMoment\>", 
              e\ L\ t}, \[IndentingNewLine]{"\<Derived\>", \
"\<ElectricDisplacement\>", \(e\ t\)\/L\^2}, \
\[IndentingNewLine]{"\<Derived\>", "\<ElectricFieldStrength\>", \(L\ M\)\/\(e\
\ t\^3\)}, \[IndentingNewLine]{"\<Derived\>", "\<ElectricPermittivity\>", \(e\
\^2\ t\^2\)\/\(L\ M\)}, \[IndentingNewLine]{"\<Derived\>", \
"\<ElectricPolarizability\>", \(e\^2\ t\^4\)\/M}, \
\[IndentingNewLine]{"\<Derived\>", "\<ElectricPotential\>", \(L\^2\ M\)\/\(e\ \
t\^3\)}, \[IndentingNewLine]{"\<Derived\>", "\<ElectricResistance\>", \(L\^2\ \
M\)\/\(e\^2\ t\^3\)}, \[IndentingNewLine]{"\<Derived\>", \
"\<ElectricResistivity\>", 
              L\^3\/\(e\^2\ t\^3\)}, \[IndentingNewLine]{"\<Derived\>", \
"\<Energy\>", \(L\^2\ M\)\/t\^2}, \[IndentingNewLine]{"\<Derived\>", "\<Force\
\>", \(L\ M\)\/t\^2}, \[IndentingNewLine]{"\<Derived\>", "\<Frequency\>", 
              1\/t}, \[IndentingNewLine]{"\<Derived\>", "\<HeatCapacity\>", \
\(L\^2\ M\)\/\(t\^2\ T\)}, \[IndentingNewLine]{"\<Derived\>", \
"\<HeatInsulationCoefficient\>", \(t\^3\ T\)\/M}, \
\[IndentingNewLine]{"\<Derived\>", "\<HeatTransferCoefficient\>", 
              M\/\(t\^3\ T\)}, \[IndentingNewLine]{"\<Derived\>", \
"\<Illuminance\>", 
              i\/\(L\^2\ S\^2\)}, \[IndentingNewLine]{"\<Derived\>", \
"\<InverseLength\>", 1\/L}, \[IndentingNewLine]{"\<Derived\>", "\<Jerk\>", 
              L\/t\^3}, \[IndentingNewLine]{"\<Derived\>", \
"\<KinematicViscosity\>", 
              L\^2\/t}, \[IndentingNewLine]{"\<Derived\>", "\<LinearFrequency\
\>", 1\/\(L\ t\)}, \[IndentingNewLine]{"\<Derived\>", \
"\<LinearMassDensity\>", 
              M\/L}, \[IndentingNewLine]{"\<Derived\>", "\<LuminousFlux\>", 
              i\ S}, \[IndentingNewLine]{"\<Derived\>", \
"\<LuminousLuminance\>", 
              i\/L\^2}, \[IndentingNewLine]{"\<Derived\>", \
"\<MagneticDipoleMoment\>", 
              e\ L\^2}, \[IndentingNewLine]{"\<Derived\>", \
"\<MagneticFlux\>", \(L\^2\ M\)\/\(e\ t\^2\)}, \[IndentingNewLine]{"\<Derived\
\>", "\<MagneticFluxDensity\>", 
              M\/\(e\ t\^2\)}, \[IndentingNewLine]{"\<Derived\>", \
"\<MagneticInductance\>", \(L\^2\ M\)\/\(e\^2\ t\^2\)}, \[IndentingNewLine]{"\
\<Derived\>", "\<MagneticPermiability\>", \(L\ M\)\/\(e\^2\ t\^2\)}, \
\[IndentingNewLine]{"\<Derived\>", "\<MagneticPolarizability\>", \(e\^2\ L\^2\
\ t\^2\)\/M}, \[IndentingNewLine]{"\<Derived\>", "\<MagnetizingForce\>", 
              e\/L}, \[IndentingNewLine]{"\<Derived\>", "\<MassDensity\>", 
              M\/L\^3}, \[IndentingNewLine]{"\<Derived\>", \
"\<MolarElectricCharge\>", \(e\ t\^3\)\/\(L\ M\)}, \
\[IndentingNewLine]{"\<Derived\>", "\<MomentOfInertia\>", 
              L\^2\ M}, \[IndentingNewLine]{"\<Derived\>", "\<Momentum\>", \
\(L\ M\)\/t}, \[IndentingNewLine]{"\<Derived\>", "\<Power\>", \(L\^2\ \
M\)\/t\^3}, \[IndentingNewLine]{"\<Derived\>", "\<Pressure\>", 
              M\/\(L\ t\^2\)}, \[IndentingNewLine]{"\<Derived\>", \
"\<SpecificHeatCapacity\>", 
              L\^2\/\(t\^2\ T\)}, \[IndentingNewLine]{"\<Derived\>", "\<Speed\
\>", L\/t}, \[IndentingNewLine]{"\<Derived\>", "\<SurfaceEnergyDensity\>", 
              M\/t\^2}, \[IndentingNewLine]{"\<Derived\>", \
"\<SurfacePowerDensity\>", 
              M\/t\^3}, \[IndentingNewLine]{"\<Derived\>", \
"\<ThermalConductivity\>", \(L\ M\)\/\(t\^3\ T\)}, \
\[IndentingNewLine]{"\<Derived\>", "\<Volume\>", 
              L\^3}, \[IndentingNewLine]{"\<Derived\>", "\<VolumeFlow\>", 
              L\^3\/t}} /. \[InvisibleSpace]\[IndentingNewLine]{i \[Rule] \
"\<LuminousIntensity\>", S \[Rule] "\<SolidAngle\>", A \[Rule] "\<Angle\>", 
            e \[Rule] "\<ElectricCurrent\>", T \[Rule] "\<Temperature\>", 
            t \[Rule] "\<Time\>", M \[Rule] "\<Mass\>", 
            L \[Rule] "\<Length\>"}];\)\)



\!\(\(Unit[Definition, 
        UnitMKS] = {\[IndentingNewLine]{"\<Base\>", "\<Length\>", \
"\<Meter\>", "\<m\>"}, \[IndentingNewLine]{"\<Base\>", "\<Mass\>", \
"\<Kilogram\>", "\<Kg\>", "\<kg\>"}, \[IndentingNewLine]{"\<Base\>", \
"\<Time\>", "\<Second\>", "\<s\>"}, \[IndentingNewLine]{"\<Base\>", \
"\<ElectricCurrent\>", "\<Ampere\>", "\<Amp\>", "\<A\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<Temperature\>", "\<Kelvin\>", "\<\
\[DoubleStruckCapitalK]\>"}, \[IndentingNewLine]{"\<Base\>", "\<Substance\>", \
"\<Mole\>", "\<mol\>"}, \[IndentingNewLine]{"\<Base\>", \
"\<LuminousIntensity\>", "\<Candela\>", "\<cd\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<Angle\>", "\<Radian\>", "\<rad\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<SolidAngle\>", "\<Steradian\>", "\<sr\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<Information\>", "\<Bit\>", "\<bit\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<Money\>", "\<$\>"}, \
\[IndentingNewLine]{"\<Derived\>", "\<ElectricCapacitance\>", "\<F\>", \("\<s\
\>"\^4\ "\<A\>"\^2\)\/\("\<m\>"\^2\ "\<kg\>"\)}, \
\[IndentingNewLine]{"\<Derived\>", "\<ElectricConductance\>", "\<S\>", \("\<s\
\>"\^3\ "\<A\>"\^2\)\/\("\<m\>"\^2\ "\<kg\>"\)}, \
\[IndentingNewLine]{"\<Derived\>", "\<ElectricPotential\>", "\<V\>", \
\("\<m\>"\^2\ "\<kg\>"\)\/\("\<s\>"\^3\ "\<A\>"\)}, \
\[IndentingNewLine]{"\<Derived\>", "\<ElectricResistance\>", "\<\
\[CapitalOmega]\>", \("\<m\>"\^2\ "\<kg\>"\)\/\("\<s\>"\^3\ "\<A\>"\^2\)}, \
\[IndentingNewLine]{"\<Derived\>", "\<Energy\>", "\<J\>", \("\<m\>"\^2\ "\<kg\
\>"\)\/"\<s\>"\^2}, \[IndentingNewLine]{"\<Derived\>", "\<Force\>", "\<N\>", \
\("\<m\>"\ "\<kg\>"\)\/"\<s\>"\^2}, \[IndentingNewLine]{"\<Derived\>", \
"\<Frequency\>", "\<Hz\>", 
          1\/"\<s\>"}, \[IndentingNewLine]{"\<Derived\>", "\<Illuminance\>", \
"\<lx\>", "\<cd\>"\/\("\<m\>"\^2\ "\<sr\>"\^2\)}, \
\[IndentingNewLine]{"\<Derived\>", "\<LuminousFlux\>", "\<lm\>", "\<cd\>"\ \
"\<sr\>"}, \[IndentingNewLine]{"\<Derived\>", "\<MagneticFlux\>", "\<Wb\>", \
\("\<m\>"\^2\ "\<kg\>"\)\/\("\<s\>"\^2\ "\<A\>"\)}, \
\[IndentingNewLine]{"\<Derived\>", "\<MagneticFluxDensity\>", "\<T\>", \
"\<kg\>"\/\("\<s\>"\^2\ "\<A\>"\)}, \[IndentingNewLine]{"\<Derived\>", \
"\<MagneticInductance\>", "\<Hy\>", "\<H\>", \("\<m\>"\^2\ "\<kg\>"\)\/\("\<s\
\>"\^2\ "\<A\>"\^2\)}, \[IndentingNewLine]{"\<Derived\>", "\<Power\>", \
"\<W\>", \("\<m\>"\^2\ "\<kg\>"\)\/"\<s\>"\^3}, \
\[IndentingNewLine]{"\<Derived\>", "\<Pressure\>", "\<Pa\>", "\<kg\>"\/\("\<m\
\>"\ "\<s\>"\^2\)}, \[IndentingNewLine]{"\<Derived\>", "\<ElectricCharge\>", \
"\<C\>", "\<s\>"\ "\<A\>"}, \[IndentingNewLine]{"\<Combined\>", \
"\<Acceleration\>", "\<m\>"\/"\<s\>"\^2}, \[IndentingNewLine]{"\<Combined\>", \
"\<Action\>", \("\<kg\>"\ "\<m\>"\^2\)\/"\<s\>"}, \
\[IndentingNewLine]{"\<Combined\>", "\<AngularAcceleration\>", \
"\<rad\>"\/"\<s\>"\^2}, \[IndentingNewLine]{"\<Combined\>", \
"\<AngularSpeed\>", "\<rad\>"\/"\<s\>"}, \[IndentingNewLine]{"\<Combined\>", \
"\<Area\>", "\<m\>"\^2}, \[IndentingNewLine]{"\<Combined\>", \
"\<DynamicViscosity\>", "\<kg\>"\/\("\<m\>"\ "\<s\>"\)}, \
\[IndentingNewLine]{"\<Combined\>", "\<ElectricDipoleMoment\>", "\<A\>"\ "\<s\
\>"\ "\<m\>"}, \[IndentingNewLine]{"\<Combined\>", \
"\<ElectricDisplacement\>", "\<C\>"\/"\<m\>"\^2}, \
\[IndentingNewLine]{"\<Combined\>", "\<ElectricFieldStrength\>", \("\<kg\>"\ \
"\<m\>"\)\/\("\<A\>"\ "\<s\>"\^3\)}, \[IndentingNewLine]{"\<Combined\>", \
"\<ElectricPermittivity\>", "\<F\>"\/"\<m\>"}, \
\[IndentingNewLine]{"\<Combined\>", "\<ElectricPolarizability\>", \
\("\<A\>"\^2\ "\<s\>"\^4\)\/"\<kg\>"}, \[IndentingNewLine]{"\<Combined\>", \
"\<ElectricResistivity\>", "\<\[CapitalOmega]\>"\ "\<m\>"}, \
\[IndentingNewLine]{"\<Combined\>", "\<HeatCapacity\>", "\<J\>"\/"\<K\>"}, \
\[IndentingNewLine]{"\<Combined\>", "\<HeatInsulationCoefficient\>", \
\("\<s\>"\^3\ "\<K\>"\)\/"\<kg\>"}, \[IndentingNewLine]{"\<Combined\>", \
"\<HeatTransferCoefficient\>", "\<kg\>"\/\("\<s\>"\^3\ "\<K\>"\)}, \
\[IndentingNewLine]{"\<Combined\>", "\<InverseLength\>", 
          1\/"\<m\>"}, \[IndentingNewLine]{"\<Combined\>", "\<Jerk\>", \
"\<m\>"\/"\<s\>"\^3}, \[IndentingNewLine]{"\<Combined\>", \
"\<KinematicViscosity\>", "\<m\>"\^2\/"\<s\>"}, \
\[IndentingNewLine]{"\<Combined\>", "\<LinearFrequency\>", \
"\<Hz\>"\/"\<m\>"}, \[IndentingNewLine]{"\<Combined\>", \
"\<LinearMassDensity\>", "\<kg\>"\/"\<m\>"}, \
\[IndentingNewLine]{"\<Combined\>", "\<LuminousLuminance\>", \
"\<cd\>"\/"\<m\>"\^2}, \[IndentingNewLine]{"\<Combined\>", \
"\<MagneticDipoleMoment\>", "\<A\>"\ "\<m\>"\^2}, \
\[IndentingNewLine]{"\<Combined\>", "\<MagneticPermiability\>", "\<N\>"\/"\<A\
\>"\^2}, \[IndentingNewLine]{"\<Combined\>", "\<MagneticPolarizability\>", \
\("\<A\>"\^2\ "\<m\>"\^2\ "\<s\>"\^2\)\/"\<kg\>"}, \
\[IndentingNewLine]{"\<Combined\>", "\<MagnetizingForce\>", \
"\<A\>"\/"\<m\>"}, \[IndentingNewLine]{"\<Combined\>", "\<MassDensity\>", \
"\<kg\>"\/"\<m\>"\^3}, \[IndentingNewLine]{"\<Combined\>", \
"\<MolarElectricCharge\>", "\<C\>"\/"\<N\>"}, \[IndentingNewLine]{"\<Combined\
\>", "\<MomentOfInertia\>", "\<kg\>"\ "\<m\>"\^2}, \
\[IndentingNewLine]{"\<Combined\>", "\<Momentum\>", \("\<kg\>"\ \
"\<m\>"\)\/"\<s\>"}, \[IndentingNewLine]{"\<Combined\>", "\<Radioactivity\>", \
\("\<kg\>"\ "\<m\>"\^2\)\/"\<s\>"}, \[IndentingNewLine]{"\<Combined\>", \
"\<SpecificHeatCapacity\>", "\<m\>"\^2\/\("\<s\>"\^2\ "\<K\>"\)}, \
\[IndentingNewLine]{"\<Combined\>", "\<Speed\>", "\<m\>"\/"\<s\>"}, \
\[IndentingNewLine]{"\<Combined\>", "\<SurfaceEnergyDensity\>", "\<J\>"\/"\<m\
\>"\^2}, \[IndentingNewLine]{"\<Combined\>", "\<SurfacePowerDensity\>", \
"\<W\>"\/"\<m\>"\^2}, \[IndentingNewLine]{"\<Combined\>", \
"\<ThermalConductivity\>", \("\<kg\>"\ "\<m\>"\)\/\("\<s\>"\^3\ "\<K\>"\)}, \
\[IndentingNewLine]{"\<Combined\>", "\<Volume\>", "\<m\>"\^3}, \
\[IndentingNewLine]{"\<Combined\>", "\<VolumeFlow\>", \
"\<m\>"\^3\/"\<s\>"}};\)\)





\!\(\(Unit[Definition, 
        UnitCGS] = {\[IndentingNewLine]{"\<Equivalence\>", "\<m\>", 
          100\ "\<cm\>"}, \[IndentingNewLine]{"\<Equivalence\>", "\<kg\>", 
          1000\ "\<gr\>"}, \[IndentingNewLine]{"\<Base\>", "\<Length\>", \
"\<Centimeter\>", "\<cm\>"}, \[IndentingNewLine]{"\<Base\>", "\<Mass\>", \
"\<Gram\>", "\<gr\>"}, \[IndentingNewLine]{"\<Base\>", "\<Time\>", \
"\<Second\>", "\<s\>"}, \[IndentingNewLine]{"\<Base\>", "\<Temperature\>", \
"\<Kelvin\>", "\<\[DoubleStruckCapitalK]\>"}, \[IndentingNewLine]{"\<Base\>", \
"\<Substance\>", "\<Mole\>", "\<mol\>"}, \[IndentingNewLine]{"\<Base\>", \
"\<Angle\>", "\<Radian\>", "\<rad\>"}, \[IndentingNewLine]{"\<Base\>", \
"\<SolidAngle\>", "\<Steradian\>", "\<sr\>"}, \[IndentingNewLine]{"\<Base\>", \
"\<LuminousIntensity\>", "\<Candela\>", "\<cd\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<Information\>", "\<Bit\>", "\<bit\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<Money\>", "\<$\>"}, \
\[IndentingNewLine]{"\<Derived\>", "\<Acceleration\>", "\<Galileo\>", \
"\<Gal\>", "\<gal\>", "\<cm\>"\ "\<s\>"\^\(-2\)}, \
\[IndentingNewLine]{"\<Derived\>", "\<Energy\>", "\<Erg\>", "\<erg\>", \
"\<cm\>"\^2\ "\<gr\>"\ "\<s\>"\^\(-2\)}, \[IndentingNewLine]{"\<Derived\>", "\
\<Force\>", "\<Dyne\>", "\<dyn\>", "\<cm\>"\ "\<gr\>"\ "\<s\>"\^\(-2\)}, \
\[IndentingNewLine]{"\<Derived\>", "\<Frequency\>", "\<Hertz\>", "\<Hz\>", \
"\<s\>"\^\(-1\)}, \[IndentingNewLine]{"\<Derived\>", "\<Pressure\>", "\<Barye\
\>", "\<cm\>"\^\(-1\)\ "\<gr\>"\ "\<s\>"\^\(-2\)}, \
\[IndentingNewLine]{"\<Derived\>", "\<Speed\>", "\<Kyne\>", "\<cm\>"\ "\<s\>"\
\^\(-1\)}, \[IndentingNewLine]{"\<Derived\>", "\<DynamicViscosity\>", \
"\<Poise\>", "\<P\>", "\<dyn\>"\ "\<s\>"\ "\<cm\>"\^\(-2\)}, \
\[IndentingNewLine]{"\<Derived\>", "\<KinematicViscosity\>", "\<Stokes\>", \
"\<St\>", "\<cm\>"\^2\ "\<s\>"\^\(-1\)}, \[IndentingNewLine]{"\<Derived\>", "\
\<Illuminance\>", "\<Phot\>", "\<ph\>", "\<cd\>" "\<cm\>"\^\(-2\)\ "\<sr\>"\^\
\(-2\)}, \[IndentingNewLine]{"\<Derived\>", "\<LuminousLuminance\>", "\<Stilb\
\>", "\<sb\>", "\<cd\>"\ "\<cm\>"\^\(-2\)}, \
\[IndentingNewLine]{"\<Derived\>", "\<MagneticFlux\>", "\<abWeber\>", "\<abWb\
\>", "\<Maxwell\>", "\<Mx\>", 
          10\^\(-1\)\ "\<cm\>"\^2\ "\<gr\>"\ "\<s\>"\^\(-2\)\ \
"\<A\>"\^\(-1\)}, \[IndentingNewLine]{"\<Derived\>", \
"\<MagneticFluxDensity\>", "\<abTesla\>", "\<abT\>", "\<Gauss\>", "\<Gs\>", "\
\<Mx\>"\ "\<cm\>"\^\(-2\)}, \[IndentingNewLine]{"\<Derived\>", \
"\<ElectricCurrent\>", "\<Gilbert\>", "\<Gb\>", 
          1/\((4\ Pi)\)\ 10\ "\<A\>"}, \[IndentingNewLine]{"\<Combined\>", \
"\<Power\>", "\<erg\>"\ "\<s\>"\^\(-1\)}};\)\)



\!\(\(Unit[Definition, 
        UnitFPS] = {\[IndentingNewLine]{"\<Equivalence\>", "\<m\>", 
          5000/1524\ "\<ft\>"}, \[IndentingNewLine]{"\<Equivalence\>", \
"\<kg\>", 
          11023113\/5000000\ "\<lb\>"}, \
\[IndentingNewLine]{"\<Equivalence\>", "\<\[DoubleStruckCapitalK]\>", 
          9/5\ "\<\[DoubleStruckCapitalR]\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<Length\>", "\<Foot\>", "\<Feet\>", \
"\<ft\>"}, \[IndentingNewLine]{"\<Base\>", "\<Mass\>", \
"\<AvoirdupoisPound\>", "\<Pound\>", "\<lb\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<Time\>", "\<Second\>", "\<s\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<Temperature\>", "\<Rankine\>", "\<\
\[DoubleStruckCapitalR]\>"}, \[IndentingNewLine]{"\<Base\>", "\<Angle\>", \
"\<Radian\>", "\<rad\>"}, \[IndentingNewLine]{"\<Base\>", "\<SolidAngle\>", "\
\<Steradian\>", "\<sr\>"}, \[IndentingNewLine]{"\<Base\>", "\<Money\>", \
"\<$\>"}, \[IndentingNewLine]{"\<Derived\>", "\<Frequency\>", "\<Hertz\>", \
"\<Hz\>", "\<s\>"\^\(-1\)}, \[IndentingNewLine]{"\<Derived\>", "\<Power\>", "\
\<Horsepower\>", "\<HP\>", 
          550\ \(41949360957\/41949338500\) "\<ft\>"\ "\<lbf\>"\ \
"\<s\>"\^\(-1\)}, \[IndentingNewLine]{"\<Derived\>", "\<Force\>", \
"\<PoundForce\>", "\<lbf\>", 
          32.1740\ \(817220528481\/817219600000\) "\<ft\>"\ "\<lb\>"\ "\<s\>"\
\^\(-2\)}, {"\<Combined\>", "\<Energy\>", "\<lbf\>"\ "\<ft\>"}, \
\[IndentingNewLine]{"\<Combined\>", "\<Pressure\>", "\<lbf\>"\ "\<in\>"\^\(-2\
\)}};\)\)





\!\(\(\( (*\ \(--\(-\ \(MULTIPLIERS\ --\)\)\)\(-\)\ \
*) \)\(\[IndentingNewLine]\)\(\[IndentingNewLine]\)\(Unit[Prefix, All] = 
      ListToRules@{\[IndentingNewLine]{"\<Percent\>", 
            1/100}, \[IndentingNewLine]{"\<Gross\>", 
            144}, \[IndentingNewLine]{"\<Dozen\>", 
            12}, \[IndentingNewLine]{"\<BakersDozen\>", 
            13}, \[IndentingNewLine]{"\<Mole\>", "\<mol\>", 
            6.0221367\ 10\^23}, \[IndentingNewLine]{"\<Yotta\>", "\<\
\[ScriptCapitalY]\>", 
            10\^24}, \[IndentingNewLine]{"\<Zetta\>", \
"\<\[ScriptCapitalZ]\>", 
            10\^21}, \[IndentingNewLine]{"\<Exa\>", "\<\[ScriptCapitalE]\>", 
            10\^18}, \[IndentingNewLine]{"\<Peta\>", "\<\[ScriptCapitalP]\>", 
            10\^15}, \[IndentingNewLine]{"\<Tera\>", "\<\[ScriptCapitalT]\>", 
            10\^12}, \[IndentingNewLine]{"\<Giga\>", "\<\[ScriptCapitalG]\>", 
            10\^9}, \[IndentingNewLine]{"\<Mega\>", "\<\[ScriptCapitalM]\>", 
            10\^6}, \[IndentingNewLine]{"\<Kilo\>", "\<\[ScriptK]\>", 
            10\^3}, \[IndentingNewLine]{"\<Hecto\>", "\<\[ScriptH]\>", 
            100}, \[IndentingNewLine]{"\<Deca\>", "\<\[ScriptD]\[ScriptA]\>", 
            10}, \[IndentingNewLine]{"\<Deci\>", "\<\[ScriptD]\>", 
            10\^\(-1\)}, \[IndentingNewLine]{"\<Centi\>", "\<\[ScriptC]\>", 
            10\^\(-2\)}, \[IndentingNewLine]{"\<Milli\>", "\<\[ScriptM]\>", 
            10\^\(-3\)}, \[IndentingNewLine]{"\<Micro\>", "\<\[Mu]\>", 
            10\^\(-6\)}, \[IndentingNewLine]{"\<Nano\>", "\<\[ScriptN]\>", 
            10\^\(-9\)}, \[IndentingNewLine]{"\<Pico\>", "\<\[ScriptP]\>", 
            10\^\(-12\)}, \[IndentingNewLine]{"\<Femto\>", "\<\[ScriptF]\>", 
            10\^\(-15\)}, \[IndentingNewLine]{"\<Atto\>", "\<\[ScriptA]\>", 
            10\^\(-18\)}, \[IndentingNewLine]{"\<Zepto\>", "\<\[ScriptZ]\>", 
            10\^\(-21\)}, \[IndentingNewLine]{"\<Yocto\>", "\<\[ScriptY]\>", 
            10\^\(-24\)}};\)\)\)



Unit["Angle",All]=ListToRules@{
        {"Radian","rad",1},
        {"Steradian","sr",1}};



\!\(\(\( (*\ \(--\(-\ \(Temperature\ --\)\)\)\(-\)\ \
*) \)\(\[IndentingNewLine]\)\(\[IndentingNewLine]\)\(Unit["\<Temperature\>", 
        All] = ListToRules@{\[IndentingNewLine]{"\<Centigrade\>", \
"\<Celsius\>", "\<\[DoubleStruckCapitalC]\>", "\<\[DoubleStruckCapitalK]\>"}, \
\[IndentingNewLine]{"\<Fahrenheit\>", "\<\[DoubleStruckCapitalF]\>", "\<\
\[DoubleStruckCapitalR]\>"}, \[IndentingNewLine]{"\<Rankine\>", "\<\
\[DoubleStruckCapitalR]\>", 
            5\/9\ "\<\[DoubleStruckCapitalK]\>"}, \
\[IndentingNewLine]{"\<Kelvin\>", "\<K\>", "\<\[DoubleStruckCapitalK]\>"}, \
\[IndentingNewLine]{"\<\[Degree]Centigrade\>", "\<\[Degree]Celsius\>", "\<\
\[Degree]C\>", "\<\[Degree]\[DoubleStruckCapitalC]\>"}, \[IndentingNewLine]{"\
\<\[Degree]Fahrenheit\>", "\<\[Degree]F\>", "\<\[Degree]\
\[DoubleStruckCapitalF]\>"}, \[IndentingNewLine]{"\<\[Degree]Rankine\>", "\<\
\[Degree]R\>", "\<\[Degree]\[DoubleStruckCapitalR]\>"}, \[IndentingNewLine]{"\
\<\[Degree]Kelvin\>", "\<\[Degree]K\>", \
"\<\[Degree]\[DoubleStruckCapitalK]\>"}};\)\)\)



\!\(\(constants = {\[IndentingNewLine]\[IndentingNewLine]{ (*\ \(--\(-\ \
\(UNIVERSAL\ --\)\)\)\(-\)\ *) \[IndentingNewLine]"\<SpeedOfLight\>", \
"\<VacuumSpeedOfLight\>", \*"\"\<\!\(c\_0\)\>\"", "\<c\>", 0, 
          299792458\ "\<m\>"\ "\<s\>"\^\(-1\)}, \
\[IndentingNewLine]{"\<MagneticConstant\>", "\<VacuumPermeability\>", \*"\"\<\
\!\(\[Mu]\_0\)\>\"", 0, 
          4  \[Pi]\ \(10\^\(-7\)\) "\<N\>"\ "\<A\>"\^\(-2\)}, \
\[IndentingNewLine]{"\<ElectricConstant\>", "\<VacuumPermittivity\>", \*"\"\<\
\!\(\[Epsilon]\_0\)\>\"", 0, 
          8.854187817\ 10\^\(-12\)\ "\<F\>"\ "\<m\>"\^\(-1\)}, \
\[IndentingNewLine]{"\<VacuumCharacteristicImpedance\>", \
\*"\"\<\!\(Z\_0\)\>\"", 0, 
          376.730313461\ "\<Ohm\>"}, \
\[IndentingNewLine]{"\<NewtonianConstantOfGravitation\>", \
"\<GravitationalConstant\>", "\<G\>", 10\^\(-14\)\ , 
          6.6742\ 10\^\(-11\)\ "\<m\>"\^3\ "\<kg\>"\^\(-1\)\ \
"\<s\>"\^\(-2\)}, \[IndentingNewLine]{"\<StandardAccelerationOfGravity\>", \
"\<AccelerationDueToGravity\>", Gravity, "\<g\>", 0, 
          9.80665\ "\<m\>"\ "\<s\>"\^\(-2\)}, \
\[IndentingNewLine]{"\<PlanckConstant\>", "\<\[HBar]\>", 
          0.0000011\ 10\^\(-34\), 
          6.626069\ 10\^\(-34\)\ \ "\<J\>"\ "\<s\>"}, \
\[IndentingNewLine]{"\<PlanckMass\>", \*"\"\<\!\(m\_P\)\>\"", 
          0.00016\ 10\^\(-8\), 
          2.17645\ 10\^\(-8\)\ "\<kg\>"}, \
\[IndentingNewLine]{"\<PlanckTemperature\>", \*"\"\<\!\(T\_P\)\>\"", 
          0.00011\ 10\^32, 
          1.41679\ 10\^32\ "\<\[DoubleStruckCapitalK]\>"}, \
\[IndentingNewLine]{"\<PlanckLength\>", \*"\"\<\!\(l\_P\)\>\"", 
          0.00012\ 10\^\(-35\), 
          1.61624\ 10\^\(-35\)\ "\<m\>"}, \
\[IndentingNewLine]{"\<PlanckTime\>", \*"\"\<\!\(t\_P\)\>\"", 
          0.00040\ 10\^\(-44\), 
          5.39121\ 10\^\(-44\)\ "\<s\>"}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(--\(-\ \(ELECTROMAGNETIC\ --\)\)\)\(-\)\ \
*) \[IndentingNewLine]"\<ElementaryCharge\>", "\<ElectronCharge\>", \*"\"\<\!\
\(\(e\^-\)\)\>\"", "\<e\>", 0.00000014\ 10\^\(-19\), 
          1.60217653\ 10\^\(-19\)\ "\<C\>"}, \
\[IndentingNewLine]{"\<MagneticFluxQuantum\>", \
\*"\"\<\!\(\[CapitalPhi]\_0\)\>\"", 0.00000018\ 10\^\(-15\), 
          2.06783372\ 10\^\(-15\)\ "\<Wb\>"}, \
\[IndentingNewLine]{"\<ConductanceQuantum\>", \*"\"\<\!\(G\_0\)\>\"", 
          0.000000026\ 10\^\(-5\), 
          7.748091733\ 10\^\(-5\)\ "\<S\>"}, \
\[IndentingNewLine]{"\<JosephsonConstant\>", \*"\"\<\!\(K\_J\)\>\"", 
          4.1\ 10\^7, 
          483597.879\ 10\^9\ "\<Hz\>"\ "\<V\>"\^\(-1\)}, \
\[IndentingNewLine]{"\<vonKlitzingConstant\>", \*"\"\<\!\(R\_K\)\>\"", 
          0.000086, 
          25812.807449\ "\<Ohm\>"}, \[IndentingNewLine]{"\<BohrMagneton\>", \
\*"\"\<\!\(\[Mu]\_B\)\>\"", 0.000080\ 10\^\(-26\), 
          927.400949\ \(10\^\(-26\)\) "\<J\>"\ "\<T\>"\^\(-1\)}, \
\[IndentingNewLine]{"\<NuclearMagneton\>", \*"\"\<\!\(\[Mu]\_N\)\>\"", 
          0.00000043\ 10\^\(-27\), 
          5.05078343\ 10\^\(-27\)\ "\<J\>"\ "\<T\>"\^\(-1\)}, \
\[IndentingNewLine]\[IndentingNewLine]{ (*\ \(\(--\(-\ 
                    PHYSICO\)\)\ \(CHEMICAL\ --\)\)\(-\)\ \
*) \[IndentingNewLine]"\<AvogadroNumber\>", "\<AvogadroConstant\>", \*"\"\<\!\
\(N\_A\)\>\"", 0.0000010\ 10\^23, 
          6.0221415\ 10\^\(-23\)\ "\<mol\>"}, \
\[IndentingNewLine]{"\<AtomicMassConstant\>", \*"\"\<\!\(m\_u\)\>\"", 
          0.00000028\ 10\^\(-27\), 
          1.66053886\ 10\^\(-27\)\ "\<kg\>"}, \
\[IndentingNewLine]{"\<FaradayConstant\>", \*"\"\<\!\(F\_K\)\>\"", 0.0083, 
          96485.3383\ "\<C\>"\ "\<mol\>"\^\(-1\)}, \
\[IndentingNewLine]{"\<BoltzmannConstant\>", "\<k\>", 0.0000024\ 10\^\(-23\), 
          1.3806505\ 10\^\(-23\)\ "\<J\>"\ \
"\<\[DoubleStruckCapitalK]\>"\^\(-1\)}, \
\[IndentingNewLine]{"\<StefanBoltzmannConstant\>", "\<\[Sigma]\>", 
          0.000040\ 10\^\(-8\), 
          5.670400\ 10\^\(-8\)\ "\<W\>"\ "\<m\>"\^\(-2\)\ "\<\
\[DoubleStruckCapitalK]\>"\^\(-4\)}, \
\[IndentingNewLine]{"\<FirstRadiationConstant\>", \*"\"\<\!\(c\_1\)\>\"", 
          0.00000064\ 10\^\(-16\), 
          3.74177138\ 10\^\(-16\)\ "\<W\>"\ "\<m\>"\^2}, \
\[IndentingNewLine]{"\<SpectralRadianceFirstRadiationConstant\>", \
\*"\"\<\!\(c\_\(1  L\)\)\>\"", 0.00000020\ 10\^\(-16\), 
          
          1.19104282\ 10\^\(-16\)\ "\<W\>"\ "\<m\>"\^\(-2\)\ \
"\<sr\>"\^\(-1\)}, \[IndentingNewLine]{"\<SecondRadiationConstant\>", \*"\"\<\
\!\(c\_2\)\>\"", 0.0000025\ 10\^\(-2\), 
          1.438\ 7752\ 10\^\(-2\)\ "\<m\>"\ "\<\[DoubleStruckCapitalK]\>"}, \
\[IndentingNewLine]{"\<WienDisplacementLawConstant\>", \
\*"\"\<\!\(b\_W\)\>\"", 0.0000051\ 10\^\(-3\), 
          2.8977685\ 10\^\(-3\)\ "\<m\>"\ "\<\[DoubleStruckCapitalK]\>"}, \
\[IndentingNewLine]{"\<LoschmidtConstant\>", 2.6867773\ 10\^25, 
          0.0000047\ 10\^25\ "\<m\>"\^\(-3\)}, \[IndentingNewLine]\
\[IndentingNewLine]{"\<StandardTemperature\>", \*"\"\<\!\(T\_0\)\>\"", 0, 
          273.15\ "\<\[DoubleStruckCapitalK]\>"}, \
\[IndentingNewLine]{"\<StandardAtmosphere\>", \*"\"\<\!\(P\_0\)\>\"", 0, 
          101325\ "\<Pa\>"}, \[IndentingNewLine]{"\<IdealGasVolume\>", \
"\<MolarVolume\>", \*"\"\<\!\(V\_0\)\>\"", 0.000039\ 10\^\(-3\), 
          22.413996\ 10\^\(-3\)\ "\<m\>"\^3\ "\<mol\>"\^\(-1\)}, \
\[IndentingNewLine]{"\<IdealGasConstant\>", "\<MolarGasConstant\>", "\<R\>", 
          0.000015, 
          8.314472\ "\<J\>"\ "\<mol\>"\^\(-1\)\ "\<\[DoubleStruckCapitalK]\>"\
\^\(-1\)}, \[IndentingNewLine]\[IndentingNewLine]{ (*\ \(--\(-\ 
                    ATOMIC\)\)\ AND\ NUCLEAR\  - \ \(General\ --\) - \ \
*) \[IndentingNewLine]"\<FineStructureConstant\>", "\<\[Alpha]\>", 
          0.000000024\ 10\^\(-3\), 
          7.297352568\ 10\^\(-3\)}, \
\[IndentingNewLine]{"\<RydbergConstant\>", \*"\"\<\!\(R\_\[Infinity]\)\>\"", 
          0.000073, 
          10973731.568525\ "\<m\>"\^\(-1\)}, \
\[IndentingNewLine]{"\<BohrRadius\>", \*"\"\<\!\(a\_0\)\>\"", 
          0.0000000018\ 10\^\(-10\), 
          0.5291772108\ 10\^\(-10\)\ "\<m\>"}, \
\[IndentingNewLine]{"\<HartreeEnergy\>", \*"\"\<\!\(E\_h\)\>\"", 
          0.00000075\ 10\^\(-18\), 
          4.35974417\ 10\^\(-18\)\ "\<J\>"}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(\(--\(-\ A\)\) &\) 
                N\  - \ \(Electron\  : \ \(\(\(e\^-\)\ --\)\(-\)\)\)\ \
*) \[IndentingNewLine]"\<ElectronMass\>", \*"\"\<\!\(m\_e\)\>\"", 
          0.0000016\ 10\^\(-31\), 
          
          9.1093826\ 10\^\(-31\)\ "\<kg\>"}, \
\[IndentingNewLine]{"\<ElectronComptonWavelength\>", \
\*"\"\<\!\(\[Lambda]\_\(C\_e\)\)\>\"", 0.000000016\ 10\^\(-12\), 
          2.426310238\ 10\^\(-12\)\ "\<m\>"}, \
\[IndentingNewLine]{"\<ClassicalElectronRadius\>", \*"\"\<\!\(r\_e\)\>\"", 
          0.000000028\ 10\^\(-15\), 
          2.817940325\ 10\^\(-15\)\ "\<m\>"}, \
\[IndentingNewLine]{"\<ThomsonCrossSection\>", \*"\"\<\!\(\[Sigma]\_e\)\>\"", 
          0.000000013\ 10\^\(-28\), 
          0.665245873\ 10\^\(-28\)\ "\<m\>"\^2}, \
\[IndentingNewLine]{"\<ElectronMagneticMoment\>", \*"\"\<\!\(\[Mu]\_e\)\>\"", 
          0.000080\ 10\^\(-26\), \(-928.476412\)\ 10\^\(-26\)\ "\<J\>"\ \
"\<T\>"\^\(-1\)}, \[IndentingNewLine]{"\<ElectronMagneticMomentAnomaly\>", \
\*"\"\<\!\(a\_e\)\>\"", 0.0000000038\ 10\^\(-3\), 
          1.1596521859\ 10\^\(-3\)}, \
\[IndentingNewLine]{"\<ElectronGFactor\>", \*"\"\<\!\(g\_e\)\>\"", 
          0.0000000000075, \(-2.0023193043718\)}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(\(--\(-\ A\)\) &\) 
                N\  - \ \(Muon\  : \ \(\(\(\[Mu]\^-\)\ --\)\(-\)\)\)\ \
*) \[IndentingNewLine]"\<MuonMass\>", \*"\"\<\!\(m\_\[Mu]\)\>\"", 
          0.00000033\ 10\^\(-28\), 
          1.88353140\ 10\^\(-28\)\ "\<kg\>"}, \
\[IndentingNewLine]{"\<MuonComptonWavelength\>", \*"\"\<\!\(\[Lambda]\_\(C\_\
\[Mu]\)\)\>\"", 0.00000030\ 10\^\(-15\), 
          11.73444105\ 10\^\(-15\)\ "\<m\>"}, \
\[IndentingNewLine]{"\<MuonMagneticMoment\>", \*"\"\<\!\(\[Mu]\_\[Mu]\)\>\"", 
          0.00000040\ 10\^\(-26\), \(-4.49044799\)\ 10\^\(-26\)\ "\<J\>"\ \
"\<T\>"\^\(-1\)}, \[IndentingNewLine]{"\<MuonMagneticMomentAnomaly\>", \
\*"\"\<\!\(a\_\[Mu]\)\>\"", 0.00000062\ 10\^\(-3\), 
          1.16591981\ 10\^\(-3\)}, \[IndentingNewLine]{"\<MuonGFactor\>", \*"\
\"\<\!\(g\_\[Mu]\)\>\"", 
          0.0000000012, \(-2.0023318396\)}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(\(--\(-\ A\)\) &\) 
                N\  - \ \(Tau\  : \ \(\(\(\[Tau]\^-\)\ --\)\(-\)\)\)\ \
*) \[IndentingNewLine]"\<TauMass\>", \*"\"\<\!\(m\_\[Tau]\)\>\"", 
          0.00052\ 10\^\(-27\), 
          
          3.16777\ 10\^\(-27\)\ "\<kg\>"}, \
\[IndentingNewLine]{"\<TauComptonWavelength\>", \*"\"\<\!\(\[Lambda]\_\(C\_\
\[Tau]\)\)\>\"", 0.69772\ 10\^\(-15\), 
          0.00011\ 10\^\(-15\)\ "\<m\>"}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(\(--\(-\ A\)\) &\) 
                N\  - \ \(Proton\  : \ \(\(p\ --\)\(-\)\)\)\ \
*) \[IndentingNewLine]"\<ProtonMass\>", \*"\"\<\!\(m\_p\)\>\"", 
          0.00000029\ 10\^\(-27\), 
          1.67262171\ 10\^\(-27\)\ "\<kg\>"}, \
\[IndentingNewLine]{"\<ProtonComptonWavelength\>", \
\*"\"\<\!\(\[Lambda]\_\(C\_p\)\)\>\"", 0.0000000088\ 10\^\(-15\), 
          1.3214098555\ 10\^\(-15\)\ "\<m\>"}, \
\[IndentingNewLine]{"\<ProtonMagneticMoment\>", \*"\"\<\!\(\[Mu]\_p\)\>\"", 
          0.00000012\ 10\^\(-26\), 
          1.41060671\ 10\^\(-26\)\ "\<J\>"\ "\<T\>"\^\(-1\)}, \
\[IndentingNewLine]{"\<ProtonGFactor\>", \*"\"\<\!\(g\_p\)\>\"", 0.000000056, 
          5.585694701}, \[IndentingNewLine]{"\<ProtonGyromagneticRatio\>", \
\*"\"\<\!\(\[Gamma]\_p\)\>\"", 0.00000023\ 10\^8, 
          2.67522205\ 10\^8\ "\<s\>"\^\(-1\)\ "\<T\>"\^\(-1\)}, \
\[IndentingNewLine]\[IndentingNewLine]{ (*\ \(\(--\(-\ A\)\) &\) 
                N\  - \ \(Neutron\  : \ \(\(n\ --\)\(-\)\)\)\ \
*) \[IndentingNewLine]"\<NeutronMass\>", \*"\"\<\!\(m\_n\)\>\"", 
          0.00000029\ 10\^\(-27\), 
          1.674\ 92728\ 10\^\(-27\)\ "\<kg\>"}, \
\[IndentingNewLine]{"\<NeutronComptonWavelength\>", \*"\"\<\!\(\[Lambda]\_\(C\
\_n\)\)\>\"", 0.0000000088\ 10\^\(-15\), 
          1.3195909067\ 10\^\(-15\)\ "\<m\>"}, \
\[IndentingNewLine]{"\<NeutronMagneticMoment\>", \*"\"\<\!\(\[Mu]\_n\)\>\"", 
          0.00000024\ 10\^\(-26\), \(-0.96623645\)\ 10\^\(-26\)\ "\<J\>"\ \
"\<T\>"\^\(-1\)}, \[IndentingNewLine]{"\<NeutronGFactor\>", \*"\"\<\!\(g\_n\)\
\>\"", 0.00000090, \(-3.82608546\)}, \[IndentingNewLine]\[IndentingNewLine]{ \
(*\ \(\(--\(-\ A\)\) &\) 
                N\  - \ \(Deuteron\  : \ \(\(d\ --\)\(-\)\)\)\ \
*) \[IndentingNewLine]"\<DeuteronMass\>", \*"\"\<\!\(m\_d\)\>\"", 
          0.00000057\ 10\^\(-27\), 
          3.34358335\ 10\^\(-27\)\ "\<kg\>"}, \
\[IndentingNewLine]{"\<DeuteronMagneticMoment\>", \*"\"\<\!\(\[Mu]\_d\)\>\"", 
          0.000000038\ 10\^\(-26\), 
          0.433073482\ 10\^\(-26\)\ "\<J\>"\ "\<T\>"\^\(-1\)}, \
\[IndentingNewLine]\[IndentingNewLine]{ (*\ \(\(--\(-\ A\)\) &\) 
                N\  - \ \(Helion\  : \ \(\(h\ --\)\(-\)\)\)\ \
*) \[IndentingNewLine]"\<HelionMass\>", \*"\"\<\!\(m\_h\)\>\"", 
          0.00000086\ 10\^\(-27\), 
          5.00641214\ 10\^\(-27\)\ "\<kg\>"}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(\(--\(-\ A\)\) &\) 
                N\  - \ \(Alpha\  : \ \(---\)\)\ \
*) \[IndentingNewLine]"\<AlphaParticleMass\>", \*"\"\<\!\(m\_\[Alpha]\)\>\"", 
          0.0000011\ 10\^\(-27\), 
          6.6446565\ 10\^\(-27\)\ "\<kg\>"}\[IndentingNewLine]\
\[IndentingNewLine]};\)\)

Unit[Constant,All]=Module[{list},
      ListToRules[
          list@@constants/.{a__,b_,c_}\[RuleDelayed]{a,c}]/.list\[Rule]List];





\!\(\(UCR[p_Symbol\_q__] := 
      UCR[Evaluate@ToString[p\_q, StandardForm]]\ ;\)\[IndentingNewLine]
  \(UCR[x_Symbol\^m_. ] := UCR[Evaluate@ts[x]];\)\[IndentingNewLine]
  \({ListToRules[\(list @@ 
                constants /. \[IndentingNewLine]{a___, b_, 
                  c_} \[RuleDelayed] {a, \((b /. \((0 \[Rule] 0. )\))\)}\) /. 
            list \[Rule] List] /. \[IndentingNewLine]\((a_ \[Rule] 
              b_)\) \[RuleDelayed] Set[UCR[a], UCR[b]]};\)\)



\!\(\(Unit[Table, 
        All] = \[IndentingNewLine]Unit[Prefix, 
          All] \[Union] \[IndentingNewLine]Unit["\<Angle\>", 
          All] \[Union] \[IndentingNewLine]Unit["\<Temperature\>", 
          All] \[Union] \[IndentingNewLine]Unit[Constant, 
          All] \[Union] \[IndentingNewLine]ListToRules[\(\(\({\
\[IndentingNewLine]\[IndentingNewLine]{ (*\ \(\(--\(-\ 
                                MKS\)\)\ \(DERIVED\ --\)\)\(-\)\ \
*) \[IndentingNewLine]"\<Farad\>", "\<F\>", "\<m\>"\^\(-2\)\ "\<kg\>"\^\(-1\)\
\ "\<s\>"\^4\ "\<A\>"\^2}, \[IndentingNewLine]{"\<Siemens\>", "\<mho\>", \
"\<Mho\>", "\<S\>", "\<m\>"\^\(-2\)\ "\<kg\>"\^\(-1\)\ "\<s\>"\^3\ \
"\<A\>"\^2}, \[IndentingNewLine]{"\<Volt\>", "\<V\>", \("\<m\>"\^2\) "\<kg\>"\
\ "\<s\>"\^\(-3\)\ "\<A\>"\^\(-1\)}, \[IndentingNewLine]{"\<Ohm\>", \
"\<Omega\>", "\<\[CapitalOmega]\>", "\<m\>"\^2\ "\<kg\>"\ "\<s\>"\^\(-3\)\ \
"\<A\>"\^\(-2\)}, \[IndentingNewLine]{"\<Joule\>", "\<J\>", "\<m\>"\^2\ "\<kg\
\>"\ "\<s\>"\^\(-2\)}, \[IndentingNewLine]{"\<Newton\>", "\<N\>", "\<m\>"\ \
"\<kg\>"\ "\<s\>"\^\(-2\)}, \[IndentingNewLine]{"\<Hertz\>", "\<Hz\>", \
"\<s\>"\^\(-1\)}, \[IndentingNewLine]{"\<Lux\>", "\<lx\>", \
\("\<m\>"\^\(-2\)\) "\<cd\>"\ "\<sr\>"\^\(-2\)}, \[IndentingNewLine]{"\<Lumen\
\>", "\<lm\>", "\<cd\>"\ "\<sr\>"}, \[IndentingNewLine]{"\<Weber\>", \
"\<Wb\>", "\<m\>"\^2\ "\<kg\>"\ "\<s\>"\^\(-2\)\ "\<A\>"\^\(-1\)}, \
\[IndentingNewLine]{"\<Tesla\>", "\<T\>", "\<kg\>"\ "\<s\>"\^\(-2\)\ \
"\<A\>"\^\(-1\)}, \[IndentingNewLine]{"\<Henry\>", "\<Hy\>", "\<H\>", "\<m\>"\
\^2\ "\<kg\>"\ "\<s\>"\^\(-2\)\ "\<A\>"\^\(-2\)}, \[IndentingNewLine]{"\<Watt\
\>", "\<W\>", "\<m\>"\^2\ "\<kg\>"\ "\<s\>"\^\(-3\)}, \
\[IndentingNewLine]{"\<Pascal\>", "\<Pa\>", "\<m\>"\^\(-1\)\ "\<kg\>"\ \
"\<s\>"\^\(-2\)}, \[IndentingNewLine]{"\<Couloumb\>", "\<C\>", "\<s\>"\ \
"\<A\>"}, \ \[IndentingNewLine]\[IndentingNewLine]{ (*\ \(\(--\(-\ 
                                CGS\)\)\ \(DERIVED\ --\)\)\(-\)\ \
*) \[IndentingNewLine]"\<Galileo\>", "\<Gal\>", "\<gal\>", "\<cm\>"\ \
"\<s\>"\^\(-2\)}, \[IndentingNewLine]{"\<Erg\>", "\<erg\>", "\<cm\>"\^2\ \
"\<gr\>"\ "\<s\>"\^\(-2\)}, \[IndentingNewLine]{"\<Dyne\>", "\<dyn\>", \
"\<cm\>"\ "\<gr\>"\ "\<s\>"\^\(-2\)}, \[IndentingNewLine]{"\<Hertz\>", \
"\<Hz\>", "\<s\>"\^\(-1\)}, \[IndentingNewLine]{"\<Barye\>", "\<cm\>"\^\(-1\)\
\ "\<gr\>"\ "\<s\>"\^\(-2\)}, \[IndentingNewLine]{"\<Kyne\>", "\<cm\>"\ \
"\<s\>"\^\(-1\)}, \[IndentingNewLine]{"\<Poise\>", "\<P\>", "\<dyn\>"\ \
"\<s\>"\ "\<cm\>"\^\(-2\)}, \[IndentingNewLine]{"\<Stokes\>", "\<St\>", "\<cm\
\>"\^2\ "\<s\>"\^\(-1\)}, \[IndentingNewLine]{"\<Phot\>", "\<ph\>", "\<cd\>" \
"\<cm\>"\^\(-2\)\ "\<sr\>"\^\(-2\)}, \[IndentingNewLine]{"\<Stilb\>", \
"\<sb\>", "\<cd\>"\ "\<cm\>"\^\(-2\)}, \[IndentingNewLine]{"\<abWeber\>", \
"\<abWb\>", "\<Maxwell\>", "\<Mx\>", 
                      10\ "\<cm\>"\^2\ "\<gr\>"\ "\<s\>"\^\(-2\)\ \
"\<A\>"\^\(-1\)}, \[IndentingNewLine]{"\<abTesla\>", "\<abT\>", "\<Gauss\>", \
"\<Gs\>", "\<Mx\>"\ "\<cm\>"\^\(-2\)}, \[IndentingNewLine]{"\<Oersted\>", \
"\<Oe\>", \ 
                      0.79577472\ "\<A\>" "\<cm\>"\^\(-1\)}, \
\[IndentingNewLine]\[IndentingNewLine]{ (*\ \(\(--\(-\ 
                                FPS\)\)\ \(DERIVED\ --\)\)\(-\)\ \
*) \[IndentingNewLine]"\<Horsepower\>", "\<HP\>", 
                      0.745700\ 10\^3\ "\<W\>"}, \
\[IndentingNewLine]{"\<PoundWeight\>", "\<PoundForce\>", "\<lbf\>", 
                      4.44822\ "\<N\>"}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(--\(-\ \(TIME\ --\)\)\)\(-\)\ \
*) \[IndentingNewLine]"\<Minute\>", "\<min\>", 
                      60\ "\<s\>"}, \[IndentingNewLine]{"\<Hour\>", "\<hr\>", \
"\<h\>", 60\ "\<min\>"}, \[IndentingNewLine]{"\<Day\>", "\<d\>", 
                      24\ "\<h\>"}, \[IndentingNewLine]{"\<Week\>", 
                      7\ "\<d\>"}, \[IndentingNewLine]{"\<Fortnight\>", 
                      2\ "\<Week\>"}, \[IndentingNewLine]{"\<Year\>", \
"\<yr\>", 365\ "\<d\>"}, \[IndentingNewLine]{"\<Month\>", "\<yr\>"/
                        12}, \[IndentingNewLine]{"\<Decade\>", 
                      10\ "\<yr\>"}, \[IndentingNewLine]{"\<Century\>", 
                      100\ "\<yr\>"}, \[IndentingNewLine]{"\<Millennium\>", 
                      1000\ "\<yr\>"}, \
\[IndentingNewLine]{"\<SiderealYear\>", 
                      365.25636\ "\<d\>"}, \
\[IndentingNewLine]{"\<TropicalYear\>", 
                      365.24219\ "\<d\>"}, \
\[IndentingNewLine]{"\<SiderealSecond\>", 
                      0.9972696\ "\<s\>"}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(--\(-\ \(ANGLES\ --\)\)\)\(-\)\ \
*) \[IndentingNewLine]"\<Degree\>", "\<deg\>", \[Pi]/
                          180\ "\<rad\>"}, \
\[IndentingNewLine]{"\<ArcMinute\>", 
                      1/60\ "\<deg\>"}, \[IndentingNewLine]{"\<ArcSecond\>", 
                      1/60\ "\<ArcMinute\>"}, \
\[IndentingNewLine]{"\<ArcHour\>", \[Pi]/
                          12\ "\<rad\>"}, \[IndentingNewLine]{"\<Gon\>", \
\[Pi]/200\ "\<rad\>"}, \[IndentingNewLine]{"\<Revolution\>", "\<rev\>", 
                      2  \[Pi]\ "\<rad\>"}, \[IndentingNewLine]{"\<Circle\>", 
                      2\ \[Pi]\ "\<rad\>"}, \[IndentingNewLine]{"\<Semicircle\
\>", \[Pi]\ "\<rad\>"}, \[IndentingNewLine]{"\<Quadrant\>", "\<RightAngle\>", \
\[Pi]/2\ "\<rad\>"}, \[IndentingNewLine]{"\<Point\>", \[Pi]/
                          16\ "\<rad\>"}, \
\[IndentingNewLine]{"\<AngularMil\>", 
                      1/1000\ "\<rad\>"}, \
\[IndentingNewLine]{"\<MilitarMil\>", \[Pi]/
                          3200\ "\<rad\>"}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(--\(-\ \(LENGTH\ --\)\)\)\(-\)\ \
*) \[IndentingNewLine]"\<Angstrom\>", "\<\[CapitalARing]\>", \(10\^\(-10\)\) \
"\<m\>"}, \[IndentingNewLine]{"\<Fermi\>", \(10\^\(-15\)\) "\<m\>"}, \
\[IndentingNewLine]{"\<Micron\>", \(10\^\(-6\)\) "\<m\>"}, \
\[IndentingNewLine]{"\<AstronomicalUnit\>", "\<AU\>", 
                      1.4959787066\ 10\^11\ "\<m\>"}, \
\[IndentingNewLine]{"\<Parsec\>", "\<pc\>", 
                      30857\ 10\^12\ "\<m\>"}, \
\[IndentingNewLine]{"\<LightYear\>", "\<ly\>", 
                      9.46073\ 10\^15\ "\<m\>"}, \
\[IndentingNewLine]{"\<DidotPoint\>", "\<Didot\>", "\<m\>"/
                        2660}, \[IndentingNewLine]{"\<Cicero\>", 
                      12\ "\<Didot\>"}, \[IndentingNewLine]{"\<Inch\>", "\<in\
\>", 2.54\ "\<cm\>"}, \[IndentingNewLine]{"\<Mil\>", "\<in\>"/
                        1000}, \[IndentingNewLine]{"\<Caliber\>", "\<in\>"/
                        100}, \[IndentingNewLine]{"\<Hand\>", 
                      4\ "\<in\>"}, \[IndentingNewLine]{"\<Link\>", 
                      7.92\ "\<in\>"}, \[IndentingNewLine]{"\<Span\>", 
                      9\ "\<in\>"}, \[IndentingNewLine]{"\<Cubit\>", 
                      18\ "\<in\>"}, \[IndentingNewLine]{"\<Ell\>", 
                      45\ "\<in\>"}, \[IndentingNewLine]{"\<Point\>", 
                      1/72\ "\<in\>"}, \[IndentingNewLine]{"\<Pica\>", 
                      12\ "\<Point\>"}, \
\[IndentingNewLine]{"\<PrintersPoint\>", 
                      0.013837\ "\<in\>"}, \[IndentingNewLine]{"\<Fathom\>", 
                      6\ "\<ft\>"}, \[IndentingNewLine]{"\<Rope\>", 
                      20\ "\<ft\>"}, \[IndentingNewLine]{"\<Chain\>", 
                      66\ "\<ft\>"}, \[IndentingNewLine]{"\<Cable\>", 
                      720\ "\<ft\>"}, \[IndentingNewLine]{"\<Skein\>", 
                      360\ "\<ft\>"}, \[IndentingNewLine]{"\<Stadion\>", 
                      622\ "\<ft\>"}, \[IndentingNewLine]{"\<Yard\>", \
"\<yd\>", 3\ "\<ft\>"}, \[IndentingNewLine]{"\<Bolt\>", 
                      40\ "\<yd\>"}, \[IndentingNewLine]{"\<Furlong\>", 
                      220\ "\<yd\>"}, \[IndentingNewLine]{"\<Stadium\>", 
                      202\ "\<yd\>"}, \[IndentingNewLine]{"\<Rod\>", 
                      5.5\ "\<yd\>"}, \[IndentingNewLine]{"\<Pole\>", \
"\<Rod\>"}, \[IndentingNewLine]{"\<Perch\>", "\<Rod\>"}, \
\[IndentingNewLine]{"\<SurveyMile\>", 
                      320\ "\<Rod\>"}, \[IndentingNewLine]{"\<StatuteMile\>", \
"\<Mile\>", "\<mi\>", 5280\ "\<ft\>"}, \[IndentingNewLine]{"\<League\>", 
                      3\ "\<Mile\>"}, \[IndentingNewLine]{"\<NauticalMile\>", \
"\<nm\>", 
                      1.852\ 10\^3\ "\<m\>"}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(--\(-\ \(AREA\ --\)\)\)\(-\)\ \
*) \[IndentingNewLine]"\<Barn\>", 
                      10\^\(-28\)\ "\<m\>"\^2}, \
\[IndentingNewLine]{"\<Shed\>", \(10\^\(-52\)\) "\<m\>"\^2}, \
\[IndentingNewLine]{"\<Are\>", 
                      100\ "\<m\>"\^2}, \[IndentingNewLine]{"\<Hectare\>", \
"\<ha\>", 100\ "\<Are\>"}, \[IndentingNewLine]{"\<CircularMile\>", \[Pi]/
                          4\ \(10\^\(-6\)\) "\<in\>"\^2}, \
\[IndentingNewLine]{"\<Rood\>", 
                      1/4\ "\<Acre\>"}, \[IndentingNewLine]{"\<Acre\>", 
                      10\ "\<Chain\>"\^2}, \[IndentingNewLine]{"\<Lot\>", 
                      1/10\ "\<mi\>"\^2}, \[IndentingNewLine]{"\<Section\>", \
"\<mi\>"\^2}, \[IndentingNewLine]{"\<Township\>", 
                      36 "\<mi\>"\^2}, \
\[IndentingNewLine]\[IndentingNewLine]{ (*\ \(--\(-\ \(VOLUME\ --\)\)\)\(-\)\ \
*) \[IndentingNewLine]"\<Liter\>", "\<L\>", "\<l\>", \(10\^\(-3\)\) \
"\<m\>"\^3}, \[IndentingNewLine]{"\<Stere\>", "\<st\>", "\<m\>"\^3}, \
\[IndentingNewLine]{"\<Barrel\>", "\<bbl\>", 
                      0.1590\ "\<m\>"\^3}, \[IndentingNewLine]{"\<Drop\>", 
                      0.03\ 10\^\(-6\)\ "\<m\>"\^3}, \
\[IndentingNewLine]{"\<Cord\>", 
                      128\ "\<ft\>"\^3}, \
\[IndentingNewLine]{"\<RegisterTon\>", 
                      100\ "\<ft\>"\^3}, \[IndentingNewLine]{"\<BoardFoot\>", 
                      144\ "\<in\>"\^3}, \[IndentingNewLine]{"\<UKPint\>", \
"\<ImperialPint\>", "\<ipt\>", 
                      0.568261\ "\<L\>"}, \
\[IndentingNewLine]{"\<WineBottle\>", 
                      0.7576778\ "\<L\>"}, \[IndentingNewLine]{"\<Last\>", 
                      2909.414\ "\<L\>"}, \[IndentingNewLine]{"\<UKGallon\>", \
"\<ImperialGallon\>", "\<impgal\>", 
                      4.54609\ "\<L\>"}, \[IndentingNewLine]{"\<Firkin\>", 
                      9\ "\<UKGallon\>"}, \[IndentingNewLine]{"\<Cup\>", 
                      0.236588\ "\<L\>"}, \[IndentingNewLine]{"\<Pint\>", \
"\<pt\>", 2\ "\<Cup\>"}, \[IndentingNewLine]{"\<FluidOunce\>", "\<Shot\>", 
                      1/16\ "\<Pint\>"}, \[IndentingNewLine]{"\<Minim\>", \
"\<FluidOunce\>"/480}, \[IndentingNewLine]{"\<Jigger\>", 
                      1.5\ "\<Shot\>"}, \[IndentingNewLine]{"\<Pony\>", 
                      0.5\ "\<Jigger\>"}, \
\[IndentingNewLine]{"\<FluidDram\>", 
                      1/8\ "\<FluidOunce\>"}, \
\[IndentingNewLine]{"\<Tablespoon\>", 
                      4\ "\<FluidDram\>"}, \
\[IndentingNewLine]{"\<Teaspoon\>", "\<Tablespoon\>"/
                        3}, \[IndentingNewLine]{"\<Noggin\>", "\<Gill\>", 
                      1/4\ "\<Pint\>"}, \[IndentingNewLine]{"\<Quart\>", 
                      2\ "\<Pint\>"}, \[IndentingNewLine]{"\<Fifth\>", 
                      4/5\ "\<Quart\>"}, \[IndentingNewLine]{"\<Magnum\>", 
                      2\ "\<Quart\>"}, \[IndentingNewLine]{"\<Gallon\>", \
"\<gal\>", 4\ "\<Quart\>"}, \[IndentingNewLine]{"\<Jeroboam\>", 
                      4/5\ "\<Gallon\>"}, \[IndentingNewLine]{"\<Bucket\>", 
                      4\ "\<Gallon\>"}, \[IndentingNewLine]{"\<Puncheon\>", 
                      84\ "\<Gallon\>"}, \[IndentingNewLine]{"\<Butt\>", 
                      126\ "\<Gallon\>"}, \[IndentingNewLine]{"\<Hogshead\>", \
"\<Butt\>"/2}, \[IndentingNewLine]{"\<Tun\>", 
                      4\ "\<Hogshead\>"}, \[IndentingNewLine]{"\<Peck\>", 
                      8.810\ "\<L\>"}, \[IndentingNewLine]{"\<Omer\>", 
                      0.45\ "\<Peck\>"}, \[IndentingNewLine]{"\<Ephah\>", 
                      10\ "\<Omer\>"}, \[IndentingNewLine]{"\<Bushel\>", 
                      4\ "\<Peck\>"}, \[IndentingNewLine]{"\<Seam\>", 
                      8\ "\<Bushel\>"}, \[IndentingNewLine]{"\<Bag\>", 
                      3\ "\<Bushel\>"}, \
\[IndentingNewLine]\[IndentingNewLine]{ (*\ \(--\(-\ \(MASS\ --\)\)\)\(-\)\ \
*) \[IndentingNewLine]"\<Quintal\>", 
                      100000\ "\<gr\>"}, \[IndentingNewLine]{"\<SolarMass\>", 
                      1.9891\ 10\^33\ "\<gr\>"}, \
\[IndentingNewLine]{"\<Dalton\>", "\<AtomicMassUnit\>", "\<AMU\>", 
                      1.6605402\ 10\^\(-24\)\ "\<gr\>"}, \
\[IndentingNewLine]{"\<AssayTon\>", 
                      29.167\ "\<gr\>"}, \[IndentingNewLine]{"\<Grain\>", 
                      64.799\ 10\^\(-3\)\ "\<gr\>"}, \
\[IndentingNewLine]{"\<Carat\>", 
                      0.2\ "\<gr\>"}, \[IndentingNewLine]{"\<Shekel\>", 
                      14.1\ "\<gr\>"}, \[IndentingNewLine]{"\<Obolos\>", 
                      715.38\ 10\^\(-3\)\ "\<gr\>"}, \
\[IndentingNewLine]{"\<Drachma\>", 
                      4.2923\ "\<gr\>"}, \[IndentingNewLine]{"\<Libra\>", 
                      325.971\ "\<gr\>"}, \
\[IndentingNewLine]{"\<TroyOunce\>", 
                      31.103\ "\<gr\>"}, \
\[IndentingNewLine]{"\<Pennyweight\>", 
                      1.555\ "\<gr\>"}, \[IndentingNewLine]{"\<MetricTon\>", \
"\<Tonne\>", "\<t\>", 10\^6\ "\<gr\>"}, \[IndentingNewLine]{"\<Pondus\>", 
                      0.71864\ "\<lb\>"}, \[IndentingNewLine]{"\<Stone\>", 
                      14\ "\<lb\>"}, \[IndentingNewLine]{"\<Wey\>", 
                      252\ "\<lb\>"}, \[IndentingNewLine]{"\<Bale\>", 
                      500\ "\<lb\>"}, \[IndentingNewLine]{"\<Ton\>", 
                      2240\ "\<lb\>"}, \[IndentingNewLine]{"\<Cental\>", \
"\<NetHundredweight\>", "\<ShortHundredweight\>", 
                      100\ "\<lb\>"}, \
\[IndentingNewLine]{"\<GrossHundredweight\>", "\<Hundredweight\>", "\<cwt\>", 
                      112\ "\<lb\>"}, \[IndentingNewLine]{"\<ShortTon\>", 
                      2000\ "\<lb\>"}, \[IndentingNewLine]{"\<Mina\>", 
                      0.9463\ "\<lb\>"}, \[IndentingNewLine]{"\<Talent\>", 
                      60\ "\<Mina\>"}, \
\[IndentingNewLine]{"\<AvoirdupoisOunce\>", "\<Ounce\>", "\<oz\>", 
                      28.3495\ "\<gr\>"}, \[IndentingNewLine]{"\<Geepound\>", \
"\<Slug\>", 
                      14.5939\ "\<kg\>"}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(--\(-\ \(FORCE\ --\)\)\)\(-\)\ \
*) \[IndentingNewLine]"\<TonForce\>", 
                      9.96402\ 10\^3\ "\<N\>"}, \
\[IndentingNewLine]{"\<KilogramWeight\>", "\<KilogramForce\>", 
                      9.80665\ "\<N\>"}, \
\[IndentingNewLine]{"\<GramWeight\>", "\<GramForce\>", "\<KilogramWeight\>"/
                        1000}, \[IndentingNewLine]{"\<Poundal\>", "\<pdl\>", 
                      0.138255\ "\<N\>"}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(--\(-\ \(PRESSURE\ --\)\)\)\(-\)\ \
*) \[IndentingNewLine]"\<Atmosphere\>", "\<atm\>", 
                      0.101325\ 10\^6\ "\<Pa\>"}, \
\[IndentingNewLine]{"\<InchMercury\>", "\<inHg\>", 
                      3.38639\ 10\^3\ "\<Pa\>"}, \
\[IndentingNewLine]{"\<Bar\>", 
                      10\^5\ "\<Pa\>"}, \
\[IndentingNewLine]{"\<PoundsPerSquareInch\>", "\<PSI\>", 
                      6.894757\ 10\^3\ "\<Pa\>"}, \
\[IndentingNewLine]{"\<MillimeterMercury\>", "\<mmHg\>", "\<Torricheli\>", \
"\<Tor\>", 
                      1.33322\ 10\^2\ "\<Pa\>"}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(--\(-\ \(ENERGY\ --\)\)\)\(-\)\ \
*) \[IndentingNewLine]"\<Rydberg\>", 
                      2.1799\ 10\^\(-11\)\ "\<erg\>"}, \
\[IndentingNewLine]{"\<ElectronVolt\>", "\<eV\>", 
                      0.160217733\ 10\^\(-18\)\ "\<J\>"}, \
\[IndentingNewLine]{"\<Calorie\>", "\<cal\>", 
                      4.1868\ "\<J\>"}, \
\[IndentingNewLine]{"\<BritishThermalUnit\>", "\<BTU\>", "\<Btu\>", 
                      1.05506\ 10\^3\ "\<J\>"}, \
\[IndentingNewLine]{"\<Therm\>", 
                      10\^5\ "\<BTU\>"}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(--\(-\ \(POWER\ --\)\)\)\(-\)\ \
*) \[IndentingNewLine]"\<ChevalVapeur\>", "\<CV\>", 
                      0.735499\ 10\^3\ "\<W\>"}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(\(--\(-\ 
                                VISCOSITY\)\)\ \(variet\[EAcute]e\ \
--\)\)\(-\)\ *) \[IndentingNewLine]"\<Rhes\>", "\<Poise\>"\^\(-1\)}, \
\[IndentingNewLine]{"\<Reyn\>", "\<lbf\>"\ "\<s\>"\ "\<in\>"\^\(-2\)}, \
\[IndentingNewLine]\[IndentingNewLine]{ (*\ \(\(--\(-\ 
                                LIGHT\)\)\ \(variet\[EAcute]e\ --\)\)\(-\)\ \
*) \[IndentingNewLine]"\<Nit\>", "\<cd\>"\ "\<m\>"\^\(-2\)}, \
\[IndentingNewLine]{"\<Hefner\>", 
                      0.92\ "\<cd\>"}, \[IndentingNewLine]{"\<Candle\>", \
"\<cd\>"}, \[IndentingNewLine]{"\<FootCandle\>", "\<lx\>"\ "\<m\>"\^2\ \
"\<ft\>"\^\(-2\)}, \[IndentingNewLine]{"\<Lambert\>", \((10\^4/
                            Pi)\)\ "\<lm\>"\ "\<m\>"\^\(-2\)}, \
\[IndentingNewLine]{"\<Apostilb\>", 
                      10\^\(-4\)\ "\<Lambert\>"}, \
\[IndentingNewLine]{"\<Talbot\>", "\<lm\>"\ "\<s\>"}, \
\[IndentingNewLine]{"\<Lumerg\>", "\<Talbot\>"}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(\(--\(-\ 
                                ESU\)\)\  &\)\ EMU\ \
*) \[IndentingNewLine]"\<Gilbert\>", "\<Gb\>", 
                      1/\((4\ Pi)\)\ 10\ "\<A\>"}, \
\[IndentingNewLine]{"\<AbAmpere\>", "\<abA\>", "\<Biot\>", "\<Bi\>", 
                      10\ "\<A\>"}, \[IndentingNewLine]{"\<StatAmpere\>", \
"\<statA\>", 
                      3.335635\ 10\^\(-10\)\ "\<A\>"}, \
\[IndentingNewLine]{"\<AbOhm\>", "\<abOhm\>", "\<ab\[CapitalOmega]\>", 
                      10\^\(-9\)\ "\<\[CapitalOmega]\>"}, \
\[IndentingNewLine]{"\<StatOhm\>", "\<statOhm\>", "\<stat\[CapitalOmega]\>", 
                      8.987584\ 10\^11\ "\<\[CapitalOmega]\>"}, \
\[IndentingNewLine]{"\<AbMho\>", "\<abmho\>", "\<abSiemens\>", "\<abS\>", 
                      10\^9\ "\<S\>"}, \[IndentingNewLine]{"\<StatMho\>", \
"\<statmho\>", "\<statSiemens\>" "\<StatS\>", 
                      1.1126\ 10\^\(-12\)\ "\<S\>"}, \
\[IndentingNewLine]{"\<AbCoulomb\>", "\<abC\>", 
                      10\ "\<C\>"}, \[IndentingNewLine]{"\<StatCoulomb\>", \
"\<statC\>", 
                      3.335635\ 10\^\(-10\)\ "\<C\>"}, \
\[IndentingNewLine]{"\<AbFarad\>", "\<abF\>", 
                      10\^9\ "\<F\>"}, \[IndentingNewLine]{"\<StatFarad\>", "\
\<statF\>", 
                      1.112646\ 10\^\(-12\)\ "\<F\>"}, \
\[IndentingNewLine]{"\<AbHenry\>", "\<abH\>", "\<abHy\>", 
                      10\^\(-9\)\ "\<H\>"}, \
\[IndentingNewLine]{"\<StatHenry\>", "\<statH\>", "\<statHy\>", 
                      8.987584\ 10\^11\ "\<H\>"}, \
\[IndentingNewLine]{"\<AbVolt\>", "\<abV\>", 
                      10\^\(-8\)\ "\<V\>"}, \
\[IndentingNewLine]{"\<StatVolt\>", "\<statV\>", 
                      299.7930\ "\<V\>"}, \[IndentingNewLine]{"\<Gamma\>", 
                      10\^\(-9\)\ "\<T\>"}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(--\(-\ \(INFORMATION\ --\)\)\)\(-\)\ \
*) \[IndentingNewLine]"\<Byte\>", 
                      8\ "\<Bit\>"}, \[IndentingNewLine]{"\<Nibble\>", 
                      4\ "\<Bit\>"}, \[IndentingNewLine]{"\<Baud\>", \
"\<Bit\>"/"\<Second\>"}, \[IndentingNewLine]\[IndentingNewLine]{ (*\ \(\(\(\
--\(-\ RADIOACTIVITY\)\)\  &\)\ MEDICAL\ \(variet\[EAcute]e\ --\)\)\(-\)\ \
*) \[IndentingNewLine]"\<Rad\>", 
                      0.01\ "\<Gray\>"}, \[IndentingNewLine]{"\<Gray\>", \
"\<gy\>", "\<J\>"\ "\<kg\>"\^\(-1\)}, \[IndentingNewLine]{"\<Rutherford\>", 
                      10\^6\ "\<s\>"\^\(-1\)}, \
\[IndentingNewLine]{"\<Becquerel\>", "\<s\>"\^\(-1\)}, \
\[IndentingNewLine]{"\<Curie\>", "\<Ci\>", 
                      37\ 10\^9\ "\<Becquerel\>"}, \
\[IndentingNewLine]{"\<Rontgen\>", "\<Roentgen\>", 
                      0.258\ 10\^\(-3\)\ "\<C\>" "\<kg\>"\^\(-1\)}, \
\[IndentingNewLine]{"\<GramsRadiation\>", "\<rd\>", \(10\^\(-2\)\) "\<gy\>"}, \
\[IndentingNewLine]{"\<Sievert\>", "\<Sv\>", "\<J\>"\ "\<kg\>"\^\(-1\)}, \
\[IndentingNewLine]{"\<Rems\>", \(10\^\(-2\)\) "\<Sv\>"}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(\(--\(-\ 
                                ANGULAR\)\)\ \(SPEED\ --\)\)\(-\)\ \
*) \[IndentingNewLine]"\<RevolutionsPerMinute\>", "\<rpm\>", 
                      2  \[Pi]\ "\<rad\>"\ "\<min\>"\^\(-1\)}, \
\[IndentingNewLine]\[IndentingNewLine]{ (*\ \(--\(-\ \(FITNESS\ --\)\)\)\(-\)\
\ *) \[IndentingNewLine]"\<Denier\>", 
                      1/9000\ "\<gr\>"\ "\<m\>"\^\(-1\)}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(--\(-\ \(SPEED\ \
--\)\)\)\(-\)*) \[IndentingNewLine]"\<Knot\>", "\<NauticalMile\>"/"\<h\>"}, \
\[IndentingNewLine]\[IndentingNewLine]{ (*\ \(\(--\(-\ 
                                INVERSE\)\)\ \(LENGTH\ --\)\)\(-\)\ \
*) \[IndentingNewLine]"\<Kayser\>", 
                      100\ "\<m\>"\^\(-1\)}, \
\[IndentingNewLine]{"\<Diopter\>", "\<m\>"\^\(-1\)}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(--\(-\ \(ACTION\ --\)\)\)\(-\)\ \
*) \[IndentingNewLine]"\<Planck\>", "\<J\>"\ "\<s\>"}\[IndentingNewLine]\
\[IndentingNewLine]} //. "\<ft\>" \[Rule] \(1524\/5000\) "\<m\>"\) //. \
"\<lb\>" \[Rule] \(5000000\/11023113\) "\<kg\>"\) \
//. \[IndentingNewLine]"\<cm\>" \[Rule] \(10\^\(-2\)\) "\<m\>"\) //. "\<gr\>" \
\[Rule] \(10\^\(-3\)\) "\<kg\>"];\)\)



(* === Some little simplifications *)

(* --- CoDomain of Unit function *)
Unit/:Unit[_]\[Element]Reals:=True;
Unit/:Unit[_]>0:=True;
Unit/:Unit[_]\[GreaterEqual]0:=True;
Unit/:Unit[_]<0:=False;
Unit/:Unit[_]\[LessEqual]0:=False;

(* --- Test Functions *)
Unit/:Positive[Unit[_]]:=True;
Unit/:NonNegative[Unit[_]]:=True;
Unit/:Negative[Unit[_]]:=False;
Unit/:NonPositive[Unit[_]]:=False;

(* === Mathematical Functions *)

(* --- Numerical Functions *)
Unit/:Abs[Unit[x_]]:=Unit[x];
Unit/:Sign[Unit[x_]]:=1;
Unit/:Round[Unit[x_]]:=Unit[x];
Unit/:IntegerPart[Unit[x_]]:=Unit[x];
Unit/:FractionalPart[Unit[x_]]:=Unit[x];
Unit/:Ceiling[Unit[x_]]:=Unit[x];
Unit/:Floor[Unit[x_]]:=Unit[x];
Unit/:Re[Unit[x_]]:=Unit[x];
Unit/:Conjugate[Unit[x_]]:=Unit[x];
Unit/:Im[Unit[x_]]:=0;
Unit/:Arg[Unit[x_]]:=0;

(* --- Vectorial Functions *)
Unit/:Norm[Unit[x_]]:=Unit[x];
Unit/:Dot[a_,Unit[x_]]:=a Unit[x];
Unit/:Dot[Unit[x_],a_]:=a Unit[x];
Unit/:Cross[a_,Unit[x_]]:=a Unit[x];
Unit/:Cross[Unit[x_],a_]:=a Unit[x];







(* --- $unit *)

Unit["System",Default]:=$unit;
$unit:=
    If[ValueQ[$Unit]\[And]UnitQ[$Unit,"System"],
      $Unit,
      Unit[Set,UnitMKS];$Unit];



table=Dispatch@Unit[Table,All];
Unit[Set,All];



End[];



SetAttributes[#,{ReadProtected,Protected}]&/@{
      Unit,$Unit,UnitQ,
      UnitD,UnitN,UnitK,UnitS,UnitI,
      UnitConvert,UnitSimplify,
      UnitFullSimplify,UnitPowerExpand,UnitComplexExpand,
      UnitDIM,UnitMKS,UnitCGS,UnitFPS};
SetAttributes[#,{Protected}]&/@{
      Angle,Temperature,
      Base,Derived,Combined,
      Equivalence,System,
      Author};



EndPackage[(*"adMath`Unit`"*)];

(* --- (c) 2004 Alvaro D\[IAcute]az Falconi --- *)