(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    834245,      19452]*)
(*NotebookOutlinePosition[   1154961,      29816]*)
(*  CellTagsIndexPosition[   1153693,      29783]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell[TextData[{
  "adMath",
  StyleBox["`", "MB"],
  "Unit",
  StyleBox["`", "MB"]
}], "Subsection",
  CellTags->"Unit tour"],

Cell["\[Copyright] 2004, Alvaro D\[IAcute]az Falconi", "Caption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{

Cell["Installation notes", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->"Installation notes"],

Cell["\<\
Welcame to Unit package. I assume that you obtaing this file decompressing \
Unit.zip. To instal Unit package, follow this steps:\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->"Installation notes"],

Cell[TextData[{
  StyleBox["1",
    FontWeight->"Bold"],
  ". ",
  Cell[BoxData[
      \(adMath\)]],
  " directory: Save the file ",
  Cell[BoxData[
      \(Unit . m\)]],
  " in this directory (execute the next cell)"
}], "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->"Installation notes"],

Cell[CellGroupData[{

Cell[BoxData[
    \(ToFileName[{$InstallationDirectory, \[IndentingNewLine]"\<AddOns\>", \
"\<Applications\>", \[IndentingNewLine]"\<adMath\>"}]\)], "Input",
  CellLabel->"In[1]:=",
  CellTags->"Installation notes"],

Cell[BoxData[
    \("c:\\Program Files\\Wolfram \
Research\\Mathematica\\5.0\\Mathematica\\AddOns\\Applications\\adMath\\"\)], \
"Output",
  CellLabel->"Out[338]="]
}, Open  ]],

Cell[TextData[{
  StyleBox["2",
    FontWeight->"Bold"],
  ". ",
  Cell[BoxData[
      \(adMathUnit\)]],
  " directory: Save the Unit package documentation files, ",
  Cell[BoxData[
      \(UnitDocumentation . nb\)]],
  " (this file), and ",
  Cell[BoxData[
      \(BrowserCategories . m\)]],
  " in this directory (execute the next cell)"
}], "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->"Installation notes"],

Cell[CellGroupData[{

Cell[BoxData[
    \(ToFileName[{$InstallationDirectory, \[IndentingNewLine]"\<AddOns\>", \
\[IndentingNewLine]"\<Applications\>", \[IndentingNewLine]"\<adMathUnit\>", "\
\<Documentation\>", "\<English\>"}]\)], "Input",
  CellLabel->"In[2]:=",
  CellTags->"Installation notes"],

Cell[BoxData[
    \("c:\\Program Files\\Wolfram \
Research\\Mathematica\\5.0\\Mathematica\\AddOns\\Applications\\adMathUnit\\\
Documentation\\English\\"\)], "Output",
  CellLabel->"Out[339]=",
  CellTags->"Installation notes"]
}, Open  ]],

Cell[TextData[{
  StyleBox["3",
    FontWeight->"Bold"],
  ". Then, from main menu, select \"Help / Rebuild Help Index\""
}], "Text",
  CellTags->"Installation notes"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .86861 
%%ImageSize: 275 239 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
1.64799e-017 0.00364964 -0.00364964 0.00364964 [
[ 0 0 0 0 ]
[ 1 .86861 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .86861 L
0 .86861 L
closepath
clip
newpath
% Start of gray image
p
0 -0.00365 translate
1.00365 .87226 scale
275 string
275 239 8 [275 0 0 239 0 0] {
\tcurrentfile
\t1 index
\treadhexstring
\tpop
}  Mimage
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFA616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161FAFAA6
A6FAFA616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161FAFAA6
A6FAFA616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161FAFAA6
A6FAFA616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
61FA61616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161FAFAA6
A6FAFA616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
61FA61616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161FAFAA6
A6FAFA6161616161616161616161616161616161FA61616161FA6161FAFAFA6161FAFAFA
FA616161FAFAFAFA61FA61FA6161FAFAFAFA61616161FA61616161FA6161FAFAFA6161FA
61FAFAFAFA6161616161FAFAFA61FA616161FA6161FAFAFAFA6161FAFAFA6161FA616161
FA6161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161FAFAA6
A6FAFA6161616161616161616161616161616161FA616161FA6161FA616161FA61FA6161
61FA61FA616161FA61FA61FA61FA616161FA61616161FA61616161FA61FA616161FA61FA
61FA616161FA6161616161FA6161FA616161FA61FA616161FA61FA616161FA6161FA61FA
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161FAFAA6
A6FAFA6161616161616161616161616161616161FA6161FA616161FA6161616161FA6161
61FA61FA616161FA61FA61FA61FA616161FA61616161FA61616161FA61FA6161616161FA
61FA616161FA6161616161FA6161FA616161FA61FA616161FA61FA61616161616161FA61
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161FAFAA6
A6FAFA6161616161616161616161616161616161FAFAFAFA616161FAFAFAFAFA61FA6161
61FA61FA616161FA61FA61FA61FA616161FA61616161FA61616161FA61FAFAFAFAFA61FA
61FA616161FA6161616161FA6161FA616161FA61FA616161FA61FAFAFAFAFA616161FA61
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161FAFAA6
A6FAFA6161616161616161616161616161616161FA616161FA6161FA616161FA61FA6161
61FA61FA616161FA61FA61FA61FA616161FA61616161FAFAFAFAFAFA61FA616161FA61FA
61FA616161FA6161616161FA6161FA616161FA61FA616161FA61FA616161FA6161FA61FA
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161FAFAA6
A6FAFA6161616161616161616161616161616161FA616161FA616161FAFAFA6161FAFAFA
FA6161FA616161FA61FA61FA6161FAFAFAFA61616161FA61616161FA6161FAFAFA6161FA
61FAFAFAFA616161616161FA6161FAFAFAFA616161FAFAFAFA6161FAFAFA6161FA616161
FA6161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161FAFAA6
A6FAFA6161616161616161616161616161616161FA616161FA6161616161616161FA6161
6161616161616161616161FA6161616161FA61616161FA61616161FA61616161616161FA
6161616161616161616161FA616161616161616161616161FA6161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161FAFAA6
A6FAFA6161616161616161616161616161616161FAFAFAFA616161616161616161FA6161
616161616161616161FA61FA6161616161FA61616161FA61616161FA61616161616161FA
61616161616161616161FAFAFA6161616161616161616161FA6161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161FAFAA6
A6FAFA616161616161616161616161616161616161616161616161616161616161FA6161
6161616161616161616161FA6161616161FA6161616161616161616161616161616161FA
616161616161616161616161616161616161616161616161FA6161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161FAFAA6
A6FAFA616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161FAFAA6
A6FAFA616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161FAFAA6
A6FAFA616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161FAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAA6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6FAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFA00FA00000000FAFAFA0000
00FAFAFA00000000FAFA0000FAFAFAFA00FAFAFAFAFA00FAFA00000000FAFA0000FA00FA
FAFA00FAFA000000FAFA00FAFA00FAFA00FAFA00000000FAFA0000FA00FAFA000000FAFA
00000000FAFA00FAFAFA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFA00FA00FAFAFA00FA00FAFA
FA00FA00FAFAFA00FA00FAFAFAFAFAFA00FAFAFAFAFA00FA00FAFAFA00FA00FAFAFA00FA
FAFA00FA00FAFAFA00FA00FAFA00FAFA00FA00FAFAFA00FA00FAFAFA00FA00FAFAFAFA00
FAFAFA00FAFA00FAFAFA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA000000000000FA00FAFAFA00FA00FAFA
FA00FA00FAFAFA00FA00FAFAFAFAFAFA00FAFA00FAFA00FA00FAFAFA00FA00FAFAFA00FA
FAFA00FA00FAFAFAFAFA00FAFA00FAFA00FA00FAFAFA00FA00FAFAFA00FA00FAFAFAFA00
FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFA00FAFA00FAFAFA00FA00FAFA
FA00FA00FAFAFA00FA00FAFAFAFAFAFA00FAFA00FAFA00FAFA00000000FA00FAFAFA00FA
FAFA00FA0000000000FA00FAFA00FAFA00FAFA00000000FA00FAFAFA00FA00FAFAFAFAFA
00000000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFA00FAFA00FAFAFA00FA00FAFA
FA00FA00FAFAFA00FA00FAFAFAFAFAFA00FA00FA00FA00FAFAFAFAFA00FA00FAFAFA00FA
FAFA00FA00FAFAFA00FA00FAFA00FAFA00FAFAFAFAFA00FA00FAFAFA00FA00FAFAFAFAFA
FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFA00FAFA00000000FAFAFA0000
00FAFA00FAFAFA00FA000000FAFAFAFA00FA00FA00FA00FAFA000000FAFA000000FA0000
0000FAFAFA000000FAFA000000FA0000FAFAFA000000FAFA000000FA00FAFA000000FAFA
000000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA0000FAFAFA00FAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFA00FAFAFAFAFAFA0000FAFAFA0000FAFAFAFAFAFAFA00FAFAFA00FA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA0000FAFAFA00FAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFA00FAFAFAFAFAFA0000FAFAFA0000FAFAFAFAFAFAFA00FAFAFA00FA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFA00FAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00000000FAFAFA0000FAFA00000000FA
00FAFAFAFA0000FAFA00000000FA00000000FAFAFAFAFA00FAFAFAFAFAFA00000000FA00
FAFA000000FAFAFA0000FAFA0000FAFA000000FAFAFA00FAFAFA00FAFAFA00FAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FA00FAFAFA00FAFAFA00FA
00FAFAFA00FAFAFA00FAFAFA00FA00FAFAFA00FAFAFAFA00FAFAFAFAFA00FAFAFA00FA00
FA00FAFAFA00FA00FAFAFA00FAFAFA00FAFAFA00FAFA00FAFAFA00FAFAFA00FAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FA00FAFAFA00FAFAFA00FA
00FAFAFA00FAFAFA00FAFAFA00FA00FAFAFA00FAFAFAFA00FAFAFAFAFA00FAFAFA00FA00
FA00FAFAFAFAFA00FAFAFA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FA00FAFAFAFA00000000FA
00FAFAFA00FAFAFA00FAFAFA00FA00FAFAFA00FAFAFAFA00000000FAFAFA00000000FA00
FA0000000000FA00FAFAFA00FAFAFA0000000000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA000000FAFA00FAFAFAFAFAFAFA00FA
0000FAFA00FAFAFA00FAFAFA00FA00FAFAFA00FAFAFAFA00FAFAFA00FAFAFAFAFA00FA00
FA00FAFAFA00FA00FAFAFA00FAFAFA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFA000000FAFA000000FAFA
00FA00FA000000FA00FAFAFA00FA00000000FAFAFAFAFA00FAFAFA00FAFA000000FAFA00
FAFA000000FAFA000000FA000000FAFA000000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFA00FAFAFAFAFAFAFAFAFA
FAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFA00FAFAFAFAFAFAFA00
FAFAFAFAFAFAFA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00000000FA00FAFAFAFAFAFAFAFAFA
FAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00000000FAFAFAFAFAFAFAFA00
FAFAFAFAFAFAFA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFA00FAFAFA00FAFAFA00FA
FAFA00FAFAFAFAFAFAFA0000FA00FAFAFA00FAFA000000FAFAFAFAFA00000000FAFAFA00
0000FAFAFA000000FAFA00000000FAFAFA00FAFAFAFA00FAFAFA00FAFAFA00FAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFA00000000FAFA00FAFAFA00FA00FA00FAFAFAFA0000FAFAFAFA
00FAFAFAFAFAFA00000000FAFA0000FA00FAFAFA00FAFAFAFA00FAFAFAFA00FAFAFAFA00
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFA00FAFAFA00FAFAFA00FA
FAFA00FAFAFAFAFAFA00FAFAFA00FAFAFA00FA00FAFAFA00FAFAFAFA00FAFAFA00FA00FA
FAFA00FA00FAFAFA00FA00FAFAFA00FAFAFAFAFAFAFA00FAFAFA00FAFAFA00FAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FA00FAFAFA00FA00FA00FAFAFA00FAFAFAFAFAFA
00FAFAFAFAFA00FAFAFAFAFA00FAFAFA00FAFAFA00FAFAFAFA00FAFAFAFA00FAFAFAFA00
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FA00FA00FA00FAFA00FAFAFA00FA
FA00FA00FAFAFAFAFA00FAFAFA00FAFAFA00FA00FAFAFAFAFAFAFAFA00FAFAFA00FA00FA
FAFAFAFA00FAFAFAFAFA00FAFAFA00FAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FA00FAFAFA00FA00FA00FAFAFA00FAFAFAFAFAFA
00FAFAFAFA00FAFAFAFAFAFA00FAFAFA00FAFAFA00FAFAFAFA00FAFAFAFA00FAFAFAFA00
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FA00FA00FA00FAFA00FAFAFA00FA
FA00FA00FAFAFAFAFA00FAFAFA00FAFAFA00FA0000000000FAFAFAFA00FAFAFA00FA0000
000000FA0000000000FA00FAFAFA00FAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FA00FAFAFA00FA00FA00FAFAFA00FAFAFA000000
00000000FA00FAFAFAFAFAFA00FAFAFA00FAFAFA00FA00000000000000FA00FAFAFAFA00
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FA00FA00FA00FAFA00FAFAFA00FA
00FAFAFA00FAFAFAFA00FAFAFA00FAFAFA00FA00FAFAFA00FAFAFAFA00000000FAFA00FA
FAFA00FA00FAFAFA00FA00FAFAFA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFA000000FAFA00FAFAFA00FA00FA00FAFAFA00FAFAFAFAFAFA
00FAFAFAFA00FAFAFAFAFAFA00FAFAFA0000FAFA00FAFAFAFA00FAFAFAFA000000000000
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFA00FAFAFA00FA00000000FAFA
00FAFAFA00FAFAFAFA000000FA00000000FAFAFA000000FAFAFAFAFA00FAFAFA00FAFA00
0000FAFAFA000000FAFA00000000FAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFA00000000FAFA00FA000000FA000000FAFAFAFA
00FAFAFAFA00FAFAFAFAFAFA000000FA00FA00FA00FAFAFAFA00FAFAFAFA00FAFAFAFA00
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFA00FAFAFA00FA00FAFAFAFAFA
FAFAFAFAFAFAFAFAFA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFA00FAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFA00FAFAFAFAFAFAFA00FAFAFA00FAFAFAFAFAFA
00FAFAFAFAFA00FAFAFAFAFA00FAFAFAFAFAFAFA00FAFAFAFA00FAFAFAFA00FAFAFAFA00
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFA00FAFAFA00FA00FAFAFAFAFA
FAFAFAFAFAFAFAFAFA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFA00000000FAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA000000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFA00000000FA00FAFAFAFAFA00FA00FAFAFA00FAFAFAFAFAFA
FAFAFAFAFAFAFA00000000FA00FAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFA00FAFAFAFA00
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFA0000FAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAA6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6FAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA000000FAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA000000FAFAFA00FAFAFA00FA00FA
00FA00FAFAFA00FAFA000000FAFAFAFAFA00FAFAFAFA00FAFA000000FAFAFA00000000FA
00FA000000FAFAFA0000FA00FAFAFAFA00000000FAFA0000FA00FAFA000000FAFA00FAFA
FA00FAFA00FAFAFA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFA00FAFA00FAFAFA00FA00FA
00FA00FAFAFA00FA00FAFAFA00FAFAFAFA00FAFAFA00FAFA00FAFAFA00FA00FAFAFA00FA
00FAFAFAFA00FA00FAFAFA00FAFAFA00FAFAFA00FA00FAFAFA00FA00FAFAFA00FA00FAFA
FA00FAFA00FAFAFA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFA00FA00FAFAFA00FA00FA
00FA00FAFAFA00FA00FAFAFAFAFAFAFAFA00FAFA00FAFAFA00FAFAFAFAFA00FAFAFA00FA
00FAFAFA0000FA00FAFAFA00FAFAFA00FAFAFA00FA00FAFAFA00FA00FAFAFA00FA00FAFA
FA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFA00FA00FAFAFA00FA00FA
00FA00FAFAFA00FA0000000000FAFAFAFA00000000FAFAFA0000000000FA00FAFAFA00FA
00FA0000FAFAFA00FAFAFA00FAFAFAFA00000000FA00FAFAFA00FA00FAFAFA00FA00FAFA
FA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFA00FA00FAFAFA00FA00FA
00FA00FAFAFA00FA00FAFAFA00FAFAFAFA00FAFAFA00FAFA00FAFAFA00FA00FAFAFA00FA
00FA00FAFAFAFA00FAFAFA0000FAFAFAFAFAFA00FA00FAFAFA00FA00FAFAFA00FA00FAFA
FA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFA00FA00000000FAFA00FA
00FA00000000FAFAFA000000FAFAFAFAFA00FAFAFA00FAFAFA000000FAFAFA00000000FA
00FAFA000000FA000000FA00FA00FAFA000000FAFA000000FA00FAFA000000FAFA000000
00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFA00FAFAFAFAFAFAFAFA00FA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA000000FAFAFAFAFAFAFAFAFA00FA
00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00000000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
00FAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFA00FAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFA00FAFAFAFA000000FAFA
00FA00FAFAFA00FAFAFAFA00000000FA00FAFA00FAFA00FAFAFAFA00FAFAFAFA00FAFA00
0000FAFA000000FAFAFA000000FAFAFA00000000FA00FAFAFAFA000000FA00FAFAFA00FA
FAFAFAFA000000FAFA00FAFAFA00FAFAFAFAFA0000FA00FAFAFA00FAFA000000FAFAFAFA
FAFAFA00FAFAFA00FAFAFAFA000000FAFA00000000FAFAFA00FAFAFA00FAFAFA00FAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFA00FAFAFA00FAFAFA00FA
00FA00FAFAFA00FAFAFA00FAFAFA00FA00FAFA00FAFA00FAFAFAFA00FAFAFA00FAFA00FA
FAFA00FAFAFAFA00FA00FAFAFA00FA00FAFAFA00FA00FAFAFA00FAFAFAFA00FAFAFA00FA
FAFAFA00FAFAFA00FA00FAFAFA00FAFAFAFA00FAFAFA00FAFAFA00FA00FAFAFA00FAFAFA
FAFAFA00FAFAFA00FAFAFA00FAFAFA00FA00FAFAFA00FAFA00FAFAFA00FAFAFA00FAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FA00FA00FA00FAFA00FAFAFA00FA
00FA00FAFAFA00FAFAFA00FAFAFA00FA00FAFA00FAFA00FAFAFAFA00FAFA00FAFAFA00FA
FAFAFAFAFAFA0000FA00FAFAFAFAFA00FAFAFA00FA00FAFAFA00FAFAFAFA00FAFAFA00FA
FAFAFA00FAFAFA00FA00FAFAFA00FAFAFAFA00FAFAFA00FAFAFA00FA00FAFAFAFAFAFAFA
FAFA00FA00FA00FA00FAFA00FAFAFAFAFA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FA00FA00FA00FAFA00FAFAFA00FA
00FA00FAFAFA00FAFAFAFA00000000FA00FAFA00FAFA00FAFAFAFA00000000FAFAFA0000
000000FA0000FAFAFA0000000000FAFA00000000FA00FAFAFA00FAFAFAFA00FAFAFA00FA
FAFAFA00FAFAFA00FA00FAFAFA00FAFAFAFA00FAFAFA00FAFAFA00FA0000000000FAFAFA
FAFA00FA00FA00FA00FAFA0000000000FA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FA00FA00FA00FAFA00FAFAFA00FA
00FA00FAFAFA0000FAFAFAFAFAFA00FA00FAFA00FAFA00FAFAFAFA00FAFAFA00FAFA00FA
FAFA00FA00FAFAFAFA00FAFAFA00FAFAFAFAFA00FA0000FAFA00FAFAFAFA00FAFAFA00FA
FAFAFA00FAFAFA00FA00FAFAFA00FAFAFAFA00FAFAFA00FAFAFA00FA00FAFAFA00FAFAFA
FAFA00FA00FA00FA00FAFA00FAFAFA00FA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFA00FAFAFA00FAFA000000FAFA
00FA000000FA00FA00FAFA000000FAFA000000FA0000FAFAFAFAFA00FAFAFA00FAFAFA00
0000FAFAFA000000FAFA000000FAFAFA000000FAFA00FA00FAFA000000FA00000000FAFA
FAFAFAFA000000FAFA00000000FAFAFAFAFA000000FA00000000FAFAFA000000FAFAFAFA
FA00FAFAFA00FAFAFA00FAFA000000FAFA00000000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFA00FAFAFA00FAFAFAFAFAFAFA
00FA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFA00FAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFA
FA00FAFAFA00FAFAFA00FAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFA00FAFAFA00FAFAFAFAFAFAFA
00FA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00000000FAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFA
FA00FAFAFA00FAFAFA00FAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
00FAFA0000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA000000FA00FAFAFA00FA00FAFAFAFA00
0000FAFA00FAFAFA00FAFA00FAFA00FAFA00000000FAFA0000FA00FAFA000000FAFA00FA
FAFA00FAFAFAFAFAFA00000000FAFA000000FAFA00FAFAFA00FAFA0000FAFA000000FAFA
00FAFAFAFAFAFAFA000000FAFA00FAFAFA00FAFAFAFAFA0000FA00FAFAFA00FAFA000000
FAFAFAFAFAFAFA00FAFAFA00FAFAFAFA000000FAFA00000000FAFAFA00FAFAFA00FAFAFA
00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFA00FAFAFA00FA00FAFAFA00FA
FAFA00FA00FAFAFA00FAFA00FAFA00FA00FAFAFA00FA00FAFAFA00FA00FAFAFA00FA00FA
FAFA00FAFAFAFAFA00FAFAFAFAFA00FAFAFA00FA00FAFAFA00FA00FAFAFA00FAFAFA00FA
00FAFAFAFAFAFA00FAFAFA00FA00FAFAFA00FAFAFAFA00FAFAFA00FAFAFA00FA00FAFAFA
00FAFAFAFAFAFA00FAFAFA00FAFAFA00FAFAFA00FA00FAFAFA00FAFA00FAFAFA00FAFAFA
00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFA00FAFAFA00FA00FAFAFA00FA
FAFA00FA00FAFAFA00FAFA00FAFA00FA00FAFAFA00FA00FAFAFA00FA00FAFAFA00FA00FA
FAFA00FAFAFAFA00FAFAFAFAFAFA00FAFAFAFAFA00FAFAFA00FA00FAFAFA00FAFAFAFAFA
00FAFAFAFAFAFA00FAFAFA00FA00FAFAFA00FAFAFAFA00FAFAFA00FAFAFA00FA00FAFAFA
FAFAFAFAFAFA00FA00FA00FA00FAFA00FAFAFAFAFA00FAFAFA00FAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFA00FAFAFA00FA00FAFAFA00FA
FAFA00FA00FAFAFA00FAFA00FAFA00FAFA00000000FA00FAFAFA00FA00FAFAFA00FA00FA
FAFA00FAFAFAFA00FAFAFAFAFAFA0000000000FA00FAFAFA00FA00FAFAFA0000000000FA
00FAFAFAFAFAFA00FAFAFA00FA00FAFAFA00FAFAFAFA00FAFAFA00FAFAFA00FA00000000
00FAFAFAFAFA00FA00FA00FA00FAFA0000000000FA00FAFAFA00FAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFA00FAFAFA00FA00FAFAFA00FA
FAFA00FA0000FAFA00FAFA00FAFA00FAFAFAFAFA00FA00FAFAFA00FA00FAFAFA00FA00FA
FAFA00FAFAFAFA00FAFAFAFAFAFA00FAFAFA00FA00FAFAFA00FA00FAFAFA00FAFAFA00FA
0000FAFAFAFAFA00FAFAFA00FA00FAFAFA00FAFAFAFA00FAFAFA00FAFAFA00FA00FAFAFA
00FAFAFAFAFA00FA00FA00FA00FAFA00FAFAFA00FA00FAFAFA00FAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFA00000000FAFA000000FAFA00
0000FAFA00FA00FA000000FA0000FAFAFA000000FAFA000000FA00FAFA000000FAFA0000
0000FAFAFAFAFA00FAFAFAFAFAFAFA000000FAFA00000000FAFA000000FAFA000000FAFA
00FA00FAFAFAFAFA000000FAFA00000000FAFAFAFAFA000000FA00000000FAFAFA000000
FAFAFAFAFA00FAFAFA00FAFAFA00FAFA000000FAFA00000000FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFA00FAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFA00FAFAFAFAFAFAFAFAFA
FAFAFAFAFA00FAFAFA00FAFAFA00FAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA000000FAFAFAFAFAFAFA00FAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFA00FAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFA00000000FAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFA00FAFAFAFAFAFAFAFAFA
FAFAFAFAFA00FAFAFA00FAFAFA00FAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA0000FAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFA00000000FAFA0000FA
FA000000FAFA00FAFAFA00FAFA00000000FA00FAFA00FAFAFA00FAFAFA00FAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFA00FAFAFA00FA00FAFAFA
00FAFAFA00FA00FAFAFA00FA00FAFAFA00FA00FAFA00FAFAFA00FAFAFA00FAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFA00FAFAFA00FA00FAFAFA
00FAFAFA00FA00FAFAFA00FA00FAFAFA00FA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFA00FAFAFA00FA00FAFAFA
00FAFAFA00FA00FAFAFA00FAFA00000000FA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFA00FAFAFA00FA00FAFAFA
00FAFAFA00FA0000FAFA00FAFAFAFAFA00FA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFA00FAFAFA00FA000000FA
FA000000FAFA00FA00FA00FAFA000000FAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFA00FAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA0000000000FAFAFAFAFAFAFA00FAFAFA
FAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAA6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6FAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFA00FAFA00000000FA0000
00FAFAFA0000FAFA000000FAFA00FAFAFAFAFAFA000000FA00FAFAFA00FAFA00000000FA
FA000000FAFA00FAFAFA00FAFA00FAFAFA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFA00FA00FAFAFA00FAFAFA
FA00FA00FAFAFA00FAFAFA00FA00FAFAFAFAFAFAFA00FAFA00FAFAFA00FA00FAFAFA00FA
00FAFAFA00FAFA00FA00FAFAFA00FAFAFA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFA00FAFA00FA00FAFAFA00FAFAFA
0000FA00FAFAFA00FAFAFAFAFA00FAFAFAFAFAFAFA00FAFA00FAFAFA00FA00FAFAFA00FA
00FAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFA00FAFA00FAFA00000000FA0000
FAFAFA00FAFAFA0000000000FA00FAFAFAFAFAFAFA00FAFA00FAFAFA00FA00FAFAFA00FA
0000000000FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FA00FA00FA00FAFAFAFAFA00FA00FA
FAFAFA00FAFAFA00FAFAFA00FA0000FAFAFAFAFAFA00FAFA00FAFAFA00FA00FAFAFA00FA
00FAFAFA00FAFA00FA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FA00FA00FA00FAFA000000FAFAFA00
0000FA000000FAFA000000FAFA00FA00FAFAFAFAFA00FAFA00000000FAFAFA00000000FA
FA000000FAFA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA0000FAFAFA0000FAFAFAFAFAFAFAFAFA
FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFA00FA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA0000FAFAFA0000FAFAFAFAFAFAFAFAFA
FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA000000FAFAFAFAFAFAFAFAFAFAFA00FA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFA00FA00FAFAFA00FAFA00
000000FAFAFAFA00000000FAFAFA000000FAFA00FAFA000000FAFAFA000000FAFA0000FA
FA000000FAFAFA00000000FAFAFAFA00FAFAFAFAFAFA00000000FA00FAFAFA00FAFA0000
00FAFA0000FA00FAFA000000FAFA00FAFAFA00FAFA00FAFAFA00FAFAFA00FAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFA000000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFA00FA00FAFAFA00FA00FA
FAFA00FAFAFAFAFAFAFAFA00FA00FAFAFA00FA00FA00FAFAFA00FA00FAFAFAFA00FAFAFA
00FAFAFA00FA00FAFAFA00FAFAFAFA00FAFAFAFAFA00FAFAFA00FA00FAFAFA00FA00FAFA
FAFA00FAFAFA00FA00FAFAFA00FA00FAFAFA00FAFA00FAFAFA00FAFAFA00FAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFA00FA00FAFAFA00FA00FA
FAFA00FAFAFAFAFAFAFAFA00FA00FAFAFAFAFA00FA00FAFAFAFAFA00FAFAFAFA00FAFAFA
00FAFAFAFAFA00FAFAFA00FAFAFAFA00FAFAFAFAFA00FAFAFA00FA00FAFAFA00FA00FAFA
FAFA00FAFAFA00FA00FAFAFA00FA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFA00FA00FAFAFA00FA00FA
FAFA00FAFAFAFAFAFAFAFA00FA0000000000FA00FA0000000000FA00FAFAFAFA00FAFAFA
0000000000FA00FAFAFA00FAFAFAFA00FAFAFAFAFA00FAFAFA00FA00FAFAFA00FA00FAFA
FAFA00FAFAFA00FA00FAFAFA00FA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA0000000000FA00FA00FAFAFA00FA00FA
FAFA00FAFAFAFAFA000000FAFA00FAFAFA00FA00FA00FAFAFA00FA00FAFAFAFA00FAFAFA
00FAFAFA00FA00FAFAFA00FAFAFAFA0000000000FA00FAFAFA00FA00FAFAFA00FA00FAFA
FAFA00FAFAFA00FA00FAFAFA00FA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFA0000000000FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFA00FA00000000FAFAFA00
000000FAFAFAFA00FAFAFAFAFAFA000000FAFA00FAFA000000FAFAFA000000FA000000FA
FA000000FAFAFA00000000FAFAFAFA00FAFAFAFAFA00FAFAFA00FA00000000FAFAFA0000
00FA000000FA00FAFA000000FAFA00000000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFA00FAFAFAFA00FAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFA00FAFAFA
FAFAFAFAFAFAFAFAFAFA00FAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFA0000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA0000000000FA00FAFAFAFAFAFAFAFAFA
FAFA00FAFAFAFAFA00000000FAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFA00FAFAFA
FAFAFAFAFAFAFAFAFAFA00FAFAFAFA0000000000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFA0000000000FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFA00FAFA000000FAFA00FA00
000000FAFAFAFAFA00000000FAFA00FAFAFAFA000000FAFAFA00FAFAFA00FAFA000000FA
FAFA000000FAFA00FAFAFAFA00FAFAFA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFA00000000FAFA00FAFAFA00FA00FA00FAFAFAFA0000FAFAFAFA
00FAFAFAFA00FAFAFAFAFAFA000000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFA00FA00FAFAFA00FA00FA00
FAFAFA00FAFAFAFA00FAFAFA00FA00FAFAFA00FAFAFA00FAFA00FAFAFA00FAFAFAFAFA00
FA00FAFAFA00FA00FAFAFAFA00FAFAFA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FA00FAFAFA00FA00FA00FAFAFA00FAFAFAFAFAFA
00FAFAFAFA00FAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFA00FA00FAFAFAFAFA00FA00
FAFAFA00FAFAFAFA00FAFAFA00FA00FAFAFA00FAFAFA00FA00FA00FA00FA00FAFAFA0000
FA00FAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FA00FAFAFA00FA00FA00FAFAFA00FAFAFAFAFAFA
00FAFAFAFA00FAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFA00FA0000000000FA00FA00
FAFAFA00FAFAFAFA00FAFAFA00FA00FAFAFA00FAFAFA00FA00FA00FA00FA00FA0000FAFA
FA0000000000FA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FA00FAFAFA00FA00FA00FAFAFA00FAFAFA000000
00000000FA00FAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA000000000000FA00FAFAFA00FA00FA00
FAFAFA00FAFAFAFA00000000FAFA0000FAFA00FAFAFA00FA00FAFA00FAFA00FA00FAFAFA
FA00FAFAFA00FA0000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFA000000FAFA00FAFAFA00FA00FA00FAFAFA00FAFAFAFAFAFA
00FAFAFAFA0000000000FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFA00FAFA000000FAFA00FA00
000000FAFAFAFAFA00FAFAFA00FA00FA00FAFA000000FAFA00FAFA00FAFA00FAFA000000
FAFA000000FAFA00FA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFA00000000FAFA00FA000000FA000000FAFAFAFA
00FAFAFAFA00FAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFA00FAFAFAFAFAFAFA00FAFA
FAFAFAFAFAFAFAFA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFA00FAFAFAFAFAFAFA00FAFAFA00FAFAFAFAFAFA
00FAFAFAFA00FAFAFAFAFAFA0000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFA00FAFAFAFAFAFAFA00FAFA
FAFAFAFAFAFAFAFA00000000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFA00000000FA00FAFAFAFAFA00FA00FAFAFA00FAFAFAFAFAFA
FAFAFAFAFA0000000000FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFA0000FAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAA6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
616161616161616161616161616161616161616161616161616161616161616161E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
616161616161616161616161616161616161616161616161616161616161616161E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
616161616161616161616161616161616161616161616161616161616161616161E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
616161616161616161616161616161616161616161616161616161616161616161E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
616161616161FAFAFAFAFAFAFA6161616161616161FA6161616161616161616161E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
616161616161616161616161616161616161616161FA6161616161616161616161E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
616161616161FA61616161FA6161FAFAFA6161FA61FAFAFAFA6161616161616161E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
616161616161FA61616161FA61FA616161FA61FA61FA616161FA61616161616161E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
616161616161FA61616161FA61FA6161616161FA61FA616161FA61616161616161E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
616161616161FA61616161FA61FAFAFAFAFA61FA61FA616161FA61616161616161E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
616161616161FAFAFAFAFAFA61FA616161FA61FA61FA616161FA61616161616161E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
616161616161FA61616161FA6161FAFAFA6161FA61FAFAFAFA6161616161616161E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
616161616161FA61616161FA61616161616161FA61616161616161616161616161E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
616161616161FA61616161FA61616161616161FA61616161616161616161616161E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
61616161616161616161616161616161616161FA61616161616161616161616161E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
616161616161616161616161616161616161616161616161616161616161616161E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
616161616161616161616161616161616161616161616161616161616161616161E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
616161616161616161616161616161616161616161616161616161616161616161E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
616161616161616161616161616161616161616161616161616161616161616161E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
pop
P
% End of image
% End of Graphics
MathPictureEnd
\
\>"], "Text",
  ImageSize->{275, 239},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004C0000ka000`40O003h00Oogoo57oo00000e:D
Oomoo`3oOolAOol00003DYAoogoo0?mooa5oo`0000=BU7ooOol0oc6<3S6<0goo00000e:DOomoo`3o
<H`><H`3Ool00003DYAoogoo0?laS0haS0=oo`0000=BU7ooOol0AS6<00=ooc6<<H`0a36<0goo0000
0e:DOomoo`16<H`00goo<H`aS034<H`3Ool00003DYAoogoo014aS003OolaS36<008aS003OolaS36<
00=oo`8aS0Aoo`<aS0Aoo`04<Haooc6<Ool2<H`4Ool4<H`00goo<H`aS002<H`00goo<H`aS003Ool2
<H`00goo<Haoo`03Ool5<H`3Ool00c6<OolaS002<H`00goo<H`aS004Ool2<H`3Ool2<H`01Goo<H`a
S36<Ool0Xc6<0goo00000e:DOomoo`0A<H`01Goo<H`aS36<Ool00S6<00Mooc6<<H`aS7oo<Haoo`03
<H`00goo<Haoo`03<H`01goo<Haooc6<OolaS7oo00<aS003OolaS36<008aS003OolaS36<008aS003
OolaS7oo00<aS005OolaS7oo<Haoo`03<H`00goo<H`aS003<H`017oo<H`aS7oo0c6<00=ooc6<Ool0
0c6<00=ooc6<Ool00c6<00Iooc6<<Haooc6<OonT<H`3Ool00003DYAoogoo014aS004OolaS36<Ool3
<H`00goo<H`aS003<H`01goo<H`aS36<OolaS7oo00<aS007OolaS7oo<Haooc6<Ool00c6<00=ooc6<
<H`00S6<00=ooc6<<H`00S6<00=ooc6<Ool01C6<00=ooc6<Ool00c6<00=ooc6<<H`00c6<00Aooc6<
<Haoo`<aS003OolaS7oo00<aS003OolaS7oo00LaS003OolaS36<0:<aS0=oo`0000=BU7ooOol04C6<
17oo0c6<1Goo00<aS7oo<H`00S6<00=ooc6<Ool00c6<00Mooc6<OolaS7oo<Haoo`03<H`00goo<H`a
S002<H`00goo<H`aS002<H`00goo<Haoo`04Ool0136<OolaS7oo0c6<00=ooc6<<H`00c6<00Aooc6<
<Haoo`<aS003OolaS7oo00<aS003OolaS7oo00Aoo`<aS003OolaS36<0:<aS0=oo`0000=BU7ooOol0
4C6<00Eooc6<<H`aS7oo008aS007OolaS36<<Haooc6<Ool00c6<00=ooc6<Ool00c6<00Mooc6<Oola
S7oo<Haoo`03<H`00goo<H`aS002<H`6Ool00c6<OolaS002<H`01Goo<Haooc6<Ool00c6<00=ooc6<
<H`00c6<00Aooc6<<Haoo`<aS003OolaS7oo00<aS003OolaS7oo00<aS006OolaS36<OolaS7ooY36<
0goo00000e:DOomoo`0A<H`01Goo<H`aS36<Ool00c6<0goo0S6<17oo0S6<00Uooc6<<H`aS7oo<Hao
oc6<Ool00S6<17oo136<00=ooc6<<H`00S6<00=ooc6<<H`00goo0S6<00=ooc6<Ool00goo1S6<00=o
oc6<<H`017oo0c6<17oo0S6<0goo0S6<00Eooc6<<H`aS7oo0:<aS0=oo`0000=BU7ooOol04C6<00Eo
oc6<<H`aS7oo00PaS003OolaS36<00/aS003OolaS36<00<aS003OolaS36<008aS003OolaS36<008a
S003OolaS36<00DaS003OolaS36<00TaS003OolaS36<00XaS003OolaS36<0:daS0=oo`0000=BU7oo
Ool04C6<17oo2C6<00=ooc6<<H`02C6<00=ooc6<Ool01C6<00=ooc6<<H`00S6<00=ooc6<<H`00S6<
00=ooc6<<H`01C6<00=ooc6<<H`0236<0goo2c6<00=ooc6<<H`0[C6<0goo00000e:DOomoo`0N<H`0
0goo<H`aS00;<H`00goo<H`aS003<H`00goo<H`aS00?<H`00goo<H`aS00F<H`00goo<H`aS02]<H`3
Ool00003DYAoogoo0?laS0haS0=oo`0000=BU7ooOol0oc6<3S6<0goo00000e:DOomoo`3o<H`><H`3
Ool00003DYAoogoo0?mooa5oo`0000=BU7ooOol0ogoo4Goo00000e:DOomoo`3oOolAOol00003DYAo
ogoo0?mooa5oo`0000=BU7ooOol0ogoo4Goo000015:DOomoogoooe:D35:D17oo00000e:DOomoo`3o
OolAOol00003DYAoogoo0?mooa5oo`0000=BU7ooOol0ogoo4Goo00000e:DOomoo`3oOolAOol00003
DYAoogoo0?mooa5oo`0000=BU7ooOol0ogoo4Goo00000e:DOomoo`3oOolAOol00003DYAoogoo0?mo
oa5oo`0000=BU7ooOol04Goo00<007ooOol00Woo00<007oo00000`000goo0`000goo10000Woo0P00
17oo00<007ooOol00goo00<007ooOol010000Woo0P0000=oo`00Ool00Woo00<007ooOol00`000Woo
00@007ooOol0009oo`03001oogoo00@0009oo`800004Ool007ooOol30002Ool40002Ool01@00Oomo
ogoo00000goo00<007ooOol0UWoo00000e:DOomoo`0AOol00`00Oomoo`02Ool00`00Ool00003Ool0
0`00Ool00003Ool00`00Ool00003Ool00`00Ool00006Ool00`00Oomoo`03Ool00`00Ool00003Ool0
0`00Ool00003Ool01`00Oomoogoo001oo`0000=oo`03001oo`00009oo`06001oogoo001oo`000goo
00<007oo00000goo00<007oo000017oo00D007ooOomoo`00009oo`05001oogooOol00003Ool00`00
Oomoo`2FOol00003DYAoogoo015oo`H00003Ool007oo009oo`03001oo`0000=oo`03001oo`0000=o
o`03001oo`0000Ioo`04001oogoo0002Ool00`00Ool00003Ool00`00Ool00003Ool01`00Oomoogoo
001oo`0000Eoo`04001oogoo0002Ool00`00Ool00003Ool00`00Ool00003Ool00`00Ool00004Ool0
1@00Oomoogoo0000Xgoo00000e:DOomoo`0BOol01000Oomoo`000Woo00L007ooOomoo`00Ool00003
Ool00`00Ool00003Ool00`00Ool00006Ool01000Oomoo`000Woo00<007ooOol0100000=oo`00Ool0
0Woo00H007ooOomoo`00Ool500001Goo001oogoo00000Woo00<007ooOol0100000=oo`00Ool00Woo
00<007oo00001Goo1000Xgoo00000e:DOomoo`0BOol01000Oomoo`000Woo00L007ooOomoo`00Ool0
0003Ool00`00Ool00003Ool00`00Ool00006Ool01`00Ool007oo001oo`0000Eoo`03001oo`0000=o
o`07001oogooOol007oo00000goo00<007oo00000Woo00@007ooOol000Eoo`03001oo`0000=oo`03
001oo`0000Qoo`03001oogoo0:5oo`0000=BU7ooOol04Woo00@007ooOol0009oo`@000=oo`<0009o
o`06001oogooOol007oo0`0017oo00L007oo001oo`00Ool00002Ool30002Ool300000goo00000002
0003Ool30002Ool300000goo00000003Ool30002Ool3000017oo001oogoo0`000Woo0`00Y7oo0000
0e:DOomoo`0COol20003Ool00`00Oomoo`0?Ool00`00Oomoo`04Ool20003Ool20007Ool01@00Oomo
ogoo00006Goo00<007ooOol0/7oo00000e:DOomoo`0COol20003Ool00`00Oomoo`0?Ool00`00Oomo
o`04Ool20003Ool20007Ool01@00Oomoogoo00006Goo00D007ooOomoo`000:ioo`0000=BU7ooOol0
67oo00<007ooOol0:7oo00<007ooOol0bWoo00000e:DOomoo`3oOolAOol00003DYAoogoo0?mooa5o
o`0000=BU7ooOol0ogoo4Goo00000e:DOomoo`3oOolAOol00003DYAoogoo0?mooa5oo`0000=BU7oo
Ool0ogoo4Goo00000e:DOomoo`0_Ool00`00Oomoo`3NOol00003DYAoogoo02moo`03001oogoo0=io
o`0000=BU7ooOol04Goo10000goo0P000Woo100000=oo`00Ool00goo0P000Woo100000=oo`000000
0P001Goo00<007ooOol017oo100000Aoo`00Oomoo`<000=oo`80009oo`80009oo`<000=oo`05001o
ogooOol00003Ool00`00Oomoo`2ZOol00003DYAoogoo01Eoo`03001oo`0000=oo`07001oogooOol0
07oo00000goo00D007ooOomoo`0000=oo`03001oo`0000=oo`03001oogoo009oo`03001oogoo00=o
o`09001oogooOol007oo001oo`0000=oo`03001oo`0000=oo`05001oogooOol00003Ool01000Oomo
o`000goo00D007ooOomoo`000:aoo`0000=BU7ooOol05Goo00<007oo00000goo00L007ooOomoo`00
Ool00003Ool01@00Oomoogoo00000goo00<007oo00000goo00<007ooOol00Woo00<007ooOol00goo
00T007ooOomoo`00Ool007oo00001Goo00D007ooOomoo`0000=oo`03001oogoo0;Uoo`0000=BU7oo
Ool05Goo00<007oo000017oo100000=oo`00Ool00Woo00D007ooOomoo`0000=oo`03001oo`0000=o
o`03001oogoo009oo`@000=oo`@00003Ool007oo00D00003Ool007oo009oo`04001oogooOol5002g
Ool00003DYAoogoo019oo`<0009oo`03001oogoo00Eoo`04001oo`000002Ool01@00Oomoogoo0000
0goo00<007oo00000goo00<007ooOol00Woo00D007ooOomoo`0000Eoo`05001oo`00Ool00003Ool0
0`00Ool00003Ool01@00Oomoogoo00000goo00<007ooOol0]Goo00000e:DOomoo`0AOol00`00Oomo
o`03Ool30002Ool30002Ool01000Ool007oo0`0000=oo`00Ool00Woo00<007oo00000`001Goo00D0
07ooOomoo`00009oo`<0009oo`03001oogoo00<0009oo`<00004Ool000000002Ool3002hOol00003
DYAoogoo015oo`03001oogoo00=oo`03001oogoo00]oo`03001oogoo011oo`05001oogooOol00007
Ool00`00Oomoo`05Ool01@00Oomoogoo0000_goo00000e:DOomoo`0BOol400000goo001oo`0<Ool0
0`00Oomoo`0@Ool40008Ool00`00Oomoo`05Ool01@00Oomoogoo0000_goo00000e:DOomoo`14Ool0
0`00Oomoo`39Ool00003DYAoogoo0?mooa5oo`0000=BU7ooOol0ogoo4Goo00000e:DOomoo`3oOolA
Ool00003DYAoogoo0?mooa5oo`0000=BU7ooOol0ogoo4Goo00000e:DOomoo`3oOolAOol00003DYAo
ogoo029oo`03001oogoo02Yoo`03001oogoo0;ioo`0000=BU7ooOol08Woo00<007ooOol0:Woo00<0
07ooOol0_Woo00000e:DOomoo`0COol01@00Oomoogoo00000goo00D007ooOomoo`0000=oo`03001o
ogoo00Eoo`800003Ool007oo009oo`03001oogoo00<000Eoo`@000=oo`<000=oo`<0009oo`@000=o
o`03001oogoo009oo`05001oogooOol00003Ool00`00Oomoo`1FOol40002Ool02@00Oomoogoo001o
o`00Ool00004Ool20004Ool00`00Oomoo`04Ool40002Ool200000goo001oo`02Ool00`00Oomoo`02
Ool00`00Oomoo`02Ool00`00Oomoo`02Ool00`00Oomoo`0EOol00003DYAoogoo01=oo`05001oogoo
Ool00003Ool01@00Oomoogoo00000goo00<007ooOol017oo00D007ooOomoo`0000=oo`03001oo`00
00=oo`03001oogoo009oo`07001oogooOol007oo00000goo00<007oo00000goo00<007oo00000goo
00<007ooOol01Goo00D007ooOomoo`0000=oo`03001oogoo05Yoo`03001oo`0000=oo`05001oo`00
Ool00003Ool00`00Oomoo`04Ool00`00Oomoo`03Ool00`00Oomoo`03Ool01@00Oomoogoo00000goo
00<007ooOol00Woo00<007ooOol00Woo00<007ooOol00Woo00<007ooOol05Goo00000e:DOomoo`0B
Ool01`00Ool007oo001oo`00009oo`05001oogooOol00002Ool00`00Ool00005Ool01@00Oomoogoo
00000goo00<007oo000027oo00L007ooOomoo`00Ool00005Ool00`00Oomoo`03Ool01@00Oomoogoo
00000Woo00<007ooOol0Igoo00<007oo00000goo00D007oo001oo`0000=oo`03001oogoo00Aoo`03
001oogoo009oo`03001oogoo00Aoo`05001oogooOol00003Ool00`00Oomoo`02Ool00`00Oomoo`02
Ool00`00Oomoo`02Ool00`00Oomoo`0EOol00003DYAoogoo019oo`07001oo`00Ool007oo00000Woo
00D007ooOomoo`00009oo`03001oo`0000Eoo`05001oogooOol00003Ool00`00Ool000040004Ool0
1P00Oomoogoo001oo`D00003Ool0000000<00003Ool007oo009oo`04001oogoo001YOol00`00Ool0
0003Ool01@00Ool007oo00000goo00@007ooOomoo`L00003Ool007oo00Eoo`05001oogooOol00003
Ool00`00Ool0000600000goo001oo`03Ool00`00Oomoo`0EOol00003DYAoogoo019oo`07001oo`00
Ool007oo00000Woo00L007ooOomoo`00Ool00003Ool00`00Oomoo`02Ool01@00Oomoogoo00000goo
00<007oo00000goo00<007ooOol00Woo10000Woo00L007ooOomoo`00Ool00003Ool00`00Ool00003
Ool01@00Oomoogoo0000IGoo0`000Woo00T007ooOomoo`00Ool007oo00000goo00<007ooOol017oo
00<007ooOol00Woo00<007ooOol017oo00@007ooOomoo`80009oo`03001oogoo009oo`03001oogoo
009oo`H001Moo`0000=BU7ooOol04Goo00D007ooOomoo`0000=oo`03001oo`0000<0009oo`05001o
ogooOol00004Ool300000goo000000020003Ool30005Ool01@00Oomoogoo00000Woo0`000goo0`00
0Woo10001Goo00<007ooOol0HGoo00<007ooOol00goo10000Woo00<007oo00000P0000Aoo`000000
00Aoo`03001oogoo009oo`03001oogoo00Aoo`<00006Ool007oo001oo`0017oo00<007ooOol00Woo
00<007ooOol00Woo00<007ooOol05Goo00000e:DOomoo`0AOol01@00Oomoogoo00000goo00<007oo
00003Woo00D007ooOomoo`0000ioo`05001oogooOol0000FOol00`00Oomoo`1QOol00`00Oomoo`03
Ool00`00Oomoo`05Ool01@00Oomoogoo00001Woo00<007ooOol00goo00<007ooOol00goo00<007oo
Ool01Goo00<007ooOol00Woo00<007ooOol00Woo00<007ooOol00Woo00<007ooOol05Goo00000e:D
Oomoo`0AOol01@00Oomoogoo00000goo00<007oo00003Woo00D007ooOomoo`0000ioo`@001Aoo`<0
06Eoo`@00003Ool007oo00Aoo`03001oo`0000=oo`03001oogoo00]oo`@00003Ool007oo00Ioo`03
001oogoo00Moo`03001oogoo009oo`03001oogoo01Eoo`0000=BU7ooOol06goo00<007ooOol047oo
00<007ooOol0TGoo00<007ooOol01Woo0P0077oo00<007ooOol097oo00000e:DOomoo`3oOolAOol0
0003DYAoogoo0?mooa5oo`0000=BU7ooOol0ogoo4Goo00000e:DOomoo`3oOolAOol00003DYAoogoo
0?mooa5oo`0000=BU7ooOol0ogoo4Goo00000e:DOomoo`3oOolAOol00003DYAoogoo0?mooa5oo`00
00ABU7ooOomooomBU0aBU0Aoo`0000=BU7ooOol0ogoo4Goo00000e:DOomoo`3oOolAOol00003DYAo
ogoo0?mooa5oo`0000=BU7ooOol0ogoo4Goo00000e:DOomoo`3oOolAOol00003DYAoogoo0?mooa5o
o`0000=BU7ooOol0@7oo0`00cGoo00000e:DOomoo`13Ool00`00Oomoo`3:Ool00003DYAoogoo01=o
o`<000=oo`0;001oogooOol007oo001oo`00Ool00003Ool00`00Oomoo`030005Ool00`00Oomoo`02
Ool00`00Oomoo`030003Ool400000goo001oo`030003Ool200000goo001oo`03Ool40002Ool20000
17oo001oogoo0`000Woo00D007ooOomoo`00009oo`05001oogooOol00003Ool00`00Oomoo`2HOol0
0003DYAoogoo019oo`05001oogooOol00002Ool02`00Oomoogoo001oo`00Ool007oo00000goo00<0
07oo00000goo00<007ooOol00Woo00D007ooOomoo`00009oo`07001oogooOol007oo00000goo00<0
07oo000017oo00<007oo00000goo00D007ooOomoo`0000=oo`03001oo`0000=oo`03001oo`0000=o
o`03001oo`0000=oo`04001oogoo0003Ool01@00Oomoogoo0000VWoo00000e:DOomoo`0AOol00`00
Oomoo`03Ool00`00Ool00003Ool01`00Ool007oo001oo`0000=oo`03001oo`0000Qoo`04001oogoo
0003Ool00`00Oomoo`03Ool01`00Oomoogoo001oo`0000=oo`800003Ool007oo009oo`05001oogoo
Ool00003Ool00`00Ool00003Ool00`00Ool00003Ool00`00Ool00003Ool00`00Oomoo`2SOol00003
DYAoogoo015oo`03001oogoo00=oo`03001oo`0000=oo`07001oo`00Ool007oo00000goo00<007oo
0000100017oo10000goo1@0000=oo`00Ool00Woo00@007oo001oo`8000=oo`05001oogooOol00004
Ool400000goo001oo`02Ool00`00Ool00003Ool00`00Ool00003Ool00`00Oomoo`2SOol00003DYAo
ogoo015oo`03001oogoo00=oo`03001oo`0000=oo`07001oo`00Ool007oo00000goo00<007oo0000
0goo00<007ooOol00Woo00D007ooOomoo`00009oo`07001oogooOol007oo00000goo00D007oo001o
o`0000Aoo`04001oogooOol20006Ool00`00Ool00003Ool00`00Ool00003Ool00`00Ool00003Ool0
0`00Oomoo`2SOol00003DYAoogoo015oo`03001oogoo00=oo`03001oo`0000<0009oo`04001oo`00
Ool40003Ool30005Ool01@00Oomoogoo00000goo0`000goo100000Aoo`00Oomoo`<00008Ool00000
001oo`00Ool0009oo`<0009oo`<00004Ool007ooOol30002Ool4002VOol00003DYAoogoo019oo`05
001oogooOol00008Ool00`00Oomoo`0@Ool01@00Oomoogoo00005Goo00<007ooOol02goo00<007oo
Ool0/goo00000e:DOomoo`0COol30009Ool00`00Ool0000@Ool4000?Ool00`00Oomoo`04Ool00`00
Oomoo`0;Ool01@00Oomoogoo0000/Goo00000e:DOomoo`0OOol00`00Oomoo`3^Ool00003DYAoogoo
0?mooa5oo`0000=BU7ooOol0ogoo4Goo00000e:DOomoo`3oOolAOol00003DYAoogoo0?mooa5oo`00
00=BU7ooOol0ogoo4Goo00000e:DOomoo`3oOolAOol00003DYAoogoo0?mooa5oo`0000=BU7ooOol0
ogoo4Goo00000e:DOomoo`0COol01@00Oomoogoo000017oo0`000Woo00<007oo00000goo00<007oo
Ool00Woo100000Eoo`00Oomoo`00009oo`03001oogoo009oo`03001oogoo009oo`03001oogoo00<0
009oo`<000=oo`<000=oo`@00003Ool007oo00=oo`<00003Ool007oo009oo`03001oogoo00=oo`<0
009oo`05001oogooOol00005Ool200000goo001oo`02Ool00`00Oomoo`030007Ool01@00Oomoogoo
000017oo0`000Woo10000goo00D007ooOomoo`0000=oo`03001oogoo061oo`0000=BU7ooOol04goo
00D007ooOomoo`0000=oo`09001oogooOol007oo001oo`0000=oo`05001oogooOol00003Ool00`00
Ool00002Ool01000Oomoo`0017oo00D007ooOomoo`00009oo`05001oogooOol00004Ool00`00Ool0
0003Ool00`00Ool00003Ool00`00Ool00003Ool00`00Oomoo`02Ool01@00Oomoogoo000017oo00L0
07ooOomoo`00Ool00003Ool00`00Oomoo`02Ool01@00Oomoogoo00000goo00<007oo00000goo00<0
07ooOol017oo00D007ooOomoo`0000=oo`07001oogooOol007oo00000goo00@007ooOol000=oo`05
001oogooOol0001ROol00003DYAoogoo019oo`07001oo`00Ool007oo00000Woo00T007ooOomoo`00
Ool007oo00000goo00D007ooOomoo`0000=oo`03001oo`00009oo`04001oogoo0004Ool01000Oomo
o`000goo00<007ooOol01Goo0P0000=oo`00Ool017oo00L007ooOomoo`00Ool00003Ool00`00Oomo
o`02Ool01@00Oomoogoo000017oo00L007ooOomoo`00Ool00003Ool00`00Oomoo`02Ool01@00Oomo
ogoo00000goo00<007oo00002Goo00L007oo001oo`00Ool00002Ool00`00Oomoo`03Ool01@00Oomo
ogoo0000KGoo00000e:DOomoo`0BOol01`00Ool007oo001oo`00009oo`09001oogooOol007oo001o
o`0000=oo`03001oogoo009oo`@00005Ool007ooOol00002Ool00`00Oomoo`02Ool40003Ool50000
0goo00000003Ool50002Ool400000goo001oo`02Ool00`00Oomoo`02Ool01@00Oomoogoo000017oo
00L007ooOomoo`00Ool00003Ool00`00Oomoo`02Ool01@00Oomoogoo00000goo00<007oo00001000
1Goo00L007oo001oo`00Ool00002Ool500000goo001oo`02Ool00`00Oomoo`1[Ool00003DYAoogoo
019oo`07001oo`00Ool007oo00000Woo00T007ooOomoo`00Ool007oo00000goo0P001Woo00<007oo
00000Woo00@007ooOol000Aoo`05001oogooOol00002Ool01`00Oomoogoo001oo`0000Aoo`05001o
ogooOol00005Ool01000Ool000000Woo00<007ooOol00Woo00D007ooOomoo`0000Aoo`07001oogoo
Ool007oo00000goo00<007ooOol00Woo00D007ooOomoo`0000=oo`03001oo`0000=oo`03001oogoo
00=oo`07001oo`00Ool007oo00000Woo00L007ooOomoo`00Ool00003Ool00`00Oomoo`1[Ool00003
DYAoogoo015oo`05001oogooOol00003Ool00`00Oomoo`030002Ool00`00Ool00002000017oo001o
o`000Woo0`000Woo0`0000=oo`0000001Goo00D007ooOomoo`0000=oo`<000=oo`<0009oo`<000=o
o`<0009oo`03001oo`00009oo`<00003Ool00000008000Ioo`<0009oo`@000Eoo`<00003Ool00000
008000=oo`<000Eoo`05001oogooOol00003Ool00`00Oomoo`030002Ool4001^Ool00003DYAoogoo
015oo`05001oogooOol00003Ool00`00Oomoo`05Ool00`00Ool0000HOol01@00Oomoogoo00008Woo
00<007ooOol05Goo00D007ooOomoo`0000ioo`05001oogooOol00003Ool00`00Oomoo`05Ool00`00
Oomoo`1_Ool00003DYAoogoo015oo`05001oogooOol00003Ool00`00Oomoo`05Ool00`00Ool0000H
Ool4000SOol00`00Oomoo`0EOol01@00Oomoogoo00003Woo00D007ooOomoo`0000=oo`03001oogoo
00Eoo`03001oogoo06moo`0000=BU7ooOol08Goo00<007ooOol00P00?Goo00<007ooOol06Goo00<0
07ooOol077oo00<007ooOol0Kgoo00000e:DOomoo`3oOolAOol00003DYAoogoo0?mooa5oo`0000=B
U7ooOol0ogoo4Goo00000e:DOomoo`3oOolAOol00003DYAoogoo0?mooa5oo`0000=BU7ooOol0ogoo
4Goo00000e:DOomoo`3oOolAOol00003DYAoogoo0?mooa5oo`0000=BU7ooOol04Goo0`0000=oo`00
Ool00Woo00<007oo000017oo0`000Woo00D007ooOomoo`00009oo`04001oogoo0002Ool40002Ool2
000017oo001oogoo0`000Woo00D007ooOomoo`0000Ioo`@0009oo`<0009oo`05001oogooOol00002
Ool20002Ool30002Ool00`00Oomoo`05Ool30002Ool01@00Oomoogoo00001Goo0P0000=oo`00Ool0
0Woo00<007ooOol00`001goo00D007ooOomoo`0000Aoo`<0009oo`@000=oo`05001oogooOol00003
Ool00`00Oomoo`1LOol00003DYAoogoo019oo`04001oogoo0003Ool00`00Ool00003Ool01`00Oomo
ogoo001oo`0000=oo`04001oogoo0002Ool00`00Ool00003Ool00`00Ool00003Ool00`00Ool00003
Ool00`00Ool00003Ool00`00Oomoo`03Ool00`00Oomoo`03Ool01`00Oomoogoo001oo`0000=oo`03
001oo`0000=oo`07001oogooOol007oo00001Woo00L007ooOomoo`00Ool00003Ool00`00Oomoo`02
Ool01@00Oomoogoo00000goo00<007oo00000goo00<007ooOol017oo00D007ooOomoo`0000=oo`07
001oogooOol007oo00000goo00@007ooOol000=oo`05001oogooOol0001NOol00003DYAoogoo019o
o`04001oogoo0003Ool00`00Ool00003Ool01`00Oomoogoo001oo`0000=oo`04001oogoo0002Ool0
0`00Ool00003Ool00`00Ool00003Ool00`00Ool00003Ool00`00Ool00003Ool00`00Oomoo`02Ool0
0`00Oomoo`04Ool00`00Oomoo`03Ool01`00Oomoogoo001oo`0000=oo`03001oogoo00=oo`03001o
ogoo00Aoo`07001oogooOol007oo00000goo00<007ooOol00Woo00D007ooOomoo`0000=oo`03001o
o`0000Uoo`07001oo`00Ool007oo00000Woo00<007ooOol00goo00D007ooOomoo`0006Uoo`0000=B
U7ooOol04Woo00@007ooOol000=oo`03001oo`0000=oo`07001oogooOol007oo00000goo00@007oo
Ool0009oo`03001oogoo00@00003Ool007oo009oo`03001oo`0000=oo`03001oo`0000=oo`03001o
ogoo009oo`03001oogoo00Aoo`D00003Ool007oo009oo`03001oo`0000=oo`D00003Ool007oo00Eo
o`07001oogooOol007oo00000goo00<007ooOol00Woo00D007ooOomoo`0000=oo`03001oo`0000@0
00Eoo`07001oo`00Ool007oo00000Woo1@0000=oo`00Ool00Woo00<007ooOol0Igoo00000e:DOomo
o`0BOol01000Oomoo`000goo00<007oo00000goo00H007ooOomoo`00Ool20002Ool01000Oomoo`00
0Woo00<007ooOol00goo00<007oo00000goo00<007oo00000goo00<007oo00000goo00<007ooOol0
0Woo00<007ooOol017oo00L007ooOomoo`00Ool00003Ool00`00Ool00003Ool01P00Oomoogoo001o
o`8000Eoo`07001oogooOol007oo00000goo00<007ooOol00Woo00D007ooOomoo`0000=oo`03001o
o`0000=oo`03001oogoo00=oo`07001oo`00Ool007oo00000Woo00L007ooOomoo`00Ool00003Ool0
0`00Oomoo`1WOol00003DYAoogoo019oo`03001oogoo00@0009oo`<0009oo`<0009oo`04001oo`00
Ool300000goo00000003Ool30002Ool3000017oo001oogoo0`000Woo10001Goo00<007ooOol01Goo
0`000Woo10000Woo0`000Woo0`000Woo00<007oo00001Goo0`000Woo10001Goo0`0000=oo`000000
0P000goo0`001Goo00D007ooOomoo`0000=oo`03001oogoo00<0009oo`@006Yoo`0000=BU7ooOol0
4Woo00<007ooOol01Woo00<007ooOol06Goo00<007ooOol04goo00<007ooOol03goo00<007ooOol0
7Goo00D007ooOomoo`0000ioo`05001oogooOol00003Ool00`00Oomoo`05Ool00`00Oomoo`1[Ool0
0003DYAoogoo015oo`<000Moo`03001oogoo01Uoo`05001oogooOol0000BOol4000=Ool00`00Oomo
o`0MOol01@00Oomoogoo00003Woo00D007ooOomoo`0000=oo`03001oogoo00Eoo`03001oogoo06]o
o`0000=BU7ooOol077oo0P00IGoo00<007ooOol077oo00<007ooOol0Jgoo00000e:DOomoo`3oOolA
Ool00003DYAoogoo0?mooa5oo`0000=BU7ooOol0ogoo4Goo00000e:DOomoo`3oOolAOol00003DYAo
ogoo0?mooa5oo`0000=BU7ooOol0ogoo4Goo00000e:DOomoo`3oOolAOol00003DYAoogoo0?mooa5o
o`0000=BU7ooOol04goo00<007ooOol00Woo10000Woo0P000Woo0`000Woo00D007ooOomoo`00009o
o`@00005Ool007ooOol00003Ool01@00Oomoogoo0000dGoo00000e:DOomoo`0COol01@00Oomoogoo
00000goo00<007oo00000goo00L007ooOomoo`00Ool00003Ool00`00Ool00003Ool00`00Ool00002
Ool01@00Oomoogoo00000goo00<007ooOol0cgoo00000e:DOomoo`0COol01@00Oomoogoo00000goo
00<007oo00000goo00L007ooOomoo`00Ool00003Ool00`00Ool00003Ool00`00Ool0003LOol00003
DYAoogoo01=oo`05001oogooOol00003Ool00`00Ool00003Ool01`00Oomoogoo001oo`0000=oo`03
001oogoo00@00003Ool007oo0=]oo`0000=BU7ooOol04goo00D007ooOomoo`0000=oo`03001oo`00
00=oo`06001oogooOol007oo0P000Woo00<007ooOol00goo00<007oo0000g7oo00000e:DOomoo`0C
Ool01@00Oomoogoo00000goo00<007oo00000P000Woo0`000Woo00D007oo001oo`00009oo`<0009o
o`03001oogoo0=Yoo`0000=BU7ooOol04goo00<007ooOol01goo00<007ooOol04goo00<007ooOol0
fWoo00000e:DOomoo`0AOol50007Ool00`00Oomoo`0;Ool00`00Oomoo`05Ool00`00Oomoo`3JOol0
0003DYAoogoo03=oo`03001oogoo0=Yoo`0000=BU7ooOol0ogoo4Goo00000e:DOomoo`3oOolAOol0
0003DYAoogoo0?mooa5oo`0000=BU7ooOol0ogoo4Goo00000e:DOomoo`3oOolAOol00003DYAoogoo
0?mooa5oo`0000=BU7ooOol0ogoo4Goo00000e:DOomoo`3oOolAOol00004DYAoogooOoooDY@<DY@4
Ool00003DYAoogoo0?mooa5oo`0000=BU7ooOol0ogoo4Goo00000e:DOomoo`3oOolAOol00003DYAo
ogoo0?mooa5oo`0000=BU7ooOol0ogoo4Goo00000e:DOomoo`3oOolAOol00003DYAoogoo0?mooa5o
o`0000=BU7ooOol0ogoo4Goo00000e:DOomoo`0AOol00`00Oomoo`03Ool00`00Oomoo`04000017oo
000000000goo0P000Woo0`000Woo00<007ooOol017oo0`0000=oo`00Ool00Woo00<007ooOol01000
0Woo0`000Woo00D007ooOomoo`00009oo`05001oogooOol00003Ool00`00Oomoo`2cOol00003DYAo
ogoo015oo`03001oogoo00=oo`03001oo`0000=oo`03001oogoo009oo`03001oo`0000=oo`07001o
ogooOol007oo00001goo00@007ooOol000=oo`03001oo`0000=oo`03001oo`0000=oo`06001oogoo
001oo`000goo00D007ooOomoo`0000=oo`03001oogoo0;=oo`0000=BU7ooOol04Goo00@007ooOol0
009oo`03001oo`0000=oo`04001oogooOol200000goo001oo`02Ool00`00Oomoo`03Ool00`00Oomo
o`05Ool01000Oomoo`000goo00<007oo00000goo00<007oo00001goo00<007ooOol0`7oo00000e:D
Oomoo`0AOol01000Oomoo`000Woo00<007ooOol0100000=oo`0000000goo00@007ooOomoo`D00003
Ool007oo00Ioo`04001oogoo0003Ool00`00Ool00003Ool00`00Ool000040003Ool00`00Oomoo`30
Ool00003DYAoogoo015oo`07001oo`00Ool007oo00001Goo00<007oo000017oo00D007ooOomoo`00
00=oo`04001oo`000006Ool01000Oomoo`000goo00<007oo00000goo00<007oo00000goo00H007oo
Ool007oo0031Ool00003DYAoogoo015oo`07001oo`00Ool007oo00000Woo0`000goo0`0000Aoo`00
0000009oo`<0009oo`03001oo`0000Eoo`03001oogoo00@000=oo`@0009oo`<0009oo`05001oogoo
Ool00030Ool00003DYAoogoo015oo`8000=oo`8000aoo`03001oogoo00moo`03001oogoo00Yoo`03
001oogoo0<Yoo`0000=BU7ooOol04Goo0P000goo0P0037oo00<007ooOol03Woo0`002goo00<007oo
Ool0bWoo00000e:DOomoo`13Ool00`00Oomoo`3:Ool00003DYAoogoo0?mooa5oo`0000=BU7ooOol0
ogoo4Goo00000e:DOomoo`3oOolAOol00003DYAoogoo0?mooa5oo`0000=BU7ooOol0ogoo4Goo0000
0e:DOomoo`3oOolAOol00003DYAoogoo0?mooa5oo`0000=BU7ooOol0ogoo4Goo00000e:DOomoo`0A
Ool00`00Oomoo`03Ool00`00Ool00003Ool00`00Oomoo`040004Ool40003Ool30002Ool00`00Oomo
o`030003Ool30002Ool20002Ool30003Ool40004Ool00`00Oomoo`04Ool400000goo001oo`02Ool0
0`00Oomoo`030002Ool2000017oo001oogoo0`000Woo00D007ooOomoo`00009oo`05001oogooOol0
0003Ool00`00Oomoo`0cOol00`00Oomoo`04Ool3001:Ool00003DYAoogoo015oo`03001oogoo00=o
o`03001oo`0000=oo`03001oo`0000=oo`03001oogoo00Ioo`03001oo`0000=oo`05001oo`00Ool0
0003Ool00`00Ool00004Ool01@00Oomoogoo00000goo00<007oo00000goo00<007ooOol00Woo00<0
07ooOol00goo00L007ooOomoo`00Ool00003Ool00`00Ool00004Ool01`00Oomoogoo001oo`0000=o
o`03001oo`0000=oo`04001oogoo0003Ool01@00Oomoogoo0000=Goo00<007ooOol01Goo00<007oo
Ool0BGoo00000e:DOomoo`0AOol00`00Oomoo`03Ool00`00Ool00003Ool00`00Ool00003Ool00`00
Oomoo`06Ool00`00Ool00005Ool00`00Ool00005Ool00`00Oomoo`02Ool01@00Oomoogoo00001Goo
00D007ooOomoo`0000Aoo`03001oogoo00=oo`07001oogooOol007oo00000goo00<007oo000017oo
00L007ooOomoo`00Ool00003Ool00`00Ool00003Ool00`00Oomoo`0nOol00`00Oomoo`05Ool00`00
Oomoo`19Ool00003DYAoogoo015oo`03001oogoo00=oo`03001oo`0000=oo`03001oo`0000=oo`03
001oogoo00Ioo`03001oo`0000@00003Ool007oo00D00003Ool007oo00=oo`04001oogooOol50000
0goo001oo`02Ool00`00Oomoo`02Ool00`00Oomoo`03Ool01`00Oomoogoo001oo`0000=oo`03001o
o`0000Aoo`07001oogooOol007oo00000goo00<007oo00000goo00<007ooOol0?Woo00<007ooOol0
1Goo00<007ooOol0BGoo00000e:DOomoo`0AOol5000017oo001oo`000goo00<007oo00000goo00<0
07ooOol00goo0`000Woo00T007ooOomoo`00Ool007oo00000goo00<007oo000017oo00D007ooOomo
o`0000=oo`03001oo`0000=oo`03001oogoo009oo`D00003Ool007oo009oo`03001oo`0000=oo`03
001oo`0000Aoo`07001oogooOol007oo00000goo00<007oo00000goo00<007ooOol0?Woo1@000goo
00<007ooOol0BGoo00000e:DOomoo`0AOol00`00Oomoo`03Ool00`00Ool000030003Ool40004Ool0
0`00Oomoo`04Ool30002Ool00`00Oomoo`030003Ool3000017oo000000000Woo0`000goo100017oo
00<007ooOol00goo00H007ooOomoo`00Ool40003Ool300001Woo00000000Ool0009oo`<0009oo`@0
045oo`03001oogoo00Eoo`03001oogoo04Uoo`0000=BU7ooOol04Goo00<007ooOol03goo00<007oo
Ool00Woo00<007ooOol02Goo00<007ooOol02Woo00<007ooOol02goo00<007ooOol00Woo00<007oo
Ool057oo00<007ooOol0CWoo00<007ooOol017oo0P00Bgoo00000e:DOomoo`0AOol500000goo001o
o`0:Ool00`00Oomoo`03Ool40007Ool00`00Oomoo`0:Ool00`00Oomoo`0;Ool00`00Oomoo`02Ool5
000BOol01@00Oomoogoo0000C7oo1@000goo00<007ooOol0BGoo00000e:DOomoo`0SOol00`00Oomo
o`0>Ool00`00Oomoo`0HOol00`00Oomoo`2nOol00003DYAoogoo0?mooa5oo`0000=BU7ooOol0ogoo
4Goo00000e:DOomoo`3oOolAOol00003DYAoogoo0?mooa5oo`0000=BU7ooOol0ogoo4Goo00000e:D
Oomoo`3oOolAOol00003DYAoogoo021oo`03001oogoo0>eoo`0000=BU7ooOol087oo00<007ooOol0
kGoo00000e:DOomoo`0AOol00`00Oomoo`02Ool00`00Oomoo`030002Ool00`00Ool000030005Ool4
0002Ool00`00Oomoo`02Ool30003Ool01@00Oomoogoo00000Woo0`000goo0`000Woo00<007ooOol0
0Woo00D007ooOomoo`0000=oo`03001oogoo061oo`@0009oo`09001oogooOol007oo001oo`0000Ao
o`8000Aoo`03001oogoo009oo`03001oogoo00Aoo`<002aoo`0000=BU7ooOol04Goo00<007ooOol0
0Woo00<007oo00000goo00D007oo001oo`0000=oo`03001oogoo009oo`07001oogooOol007oo0000
0goo00D007ooOomoo`00009oo`05001oogooOol00005Ool00`00Ool00003Ool00`00Ool00004Ool0
1@00Oomoogoo00000goo00<007ooOol0I7oo00<007oo00000goo00D007oo001oo`0000=oo`03001o
ogoo00Aoo`03001oogoo009oo`03001oogoo00Eoo`03001oogoo02]oo`0000=BU7ooOol04Goo00<0
07ooOol00Woo00<007oo00001Goo00<007oo00000goo00<007ooOol00Woo00L007ooOomoo`00Ool0
0003Ool03@00Oomoogoo001oo`00Ool007oo001oo`0000=oo`800003Ool007oo00Aoo`03001oogoo
075oo`03001oo`0000=oo`05001oo`00Ool00003Ool00`00Oomoo`04Ool00`00Oomoo`02Ool00`00
Oomoo`05Ool00`00Oomoo`0[Ool00003DYAoogoo015oo`03001oogoo009oo`03001oo`0000@00004
Ool007oo0003Ool00`00Oomoo`02Ool01`00Oomoogoo001oo`0000=oo`0>001oogooOol007oo001o
o`00Ool007oo001oo`8000=oo`D00003Ool007oo079oo`03001oo`0000=oo`05001oo`00Ool00003
Ool01000Oomoogoo1`0000=oo`00Ool01Woo00<007ooOol0:goo00000e:DOomoo`0AOol600000goo
001oo`02Ool01@00Ool007oo00000goo00<007ooOol00Woo10000Woo0P000Woo00L007ooOomoo`00
Ool00002Ool01P00Oomoo`00Ool000Aoo`06001oogooOol007oo0P00Kgoo0`000Woo00T007ooOomo
o`00Ool007oo00000goo00<007ooOol017oo00<007ooOol00Woo1@000goo00<007ooOol0:goo0000
0e:DOomoo`0AOol00`00Oomoo`02Ool00`00Oomoo`030002Ool00`00Ool000030005Ool02@00Oomo
ogoo001oo`00Ool00002Ool30002Ool01000Oomoo`000Woo00<007ooOol00`000Woo0`000Woo00<0
07oo0000KGoo00<007ooOol00goo10000Woo00<007oo00000P0000Aoo`00000000Aoo`03001oogoo
009oo`03001oogoo00Eoo`03001oogoo02]oo`0000=BU7ooOol04Goo00<007ooOol00Woo00<007oo
Ool01Goo00<007ooOol027oo00D007ooOomoo`0008ioo`03001oogoo00=oo`03001oogoo00Eoo`05
001oogooOol00006Ool00`00Oomoo`02Ool00`00Oomoo`04Ool2000]Ool00003DYAoogoo015oo`03
001oogoo009oo`03001oogoo00Eoo`03001oogoo00Qoo`@0091oo`@00003Ool007oo00Aoo`03001o
o`0000=oo`03001oogoo00Uoo`D000=oo`03001oogoo02]oo`0000=BU7ooOol07Woo00<007ooOol0
XGoo00<007ooOol01Woo0P00@goo00000e:DOomoo`3oOolAOol00003DYAoogoo0?mooa5oo`0000=B
U7ooOol0ogoo4Goo00000e:DOomoo`3oOolAOol00003DYAoogoo0?mooa5oo`00oe:D4e:D0Goo000Q
<HcaLi`1Ool0024aS?5cW05oo`008C6<lG>L0Goo000Q<HcaLi`1Ool000HaS0Moo`PaS003OolaS36<
00TaS?5cW05oo`005C6<00=ooc6<<H`02C6<lG>L0Goo0006<H`00goo<H`aS002<H`00goo<H`aS003
Ool2<H`00goo<Haoo`03Ool8<HcaLi`1Ool000HaS003OolaS36<008aS003OolaS7oo00<aS005Oola
S7oo<Haoo`03<H`00goo<H`aS005<HcaLi`1Ool000HaS003OolaS36<008aS003OolaS7oo00DaS003
OolaS7oo00<aS003OolaS36<00DaS?5cW05oo`001S6<00=ooc6<<H`00S6<00=ooc6<Ool017oo00@a
S7oo<Haoo`<aS003OolaS36<00DaS?5cW05oo`001S6<1Woo00<aS7oo<H`00S6<00Eooc6<OolaS7oo
00<aS003OolaS36<00DaS?5cW05oo`001S6<00=ooc6<<H`00S6<00=ooc6<<H`00goo0S6<00=ooc6<
Ool00goo236<lG>L0Goo0006<H`00goo<H`aS002<H`00goo<H`aS005<H`00goo<H`aS00;<HcaLi`1
Ool000HaS003OolaS36<008aS003OolaS36<00DaS003OolaS36<00/aS?5cW05oo`004c6<00=ooc6<
<H`02c6<lG>L0Goo000Q<HcaLi`1Ool0024aS?5cW05oo`008C6<lG>L0Goo000Q<HcaLi`1Ool00001
\
\>"],
  ImageRangeCache->{{{0, 274}, {238, 0}} -> {-0.00137001, 0.99838, 1.00001, \
1.00001}},
  CellTags->"Installation notes"],

Cell[TextData[{
  StyleBox["4",
    FontWeight->"Bold"],
  ". Finally, see Unit package documentation at"
}], "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->"Installation notes"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .47679 
%%ImageSize: 475 227 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
4.2067e-017 0.0021097 -0.0021097 0.0021097 [
[ 0 0 0 0 ]
[ 1 .47679 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .47679 L
0 .47679 L
closepath
clip
newpath
% Start of gray image
p
0 -0.00211 translate
1.00211 .4789 scale
475 string
475 227 8 [475 0 0 227 0 0] {
\tcurrentfile
\t1 index
\treadhexstring
\tpop
}  Mimage
24365C4CFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA
24365C4CFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA
24365C4CFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA
24365C4CFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA
24365C4CFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA
24365C4C966C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C
6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C
6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C
6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C
6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C
6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C
6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C
6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C
6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C
6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C
6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C
6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C
6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C6C
6C6C6C6C6C6C6C
24365C4C96E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24365C4C96E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24365C4C96E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24365C4C96E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24365C4C96FAF7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F5
F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5
F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5
F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5
F5F5F5F5F5F5F5F5F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7
F7F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F7F7F7F7F7F7F7F7F7F7F7F7F7F7F5F5F5F5F5F5
F5F5F5F5F5F5F5F5F5F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F5F5F5F5F5F5F5F5F5F5F5F5
F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5
F5F5F5F5F5F5F5F5F5F5F7F7F7F7F7F7F7F7F7F7F7F7F7F7F5F5F5F5F5F5F5F5F5F5F5F5
F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7
F7F7F7F7F7F7F7F7F7F7F7F5F5F5F5F5F5F5F5F5F5F5F5F5F5F7F7F7F7F7F7F7F7F7F7F7
F7F7F7F7F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F7F7F7F7F7F7F7F7F7F7F7F7F7F7F5F5F5
F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F5F7F7F7F7F7F7F7F7F7F7
F7F7F7F7F7F7F7
24365C4C9494949494949494949494949494949494949494949494949494949494949494
949494949494949494949494949494949494949494949494949494949494949494949494
949494949494949494949494949494949494949494949494949494949494949494949494
949494949494949494949494949494949494949494949494949494949494949494949494
949494949494949494949494F7F794949494949494949494949494949494949494949494
949494949494949494949494949494949494949494949494949494949494949494949494
949494949494949494949494949494949494949494949494949494949494949494949494
949494949494949494949494949494949494949494949494949494949494949494949494
94949494949494949494949494949494949494949494F7F7949494949494949494949494
949494949494949494949494949494949494949494949494949494949494949494949494
949494949494949494949494949494949494949494949494949494949494949494949494
949494949494949494949494949494949494949494949494949494949494949494949494
9494949494949494949494949494949494949494949494949494949494949494F7F79494
94949494949494
24365C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFA94F7F794FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F7F794FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F7F794FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9EEBCABA19E99
9797979999999EABEEE9FA94F7F794FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F7F794FAFAFA00FAFAFA00FAFA00
FAFAFA00FAFA00FAFA00FAFAFA00FA00FAFAFA00FAFAFA00FA00FAFAFA00FA00FAFAFA00
FA00FAFAFA00FA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9EEBCABA19E999797979999999EABEEE9FA94F7F794FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9CFFAFAFAFAFA
FAFAFAFAFAFAFAFABFE9FA94F7F794FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F7F794FAFAFA00FAFAFA00FAFA00
FAFAFAFAFAFA00FAFA00FAFAFAFAFA00FAFAFA00FAFAFAFAFA00FAFAFA00FA00FAFAFAFA
FA00FAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA00FAFAFAFAFAE9CFFAFAFAFAFAFAFAFAFAFAFAFAFABFE9FA94F7F794FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FAE0C3C8C8C8
C8C8C5C5C5C3C3DFFABBFA94F7F794FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F7F794FAFAFA00FAFA00FAFAFA00
00000000FAFA00FAFA0000000000FA00FAFAFA0000000000FA00FAFAFA00FA00FAFAFAFA
FA0000000000FAFA0000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA0000FAFAFAFAE9FAE0C3C8C8C8C8C8C5C5C5C3C3DFFABBFA94F7F794FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FABEC6CBCBCB
CBCBC8C8C6C4C3C3FAB1FA94F7F794FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F7F794FAFAFA0000000000FAFA00
FAFAFA00FAFA00FAFA00FAFAFA00FA0000FAFA00FAFAFA00FA00FAFAFA00FA00FAFAFA00
FA00FAFAFA00FA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA000000FAFAFAE9FABEC6CBCBCBCBCBC8C8C6C4C3C3FAB1FA94F7F794FA
FAFAFAFAFAFAFA
24365C4C94FA616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161616161616161616161E9FABECBCDD0CD
CDCDCBCBC8C6C4C3FAAFFA94F7F794FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F7F794FAFAFA00FAFAFAFA00FAFA
000000FAFA000000FAFA000000FAFA00FA00FAFA000000FAFA00000000FAFAFA000000FA
FAFA000000FAFAFA000000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA0000FAFAFAFAE9FABECBCDD0CDCDCDCBCBC8C6C4C3FAAFFA94F7F794FA
FAFAFAFAFAFAFA
24365C4C94FA616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161616161616161616161E9FABECDD0D0D2
D25CD0CBCBC6C4C5FAAFFA94F7F794FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F7F794FAFAFA00FAFAFAFA00FAFA
FAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA00FAFAFAFAFAE9FABECDD0D0D2D25CD0CBCBC6C4C5FAAFFA94F7F794FA
FAFAFAFAFAFAFA
24365C4C94FA616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161616161616161616161E9FAC3D0D2D2D2
5C5C5CC8C8C8C6C5FAAFFA94F7F794FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F7F794FAFAFA0000000000FAFAFA
FAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC3D0D2D2D25C5C5CC8C8C8C6C5FAAFFA94F7F794FA
FAFAFAFAFAFAFA
24365C4C94FA616161FAFA61FA6161FAFA61FA61FA6161FA6161FA6161FAFA61FA61FAFA
61FA616161FA616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161616161616161616161E9FAC5D2D2D25C
5C5C5C5CC8C8C8C5FAAFFA94F7F794FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F7F794FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC5D2D2D25C5C5C5C5CC8C8C8C5FAAFFA94F7F794FA
FAFAFAFAFAFAFA
24365C4C94FA6161FA6161FAFA61FA6161FAFA61FA6161FA6161FA61FA6161FAFA61FA61
61FA616161FA616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161616161616161616161E9FAC5D4D45C5C
5CD05C5C5CC8C8C8FAB1FA94F7F794FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F7F794FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC5D4D45C5C5CD05C5C5CC8C8C8FAB1FA94F7F794FA
FAFAFAFAFAFAFA
24365C4C94FA6161FA616161FA61FA616161FA61FA61FA61FA61FA61FA616161FA61FA61
61FA616161FA616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161616161FA6161616161E9FAC8D75C5C5C
D0D0C85C5C5CCBC8FAB1FA94F7F794FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F7F794FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC8D75C5C5CD0D0C85C5C5CCBC8FAB1FA94F7F794FA
FAFAFAFAFAFAFA
24365C4C94FA616161FAFAFAFA61FA616161FA61FA61FA61FA61FA6161FAFAFAFA61FA61
61FA616161FA616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161616161FAFA61616161E9FACAD7D75CD7
D7CBCBCB5CCBCBCAFAB3FA94F7F794FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F7F794FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FACAD7D75CD7D7CBCBCB5CCBCBCAFAB3FA94F7F794FA
FAFAFAFAFAFAFA
24365C4C94FA6161FA616161FA61FA6161FAFA61FA61FA61FA61FA61FA616161FA61FA61
61FAFA6161FA616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161616161FAFAFA616161E9FACDDBD9D7D4
D4D4CBCBCBCBCBCAFAB6FA94F7F794FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F7F794FAFAFAFAFAFAFAFAFAFAFA
FAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FACDDBD9D7D4D4D4CBCBCBCBCBCAFAB6FA94F7F794FA
FAFAFAFAFAFAFA
24365C4C94FA616161FAFAFA616161FAFA61FA61FAFA616161FAFA6161FAFAFA61FAFAFA
61FA61FAFA61616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161616161FAFA61616161E9FAD1DEDED7D7
D7D4CDCBCBCBCBCAFABDFA94F7F794FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFAFAFAFAFAFAFAFAFA
FAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FAD1DEDED7D7D7D4CDCBCBCBCBCAFABDFA94F8F894FA
FAFAFAFAFAFAFA
24365C4C94FA616161616161616161616161FA61FAFA616161FAFA61616161616161FA61
61FA61616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161616161FA6161616161E9FAD7E3E0DBD7
D7D7D2D0D0CDCBCAFAC5FA94F7F794FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFA00FA00FAFA00FAFA
00FA00FA0000FAFA00FAFA000000FAFA00FAFA00FAFA00FAFA000000FAFA00FAFAFA00FA
0000FAFA0000FA00FA0000FA00FAFA000000FAFA00FAFAFA00FAFAFAFA00FAFAFA00FAFA
000000FAFA0000FAFA000000FAFAFA000000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FAD7E3E0DBD7D7D7D2D0D0CDCBCAFAC5FA94F8F894FA
FAFAFAFAFAFAFA
24365C4C94FA616161616161616161616161FA61FA6161616161FA61616161616161FA61
61FA61616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161616161616161616161E9FADBE7E3DEDE
DBD7D7D7D2D0CBC8FAD1FA94F7F794FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFA00FA00FAFA00FAFA
00FA0000FAFA00FA00FA00FAFAFA00FA00FAFA00FAFA00FA00FAFAFA00FA00FAFAFA00FA
00FAFA00FAFA0000FA00FAFA00FA00FAFAFA00FA00FAFAFA00FAFAFAFA00FAFAFA00FA00
FAFAFA00FA00FAFA00FAFAFA00FA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FADBE7E3DEDEDBD7D7D7D2D0CBC8FAD1FA94F8F894FA
FAFAFAFAFAFAFA
24365C4C94FA616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161616161616161616161E9FAEADBD7CFCF
CACAC8C5C5C3C0E3FADEFA94F7F794FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFA00FA00FAFA00FAFA
00FA00FAFAFA00FA00FA00FAFAFAFAFA00FAFA00FAFA00FA00FAFAFAFAFA00FAFAFA00FA
00FAFA00FAFAFA00FA00FAFA00FA00FAFAFA00FA00FAFAFA00FAFAFAFA00FAFAFA00FA00
FAFAFA00FA00FAFA00FAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA00FAFAFAFAFAE9FAEADBD7CFCFCACAC8C5C5C3C0E3FADEFA94F8F894FA
FAFAFAFAFAFAFA
24365C4C94FA616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161616161616161616161E9FAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAE9FA94F7F794FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFA00FA00FAFA00FAFA
00FA00FAFAFA00FA00FA0000000000FA00FAFA00FAFA00FA0000000000FA00FAFAFA00FA
00FAFAFA00000000FA00FAFA00FA00FAFAFA00FA00FAFAFA00FAFAFAFA00FAFAFA00FA00
FAFAFA00FA00FAFA0000000000FAFA0000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA0000FAFAFAFAE9FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FA94F8F894FA
FAFAFAFAFAFAFA
24365C4C94FA616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161616161616161616161E9EEA89E979797
9797979797999EABEEE9FA94F7F794FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFA00FA0000FA00FAFA
00FA0000FAFA00FA00FA00FAFAFA00FA0000FA00FAFA00FA00FAFAFA00FA00FAFAFA00FA
00FAFA00FAFAFA00FA00FAFA00FA00FAFAFA00FA00FAFAFA00FAFAFAFA00FAFAFA00FA00
FAFAFA00FA00FAFA00FAFAFA00FA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA000000FAFAFAE9EFEFEFF1F2F2F7F7F8F8F8FAFAFAFAE9FA94F8F894FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9B0FAFAFAFAFA
FAFAFAFAFAFAFAFABCE9FA94F7F794FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFA00FA00FA00000000
FAFA00FA0000FAFA00FAFA000000FAFA00FA00000000FAFAFA000000FAFA00000000FA00
0000FAFA000000FA000000FA00FAFA000000FAFA00000000FAFAFAFAFA00000000FAFAFA
000000FA000000FAFA000000FAFAFA000000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA0000FAFAFAFAE9EFEFEFF1F2F2F7F7F8F8F8FAFAFAFAE9FA94F8F894FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFA00000000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FAE0C3C8C8C8
C8C8C8C8C5C3C3DFFABFFA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFA00FAFAFAFAFAFAFA
FAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
00FAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA00FAFAFAFAFAE9EFEFEFF1F2F2F7F7F8F8F8FAFAFAFAE9FA94F8F894FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC8D7D7D7D2
D2D0D0D0CDC8CBC8FAAFFA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFA00FAFAFAFAFAFAFA
FAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
00FAFAFAFAFAFAFAFA00FAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9EFEFEFF1F2F2F7F7F8F8F8FAFAFAFAE9FA94F8F894FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFA00FAFAFAFAFA00FAFAFA000000FAFA00FAFAFA00FAFA00FA00FA00
FAFAFA00FAFA0000FA00FAFAFAFAFAFA00FAFAFA00FAFAFA00FA0000FA00FAFAFA00FAFA
FAFA00FAFAFAFAFA00FAFA0000FA00FAFA0000FA00FAFAFAFAFAFA000000FAFA00FAFAFA
00FAFA000000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC5D2D4D4D2
D2D2D2D2CDC8C8C5FAAFFA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9EFEFEFF1F2F2F7F7F8F8F8FAFAFAFAE9FA94F8F894FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFA00FAFAFAFAFA00FAFA00FAFAFA00FA00FAFAFA00FA00FAFA00FA00
FAFAFA00FA00FAFA0000FAFAFAFAFAFA00FAFAFA00FAFAFA00FA00FAFA00FAFAFA00FAFA
FAFA00FAFAFAFAFA00FA00FAFA0000FA00FAFA0000FAFAFAFAFA00FAFAFA00FA00FAFAFA
00FA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC5D4D7D4D2
D2D2D0D0CDC8C8C8FAAFFA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9EFEFEFF1F2F2F7F7F8F8F8FAFAFAFAE9FA94F8F894FA
FAFAFAFAFAFAFA
24365C4C94FAFAFA00FA00FAFAFA00FA00FA00FAFAFA00FA00FAFAFA00FA00FAFA00FA00
FAFAFA00FA00FAFAFA00FAFAFAFAFA00FA00FA00FA00FAFA00FA00FAFA00FAFAFA00FAFA
FAFAFA0000000000FAFA00FAFAFA00FA00FAFAFA00FA000000FA00FAFAFA00FA00FAFAFA
00FAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAE9FAC5D4D7D4D2
D2D2D0D0CDC8C8C8FAAFFA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9EFEFEFF1F2F2F7F7F8F8F8FAFAFAFAE9FA94F8F894FA
FAFAFAFAFAFAFA
24365C4C94FAFAFA00FA00FAFAFA00FA00FA00FAFAFA00FA00FAFAFA0000FAFAFA00FA00
FAFAFA00FA00FAFAFA00FAFAFAFAFA00FA00FA00FA00FAFA00FA00FAFA00FAFAFA00FAFA
FAFAFA00FAFAFA00FAFA00FAFAFA00FA00FAFAFA00FAFAFAFAFA00FAFAFA00FA00FAFAFA
00FAFA0000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA0000FAFAFAFAE9FAC8D7D7D7D2
D2D0D0D0CDC8CBC8FAAFFA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9EFEFEFF1F2F2F7F7F8F8F8FAFAFAFAE9FA94F8F894FA
FAFAFAFAFAFAFA
24365C4C94FAFAFA00FAFA00FA00FAFA00FA00FAFAFA00FA0000FAFA00FA00FAFA00FA00
FAFAFA00FA00FAFA0000FAFAFAFA00FAFA00FA00FAFA00FA00FA00FAFA0000FAFA00FAFA
FAFAFAFA00FA00FAFAFA00FAFA0000FA00FAFA0000FAFAFAFAFA00FAFAFA00FA00FAFAFA
00FA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA000000FAFAFAE9FAC8D7D7D7D2
D2D0D0D0CDC8CBC8FAAFFA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9EFEFEFF1F2F2F7F7F8F8F8FAFAFAFAE9FA94F8F894FA
FAFAFAFAFAFAFA
24365C4C94FAFAFA00FAFA00FA00FAFA00FAFA000000FAFA00FA00FA00FAFA00FA00FA00
000000FAFAFA0000FA00FAFAFAFA00FAFAFA00FAFAFA00FA00000000FA00FA0000FAFAFA
FAFAFAFA00FA00FAFAFAFA0000FA00FAFA0000FA00FAFAFAFAFAFA000000FAFA00000000
FAFAFA000000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA0000FAFAFAFAE9FAC5D2D4D4D2
D2D2D2D2CDC8C8C5FAAFFA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9EEA89E9797979797979797999EABEEE9FA94F8F894FA
FAFAFAFAFAFAFA
24365C4C94FAFA00FAFAFA00FA00FAFAFA00FAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFA00FAFAFAFAFAFA
FAFAFAFA00FA00FAFAFAFAFAFAFA00FAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAE9FAC5D2D4D4D2
D2D2D2D2CDC8C8C5FAAFFA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFA00FAFAFAFAFA00FA
FA0000FA00FAFAFA00FAFAFAFA0000FA00FA00FAFAFA00FAFA000000FAFAFA000000FAFA
FA000000FAFAFAFAFAFA00FAFAFA000000FAFAFA0000FA00FA0000FAFA0000FA00FA00FA
FAFAFA000000FAFAFA000000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9B0FAFAFAFAFAFAFAFAFAFAFAFAFABCE9FA94F8F894FA
FAFAFAFAFAFAFA
24345C4C94FAFA00FAFAFAFA00FAFAFAFA00FAFAFAFAFAFAFAFAFAFA00FAFAFAFA00FAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FA00FAFA00FAFAFAFAFAFA
FAFAFAFAFA00FAFAFAFAFAFAFAFA00FAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC5D2D4D4D2
D2D2D2D2CDC8C8C5FAAFFA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFA00FAFAFAFAFA00FA
00FAFA0000FAFAFA00FAFAFA00FAFA0000FA00FAFAFA00FA00FAFAFA00FA00FAFAFA00FA
00FAFAFA00FAFAFAFAFA00FAFA00FAFAFA00FA00FAFA0000FA00FAFA00FAFA0000FA00FA
FAFA00FAFAFA00FA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FAE0C3C8C8C8C8C8C8C8C5C3C3DFFABFFA94F8F894FA
FAFAFAFAFAFAFA
24345C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC5D4D7D4D2
D2D2D0D0CDC8C8C8FAAFFA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFAFA0000000000FAFA
00FAFAFA00FAFA00FA00FAFA00FAFAFA00FA00FAFAFA00FA00FAFAFAFAFA00FAFAFAFAFA
FAFAFA00FAFAFAFAFAFA00FAFA00FAFAFAFAFA00FAFAFA00FA00FAFA00FAFAFA00FA00FA
FAFA00FAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA00FAFAFAFAFAE9FAC8D7D7D7D2D2D0D0D0CDC8CBC8FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24345C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC5D4D7D4D2
D2D2D0D0CDC8C8C8FAAFFA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFAFA00FAFAFA00FAFA
00FAFAFA00FAFA00FA00FAFAFA00000000FA00FAFAFA00FA00FAFAFAFAFA0000000000FA
FA0000FAFAFAFAFAFAFA00FAFA0000000000FAFA00000000FA00FAFA00FAFAFA00FA00FA
FAFA0000000000FAFA0000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA0000FAFAFAFAE9FAC5D2D4D4D2D2D2D2D2CDC8C8C5FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24345C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC8D7D7D7D2
D2D0D0D0CDC8CBC8FAAFFA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFAFAFA00FA00FAFAFA
00FAFA0000FA00FAFAFA00FA00FAFAFA00FA00FAFAFA00FA00FAFAFA00FA00FAFAFA00FA
00FAFAFA00FAFAFAFAFA00FAFA00FAFAFA00FA00FAFAFA00FA00FAFA00FAFAFA00FA0000
FAFA00FAFAFA00FA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA000000FAFAFAE9FAC5D4D7D4D2D2D2D0D0CDC8C8C8FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24345C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC8D7D7D7AC
ACACACACACC8CBC8FAAFFA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFAFAFA00FA00FAFAFA
FA0000FA00FA00FAFAFA00FAFA000000FAFA00000000FAFAFA000000FAFAFA000000FAFA
FA000000FAFAFAFAFA000000FAFA000000FAFAFA000000FA000000FA00FAFAFA00FA00FA
00FAFA000000FAFAFA000000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA0000FAFAFAFAE9FAC5D4D7D4D2D2D2D0D0CDC8C8C8FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24345C4C94FAFAA6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6FAE9FAC5D2D4F1F1
F1F1F1F1CDC8C8C5FAAFFA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFAFAFA00FA00FAFAFA
FAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA00FAFAFAFAFAE9FAC5D4D7D4D2D2D2D0D0CDC8C8C8FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24345C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC5D2D4D4AC
ACACACACACC8C8C5FAAFFA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFAFAFAFA00FAFAFAFA
FAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC8D7D7D7D2D2D0D0D0CDC8CBC8FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24345C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC5D4D7F1F1
F1F1F1F1CDC8C8C8FAAFFA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC8D7D7D7D2D2D0D0D0CDC8CBC8FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24345C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC5D4D7D4AC
ACACACACACC8C8C8FAAFFA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC8D7D7D7D2D2D0D0D0CDC8CBC8FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24345C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC5D4D7F1F1
F1F1F1F1CDC8C8C8FAAFFA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC8D7D7D7D2D2D0D0D0CDC8CBC8FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24345C4C94FAFAFAFA00FA00FAFAFAFA00FA0000000000FAFAFA00FAFAFA00FAFA000000
0000FA00FA00FAFAFA00FA00FAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC8D7D7D7AC
ACACACACACC8CBC8FAAFFA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC5D2D4D4D2D2D2D2D2CDC8C8C5FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24345C4C94FAFAFAFAFAFA00FAFAFA0000FA00FAFAFAFAFAFAFA00FAFAFA00FAFA00FAFA
FAFAFA00FA00FAFAFA00FA00FA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC8D7D7F1F1
F1F1F1F1CDC8CBC8FAAFFA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC5D2D4D4D2D2D2D2D2CDC8C8C5FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24345C4C94FAFAFAFAFAFA00FAFA00FA00FA00FAFAFAFAFAFAFA00FAFAFAFA00FA00FAFA
FAFAFA00FA00FAFAFA00FA00FA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAE9FAC5D2D4D4D2
D2D2D2D2CDC8C8C5FAAFFA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC5D2D4D4D2D2D2D2D2CDC8C8C5FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFAFAFA00FAFA00FA00FA00FAFAFAFAFAFAFA00FAFAFAFA00FA00FAFA
FAFAFA00FA00FAFAFA00FA0000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA0000FAFAFAFAE9FAC5D2D4D4D2
D2D2D2D2CDC8C8C5FAAFFA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFA0000000000FA00FA
FAFA00FAFA0000FA00FA00FAFA00FAFA00FA00FA0000FAFA00FAFA000000FAFAFA000000
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC5D4D7D4D2D2D2D0D0CDC8C8C8FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFAFAFA00FA00FAFA00FA0000000000FAFAFA00FAFAFAFA00FA00FAFA
FAFAFA00FA00FAFAFA00FA00FA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA000000FAFAFAE9FAC5D4D7D4D2
D2D2D0D0CDC8C8C8FAAFFA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFA00FAFAFAFAFAFA00
FA00FAFA00FAFA0000FA00FAFA00FAFA00FA0000FAFA00FA00FA00FAFAFA00FA00FAFAFA
00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC5D4D7D4D2D2D2D0D0CDC8C8C8FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFAFAFA00FA00FAFA00FA00FAFAFAFAFAFAFA00FAFAFAFA00FA00FAFA
FAFAFA00FA00000000FAFA00FAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA0000FAFAFAFAE9FAC5D4D7D4D2
D2D2D0D0CDC8C8C8FAAFFA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFA00FAFAFAFAFAFAFA
00FAFAFA00FAFAFA00FA00FAFA00FAFA00FA00FAFAFA00FA00FA00FAFAFAFAFAFAFAFA00
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA00FAFAFAFAFAE9FAC5D4D7D4D2D2D2D0D0CDC8C8C8FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFAFAFA0000FAFAFA00FA00FAFAFAFAFAFAFA00FAFAFAFAFA0000FAFA
FAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAE9FAC5D4D7D4D2
D2D2D0D0CDC8C8C8FAAFFA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFA00FAFAFAFAFAFAFA
00FAFAFAFA00000000FA00FAFA00FAFA00FA00FAFAFA00FA00FA0000000000FAFA0000FA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA0000FAFAFAFAE9FAC5D4D7D4D2D2D2D0D0CDC8C8C8FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFAFAFA00FAFAFAFA00FA0000000000FA0000000000FAFAFA0000FAFA
FAFAFA00FAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC5D4D7D4D2
D2D2D0D0CDC8C8C8FAAFFA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFA0000000000FAFA00
FA00FAFA00FAFAFA00FA0000FA00FAFA00FA0000FAFA00FA00FA00FAFAFA00FA00FAFAFA
00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA000000FAFAFAE9FAC8D7D7D7D2D2D0D0D0CDC8CBC8FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC5D4D7D4D2
D2D2D0D0CDC8C8C8FAAFFA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFA00FAFAFAFAFA00FA
FAFA00FAFA000000FAFA00FA00000000FAFA00FA0000FAFA00FAFA000000FAFAFA000000
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA0000FAFAFAFAE9FAC8D7D7D7D2D2D0D0D0CDC8CBC8FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC8D7D7D7D2
D2D0D0D0CDC8CBC8FAAFFA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFA00FAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA00FAFAFAFAFAE9FAC8D7D7D7D2D2D0D0D0CDC8CBC8FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC8D7D7D7D2
D2D0D0D0CDC8CBC8FAAFFA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFA0000000000FAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC5D2D4D4ACACACACACACC8C8C5FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC5D2D4D4D2
D2D2D2D2CDC8C8C5FAAFFA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC5D2D4F1F1F1F1F1F1CDC8C8C5FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC5D4D7D4D2
D2D2D0D0CDC8C8C8FAAFFA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC5D2D4D4ACACACACACACC8C8C5FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FADBE7E3DEDE
DEDBD7D7D7D0CBC8FACCFA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC5D4D7F1F1F1F1F1F1CDC8C8C8FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFA0000FAFA00FAFA0000000000FA00FA00FAFAFA00FA00FAFA00FAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FAEADBD7CFCF
CFCACACAC8C3C0E3FAE2FA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC5D4D7D4ACACACACACACC8C8C8FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24365C4C94FAFAFA00FAFA00FA00FAFA00FAFAFAFAFA00FA00FAFAFA00FA00FA00FAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAE9FA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC5D4D7F1F1F1F1F1F1CDC8C8C8FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24345C4C94FAFAFA00FAFA00FAFA00FA00FAFAFAFAFA00FA00FAFAFA00FA00FA00FAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAE9EFEFEFF1F2F2
F7F7F8F8F8FAFAFAFAE9FA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC5D4D7D4ACACACACACACC8C8C8FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24345C4C94FAFAFAFAFAFA00FAFA00FA00FAFAFAFAFA00FA00FAFAFA00FA0000FAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA0000FAFAFAFAE9EFEFEFF1F2F2
F7F7F8F8F8FAFAFAFAE9FA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFA0000000000FAFAFA
0000FA00FAFA000000FAFA00FAFA000000FAFAFAFAFA00FA0000FAFAFA000000FAFA00FA
FAFA00FAFA0000FA00FAFAFA00FAFAFA00FAFA000000FAFA00FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC8D7D7F1F1F1F1F1F1CDC8CBC8FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24345C4C94FAFAFAFAFAFA00FAFA00FA00FAFAFAFAFA00FA00FAFAFA00FA00FA00FAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA000000FAFAFAE9EFEFEFF1F2F2
F7F7F8F8F8FAFAFAFAE9FA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFA00FAFAFAFA00FA00
FAFA0000FA00FAFAFA00FA00FA00FAFAFA00FAFAFAFA0000FAFA00FA00FAFAFA00FA00FA
FAFA00FA00FAFA0000FAFAFA00FAFAFA00FA00FAFAFA00FA00FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC8D7D7D7D2D2D0D0D0CDC8CBC8FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24345C4C94FAFAFAFAFAFA00FAFA00FA00FAFAFAFAFA00FA00000000FAFA00FAFA00FAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA0000FAFAFAFAE9EFEFEFF1F2F2
F7F7F8F8F8FAFAFAFAE9FA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFA00FAFAFAFA00FA00
FAFAFA00FAFAFAFA00FAFA00FA00FAFAFAFAFAFAFAFA00FAFAFA00FA00FAFAFAFAFA00FA
FAFA00FA00FAFAFA00FAFA00FA00FAFA00FA00FAFAFA00FA00FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA00FAFAFAFAFAE9FAC8D7D7D7D2D2D0D0D0CDC8CBC8FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24345C4C94FAFAFAFAFAFA00FAFAFA0000FAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAE9EFEFEFF1F2F2
F7F7F8F8F8FAFAFAFAE9FA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFA00FAFAFAFA00FAFA
00000000FAFA0000FAFAFA00FA00FAFAFAFAFAFAFAFA00FAFAFA00FA0000000000FA00FA
FAFA00FAFA00000000FAFA00FA00FAFA00FA00FAFAFA00FA00FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA0000FAFAFAFAE9FAC5D2D4D4D2D2D2D2D2CDC8C8C5FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24345C4C94FAFAFAFAFAFA00FAFAFA0000FAFAFAFAFA00FAFAFAFAFAFAFA00FAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9EFEFEFF1F2F2
F7F7F8F8F8FAFAFAFAE9FA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFA000000000000FA00
FAFAFA00FA00FAFAFA00FA00FA00FAFAFA00FAFAFAFA0000FAFA00FA00FAFAFA00FA0000
FAFA00FA00FAFAFA00FA00FAFAFA00FA00FA00FAFAFA00FA0000FAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA000000FAFAFAE9FAC5D2D4D4D2D2D2D2D2CDC8C8C5FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24345C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9EFEFEFF1F2F2
F7F7F8F8F8FAFAFAFAE9FA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFA00FAFAFAFA00FAFA
000000FAFAFA000000FAFA00FAFA000000FAFAFAFAFA00FA0000FAFAFA000000FAFA00FA
0000FAFAFA000000FAFA00FAFAFA00FA00FAFA000000FAFA00FA00FAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA0000FAFAFAFAE9FAC5D2D4D4D2D2D2D2D2CDC8C8C5FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24345C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9EFEFEFF1F2F2
F7F7F8F8F8FAFAFAFAE9FA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFA00FAFAFAFA00FAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFA00FA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA00FAFAFAFAFAE9FAC5D2D4D4D2D2D2D2D2CDC8C8C5FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24345C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9EFEFEFF1F2F2
F7F7F8F8F8FAFAFAFAE9FA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFA0000000000FAFAFA
FAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFA00FA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC5D4D7D4D2D2D2D0D0CDC8C8C8FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24345C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9EFEFEFF1F2F2
F7F7F8F8F8FAFAFAFAE9FA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC5D4D7D4D2D2D2D0D0CDC8C8C8FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24345C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9EFEFEFF1F2F2
F7F7F8F8F8FAFAFAFAE9FA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC5D4D7D4D2D2D2D0D0CDC8C8C8FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24345C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9EFEFEFF1F2F2
F7F7F8F8F8FAFAFAFAE9FA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC5D4D7D4D2D2D2D0D0CDC8C8C8FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24345C4C94FAFAFA00FAFA00FAFA00FAFA0000FA00FA0000FA00FAFAFA00FA0000000000
FA00FA00FAFAFA00FA00FAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9EFEFEFF1F2F2
F7F7F8F8F8FAFAFAFAE9FA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC5D4D7D4D2D2D2D0D0CDC8C8C8FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24365C4C94FAFAFA00FAFA00FAFA00FA00FAFA0000FA00FAFA00FAFAFA00FA00FAFAFAFA
FA00FA00FAFAFA00FA00FA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9EFEFEFF1F2F2
F7F7F8F8F8FAFAFAFAE9FA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFA00000000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA000000
00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC5D4D7D4D2D2D2D0D0CDC8C8C8FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24365C4C94FAFAFA00FA00FA00FA00FA00FAFAFA00FA00FAFA00FAFAFA00FA00FAFAFAFA
FA00FA00FAFAFA00FA00FA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAE9EFEFEFF1F2F2
F7F7F8F8F8FAFAFAFAE9FA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC5D4D7D4D2D2D2D0D0CDC8C8C8FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24365C4C94FAFAFA00FA00FA00FA00FAFA00000000FA00FAFA00FAFAFA00FA00FAFAFAFA
FA00FA00FAFAFA00FA0000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA0000FAFAFAFAE9EFEFEFF1F2F2
F7F7F8F8F8FAFAFAFAE9FA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFA0000000000FAFAFA
000000FAFAFA0000FA00FA00FA00FAFAFA00FA00FAFAFA00FA00FA00FAFAFA00FAFA0000
FA00FAFA000000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC8D7D7D7D2D2D0D0D0CDC8CBC8FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24365C4C94FAFAFA00FA00FA00FA00FA00FAFAFA00FA00FAFA0000FAFA00FA00FAFAFAFA
FA00FA00FAFAFA00FA00FA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA000000FAFAFAE9EFEFEFF1F2F2
F7F7F8F8F8FAFAFAFAE9FA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFA00FAFAFAFA00FA00
FAFAFA00FA00FAFA0000FA00FA00FAFAFA00FA00FAFAFA00FA00FA00FAFAFA00FA00FAFA
0000FA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC8D7D7D7D2D2D0D0D0CDC8CBC8FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24365C4C94FAFAFA0000FAFAFA0000FAFA000000FA000000FA00FA0000FAFA00FAFAFAFA
FA00FA00000000FAFA00FAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA0000FAFAFAFAE9EFEFEFF1F2F2
F7F7F8F8F8FAFAFAFAE9FA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFA00FAFAFAFA00FA00
FAFAFAFAFA00FAFAFA00FA00FA00FAFAFA00FA00FAFAFA00FA00FA00FAFAFA00FA00FAFA
FA00FAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA00FAFAFAFAFAE9FAC8D7D7D7D2D2D0D0D0CDC8CBC8FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24365C4C94FAFAFA0000FAFAFA0000FAFAFAFAFAFAFA00FAFA00FAFAFAFAFA00FAFAFAFA
FAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAE9EFEFEFF1F2F2
F7F7F8F8F8FAFAFAFAE9FA94F8F894FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94F8F894FAFAFA00FAFAFAFA00FA00
00000000FA00FAFAFA00FA00FA00FAFAFA00FA00FAFAFA00FA00FA00FAFAFA00FA00FAFA
FA00FAFA0000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA0000FAFAFAFAE9FAC5D2D4D4D2D2D2D2D2CDC8C8C5FAAFFA94F8F894FA
FAFAFAFAFAFAFA
24365C4C94FAFAFA00FAFAFAFAFA00FAFAFAFAFAFAFA00FAFA00FAFAFAFAFA00FAFAFAFA
FA00FAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9EFEFEFF1F2F2
F7F7F8F8F8FAFAFAFAE9FA94FAFA94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94FAFA94FAFAFA000000000000FA00
FAFAFA00FA00FAFA0000FA00FA00FAFAFA00FA00FAFAFA00FA00FA00FAFAFA00FA00FAFA
0000FA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA000000FAFAFAE9FAC5D4D7D4D2D2D2D0D0CDC8C8C8FAAFFA94FAFA94FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9EFEFEFF1F2F2
F7F7F8F8F8FAFAFAFAE9FA94FAFA94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94FAFA94FAFAFA00FAFAFAFA00FAFA
000000FAFAFA0000FA00FA00FA00000000FAFA00000000FAFA00FA00000000FAFAFA0000
FA00FAFA000000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA0000FAFAFAFAE9FADBE7E3DEDEDEDBD7D7D7D0CBC8FACCFA94FAFA94FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9EFEFEFF1F2F2
F7F7F8F8F8FAFAFAFAE9FA94FAFA94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94FAFA94FAFAFA00FAFAFAFA00FAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA00FAFAFAFAFAE9FAEADBD7CFCFCFCACACAC8C3C0E3FAE2FA94FAFA94FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9EFEFEFF1F2F2
F7F7F8F8F8FAFAFAFAE9FA94FAFA94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94FAFA94FAFAFA0000000000FAFAFA
FAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FA94FAFA94FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9EEBCABA19E99
9797979999999EABEEE9FA94FAFA94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94FAFA94FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9EEBCABA19E999797979999999EABEEE9FA94FAFA94FA
FAFAFAFAFAFAFA
24365C4C94FAFAA6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6
A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6A6FAE9CFFAFAFAFAFA
FAFAFAFAFAFAFAFABFE9FA94FAFA94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94FAFA94FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9CFFAFAFAFAFAFAFAFAFAFAFAFAFABFE9FA94FAFA94FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FAE0C3C8C8C8
C8C8C5C5C5C3C3DFFABBFA94FAFA94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94FAFA94FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAE9FAE0C3C8C8C8C8C8C5C5C5C3C3DFFABBFA94FAFA94FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FABEC6CBCBCB
CBCBC8C8C6C4C3C3FAB1FA94FAFA94FA6161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161FA94FAFA94FA9A619A619A619A619A61
9A619A619A619A619A619A619A619A619A619A619A619A619A619A619A619A619A619A61
9A619A619A619A619A619A619A619A619A619A619A619A619A619A619A619A619A619A61
9A619A619A619A619A619A619A619A619A619A619A619A619A619A619A619A619A619A61
9A619A619A619A619A619A619AE9FABEC6CBCBCBCBCBC8C8C6C4C3C3FAB1FA94FAFA94FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FABECBCDD0CD
CDCDCBCBC8C6C4C3FAAFFA94FAFA94FA6161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161FA94FAFA94FA61616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
61616161616161616161616161E9FABECBCDD0CDCDCDCBCBC8C6C4C3FAAFFA94FAFA94FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FABECDD0D0D2
D2D2D0CBCBC6C4C5FAAFFA94FAFA94FA6161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161FA94FAFA94FA9A616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161619AE9FABECDD0D0D2D2D2D0CBCBC6C4C5FAAFFA94FAFA94FA
FAFAFAFAFAFAFA
24365C4C94FAFAFA00FAFAFAFA00FA00FAFA00FAFA00FA0000000000FAFAFAFAFAFA0000
00FAFAFA0000FA00FA00FA0000FAFAFA0000FA00FA00FA0000FAFA00FA00FA00FA0000FA
00FAFA000000FAFAFA000000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC3D0D25CD2
D2D2D0C85CC8C6C5FAAFFA94FAFA94FA616161FAFAFAFA6161FA616161FA61FA61FAFA61
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161FA94FAFA94FA616161FAFAFAFA6161FA
616161FA61FA61FAFA61616161FAFA6161FAFAFA616161FAFA61FA61FA61616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
61616161616161616161616161E9FAC3D0D25CD2D2D2D0C85CC8C6C5FAAFFA94FAFA94FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFA00FAFA00FAFA00FAFA00FAFA00FA00FAFAFAFAFAFAFAFAFA00FAFA
FA00FA00FAFA0000FA0000FAFA00FA00FAFA0000FA0000FAFA00FA00FA00FA00FA00FAFA
00FA00FAFAFA00FA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FAC5D25C5C5C
D2D2CD5C5C5CC8C5FAAFFA94FAFA94FA6161FA61616161FA61FA616161FA61FA61FA6161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161FA94FAFA94FA9A61FA61616161FA61FA
616161FA61FA61FA6161616161FA6161FA616161FA61FA6161FAFA61FA61616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161619AE9FAC5D25C5C5CD2D2CD5C5C5CC8C5FAAFFA94FAFA94FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFA00FAFA00FAFA00FA00FA00FA00FA00FAFAFAFAFAFAFAFA00FAFAFA
FAFAFA00FAFAFA00FA00FAFAFA00FA00FAFAFA00FA00FAFAFA00FA00FA00FA00FA00FAFA
00FA00FAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAE9FAC5D4D45C5C
5CD05C5C5CC8C8C8FAB1FA94FAFA94FA6161FA61616161FA61FA616161FA61FA61FA6161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161FA6161616161FA94FAFA94FA6161FA61616161FA61FA
616161FA61FA61FA6161616161FA6161FA616161FA61FA616161FA61FA61616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
61616161616161616161616161E9FAC5D4D45C5C5CD05C5C5CC8C8C8FAB1FA94FAFA94FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFAFA0000FAFAFA00FA00FA00FA00FA00FAFAFAFAFAFAFAFA00FAFAFA
FAFAFAFA00000000FA00FAFAFA00FAFA00000000FA00FAFAFA00FA00FA00FA00FA00FAFA
00FA0000000000FAFA0000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA0000FAFAFAFAE9FAC8D7D7D75C
5C5C5C5CC8C8CBC8FAB1FA94FAFA94FA6161FA61616161FA61FA616161FA61FA61FA6161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161FAFA61616161FA94FAFA94FA9A61FA61616161FA61FA
616161FA61FA61FA6161616161FA6161FA616161FA61FA616161FA61FA61616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161619AE9FAC8D7D7D75C5C5C5C5CC8C8CBC8FAB1FA94FAFA94FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFAFA0000FAFAFA00FA00FA00FA00FA00FAFAFAFAFAFAFAFA00FAFAFA
FAFAFA00FAFAFA00FA0000FAFA00FA00FAFAFA00FA0000FAFA00FA00FA00FA00FA00FAFA
00FA00FAFAFA00FA00FAFAFA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA000000FAFAFAE9FACAD7D7D7D7
5C5C5CCBC8CBCBCAFAB3FA94FAFA94FA6161FA61616161FA61FA616161FA61FA61FA6161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161FAFAFA616161FA94FAFA94FA6161FA61616161FA61FA
616161FA61FA61FA6161616161FA6161FA616161FA61FA616161FA61FAFA616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
61616161616161616161616161E9FACAD7D7D7D75C5C5CCBC8CBCBCAFAB3FA94FAFA94FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFA00FAFA00FAFA0000FAFAFA0000FA00FAFAFAFAFAFAFAFA00FAFAFA
FAFAFAFA000000FAFA00FA0000FAFAFA000000FAFA00FA0000FAFA00FA00FA00000000FA
00FAFA000000FAFAFA000000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA0000FAFAFAFAE9FACDDBD9D7D4
D45CCBCBCBCBCBCAFAB6FA94FAFA94FA6161FA61616161FA61FAFAFAFA6161FAFAFAFA61
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161FAFA61616161FA94FAFA94FA9A61FA61616161FA61FA
FAFAFA6161FAFAFAFA616161FAFAFA6161FAFAFA6161FA616161FA61FA61FA6161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161619AE9FACDDBD9D7D4D45CCBCBCBCBCBCAFAB6FA94FAFA94FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFA00FAFA00FAFA0000FAFAFA0000FA00FAFAFAFAFAFAFAFAFA00FAFA
FA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAFAFA00FAFAFA00FAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFAE9FAD1DEDED7D7
D7D4CDCBCBCBCBCAFABDFA94FAFA94FA6161FA61616161FA616161616161616161FA6161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161FA6161616161FA94FAFA94FA6161FA61616161FA6161
61616161616161FA6161616161FA61616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
61616161616161616161616161E9FAD1DEDED7D7D7D4CDCBCBCBCBCAFABDFA94FAFA94FA
FAFAFAFAFAFAFA
24365C4C94FAFAFA00FAFAFAFA00FA00FAFAFAFAFA00FA00FAFAFAFAFAFAFAFAFAFA0000
00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00FAFAFAFAFA00FA00FA00FA00FAFA
00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FAD7E3E0DBD7
D7D7D2D0D0CDCBCAFAC5FA94FAFA94FA6161FA61616161FA61616161616161FA61FA6161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161FA94FAFA94FA9A61FA61616161FA6161
6161616161FA61FA6161616161FA61616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161619AE9FAD7E3E0DBD7D7D7D2D0D0CDCBCAFAC5FA94FAFA94FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FADBE7E3DEDE
DBD7D7D7D2D0CBC8FAD1FA94FAFA94FA6161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161FA94FAFA94FA61616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
61616161616161616161616161E9FADBE7E3DEDEDBD7D7D7D2D0CBC8FAD1FA94FAFA94FA
FAFAFAFAFAFAFA
24365C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FAEADBD7CFCF
CACAC8C5C5C3C0E3FADEFA94FAFA94FA6161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161FA94FAFA94FA9A616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161619AE9FAEADBD7CFCFCACAC8C5C5C3C0E3FADEFA94FAFA94FA
FAFAFAFAFAFAFA
24345C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAE9FA94FAFA94FA6161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
616161616161616161616161616161616161616161616161616161616161616161616161
6161616161616161616161616161616161616161FA94FAFA94FA619A619A619A619A619A
619A619A619A619A619A619A619A619A619A619A619A619A619A619A619A619A619A619A
619A619A619A619A619A619A619A619A619A619A619A619A619A619A619A619A619A619A
619A619A619A619A619A619A619A619A619A619A619A619A619A619A619A619A619A619A
619A619A619A619A619A619A61E9FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE9FA94FAFA94FA
FAFAFAFAFAFAFA
24345C4C94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFA94FAFA94FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94FAFA94FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94FAFA94FA
FAFAFAFAFAFAFA
24345C4C9494949494949494949494949494949494949494949494949494949494949494
949494949494949494949494949494949494949494949494949494949494949494949494
949494949494949494949494949494949494949494949494949494949494949494949494
949494949494949494949494949494949494949494949494949494949494949494949494
949494949494949494949494FAFA94949494949494949494949494949494949494949494
949494949494949494949494949494949494949494949494949494949494949494949494
949494949494949494949494949494949494949494949494949494949494949494949494
949494949494949494949494949494949494949494949494949494949494949494949494
94949494949494949494949494949494949494949494FAFA949494949494949494949494
949494949494949494949494949494949494949494949494949494949494949494949494
949494949494949494949494949494949494949494949494949494949494949494949494
949494949494949494949494949494949494949494949494949494949494949494949494
9494949494949494949494949494949494949494949494949494949494949494FAFA9494
94949494949494
24345C4C96FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA
24345C4C96FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA
24345C4C96FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA
24345C4C96FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA
24345C4C96FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA
24345C4C96FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA
24345C4C96FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA
24345C4C96FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA
24345C4C9696969696969696969696969696969696969696969696969696969696969696
969696969696969696969696969696969696969696969696969696969696969696969696
969696969696969696969696969696969696969696969696969696969696969696969696
969696969696969696969696969696969696969696969696969696969696969696969696
969696969696969696969696969696969696969696969696969696969696969696969696
969696969696969696969696969696969696969696969696FAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA9696969696
969696969696969696969696969696969696969696969696969696969696969696969696
969696969696969696969696969696969696969696969696969696969696969696969696
96969696969696
24345C4CE6E69FE7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7
E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7
E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7
E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7
E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7
E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7DFDC96FAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA96E7E7E7E7
E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7
E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7
E7E7E7E7E7E7E7
24365C4CE6E69FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEAE7DF96FAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA96EFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEF
24365C4CE6E69FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEAE7DF96FAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA96EFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEF
24365C4CE6E69FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE7DF96FAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA96EFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEF
24365C4CE6E69FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF0000000000EFEFEFEF0000000000EF00
00EF0000EFEF0000EFEFEFEFEF0000EF0000EFEF0000EFEFEFEFEF0000EFEFEFEFEFEF00
00000000EF0000EFEF0000EFEF00000000EFEFEF0000EF0000EFEF00000000EFEF0000EF
EF0000EFEF000000EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE7DF96FAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA96EFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEF0000EFEFEFEF0000EFEF0000EFEF00000000EFEFEFEFEFEF0000
EFEFEFEF0000EF
24365C4CE6E69FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF0000EFEF0000EFEF0000EF000000EF00
00EF0000EF0000EFEFEFEFEFEF0000EF0000EFEF0000EFEFEFEFEF0000EFEFEFEFEF0000
EF000000EF0000EFEF0000EF0000EFEF0000EF0000EFEF0000EF0000EFEF0000EF0000EF
EF0000EF0000EF0000EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE9E196FAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA96EFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEF0000EFEFEFEF0000EFEF0000EF0000EFEF0000EFEFEFEFEF0000
EF0000EF0000EF
24365C4CE6E69FF1F1EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF0000EFEF0000EFEF0000EFEF0000EF00
00EF0000EF0000EFEFEFEFEFEF0000EF0000EFEF0000EFEFEFEFEF0000EFEFEFEFEF0000
EFEF0000EF0000EFEF0000EF0000EFEFEFEFEF0000EFEF0000EF0000EFEF0000EF0000EF
EF0000EFEFEF0000EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE9E496FAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00
00FAFAFAFA0000FAFA0000000000FAFA0000000000FAFAFAFAFAFA00000000FAFA0000FA
FA0000FAFA000000FAFAFAFAFAFAFA0000000000FAFAFAFAFA000000000000FA0000FA00
00FAFA0000FA0000FAFA0000FAFA000000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA96F1EFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEF0000EFEFEFEF0000EFEF0000EF0000EFEFEFEFEFEFEFEFEF0000
EF0000EF0000EF
24365C4CE6E69FF2F2EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF0000EFEF0000EFEF0000EFEF0000EF00
00EF0000EF0000EFEF000000EF0000EF0000EFEF0000EFEFEFEFEF0000EFEFEFEFEF0000
EFEF0000EF0000EFEF0000EF0000EFEFEFEFEF0000EFEF0000EF0000EFEF0000EF0000EF
EF0000EFEF0000EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE9E496FAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA00
00FAFAFAFA0000FA0000FAFA0000FA0000FAFA0000FAFAFAFAFA0000FAFA0000FA0000FA
FA0000FA0000FA0000FAFAFAFAFA0000FA0000FAFAFAFAFAFA0000FAFAFAFAFA0000FA00
00FAFA0000FA0000FA0000FAFA0000FA0000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA96F2EFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEF0000EFEFEFEF0000EFEF0000EF000000000000EFEFEFEFEF0000
000000000000EF
24365C4CE6E69FF2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F20000000000F2F2F20000F2F20000F200
00F20000F20000F2F2F2F2F2F20000F2000000F20000F2F2F2F2F20000000000F2F20000
F2F20000F2000000F20000F20000F2F20000F20000F2F20000F20000F2F20000F2000000
F20000F20000F20000F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2EFEAE596FAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
000000000000FAFA0000FAFA0000FA0000FAFA0000FAFAFAFAFA0000FAFA0000FA0000FA
FA0000FAFAFA0000FAFAFAFAFAFA0000FA0000FAFAFAFAFAFA0000FAFAFAFAFA0000FA00
00FAFA0000FA00000000FAFAFAFAFA0000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA96F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F20000F2F2F2F2000000F20000F20000F2F20000F2F2F2F2F20000
000000000000F2
24365C4CE6E69FF2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F20000F2F20000F2F20000F2F20000F200
00F20000F2000000F2F2F2F2F20000F20000000000F2F2F2F2F2F20000F2F2F2F2F20000
F2F20000F20000000000F2F2F200000000F2F2000000F20000F2F200000000F2F2000000
0000F2F2F2000000F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2EDE596FAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
0000FAFA0000FAFA0000FAFA0000FA0000FAFA0000FA000000FA0000FAFA0000FA0000FA
FA0000FAFA0000FAFAFAFAFAFAFA000000000000FAFAFAFAFA0000FAFAFAFAFA0000FA00
00FAFA0000FA000000FAFAFAFAFA0000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA96F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F20000F2F2F2F20000000000F2F2F200000000F2F2F2F2F2F20000
00F2F2000000F2
24365C4CE6E69FF2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F20000F2F20000F2F2F2F2F2F2F2F2F2F2
F2F20000F20000F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F20000F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F20000F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2EFE796FAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
0000FAFA0000FAFA0000FAFA0000FA0000FAFA0000FAFAFAFAFA0000FAFA0000FA000000
FA0000FA0000FA0000FAFAFAFAFAFA0000FAFAFAFAFAFAFAFA0000FAFAFAFAFA0000FA00
0000FA0000FA00000000FAFAFA0000FA0000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA96F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F20000F2F2F2F20000F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F20000
00F2F2000000F2
24365C4CE6E69FF2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F20000F2F20000F2F2F2F2F2F2F2F2F2F2
F2F20000F20000F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F20000F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F20000F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2EFE796FAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FA00000000FAFAFAFA0000000000FAFA0000000000FAFAFAFAFAFA00000000FAFA000000
0000FAFAFA000000FAFAFAFAFAFAFA0000FAFAFAFAFAFAFAFA0000FAFAFAFAFA0000FA00
00000000FAFA0000FA0000FAFAFA000000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA96F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F20000F2F2F2F20000F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F20000
F2F2F2F20000F2
24365C4CE6E69FF7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7
F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F70000000000F7F7F7F7F7F7F7F7F7F700
00F70000F7F7F7F7F7F7F7F7F70000F7F7F7F7F7F7F7F7F7F7F7F7000000000000F7F7F7
F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F70000F7F7F7F7F7F7F7F7F7F7F7
F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7
F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F2EFE796FAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FA00000000FAFAFAFAFAFAFA0000FAFAFAFAFA0000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFA00000000FAFAFAFAFAFAFA0000FAFAFAFAFAFAFAFAFA
FAFAFAFAFAFA0000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA96F7F7F7F7
F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7
F7F7F7F7F7F7F7F7000000000000F7F70000F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F70000
F7F7F7F70000F7
24365C4CE6E69FF8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8
F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8
F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8
F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8
F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8
F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F2ED96FAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFA0000FAFAFAFAFAFAFAFA0000FAFAFAFAFA0000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFA00000000FAFAFAFAFAFAFA0000FAFAFAFAFAFAFAFAFA
FAFAFAFAFAFA0000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA96F8F8F8F8
F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8
F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8
F8F8F8F8F8F8F8
24345C4CE6E69FFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAF8F296FAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFA0000FAFAFAFAFAFAFAFA0000FAFAFAFAFA0000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFA0000FAFAFAFAFAFAFAFA0000FAFAFAFAFA0000FAFA
FAFAFAFAFAFA0000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA96FAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA
24345C4CE6E6B3E6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE696FAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA96FAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA
24345C4CE6E6D2BEE6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAEEBE96FAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA96E6FAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA
24345C4CE6E6EBD2B39F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F
9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F
9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F
9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F
9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F
9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9FACCDA8BDC4C4C4C4C4C4C4C4C4C4C4
C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4
C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4
C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4
C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4
C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4BDA8B39F9F9F
9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F
9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F
9F9F9F9F9F9F9F
24345C4CE6E69FE7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7
E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7
E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7
E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7DFDC9FEB9FE7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7
E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7
E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7C6A7BDC7C7C7C7C7C7C7C7C7C7
C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7
C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7
C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7
C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7
C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C0A7C6E7E7E7E7
E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7
E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7
E7E7E7E7E7E7E7
24345C4CE6E69FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEAE7DF9FEB9FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEBC6A198989898989898989898
989898989898989898989898989898989898989898989898989898989898989898989898
989898989898989898989898989898989898989898989898989898989898989898989898
989898989898989898989898989898989898989898989898989898989898989898989898
989898989898989898989898989898989898989898989898989898989898989898989898
9898989898989898989898989898989898989898989898989898989898A1C1EBEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEF
24345C4CE6E69FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEAE7DF9FEB9FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEF0000000000EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEAE7DF9FEB9FEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEAE7DF9FEB9FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEF
24345C4CE6E69FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE7DF9FEB9FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF0000EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE7DF9FEB9FEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE7DF9FEB9FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEF
24345C4CE6E69FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEF0000EFEFEFEFEF0000EFEFEF00000000EFEF0000EFEF0000EFEF0000EFEFEFEFEF
000000000000EFEF0000EFEF0000EFEF0000000000EFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE7DF9FEB9FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF000000000000EFEFEF00000000EFEFEF0000EF
EF0000EF0000EF0000EFEF0000EFEF0000000000EFEFEFEFEFEF00000000EFEFEFEF0000
EFEF0000000000EF0000EFEFEF0000EFEF00000000EFEFEF0000000000EFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE7DF9FEB9FEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF0000EFEFEFEFEF000000
00EFEFEF0000000000EF0000EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE7DF9FEB9FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF0000000000EFEFEFEFEF00000000EFEF0000EF
0000EF0000EFEF00000000EFEFEF000000EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEF
24345C4CE6E69FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEF0000EFEFEFEFEF0000EFEF0000EFEF0000EF0000EFEF0000EF0000EFEFEFEFEFEF
0000EFEFEFEFEFEF0000EFEF0000EF0000EFEF0000EFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE9E19FEB9FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF0000EFEF000000EFEF0000EFEF0000EF0000EFEF
0000EFEF0000EF0000EFEF0000EF0000EFEF0000EFEFEFEFEF0000EFEF0000EFEF0000EF
EF0000EFEF0000EF0000EFEF0000EFEF0000EFEF0000EF0000EFEF0000EFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE9E19FEB9FEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF0000EFEFEFEF0000EFEF
0000EF0000EF000000EF0000EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE9E19FEB9FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF0000EFEF0000EFEFEF0000EFEF0000EF0000EF
0000EF0000EF0000EFEF0000EF0000EF0000EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEF
24345C4CE6E69FF1F1EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEF0000EFEFEFEFEF0000EFEF0000EFEF0000EF0000EFEF0000EF0000EFEFEFEFEFEF
0000EFEFEFEFEFEF0000EFEF0000EF0000EFEF0000EFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE9E49FEB9FF1F1EFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF0000EFEFEF0000EFEF0000EFEFEFEFEF0000EFEF
0000EFEF0000EF0000EFEF0000EF0000EFEF0000EFEFEFEFEFEFEFEFEF0000EFEF0000EF
EF0000EFEF0000EF0000EFEF0000EFEF0000EFEFEFEFEF0000EFEF0000EFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE9E49FEB9FF1F1EFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF0000EFEFEFEF0000EFEF
0000EF0000EFEF0000EF0000EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE9E49FEB9FF1F1EFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF0000EFEFEF0000EFEF0000EFEFEFEFEF0000EF
0000EF0000EF0000EFEF0000EFEFEF0000EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEF
24345C4CE6E69FF2F2EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEF0000EFEFEFEFEF0000EFEF0000EFEF0000EF0000EFEF0000EF0000EFEFEFEFEFEF
0000EFEFEFEFEFEF0000EFEF0000EF0000EFEF0000EFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE9E49FEB9FF2F2EFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF0000EFEFEF0000EFEF000000000000EF0000EFEF
0000EFEF0000EF0000EFEF0000EF0000EFEF0000EFEFEFEFEFEFEFEFEF0000EFEF0000EF
EFEF0000000000EF0000EFEF0000EFEF000000000000EF0000EFEF0000EFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE9E49FEB9FF2F2EFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF0000EFEFEFEF0000EFEF
0000EF0000EFEF0000EF0000EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE9E49FEB9FF2F2EFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF0000EFEFEF0000EFEF000000000000EF0000EF
0000EF0000EF0000EFEF0000EFEF0000EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEF
24345C4CE6E69FF2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F20000000000F2F20000F2F20000F2F20000F2000000F20000F20000F2F2F2F2F2F2
0000000000F2F2F2000000F20000F20000F2F20000F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2EFEAE59FEB9FF2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F20000F200000000F2F20000F2F20000F20000F2F2
0000F2F20000F2000000F20000F20000F2F20000F2F2F2F2F2F200000000F2F2F20000F2
F2F2F2F2F20000F20000F2F20000F2F20000F2F20000F20000F2F20000F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2EFEAE59FEB9FF2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F20000F2F2F2F20000F2F2
0000F20000F2F20000F20000F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2EFEAE59FEB9FF2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F20000F2F2F20000F2F20000F2F20000F20000F2
0000F20000F20000F2F20000F20000F20000F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2
24345C4CE6E69FF2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F20000F2F2F2F2F2000000F2F200000000F2F20000000000F2F2000000F2F2F2F2F2
0000F2F2F2F2F2F20000000000F2F2F20000000000F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2EDE59FEB9FF2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F20000F2F2F2F2F2F2F2F200000000F2F2000000F2
000000F20000F20000000000F2F2F20000000000F2F2F2F2F20000F2F2F2F2F2F2000000
F2F200000000F2F2000000F2000000F2F200000000F2F2F20000000000F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2EDE59FEB9FF2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F20000F2F2F2F2F2000000
00F2F20000F2F20000F2000000F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2EDE59FEB9FF2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F20000F2F2F20000F2F2F200000000F2F2000000
00000000F2F2F200000000F2F2F2000000F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2
24345C4CE6E69FF2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F20000F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F20000F2F2F2F2F2F2
0000F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F20000F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2EFE79FEB9FF2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F20000F2F2F2F2F2F2F2F2F2F2F2F2F2F20000F2F2
0000F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F20000F2F2F2F2F2F20000F2
F2F2F2F2F2F2F2F2F2F2F2F20000F2F2F2F2F2F2F2F2F2F2F2F2F20000F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2EFE79FEB9FF2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F20000F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2EFE79FEB9FF2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F20000F2F2F20000F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2
24345C4CE6E69FF2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F20000F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F20000F2F2F2F2F2F2
0000F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F20000F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2EFE79FEB9FF2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F20000F2F2F20000F2F2F2F2F2F2F2F2F20000F2F2
0000F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F20000F2F20000F2F20000F2
F2F2F2F2F2F2F2F2F2F2F2F20000F2F2F2F2F2F2F2F2F2F2F2F2F20000F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2EFE79FEB9FF2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F20000F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2EFE79FEB9FF2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F20000F2F20000F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2
F2F2F2F2F2F2F2
24345C4CE6E69FF7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7
F7F7F7000000000000F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7
000000000000F7F7F7F7F7F7F7F7F7F7F7F7F70000F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7
F7F7F7F7F7F7F7F7F7F7F7F7F7F7F2EFE79FEB9FF7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7
F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F70000000000F7F7F7F7F7F7F7F7F7F7F7F7F7F7
F7F7F7F70000F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F700000000F7F7F7F7F7F7
F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F70000F7F7F7F7F7F7F7
F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F2EFE79FEB9FF7F7F7F7F7F7F7F7
F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7000000000000F7F7F7F7F7F7
F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7
F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F2EFE79FEB9FF7F7F7F7F7F7F7F7F7F7F7F7F7F7F7
F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F70000000000F7F7F7F7F7F7F7F7F7F7F7F7F7F7
F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7
F7F7F7F7F7F7F7
24345C4CE6E69FF8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8
F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8
F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8
F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F2ED9FEB9FF8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8
F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8
F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8
F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8
F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F2ED9FEB9FF8F8F8F8F8F8F8F8
F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8
F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8
F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F2ED9FEB9FF8F8F8F8F8F8F8F8F8F8F8F8F8F8F8
F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8
F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8
F8F8F8F8F8F8F8
24345C4CE6E69FFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAF8F29FEB9FFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAF8F29FEB9FFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAF8F29FEB9FFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA
24345C4CE6E6B3E6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE6B3EBB3E6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE6B3EBB3E6FAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAE6B3EBB3E6FAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA
24345C4CE6E6D2BEE6FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAEEBED2EBD2BEE6FAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAEEBED2EBD2BEE6FAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAEEBED2EBD2BEE6FAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFA
24345C4CE6E6EBD2B39F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F
9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F
9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F
9F9F9F9F9F9F9F9F9F9F9F9F9F9F9FACCDEBEBEBD2B39F9F9F9F9F9F9F9F9F9F9F9F9F9F
9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F
9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F
9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F
9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9FACCDEBEBEBD2B39F9F9F9F9F9F
9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F
9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F
9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9FACCDEBEBEBD2B39F9F9F9F9F9F9F9F9F9F9F9F9F
9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F
9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F9F
9F9F9F9F9F9F9F
24345C4CE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24345C4CE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24345C4CE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24345C4CE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24365C4CE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24365C4CE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24365C4CE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24365C4CE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24365C4CE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24365C4CE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24365C4CE6E6E6E6E6E6E6E6EBECEFF1F5F5F5F5F5F5F5F5F5F7F7F7F7F7F7F7F5F5F7F7
F7F7ECE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6EBECEFF1F5F5F5F5F5F5F5F5F5F7
F7F7F7F7F7F7F5F5F7F7F7F7ECE6E6E6E6E6E6EBECEFF1F5F5F5F5F5F5F5F5F5F7F7F7F7
F7F7F7F5F5F7F7F7F7ECE6E6E6EBECEFF1F5F5F5F5F5F5F5F5F5F7F7F7F7F7F7F7F5F5F7
F7F7F7ECE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24365C4CE6E6E6E6E6E6E6E6E6E69049303030303030303030303030303030303030303F
83F1F5E6E6E6E6E6E6E6E6D4C6C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4CEE6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6904930303030303030303030
3030303030303030303F83F1F5E6E6E6E6E6E6E6E6904930303030303030303030303030
3030303030303F83F1F5E6E6E6E6E6904930303030303030303030303030303030303030
3F83F1F5E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24365C4CE6E6E6E6E6E6E6E6E17C67A9CECECECECECECECECECECECECECECECECECECCB2
6581F1E6E6E6E6E6E6E6CED4E6F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1E9D4CEE6
E6E6E6E6E6E6949494949494949494949494949494949494949494949494949494949494
949494949494949494949494949494949494949494949494949494949494949494949494
949494949494949494949494949494949494949494949494949494949494949494949494
949494949494949494949494949494949494949494949494949494949494949494949494
949494949494949494949494949494949494949494949494949494949494949494949494
949494949494949494949494949494949494949494949494949494949494949494949494
9494949494949494949494949494949494E6E6E6E6E6E17C447484848484848484848484
848484848484848484844481F1E6E6E6E6E6E6E17C67A9CECECECECECECECECECECECECE
CECECECECECCB26581F1E6E6E6E17C67A9CECECECECECECECECECECECECECECECECECECC
B26581F1E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24365C4CE6E6E6E6E6E6E6E6DE3FC1DCDCDCDCDCDCDCDCDCDCDCDCDCDCDCDCDCDCDCD9D4
B83FEFE6E6E6E6E6E6E6C4E9F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1E9C4E6
E6E6E6E6E6E694FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94E6E6E6E6E6DE3FA7A7A7A7A7A7A7A7A7A7A7A7
A7A7A7A7A7A7A7A7A7A7A73FEFE6E6E6E6E6E6DE3FC1DCDCDCDCDCDCDCDCDCDCDCDCDCDC
DCDCDCDCDCD9D4B83FEFE6E6E6DE3FC1DCDCDCDCDCDCDCDCDCDCDCDCDCDCDCDCDCDCDCD9
D4B83FEFE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24365C4CE6E6E6E6E6E6E6E6DC30E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7DF
DC30EEE6E6E6E6E6E6E6C4F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1C4E6
E6E6E6E6E6E694FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94E6E6E6E6E6DC30A7A7E7E7E7E7E7E7E7E7E7E7
E7E7E7E7E7E7E7E7E7A7A730EEE6E6E6E6E6E6DC30E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7
E7E7E7E7E7E7DFDC30EEE6E6E6DC30E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7E7
DFDC30EEE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24365C4CE6E6E6E6E6E6E6E6DC30EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEAE7
DF30ECE6E6E6E6E6E6E6C4F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1C4E6
E6E6E6E6E6E694FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94E6E6E6E6E6DC30A7A7EFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEAA7A730ECE6E6E6E6E6E6DC30EFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEAE7DF30ECE6E6E6DC30EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEA
E7DF30ECE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24365C4CE6E6E6E6E6E6E6E6DC30EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEAE7
DF30ECE6E6E6E6E6E6E6C4F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1C4E6
E6E6E6E6E6E694FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94E6E6E6E6E6DC30A7A7EFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFEFEFEAA7A730ECE6E6E6E6E6E6DC30EFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEAE7DF30ECE6E6E6DC30EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEA
E7DF30ECE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24395C4CE6E6E6E6E6E6E6E6DC30EFEFEFEFEFEFEFEFEFEFEFEFEFCCBFEFEFEFEFEFEFE7
DF30ECE6E6E6E6E6E6E6C4F1F1F1F1F1F1F1C7F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1C4E6
E6E6E6E6E6E694FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94E6E6E6E6E6DC30ACACEFEFEFEF000000EF00EF
EFEF000000EFEFEFEFACAC30ECE6E6E6E6E6E6DC30EFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
EFEFEFEFEFEFE7DF30ECE6E6E6DC30EFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF
E7DF30ECE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24395C4CE6E6E6E6E6E6E6E6DC30EFEFEFEFEFEFEFEFEFEFEFEFC4A792EFEFEFEFEFEFE7
DF30ECE6E6E6E6E6E6E6C4F1F1F1F1F1F1F1B7B7F1F1F1F1F1F1F1F1F1F1F1F1F1F1C4E6
E6E6E6E6E6E694FAFAFAFA00000000FAFAFA00FAFAFA00FA00FAFA00FAFAFAFAFA00FAFA
000000FAFAFA0000FA00FA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94E6E6E6E6E6DC30AFADEFEFEF00EFEFEF0000EF
EF00EFEFEF00EFEFEFAFAF30ECE6E6E6E6E6E6DC30EFEFEFEFEFEFBF9290909090909090
B5EFEFEFEFEFE7DF30ECE6E6E6DC30EFEFEFEFEFEFEFEFEFEFB7AFEFEFEFEFEFEFEFEFEF
E7DF30ECE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24395C4CE6E6E6E6E6E6E6E6DC30EFEFEFEFEFEFEFEFEFEFEFB5958A90EFEFEFEFEFEFE9
E130ECE6E6E6E6E6E6E6C4F1F1F1F1F1F1F1B7AFB5BFF1F1F1F1F1F1F1F1F1F1F1F1C4E6
E6E6E6E6E6E694FAFAFA00FAFAFAFA00FAFA00FAFAFA00FA00FA00FAFAFAFAFA00FAFA00
FAFAFA00FA00FAFA0000FA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94E6E6E6E6E6DC30B4B4EFEFEF00EFEFEFEF00EF
EF00EFEFEF00EFEFEFB4B430ECE6E6E6E6E6E6DC30EFEFEFEFEFEFCCA58A8A8A8A8A827A
C4EFEFEFEFEFE9E130ECE6E6E6DC30EFEFEFEFEFEFEFEFEFC79F90BFEFEFEFEFEFEFEFEF
E9E130ECE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24395C4CE6E6E6E6E6E6E6E6DC30F1F1EFEFEFEFEFEFEFBCA08A8A8A7AEFEFEFEFEFEFE9
E430ECE6E6E6E6E6E6E6C4F1F1F1F1F1F1F1B7AFAFB0B7F1F1F1F1F1F1F1F1F1F1F1C4E6
E6E6E6E6E6E694FAFAFA00FAFAFAFA00FAFA00FAFAFA00FA00FA00FAFAFAFAFA00FAFA00
FAFAFA00FA00FAFAFA00FA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94E6E6E6E6E6DC30B4B6EFEFEF00EFEFEFEF00EF
EF00EFEFEF00EFEFEFB4B430ECE6E6E6E6E6E6DC30F1F1EFEFEFEFEFBF7A7A88887058A5
EFEFEFEFEFEFE9E430ECE6E6E6DC30F1F1EFEFEFEFEFEFEFB58A8AA7EFEFEFEFEFEFEFEF
E9E430ECE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24395C4CE6E6E6E6E6E6E6E6DC30F2F2EFEFEFEFEFC1A7908A8A8A8272EFEFEFEFEFEFE9
E430ECE6E6E6E6E6E6E6C4F1F1F1F1F1F1F1B7AFAFAFAFAFB7C4F1F1F1F1F1F1F1F1C4E6
E6E6E6E6E6E694FAFAFA00FAFAFAFA00FAFA00FAFAFA00FA00FA00FAFAFAFAFA00FAFA00
FAFAFA00FA00FAFAFA00FA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94E6E6E6E6E6DC30B8B8EFEFEF00EFEF000000EF
EF00EFEFEF00EFEFEFB8B830ECE6E6E6E6E6E6DC30F2F2EFEFEFEFEFEFA7727A785A7DEF
EFEFEFEFEFEFE9E430ECE6E6E6DC30F2F2EFEFEFEFEFEFC5988A8A8FBDEFEFEFEFEFEFEF
E9E430ECE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24395C4CE6E6E6E6E6E6E6E6DC30F2F2F2F2F2F2F2BF8A787A82888072F2F2F2F2F2EFEA
E530ECE6E6E6E6E6E6E6C4F1F1F1F1F1F1F1B7AFAFAAA59F9FB7F1F1F1F1F1F1F1F1C4E6
E6E6E6E6E6E694FAFAFA00FAFAFAFA00FAFA0000FAFA00FA00FA00FAFAFAFAFA00FAFA00
FAFAFA00FA00FAFAFA00FA00FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94E6E6E6E6E6DC30BBBBF2F2F200F2F2F2F2F2F2
F2F2000000F2F2F2EFBBBB30ECE6E6E6E6E6E6DC30F2F2F2F2F2F2F2F2C78A70625AB7F2
F2F2F2F2F2EFEAE530ECE6E6E6DC30F2F2F2F2F2F2F2F2AD8A8A8A8A9DF2F2F2F2F2F2EF
EAE530ECE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24395C4CE6E6E6E6E6E6E6E6DC30F2F2F2F2F2F2F2F2C4915A60727872F2F2F2F2F2F2ED
E530ECE6E6E6E6E6E6E6C4F1F1F1F1F1F1F1B7AFA5978FA7C4F1F1F1F1F1F1F1F1F1C4E6
E6E6E6E6E6E694FAFAFA00FAFAFAFA00FAFA00FA0000FAFA00FA0000FAFAFAFA0000FAFA
000000FAFA00FAFAFA00FA0000FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94E6E6E6E6E6DC30C0C0F2F2F200F2F2F2F2F2F2
F2F2F2F2F2F2F2F2F2C0C030ECE6E6E6E6E6E6DC30F2F2F2F2F2F2F2F2F2B4684A8FF2F2
F2F2F2F2F2F2EDE530ECE6E6E6DC30F2F2F2F2F2F2F2BF908A8A888A8AAFF2F2F2F2F2F2
EDE530ECE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24395C4CE6E6E6E6E6E6E6E6DC30F2F2F2F2F2F2F2F2F2F2B578525A62F2F2F2F2F2F2EF
E730ECE6E6E6E6E6E6E6C4F1F1F1F1F1F1F1B79F929DB9F1F1F1F1F1F1F1F1F1F1F1C4E6
E6E6E6E6E6E694FAFAFA00FAFAFAFA00FAFAFAFAFAFAFAFAFAFA00FAFAFAFAFA00FAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94E6E6E6E6E6DC30C3C0F2F2F200F2F2F2F200F2
F2F2F2F2F2F2F2F2F2C0C030ECE6E6E6E6E6E6DC30F2F2F2F2F2F2F2F2F2CC825ABFF2F2
F2F2F2F2F2F2EFE730ECE6E6E6DC30F2F2F2F2F2F2F29A8870626268707ABFF2F2F2F2F2
EFE730ECE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24395C4CE6E6E6E6E6E6E6E6DC30F2F2F2F2F2F2F2F2F2F2F2C7A15A50F2F2F2F2F2F2EF
E730ECE6E6E6E6E6E6E6C4F1F1F1F1F1F1F1A995AFC7F1F1F1F1F1F1F1F1F1F1F1F1C4E6
E6E6E6E6E6E694FAFAFA00FAFAFAFA00FAFAFAFAFAFAFAFAFAFA00FAFAFAFAFA00FAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94E6E6E6E6E6DC30C5C5F2F2F2F200000000F2F2
F2F2F2F2F2F2F2F2F2C5C830ECE6E6E6E6E6E6DC30F2F2F2F2F2F2F2F2F2F2B7B5F2F2F2
F2F2F2F2F2F2EFE730ECE6E6E6DC30F2F2F2F2F2F2B978685D5A5A5A5F609FF2F2F2F2F2
EFE730ECE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24395C4CE6E6E6E6E6E6E6E6DC30F7F7F7F7F7F7F7F7F7F7F7F7F7BF99F7F7F7F7F7F2EF
E730ECE6E6E6E6E6E6E6C4F1F1F1F1F1F1F1B7BFF1F1F1F1F1F1F1F1F1F1F1F1F1F1C4E6
E6E6E6E6E6E694FAFAFA00FAFAFAFA00FAFAFAFAFAFAFAFA00FAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94E6E6E6E6E6DC30C8C8F7F7F7F7F7F7F7F7F7F7
F7F7F7F7F7F7F7F7F2C8C830ECE6E6E6E6E6E6DC30F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7
F7F7F7F7F7F2EFE730ECE6E6E6DC30F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F7F2
EFE730ECE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24395C4CE6E6E6E6E6E6E6E6DC30F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F2
ED30ECE6E6E6E6E6E6E6C4F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1C4E6
E6E6E6E6E6E694FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94E6E6E6E6E6DC30CACCF8F8F8F8F8F8F8F8F8F8
F8F8F8F8F8F8F8F8F8CCCC30ECE6E6E6E6E6E6DC30F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8
F8F8F8F8F8F8F2ED30ECE6E6E6DC30F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8F8
F2ED30ECE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24395C4CE6E6E6E6E6E6E6E6DB30FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAF8
F230ECE6E6E6E6E6E6E6C4F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1C4E6
E6E6E6E6E6E694FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94E6E6E6E6E6DB30CCCCFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFACCCC30ECE6E6E6E6E6E6DB30FAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAF8F230ECE6E6E6DB30FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
F8F230ECE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24395C4CE6E6E6E6E6E6E6E6DC49C7FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
C749ECE6E6E6E6E6E6E6C6E6F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1E6C6E6
E6E6E6E6E6E694FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94E6E6E6E6E6DC49CFCFCFCFCFCFCFCFCFCFCFCF
CFCFCFCFCFCFCFCFCFCFCF49ECE6E6E6E6E6E6DC49C7FAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAC749ECE6E6E6DC49C7FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAC749ECE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24365C4CE6E6E6E6E6E6E6E6DC8E73CAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFADA
738EE6E6E6E6E6E6E6E6D4D4E6F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1E9D4D4E6
E6E6E6E6E6E694FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA94E6E6E6E6E6DC8E44DEDEDEDEDEDEDEDEDEDEDE
DEDEDEDEDEDEDEDEDEDE448EE6E6E6E6E6E6E6DC8E73CAFAFAFAFAFAFAFAFAFAFAFAFAFA
FAFAFAFAFAFADA738EE6E6E6E6DC8E73CAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFAFA
DA738EE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24365C4CE6E6E6E6E6E6E6E6DEE18E49303030303030303030303030303030303030303F
7FE3E4E6E6E6E6E6E6E6E6D4C6C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4CEE6E6
E6E6E6E6E6E6949494949494949494949494949494949494949494949494949494949494
949494949494949494949494949494949494949494949494949494949494949494949494
949494949494949494949494949494949494949494949494949494949494949494949494
949494949494949494949494949494949494949494949494949494949494949494949494
949494949494949494949494949494949494949494949494949494949494949494949494
949494949494949494949494949494949494949494949494949494949494949494949494
9494949494949494949494949494949494E6E6E6E6E6DEE18E4930303030303030303030
3030303030303030303F7FE3E4E6E6E6E6E6E6DEE18E4930303030303030303030303030
3030303030303F7FE3E4E6E6E6DEE18E4930303030303030303030303030303030303030
3F7FE3E4E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24365C4CE6E6E6E6E6E6E6E6E6DEDBDBDBDBDBDBDBDBDBDBDBD5D5D5D5D5D5D5DBDBDBDB
DCDEE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6DEDBDBDBDBDBDBDBDBDBDBDBD5
D5D5D5D5D5D5DBDBDBDBDCDEE6E6E6E6E6E6E6E6DEDBDBDBDBDBDBDBDBDBDBDBD5D5D5D5
D5D5D5DBDBDBDBDCDEE6E6E6E6E6DEDBDBDBDBDBDBDBDBDBDBDBD5D5D5D5D5D5D5DBDBDB
DBDCDEE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24365C4CE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24365C4CE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24365C4CE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24365C4CE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24365C4CE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24365C4CE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24365C4CE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24365C4CE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24365C4CE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
24365C4CE6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6E6
E6E6E6E6E6E6E6
243A3A433C3C3C3F3F3F3F3F3F3F3F3F3F3F3F3F3F3C3C3F3C3C3F3F3F3F3F3F3F3F3F3F
3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F
3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F
3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F
3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F
3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3F3C
3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C
3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C
3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C
3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C
3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C
3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C
3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C
3C3C3C3C3C3C3C
243A3A43393C3F3F3F424242444444484548484848484848484845454545454545454545
454545454545454545454545454545454545454545454545454545454545454545454545
454545454545454545454545454545454545454545454545454545454545454545454545
454545454545454545454545454545454545454545454545454545454545454545454545
454545454545454545454545454545454545454545454545454545454545454545454545
454545454545454545454545454545454545454545454545454545454545454545454545
454545454545454545454545454545454545454545454545454545454545454545454545
454545454545454545454545454545454545454545454545454545454545454545454545
454545454545454545454545454545454545454545454545454545454545454545454545
454545454545454545454545454545454545454545454545454545454545454545454545
454545454545454545454545454545454545454545454545454545454545454545454545
454545454545454141414141414141414141414141414141414141414141414141414141
414141414141414141414141414141414141414141414141414141414141414141414141
41414141414141
243A44454A4C4C4D50525155555558585858585858585858585656565454545454545454
545454545454545454545454545454545454545454545454545454545454545454545454
545454545454545454545454545454545454545454545454545454545454545454545454
545454545454545454545454545454545454545454545454545454545454545454545454
545454545454545454545454545454545454545454545454545454545454545454545454
545454545454545454545454545454545454545454545454545454545454545454545454
545454545454545454545454545454545454545454545454545454545454545454545454
545454545454545454545454545454545454545454545454545454545454545454545454
545454545454545454545454545454545454545454545454545454545454545454545454
545454545454545454545454545454545454545454545454545454545454545454545454
545454545454545454545454545454545454545454545454545454545454545454545454
545454545454545454545454545454545454545454545454545454545454545454545454
545454545454545454545454545454545454545454545454545454545454545454545454
54545454545454
243A444D4E4D4E53535358585858585B5B5B585858585858585858585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585856
565656565656565656565656565656565656565656565656565656565656565656565656
565656565656565656565656565656565656565656565656565656565656565656565656
565656565656565656565656565656565656565656565656565656565656565656565656
565656565656565656565656565656565656565656565656565656565656565656565656
565656565656565656565656565656565656565656565656565656565656565656565656
565656565656565656565656565656565656565656565656565656565656565656565656
565656565656565656565656565656565656565656565656565656565656565656565656
56565656565656
243A444D4E5353565658585B5B5B5D5D5D5D5D5D5D5D5D5D5B5B5B585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
585858585858585858585858585858585858585858581F1F585858585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
58585858585858
243A444D53535358585B5B5B5D5D6060606060605D5D5D5D5D5B5B5B5B5B5B5B5B5B5B5B
5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B
5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B
5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5BFAFA1F5B5B5B5B5B5B5B5B5B5B5B5B
5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B
5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B58
585858585858585858585858585858585858585858585858585858585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
58585858585858
243A444D53535658585B5B5D5D5D60606060605D5D5D5D5D5B5B5B5B5858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
585858585858585858585858585858585858585858FAFA1F585858585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
58585858585858
273A444D5153568888888888888892888888888888885B5B5B58581F1F58521F52581F1F
5858431F46431F4F584C1F1F58581F1F58581F1F5858472E1F3452581F1F58581F1F5858
1F1F5858431F46431F4F584C1F1F58581F1F585847341F34525858431F46431F4F585858
581F1F585858581F1F5858472E1F345258584F2E49FAFA1F341F435858585858581F1F1F
1F2E435858581F1F58585858431F1F46585858501F5258521F5058584C1F1F3852585847
2E1F345258581F1F58585858585858585858585858585858585858585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
585858585858585858585858585858585858585858585858585858585858585858585858
585858585858585656565656565656565656565656565656565656565656565656565656
565656565656565656565656565656565656565656565656565656565656565656565656
56565656565656
2A3A434D51538888A8EAEAEAEACD77FAFAFAFAFAFA8858585856FAFA1FA5FA8644FAFA3B
56D5FAD3D8FAA250BFFAFA5656FAFA1F56FAFA1F56C9F2FAEE8F44FAFA1F56FAFA1F56FA
FA1F56D5FAD3D8FAA250BFFAFA5656FAFA1F56C9EBFAEE984456D5FAD3D8FAA250565656
FAFA1F565656FAFA1F56C9F2FAEE8F4456B8F2B656FAFAEBFAD81F4056565656FAFAFAFA
F3D51F3E56FAFA1F565656D6FAFAD11F4456AEFA8644A5FA954056BFFAFAEA862B56C9F2
FAEE8F4456FAFA1F56565656565656565656565656565656565656565656565656565656
565656565656565656565656565656565656565656565656565656565656565656565656
565656565656565656565656565656565656565656565656565656565656565656565656
565656565656565656565656565656565656565656565656565656565656565656565656
565656565656565656565656565656565656565656565656565656565656565656565656
565656565656565656565656565656565656565656565656565656565656565656565656
565656565656565454545454545454545454545454545454545454545454545454545454
545454545454545454545454545454545454545454545454545454545454545454545454
54545454545454
2A3A414951515388EAEAF0EAEADF77FAFAAAD4FAFA8856565656E5FA1FD4FAC732FADE38
D9FA86C6FAFA8654F3FA1F5454FAFA1F54FAFA1FCDFAC0C6F3D454FAFA1F54FAFA1F54FA
FA1FD9FA86C6FAFA8654F3FA1F5454FAFA1FCDFAC054E0D454D9FA86C6FAFA8654545454
FAFA1F545454FAFA1FCDFAC0C6F3D45454F3FA1F54FAFA1FC6FACF2B54545454FAFA1F54
D9FAD61F54FAFA1F5454D4FAABC6FAC72B54D8FAC72BD4FACF1F4EE5D454FAF22BCDFAC0
C6F3D45454FAFA1F54545454545454545454545454545454545454545454545454545454
545454545454545454545454545454545454545454545454545454545454545454545454
545454545454545454545454545454545454545454545454545454545454545454545454
545454545454545454545454545454545454545454545454545454545454545454545454
545454545454545454545454545454545454545454545454545454545454545454545454
545454545454545454545454545454545454545454545454545454545454545454545454
545454545454545454545454545454545454545454545454545454545454545454545454
545454545454545454545454545454545454545454545454545454545454545454545454
54545454545454
273A414B5051518888EA775882DFA4A6AF58FAFAFA8853535353E4FA1FEEFAEE1FFADE44
FAFA1F47FAFA1F53FAFA1F5353FAFA1F53FAFA1FF2FA1F1F1F1F1FFAFA1F53FAFA1F53FA
FA1FFAFA1F47FAFA1F53FAFA1F5353FAFA1FF2FA1F53535353FAFA1F47FAFA1F53535353
FAFA1F535353FAFA1FF2FA1F1F1F1F1F53FAFA1F53FAFA1F53FAF21F53535353FAFA1F53
53FAFA1F53FAFA1F5353F2FA1F53FAF21F93FAFAF21FF2FAFA7744534CBCFAF24CF2FA1F
1F1F1F1F53FAFA1F5353535353535353535353535353535353535353535353535353534E
4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E
4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E
4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E
4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E
4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E
4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E
4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E
4E4E4E4E4E4E4E
273B414A4D508888EAEAEA3777DFC39658587CA0C39253534E4ECCFA86FAB2FA8FFAC03F
E4FAB529FAFA1F4EFAFA1F4E4EFAFA1F4EFAFA1FFAFAFAFAFAFA29FAFA1F4EFAFA1F4EFA
FA1FE4FAB529FAFA1F4EFAFA1F4E4EFAFA1FFAFA1F4E4E4E4EE4FAB529FAFA1F4E4E4E4E
FAFA1F4E4E4EFAFA1FFAFAFAFAFAFA294EFAFA1F4EFAFA1F4EFAFA294E4E4E4EFAFA1F4E
4EFAFA384EFAFA1F4E4EFAFA1F4EFAFA29CCFAD2FAD2FAD2FAC3299FEEFADD9F4EFAFAFA
FAFAFA294EFAFA1F4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E
4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E
4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E
4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E
4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E
4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E
4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E
4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E4E
4E4E4E4E4E4E4E
293941484D505288A0E4E4C3C3C3C3C39696C3C3FA88534E4E4DCCFAC7EE3EEECEFAC047
4DD8F2FAFAFA324DFAFA1F4D4DFAFA1F47FAFA32F2FA1F41FAF23BFAFA1F44FAFA1F47FA
FA2F4DD8F2FAFAFA324DFAFA1F4D4DFAFA1FEEFA1F3E4D383E4DD8F2FAFAFA324D4D4D4D
FAFA1F1F1F1FFAFA1FF2FA1F41FAF23B4DFAFA1F4DFAFA1F4DFAF23B4D4D4D4DFAFA1F1F
C0FAD6444DFAFA1F4444F2FA1F44FAF23EF2F23EF2FAF23EF2F21FEEFA954A3241F2FA1F
41FAF23B4DFAFA1F44444D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D
4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D
4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D
4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D
4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D
4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D
4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D
4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D
4D4D4D4D4D4D4D
293941484B4D50886E77A4DFC3A4A49658C3EAFAFA885050504DABFAEBC747D3EEFA9547
4D4D2F86FAE6474DFAFA1F1F4DFAFA86A1FAE647D8FABCA2FAD54DFAFAB88FFAFA9B92FA
EE474D4D2F86FAE6474DFAFA1F1F4DFAFA1FCCFACE2FD6C3444D4D2F86FAE6474D4D4D4D
FAFAFAFAFAFAFAFA1FD8FABCA2FAD54D4DFAFA1F4DFAFA1FBAFAD54D4D4D4D4DFAFAFAFA
FAFAAB2F4DFAFAABAC2FD3FAB5A2FACEBCFAC747D3FAC747D3FAABF2FA81E6BA47D8FABC
A2FAD54D4DFAFAABAC2F4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4B
4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B
4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B
4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B
4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B
4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B
4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B
4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B
4B4B4B4B4B4B4B
22353D484C4D8888B8EABF96C3C3A47777C3EAFAFA8850504D4DABFAFA8F4B9EFAFA954B
4BEEFAFAE49E4BFAFAFAFA4B4BFAFADEFAEE9E4B4BD8FAFAD84B4BFACCEEFAE4ABE4FAEE
9E4B4BEEFAFAE49E4BFAFAFAFA4BFAFAFA4B4BCCEEFAEEB24B4BEEFAFAE49E4B4B4B4B4B
FAFA1F4B4B4BFAFA1F4BD8FAFAD84B4B4BFAFA1F4BFAFAEEFAE44B4B4B4B4B4BFAFA1F4B
CCFAEB1F4BFAFAD8EE4B4BD8FAFAD84BE9FA9E4B9EFA9E4B9EFAE9B2E9FAEE9E4B4BD8FA
FAD84B4B4BFAFAD8EE4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B
4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B
4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B
4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B
4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B
4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B
4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B
4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B4B
4B4B4B4B4B4B4B
22353D42484A4D88A8EAD477C396775877C3C3C3C39B50504D4D4CFAEB3B4A4AEEFA1F4A
4A4A4A4A4A4A4A4AFAFA2E4A4AFAFA1F4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4AFAFA2E4A4A4A31314A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
FAFA1F4A4A4AFAFA1F4A4A4A4A4A4A4A4AFAFA1F4A4A4A4A4A4A4A4A4A4A4A4AFAFA1F4A
4AFAFA344A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A
22353D424A4A4D88EACD96779677775833A4A4FAFA924D4D4D4C4CFACE444A4AD1FA344A
4A4A4A4A4A4A4A4AD1EE4A4A4AFAFA284A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4AD1EE4A4A4AE9E6314A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
FAFA1F4A4A4AFAFA1F4A4A4A4A4A4A4A4AFAFA284A4A4A4A4A4A4A4A4A4A4A4AFAFA1F1F
B6FAE24A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A
22353842484A888872A4EAD4A4C3C3A47777AAFAFA884C4C4C4C4AE49E4A4A4A9EE44A4A
4A4A4A4A4A4A4A4A4A4A4A4A4AE4F24A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4AE9E94A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
FAFA4A4A4A4AFAFA4A4A4A4A4A4A4A4A4AE4F24A4A4A4A4A4A4A4A4A4A4A4A4AFAFAFAFA
EED84A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4848484848484848484848484848484848484848484848484848484848
484848484848484848484848484848484848484848484848484848484848484848484848
48484848484848
21313A42484A4C88DAEAEAD4C3F0D4A4D4D4A4FAFA884C4C4C4C4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A
21313A42484A4C8898EAEAA4F0FAD4A4FAFAD9C8FA884C4C4C4C4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A
2131393F474C8888EAEAF5EAFAFAFAA4FAFAFAFAFA884C4C4C4C4C4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4848484848484848484848484848484848484848484848484848484848
484848484848484848484848484848484848484848484848484848484848484848484848
48484848484848
2131393F47474C8888888888888888928888888888884C4C4C4C4C4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4848484848484848484848484848484848484848484848484848484848
484848484848484848484848484848484848484848484848484848484848484848484848
48484848484848
27313C4447474C4C4F5252545454545454525252504F4F4C4C4C4C4C4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A4A
4A4A4A4A4A4A4A4848484848484848484848484848484848484848484848484848484848
484848484848484848484848484848484848484848484848484848484848484848484848
48484848484848
31313C4447474C4C4F52525454545454545454545452525050504C4C4C4C4C4C4C4C4C4C
4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C
4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C
4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C
4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C
4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C
4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C
4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C
4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C
4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C
4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C
4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C
4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C4C
4C4C4C4C4C4C4C
3142404747474C4C4F525254545454585858585454545454525252505050505050505050
505050505050505050505050505050505050505050505050505050505050505050505050
505050505050505050505050505050505050505050505050505050505050505050505050
505050505050505050505050505050505050505050505050505050505050505050505050
505050505050505050505050505050505050505050505050505050505050505050505050
505050505050505050505050505050505050505050505050505050505050505050505050
505050505050505050505050505050505050505050505050505050505050505050505050
505050505050505050505050505050505050505050505050505050505050505050505050
505050505050505050505050505050505050505050505050505050505050505050505050
505050505050505050505050505050505050505050505050505050505050505050505050
505050505050505050505050505050505050505050505050505050505050505050505050
505050505050505050505050505050505050505050505050505050505050505050505050
505050505050505050505050505050505050505050505050505050505050505050505050
50505050505050
D03C404C4C4C4C4F5254545A5A5A5A5A5A5A5A5A5A5A5A5A585858585555555555555555
555555555555555555555555555555555555555555555555555555555555555555555555
555555555555555555555555555555555555555555555555555555555555555555555555
555555555555555555555555555555555555555555555555555555555555555555555555
555555555555555555555555555555555555555555555555555555555555555555555555
555555555555555555555555555555555555555555555555555555555555555555555555
555555555555555555555555555555555555555555555555555555555555555555555555
555555555555555555555555555555555555555555555555555555555555555555555555
555555555555555555555555555555555555555555555555555555555555555555555555
555555555555555555555555555555555555555555555555555555555555555555555555
555555555555555555555555555555555555555555555555555555555555555555555555
555555555555555555555555555555555555555555555555555555555555555555555555
555555555555555555555555555555555555555555555555555555555555555555555555
55555555555555
D03C484754545454545A5A5B605D5D5D605D60605D5D605D5D605D5D5D5D5D5D5D5D5D5D
5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D
5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D
5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D
5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D
5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D
5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D
5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D
5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D
5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D
5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D5D
5D5D5D5D5D5D5D5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B
5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B5B
5B5B5B5B5B5B5B
D0D04450555A6067676E6E7575777C7C7C7C8181817C7C7C7C7C7C7C7C7C7C7C7C7C7C7C
7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C
7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C
7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C
7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C
7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C
7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C
7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C
7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C
7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C
7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C
7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C
7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C7C
7C7C7C7C7C7C7C
D0D0D04444555D676E6E73777C8181818383838383838383838383838383838383838383
838383838383838383838383838383838383838383838383838383838383838383838383
838383838383838383838383838383838383838383838383838383838383838383838383
838383838383838383838383838383838383838383838383838383838383838383838383
838383838383838383838383838383838383838383838383838383838383838383838383
838383838383838383838383838383838383838383838383838383838383838383838383
838383838383838383838383838383838383838383838383838383838383838383838383
838383838383838383838383838383838383838383838383838383838383838383838383
838383838383838383838383838383838383838383838383838383838383838383838383
838383838383838383838383838383838383838383838383838383838383838383838383
838383838383838383838383838383838383838383838383838383838383838383838383
838383838383838383838383838383838383838383838383838383838383838383838383
838383838383838383838383838383838383838383838383838383838383838383838383
83838383838383
A6A6A6A6A64044443F3F42424248484C4F4C4F52504C50505050504D4D4D4D4D4D4D4D4D
4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D
4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D
4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D
4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D
4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D
4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D
4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D
4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D
4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D
4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D
4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D
4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D4D
4D4D4D4D4D4D4D
pop
P
% End of image
% End of Graphics
MathPictureEnd
\
\>"], "Text",
  ImageSize->{475, 227},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007K0000ha000`40O003h00Oogoog7oo00001124
6<H]JbDYogoof7oo000011246<H]JbDYogoof7oo000011246<H]JbDYogoof7oo000011246<H]JbDY
ogoof7oo00001A246<H]JbDYBU80ocF]eCF]0Woo00001A246<H]JbDYBU80og>LeG>L0Woo00001A24
6<H]JbDYBU80og>LeG>L0Woo00001A246<H]JbDYBU80og>LeG>L0Woo00001A246<H]JbDYBU80og>L
eG>L0Woo00001Q246<H]JbDYBU9ooomkg]AkgP9oo`0000@@Q1S6;F/U:IQ:DP9kgYQ:DP9kgYQ:DP9k
gPM:DP9oo`0000D@Q1S6;F/U:DYB09Ioo`04BU9kgW_NBU:FOol014YBNmikgTYBUWoo00A:DW_NNmi:
DPQoo`0000D@Q1S6;F/U:DYB08Aoo`9g_@03G_MF]E:D009>L`=:DPA>L`05E[Eg_GNmOom:DP02Nmh0
0dYBOomoo`2DOol014YBNmikgTYB0goo00D007ooOomoo`00009oo`05001oogooOol00002Ool01000
Oomoo`000goo00<007oo00000goo00L007ooOomoo`00Ool00003Ool00`00Ool00003Ool00`00Ool0
0003Ool00`00Ool00003Ool00`00Oomoo`17Ool2Mkd00ekgE[EBU002CW<3BU84CW<01EJeMkeg_Goo
BU800W_N00=:DWooOol01Woo00001A246<H]JbDYBU80Q7oo00=g_FLiOol037oo00ANmgNmOom:DP9k
gP03BU9oogoo09Aoo`04BU9kgW_NBU83Ool01@00Oomoogoo00000Woo00<007ooOol017oo00@007oo
Ool000Eoo`05001oogooOol00005Ool01`00Oomoogoo001oo`0000Eoo`03001oogoo00Ioo`03001o
ogoo049oo`03001oogoo00=oo`03MkeW>Goo00aoo`04G_Mg_GooBU82Nmh00dYBOomoo`06Ool00005
48@HaRe[9BU:DP24Ool017NmOomcW6<H1FLi1F<H00E_NgooG_MoodYB009kgP03BU9oogoo09Aoo`04
BU9kgW_NBU83Ool01000Oomoo`000goo1@000Woo00<007ooOol01@0000=oo`00Ool00Woo1@0000=o
o`00Ool00Woo00<007oo00001Goo1@000Woo0P00AGoo0P0017oo00Ag_GooLiaS60EW>@ES6005Kg]o
oekgOom:DP02Nmh00dYBOomoo`06Ool0000548@HaRe[9BU:DP24Ool017NmOomNmf<H1fLi16<H00Ao
oe[FOom:DP9kgP03BU9oogoo09Aoo`04BU9kgW_NBU83Ool50002Ool01@00Oomoogoo00000Woo00@0
07ooOol000=oo`04001oo`000002Ool01`00Oomoogoo001oo`0000=oo`03001oo`0000=oo`03001o
o`0000=oo`03001oo`0000=oo`03001oogoo045oo`<000=oo`04MkeooekgHaP7IcT4HaP017ooF]Io
odYB0W_N00=:DWooOol01Woo00001Q246<H]JbDYBU9ooh<aS003Mkeooekg009W>@03JeYW>FLi00AW
>@=S6004OomF]GooBU82Nmh00dYBOomoo`2DOol014YBNmikgTYB0goo00<007ooOol00Woo00<007oo
Ool00`000Woo0`000Woo0`000Woo00<007oo00000Woo0`000Woo10000goo0`000goo0`000goo0`00
A7oo0P0017oo00=g_GooG_L00VLi00=[FVLiIcT016Li0f<H00AooeJeOom:DP9kgP03BU9oogoo00Io
o`0000H@Q1S6;F/U:DYBOon3<H`017NmOomNmfLi16]J00@]Jf]JIcUW>@=S6004OomF]GooBU82Nmh0
0dYBOomoo`2DOol014YBNmikgTYB0goo00<007ooOol00Woo00<007ooOol01Woo00<007ooOol0JWoo
00<007ooOol00goo00Ag_GooG_MW>@A[FP04;F][FVLiIcT3HaP017ooE[EoodYB0W_N00=:DWooOol0
1Woo00001Q246<H]JbDYBU9ooh<aS003Mkeoof<H00A[FP<]J`=W>@9S6004OomF]GooBU82Nmh00dYB
Oomoo`2DOol014YBNmikgTYB0goo1@002Woo00<007ooOol0Kgoo00=g_GooHaP016]J0be[0fLi0V<H
00AooeJeOom:DP9kgP03BU9oogoo00Ioo`0000H@Q1S6;F/U:DYBOol3<H`2Ool0136<OolaS36<0Woo
00@aS7oo<Haoo`8aS004OolaS36<Ool2<H`2Ool00c6<OolaS002Ool00c6<OolaS002<H`00goo<H`a
S01M<H`00gNmOomS6003JeX5;F/3IcT01F<HOomF]GooBU800W_N00=:DWooOol0U7oo00A:DW_NNmi:
DXAoo`03Mkeoof<H00=[FPD]J`=W>@05HaQooeJeOom:DP02Nmh00dYBOomoo`06Ool0000648@HaRe[
9BU:DWoo0S6<00=ooc6<<H`00Woo00@aS7oo<H`aS09oo`05<Haooc6<<Haoo`02<H`00goo<Haoo`02
<H`2Ool01C6<OolaS36<Ool00c6<00=ooc6<<H`0GC6<00=g_GooHaP00V]J0be[00A[FRe[;F/]J`=W
>@04OomJeWooBU82Nmh00dYBOomoo`2DOol014YBNmikgTYBQ7oo00=g_GooHaP00V]J0be[00A[FRe[
;F/]J`=W>@04OomJeWooBU82Nmh00dYBOomoo`06Ool0000648@HaRe[9BU:DWoo0S6<00Mooc6<<H`a
S7oo<Haoo`03<H`02goo<Haooc6<OolaS7oo<Haooc6<Ool00c6<00=ooc6<Ool00S6<00Eooc6<<H`a
S7oo05TaS003OolaS36<00<aS004MkeoofLiJeX3;F/2JeX016Li;F/]Jbe[0VLi00Aooe[FOom:DP9k
gP03BU9oogoo09Aoo`04BU9kgW_NBU:4Ool017NmOomW>F]J0be[0V]J00AW>Be[;F/]J`9W>@04OomJ
eWooBU82Nmh00dYBOomoo`06Ool0000648@HaRe[9BU:DWoo0c6<17oo00<aS7oo<H`00S6<00Uooc6<
OolaS7oo<Haooc6<Ool00S6<17oo00DaS7oo<H`aS7oo00<aS003OolaS36<05LaS09oo`@aS003Mkeo
ofLi009[FP03;F][FV]J00=W>@08;F]W>FLiIcUooe[FOom:DP9kgP03BU9oogoo09Aoo`04BU9kgW_N
BU:4Ool00gNmOomW>@02JeX00be[JeY[FP03IcT022e[IcUW>FLiOomJeWooBU82Nmh00dYBOomoo`06
Ool0000648@HaRe[9BU:DWoo0S6<00Mooc6<<H`aS7oo<Haoo`02<H`2Ool02S6<OolaS7oo<Haooc6<
OolaS7oo0c6<00=ooc6<Ool00S6<0Woo0S6<00=ooc6<<H`0Ec6<0goo0c6<00=g_GooIcT00Vmk16]J
1VLi00Aooe[FOom:DP9kgP03BU9oogoo09Aoo`04BU9kgW_NBU8=Ool00`00Oomoo`1dOol00gNmOomW
>@02Kg/4JeX6IcT017ooF]IoodYB0W_N00=:DWooOol01Woo00001Q246<H]JbDYBU9oo`<aS0=oo`<a
S09oo`03<Haooc6<009oo`<aS09oo`8aS0=oo`07<HaoogooOolaS7oo<H`00WooFS6<0Woo136<00=g
_GooJeX00Vmk16]J1VLi00AooekgOom:DP9kgP03BU9oogoo09Aoo`04BU9oogooBU8=Ool00`00Oomo
o`1dOol00gNmOom[FP02Kg/4JeX6IcT017ooG_MoodYB0Woo00=:DWooOol01Woo00001Q246<H]JbDY
BU9oo``aS004OolaS7ooOol3<H`2Ool7<H`017oo<H`aS7ooGC6<00=ooc6<<H`00c6<00=g_GooJeX0
0W>L00=_Nf]JJeX016]J0fLi00Aoof<HOom:DP9kgP03BU9oogoo09Aoo`04BU9oogooBU83Ool00`00
Ool00002Ool01`00Oomoo`00Ool007oo0080009oo`03001oogoo00<0009oo`04001oogoo0002Ool0
0`00Oomoo`030002Ool01P00Oomoogoo001oo`80009oo`800003Ool007oo00800004Ool007ooOol3
0002Ool01@00Oomoogoo000017oo00D007ooOomoo`00009oo`<0009oo`80009oo`<000=oo`<001mo
o`03Mkeoof]J009cW003Kg][FV]J00A[FP=W>@04OomS67ooBU82Ool00dYBOomoo`06Ool0000648@H
aRe[9BU:DWoo336<00=ooc6<Ool01C6<00=ooc6<<H`01C6<00Aooc6<<Haoof<aS003Mkeoofmk009c
W0=_N`E[FP9W>@04Oom[FWooBU82Nmh00dYBOomoo`2DOol014YBOomoodYB0goo00<007oo00000Woo
00D007ooOol007oo0080009oo`05001oo`00Ool00003Ool00`00Ool00002Ool01P00Oomoo`00Ool0
00=oo`03001oo`0000=oo`03001oo`00009oo`03001oogoo00800007Ool007ooOol007oo00000goo
00<007oo00000goo00<007ooOol00Woo00L007ooOomoo`00Ool00003Ool00`00Ool00002Ool01`00
Oomoogoo001oo`0000=oo`03001oogoo01aoo`03Mkeoofmk009cW0=_N`E[FP9W>@04Oom[FWooBU82
Ool00dYBOomoo`06Ool0000648@HaRe[9BU:DWooPc6<00Eg_GooMke_Nf]J00EW>@AS6005Liaoofmk
Oom:DP02Nmh00dYBOomoo`2DOol014YBOomoodYB0goo00<007oo00000Woo00H007ooOol007oo0003
Ool01@00Ool007oo00001Goo00@007ooOol0009oo`03001oo`0000Eoo`07001oogooOol007oo0000
0Woo00L007ooOomoo`00Ool00002Ool00`00Ool00003Ool00`00Ool00003Ool00`00Oomoo`02Ool0
1`00Oomoogoo001oo`0000=oo`03001oo`00009oo`03001oogoo00Ioo`03001oogoo01Moo`03001o
ogoo00=oo`05MkeoogNmKg][FP05IcT4HaP01G>LOom_NgooBU800Woo00=:DWooOol01Woo00001Q24
6<H]JbDYBU9ooh<aS003Mkeoogoo00eoo`03MkeoodYB009kgP03BU9oogoo09Aoo`04BU9oogooBU83
Ool00`00Ool00002Ool01P00Oomoo`00Ool000=oo`04001oo`00Ool500001Goo001oogoo00000Woo
00<007oo0000100000=oo`00Ool00Woo00<007oo00000goo100000Moo`00Oomoo`00Ool00003Ool0
0`00Ool00003Ool00`00Oomoo`02Ool01`00Oomoogoo001oo`0000=oo`03001oo`00009oo`D0009o
o`8001Yoo`8000Aoo`03Mkeoogoo00eoo`03MkeoodYB009oo`03BU9oogoo00Ioo`0000H@Q1S6;F/U
:DYBOon3<H`2Mkd00eJeCW=:DP07BU82CW<01EJeMkeg_GooBU800W_N00=:DWooOol0U7oo00A:DWoo
Oom:DP=oo`06001oo`00001oo`000Woo00@007oo0000009oo`05001oo`00Ool00003Ool01P00Ool0
0000Ool0009oo`03001oo`0000=oo`03001oo`0000=oo`03001oo`00009oo`07001oogooOol007oo
00000Woo00<007oo00000goo00<007oo00000goo00<007ooOol00Woo00L007ooOomoo`00Ool00003
Ool00`00Ool00002Ool01`00Oomoogoo001oo`0000=oo`03001oogoo01Ioo`<000=oo`Ag_@EkgPMo
o`03MkeoodYB009oo`03BU9oogoo00Ioo`0000D@Q1S6;F/U:DYB08Aoo`03MkeJeWoo00aoo`04G_Mg
_GooBU82Nmh00dYBOomoo`2DOol014YBOomoodYB0goo00@007oo001oo`@0009oo`04001oo`000002
Ool00`00Oomoo`030002Ool00`00Ool000030003Ool30002Ool4000017oo000000000Woo0`0000Io
o`00000007oo0002Ool30002Ool40005Ool40003Ool3000017oo000000000Woo0`000goo0`006Goo
0P0017oo17Nm1G_N1goo00=g_GooBU800Woo00=:DWooOol01Woo00001A246<H]JbDYBU8097oo1000
G7oo00Ag_GooLiaS60MW>@=S6005Kg]ooekgOom:DP02Ool00dYBOomoo`2DOol014YBOomoodYB0goo
00<007ooOol03Goo00<007ooOol06Goo00<007ooOol01Woo00<007ooOol07Goo00<007ooOol08goo
00<007ooOol00goo17Nm1G_N1goo00=g_GooBU800Woo00=:DWooOol01Woo00001A246<H]JbDYBU80
:7oo00<007ooOol0FGoo00=g_GooIcT026]J16Li00AooeJeOom:DP9oo`03BU9oogoo09Aoo`04BU9o
ogooBU83Ool00`00Oomoo`0=Ool00`00Oomoo`0IOol00`00Oomoo`06Ool01000Oomoo`0077oo00<0
07ooOol0:Goo17Nm1G_N1goo00=g_GooBU800Woo00=:DWooOol01Woo00001A246<H]JbDYBU8017oo
00<007ooOol00goo00@007ooOomoo`<0009oo`05001oogooOol00002Ool01@00Ool007oo00000goo
00<007ooOol00P0000=oo`00Ool01Goo00D007ooOomoo`0000=oo`06001oo`00001oo`000goo00<0
07ooOol00Woo00<007ooOol00goo00<007ooOol00P0000Aoo`00Oomoo`800003Ool007oo00Eoo`<0
009oo`05001oogooOol00002Ool3000GOol00gNmOomS6008JeX3IcT01F<HOomF]GooBU800Woo00=:
DWooOol0U7oo00A:DWooOom:DXAoo`Ag_@EkgPMoo`03MkeoodYB009oo`03BU9oogoo00Ioo`0000D@
Q1S6;F/U:DYB00Aoo`03001oogoo00=oo`04001oogoo0003Ool00`00Ool00003Ool00`00Ool00002
Ool00`00Ool00003Ool00`00Ool00002Ool20006Ool01@00Oomoogoo00000goo00<007oo00000Woo
00D007ooOomoo`0000Aoo`03001oogoo00=oo`03001oo`00009oo`800004Ool007ooOol20005Ool0
1`00Oomoogoo001oo`0000=oo`03001oo`0000=oo`03001oogoo01Aoo`03Mkeoof<H00Q[FPAW>@04
OomF]GooBU82Ool00dYBOomoo`2DOol014YBOomoodYBQ7oo17Nm1G_N1goo00=g_GooBU800Woo00=:
DWooOol01Woo00001A246<H]JbDYBU800goo00<007oo00000goo00D007oo001oo`0000=oo`03001o
o`0000=oo`03001oo`00009oo`03001oo`0000=oo`03001oo`0000=oo`03001oogoo00=oo`07001o
o`00Ool007oo00000Woo00<007oo00000Woo00D007ooOomoo`0000Eoo`D0009oo`07001oogooOol0
07oo00000goo00<007oo00000P0000=oo`00Ool00Woo00<007oo00000goo00<007ooOol00Woo00<0
07ooOol03goo00<007ooOol00goo00=g_GooHaP026]J16Li00AooeJeOom:DP9oo`03BU9oogoo09Ao
o`04BU9oogooBU:4Ool4Mkd5Nmh7Ool00gNmOom:DP02Ool00dYBOomoo`06Ool0000548@HaRe[9BU:
DP03Ool00`00Ool00003Ool01@00Ool007oo00000goo00<007oo00000goo0P000goo00<007oo0000
0goo00<007oo00000goo00<007ooOol00goo00L007oo001oo`00Ool00002Ool00`00Ool00002Ool0
1@00Oomoogoo00001Goo00D007ooOomoo`00009oo`07001oogooOol007oo00000goo00<007ooOol0
0goo00L007ooOomoo`00Ool00003Ool00`00Oomoo`02000BOol20004Ool00gNmOomW>@08JeX4IcT0
17ooE[EoodYB0Woo00=:DWooOol0U7oo00A:DWooOom:DXAoo`Ag_@EkgPMoo`03MkeoodYB009oo`03
BU9oogoo00Ioo`0000D@Q1S6;F/U:DYB00=oo`06001oogoo001oo`000Woo00<007oo00000goo00@0
07oo0000009oo`03001oo`00009oo`03001oo`0000=oo`03001oo`00009oo`8000Aoo`06001oogoo
001oo`000Woo00D007oo001oo`00009oo`80009oo`03001oogoo00Aoo`03001oo`0000=oo`03001o
ogoo00800004Ool007ooOol20005Ool01`00Oomoogoo001oo`0000=oo`03001oo`0000=oo`03001o
ogoo00ioo`<000=oo`03MkeoofLi00Q[FPAW>@04OomF]GooBU82Ool00dYBOomoo`2DOol014YBOomo
odYBQ7oo17Nm1G_N1goo00=g_GooBU800Woo00=:DWooOol01Woo00001A246<H]JbDYBU800goo00H0
07ooOol007oo0002Ool00`00Oomoo`030002Ool01@00Ool007oo00000Woo00@007oo001oo`@000=o
o`800003Ool007oo00=oo`05001oogooOol00003Ool00`00Ool0000300000goo001oo`020007Ool0
0`00Ool00004Ool2000017oo001oogoo0P0000=oo`00Ool01Goo0`000Woo10000goo0`004Goo0P00
17oo00=g_GooHaP026]J0fLi00ES67ooE[EoodYB009oo`03BU9oogoo09Aoo`04BU9oogooBU:4Ool2
Mkd00eJeCW=:DP07BU82CW<01EJeMkeg_GooBU800Woo00=:DWooOol01Woo00001A246<H]JbDYBU80
0Woo00L007ooOomoo`00Ool00003Ool00`00Oomoo`08Ool00`00Oomoo`0OOol01000Oomoo`002Woo
00<007oo00001goo00<007ooOol00goo00<007ooOol097oo00<007ooOol00goo00=g_GooHaP026]J
0fLi00ES67ooE[EoodYB009oo`03BU9oogoo09Aoo`04BU9oogooBU83Ool00`00Oomoo`03Ool00`00
Oomoo`0200000goo001oo`02Ool00`00Oomoo`02Ool2000017oo001oo`000goo00<007ooOol00`00
0goo0`000goo0`001Woo00@007ooOomoo`<000=oo`800003Ool007oo0080009oo`800004Ool007oo
0004Ool30003Ool3000UOol00gNmF]Ioo`0<Ool015kgMkeoodYB0Woo00=:DWooOol01Woo00001A24
6<H]JbDYBU800Woo00<007ooOol00Woo00<007ooOol00Woo00<007ooOol027oo00<007ooOol00Woo
00<007ooOol067oo00<007oo00000Woo00<007ooOol02Goo00<007ooOol01Woo00<007ooOol00goo
00<007ooOol0:Woo00=g_GooHaP026]J0fLi00ES67ooE[EoodYB009oo`03BU9oogoo09Aoo`04BU9o
ogooBU83Ool00`00Oomoo`03Ool00`00Ool00002Ool20003Ool01@00Oomoogoo00000Woo0P0000=o
o`00Ool00Woo00<007oo00000goo00<007oo00000goo00<007oo00000goo00<007ooOol00goo00@0
07ooOol000=oo`03001oo`00009oo`800005Ool007ooOol00002Ool200000goo001oo`02Ool01`00
Oomoogoo001oo`0000=oo`03001oogoo029oo`04Mkeoog>LHaP7IcT3HaP01FmkOomNmgooBU800Woo
00=:DWooOol01Woo00001A246<H]JbDYBU80Q7oo00=g_GooHaP026]J16Li00AooeJeOom:DP9oo`03
BU9oogoo09Aoo`04BU9oogooBU84Ool50002Ool01@00Oomoogoo00000Woo00<007oo00000Woo00L0
07ooOomoo`00Ool00003Ool00`00Ool00005Ool00`00Oomoo`06Ool00`00Oomoo`04Ool01000Oomo
o`001Goo00L007ooOomoo`00Ool00002Ool01`00Oomoogoo001oo`0000=oo`03001oogoo00Ioo`03
001oogoo01eoo`03001oogoo00=oo`03MkeoofLi00Q[FPAW>@04OomF]GooBU82Ool00dYBOomoo`06
Ool0000548@HaRe[9BU:DP24Ool00gNmOomS6008JeX4IcT017ooE[EoodYB0Woo00=:DWooOol0U7oo
00A:DWooOom:DPAoo`05001oogooOol00002Ool01@00Oomoogoo00000Woo00<007oo00000goo1000
00=oo`00Ool00Woo00<007oo00001Goo1@000Woo0P001goo00<007ooOol01@000Woo100000Eoo`00
Oomoo`0000=oo`03001oo`0000=oo`D0009oo`80021oo`8000Aoo`03Mkeoof<H00Q[FP=W>@05HaQo
oeJeOom:DP02Ool00dYBOomoo`06Ool0000548@HaRe[9BU:DP24Ool00gNmOomW>@08JeX4IcT017oo
E[EoodYB0Woo00=:DWooOol0U7oo00A:DWooOom:DPEoo`03001oo`0000=oo`03001oogoo00800003
Ool007oo009oo`03001oo`0000=oo`03001oo`0000=oo`03001oo`0000=oo`03001oo`0000=oo`03
001oo`0000=oo`03001oogoo00=oo`04001oogoo0003Ool00`00Ool00003Ool00`00Ool00002Ool0
1P00Oomoogoo001oo`80009oo`07001oogooOol007oo00000goo00<007ooOol077oo0`000goo00=g
_GooHaP026]J16Li00AooeJeOom:DP9oo`03BU9oogoo00Ioo`0000D@Q1S6;F/U:DYB08Aoo`03Mkeo
ofLi00=[FPIF]@=W>@04OomF]GooBU82Ool00dYBOomoo`2DOol014YBOomoodYB1Goo00<007oo0000
17oo0P0000Aoo`00Ool000=oo`03001oogoo00<0009oo`@000=oo`<000=oo`<000=oo`<000Eoo`<0
009oo`<000=oo`<00006Ool00000001oo`000goo00D007oo001oo`00009oo`<000=oo`<001moo`80
00Aoo`03Mkeoof<H00Q[FPAW>@04OomF]GooBU82Ool00dYBOomoo`06Ool0000548@HaRe[9BU:DP02
Oon1DY@017ooMkeoof<H0V]J1W_N0fLi00ES67ooE[EoodYB009oo`03BU9oogoo09Aoo`04BU9oogoo
BU85Ool00`00Ool00007Ool00`00Oomoo`0WOol00`00Oomoo`0<Ool00`00Oomoo`0cOol00`00Oomo
o`03Ool00gNmOomS6008JeX4IcT017ooE[EoodYB0Woo00=:DWooOol01Woo00001A246<H]JbDYBU80
Q7oo00=g_GooHaP00f]J1UJe0VLi00ES67ooE[EoodYB009oo`03BU9oogoo09Aoo`04BU9oogooBU86
Ool00`00Oomoo`06Ool00`00Oomoo`0XOol00`00Oomoo`0;Ool00`00Oomoo`0iOol00gNmOomW>@08
JeX4IcT017ooE[EoodYB0Woo00=:DWooOol01Woo00001A246<H]JbDYBU80Q7oo00=g_GooHaP00V]J
1W_N16Li00AooeJeOom:DP9oo`03BU9oogoo09Aoo`04BU9oogooBU:4Ool00gNmOomW>@08JeX4IcT0
17ooE[EoodYB0Woo00=:DWooOol01Woo00001A246<H]JbDYBU80Q7oo00=g_GooHaP00f]J1UJe0fLi
00AooeJeOom:DP9oo`03BU9oogoo09Aoo`04BU9oogooBU:4Ool00gNmOomW>@08JeX4IcT017ooE[Eo
odYB0Woo00=:DWooOol01Woo00001A246<H]JbDYBU80Q7oo00=g_GooHaP00V]J1W_N16Li00AooeJe
Oom:DP9oo`03BU9oogoo09Aoo`04BU9oogooBU:4Ool00gNmOomW>@08JeX4IcT017ooE[EoodYB0Woo
00=:DWooOol01Woo00001A246<H]JbDYBU8017oo00<007oo000017oo00<007oo000010000goo00D0
07ooOomoo`00009oo`D00004Ool007oo0003Ool00`00Ool00002Ool00`00Oomoo`1DOol00gNmOomW
>@03JeX6E[D3IcT017ooE[EoodYB0Woo00=:DWooOol0U7oo00A:DWooOom:DXAoo`03Mkeoof<H00Q[
FP=W>@05HaQooeJeOom:DP02Ool00dYBOomoo`06Ool0000548@HaRe[9BU:DP06Ool01000Oomoogoo
0P0000=oo`00Ool01Woo00D007ooOomoo`00009oo`03001oogoo00=oo`03001oo`0000=oo`05001o
o`00Ool0001GOol00gNmOomW>@02JeX6Nmh4IcT017ooE[EoodYB0Woo00=:DWooOol0U7oo00A:DWoo
Oom:DQeoo`03001oogoo06Aoo`03Mkeoof<H00Q[FP=W>@05HaQooeJeOom:DP02Ool00dYBOomoo`06
Ool0000548@HaRe[9BU:DP06Ool02000Oomoo`00Ool007oo0007Ool00`00Oomoo`02Ool00`00Ool0
0005Ool00`00Ool00003Ool01@00Ool007oo0000DGoo00<007ooOol00goo00=g_GooHaP026]J0fLi
00ES67ooE[EoodYB009oo`03BU9oogoo09Aoo`04BU9oogooBU8MOol00`00Oomoo`1TOol00gNmOomS
6008JeX3IcT01F<HOomF]GooBU800Woo00=:DWooOol01Woo00001A246<H]JbDYBU801Woo00P007oo
Ool007oo001oo`001goo00<007ooOol00Woo00<007oo00001Goo00<007oo00000goo00@007oo0000
059oo`8000Aoo`03Mkeoof<H00Q[FP=W>@05HaQooeJeOom:DP02Ool00dYBOomoo`2DOol014YBOomo
odYB0goo1@0000=oo`00Ool00Woo00<007ooOol00P0000Aoo`00Ool0009oo`07001oogoo001oo`00
Ool00P000Woo00<007ooOol00`000goo0`00EGoo00=g_GooHaP026]J16Li00AooeJeOom:DP9oo`03
BU9oogoo00Ioo`0000D@Q1S6;F/U:DYB00Ioo`03001oo`00009oo`03001oo`0000@000=oo`03001o
ogoo009oo`03001oo`0000Eoo`03001oo`0000=oo`05001oo`00Ool0001AOol30003Ool00gNmOomS
6008JeX4IcT017ooE[EoodYB0Woo00=:DWooOol0U7oo00A:DWooOom:DP=oo`03001oogoo00Aoo`03
001oo`00009oo`03001oogoo00800005Ool007ooOol00002Ool01000Ool000000Woo00D007oo001o
o`0000=oo`03001oo`0000=oo`03001oogoo059oo`03Mkeoof<H00Q[FPAW>@04OomF]GooBU82Ool0
0dYBOomoo`06Ool0000548@HaRe[9BU:DP06Ool00`00Ool00002Ool00`00Ool00007Ool00`00Oomo
o`02Ool00`00Ool00005Ool00`00Ool000030002Ool01000Oomoo`00D7oo0P0017oo00=g_GooHaP0
26]J16Li00AooeJeOom:DP9oo`03BU9oogoo09Aoo`04BU9oogooBU83Ool00`00Oomoo`05Ool01@00
Oomoogoo00000goo00<007oo00000Woo00H007ooOol007oo0003Ool01@00Ool007oo000027oo00<0
07ooOol0CGoo00<007ooOol00goo00=g_GooHaP026]J16Li00AooeJeOom:DP9oo`03BU9oogoo00Io
o`0000D@Q1S6;F/U:DYB00Ioo`8000=oo`03001oo`0000Moo`03001oogoo00=oo`8000eoo`03001o
ogoo055oo`03001oogoo00=oo`03Mkeoof<H00Q[FPAW>@04OomF]GooBU82Ool00dYBOomoo`2DOol0
14YBOomoodYB0goo00<007ooOol01Goo00<007ooOol00Woo100000Eoo`00Oomoo`00009oo`03001o
o`0000=oo`04001oo`00Ool50002Ool2001@Ool20004Ool00gNmOomS6008JeX4IcT017ooE[EoodYB
0Woo00=:DWooOol01Woo00001A246<H]JbDYBU801Woo00<007ooOol00Woo00<007oo0000100000=o
o`0000000`000goo0P001Goo00<007ooOol01Goo00<007ooOol0Egoo00=g_GooHaP026]J16Li00Ao
oeJeOom:DP9oo`03BU9oogoo09Aoo`04BU9oogooBU83Ool50002Ool00`00Ool00002Ool01P00Oomo
ogoo001oo`800006Ool007ooOol007oo0P000Woo00D007oo001oo`0000=oo`03001oo`0000=oo`03
001oogoo04aoo`<000=oo`03MkeoofLi00Q[FPAW>@04OomF]GooBU82Ool00dYBOomoo`06Ool00005
48@HaRe[9BU:DP24Ool00gNmOomS6008JeX4IcT017ooE[EoodYB0Woo00=:DWooOol0U7oo00A:DWoo
Oom:DP=oo`03001oogoo00=oo`05001oogooOol00002Ool30002Ool00`00Ool000030002Ool01000
Ool000000Woo00<007ooOol00`000goo0`00Cgoo0P0017oo00=g_GooIcT026]J16Li00AooeJeOom:
DP9oo`03BU9oogoo00Ioo`0000D@Q1S6;F/U:DYB08Aoo`03MkeoofLi00Q[FPAW>@04OomF]GooBU82
Ool00dYBOomoo`2DOol014YBOomoodYB0goo00<007ooOol07Goo00<007ooOol0F7oo00<007ooOol0
0goo00=g_GooIcT026]J16Li00AooeJeOom:DP9oo`03BU9oogoo00Ioo`0000D@Q1S6;F/U:DYB08Ao
o`03MkeoofLi00Q[FPAW>@04OomF]GooBU82Ool00dYBOomoo`2DOol014YBOomoodYB0goo1@006goo
00<007ooOol0GWoo00=g_GooHaP00f]J1UJe0VLi00ES67ooE[EoodYB009oo`03BU9oogoo00Ioo`00
00D@Q1S6;F/U:DYB08Aoo`03Mkeoof<H00Q[FP=W>@05HaQooeJeOom:DP02Ool00dYBOomoo`2DOol0
14YBOomoodYBQ7oo00=g_GooHaP00V]J1W_N0fLi00ES67ooE[EoodYB009oo`03BU9oogoo00Ioo`00
00D@Q1S6;F/U:DYB08Aoo`03Mkeoof<H00Q[FPAW>@04OomF]GooBU82Ool00dYBOomoo`2DOol014YB
OomoodYBQ7oo00=g_GooHaP00f]J1UJe0VLi00ES67ooE[EoodYB009oo`03BU9oogoo00Ioo`0000D@
Q1S6;F/U:DYB08Aoo`03Mkeoofmk009cW0A_N`A[FP9W>@04OomW>GooBU82Ool00dYBOomoo`2DOol0
14YBOomoodYBQ7oo00=g_GooHaP00V]J1W_N16Li00AooeJeOom:DP9oo`03BU9oogoo00Ioo`0000D@
Q1S6;F/U:DYB00Aoo`80009oo`03001oogoo00D00004Ool007oo0003Ool00`00Ool00002Ool00`00
Oomoo`1UOol01GNmOomg_FmkJeX01fLi0V<H00EcW7ooLiaoodYB009oo`03BU9oogoo09Aoo`04BU9o
ogooBU:4Ool00gNmOomS6003JeX6E[D3IcT017ooE[EoodYB0Woo00=:DWooOol01Woo00001A246<H]
JbDYBU800goo00H007ooOol007oo0002Ool00`00Oomoo`03Ool00`00Ool00003Ool01@00Ool007oo
0000J7oo00=g_GooOol03Goo00=g_GooBU800Woo00=:DWooOol0U7oo00A:DWooOom:DXAoo`03Mkeo
of<H009[FPIkgPAW>@04OomF]GooBU82Ool00dYBOomoo`06Ool0000548@HaRe[9BU:DP03Ool01000
Oomoo`000Woo00<007oo00001Goo00<007oo00000goo00D007oo001oo`00069oo`03001oogoo00=o
o`Ag_@EkgPMoo`03MkeoodYB009oo`03BU9oogoo09Aoo`04BU9oogooBU:4Ool00gNmOomS6003JeX6
E[D3IcT017ooE[EoodYB0Woo00=:DWooOol01Woo00001A246<H]JbDYBU801Woo00H007ooOol007oo
0005Ool00`00Ool00003Ool01000Ool00000Hgoo0P0017oo17Nm1G_N1goo00=g_GooBU800Woo00=:
DWooOol0U7oo00A:DWooOom:DP=oo`D000=oo`800004Ool007ooOol30002Ool00`00Oomoo`030005
Ool01000Ool000000goo0`000Woo00D007ooOomoo`00009oo`800003Ool007oo009oo`05001oogoo
Ool00002Ool30002Ool00`00Oomoo`0jOol00gNmOomW>@02JeX6Nmh4IcT017ooE[EoodYB0Woo00=:
DWooOol01Woo00001A246<H]JbDYBU801Woo00H007ooOol007oo0005Ool00`00Ool00003Ool01@00
Ool007oo0000HWoo0`000goo17Nm1G_N1goo00=g_GooBU800Woo00=:DWooOol0U7oo00A:DWooOom:
DP=oo`03001oogoo009oo`03001oo`00009oo`800003Ool007oo009oo`05001oo`00Ool00003Ool0
0`00Oomoo`02Ool20002Ool00`00Ool00003Ool00`00Ool00003Ool00`00Ool00002Ool20003Ool0
1`00Oomoogoo001oo`0000=oo`03001oo`0003aoo`03MkeoofLi00Q[FPAW>@04OomF]GooBU82Ool0
0dYBOomoo`06Ool0000548@HaRe[9BU:DP06Ool01P00Oomoo`00Ool000Eoo`03001oo`0000<0009o
o`04001oogoo001QOol20004Ool4Mkd5Nmh7Ool00gNmOom:DP02Ool00dYBOomoo`2DOol014YBOomo
odYB0goo00<007ooOol00Woo00<007oo00000goo00<007ooOol00Woo00H007ooOol007oo0008Ool0
1`00Oomoogoo001oo`0000Eoo`07001oogooOol007oo00000goo00H007ooOol007oo0002Ool00`00
Ool00003Ool00`00Ool0000fOol00`00Oomoo`03Ool00gNmOomW>@08JeX4IcT017ooE[EoodYB0Woo
00=:DWooOol01Woo00001A246<H]JbDYBU801Woo00@007ooOomoo`8000eoo`03001oogoo069oo`03
001oogoo00=oo`Ag_@EkgPMoo`03MkeoodYB009oo`03BU9oogoo09Aoo`04BU9oogooBU83Ool00`00
Oomoo`02Ool00`00Oomoo`040002Ool20003Ool00`00Ool00008Ool01P00Oomoogoo001oo`D00003
Ool007oo009oo`03001oogoo00@0009oo`03001oo`00009oo`03001oo`0000=oo`03001oo`0003Io
o`8000Aoo`03Mkeoof<H00Q[FP=W>@05HaQooeJeOom:DP02Ool00dYBOomoo`06Ool0000548@HaRe[
9BU:DP06Ool01000Oomoogoo0P001Goo00<007ooOol01Goo00<007ooOol0J7oo17Nm1G_N1goo00=g
_GooBU800Woo00=:DWooOol0U7oo00A:DWooOom:DP=oo`H00003Ool007oo009oo`03001oo`0000=o
o`05001oo`00Ool00003Ool00`00Oomoo`02Ool20002Ool00`00Ool00003Ool01000Ool000000Woo
00<007oo00000goo00<007oo00000goo00D007oo001oo`0000=oo`04001oo`00000eOol30003Ool0
0gNmOomS6008JeX3IcT01F<HOomF]GooBU800Woo00=:DWooOol01Woo00001A246<H]JbDYBU80Q7oo
17Nm1G_N1goo00=g_GooBU800Woo00=:DWooOol0U7oo00A:DWooOom:DP=oo`03001oogoo009oo`03
001oogoo00<000=oo`<0009oo`03001oogoo00<000Eoo`04001oo`000003Ool30002Ool01000Ool0
00000goo0`000Woo00L007ooOomoo`00Ool00002Ool30002Ool00`00Ool0000dOol20004Ool00gNm
OomS6008JeX3IcT01F<HOomF]GooBU800Woo00=:DWooOol01Woo00001A246<H]JbDYBU80Q7oo17Nm
1G_N1goo00=g_GooBU800Woo00=:DWooOol0U7oo00A:DWooOom:DP=oo`03001oogoo009oo`03001o
ogoo01Ioo`03001oogoo00Uoo`03001oogoo04ioo`03001oogoo00=oo`03Mkeoof<H00Q[FP=W>@05
HaQooeJeOom:DP02Ool00dYBOomoo`06Ool0000548@HaRe[9BU:DP24Ool4Mkd5Nmh7Ool00gNmOom:
DP02Ool00dYBOomoo`2DOol014YBOomoodYB0goo1@003Woo00<007ooOol027oo00<007ooOol02Goo
00<007ooOol03goo00<007ooOol0@Woo00=g_GooHaP026]J16Li00AooeJeOom:DP9oo`03BU9oogoo
00Ioo`0000D@Q1S6;F/U:DYB08Aoo`Ag_@EkgPMoo`03MkeoodYB009oo`03BU9oogoo09Aoo`04BU9o
ogooBU:4Ool00gNmOomS6008JeX4IcT017ooE[EoodYB0Woo00=:DWooOol01Woo00001A246<H]JbDY
BU80Q7oo17Nm1G_N1goo00=g_GooBU800Woo00=:DWooOol0U7oo00A:DWooOom:DXAoo`03Mkeoof<H
00Q[FPAW>@04OomF]GooBU82Ool00dYBOomoo`06Ool0000548@HaRe[9BU:DP24Ool4Mkd5Nmh7Ool0
0gNmOom:DP02Ool00dYBOomoo`2DOol014YBOomoodYBQ7oo00=g_GooHaP026]J16Li00AooeJeOom:
DP9oo`03BU9oogoo00Ioo`0000D@Q1S6;F/U:DYB00=oo`04001oogoo0002Ool00`00Oomoo`020000
0goo001oo`0200000goo001oo`02Ool00`00Ool00004000017oo001oo`000goo00<007oo00000Woo
00<007ooOol0EWoo17Nm1G_N1goo00=g_GooBU800Woo00=:DWooOol0U7oo00A:DWooOom:DXAoo`03
Mkeoof<H00Q[FPAW>@04OomF]GooBU82Ool00dYBOomoo`06Ool0000548@HaRe[9BU:DP03Ool01000
Oomoo`000Woo00<007oo00000Woo0P0000Eoo`00Oomoo`0000=oo`03001oo`0000Eoo`03001oo`00
00=oo`05001oo`00Ool0001IOol4Mkd5Nmh7Ool00gNmOom:DP02Ool00dYBOomoo`2DOol014YBOomo
odYB47oo100067oo1000E7oo00=g_GooHaP026]J16Li00AooeJeOom:DP9oo`03BU9oogoo00Ioo`00
00D@Q1S6;F/U:DYB00=oo`09001oo`00Ool007oo001oo`0000=oo`03001oo`00009oo`07001oogoo
Ool007oo00001Goo00<007oo00000goo00D007oo001oo`0005=oo`03001oogoo00=oo`Ag_@EkgPMo
o`03MkeoodYB009oo`03BU9oogoo09Aoo`04BU9oogooBU8DOol00`00Oomoo`0IOol00`00Oomoo`1A
Ool00gNmOomS6008JeX4IcT017ooE[EoodYB0Woo00=:DWooOol01Woo00001A246<H]JbDYBU800goo
00L007oo001oo`00Ool00002Ool400001Goo001oogoo00000goo00<007oo00001Goo00<007oo0000
0goo00@007oo000005Aoo`8000Aoo`Ag_@EkgPMoo`03MkeoodYB009oo`03BU9oogoo09Aoo`04BU9o
ogooBU83Ool50003Ool30003Ool200001Woo001oo`00Ool000=oo`03001oo`0000=oo`05001oo`00
Ool00003Ool00`00Oomoo`02000017oo001oogoo0`00CWoo00=g_GooIcT026]J16Li00AooeJeOom:
DP9oo`03BU9oogoo00Ioo`0000D@Q1S6;F/U:DYB00=oo`09001oo`00Ool007oo001oo`0000=oo`03
001oo`00009oo`80009oo`03001oo`0000Eoo`03001oo`0000=oo`05001oo`00Ool0001COol30003
Ool4Mkd5Nmh7Ool00gNmOom:DP02Ool00dYBOomoo`2DOol014YBOomoodYB0goo00<007ooOol00Woo
00<007oo00000goo00<007oo00000Woo0P0000Aoo`00Ool000=oo`03001oo`0000=oo`05001oo`00
Ool00003Ool00`00Ool00002Ool200000goo001oo`02Ool00`00Oomoo`1;Ool00gNmOomW>@08JeX4
IcT017ooE[EoodYB0Woo00=:DWooOol01Woo00001A246<H]JbDYBU800goo0P000goo0P000Woo0`00
00Moo`00000007oo001oo`020002Ool00`00Oomoo`03Ool00`00Ool000030002Ool01000Oomoo`00
DWoo0P0017oo17Nm1G_N1goo00=g_GooBU800Woo00=:DWooOol0U7oo00A:DWooOom:DP=oo`03001o
ogoo009oo`03001oo`0000Eoo`09001oogooOol007oo001oo`0000=oo`03001oo`0000=oo`05001o
o`00Ool00003Ool00`00Ool00003Ool00`00Oomoo`02Ool00`00Oomoo`16Ool00`00Oomoo`03Ool0
0gNmOomW>@08JeX4IcT017ooE[EoodYB0Woo00=:DWooOol01Woo00001A246<H]JbDYBU800goo0P00
0goo0P001goo00@007ooOol000Eoo`03001oogoo00]oo`03001oogoo05=oo`03001oogoo00=oo`Ag
_@EkgPMoo`03MkeoodYB009oo`03BU9oogoo09Aoo`04BU9oogooBU83Ool00`00Oomoo`02Ool00`00
Ool0000400000goo001oo`02Ool01@00Ool007oo00000goo00<007oo00000goo00D007oo001oo`00
00=oo`03001oo`0000=oo`03001oogoo008004Uoo`8000Aoo`03Mkeoof<H00Q[FP=W>@05HaQooeJe
Oom:DP02Ool00dYBOomoo`06Ool0000548@HaRe[9BU:DP03Ool00`00Oomoo`03Ool00`00Oomoo`05
Ool01000Oomoo`001Goo00<007ooOol00goo00<007ooOol01Goo00<007ooOol0FGoo17Nm1G_N1goo
00=g_GooBU800Woo00=:DWooOol0U7oo00A:DWooOom:DP=oo`H00003Ool007oo009oo`03001oo`00
009oo`800004Ool007oo0003Ool00`00Ool00003Ool01@00Ool007oo00000goo00<007oo00000Woo
0P0000=oo`00Ool00Woo00<007ooOol0AGoo0`000goo00=g_GooHaP026]J16Li00AooeJeOom:DP9o
o`03BU9oogoo00Ioo`0000D@Q1S6;F/U:DYB08Aoo`Ag_@EkgPMoo`03MkeoodYB009oo`03BU9oogoo
09Aoo`04BU9oogooBU83Ool00`00Oomoo`02Ool00`00Oomoo`030003Ool200001Goo001oo`00Ool0
10000Woo10000Woo00<007oo00000`000goo0P0000Aoo`00Oomoo`<004Qoo`8000Aoo`03Mkeoofmk
009cW0A_N`A[FP9W>@04OomW>GooBU82Ool00dYBOomoo`06Ool0000548@HaRe[9BU:DP24Ool4Mkd5
Nmh7Ool00gNmOom:DP02Ool00dYBOomoo`2DOol014YBOomoodYB0goo00<007ooOol00Woo00<007oo
Ool0Lgoo00<007ooOol00goo00Eg_GooMke_Nf]J00MW>@9S6005Liaoog>LOom:DP02Ool00dYBOomo
o`06Ool0000548@HaRe[9BU:DP24Ool4Mkd5Nmh7Ool00gNmOom:DP02Ool00dYBOomoo`2DOol014YB
OomoodYB0goo1@003Woo00<007ooOol02goo00<007ooOol0GGoo00=g_GooOol03Goo00=g_GooBU80
0Woo00=:DWooOol01Woo00001A246<H]JbDYBU80Q7oo0WNm00=NmeJeDY@00Tic0dYB14ic00EF]GNm
MkeoodYB009oo`03BU9oogoo09Aoo`04BU9oogooBU:4Ool2Mkd00ekgE[EBU002CW<3BU84CW<01EJe
Mkeg_GooBU800Woo00=:DWooOol01Woo00001A246<H]JbDYBU800WooPE:D00=oogNmIcT03Goo00AN
mgNmOom:DP9oo`03BU9oogoo09Aoo`04BU9oogooBU:4Ool00gNmIcUoo`0<Ool015kgMkeoodYB0Woo
00=:DWooOol01Woo00001A246<H]JbDYBU80Q7oo00Ag_GooLiaS60EW>@ES6005Kg]ooekgOom:DP02
Ool00dYBOomoo`2DOol014YBOomoodYBQ7oo00Ag_GooLiaS60EW>@ES6005Kg]ooekgOom:DP02Ool0
0dYBOomoo`06Ool0000548@HaRe[9BU:DP24Ool017NmOomNmf<H1fLi16<H00Aooe[FOom:DP9oo`03
BU9ooc6<09<aS02=Oom:DWooOom:DWooCW<aS4ic<Ha>Lc6<CW<aS4ic<Ha>Lc6<CW<aS4ic<Ha>Lc6<
CW<aS4ic<Ha>Lc6<CW<aS4ic<Ha>Lc6<CW<aS4ic<Ha>Lc6<CW<aS4ic<Ha>Lc6<CW<aS4ic<Ha>Lc6<
CW<aS4ic<Ha>Lc6<CW<aS4ic<Ha>Lc6<CW<aS4ic<Ha>Lc6<CW<aS4ic<Ha>Lc6<CW<aS4ic<Ha>Lc6<
CW<aS4ic<Ha>Lc6<CW<aS4ic<Ha>Lc6<CW<aS4ic<Ha>Lc6<CW<aS4ic<Ha>Lc6<CW<aS4ic<Ha>Lc6<
CW<aS4ic<Ha>Lc6<CW<aS4ic<Ha>Lc6<CW<aS4ic<Ha>Lc6<CW<aS4ic<Ha>LgNmOomNmf<H00MW>@AS
6004OomJeWooBU82Ool00dYBOomoo`06Ool0000548@HaRe[9BU:DP0XOol00`00Oomoo`1IOol00gNm
OomNm`02IcT00f]JIcUW>@04IcT3HaP017ooE[EoodYB0Woo00=:DWoo<H`0Tc6<00IoodYBOomoodYB
Oon3<H`00gNmOomNm`02IcT00f]JIcUW>@04IcT3HaP017ooE[EoodYB0Woo00=:DWooOol01Woo0000
1A246<H]JbDYBU80:7oo00<007ooOol0FGoo00Ag_GooG_MW>@I[FP9W>@=S6004OomF]GooBU82Ool0
0dYBOolaS02C<H`01gooBU9oogooBU9oodic084aS005CW=g_GooG_MW>@06JeX2IcT3HaP017ooE[Eo
odYB0Woo00=:DWooOol01Woo00001A246<H]JbDYBU800goo00<007ooOol00Woo00<007oo00000Woo
00D007ooOol007oo00D000Ioo`<000=oo`800005Ool007oo001oo`020003Ool200001Goo001oo`00
Ool00P000Woo00H007oo001oo`00Ool2000017oo001oogoo0`000goo0`00=Goo00=g_GooHaP00V]J
00<]Jf]JJeX00V]J00=W>Be[IcT00V<H00AooeJeOom:DP9oo`03BU9ooc6<008aS0Aoo`8aS008Oola
S36<<Haooc6<OolaS09ooh4aS006Oom:DWooOom:DWoo0c6<17oo0S6<00Qooc6<<H`aS7oo<Haooc6<
0Woo136<0Woo0S6<0goo0c6<0Woo00@aS7oo<Haooe`aS003Mkeoof<H009[FP03;F][FV]J009[FP03
IcT]JfLi009S6004OomF]GooBU82Ool00dYBOomoo`06Ool0000548@HaRe[9BU:DP04Ool01000Oomo
o`000Woo00@007ooOol0009oo`03001oo`0000Uoo`07001oogooOol007oo00000Woo0P0000=oo`00
00000Woo00<007oo00000Woo0P0000=oo`0000000Woo00T007oo001oo`00Ool007oo00000Woo00<0
07oo00000goo00<007oo00000goo00<007ooOol0<Woo00Ag_GooHaQ[FP<]J`9[FP0:IcT]Jbe[;F]W
>F<HOomF]GooBU82Ool01DYBOolaS36<Ool0136<00=ooc6<Ool00c6<00Eooc6<OolaS7oo088aS009
Oom:DWooOom:DWooCW<aS7oo00@aS003OolaS7oo00<aS005OolaS7oo<Haoo`05<H`017oo<H`aS7oo
0c6<00=ooc6<Ool00S6<0Woo00<aS7oo<H`0FS6<00E>LgNmOomS66]J00<]J`9[FP0:IcT]Jbe[;F]W
>F<HOomF]GooBU82Ool00dYBOomoo`06Ool0000548@HaRe[9BU:DP04Ool01000Oomoo`000Woo00T0
07oo001oo`00Ool007oo000027oo00<007ooOol017oo00L007ooOomoo`00Ool00003Ool00`00Ool0
0003Ool00`00Ool00003Ool02@00Ool007oo001oo`00Ool00002Ool00`00Ool00008Ool00`00Oomo
o`0]Ool00`00Oomoo`03Ool00gNmOomS6002JeX3;F/016]J;F/]Jbe[0fLi00Aooe[FOom:DP9oo`05
BU9ooc6<<Haoo`04<H`00goo<Haoo`03<H`01Goo<Haooc6<Ool0O36<00=ooc6<<H`00c6<00IoodYB
OomoodYBOol2<H`00goo<H`aS002<H`00goo<Haoo`03<H`01Goo<Haooc6<Ool01C6<00Aooc6<<Hao
o`<aS003OolaS7oo00<aS003OolaS7oo05`aS003Mkeoof<H009[FP<]J`04JeX]Jbe[;F/3IcT017oo
F]IoodYB0Woo00=:DWooOol01Woo00001A246<H]JbDYBU801Goo0P000goo00T007oo001oo`00Ool0
07oo000027oo00<007ooOol01Goo100000=oo`00Ool00Woo00<007ooOol0100000=oo`00Ool00Woo
00T007oo001oo`00Ool007oo00000Woo00<007oo000010000Woo0P00<7oo0P0017oo00=g_GooIcT0
0f]J1Be[16Li00Aooe[FOom:DP9oo`05BU9ooc6<<Haoo`04<H`00goo<Haoo`03<H`01Goo<Haooc6<
Ool0O36<0Woo136<00UoodYBOomoodYBOom>Lc6<Ool0136<00=ooc6<Ool00c6<00Eooc6<OolaS7oo
00DaS004OolaS36<Ool3<H`00goo<Haoo`03<H`00goo<Haoo`1K<H`014icMkeoofLi0f]J1Be[16Li
00Aooe[FOom:DP9oo`03BU9oogoo00Ioo`0000D@Q1S6;F/U:DYB00Eoo`8000=oo`09001oo`00Ool0
07oo001oo`0000Qoo`03001oogoo00Aoo`06001oogooOol007oo0P000Woo00<007oo00000goo00@0
07oo0000009oo`09001oo`00Ool007oo001oo`00009oo`03001oo`0000=oo`03001oo`0000=oo`03
001oogoo02aoo`<000=oo`03MkeoofLi00A[FP<]J`EW>@04OomJeWooBU82Ool01DYBOolaS36<Ool0
136<00=ooc6<Ool00c6<00Eooc6<OolaS7oo07`aS0=oo`<aS006Oom:DWooOom:DWoo0S6<00=ooc6<
<H`00S6<00=ooc6<Ool00c6<00Eooc6<OolaS7oo00DaS004OolaS36<Ool3<H`00goo<Haoo`03<H`0
17oo<HaoogooFc6<00=g_GooIcT016]J0be[1FLi00Aooe[FOom:DP9oo`03BU9oogoo00Ioo`0000D@
Q1S6;F/U:DYB00Aoo`04001oogoo0002Ool20003Ool200000goo001oo`07Ool00`00Oomoo`05Ool3
0002Ool01000Ool000000goo0`000Woo00@007oo0000009oo`04001oo`00Ool4000017oo001oogoo
0`000goo0`00;goo0P0017oo00=g_GooIcT00Vmk0f]J00<]JfLiIcT016Li00Aooe[FOom:DP9oo`05
BU9ooc6<<Haoo`04<H`00goo<Haoo`03Ool2<H`4Oomk<H`2Ool4<H`02GooBU9oogooBU9oodic<Hao
o`04<H`00goo<Haoo`03Ool2<H`4Ool3<H`3Ool2<H`3Ool2<H`02Goo<H`aS36<OolaS7oo<Haoo`1I
<H`014icMkeoofLi0Vmk0f]J00<]JfLiIcT016Li00Aooe[FOom:DP9oo`03BU9oogoo00Ioo`0000D@
Q1S6;F/U:DYB00Aoo`04001oogoo0002Ool20003Ool200000goo001oo`08Ool01@00Oomoogoo0000
4goo00<007ooOol01Goo00D007ooOomoo`0003eoo`03001oogoo00=oo`03Mkeoof]J009_N`A[FPIW
>@04OomNmgooBU82Ool01DYBOolaS36<Ool0136<00=ooc6<<H`01c6<00=ooc6<<H`0NS6<00=ooc6<
<H`00c6<00IoodYBOomoodYBOol2<H`00goo<H`aS002<H`00goo<H`aS007<H`00goo<H`aS003<H`0
0goo<H`aS01Y<H`00gNmOom[FP02Kg/4JeX6IcT017ooG_MoodYB0Woo00=:DWooOol01Woo00001A24
6<H]JbDYBU800goo00<007ooOol00Woo00<007oo00001Goo00<007oo00002Woo0`0057oo00<007oo
Ool00goo00L007oo001oo`00Ool00002Ool00`00Oomoo`0nOol00gNmOom[FP02Li`00fmkJeY[FP04
JeX3IcT017ooHaQoodYB0Woo00E:DWoo<H`aS7oo00@aS003OolaS36<00DaS003OolaS7oo088aS009
Oom:DWooOom:DWooCW<aS7oo00@aS003OolaS36<00DaS003OolaS7oo00DaS003OolaS36<06PaS004
CW=g_GooJeX2Li`00fmkJeY[FP04JeX3IcT017ooHaQoodYB0Woo00=:DWooOol01Woo00001A246<H]
JbDYBU80Q7oo00=g_GooKg/00W>L0fmk1F]J0VLi00Aoof]JOom:DP9oo`03BU9ooc6<09<aS006Oom:
DWooOom:DWooPc6<00=g_GooKg/00W>L0fmk1F]J0VLi00Aoof]JOom:DP9oo`03BU9oogoo00Ioo`00
00D@Q1S6;F/U:DYB08Aoo`05MkeoogNmKg][FP05IcT4HaP01G>LOom_NgooBU800Woo00=:DWoo<H`0
Tc6<00MoodYBOomoodYBOom>L`21<H`01TicMkeoogNmKg][FPEW>@AS6005LiaoofmkOom:DP02Ool0
0dYBOomoo`06Ool0000548@HaRe[9BU:DP24Ool00gNmOomoo`0=Ool00gNmOom:DP02Ool00dYBOola
S02C<H`0RWooBU9oogooBU9ooc6<CW<aS4ic<Ha>Lc6<CW<aS4ic<Ha>Lc6<CW<aS4ic<Ha>Lc6<CW<a
S4ic<Ha>Lc6<CW<aS4ic<Ha>Lc6<CW<aS4ic<Ha>Lc6<CW<aS4ic<Ha>Lc6<CW<aS4ic<Ha>Lc6<CW<a
S4ic<Ha>Lc6<CW<aS4ic<Ha>Lc6<CW<aS4ic<Ha>Lc6<CW<aS4ic<Ha>Lc6<CW<aS4ic<Ha>Lc6<CW<a
S4ic<Ha>Lc6<CW<aS4ic<Ha>Lc6<CW<aS4ic<Ha>Lc6<CW<aS4ic<Ha>Lc6<CW<aS4ic<Ha>Lc6<CW<a
S4ic<Ha>Lc6<CW<aS4ic<Ha>Lc6<CW<aS4ic<Ha>Lc6<CW<aS4ic<Hag_@moo`03MkeoodYB009oo`03
BU9oogoo00Ioo`0000D@Q1S6;F/U:DYB09Ioo`04BU9oogooBU:FOol014YBOomoodYBUWoo00A:DWoo
Oom:DPQoo`0000@@Q1S6;F/U:IQ:DP9ooiQ:DP9ooiQ:DP9oo`M:DP9oo`0000D@Q1S6;F/U:DYB0?mo
omMoo`0000D@Q1S6;F/U:DYB0?moomMoo`0000D@Q1S6;F/U:DYB0?moomMoo`0000D@Q1S6;F/U:DYB
0?moomMoo`0000D@Q1S6;F/U:DYB0?moomMoo`0000D@Q1S6;F/U:DYB0?moomMoo`0000D@Q1S6;F/U
:DYB0?moomMoo`0000D@Q1S6;F/U:DYB0?moomMoo`0000@@Q1S6;F/U:LQ:D[]ooe9:DP9oo`0000@@
Q1S6;F/U:@9cW003CW=cW7>L0<1cW09_N`03BU9oogoo0;Uoo`03BU9cW7>L04mcW09oo`0000@@Q1S6
;F/U:@9cW003CW=g_GNm0<1g_@03Lia_NdYB0;]oo`03BU9g_GNm04mg_@9oo`0000@@Q1S6;F/U:@9c
W003CW=g_GNm0<1g_@03Lia_NdYB0;]oo`03BU9g_GNm04mg_@9oo`0000@@Q1S6;F/U:@9cW003CW=g
_GNm0<1g_@03Lia_NdYB0;]oo`03BU9g_GNm04mg_@9oo`0000@@Q1S6;F/U:@9cW003CW=g_GNm02mg
_@D000Ag_@D00004Mkd00000Mkd20002Mkd20005Mkd200000gNm00000002Mkd20005Mkd20006Mkd5
00000gNm00000002Mkd20002Mkd40003Mkd200000gNm00000002Mkd40002Mkd20002Mkd20002Mkd3
000aMkd00g>LKg]:DP2kOol00dYBMkeg_@0`Mkd20004Mkd20002Mkd20002Mkd40006Mkd20004Mkd1
0001Ool1Ool0000448@HaRe[9BT2Li`00dicMkeg_@0_Mkd20002Mkd20002Mkd200001GNm00000000
Mkd00P0000Ag_@00001g_@8000Ig_@800003Mkd00000009g_@8000Eg_@8000Eg_@800005Mkd00000
001g_@020002Mkd200000gNm00000002Mkd200000gNm00000002Mkd200000gNm00000002Mkd20000
0gNm00000002Mkd2000017Nm000007Nm0P00<GNm00=cW4YBOol0^Woo00=:DWNmMkd0<7Nm0P0017Nm
0P000WNm0P0000=g_@0000000WNm0P001GNm0P0000Eg_@00001g_@00009oo`0000@@Q1S6;F/U:@9c
W003CW=kgW_N02mg_@80009g_@80009g_@80009g_@800004Mkd00000Mkd200000gNm00000006Mkd2
00000gNm00000002Mkd20005Mkd20005Mkd20002Mkd200000gNm00000002Mkd200000gNm00000005
Mkd20002Mkd200000gNm00000002Mkd200000gNm00000002Mkd20003Mkd2000bMkd00g>LBU9oo`0^
Ool20004Ool20002Ool50002Ool50006Ool40002Ool20002Ool20002Ool30007Ool50005Ool60000
17oo000007oo0P000Woo0P0000=oo`0000000Woo0P000Woo0`00<Woo00=:DW_NMkd0<7Nm0P0017Nm
0P000WNm0P0000=g_@0000002GNm0P0000Eg_@00001g_@00009oo`0000@@Q1S6;F/U:@9cW003CW=k
gW_N02mg_@80009g_@80009g_@80009g_@800004Mkd00000Mkd200000gNm00000002Mkd3000017Nm
000007Nm0P000WNm0P001GNm0P001GNm0P000WNm0P0000=g_@0000000WNm0P0000=g_@0000001GNm
0P000WNm0P0000=g_@0000000WNm0P0000=g_@0000000WNm0P000WNm0P00<gNm00=cW4YBOol0;Woo
0P0017oo0P0000=oo`0000000Woo0P0000=oo`0000000Woo0P001Goo0P000Woo0P0000=oo`000000
0Woo0P0000Aoo`00001oo`8000Eoo`800003Ool0000000Ioo`8000Eoo`800003Ool00000009oo`80
0004Ool00000Ool20002Ool200000goo0000000aOol00dYBNmig_@0`Mkd20004Mkd20002Mkd20000
0gNm000000040005Mkd70002Ool0000448@HaRe[9BT2Li`00dicNmikgP0_Nmh50003Nmh20002Nmh2
000017_N000007_N0P0000=kgP0000001W_N0P0000EkgP00000007_N008000EkgPD0009kgP80009k
gP800005Nmh00000001kgP0200000g_N00000002Nmh200000g_N00000002Nmh200000g_N00000002
Nmh200001G_N00000000Nmh00P0000AkgP00001kgP8002mkgP9g_@03Lia:DWoo02moo`H0009oo`80
009oo`800003Ool00000009oo`8000Eoo`80009oo`800003Ool00000009oo`8000=oo`8000Ioo`80
0003Ool0000000Ioo`8000Eoo`800003Ool00000009oo`800003Ool00000008000Eoo`80039oo`03
BU9kgW_N031kgP8000AkgP<00004Nmh00000Nmh20002Nmh20005Nmh70002Ool0000448@HaRe[9BT2
Li`00dicNmikgP0_Nmh20002Nmh20002Nmh20002Nmh2000017_N000007_N0P0000AkgP00000000Ek
gP800003Nmh0000000<000IkgP8000EkgP80009kgP800003Nmh0000000<000=kgP@0009kgP<00003
Nmh00000009kgP@0009kgPD000=kgP<0035kgP03MkecW4YB031oo`80009oo`80009oo`80009oo`80
0003Ool00000009oo`800005Ool00000001oo`020002Ool200000goo00000002Ool20002Ool20007
Ool60005Ool20005Ool200000goo00000002Ool2000017oo000000001Goo0P00<goo00=:DW_NNmh0
<7_N0P0017_N1@000g_N10001W_N0`000W_N0P000Woo000011246<H]JbDY0W>L00=>Lg_NNmh0;g_N
0P000W_N0P0037_N0P0000=kgP00000057_N0P006W_N0P00B7_N00=g_G>LBU80<7oo0P000Woo0P00
0Woo0P000Woo0P0000=oo`0000000Woo0P001Goo0P000Woo0P0000Eoo`00000007oo00800004Ool0
0000Ool20006Ool20008Ool20005Ool200001Goo00000000Ool00P0000=oo`0000000P000goo0P00
00=oo`000000<Goo00=:DW_NNmh0<7_N0P0017_N0P0047_N0`000W_N0P000Woo000011246<H]JbDY
0W>L00=>Lg_NNmh0;g_N0P000W_N0P0037_N0P0000=kgP00000057_N0P006W_N0P00B7_N00=g_G>L
BU80<Goo100017oo1@000Woo1@001Woo10000Woo1@000goo0`001goo0P0027oo0P001Goo0P0000=o
o`0000000`000Woo0P0000=oo`0000000goo0`00<Woo00=:DW_NNmh0<7_N0P0017_N0P0047_N0P00
17_N0@000Goo0Goo000011246<H]JbDY0W>L00=>Lg_NNmh0;g_N1@002W_N0P0000=kgP0000002G_N
0P0037_N1P006W_N0P00A7_N00=g_G>LBU80<Goo10001goo0P001Goo0P007Goo10001goo0P003goo
0P00>goo00=:DW_NNmh0;W_N1P000W_N0P0047_N0P0017_N0@000Goo0Goo000011246<H]JbDY0W>L
00=>LgooOol0`7oo00=kgWNmBU80<Woo0P0027oo0P001Goo0P007Goo10001goo0P003goo0P00>goo
00=:DWooOol0DGoo000011246<H]JbDY0W>L00=>LgooOol0`Goo00=kgTYBOol0<Goo0P0027oo0P00
1Goo0P007Woo0P0027oo0P001Goo0P0027oo0P00>goo00=:DWooOol0DGoo000011246<H]JbDY0W>L
00=JeW>LOol0`Goo00=cW4YBOol0^Woo00=:DWooOol0DGoo000011246<H]JbDY0W>L00=[FUkgLi`0
`7oo00=g_EkgBU80^goo00=:DW>LOol0DGoo000011246<H]JbDY0W>L00=g_F]JF]H0`4ic00AF]FLi
E[ENmkUS6003G_MF]E[F051>L`9oo`0000@@Q1S6;F/U:@9cW003CW=cW7>L079cW09_N`03CW=g_Dic
04]cW003HaQBU5kg0;QS6003DYAS67>L051cW09oo`0000@@Q1S6;F/U:@9cW003CW=g_GNm079g_@05
Lia_NdicMke>L`1<Mkd00f<HDYA>L`2fCW<00e:DHaQg_@1AMkd2Ool0000448@HaRe[9BT2Li`00dic
Mkeg_@1bMkd01G>LKg]>LgNmCW<0@WNm1@00C7Nm00EcW6mkCW=g_Dic061g_@05Lia_NdicMke>L`1L
Mkd2Ool0000448@HaRe[9BT2Li`00dicMkeg_@1bMkd01G>LKg]>LgNmCW<0AWNm0P00BgNm00EcW6mk
CW=g_Dic061g_@05Lia_NdicMke>L`1LMkd2Ool0000448@HaRe[9BT2Li`00dicMkeg_@0NMkd20005
Mkd20003Mkd40002Mkd20002Mkd20002Mkd20005Mkd60002Mkd20002Mkd20002Mkd5000NMkd01G>L
Kg]>LgNmCW<08GNm1P000gNm10000gNm0P000WNm0P0000Ag_@00001g_@80009g_@80009g_@D000Ig
_@@000Ag_@80009g_@D00003Mkd0000000=g_@80009g_@@000=g_@D001ig_@05Lia_NdicMke>L`0R
Mkd20005Mkd40003Mkd500000gNm0000000XMkd01G>LKg]>LgNmCW<087Nm1@001GNm10000WNm0P00
00Ag_@00001g_@80009g_@@000=g_@<001Qg_@9oo`0000@@Q1S6;F/U:@9cW003CW=g_GNm01ig_@80
00Eg_@80009g_@80009g_@800003Mkd00000009g_@800003Mkd0000000Ig_@8000Ig_@80009g_@80
0003Mkd00000009g_@8001mg_@04Lia>LgNmCW<PMkd20002Mkd30002Mkd20002Mkd200000gNm0000
0002Mkd20002Mkd200000gNm00000002Mkd200000gNm00000002Mkd20005Mkd20002Mkd20002Mkd2
0002Mkd20002Mkd200000gNm00000002Mkd20002Mkd20002Mkd200000gNm00000002Mkd2000OMkd0
17>LCW=g_Dic8WNm0P0017Nm0P000WNm0P0000Ag_@00001g_@<00003Mkd0000002Ug_@04Lia>LgNm
CW<PMkd20002Mkd20003Mkd20002Mkd2000017Nm000007Nm0P0000Ag_@00001g_@80009g_@800004
Mkd00000Mkd2000GMkd2Ool0000448@HaRe[9BT2Li`00dicNmikgP0NMkd20005Mkd20002Mkd20002
Mkd200000gNm00000002Mkd200000gNm00000006Mkd20006Mkd20002Mkd200000gNm00000002Mkd2
000OMkd017>LCW=g_Dic0W_N7WNm0P000gNm0P000WNm0P001GNm0P000WNm0P000WNm0P0000=g_@00
00000WNm0P0000=g_@0000000WNm0P002GNm0P000WNm0P000WNm0P000WNm0P0000=g_@0000000WNm
0P000WNm0P001GNm0P000WNm0P007gNm00AcW4icMke>L`9kgR1g_@8000Ag_@80009g_@800003Mkd0
0000009g_@800003Mkd0000002Ug_@04Lia>LgNmCW<2NmhNMkd20003Mkd20002Mkd20005Mkd20000
17Nm000007Nm0P0000=g_@0000000WNm0P000gNm0P0067Nm0Woo000011246<H]JbDY0W>L00=>Lg_N
Nmh07WNm0P001GNm0P000WNm0P000WNm0P0000=g_@0000000WNm0P0000=g_@0000001WNm0P001WNm
0P000WNm0P0000=g_@0000000WNm0P007gNm00AcW4icMke>L`9kgQig_@8000=g_@80009g_@H00003
Mkd00000009g_@80009g_@800003Mkd00000009g_@800003Mkd00000009g_@8000Ug_@80009g_@80
00=g_@D00003Mkd00000009g_@80009g_@H00003Mkd00000009g_@8001mg_@04Lia>LgNmCW<2NmhP
Mkd20004Mkd20002Mkd200000gNm00000002Mkd200000gNm0000000YMkd017>LCW=g_Dic0W_N7WNm
0P000gNm0P000WNm1P0000Ag_@00001g_@800004Mkd00000Mkd20002Mkd20002Mkd2000IMkd2Ool0
000448@HaRe[9BT2Li`00dicNmikgP0NNmh50002Nmh20002Nmh20002Nmh200001G_N00000000Nmh0
0P0000=kgP0000001W_N1@000g_N0`0000AkgP00001kgP80009kgP8001ekgP9g_@04Lia>LgNmCW<P
Nmh200000g_N000000020002Nmh20002Nmh200000g_N00000002Nmh20002Nmh200001G_N00000000
Nmh00P0000=kgP0000000W_N0P001W_N10000g_N0P001W_N0P0000=kgP0000000W_N0P000W_N0P00
0W_N0P0000=kgP0000000W_N0P007G_N0WNm00AcW4icMke>Lb9kgP8000AkgP80009kgP800003Nmh0
0000009kgP800003Nmh0000002MkgP9g_@04Lia>LgNmCW<PNmh20003Nmh20002Nmh20002Nmh20000
17_N000007_N0P0000AkgP00001kgP80009kgP800004Nmh00000Nmh2000GNmh2Ool0000448@HaRe[
9BT2Li`00dicNmikgP0NNmh20005Nmh30002Nmh40002Nmh50002Nmh30005Nmh20006Nmh50003Nmh5
000NNmh01GNmLia>LgNmCW<087_N0P0027_N10000W_N0`0000EkgP00000007_N00800003Nmh00000
00<000=kgPD000EkgP8000IkgP<0009kgP@0009kgP<00004Nmh000000002Nmh40003Nmh5000NNmh0
1GNmLia>LgNmCW<08W_N0P001G_N10000W_N0P000W_N0P0000AkgP00000002MkgP05MkecW4icMke>
L`0PNmh20003Nmh20003Nmh40002Nmh70003Nmh40003Nmh3000HNmh2Ool0000448@HaRe[9BT2Li`0
0dicNmikgP0NNmh2000GNmh20006Nmh2000ANmh2000NNmh01GNmLia>LgNmCW<087_N0P003W_N0P00
0W_N0P005g_N0P001W_N0P003G_N0P003G_N0P007W_N00Eg_G>LCW=g_Dic029kgP8003akgP05Mkec
W4icMke>L`0PNmh20003Nmh2000eNmh2Ool0000448@HaRe[9BT2Li`00dicNmikgP0NNmh2000GNmh2
0006Nmh2000ANmh2000NNmh01GNmLia>LgNmCW<087_N0P000g_N0P002G_N0P000W_N0P005g_N0P00
0W_N0P000W_N0P003G_N0P003G_N0P007W_N00Eg_G>LCW=g_Dic029kgP8003akgP05MkecW4icMke>
L`0PNmh20002Nmh2000fNmh2Ool0000448@HaRe[9BT2Li`00dicNmikgP0NNmh6000KNmh6000=Nmh2
000NNmh01GNmLia>LgNmCW<08G_N1@004W_N0P0057_N10008G_N0P007W_N00Eg_G>LCW=g_Dic021k
gPH003YkgP05MkecW4icMke>L`0PNmh5000gNmh2Ool0000448@HaRe[9BT2Li`00dicOomoo`1bOol0
1G_NMke>LgNmCW<0Tgoo00EkgWNmCW=g_Dic061oo`05Nmig_DicMke>L`1NOol0000448@HaRe[9BT2
Li`00dicOomoo`1cOol017_NCW=g_DicU7oo00AkgTicMke>Lf5oo`04Nmi>LgNmCW=NOol0000448@H
aRe[9BT2Li`00e[FLiaoo`1cOol01G>LF]Ig_E[FLi`0Tgoo00EcW5[FMkeJeW>L061oo`05LiaJeWNm
F]IcW01MOol0000448@HaRe[9BT2Li`00f]JG_McW01bOol01gNmG_M[FWNmJeYNmg>L095oo`07MkeN
mf]JMke[FUkgLi`0GWoo00Mg_EkgJeYg_F]JG_McW01LOol0000448@HaRe[9BT2Li`00gNmJeYJeP1b
CW<00eJeIcUg_@02Mkd00f]JF]I>L`2@CW<00eJeIcUg_@02Mkd00f]JF]I>L`1MCW<00eJeIcUg_@02
Mkd00f]JF]I>L`1ICW<2Ool0000448@HaRe[9BWoLicFLi`2Ool0000448@HaRe[9BWoLicFLi`2Ool0
000448@HaRe[9BWoLicFLi`2Ool0000448@HaRe[9BWoLicFLi`2Ool0000448@HaRe[9BWoLicFLi`2
Ool0000448@HaRe[9BWoLicFLi`2Ool0000448@HaRe[9BWoLicFLi`2Ool0000448@HaRe[9BWoLicF
Li`2Ool0000448@HaRe[9BWoLicFLi`2Ool0000448@HaRe[9BWoLicFLi`2Ool0000448@HaRe[9BT8
Li`3MkdGNmh00gNmLiacW03oLi`>Li`3MkdGNmh00gNmLiacW004Li`3MkdGNmh017NmLiacW7>L0gNm
5g_N00=g_G>LLi`0Ag>L0Woo000011246<H]JbDY2W>L00=:DRDY6<H04QS600@Lid8@NmikgPQcW003
JeYS66<H01=S6003IcUcW7>L0?1cW003BU8U:AS6018HaP047>M247_NNmh8Li`00dYB9BTHaP0B6<H0
11cW@Q1kgW_N1G>L00=:DRDY6<H04QS600@Lid8@NmikgTUcW09oo`0000@@Q1S6;F/U:@UcW003?Nla
S5Je01=W>@04F]HaS48@Nmh7Li`00fLiJeYcW00CNmh00gNmJeYW>@07LicSBU86Li`00cg_8@PicP0D
@Q000b48@Q1kgP07Li`00cg_<HaF]@0CIcT015[F<Ha247_N17>L00<mkc6<E[D04fLi00AJeS6<@Q1k
gTUcW09oo`0000@@Q1S6;F/U:@QcW003Kg/Lif<H01A_N`04JeYNmacWMkd7Li`00f<HMkekgP0DNmh0
0gNmHaQcW006Li`00dYBOomoo`3OOol00dYBLiacW003Li`00fmk7>MBU00FDY@00acWMkecW005Li`0
0fmk7>MS600DKg/016]JG_LLigNm0g>L00=_NacWHaP056mk00A[FUkg7>Mg_DUcW09oo`0000@@Q1S6
;F/U:@QcW003Kg/HaW>L01AcW09_N`036<Ig_G>L00IcW003HaQkgW_N01EkgP03HaQcW7>L00EcW003
BU9oogoo0=moo`03BU9cW7>L00=cW004Kg/HaU:DDY@CLi`2DY@00aS6MkecW005Li`00fmk6<IcW00D
Li`2Kg/00aS6MkecW002Li`00fmk6<IcW00DLi`2Kg/00aS6MkecW018Li`2Ool0000448@HaRe[9BT8
Li`00fmk6<Ig_@0DMkd017>LKg/HaWNm1g>L00=S67_NNmh05G_N00=S67>LLi`01G>L00=:DWooOol0
ggoo00=:DW>LLi`00g>L00A_NaS6DYABU1=g_@9BU0036<Ig_G>L00EcW003Kg/HaWNm01Ag_@04Lia_
NaS6Mkd3Li`00fmk6<Ig_@0DMkd017>LKg/HaWNmBG>L0Woo000011246<H]JbDY27>L00=_NaS6Mkd0
57Nm00AcW6mk6<Ig_@McW003HaQkgW_N01EkgP03HaQcW7>L00EcW003BU9oogoo0=moo`03BU9cW7>L
00=cW004Kg/HaU:DDY@CMkd2DY@00aS6MkecW005Li`00fmk6<Ig_@0DMkd017>LKg/HaWNm0g>L00=_
NaS6Mkd057Nm00AcW6mk6<Ig_DUcW09oo`0000@@Q1cW;F/U:@QcW003Kg/HaWNm00ag_@03IcUNmgNm
00Eg_@04Lia_NaS6Mkd7Li`00f<HNmikgP05Nmh00f<HNmikgP0=Nmh00f<HLiacW005Li`00dYBOomo
o`3OOol00dYBLiacW003Li`016mk6<IF]EJe17Nm0`0000=g_@00Mkd00WNm0`0017Nm0UJe00<HaWNm
Li`01G>L00=_NaS6Mkd057Nm00AcW6mk6<Ig_@=cW003Kg/HaWNm01Ag_@04Lia_NaS6Mke9Li`2Ool0
000448@Libe[9BT8Li`00fmk6<Ig_@0;Mkd00f<HDYA:DP06Mkd017>LKg/HaWNm1g>L00=S67_NNmh0
1G_N0U[F3W_N00=S67>LLi`01G>L00=:DWooOol00Woo10000goo00L007ooOomoo`00Ool00002Ool0
0`00Oomoo`03Ool00`00Oomoo`030003Ool2000017oo001oo`00^7oo00=:DW>LLi`00g>L00A_NaS6
E[EF]@=g_@04001g_GNmMkd20002Mkd01@00Mkeg_GNm00000gNm0UJe00<HaWNmLi`01G>L00=_NaS6
Mkd01GNm00=NmdYBBU801TYB00=JeWNmMkd00gNm00AcW6mk6<Ig_@=cW003Kg/HaWNm00Ug_@03F]IF
]GNm00Qg_@04Lia_NaS6Mke9Li`2Ool0000448@Libe[9BT8Li`00fmk6<Ig_@0:Mkd015[FBU96<DYB
1gNm00=cW1S6Mkd01g>L00=S67_NNmh01G_N00AJeUJeF]INm`akgP03HaQcW7>L00EcW005BU9oogoo
Ool00004Ool01000Oomoo`000goo00D007oo001oo`0000Eoo`04001oogoo0003Ool00`00Ool00002
Ool200000goo001oo`2gOol00dYBLiacW003Li`016mk6<IJeU[F0gNm00<007NmMkd00WNm00@007Nm
Mkd000=g_@04001g_GNmMkd2F]H00aS6MkecW005Li`00fmk6<Ig_@05Mkd00fLiDYA6<@04AS400d8@
?NmS6006Mkd00g>L6<Ig_@03Li`00fmk6<Ig_@08Mkd016<HCW=:DUkg2GNm00=cW1S6Mkd0BG>L0Woo
000011247>L]JbDY27>L00A_NaS6NmikgPMg_@03G_MBU4Ha0096<@03?Nmg_GNm00Eg_@03Li`HaWNm
00McW003HaQkgW_N00EkgP03F]IF]EJe009JeP]kgP03HaQcW7>L00EcW005BU9oogooOol00004Ool0
1000Oomoo`000goo00D007oo001oo`0000Eoo`04001oogoo0003Ool00`00Ool00003Ool00`00Ool0
002hOol00dYBLiacW003Li`016mk6<IJeU[F0gNm00<007NmMkd00WNm00@007NmMkd000=g_@04001g
_GNmMkd2F]H00aS6MkecW005Li`016mk6<IkgW_N1GNm00=Nmcg_?Nl00THa00<icRe[DY@01gNm00=c
W1S6Mkd00g>L00A_NaS6NmikgPMg_@04F]I6<DHaDY@9Mkd00g>L6<Ig_@19Li`2Ool0000448@Libe[
9BT8Li`016mk6<IkgW_N1GNm00=S65:DBU800dHa00=243W>Mkd01WNm00=cW1S6Mkd01g>L00=S67_N
Nmh01G_N00=JeUJeE[D00eJe00=JeV<HNmh01g_N00=S67>LLi`01G>L00E:DWooOomoo`0000Aoo`04
001oogoo0003Ool01@00Ool007oo00001Goo00@007ooOol000=oo`03001oo`0000=oo`03001oo`00
0;Qoo`03BU9cW7>L00=cW004Kg/HaUkgG_L3Mkd00`00Mkeg_@030002Mkd01@00Mkeg_GNm00000gNm
0Ukg00<HaWNmLi`01G>L00A_NaS6NmikgPIg_@06DY@icSg_?Nl]Jcg_27Nm00=cW1S6Mkd00g>L00A_
NaS6NmikgPIg_@03HaQ>LdHa0096<@03G_Mg_GNm00Ig_@03Li`HaWNm04UcW09oo`0000@@Q1cW;F/U
:@QcW003Kg/HaW_N00IkgP08G_M6<Cg_?Nm244Ha@Q0icPEkgP9g_@03Li`HaWNm00McW003HaQkgW_N
00EkgP05F]IF]EJeE[EBU002CW<00e[FNmikgP06Nmh00f<HLiacW005Li`01DYBOomoogoo000017oo
00<007ooOol00P000Woo00D007oo001oo`0000Eoo`04001oogoo0003Ool00`00Ool00003Ool00`00
Ool0002hOol00dYBLiacW003Li`016mk6<INmekg0g_N00<007_NNmh01W_N0`000g_N00Eg_EkgG_LH
aWNm00IcW003Kg/HaW_N00MkgP06HaQ6<CW><H`]Je[F1W_N0WNm00=cW1S6Mkd00g>L00=_NaS6Nmh0
1g_N00=F]DHaAS400THa00=>Lg_NNmh017_N0WNm00=cW1S6Mkd0BG>L0Woo000011247>L]JbDY27>L
00=_NaS6Nmh01g_N00MS64YB;F/aS3W>?NlicP06Nmh017NmLi`HaWNm1g>L00=S67_NNmh01G_N00MJ
eUJeDYA:DTHaDYAS6009Nmh00f<HLiacW005Li`01DYBOomoogoo000017oo00D007ooOol007oo0080
009oo`04001oo`000004Ool20002Ool30002Ool01P00Oomoogoo001oo`800;Moo`03BU9cW7>L00=c
W004Kg/HaV<HHaP3Nmh00`00NmikgP0=Nmh2HaP00aS6MkecW005Li`00fmk6<IkgP08Nmh015[F=JdU
:DHa27_N00Ag_G>L6<Ig_@=cW003Kg/HaW_N00IkgP03G_M:DTHa00A6<@03E[EkgW_N00AkgP04Mkec
W1S6Mke9Li`2Ool0000448@Libe[9BT8Li`00fmk6<IkgP09Nmh01E[F?NlYBRe[<H`01W_N00Ag_G>L
6<Ig_@McW003HaQkgW_N00EkgP05F]I>LdYBCW=Nm`0;Nmh00f<HLiacW005Li`01DYBOomoogoo0000
17oo00<007ooOol027oo00<007ooOol00goo00<007ooOol0aGoo00=:DW>LLi`00g>L00A_NaS6HaQS
60=kgP03001kgW_N009kgP03001kgW_N00QkgP9S60036<Ig_G>L00EcW003Kg/HaW_N00QkgP04IcU2
42e[G_L8Nmh017NmLi`HaWNm0g>L00=_NaS6Nmh01W_N00=>LdHa>Lh00S6<00@e[CW>?NmNm`EkgP04
MkecW1S6Mke9Li`2Ool0000448@Libe[9BT8Li`00fmk6<IkgP0:Nmh016<HDY@]JbU:1W_N00Ag_G>L
6<Ig_@McW003HaQkgW_N00EkgP04E[E:DUJeHaP<Nmh00f<HLiacW005Li`01DYBOomoogoo000017oo
00<007ooOol027oo00<007ooOol00goo00<007ooOol0aGoo00=:DW>LLi`00g>L00A_NaS6HaQS60Ak
gP@000]kgP04HaQW>AS6Mkd6Li`00fmk6<IkgP09Nmh2F]H9Nmh017NmLi`HaWNm0g>L00=_NaS6Nmh0
1G_N00=Nmcg_=Jd01Be[00<aS4icNmh017_N00Ag_G>L6<Ig_DUcW09oo`0000@@Q1cW;F/U:@QcW003
Kg/HaW_N00akgP03G_M>Lg_N00EkgP04MkecW1S6Mkd7Li`00f<HNmikgP05Nmh00e[FG_MkgP0=Nmh0
0f<HLiacW005Li`01DYBOomoogoo000017oo00<007ooOol01Woo00<007ooOol0cGoo00=:DW>LLi`0
0g>L00A_NaS6IcUW>A=kgP9W>@036<Ig_G>L00EcW003Kg/HaW_N01AkgP04MkecW1S6Mkd3Li`00fmk
6<IkgP0DNmh017NmLi`HaWNmBG>L0Woo000011247>L]JbDY27>L00=_NaS6Ool057oo00AkgWNm6<Ig
_@McW003HaQkgW_N01EkgP03HaQcW7>L00EcW003BU9oogoo0=moo`03BU9cW7>L00=cW004Kg/HaVLi
IcTCOol2IcT00aS6MkecW005Li`00fmk6<Ioo`0DOol017_NMkdHaWNm0g>L00=_NaS6Ool057oo00Ak
gWNm6<Ig_DUcW09oo`0000@@Q1cW;F/U:@QcW003Kg/HaWoo01Eoo`03NmhHaWNm00McW003HaQkgW_N
01EkgP03HaQcW7>L00EcW003BU9oogoo0=moo`03BU9cW7>L00=cW004Kg/HaVLiIcTCOol2IcT00aS6
MkecW005Li`00fmk6<Ioo`0EOol00g_N6<Ig_@03Li`00fmk6<Ioo`0EOol00g_N6<Ig_@19Li`2Ool0
000448@Libe[9BT8Li`00fmk9BUS600EOol00f<H9BUg_@07Li`00f<HLiakgP0DNmh00g>LHaQcW006
Li`00dYBOomoo`3OOol00dYBLiacW003Li`00fmk9BUW>@0FIcT00bDYMkecW005Li`00fmk9BUS600E
Ool00f<H9BUg_@03Li`00fmk9BUS600EOol00f<H9BUg_@19Li`2Ool0000448@HaRe[9BT8Li`016mk
AS4icVLi4goo00=_NcW>AS4027>L0V]J00=cW7_NNmh04G_N00=g_F]JJeX01g>L00=:DWooOol0ggoo
00=:DW>LLi`00g>L00=_NdHa8@P05Fmk00<Q24HaLi`01W>L00A_NdHa>LiW>A=oo`03Kg/icTHa00Ac
W004Kg]6<CW>IcTCOol00fmk>Li6<@1:Li`2Ool0000448@HaRe[9BT8Li`016mkLia6<BDY4aS600<L
icg_Li`02G>L00=[FV<HHaP04f<H00=W>G>LLi`01W>LhdYB1G>L00A_Ng>LAS4U:A<HaP037>Lmkg>L
00McW004Kg]cW4Ha9BTC6<H00acW?NmcW004Li`016mkLia6<BDY4aS600<Licg_Li`0BW>L0Woo0000
11246<H]JbDY2G>L36mk1f]J1Vmkog>L4W>L36mk1f]J1Vmk27>L36mk1f]J1Vmk1G>L36mk1f]J1Vmk
BW>L0Woo000011246<H]JbDYog>LeW>L0Woo000011246<H]JbDYog>LeW>L0Woo000011246<H]JbDY
og>LeW>L0Woo000011246<H]JbDYog>LeW>L0Woo000011246<H]JbDYog>LeW>L0Woo000011246<H]
JbDYog>LeW>L0Woo000011246<H]JbDYog>LeW>L0Woo000011246<H]JbDYog>LeW>L0Woo00001124
6<H]JbDYog>LeW>L0Woo000011246<H]JbDYog>LeW>L0Woo000011247>LLib48oacWeQcW0Woo0000
11247>LLib481AcW1R4800<U:B489BT022DYob48`2480Woo000011247>LQ224812DY1RU:2be[obU:
`BU:0Woo00000a247>LQ20049BT3:D[=;F_o:DX3:DX2Ool0000348@Lib48008U:@@YBWT]J`8<Hol]
JeH]J`9oo`0000@@Q1cW8@PU:@<YBPL]J`HaS6d]J`9oo`0336<]Jbe[0?l]Je@]J`9oo`0000@@Q1cW
8@PU:@<YBPL]J`DaS6h]J`9oo`0336<]Jbe[0?l]Je@]J`9oo`0000@@Q1cW8@PU:@<YBPM6<@03BU96
<DHa00E6<@D]J`8<H`05;F/YBPaS:DX]J`0236<2;F/0224836<Q224836<U:Be[9BT236<2;F/236<2
;F/236<2;F/01R485:D<HaS6:DX]J`8<H`8]J`8<H`8]J`8<H`8]J`088@P<Hb488@P<HbDY;F/U:@8<
H`8]J`8<H`8]J`058@PHaPaS6<HYBP02;F/01R4836<Q224836<U:@@]J`8<H`@]J`8<H`8]J`058@PD
Y@aS6<HYBP02;F/00bDY5:DU:@02Ool010aS6<H<Hb481Re[10aS00<DYB48;F/00Re[0PaS12e[00@Q
20aS36<Q20<]J`07:DX<HbU:;F/YBPaS:DX00Re[00DU:@aS36<LibU:008]J`058@PDY@aS6<HYBP02
;F/236?G;F]6:DX2Ool000045:DLib489BT2:DX2AS400eJeMkeg_@02Mkd00fLi>Lioo`05Ool01DHa
;F/]Jbe[:DX00Woo00D<He:DOom24248009oo`0:7>LYBV]JOom[FVmkOomBU2U:G_L2Ool2:DX2Ool0
30aS:DYoogoo36<YBVLiNmioogNmAS4Q209oo`0636<YBWooOol<HbU:0Woo00X<HbU:JeYoof]JKg]o
oe:D:DYNm`9oo`8YBP9oo`0?36<YBVLiMkeoogNmCW<Q22U:JeYoof]JKg]ooe:D00@YBP9oo`0436<Y
BRU::DX2Ool03@aS:DYW>G_NOomg_DHa8@PYBUkgNmiJeRU:009oo`05Mkeoofmk36<Q2004:DX4Ool0
1G_NJeX<HacW:DX00Woo00D<HbU::DXYBV]J009oo`0>JeX<Hb48:DYF]Goo@Q0Q25:DOom:DR48:DYN
m`9oo`0;Mke241BU:DYW>G_NOomg_DHa8@PYBP02Ool00`aS:DXYBP3o:DXL:DX2Ool000045:DLib48
9BT3:DX014HaMkeg_G_N0WNm00I_NcW>OomooeJeJeX2Ool00dHa:DXYBP02:DX03W>LOol<Hf]JOomS
61S6Oom_NacWKg]ood8@HaP2Ool01D8@:DYkgWoo36<00RU:0Woo00L<HbU:Oomoo`aSIcUoo`02HaP0
0g_NJeXYBP02Ool01PaS:DYoogoo36<YBP9oo`0536=_Ngoo@Q1S6002Ool01D8@:DYkgWoo36<00RU:
0Woo00`<HfLiOomS62U:Lia[FRU:Kg]ood8@HaP2Ool00d8@:DXYBP02:DX2Ool010aS:DXYBRU:0Woo
00<<HfLiOol00V<H00QkgV]J:DXYBW_NOol<HbU:0Woo00D<Hf<HOomW>ABU00@YBP9oo`0736<YBVmk
Oom[FPaS:DX00Woo01`<HbU::DY[FWooE[ES67ooHaPDYBU:Kg]oof<H5:E[FWooIcT<HbDYLia[FRU:
OomkgQBUIcUoo`9S6004Nmi[FRU::DX2Ool00`aS:DXYBP3o:DXL:DX2Ool0000448@Lib489BT3:DX2
AS401GNm>Lh]Jd8@Kg/00U:D00=F]Be[Ool00Woo00=6<BU::DX00RU:00YcW7oo36=g_GooMkd<Hgoo
Kg/Q209oo`0636<Q27ooOol<HbU:0Woo00<<HbU::DX00Woo00L<HbU:Oomoo`aSNmioo`0536<2Ool0
1PaS:DYoogoo36<YBP9oo`0536=oogoo36<Q2002Ool01@aS:DYoogoo36<00RU:0Woo00@<Hg_NOol<
H`@YBP9oo`0536<Q27ooOol<H`04:DX2Ool010aS:DXYBRU:0Woo00<<Hg_NOol01@aS00DYBWooOol<
HbU:009oo`0536<YBWooNmh<H`04:DX2Ool00`aS:DXYBP02Ool01@aS:DYoogoo36<00RU:00QkgWoo
36<YBWooNmh<HdYB0Woo00=kgPaSNmh00Woo00XicR48:DXU:EkgOomkgRDYNmioo`D<H`04:DYoogoo
36<K:D[o9BT39BT2Ool0000348@Lib48008U:@03:DY6<DHa00=g_@056<HicVmkHaQ:DP02;F/013g_
DYAS64YB0RU:0RDY00iW>Goo@Q1ooe[FOom6<GooHaPLig>LOomJeQBU0Woo00D<HbDYOomoo`aS008U
:@9oo`0536<U:GooOol<H`06Ool01ABUOomoo`aS9BT00Woo00T<HbDYOomoo`aSLiaooe[F5:D00Woo
00D<HbDYOomoo`aS008U:@9oo`0436=oogoo36<49BT017>LOomJeQBU0Woo00<<HbDY9BT00RDY0Woo
00@<HbDY9BTU:@9oo`0336=oogoo00Aoo`065:DU:GooOol<HbDY0Woo00D<HbDYOomooaBU00@U:@9o
o`0336<U:BDY009oo`057>LU:GooOol<H`029BT2Ool05@aS9BUoogoo5:EW>GooJeYoof]JOom[FWoo
HaPDYDicMkeoofmkCW<U:@06Ool01ABU9BUoogoo36<0obDY7RDY0Woo00000aBU7>LQ20029BT2:DX0
14HaDYAcW7>L1F<H0TYB0V<H00=oodHa:DX00bDY00eW>GooHaQg_AcWMkeW>GooHaPQ22DYKg]kgP03
Ool01AS69BUoogoo36<00RDY0Woo00`<Hb48OomooaS6Nmioo`aS8@Qoog_N7>L2Ool01PaS8@Qoogoo
36<Q209oo`045:DU:FmkNmh3Ool01AS69BUoogoo36<00RDY0Woo00H<HgNmOol<HacW9BT27>L00bDY
Kg]kgP03Ool00aS69BTU:@029BT2Ool436<2Ool02@aSNmioo`aS8@Qoog_N7>LU:@02Ool02@aS9BUo
ogoo36<U:GooNmhLi`049BT2Ool236<01F<HOom[FR489BT00Woo00X<Hb488@QkgWoo36<Q27ooNmhL
i`9kgP057>MkgWooNmhLi`02Nmh03`aSMkeoodYB9BTHaR48Nmioo`aS8@Qoog_N7>LU:@02Ool00`aS
8@PQ203o9BTL9BT2Ool000035:DLib4800<U:@07:DY6<CF]>LiBU6mkHaP00U:D00A:DRe[HaQg_@9o
o`0?AS4YBRU::DXU:EJeOomg_F<H8@Q[FWNmOom:DR48008U:@065:E247ooLi`Q22DY0Woo0PaS00lU
:GooOom245:DOomcW248Kg]ooekgDYAoof]J9BT00Woo00UNmdHaOomoodicBU9oogNm8@P00RDY00HD
YD8@OomcW2489BT2Ool236<02bDYOomoo`aSIcUoofLi5:E[FV<H8@P00RDY00DDYD8@OomcW24800@U
:@Qoo`0736=_NgooG_MBU7ooJeX00RDY0Woo00P<HbDYOomoo`aSG_Moof]J1BDY1Woo00=F]ABU9BT0
0Woo0UJe01hDYF]JOomJeU:DOomW>EkgOomS6248JeYoof<H8@Q[FWooE[EkgWoo@Q1cW5kg8@Q_Ngoo
G_MBU7ooJeX29BT2Ool2E[D00aBU9BTU:@3o9BTJ9BT2Ool0000348@HaQcW00<U:@96<@04G_Mg_Ekg
BU82HaP01E:D>LhicV<HMkd00Woo00=6<BU::DX00RDY00IF]GooOom6<BDYCW<2Ool014YB9BTU:GNm
0Woo00=cW4ic9BT017oo0RDY0Woo00A_NgooMke>L`8U:@04Kg]oogooKg/29BT02WooIcUg_GooLiaF
]G>LOomg_Dic0RDY00Ig_GooOomcW4ic9BT4Ool012DYOomoogoo0RDY00EW>GNmOomg_E[F008U:@05
MkeoogooLia>L`059BT2Ool010aS9BTU:BDY0Woo00<<HbDYKg/00Woo00A_NbDY9BTU:@9oo`0736<U
:GooOomg_GooLi`01RDY0Woo00L<HbDYIcUoogNm36<U:@02Ool01FmkMkdU:BDYKg/00Woo019_NbDY
Mkeoodic9BU>LgooCW<U:DicOomg_E[FMkeoogNmCW<29BT016mkOomoofmk0bDY0Woo00=_NgNm9BT0
obDY72DY0Woo000011246<HLib480bDY00Y6<EJeMke[FSW>HaQ:DSW>;F/icPAS6003CW<YBRU:00<U
:@03Oomg_AcW008U:@03Mkeoo`aS00TU:@9oo`035:DU:BDY009oo`0336<U:BDY01`U:@9oo`045:DU
:BDY9BT26<HB9BT2Ool010aS9BTU:BDY0Woo00<<HbDY9BT01RDY0Woo00<<HbDY9BT02RDY0Woo00<<
HbDY9BT00Woo00<HaRDY9BT0obDYA2DY0Woo000011246<HLib480bDY00I6<GNmIcU:DSW>BU82>Lh0
12e[6<IBU5:D0Woo00=:DRDY9BT00bDY00=oofLi8@P00RDY00=[FWoo6<H02BDY00=[FWNm9BT00RDY
0Woo00<DYBDY9BT072DY00=[FWNm9BT00RDY00=g_G>L6<H04RDY0Woo00@<HbDY9BTU:@9oo`0336<U
:BDY00HU:@9oo`035:DU:BDY00XU:@9oo`8<H`03F]Ioog>L0?lU:DLU:@9oo`0000@@Q1S67>LQ208U
:@96<@05>LiBU7NmJeYBU002HaP015:D>LhicUJe0Woo00=6<BDY9BT00bDY00=cW4ic9BT00RDY00=>
Lg>L9BT03RDY00=cW7_N9BT08bDY0WNm4bDY0Woo12DY0Woo2BDY00=cW7_N9BT032DY17oo00=g_Fmk
9BT0obDYAbDY0Woo000011246<HLib480bDY00U6<FmkMkeg_F]JHaQkgV]JDY@00V]J00ABU7ooOom6
<OlU:L@U:@9oo`0000@@Q1S67>LQ20<U:@09AS5>LgNmMkeBU7_NOom[FU:D009oo`04Kg]W>GooAS7o
9BW49BT2Ool0000648@HaQcW7>LQ22DY0THa0WNm00=kgWNmOol00Woo00=BU7ooOol00goo00=6<BDY
9BT0obDY`RDY0Woo000011246<HLiacW0R4800<U:DHaAS401THa00=:DTHaAS4014HaobDYa2DY0Woo
00000a246<HLi`038@P39BT<:D[o9BW59BT2Ool0008HaP047>LQ22488@P39BTA:D[o9BW09BT2Ool0
00036<HQ224800<Q20<U:@HYBP@]JolYB/LYBP9oo`0000=[FQcW8@P01BDY0bU:4Be[obU:_RU:0Woo
000016]J7>LU:B481BU:0be[00HaS2e[;F/]Jc6<;F/2<H`2;F/0136<;F/]Jc6<obe[`2e[0Woo0002
JeX01248:DXYBRe[0c6<0SF]0cW>13g_0d8@ocg_aCg_0Woo0003JeX28@P00bU:;F/aS002=Jd2>Lh0
0cg_@Q12403o@Q3;@Q02Ool000EBU0<Q208Li`<Q20HU:@8YBP039BTYBRU:00<YB_lU:KlU:@9oo`00
\
\>"],
  ImageRangeCache->{{{0, 474}, {226, 0}} -> {-0.00237003, 0.9981, 1.00001, \
1.00001}},
  CellTags->"Installation notes"],

Cell[TextData[{
  "The file ",
  Cell[BoxData[
      \(UnitSourceCode . nb\)]],
  " is for full documentation purposes, but don't need to live at specific \
location. Fraternally, good luck. Alvaro."
}], "Text",
  CellTags->"Installation notes"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Documentation Notes", "Subsection"],

Cell[CellGroupData[{

Cell["Unit tour", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->"Unit tour"],

Cell["\<\
Unit package is intended to provide some tools to work with units. This a \
tour show some Unit package features. To do this tour, we clean something\
\>", "Text",
  CellTags->"Unit tour"],

Cell[BoxData[{
    \(\(Clear[a, b, c, h, kg, mi, x, \[ScriptCapitalU], LTimesM, 
        Mass];\)\), "\[IndentingNewLine]", 
    \(Off[General::"\<spell\>"]; Off[General::"\<spell1\>"];\)}], "Input",
  CellLabel->"In[3]:=",
  CellTags->"Unit tour"],

Cell["This loads the package", "MathCaption",
  CellTags->"Unit tour"],

Cell[BoxData[
    \(Needs["\<adMath`Unit`\>"]\)], "Input",
  CellLabel->"In[5]:=",
  CellTags->"Unit tour"],

Cell[TextData[{
  "Units can be entered in abbreviated or long form, without interference \
with ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " variables"
}], "MathCaption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(m = 100; s = 200;\), "\[IndentingNewLine]", 
    \({3\ Unit[m/s], 3\ Unit[Meter/Second]}\)}], "Input",
  CellLabel->"In[6]:=",
  CellTags->"Unit tour"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"3", " ", 
          TagBox[
            StyleBox[\("m"\/"s"\),
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"3", " ", 
          TagBox[
            StyleBox[\("m"\/"s"\),
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Output",
  CellLabel->"Out[7]=",
  CellTags->"Unit tour"]
}, Closed]],

Cell["\<\
Units can combined in acceptable forms to obtanin the result in default \
system\
\>", "MathCaption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{

Cell[BoxData[
    \(3. \ Unit[lbf\/in\^2] + 65. \ Unit[N\/ft\^2]\)], "Input",
  CellLabel->"In[8]:=",
  CellTags->"Unit tour"],

Cell[BoxData[
    RowBox[{"21383.91854561487`", " ", 
      TagBox[
        StyleBox["\<\"Pa\"\>",
          ShowStringCharacters->False,
          FontSlant->"Plain",
          FontColor->GrayLevel[0.500008]],
        Unit]}]], "Output",
  CellLabel->"Out[8]=",
  CellTags->"Unit tour"]
}, Closed]],

Cell["Default system can be changed", "MathCaption",
  CellTags->"Unit tour"],

Cell[BoxData[
    \(\($Unit = UnitFPS;\)\)], "Input",
  CellLabel->"In[9]:=",
  CellTags->"Unit tour"],

Cell[CellGroupData[{

Cell[BoxData[
    \(3. \ Unit[lbf\/in\^2] + 65. \ Unit[N\/ft\^2]\)], "Input",
  CellLabel->"In[10]:=",
  CellTags->"Unit tour"],

Cell[BoxData[
    RowBox[{"3.1014762958866444`", " ", 
      TagBox[
        StyleBox[\("lbf"\/"in"\^2\),
          ShowStringCharacters->False,
          FontSlant->"Plain",
          FontColor->GrayLevel[0.500008]],
        Unit]}]], "Output",
  CellLabel->"Out[10]=",
  CellTags->"Unit tour"]
}, Closed]],

Cell[BoxData[
    \(\($Unit = UnitMKS;\)\)], "Input",
  CellLabel->"In[11]:=",
  CellTags->"Unit tour"],

Cell["Is easy obtain information about any unit", "MathCaption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{

Cell[BoxData[
    \(UnitI@Unit["\<F\>"]\)], "Input",
  CellLabel->"In[12]:=",
  FormatType->TraditionalForm,
  CellTags->"Unit tour"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"Information About: \"\>", \
"\<\"\\!\\(\\*TagBox[StyleBox[\\\"\\\\\\\"F\\\\\\\"\\\", Rule[FontSlant, \
Plain], Rule[ShowStringCharacters, False], Rule[FontColor, GrayLevel[0.5`]]], \
Unit]\\)\"\>"},
          {"\<\" \"\>", "\<\"------------------------------\"\>"},
          {"\<\"Dimensions:        \"\>", \
"\<\"\\!\\(\\\"\\\\!\\\\(\\\\*TagBox[StyleBox[\\\\\\\"\\\\\\\\\\\\\\\"\
ElectricCapacitance\\\\\\\\\\\\\\\"\\\\\\\", Rule[FontSlant, Plain], \
Rule[ShowStringCharacters, False], Rule[FontColor, GrayLevel[0.5`]]], Unit]\\\
\\)\\\" \[Rule] \
\\\"\\\\!\\\\(\\\\*TagBox[StyleBox[\\\\(\\\\(\\\\\\\"ElectricCurrent\\\\\\\"\\\
\\^2\\\\\\\\ \
\\\\\\\"Time\\\\\\\"\\\\^4\\\\)\\\\/\\\\(\\\\\\\"Length\\\\\\\"\\\\^2\\\\\\\\ \
\\\\\\\"Mass\\\\\\\"\\\\)\\\\), Rule[FontSlant, Plain], \
Rule[ShowStringCharacters, False], Rule[FontColor, GrayLevel[0.5`]]], Unit]\\\
\\)\\\"\\)\"\>"},
          {"\<\"Other Names:       \"\>", \
"\<\"\\!\\({\\\"Farad\\\"}\\)\"\>"},
          {"\<\"\\!\\(UnitCGS\\) Equivalent:\"\>", 
            RowBox[{"1.`*^-7", " ", 
              TagBox[
                StyleBox[\(\("A"\^2\ "s"\^4\)\/\("cm"\^2\ "gr"\)\),
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}]},
          {"\<\"\\!\\(UnitFPS\\) Equivalent:\"\>", 
            RowBox[{"0.04214011051143175`", " ", 
              TagBox[
                StyleBox[\(\("A"\^2\ "s"\^4\)\/\("ft"\^2\ "lb"\)\),
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}]},
          {"\<\"\\!\\(UnitMKS\\) Equivalent:\"\>", "\<\"F is a Derived \
Unit.\"\>"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ BoxForm`e$, TableAlignments -> Left]]]], "Output",
  CellLabel->"Out[12]//StandardForm=",
  CellTags->"Unit tour"]
}, Closed]],

Cell[TextData[{
  "Defined unit names are (delete ",
  Cell[BoxData[
      \(\(\(//\)\(Short\)\)\)]],
  " to see de entire list)"
}], "MathCaption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{

Cell[BoxData[
    \(UnitI[Names] // Short\)], "Input",
  CellLabel->"In[13]:=",
  FormatType->TraditionalForm,
  CellTags->"Unit tour"],

Cell[BoxData[
    TagBox[\({"A", "\[CapitalARing]", "\!\(a\_0\)", "abA", 
        "AbAmpere", \[LeftSkeleton]570\[RightSkeleton], 
        "\[Degree]\[DoubleStruckCapitalC]", 
        "\[Degree]\[DoubleStruckCapitalF]", 
        "\[Degree]\[DoubleStruckCapitalK]", 
        "\[Degree]\[DoubleStruckCapitalR]", "\[HBar]"}\),
      Short]], "Output",
  CellLabel->"Out[13]//Short=",
  CellTags->"Unit tour"]
}, Closed]],

Cell["Units can be easy entered in Standardad or Traditional form", \
"MathCaption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"{", 
          RowBox[{
            RowBox[{"a", " ", 
              TagBox[
                StyleBox["N",
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}], ",", 
            RowBox[{"b", " ", 
              TagBox[
                StyleBox["J",
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}], ",", 
            RowBox[{"c", " ", 
              TagBox[
                StyleBox["W",
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}]}], "}"}], "//", "UnitFPS"}], "//", "N"}]], "Input",
  CellLabel->"In[14]:=",
  CellTags->"Unit tour"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"0.2248090247334889`", " ", "a", " ", 
          TagBox[
            StyleBox["\<\"lbf\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"0.7375624171046226`", " ", "b", " ", 
          RowBox[{"(", 
            TagBox[
              StyleBox[\("ft"\ "lbf"\),
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit], ")"}]}], ",", 
        RowBox[{"0.0013410218586562962`", " ", "c", " ", 
          TagBox[
            StyleBox["\<\"HP\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Output",
  CellLabel->"Out[14]=",
  CellTags->"Unit tour"]
}, Closed]],

Cell["Unit package can do dimensional analysis", "MathCaption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{

Cell[BoxData[
    \(X = {a\ Unit[N\ m], b\ Unit[lbf\ ft]}\)], "Input",
  CellLabel->"In[15]:=",
  FormatType->TraditionalForm,
  CellTags->"Unit tour"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"a", " ", 
          TagBox[
            StyleBox["\<\"J\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        FractionBox[
          RowBox[{"84738591", " ", "b", " ", 
            TagBox[
              StyleBox["\<\"J\"\>",
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}], "62500000"]}], "}"}]], "Output",
  CellLabel->"Out[15]=",
  CellTags->"Unit tour"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(UnitD[X]\)], "Input",
  CellLabel->"In[16]:=",
  FormatType->TraditionalForm,
  CellTags->"Unit tour"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        TagBox[
          StyleBox[\(\("Length"\^2\ "Mass"\)\/"Time"\^2\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit], ",", 
        TagBox[
          StyleBox[\(\("Length"\^2\ "Mass"\)\/"Time"\^2\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}], "}"}]], "Output",
  CellLabel->"Out[16]=",
  CellTags->"Unit tour"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(UnitN[X]\)], "Input",
  CellLabel->"In[17]:=",
  FormatType->TraditionalForm,
  CellTags->"Unit tour"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        TagBox[
          StyleBox["\<\"Energy\"\>",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit], ",", 
        TagBox[
          StyleBox["\<\"Energy\"\>",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}], "}"}]], "Output",
  CellLabel->"Out[17]=",
  CellTags->"Unit tour"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Unit[Energy]\)], "Input",
  CellLabel->"In[18]:=",
  FormatType->TraditionalForm,
  CellTags->"Unit tour"],

Cell[BoxData[
    TagBox[
      StyleBox["\<\"J\"\>",
        ShowStringCharacters->False,
        FontSlant->"Plain",
        FontColor->GrayLevel[0.500008]],
      Unit]], "Output",
  CellLabel->"Out[18]=",
  CellTags->"Unit tour"]
}, Closed]],

Cell[TextData[{
  "Your previous work don't be lost. Because ",
  Cell[BoxData[
      \(Unit\)]],
  " take the units names from ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " standard package for units ",
  ButtonBox["Miscellaneous`Units`",
    ButtonStyle->"AddOnsLink"],
  ", units can be converted to ",
  Cell[BoxData[
      \(Unit\)]],
  " format"
}], "MathCaption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{

Cell[BoxData[
    \(100\ Meter/Second // UnitS\)], "Input",
  CellLabel->"In[19]:=",
  FormatType->TraditionalForm,
  CellTags->"Unit tour"],

Cell[BoxData[
    RowBox[{"100", " ", 
      TagBox[
        StyleBox[\("m"\/"s"\),
          ShowStringCharacters->False,
          FontSlant->"Plain",
          FontColor->GrayLevel[0.500008]],
        Unit]}]], "Output",
  CellLabel->"Out[19]=",
  CellTags->"Unit tour"]
}, Closed]],

Cell[TextData[{
  "Unit package not interfere with ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " Miscellaneous",
  StyleBox["`", "MB"],
  "Units",
  StyleBox["`", "MB"],
  "(we need to clean only the symbol ",
  Cell[BoxData[
      \(Meters\)]],
  " because ",
  StyleBox["we",
    FontSlant->"Italic"],
  " use it. ",
  Cell[BoxData[
      \(Seconds\)]],
  " is a symbol of ",
  Cell[BoxData[
      \(`System\)]],
  ")"
}], "MathCaption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(Needs["\<Miscellaneous`Units`\>"]\), "\[IndentingNewLine]", 
    \(Remove[Meter]\)}], "Input",
  CellLabel->"In[20]:=",
  CellTags->"Unit tour"],

Cell[BoxData[
    RowBox[{\(Meter::"shdw"\), \(\(:\)\(\ \)\), "\<\"Symbol \\!\\(\\\"Meter\\\
\"\\) appears in multiple contexts \\!\\({\\\"Miscellaneous`SIUnits`\\\", \
\\\"Global`\\\"}\\); definitions in context \
\\!\\(\\\"Miscellaneous`SIUnits`\\\"\\) may shadow or be shadowed by other \
definitions. \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::shdw\\\"]\\)\"\>"}]], "Message",
  CellLabel->"From In[20]:=",
  CellTags->"Unit tour"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \({10. \ Feet, 1000. \ Horsepower} // SI\)], "Input",
  CellLabel->"In[22]:=",
  CellTags->"Unit tour"],

Cell[BoxData[
    \({3.048`\ Meter, 745700.`\ Watt}\)], "Output",
  CellLabel->"Out[22]=",
  CellTags->"Unit tour"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \({10. \ Unit[ft], \ 1000. \ Unit[HP]}\)], "Input",
  CellLabel->"In[23]:=",
  CellTags->"Unit tour"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"3.048`", " ", 
          TagBox[
            StyleBox["\<\"m\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"745700.`", " ", 
          TagBox[
            StyleBox["\<\"W\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Output",
  CellLabel->"Out[23]=",
  CellTags->"Unit tour"]
}, Closed]],

Cell[TextData[{
  "There are some differences with ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " package. For example, ",
  Cell[BoxData[
      \(Unit\)]],
  " belive that convertion factors are ",
  StyleBox["exact",
    FontSlant->"Italic"]
}], "MathCaption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{\(550\ Feet\ PoundForce\ Second\^\(-1\) // SI\), ",", 
        RowBox[{"550", " ", 
          TagBox[
            StyleBox[\(\(ft\ lbf\)\/s\),
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Input",
  CellLabel->"In[24]:=",
  CellTags->"Unit tour"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{\(\(745.6996008`\ Meter\ Newton\)\/Second\), ",", 
        FractionBox[
          RowBox[{"932124501", " ", 
            TagBox[
              StyleBox["\<\"W\"\>",
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}], "1250000"]}], "}"}]], "Output",
  CellLabel->"Out[24]=",
  CellTags->"Unit tour"]
}, Closed]],

Cell["Unit package gives the result in the adecuate unit", "MathCaption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(p = 3.  PoundForce\/Inch\^2 + 65.  Newton\/Feet\^2;\)\), "\n", 
    \({SI[p], UnitS[p]}\), "\[IndentingNewLine]", 
    \(\(Clear[p];\)\)}], "Input",
  CellLabel->"In[25]:=",
  CellTags->"Unit tour"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{\(\(21383.91854561487`\ Newton\)\/Meter\^2\), ",", 
        RowBox[{"21383.918545614866`", " ", 
          TagBox[
            StyleBox["\<\"Pa\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Output",
  CellLabel->"Out[26]=",
  CellTags->"Unit tour"]
}, Closed]],

Cell[TextData[{
  Cell[BoxData[
      \(UnitSimplify\)]],
  " can do some jobs"
}], "MathCaption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{

Cell[BoxData[
    SqrtBox[
      RowBox[{
        SuperscriptBox[
          RowBox[{"(", 
            FractionBox[
              RowBox[{
                RowBox[{\(a\_1\), 
                  TagBox[
                    StyleBox["C",
                      ShowStringCharacters->False,
                      FontSlant->"Plain",
                      FontColor->GrayLevel[0.500008]],
                    Unit]}], "-", 
                RowBox[{\(a\_2\), 
                  TagBox[
                    StyleBox["C",
                      ShowStringCharacters->False,
                      FontSlant->"Plain",
                      FontColor->GrayLevel[0.500008]],
                    Unit]}]}], 
              RowBox[{\(c\_1\), 
                TagBox[
                  StyleBox["F",
                    ShowStringCharacters->False,
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit]}]], ")"}], "2"], "+", 
        SuperscriptBox[
          RowBox[{"(", 
            FractionBox[
              RowBox[{
                RowBox[{\(b\_1\), 
                  TagBox[
                    StyleBox["C",
                      ShowStringCharacters->False,
                      FontSlant->"Plain",
                      FontColor->GrayLevel[0.500008]],
                    Unit]}], "-", 
                RowBox[{\(b\_2\), 
                  TagBox[
                    StyleBox["C",
                      ShowStringCharacters->False,
                      FontSlant->"Plain",
                      FontColor->GrayLevel[0.500008]],
                    Unit]}]}], 
              RowBox[{\(c\_2\), 
                TagBox[
                  StyleBox["F",
                    ShowStringCharacters->False,
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit]}]], ")"}], "2"]}]]], "Input",
  CellLabel->"In[28]:=",
  CellTags->"Unit tour"],

Cell[BoxData[
    SqrtBox[
      RowBox[{
        FractionBox[
          RowBox[{
            SuperscriptBox[
              RowBox[{"(", 
                RowBox[{
                  RowBox[{\(a\_1\), " ", 
                    TagBox[
                      StyleBox["\<\"C\"\>",
                        ShowStringCharacters->False,
                        FontSlant->"Plain",
                        FontColor->GrayLevel[0.500008]],
                      Unit]}], "-", 
                  RowBox[{\(a\_2\), " ", 
                    TagBox[
                      StyleBox["\<\"C\"\>",
                        ShowStringCharacters->False,
                        FontSlant->"Plain",
                        FontColor->GrayLevel[0.500008]],
                      Unit]}]}], ")"}], "2"], " ", 
            TagBox[
              StyleBox[\(\("kg"\^2\ "m"\^4\)\/\("A"\^4\ "s"\^8\)\),
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}], \(c\_1\%2\)], "+", 
        FractionBox[
          RowBox[{
            SuperscriptBox[
              RowBox[{"(", 
                RowBox[{
                  RowBox[{\(b\_1\), " ", 
                    TagBox[
                      StyleBox["\<\"C\"\>",
                        ShowStringCharacters->False,
                        FontSlant->"Plain",
                        FontColor->GrayLevel[0.500008]],
                      Unit]}], "-", 
                  RowBox[{\(b\_2\), " ", 
                    TagBox[
                      StyleBox["\<\"C\"\>",
                        ShowStringCharacters->False,
                        FontSlant->"Plain",
                        FontColor->GrayLevel[0.500008]],
                      Unit]}]}], ")"}], "2"], " ", 
            TagBox[
              StyleBox[\(\("kg"\^2\ "m"\^4\)\/\("A"\^4\ "s"\^8\)\),
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}], \(c\_2\%2\)]}]]], "Output",
  CellLabel->"Out[28]=",
  CellTags->"Unit tour"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(% // UnitSimplify\)], "Input",
  CellLabel->"In[29]:=",
  CellTags->"Unit tour"],

Cell[BoxData[
    RowBox[{\(\@\(\((a\_1 - a\_2)\)\^2\/c\_1\%2 + \((b\_1 - \
b\_2)\)\^2\/c\_2\%2\)\), " ", 
      TagBox[
        StyleBox["\<\"V\"\>",
          ShowStringCharacters->False,
          FontSlant->"Plain",
          FontColor->GrayLevel[0.500008]],
        Unit]}]], "Output",
  CellLabel->"Out[29]=",
  CellTags->"Unit tour"]
}, Closed]],

Cell[TextData[{
  Cell[BoxData[
      \(UnitConvert\)]],
  " is designed to work like postfix operator"
}], "MathCaption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"6.", 
        TagBox[
          StyleBox["Parsec",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}], "//", 
      RowBox[{"UnitConvert", "[", 
        TagBox[
          StyleBox["\<\"AU\"\>",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit], "]"}]}]], "Input",
  CellLabel->"In[30]:=",
  CellTags->"Unit tour"],

Cell[BoxData[
    RowBox[{"1.2375978293219376`*^6", " ", 
      TagBox[
        StyleBox["\<\"AU\"\>",
          ShowStringCharacters->False,
          FontSlant->"Plain",
          FontColor->GrayLevel[0.500008]],
        Unit]}]], "Output",
  CellLabel->"Out[30]=",
  CellTags->"Unit tour"]
}, Closed]],

Cell["\<\
Unit package manipulate either temperature units or temperature scales \
(adding a \[Degree] to the temperature symbol)\
\>", "MathCaption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"100.", " ", 
          TagBox[
            StyleBox["\[DoubleStruckCapitalC]",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"100.", " ", 
          TagBox[
            StyleBox["\[DoubleStruckCapitalF]",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Input",
  CellLabel->"In[31]:=",
  CellTags->"Unit tour"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"100.`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalK]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"55.55555555555556`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalK]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Output",
  CellLabel->"Out[31]=",
  CellTags->"Unit tour"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"100.", " ", 
          TagBox[
            StyleBox["\[Degree]\[DoubleStruckCapitalC]",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"100.", " ", 
          TagBox[
            StyleBox["\[Degree]\[DoubleStruckCapitalF]",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Input",
  CellLabel->"In[32]:=",
  CellTags->"Unit tour"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"373.15`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalK]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"310.92777777777775`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalK]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Output",
  CellLabel->"Out[32]=",
  CellTags->"Unit tour"]
}, Closed]],

Cell["Unit package provide some few usefull constants. ", "MathCaption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{

Cell[BoxData[
    \(UnitI@Unit["\<\[HBar]\>"]\)], "Input",
  CellLabel->"In[33]:=",
  CellTags->"Unit tour"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"Information About: \"\>", \
"\<\"\\!\\(\\*TagBox[StyleBox[\\\"\\\\\\\"\[HBar]\\\\\\\"\\\", \
Rule[FontSlant, Plain], Rule[ShowStringCharacters, False], Rule[FontColor, \
GrayLevel[0.5`]]], Unit]\\) (Constant)\"\>"},
          {"\<\" \"\>", "\<\"------------------------------\"\>"},
          {"\<\"Relative Uncertainty\"\>", \
"\<\"\\!\\(1.1000000000000002`*^-40\\)\"\>"},
          {"\<\"Dimensions:        \"\>", \
"\<\"\\!\\(\\\"\\\\!\\\\(\\\\*TagBox[StyleBox[\\\\\\\"\\\\\\\\\\\\\\\"Action\\\
\\\\\\\\\\\\\"\\\\\\\", Rule[FontSlant, Plain], Rule[ShowStringCharacters, \
False], Rule[FontColor, GrayLevel[0.5`]]], Unit]\\\\)\\\" \[Rule] \\\"\\\\!\\\
\\(\\\\*TagBox[StyleBox[\\\\(\\\\(\\\\\\\"Length\\\\\\\"\\\\^2\\\\\\\\ \\\\\\\
\"Mass\\\\\\\"\\\\)\\\\/\\\\\\\"Time\\\\\\\"\\\\), Rule[FontSlant, Plain], \
Rule[ShowStringCharacters, False], Rule[FontColor, GrayLevel[0.5`]]], Unit]\\\
\\)\\\"\\)\"\>"},
          {"\<\"Other Names:       \"\>", "\<\"\\!\\({\\\"PlanckConstant\\\"}\
\\)\"\>"},
          {"\<\"\\!\\(UnitCGS\\) Equivalent:\"\>", 
            RowBox[{"6.626069000000001`*^-27", " ", 
              TagBox[
                StyleBox[\(\("cm"\^2\ "gr"\)\/"s"\),
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}]},
          {"\<\"\\!\\(UnitFPS\\) Equivalent:\"\>", 
            RowBox[{"1.572390038750013`*^-32", " ", 
              TagBox[
                StyleBox[\(\("ft"\^2\ "lb"\)\/"s"\),
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}]},
          {"\<\"\\!\\(UnitMKS\\) Equivalent:\"\>", 
            RowBox[{"6.626069000000001`*^-34", " ", 
              TagBox[
                StyleBox[\(\("kg"\ "m"\^2\)\/"s"\),
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}]}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ BoxForm`e$, TableAlignments -> Left]]]], "Output",
  CellLabel->"Out[33]//StandardForm=",
  CellTags->"Unit tour"]
}, Closed]],

Cell["Is easy to change unit's default output", "MathCaption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(Unit[
        Set, "\<m\>" \[Rule] \(125\/201168\) "\<mi\>", "\<s\>" \[Rule] \
"\<h\>"\/3600];\)\), "\[IndentingNewLine]", 
    \(50. \ Unit[cm/s]\)}], "Input",
  CellLabel->"In[34]:=",
  CellTags->"Unit tour"],

Cell[BoxData[
    RowBox[{"1.1184681460272012`", " ", 
      TagBox[
        StyleBox[\("mi"\/"h"\),
          ShowStringCharacters->False,
          FontSlant->"Plain",
          FontColor->GrayLevel[0.500008]],
        Unit]}]], "Output",
  CellLabel->"Out[35]=",
  CellTags->"Unit tour"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(Unit[Set, All];\)\), "\[IndentingNewLine]", 
    \(50. \ Unit[cm/s]\)}], "Input",
  CellLabel->"In[36]:=",
  CellTags->"Unit tour"],

Cell[BoxData[
    RowBox[{"0.5`", " ", 
      TagBox[
        StyleBox[\("m"\/"s"\),
          ShowStringCharacters->False,
          FontSlant->"Plain",
          FontColor->GrayLevel[0.500008]],
        Unit]}]], "Output",
  CellLabel->"Out[37]=",
  CellTags->"Unit tour"]
}, Closed]],

Cell["Unit package can control the precision of the results. ", "MathCaption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(X = {3\ a\ Unit[N], f[x]\ Unit[N\ m], 
          Unit[N/lb]};\)\), "\[IndentingNewLine]", 
    \(UnitFPS[X]\)}], "Input",
  CellLabel->"In[38]:=",
  FormatType->TraditionalForm,
  CellTags->"Unit tour"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        FractionBox[
          RowBox[{"50000", " ", "a", " ", 
            TagBox[
              StyleBox["\<\"lbf\"\>",
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}], "74137"], ",", 
        FractionBox[
          RowBox[{"61880511", " ", \(f[x]\), " ", 
            RowBox[{"(", 
              TagBox[
                StyleBox[\("ft"\ "lbf"\),
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit], ")"}]}], "83898677"], ",", 
        FractionBox[
          RowBox[{"3674371", " ", 
            TagBox[
              StyleBox[\("ft"\/"s"\^2\),
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}], "508000"]}], "}"}]], "Output",
  CellLabel->"Out[39]=",
  CellTags->"Unit tour"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(SetOptions[Unit, N \[Rule] 4];\)\), "\[IndentingNewLine]", 
    \(UnitFPS[X]\)}], "Input",
  CellLabel->"In[40]:=",
  CellTags->"Unit tour"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"0.6744270742004667035`3.698970004336019", " ", "a", " ", 
          TagBox[
            StyleBox["\<\"lbf\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{
        "0.7375624171046225199`3.999999999999999", " ", \(f[x]\), " ", 
          RowBox[{"(", 
            TagBox[
              StyleBox[\("ft"\ "lbf"\),
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit], ")"}]}], ",", 
        RowBox[{"7.2330137795275590552`3.698970004336019", " ", 
          TagBox[
            StyleBox[\("ft"\/"s"\^2\),
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Output",
  CellLabel->"Out[41]=",
  CellTags->"Unit tour"]
}, Closed]],

Cell[BoxData[
    \(\(SetOptions[Unit, N \[Rule] False];\)\)], "Input",
  CellLabel->"In[42]:=",
  CellTags->"Unit tour"],

Cell["Unit package can change the appearance of units", "MathCaption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(SetOptions[Unit, 
        StyleBox \[Rule] {\[IndentingNewLine]FontColor \[Rule] 
              RGBColor[0.5, 0.3, 
                0.1], \[IndentingNewLine]FontWeight \[Rule] "\<Bold\>", \
\[IndentingNewLine]Background \[Rule] 
              GrayLevel[0.9]}];\)\), "\[IndentingNewLine]", 
    \({3\ a\ Unit[N], f[x]\ Unit[N\ m], 2  Unit[N\/lb]}\)}], "Input",
  CellLabel->"In[43]:=",
  CellTags->"Unit tour"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"3", " ", "a", " ", 
          TagBox[
            StyleBox["\<\"N\"\>",
              ShowStringCharacters->False,
              FontWeight->"Bold",
              FontSlant->"Plain",
              FontColor->RGBColor[0.500008, 0.300008, 0.100008],
              Background->GrayLevel[0.900008]],
            Unit]}], ",", 
        RowBox[{\(f[x]\), " ", 
          TagBox[
            StyleBox["\<\"J\"\>",
              ShowStringCharacters->False,
              FontWeight->"Bold",
              FontSlant->"Plain",
              FontColor->RGBColor[0.500008, 0.300008, 0.100008],
              Background->GrayLevel[0.900008]],
            Unit]}], ",", 
        FractionBox[
          RowBox[{"11023113", " ", 
            TagBox[
              StyleBox[\("m"\/"s"\^2\),
                ShowStringCharacters->False,
                FontWeight->"Bold",
                FontSlant->"Plain",
                FontColor->RGBColor[0.500008, 0.300008, 0.100008],
                Background->GrayLevel[0.900008]],
              Unit]}], "2500000"]}], "}"}]], "Output",
  CellLabel->"Out[44]=",
  CellTags->"Unit tour"]
}, Closed]],

Cell[BoxData[
    \(\(SetOptions[Unit, 
        StyleBox \[Rule] {FontColor \[Rule] GrayLevel[0.5]}];\)\)], "Input",
  CellLabel->"In[45]:=",
  CellTags->"Unit tour"],

Cell["\<\
With Unit package you can define new dimensions (... in two command lines)\
\>", "MathCaption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(x := 15\ Unit[m] Unit[kg];\)\), "\[IndentingNewLine]", 
    \({x, UnitD[x], UnitN[x]}\)}], "Input",
  CellLabel->"In[46]:=",
  CellTags->"Unit tour"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"15", " ", 
          RowBox[{"(", 
            TagBox[
              StyleBox[\("kg"\ "m"\),
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit], ")"}]}], ",", 
        TagBox[
          StyleBox[\("Length"\ "Mass"\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit], ",", 
        TagBox[
          StyleBox[\("Length"\ "Mass"\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}], "}"}]], "Output",
  CellLabel->"Out[47]=",
  CellTags->"Unit tour"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(Unit[Set, 
        UnitDIM, {"\<Derived\>", "\<LTimesM\>", "\<Length\>" \
"\<Mass\>"}];\)\), "\[IndentingNewLine]", 
    \(\(Unit[Set, 
        UnitMKS, {"\<Derived\>", "\<LTimesM\>", "\<\[ScriptCapitalU]\>", \
"\<kg\>" "\<m\>"}];\)\), "\[IndentingNewLine]", 
    \({x, UnitD[x], UnitN[x]}\)}], "Input",
  CellLabel->"In[48]:=",
  CellTags->"Unit tour"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"15", " ", 
          TagBox[
            StyleBox["\<\"\[ScriptCapitalU]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        TagBox[
          StyleBox[\("Length"\ "Mass"\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit], ",", 
        TagBox[
          StyleBox["\<\"LTimesM\"\>",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}], "}"}]], "Output",
  CellLabel->"Out[50]=",
  CellTags->"Unit tour"]
}, Closed]],

Cell["In most cases, this restore the normal behavior", "MathCaption",
  CellTags->"Unit tour"],

Cell[BoxData[
    \(\(Unit[Set, All];\)\)], "Input",
  CellLabel->"In[51]:=",
  CellTags->"Unit tour"],

Cell["Clean", "MathCaption",
  CellTags->"Unit tour"],

Cell[BoxData[
    \(\(Clear[x, X];\)\)], "Input",
  CellLabel->"In[52]:=",
  CellTags->"Unit tour"],

Cell["Finally, we advise that:", "MathCaption",
  CellTags->"Unit tour"],

Cell[TextData[StyleBox["Warning: This package is not fully tested and can \
contain some bugs. ",
  FontWeight->"Bold"]], "Text",
  CellTags->"Unit tour"]
}, Closed]],

Cell[CellGroupData[{

Cell["Introducing units", "Subsubsection",
  CellTags->"Introducing units"],

Cell["\<\
Unit package is intended to provide some tools to work with units.\
\>", "Text",
  CellTags->"Introducing units"],

Cell["This loads the package", "MathCaption",
  CellTags->"Introducing units"],

Cell[BoxData[
    \(Needs["\<adMath`Unit`\>"]\)], "Input",
  CellLabel->"In[53]:=",
  CellTags->"Introducing units"],

Cell[TextData[{
  "This shows the help for ",
  Cell[BoxData[
      \(Unit\)]]
}], "MathCaption",
  CellTags->"Introducing units"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(?Unit\)\)], "Input",
  CellLabel->"In[54]:=",
  CellTags->"Introducing units"],

Cell[BoxData[
    \(" X = Unit[x] represent the unit named x.\n Setting Utilities: (SYS = \
UnitMKS|UnitCGS|UnitFPS):\n > Unit[Set, All]        Restore original \
definitions.\n > Unit[Set, SYS]        Set SYS as default (or $Unit = SYS)\n \
> Unit[Set, a \[Rule] b]      Set b as default otput for a.\n Dimension \
Utilities:    See UnitD, UnitN.\n Information Utilities:  See UnitI.\n See \
Also: UnitConvert, UnitSimplify."\)], "Print",
  CellTags->"Info3312025924-1924540"]
}, Closed]],

Cell["A quantity of 10 meters can input as", "MathCaption",
  CellTags->"Introducing units"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{\(10\ Unit[m]\), ",", \(10\ Unit["\<m\>"]\), ",", 
        RowBox[{"10", " ", 
          TagBox[
            StyleBox["\<\"m\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Input",
  CellLabel->"In[55]:=",
  CellTags->"Introducing units"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"10", " ", 
          TagBox[
            StyleBox["\<\"m\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"10", " ", 
          TagBox[
            StyleBox["\<\"m\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"10", " ", 
          TagBox[
            StyleBox["\<\"m\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Output",
  CellLabel->"Out[55]=",
  CellTags->"Introducing units"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(% // InputForm\)], "Input",
  CellLabel->"In[56]:=",
  CellTags->"Introducing units"],

Cell["{10*Unit[\"m\"], 10*Unit[\"m\"], 10*Unit[\"m\"]}", "Output",
  CellLabel->"Out[56]//InputForm=",
  CellTags->"Introducing units"]
}, Closed]],

Cell[TextData[{
  "The function ",
  Cell[BoxData[
      \(Unit\)]],
  " has been formated like functions ",
  Cell[BoxData[
      \(UnitStep\)]],
  " or ",
  Cell[BoxData[
      \(Reals\)]],
  ", but not like ",
  Cell[BoxData[
      \(Integrate\)]],
  ". Type"
}], "MathCaption",
  CellTags->"Introducing units"],

Cell["\<\
{Integrate[f[x], x], UnitStep[x], Reals, Unit[Newton], Unit[N]};\
\>", "Input",
  CellLabel->"In[57]:=",
  CellTags->"Introducing units"],

Cell[TextData[{
  "then, with the cursor at any part of the celd, press ",
  Cell[BoxData[
      \(\[ControlKey]\[ShiftKey]\[LeftModified]N\[RightModified]\)]],
  " to obtain the celd in ",
  Cell[BoxData[
      \(StandardForm\)]]
}], "MathCaption",
  CellTags->"Introducing units"],

Cell[BoxData[
    RowBox[{
      RowBox[{"{", 
        RowBox[{\(\[Integral]f[x] \[DifferentialD]x\), ",", \(UnitStep[x]\), 
          ",", "Reals", ",", 
          TagBox[
            StyleBox["Newton",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit], ",", 
          TagBox[
            StyleBox["N",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], "}"}], ";"}]], "Input",
  CellLabel->"In[58]:=",
  CellTags->"Introducing units"],

Cell[TextData[{
  "and finally, to obtain the celd in ",
  Cell[BoxData[
      \(TraditionalForm\)]],
  ", press ",
  Cell[BoxData[
      \(\[ControlKey]\[ShiftKey]\[LeftModified]T\[RightModified]\)]],
  " "
}], "MathCaption",
  CellTags->"Introducing units"],

Cell[BoxData[
    FormBox[
      RowBox[{
        RowBox[{"{", 
          RowBox[{\(\[Integral]\(f(x)\) \[DifferentialD]x\), ",", 
            RowBox[{
              InterpretationBox["\[Theta]",
                UnitStep,
                Editable->False,
                Selectable->False], "(", "x", ")"}], ",", 
            TagBox["\[DoubleStruckCapitalR]",
              Function[ {}, Reals]], ",", 
            TagBox[
              StyleBox[
                FormBox["Newton",
                  "TraditionalForm"],
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit], ",", 
            TagBox[
              StyleBox[
                FormBox["N",
                  "TraditionalForm"],
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}], "}"}], ";"}], TraditionalForm]], "Input",
  CellLabel->"In[59]:=",
  CellTags->"Introducing units"],

Cell[TextData[{
  "The variables ",
  Cell[BoxData[
      \(m, s\)]],
  " can be defined and not interfere with meters or seconds"
}], "MathCaption",
  CellTags->"Introducing units"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(m = 100; s = 200;\), "\[IndentingNewLine]", 
    \({3\ Unit[m/s], 3\ Unit[m\ s\^\(-1\)], 3\ Unit[m\/s]}\)}], "Input",
  CellLabel->"In[60]:=",
  CellTags->"Introducing units"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"3", " ", 
          TagBox[
            StyleBox[\("m"\/"s"\),
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"3", " ", 
          TagBox[
            StyleBox[\("m"\/"s"\),
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"3", " ", 
          TagBox[
            StyleBox[\("m"\/"s"\),
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Output",
  CellLabel->"Out[61]=",
  CellTags->"Introducing units"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(% // InputForm\)], "Input",
  CellLabel->"In[62]:=",
  CellTags->"Introducing units"],

Cell["{3*Unit[\"m\"/\"s\"], 3*Unit[\"m\"/\"s\"], 3*Unit[\"m\"/\"s\"]}", \
"Output",
  CellLabel->"Out[62]//InputForm=",
  CellTags->"Introducing units"]
}, Closed]],

Cell["\<\
Units can combined in acceptable forms to obtanin the result in default \
system\
\>", "MathCaption",
  CellTags->"Introducing units"],

Cell[CellGroupData[{

Cell[BoxData[
    \(3\ Unit[ft\/s] + 2\ Unit[cm\/h]\)], "Input",
  CellLabel->"In[63]:=",
  CellTags->"Introducing units"],

Cell[BoxData[
    FractionBox[
      RowBox[{"164593", " ", 
        TagBox[
          StyleBox[\("m"\/"s"\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}], "180000"]], "Output",
  CellLabel->"Out[63]=",
  CellTags->"Introducing units"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(3\ Unit[lbf\/in\^2] + 65\ Unit[N\/ft\^2]\)], "Input",
  CellLabel->"In[64]:=",
  CellTags->"Introducing units"],

Cell[BoxData[
    FractionBox[
      RowBox[{"3104111000", " ", 
        TagBox[
          StyleBox["\<\"Pa\"\>",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}], "145161"]], "Output",
  CellLabel->"Out[64]=",
  CellTags->"Introducing units"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Information utility", "Subsubsection",
  CellTags->"Information utility"],

Cell[TextData[{
  "The function ",
  Cell[BoxData[
      \(UnitI\)]],
  " can give some interesting information"
}], "Text",
  CellTags->"Information utility"],

Cell[BoxData[
    FormBox[GridBox[{
          {
            RowBox[{
              StyleBox["\<\"UnitI[\"\>",
                "MR"], 
              StyleBox["\<\"Names\"\>",
                "TI"], 
              StyleBox["\<\"]\"\>",
                "MR"], 
              StyleBox["\<\"\"\>",
                "MR"]}], \(List\ of\ avaibles\ units\)},
          {" ", " "},
          {
            RowBox[{
              StyleBox["\<\"UnitI[\"\>",
                "MR"], 
              StyleBox["\<\"X\"\>",
                "TI"], 
              StyleBox["\<\"]\"\>",
                "MR"], 
              StyleBox["\<\"\"\>",
                "MR"]}], \(Gives\ information\ about\ the\ unit\ X\)},
          {
            RowBox[{
              StyleBox["\<\"UnitI[\"\>",
                "MR"], 
              StyleBox["\<\"sys\"\>",
                "TI"], 
              StyleBox["\<\"]\"\>",
                "MR"], 
              StyleBox["\<\"\"\>",
                "MR"]}], 
            RowBox[{
              RowBox[{
                RowBox[{
                "Gives", " ", "information", " ", "about", " ", "the", " ", 
                  "unit", " ", "system", " ", 
                  RowBox[{
                    StyleBox["\<\"sys\"\>",
                      "TI"], 
                    StyleBox[".",
                      "TI"], "\n", "At"}], " ", "the", " ", "start", " ", 
                  StyleBox["\<\"sys\"\>",
                    "TI"]}], " ", "=", " ", "UnitMKS"}], ",", 
              " ", \(UnitCGS\ or\ \(\(UnitFPS\)\(.\)\)\)}]},
          {" ", " "},
          {
            StyleBox[\("UnitI[ D ]" \*"\<\"\"\>"\),
              "MR"], \(List\ of\ Base\ \(\(dimensions\)\(.\)\)\)},
          {
            StyleBox[\("UnitI[ N ]" \*"\<\"\"\>"\),
              "MR"], \(List\ of\ avaibles\ dimensions\ \(\(names\)\(.\)\)\)},
          {
            StyleBox[\("UnitI[ Prefix ]" \*"\<\"\"\>"\),
              "MR"], \(List\ of\ avaibles\ \(\(prefixes\)\(.\)\)\)},
          {" ", " "},
          {
            RowBox[{
              StyleBox["\<\"UnitI[\"\>",
                "MR"], 
              StyleBox["\<\"Author\"\>",
                "TI"], 
              StyleBox["\<\"]\"\>",
                "MR"], 
              StyleBox["\<\"\"\>",
                "MR"]}], \(Gives\ information\ about\ the\ Author\)}
          },
        ColumnAlignments->{Right, Left}], TraditionalForm]], "DefinitionBox",
  GridBoxOptions->{RowSpacings->0.4,
  RowLines->False},
  CellTags->"Information utility"],

Cell["Unit Information utulity", "Caption",
  CellTags->"Information utility"],

Cell[TextData[{
  "Defined unit names are (delete ",
  Cell[BoxData[
      \(\(\(//\)\(Short\)\)\)]],
  " to see de entire list)"
}], "MathCaption",
  CellTags->"Information utility"],

Cell[CellGroupData[{

Cell[BoxData[
    \(UnitI[Names] // Short\)], "Input",
  CellLabel->"In[65]:=",
  FormatType->TraditionalForm,
  CellTags->"Information utility"],

Cell[BoxData[
    TagBox[\({"A", "\[CapitalARing]", "\!\(a\_0\)", "abA", 
        "AbAmpere", \[LeftSkeleton]570\[RightSkeleton], 
        "\[Degree]\[DoubleStruckCapitalC]", 
        "\[Degree]\[DoubleStruckCapitalF]", 
        "\[Degree]\[DoubleStruckCapitalK]", 
        "\[Degree]\[DoubleStruckCapitalR]", "\[HBar]"}\),
      Short]], "Output",
  CellLabel->"Out[65]//Short=",
  CellTags->"Information utility"]
}, Closed]],

Cell[TextData[{
  "To obtain information about ",
  Cell[BoxData[
      RowBox[{"32", " ", 
        TagBox[
          StyleBox["Newton",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}]]],
  " type"
}], "MathCaption",
  CellTags->"Information utility"],

Cell[CellGroupData[{

Cell[BoxData[
    \(UnitI[32\ Unit[Newton]]\)], "Input",
  CellLabel->"In[66]:=",
  FormatType->TraditionalForm,
  CellTags->"Information utility"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"Information About: \"\>", "\<\"\\!\\(32\\\\ \
\\*TagBox[StyleBox[\\\"\\\\\\\"N\\\\\\\"\\\", Rule[FontSlant, Plain], \
Rule[ShowStringCharacters, False], Rule[FontColor, GrayLevel[0.5`]]], \
Unit]\\)\"\>"},
          {"\<\" \"\>", "\<\"------------------------------\"\>"},
          {"\<\"Dimensions:        \"\>", \
"\<\"\\!\\(\\\"\\\\!\\\\(\\\\*TagBox[StyleBox[\\\\\\\"\\\\\\\\\\\\\\\"Force\\\
\\\\\\\\\\\\\"\\\\\\\", Rule[FontSlant, Plain], Rule[ShowStringCharacters, \
False], Rule[FontColor, GrayLevel[0.5`]]], Unit]\\\\)\\\" \[Rule] \\\"\\\\!\\\
\\(\\\\*TagBox[StyleBox[\\\\(\\\\(\\\\\\\"Length\\\\\\\"\\\\\\\\ \\\\\\\"Mass\
\\\\\\\"\\\\)\\\\/\\\\\\\"Time\\\\\\\"\\\\^2\\\\), Rule[FontSlant, Plain], \
Rule[ShowStringCharacters, False], Rule[FontColor, GrayLevel[0.5`]]], Unit]\\\
\\)\\\"\\)\"\>"},
          {"\<\"Other Names:       \"\>", \
"\<\"\\!\\({\\\"Newton\\\"}\\)\"\>"},
          {"\<\"\\!\\(UnitCGS\\) Equivalent:\"\>", 
            RowBox[{"3.2`*^6", " ", 
              TagBox[
                StyleBox["\<\"dyn\"\>",
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}]},
          {"\<\"\\!\\(UnitFPS\\) Equivalent:\"\>", 
            RowBox[{"7.193888791471645`", " ", 
              TagBox[
                StyleBox["\<\"lbf\"\>",
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}]},
          {"\<\"\\!\\(UnitMKS\\) Equivalent:\"\>", "\<\"N is a Derived \
Unit.\"\>"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ BoxForm`e$, TableAlignments -> Left]]]], "Output",
  CellLabel->"Out[66]//StandardForm=",
  CellTags->"Information utility"]
}, Closed]],

Cell[TextData[{
  "Sometimes, this form not work, for example, if ",
  Cell[BoxData[
      \(J\)]],
  " is valued, to obtain information about ",
  Cell[BoxData[
      RowBox[{"7", " ", 
        TagBox[
          StyleBox["J",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}]]],
  " type"
}], "MathCaption",
  CellTags->"Information utility"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(J = 33;\)\), "\[IndentingNewLine]", 
    \(UnitI[7\ Unit["\<J\>"]]\)}], "Input",
  CellLabel->"In[67]:=",
  CellTags->"Information utility"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"Information About: \"\>", "\<\"\\!\\(7\\\\ \
\\*TagBox[StyleBox[\\\"\\\\\\\"J\\\\\\\"\\\", Rule[FontSlant, Plain], \
Rule[ShowStringCharacters, False], Rule[FontColor, GrayLevel[0.5`]]], \
Unit]\\)\"\>"},
          {"\<\" \"\>", "\<\"------------------------------\"\>"},
          {"\<\"Dimensions:        \"\>", \
"\<\"\\!\\(\\\"\\\\!\\\\(\\\\*TagBox[StyleBox[\\\\\\\"\\\\\\\\\\\\\\\"Energy\\\
\\\\\\\\\\\\\"\\\\\\\", Rule[FontSlant, Plain], Rule[ShowStringCharacters, \
False], Rule[FontColor, GrayLevel[0.5`]]], Unit]\\\\)\\\" \[Rule] \\\"\\\\!\\\
\\(\\\\*TagBox[StyleBox[\\\\(\\\\(\\\\\\\"Length\\\\\\\"\\\\^2\\\\\\\\ \\\\\\\
\"Mass\\\\\\\"\\\\)\\\\/\\\\\\\"Time\\\\\\\"\\\\^2\\\\), Rule[FontSlant, \
Plain], Rule[ShowStringCharacters, False], Rule[FontColor, GrayLevel[0.5`]]], \
Unit]\\\\)\\\"\\)\"\>"},
          {"\<\"Other Names:       \"\>", \
"\<\"\\!\\({\\\"Joule\\\"}\\)\"\>"},
          {"\<\"\\!\\(UnitCGS\\) Equivalent:\"\>", 
            RowBox[{"7.`*^7", " ", 
              TagBox[
                StyleBox["\<\"erg\"\>",
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}]},
          {"\<\"\\!\\(UnitFPS\\) Equivalent:\"\>", 
            RowBox[{"5.162936919732358`", " ", 
              RowBox[{"(", 
                TagBox[
                  StyleBox[\("ft"\ "lbf"\),
                    ShowStringCharacters->False,
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit], ")"}]}]},
          {"\<\"\\!\\(UnitMKS\\) Equivalent:\"\>", "\<\"J is a Derived \
Unit.\"\>"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ BoxForm`e$, TableAlignments -> Left]]]], "Output",
  CellLabel->"Out[68]//StandardForm=",
  CellTags->"Information utility"]
}, Closed]],

Cell[BoxData[
    \(\(Clear[J, m, s];\)\)], "Input",
  CellLabel->"In[69]:=",
  CellTags->"Information utility"],

Cell["Bugs reports or commentaries are welcome", "MathCaption",
  CellTags->"Information utility"],

Cell[CellGroupData[{

Cell[BoxData[
    \(UnitI[Author]\)], "Input",
  CellLabel->"In[70]:=",
  CellTags->"Information utility"],

Cell[BoxData[
    \({"(c) 2004", "Alvaro Diaz Falconi", 
      "alvarodiazfalconi@yahoo.com"}\)], "Output",
  CellLabel->"Out[70]=",
  CellTags->"Information utility"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Default unit system", "Subsubsection",
  CellTags->"Default unit system"],

Cell["\<\
There are three units system predefined, that load when the package starts\
\>", "Text",
  CellTags->"Default unit system"],

Cell[BoxData[
    FormBox[GridBox[{
          {
            StyleBox[\(UnitMKS, UnitCGS, UnitFPS\),
              "MR"], Cell[BoxData[
                \(TraditionalForm\`Symbols\ to\ denote\ the\ units\ \
systems\)]]},
          {
            StyleBox["\<\"Unit$\"\>",
              "MR"], Cell[BoxData[
                \(TraditionalForm\`Variable\ to\ store\ the\ default\ unit\ \
system\)]]}
          },
        ColumnAlignments->{Right, Left}], TraditionalForm]], "DefinitionBox",
  GridBoxOptions->{RowSpacings->0.4,
  RowLines->False},
  CellTags->"Default unit system"],

Cell["Unit systems", "Caption",
  CellTags->"Default unit system"],

Cell["Default system is", "MathCaption",
  CellTags->"Default unit system"],

Cell[CellGroupData[{

Cell[BoxData[
    \($Unit\)], "Input",
  CellLabel->"In[71]:=",
  CellTags->"Default unit system"],

Cell[BoxData[
    \(UnitMKS\)], "Output",
  CellLabel->"Out[71]=",
  CellTags->"Default unit system"]
}, Closed]],

Cell["Changing it, units outpus are now in the new system", "MathCaption",
  CellTags->"Default unit system"],

Cell[BoxData[
    \(\($Unit = UnitFPS;\)\)], "Input",
  CellLabel->"In[72]:=",
  CellTags->"Default unit system"],

Cell[CellGroupData[{

Cell[BoxData[
    \(3\ Unit[ft\/s] + 2\ Unit[cm\/h]\)], "Input",
  CellLabel->"In[73]:=",
  CellTags->"Default unit system"],

Cell[BoxData[
    FractionBox[
      RowBox[{"164593", " ", 
        TagBox[
          StyleBox[\("ft"\/"s"\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}], "54864"]], "Output",
  CellLabel->"Out[73]=",
  CellTags->"Default unit system"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(3\ Unit[lbf\/in\^2] + 65\ Unit[N\/ft\^2]\)], "Input",
  CellLabel->"In[74]:=",
  CellTags->"Default unit system"],

Cell[BoxData[
    FractionBox[
      RowBox[{"6208222", " ", 
        TagBox[
          StyleBox[\("lbf"\/"in"\^2\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}], "2001699"]], "Output",
  CellLabel->"Out[74]=",
  CellTags->"Default unit system"]
}, Closed]],

Cell["Restore the defaults", "MathCaption",
  CellTags->"Default unit system"],

Cell[BoxData[
    \(\($Unit = UnitMKS;\)\)], "Input",
  CellLabel->"In[75]:=",
  CellTags->"Default unit system"]
}, Closed]],

Cell[CellGroupData[{

Cell["Dimensions of units", "Subsubsection",
  CellTags->"Dimensions of units"],

Cell[TextData[{
  "The functions ",
  Cell[BoxData[
      \(UnitD\)]],
  ", ",
  Cell[BoxData[
      \(UnitN\)]],
  " can give the dimensions of the defined units"
}], "Text",
  CellTags->"Dimensions of units"],

Cell[BoxData[
    FormBox[GridBox[{
          {
            RowBox[{
              StyleBox["\<\"UnitD[\"\>",
                "MR"], 
              StyleBox["\<\"x\"\>",
                "TI"], 
              StyleBox["\<\"]\"\>",
                "MR"]}], Cell[BoxData[
                \(TraditionalForm\`Dimensions\ of\ x\)]]},
          {Cell[BoxData[
                FormBox[
                  RowBox[{
                    StyleBox["\<\"UnitN[\"\>",
                      "MR"], 
                    StyleBox["\<\"x\"\>",
                      "TI"], 
                    StyleBox["\<\"]\"\>",
                      "MR"]}], TraditionalForm]]], Cell[BoxData[
                \(TraditionalForm\`Dimension\ names\ of\ x\)]]}
          },
        ColumnAlignments->{Right, Left}], TraditionalForm]], "DefinitionBox",
  GridBoxOptions->{RowSpacings->0.4,
  RowLines->False},
  CellTags->"Dimensions of units"],

Cell["Dimensions of units", "Caption",
  CellTags->"Dimensions of units"],

Cell["These is a list containing some units", "MathCaption",
  CellTags->"Dimensions of units"],

Cell[CellGroupData[{

Cell[BoxData[
    \(X = {a, a\ b\ Unit[N], f[x]\ Unit[N\ m], Unit[N/lb], 
        3\ Unit[F\ s]}\)], "Input",
  CellLabel->"In[76]:=",
  FormatType->TraditionalForm,
  CellTags->"Dimensions of units"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"a", ",", 
        RowBox[{"a", " ", "b", " ", 
          TagBox[
            StyleBox["\<\"N\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{\(f[x]\), " ", 
          TagBox[
            StyleBox["\<\"J\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        FractionBox[
          RowBox[{"11023113", " ", 
            TagBox[
              StyleBox[\("m"\/"s"\^2\),
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}], "5000000"], ",", 
        RowBox[{"3", " ", 
          TagBox[
            StyleBox[\(\("A"\^2\ "s"\^5\)\/\("kg"\ "m"\^2\)\),
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Output",
  CellLabel->"Out[76]=",
  CellTags->"Dimensions of units"]
}, Closed]],

Cell["Sometimes this help", "MathCaption",
  CellTags->"Dimensions of units"],

Cell[CellGroupData[{

Cell[BoxData[
    \(% // InputForm\)], "Input",
  CellLabel->"In[77]:=",
  FormatType->TraditionalForm,
  CellTags->"Dimensions of units"],

Cell["\<\
{a, a*b*Unit[\"N\"], f[x]*Unit[\"J\"], \
(11023113*Unit[\"m\"/\"s\"^2])/5000000, 
 3*Unit[(\"A\"^2*\"s\"^5)/(\"kg\"*\"m\"^2)]}\
\>", "Output",
  CellLabel->"Out[77]//InputForm=",
  CellTags->"Dimensions of units"]
}, Closed]],

Cell["The dimensions of our list are", "MathCaption",
  CellTags->"Dimensions of units"],

Cell[CellGroupData[{

Cell[BoxData[
    \(UnitD[X]\)], "Input",
  CellLabel->"In[78]:=",
  FormatType->TraditionalForm,
  CellTags->"Dimensions of units"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"1", ",", 
        TagBox[
          StyleBox[\(\("Length"\ "Mass"\)\/"Time"\^2\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit], ",", 
        TagBox[
          StyleBox[\(\("Length"\^2\ "Mass"\)\/"Time"\^2\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit], ",", 
        TagBox[
          StyleBox[\("Length"\/"Time"\^2\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit], ",", 
        TagBox[
          
          StyleBox[\(\("ElectricCurrent"\^2\ "Time"\^5\)\/\("Length"\^2\ \
"Mass"\)\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}], "}"}]], "Output",
  CellLabel->"Out[78]=",
  CellTags->"Dimensions of units"]
}, Closed]],

Cell["\<\
and the dimensions names (Note that there are not any name to Farads by \
seconds).\
\>", "MathCaption",
  CellTags->"Dimensions of units"],

Cell[CellGroupData[{

Cell[BoxData[
    \(UnitN[X]\)], "Input",
  CellLabel->"In[79]:=",
  FormatType->TraditionalForm,
  CellTags->"Dimensions of units"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"1", ",", 
        TagBox[
          StyleBox["\<\"Force\"\>",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit], ",", 
        TagBox[
          StyleBox["\<\"Energy\"\>",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit], ",", 
        TagBox[
          StyleBox["\<\"Acceleration\"\>",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit], ",", 
        TagBox[
          
          StyleBox[\(\("ElectricCurrent"\^2\ "Time"\^5\)\/\("Length"\^2\ \
"Mass"\)\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}], "}"}]], "Output",
  CellLabel->"Out[79]=",
  CellTags->"Dimensions of units"]
}, Closed]],

Cell[BoxData[
    \(\(Clear[X];\)\)], "Input",
  CellLabel->"In[80]:=",
  CellTags->"Dimensions of units"],

Cell[TextData[{
  "Given the dimension, ",
  Cell[BoxData[
      \(Unit\)]],
  " can find the units (in MKS system)"
}], "MathCaption",
  CellTags->"Dimensions of units"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\ \)\({Unit[\(ElectricCurrent\^2\ Time\^4\)\/\(Length\^2\ Mass\)], 
      Unit[ElectricCapacitance]}\)\)\)], "Input",
  CellLabel->"In[81]:=",
  CellTags->"Dimensions of units"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        TagBox[
          StyleBox["\<\"F\"\>",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit], ",", 
        TagBox[
          StyleBox["\<\"F\"\>",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}], "}"}]], "Output",
  CellLabel->"Out[81]=",
  CellTags->"Dimensions of units"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \({Unit[Volume], Unit[Force], Unit[Energy], Unit[Force\ Length], 
      Unit[Power]}\)], "Input",
  CellLabel->"In[82]:=",
  CellTags->"Dimensions of units"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        TagBox[
          StyleBox[\("m"\^3\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit], ",", 
        TagBox[
          StyleBox["\<\"N\"\>",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit], ",", 
        TagBox[
          StyleBox["\<\"J\"\>",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit], ",", 
        TagBox[
          StyleBox["\<\"J\"\>",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit], ",", 
        TagBox[
          StyleBox["\<\"W\"\>",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}], "}"}]], "Output",
  CellLabel->"Out[82]=",
  CellTags->"Dimensions of units"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\($Unit = UnitCGS;\)\), "\[IndentingNewLine]", 
    \({Unit[Volume], Unit[Force], Unit[Energy], Unit[Force\ Length], 
      Unit[Power]}\)}], "Input",
  CellLabel->"In[83]:=",
  CellTags->"Dimensions of units"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        TagBox[
          StyleBox[\("cm"\^3\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit], ",", 
        TagBox[
          StyleBox["\<\"dyn\"\>",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit], ",", 
        TagBox[
          StyleBox["\<\"erg\"\>",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit], ",", 
        TagBox[
          StyleBox["\<\"erg\"\>",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit], ",", 
        TagBox[
          StyleBox[\("erg"\/"s"\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}], "}"}]], "Output",
  CellLabel->"Out[84]=",
  CellTags->"Dimensions of units"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\($Unit = UnitFPS;\)\), "\[IndentingNewLine]", 
    \({Unit[Volume], Unit[Force], Unit[Energy], Unit[Force\ Length], 
        Unit[Power]} // N\)}], "Input",
  CellLabel->"In[85]:=",
  CellTags->"Dimensions of units"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        TagBox[
          StyleBox[\("ft"\^3\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit], ",", 
        RowBox[{"0.03108096176586751`", " ", 
          TagBox[
            StyleBox["\<\"lbf\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"0.03108096176586751`", " ", 
          RowBox[{"(", 
            TagBox[
              StyleBox[\("ft"\ "lbf"\),
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit], ")"}]}], ",", 
        RowBox[{"0.03108096176586752`", " ", 
          RowBox[{"(", 
            TagBox[
              StyleBox[\("ft"\ "lbf"\),
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit], ")"}]}], ",", 
        RowBox[{"0.00005651080932202192`", " ", 
          TagBox[
            StyleBox["\<\"HP\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Output",
  CellLabel->"Out[86]=",
  CellTags->"Dimensions of units"]
}, Closed]],

Cell[BoxData[
    \(\($Unit = UnitMKS;\)\)], "Input",
  CellLabel->"In[87]:=",
  CellTags->"Dimensions of units"]
}, Closed]],

Cell[CellGroupData[{

Cell["Simplification of units", "Subsubsection",
  CellTags->"Simplification of units"],

Cell[TextData[{
  Cell[BoxData[
      \(UnitSimplfiy\)]],
  " have necessaries routines to simplify units in some expressions."
}], "Text",
  CellTags->"Simplification of units"],

Cell[BoxData[
    FormBox[GridBox[{
          {
            RowBox[{
              RowBox[{
                StyleBox["\<\"UnitSimplify\"\>",
                  "MR"], 
                StyleBox["[",
                  "MR"], 
                RowBox[{
                  RowBox[{
                    StyleBox["\<\"\"\>",
                      "\n\"MR\""], 
                    StyleBox["expr",
                      "TI"]}], 
                  StyleBox[",",
                    "TI"], 
                  RowBox[{
                    StyleBox["\<\"\"\>",
                      "\n\"TI\""], 
                    StyleBox["opt",
                      "TI"], 
                    StyleBox["\<\"\"\>",
                      "\n\"TI\""], 
                    StyleBox["\<\"\"\>",
                      "\n\"MR\""]}]}], 
                StyleBox["]",
                  "MR"]}], 
              StyleBox["\<\"\"\>",
                "MR"]}], 
            RowBox[{Cell[BoxData[
                  FormBox[
                    RowBox[{"Simplify", " ", 
                      StyleBox["\<\"\"\>",
                        "\n\"MR\""], 
                      StyleBox["expr",
                        "TI"], " ", "involving", " ", "units"}], 
                    TraditionalForm]]], "using", " ", 
              StyleBox["\<\"\"\>",
                "\n\"TI\""], 
              StyleBox["opt",
                "TI"], 
              StyleBox["\<\"\"\>",
                "\n\"TI\""], 
              StyleBox["\<\"\"\>",
                "\n\"MR\""]}]},
          {
            RowBox[{
              RowBox[{
                StyleBox["\<\"UnitSimplify\"\>",
                  "MR"], 
                StyleBox["[",
                  "MR"], 
                RowBox[{
                  RowBox[{
                    StyleBox["\<\"\"\>",
                      "\n\"MR\""], 
                    StyleBox["expr",
                      "TI"]}], 
                  StyleBox[",",
                    "TI"], 
                  RowBox[{
                    StyleBox["\<\"\"\>",
                      "\n\"TI\""], 
                    StyleBox["ass",
                      "TI"], 
                    StyleBox["\<\"\"\>",
                      "\n\"TI\""], 
                    StyleBox["\<\"\"\>",
                      "\n\"MR\""]}]}], 
                StyleBox["]",
                  "MR"]}], 
              StyleBox["\<\"\"\>",
                "MR"]}], 
            RowBox[{Cell[BoxData[
                  FormBox[
                    RowBox[{"Simplify", " ", 
                      StyleBox["\<\"\"\>",
                        "\n\"MR\""], 
                      StyleBox["expr",
                        "TI"], " ", "involving", " ", "units"}], 
                    TraditionalForm]]], "using", " ", "assumptions"}]}
          },
        ColumnAlignments->{Right, Left}], TraditionalForm]], "DefinitionBox",
  GridBoxOptions->{RowSpacings->0.4,
  RowLines->False},
  CellTags->"Simplification of units"],

Cell["UnitSimplify", "Caption",
  CellTags->"Simplification of units"],

Cell[TextData[{
  Cell[BoxData[
      \(UnitSimplify\)]],
  " take de same options than ",
  Cell[BoxData[
      \(Simplify\)]],
  "."
}], "MathCaption",
  CellTags->"Simplification of units"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Options@UnitSimplify\)], "Input",
  CellLabel->"In[88]:=",
  CellTags->"Simplification of units"],

Cell[BoxData[
    \({Assumptions \[RuleDelayed] $Assumptions, 
      ComplexityFunction \[Rule] Automatic, TimeConstraint \[Rule] 300, 
      TransformationFunctions \[Rule] Automatic, 
      Trig \[Rule] True}\)], "Output",
  CellLabel->"Out[88]=",
  CellTags->"Simplification of units"]
}, Closed]],

Cell[TextData[{
  "This expression don't need ",
  Cell[BoxData[
      \(UnitSimplify\)]],
  " or ",
  Cell[BoxData[
      \(Simplify\)]]
}], "MathCaption",
  CellTags->"Simplification of units"],

Cell[BoxData[
    \(\(ClearAll[\[Phi], Subscript];\)\)], "Input",
  CellLabel->"In[89]:=",
  CellTags->"Simplification of units"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{\(a\_1\), "=", 
        RowBox[{"5", " ", 
          TagBox[
            StyleBox["C",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], ";", 
      RowBox[{\(a\_2\), "=", 
        RowBox[{"9", " ", 
          TagBox[
            StyleBox["C",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], ";"}], "\n", 
    RowBox[{
      RowBox[{\(b\_1\), "=", 
        RowBox[{"4", " ", 
          TagBox[
            StyleBox["C",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], ";", 
      RowBox[{\(b\_2\), "=", 
        RowBox[{"10", " ", 
          TagBox[
            StyleBox["C",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], ";"}], "\n", 
    RowBox[{
      RowBox[{\(c\_1\), "=", 
        RowBox[{"6", " ", 
          TagBox[
            StyleBox["F",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], ";", 
      RowBox[{\(c\_2\), "=", 
        RowBox[{"16", " ", 
          TagBox[
            StyleBox["F",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], 
      ";"}], "\n", \(\[Phi] := \@\(\((\(a\_1 - a\_2\)\/c\_1)\)\^2 + \((\(b\_1 \
- b\_2\)\/c\_2)\)\^2\);\), "\n", "\[Phi]"}], "Input",
  CellLabel->"In[90]:=",
  CellTags->"Simplification of units"],

Cell[BoxData[
    FractionBox[
      RowBox[{\(\@337\), " ", 
        TagBox[
          StyleBox["\<\"V\"\>",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}], "24"]], "Output",
  CellLabel->"Out[94]=",
  CellTags->"Simplification of units"]
}, Closed]],

Cell[TextData[{
  "Now ",
  Cell[BoxData[
      \(Simplify\)]],
  " can work"
}], "MathCaption",
  CellTags->"Simplification of units"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{\(a\_1\), "=", 
        RowBox[{\(\[Alpha]\_1\), " ", 
          TagBox[
            StyleBox["C",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], ";", 
      RowBox[{\(a\_2\), "=", 
        RowBox[{\(\[Alpha]\_2\), " ", 
          TagBox[
            StyleBox["C",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], ";", \(Simplify[\[Phi]]\)}]], "Input",
  CellLabel->"In[95]:=",
  CellTags->"Simplification of units"],

Cell[BoxData[
    RowBox[{\(1\/24\), 
      " ", \(\@\(81 + 16\ \[Alpha]\_1\%2 - 32\ \[Alpha]\_1\ \[Alpha]\_2 + 
            16\ \[Alpha]\_2\%2\)\), " ", 
      TagBox[
        StyleBox["\<\"V\"\>",
          ShowStringCharacters->False,
          FontSlant->"Plain",
          FontColor->GrayLevel[0.500008]],
        Unit]}]], "Output",
  CellLabel->"Out[95]=",
  CellTags->"Simplification of units"]
}, Closed]],

Cell[TextData[{
  "Now this needs ",
  Cell[BoxData[
      \(UnitSimplify\)]]
}], "MathCaption",
  CellTags->"Simplification of units"],

Cell[CellGroupData[{

Cell[BoxData[
    \(c\_1 =. ; c\_2 =. ; UnitSimplify[\[Phi]]\)], "Input",
  CellLabel->"In[96]:=",
  CellTags->"Simplification of units"],

Cell[BoxData[
    RowBox[{\(\@\(36\/c\_2\%2 + \((\[Alpha]\_1 - \[Alpha]\_2)\)\^2\/c\_1\%2\)\
\), " ", 
      TagBox[
        StyleBox["\<\"C\"\>",
          ShowStringCharacters->False,
          FontSlant->"Plain",
          FontColor->GrayLevel[0.500008]],
        Unit]}]], "Output",
  CellLabel->"Out[96]=",
  CellTags->"Simplification of units"]
}, Closed]],

Cell[BoxData[
    \(\(ClearAll[\[Phi], Subscript];\)\)], "Input",
  CellLabel->"In[97]:=",
  CellTags->"Simplification of units"],

Cell[TextData[{
  "Functions ",
  Cell[BoxData[
      \(UnitFullSimplify\)]],
  ", ",
  Cell[BoxData[
      \(UnitPowerExpand\)]],
  ", ",
  Cell[BoxData[
      \(UnitComplexExpand\)]],
  " are provided too. Theys works calling the ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " function, and ",
  Cell[BoxData[
      \(Refine\)]],
  "."
}], "Text",
  CellTags->"Simplification of units"]
}, Closed]],

Cell[CellGroupData[{

Cell["Convertions between unit systems", "Subsubsection",
  CellTags->"Convertions between unit systems"],

Cell["\<\
There are three predefined functions to convert an unit in one system to \
another when the package starts\
\>", "Text",
  CellTags->"Convertions between unit systems"],

Cell[BoxData[
    FormBox[GridBox[{
          {
            RowBox[{
              StyleBox["\<\"UnitMKS[\"\>",
                "MR"], 
              StyleBox["\<\"x\"\>",
                "TI"], 
              StyleBox["\<\"]\"\>",
                "MR"]}], Cell[BoxData[
                \(TraditionalForm\`Convert\ x\ to\ Meter - Kilogram - 
                  Second\ system\)]]},
          {
            RowBox[{
              StyleBox["\<\"UnitCGS[\"\>",
                "MR"], 
              StyleBox["\<\"x\"\>",
                "TI"], 
              StyleBox["\<\"]\"\>",
                "MR"]}], Cell[BoxData[
                \(TraditionalForm\`Convert\ x\ to\ Centimeter - Gram - 
                  Second\ system\)]]},
          {
            RowBox[{
              StyleBox["\<\"UnitFPS[\"\>",
                "MR"], 
              StyleBox["\<\"x\"\>",
                "TI"], 
              StyleBox["\<\"]\"\>",
                "MR"]}], Cell[BoxData[
                \(TraditionalForm\`Convert\ x\ to\ Feet - Pound - 
                  Second\ system\)]]}
          },
        ColumnAlignments->{Right, Left}], TraditionalForm]], "DefinitionBox",
  GridBoxOptions->{RowSpacings->0.4,
  RowLines->False},
  CellTags->"Convertions between unit systems"],

Cell["System convertions functions", "Caption",
  CellTags->"Convertions between unit systems"],

Cell["This is a list containing some units", "MathCaption",
  CellTags->"Convertions between unit systems"],

Cell[CellGroupData[{

Cell[BoxData[
    \(X = {a, a\ b\ Unit[N], f[x]\ Unit[N\ m], Unit[N/lb], 
        3\ Unit[F\ s]}\)], "Input",
  CellLabel->"In[98]:=",
  FormatType->TraditionalForm,
  CellTags->"Convertions between unit systems"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"a", ",", 
        RowBox[{"a", " ", "b", " ", 
          TagBox[
            StyleBox["\<\"N\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{\(f[x]\), " ", 
          TagBox[
            StyleBox["\<\"J\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        FractionBox[
          RowBox[{"11023113", " ", 
            TagBox[
              StyleBox[\("m"\/"s"\^2\),
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}], "5000000"], ",", 
        RowBox[{"3", " ", 
          TagBox[
            StyleBox[\(\("A"\^2\ "s"\^5\)\/\("kg"\ "m"\^2\)\),
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Output",
  CellLabel->"Out[98]=",
  CellTags->"Convertions between unit systems"]
}, Closed]],

Cell[TextData[{
  "This convert each unit to ",
  Cell[BoxData[
      \(CGS\)]],
  " system"
}], "MathCaption",
  CellTags->"Convertions between unit systems"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(UnitCGS[X] // N\) // ColumnForm\)], "Input",
  CellLabel->"In[99]:=",
  CellTags->"Convertions between unit systems"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {"a"},
          {
            RowBox[{"100000.`", " ", "a", " ", "b", " ", 
              TagBox[
                StyleBox["\<\"dyn\"\>",
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}]},
          {
            RowBox[{"1.`*^7", " ", \(f[x]\), " ", 
              TagBox[
                StyleBox["\<\"erg\"\>",
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}]},
          {
            RowBox[{"582.4002591002079`", " ", 
              TagBox[
                StyleBox[\("gal"\/\("m"\^2\ "s"\^2\)\),
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}]},
          {
            RowBox[{"3.`", " ", 
              TagBox[
                StyleBox[\(\("A"\^2\ "s"\^5\)\/\("kg"\ "m"\^2\)\),
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}]}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      ColumnForm[ {a, 
        Times[ .1*^6, a, b, 
          Unit[ "dyn"]], 
        Times[ .1*^8, 
          f[ x], 
          Unit[ "erg"]], 
        Times[ 582.4002591002079, 
          Unit[ 
            Times[ "gal", 
              Power[ "m", -2], 
              Power[ "s", -2]]]], 
        Times[ 3.0, 
          Unit[ 
            Times[ 
              Power[ "A", 2], 
              Power[ "kg", -1], 
              Power[ "m", -2], 
              Power[ "s", 5]]]]}],
      Editable->False]], "Output",
  CellLabel->"Out[99]=",
  CellTags->"Convertions between unit systems"]
}, Closed]],

Cell[TextData[{
  "This convert each unit to ",
  Cell[BoxData[
      \(FPS\)]],
  " system"
}], "MathCaption",
  CellTags->"Convertions between unit systems"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(UnitFPS[X] // N\) // ColumnForm\)], "Input",
  CellLabel->"In[100]:=",
  CellTags->"Convertions between unit systems"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {"a"},
          {
            RowBox[{"0.2248090247334889`", " ", "a", " ", "b", " ", 
              TagBox[
                StyleBox["\<\"lbf\"\>",
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}]},
          {
            RowBox[{"0.7375624171046226`", " ", \(f[x]\), " ", 
              RowBox[{"(", 
                TagBox[
                  StyleBox[\("ft"\ "lbf"\),
                    ShowStringCharacters->False,
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit], ")"}]}]},
          {
            RowBox[{"7.233013779527559`", " ", 
              TagBox[
                StyleBox[\("ft"\/"s"\^2\),
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}]},
          {
            RowBox[{"0.12642033153429524`", " ", 
              TagBox[
                StyleBox[\(\("A"\^2\ "s"\^5\)\/\("ft"\^2\ "lb"\)\),
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}]}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      ColumnForm[ {a, 
        Times[ .2248090247334889, a, b, 
          Unit[ "lbf"]], 
        Times[ .73756241710462256, 
          f[ x], 
          Unit[ 
            Times[ "ft", "lbf"]]], 
        Times[ 7.2330137795275586, 
          Unit[ 
            Times[ "ft", 
              Power[ "s", -2]]]], 
        Times[ .12642033153429524, 
          Unit[ 
            Times[ 
              Power[ "A", 2], 
              Power[ "ft", -2], 
              Power[ "lb", -1], 
              Power[ "s", 5]]]]}],
      Editable->False]], "Output",
  CellLabel->"Out[100]=",
  CellTags->"Convertions between unit systems"]
}, Closed]],

Cell[BoxData[
    \(\(Clear[X];\)\)], "Input",
  CellLabel->"In[101]:=",
  CellTags->"Convertions between unit systems"]
}, Closed]],

Cell[CellGroupData[{

Cell["Convertions between units", "Subsubsection",
  CellTags->"Convertions between units"],

Cell[TextData[{
  "The function ",
  Cell[BoxData[
      \(UnitConvert\)]],
  " do the convertion between systems of units, or between units."
}], "Text",
  CellTags->"Convertions between units"],

Cell[BoxData[
    FormBox[GridBox[{
          {
            RowBox[{
              StyleBox["\<\"UnitConvert[\"\>",
                "MR"], 
              StyleBox["\<\"newsys\"\>",
                "TI"], 
              StyleBox["\<\"]\"\>",
                "MR"], 
              StyleBox["\<\"[\"\>",
                "MR"], 
              StyleBox["\<\"oldunits\"\>",
                "TI"], 
              StyleBox["\<\"]\"\>",
                "MR"]}], 
            RowBox[{Cell[BoxData[
                  FormBox[Cell[BoxData[
                        FormBox[
                          RowBox[{"Convert", " ", "\<\"\"\>", 
                            StyleBox["\<\"oldunits\"\>",
                              "TI"], "\<\" to the unit system\:f39f\"\>", 
                            StyleBox["\<\"newsys\"\>",
                              "TI"]}], TraditionalForm]]], TraditionalForm]]],
               "."}]},
          {
            RowBox[{
              StyleBox["\<\"UnitConvert[\"\>",
                "MR"], 
              StyleBox["\<\"newunit\"\>",
                "TI"], 
              StyleBox["\<\"]\"\>",
                "MR"], 
              StyleBox["\<\"[\"\>",
                "MR"], 
              StyleBox["\<\"oldunits\"\>",
                "TI"], 
              StyleBox["\<\"]\"\>",
                "MR"]}], Cell[BoxData[
                FormBox[
                  RowBox[{"Convert", " ", "\<\"\"\>", 
                    StyleBox["\<\"oldunits\"\>",
                      "TI"], "\<\" to \"\>", 
                    StyleBox[\(\("newunit"\)\(.\)\),
                      "TI"]}], TraditionalForm]]]}
          },
        ColumnAlignments->{Right, Left}], TraditionalForm]], "DefinitionBox",
  GridBoxOptions->{RowSpacings->0.4,
  RowLines->False},
  CellTags->"Convertions between units"],

Cell["Unit convertion function", "Caption",
  CellTags->"Convertions between units"],

Cell[TextData[{
  Cell[BoxData[
      \(UnitConvert\)]],
  " is designed to work like postfix operator"
}], "MathCaption",
  CellTags->"Convertions between units"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"6.", 
        TagBox[
          StyleBox["Parsec",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}], "//", 
      RowBox[{"UnitConvert", "[", 
        TagBox[
          StyleBox["\<\"AU\"\>",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit], "]"}]}]], "Input",
  CellLabel->"In[102]:=",
  CellTags->"Convertions between units"],

Cell[BoxData[
    RowBox[{"1.2375978293219376`*^6", " ", 
      TagBox[
        StyleBox["\<\"AU\"\>",
          ShowStringCharacters->False,
          FontSlant->"Plain",
          FontColor->GrayLevel[0.500008]],
        Unit]}]], "Output",
  CellLabel->"Out[102]=",
  CellTags->"Convertions between units"]
}, Closed]],

Cell["\<\
The first input works, the second not because centimeters fall in meters\
\>", "MathCaption",
  CellTags->"Convertions between units"],

Cell[CellGroupData[{

Cell[BoxData[
    \(100. \ Unit@\(Yard\^2\) // UnitConvert[Unit@\("\<cm\>"\^2\)]\)], "Input",\

  CellLabel->"In[103]:=",
  CellTags->"Convertions between units"],

Cell[BoxData[
    RowBox[{"836127.36`", " ", 
      TagBox[
        StyleBox[\("cm"\^2\),
          ShowStringCharacters->False,
          FontSlant->"Plain",
          FontColor->GrayLevel[0.500008]],
        Unit]}]], "Output",
  CellLabel->"Out[103]=",
  CellTags->"Convertions between units"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(100. \ Unit@\(Yard\^2\) // UnitConvert[Unit@\(cm\^2\)]\)], "Input",
  CellLabel->"In[104]:=",
  CellTags->"Convertions between units"],

Cell[BoxData[
    RowBox[{
      RowBox[{"UnitConvert", "[", 
        FractionBox[
          TagBox[
            StyleBox[\("m"\^2\),
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit], "10000"], "]"}], "[", 
      RowBox[{"83.612736`", " ", 
        TagBox[
          StyleBox[\("m"\^2\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}], "]"}]], "Output",
  CellLabel->"Out[104]=",
  CellTags->"Convertions between units"]
}, Closed]],

Cell[TextData[{
  "Symbols dimensionless are not affected by ",
  Cell[BoxData[
      \(UniConvert\)]]
}], "MathCaption",
  CellTags->"Convertions between units"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{\(f[t]\), "//", 
      RowBox[{"UnitConvert", "[", 
        InterpretationBox[
          StyleBox["m",
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit[ m]], "]"}]}]], "Input",
  CellLabel->"In[106]:=",
  CellTags->"Convertions between units"],

Cell[BoxData[
    \(f[t]\)], "Output",
  CellLabel->"Out[106]=",
  CellTags->"Convertions between units"]
}, Closed]],

Cell["\<\
When encountred unit incongruences, but there are any unasigned symbols, \
remains unevaluated\
\>", "MathCaption",
  CellTags->"Convertions between units"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{"m", "=", 
        RowBox[{"5.", " ", 
          TagBox[
            StyleBox["gr",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], ";", 
      RowBox[{"z", "=", 
        RowBox[{"2", " ", 
          TagBox[
            StyleBox["in",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], ";"}], "\n", \(m\ g\ z // 
      UnitConvert@Unit["\<erg\>"]\)}], "Input",
  CellLabel->"In[107]:=",
  CellTags->"Convertions between units"],

Cell[BoxData[
    RowBox[{
      RowBox[{"UnitConvert", "[", 
        TagBox[
          StyleBox["\<\"erg\"\>",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit], "]"}], "[", 
      RowBox[{"0.000254`", " ", "g", " ", 
        RowBox[{"(", 
          TagBox[
            StyleBox[\("kg"\ "m"\),
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit], ")"}]}], "]"}]], "Output",
  CellLabel->"Out[108]=",
  CellTags->"Convertions between units"]
}, Closed]],

Cell[TextData[{
  "That is because ",
  Cell[BoxData[
      \(UnitConvert\)]],
  " wait for units in the parameters"
}], "MathCaption",
  CellTags->"Convertions between units"],

Cell[CellGroupData[{

Cell[BoxData[
    \(% /. g \[Rule] Unit@g\)], "Input",
  CellLabel->"In[109]:=",
  CellTags->"Convertions between units"],

Cell[BoxData[
    RowBox[{"24908.890999999996`", " ", 
      TagBox[
        StyleBox["\<\"erg\"\>",
          ShowStringCharacters->False,
          FontSlant->"Plain",
          FontColor->GrayLevel[0.500008]],
        Unit]}]], "Output",
  CellLabel->"Out[109]=",
  CellTags->"Convertions between units"]
}, Closed]],

Cell["\<\
But if there are not symbols in the expression, then the error made be \
obvious\
\>", "MathCaption",
  CellTags->"Convertions between units"],

Cell[CellGroupData[{

Cell[BoxData[
    \(9.80665  m\ z // UnitConvert@Unit["\<erg\>"]\)], "Input",
  CellLabel->"In[110]:=",
  CellTags->"Convertions between units"],

Cell[BoxData[
    RowBox[{\(UnitConvert::"badUnit"\), \(\(:\)\(\ \)\), "\<\"Can't convert \
\\!\\(0.0024908891`\\\\ \\(\\((\\*TagBox[StyleBox[\\(\\\"kg\\\"\\\\ \\\"m\\\"\
\\), Rule[FontSlant, Plain], Rule[ShowStringCharacters, False], \
Rule[FontColor, GrayLevel[0.5`]]], Unit])\\)\\)\\) to \
\\!\\(\\*TagBox[StyleBox[\\\"\\\\\\\"erg\\\\\\\"\\\", Rule[FontSlant, Plain], \
Rule[ShowStringCharacters, False], Rule[FontColor, GrayLevel[0.5`]]], \
Unit]\\).\"\>"}]], "Message",
  CellLabel->"From In[110]:=",
  CellTags->"Convertions between units"],

Cell[BoxData[
    RowBox[{"0.0024908891`", " ", 
      RowBox[{"(", 
        TagBox[
          StyleBox[\("kg"\ "m"\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit], ")"}]}]], "Output",
  CellLabel->"Out[110]=",
  CellTags->"Convertions between units"]
}, Closed]],

Cell[BoxData[
    \(\(Clear[m, z];\)\)], "Input",
  CellLabel->"In[111]:=",
  CellTags->"Convertions between units"]
}, Closed]],

Cell[CellGroupData[{

Cell["Temperature convertions", "Subsubsection",
  CellTags->"Temperature convertions"],

Cell[TextData[{
  "Unit package manipulate either temperature units or temperature scales. \
The selected symbols for temperatures units are ",
  Cell[BoxData[
      \({"\[DoubleStruckCapitalC]", "\[DoubleStruckCapitalF]", 
        "\[DoubleStruckCapitalK]", "\[DoubleStruckCapitalR]"}\)]],
  ", because ",
  Cell[BoxData[
      \(C \[Equal] Couloumb\)]],
  " and ",
  Cell[BoxData[
      \(F \[Equal] Farad\)]],
  ". Symbols for temperature scales are ",
  Cell[BoxData[
      \({"\[Degree]\[DoubleStruckCapitalC]", 
        "\[Degree]\[DoubleStruckCapitalF]", 
        "\[Degree]\[DoubleStruckCapitalK]", 
        "\[Degree]\[DoubleStruckCapitalR]"}\)]],
  ". Long names are accepted, and the symbol ",
  Cell[BoxData[
      \(K\)]],
  " for ",
  Cell[BoxData[
      \(Kelvin\)]],
  " too."
}], "Text",
  CellTags->"Temperature convertions"],

Cell["\<\
Temperature units are converted to the default temperature unit\
\>", "MathCaption",
  CellTags->"Temperature convertions"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"100.", " ", 
          TagBox[
            StyleBox["\[DoubleStruckCapitalK]",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"100.", " ", 
          TagBox[
            StyleBox["\[DoubleStruckCapitalC]",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"100.", " ", 
          TagBox[
            StyleBox["\[DoubleStruckCapitalF]",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"100.", " ", 
          TagBox[
            StyleBox["\[DoubleStruckCapitalR]",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Input",
  CellLabel->"In[112]:=",
  CellTags->"Temperature convertions"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"100.`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalK]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"100.`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalK]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"55.55555555555556`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalK]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"55.55555555555556`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalK]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Output",
  CellLabel->"Out[112]=",
  CellTags->"Temperature convertions"]
}, Closed]],

Cell["\<\
Temperature scales are identifies adding degree symbol (\[Degree]) and \
converted to adecuate temperature units\
\>", "MathCaption",
  CellTags->"Temperature convertions"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"100.", " ", 
          TagBox[
            StyleBox["\[Degree]\[DoubleStruckCapitalK]",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"100.", " ", 
          TagBox[
            StyleBox["\[Degree]\[DoubleStruckCapitalC]",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"100.", " ", 
          TagBox[
            StyleBox["\[Degree]\[DoubleStruckCapitalF]",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"100.", " ", 
          TagBox[
            StyleBox["\[Degree]\[DoubleStruckCapitalR]",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Input",
  CellLabel->"In[113]:=",
  CellTags->"Temperature convertions"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"100.`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalK]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"373.15`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalK]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"310.92777777777775`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalK]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"55.55555555555556`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalK]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Output",
  CellLabel->"Out[113]=",
  CellTags->"Temperature convertions"]
}, Closed]],

Cell["This temperatures are equivalents", "MathCaption",
  CellTags->"Temperature convertions"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"246.15", " ", 
          TagBox[
            StyleBox["\[Degree]\[DoubleStruckCapitalK]",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{\(-27. \), " ", 
          TagBox[
            StyleBox["\[Degree]\[DoubleStruckCapitalC]",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{\(-16.6\), " ", 
          TagBox[
            StyleBox["\[Degree]\[DoubleStruckCapitalF]",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"443.07", " ", 
          TagBox[
            StyleBox["\[Degree]\[DoubleStruckCapitalR]",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Input",
  CellLabel->"In[114]:=",
  CellTags->"Temperature convertions"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"246.15`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalK]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"246.14999999999998`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalK]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"246.14999999999998`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalK]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"246.14999999999998`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalK]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Output",
  CellLabel->"Out[114]=",
  CellTags->"Temperature convertions"]
}, Closed]],

Cell["Changing the system we obtain", "MathCaption",
  CellTags->"Temperature convertions"],

Cell[BoxData[
    \(\($Unit = UnitFPS;\)\)], "Input",
  CellLabel->"In[115]:=",
  CellTags->"Temperature convertions"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"100.", " ", 
          TagBox[
            StyleBox["\[DoubleStruckCapitalK]",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"100.", " ", 
          TagBox[
            StyleBox["\[DoubleStruckCapitalC]",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"100.", " ", 
          TagBox[
            StyleBox["\[DoubleStruckCapitalF]",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"100.", " ", 
          TagBox[
            StyleBox["\[DoubleStruckCapitalR]",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Input",
  CellLabel->"In[116]:=",
  CellTags->"Temperature convertions"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"180.`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalR]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"180.`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalR]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"100.`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalR]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"100.`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalR]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Output",
  CellLabel->"Out[116]=",
  CellTags->"Temperature convertions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"100.", " ", 
          TagBox[
            StyleBox["\[Degree]\[DoubleStruckCapitalK]",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"100.", " ", 
          TagBox[
            StyleBox["\[Degree]\[DoubleStruckCapitalC]",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"100.", " ", 
          TagBox[
            StyleBox["\[Degree]\[DoubleStruckCapitalF]",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"100.", " ", 
          TagBox[
            StyleBox["\[Degree]\[DoubleStruckCapitalR]",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Input",
  CellLabel->"In[117]:=",
  CellTags->"Temperature convertions"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"180.`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalR]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"671.67`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalR]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"559.67`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalR]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"100.00000000000001`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalR]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Output",
  CellLabel->"Out[117]=",
  CellTags->"Temperature convertions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"246.15", " ", 
          TagBox[
            StyleBox["\[Degree]\[DoubleStruckCapitalK]",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{\(-27. \), " ", 
          TagBox[
            StyleBox["\[Degree]\[DoubleStruckCapitalC]",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{\(-16.6\), " ", 
          TagBox[
            StyleBox["\[Degree]\[DoubleStruckCapitalF]",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"443.07", " ", 
          TagBox[
            StyleBox["\[Degree]\[DoubleStruckCapitalR]",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Input",
  CellLabel->"In[118]:=",
  CellTags->"Temperature convertions"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"443.07000000000005`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalR]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"443.07`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalR]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"443.07`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalR]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"443.07`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalR]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Output",
  CellLabel->"Out[118]=",
  CellTags->"Temperature convertions"]
}, Closed]],

Cell[BoxData[
    \(\($Unit = UnitMKS;\)\)], "Input",
  CellLabel->"In[119]:=",
  CellTags->"Temperature convertions"],

Cell[TextData[{
  Cell[BoxData[
      \(UnitConvert\)]],
  " works too"
}], "MathCaption",
  CellTags->"Temperature convertions"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"{", 
        RowBox[{
          RowBox[{"100.", " ", 
            TagBox[
              StyleBox["\[DoubleStruckCapitalK]",
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}], ",", 
          RowBox[{"100.", " ", 
            TagBox[
              StyleBox["\[DoubleStruckCapitalC]",
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}], ",", 
          RowBox[{"100.", " ", 
            TagBox[
              StyleBox["\[DoubleStruckCapitalF]",
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}], ",", 
          RowBox[{"100.", " ", 
            TagBox[
              StyleBox["\[DoubleStruckCapitalR]",
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}]}], "}"}], 
      "//", \(UnitConvert[Unit["\<\[DoubleStruckCapitalF]\>"]]\)}]], "Input",
  CellLabel->"In[120]:=",
  CellTags->"Temperature convertions"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"180.`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalF]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"180.`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalF]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"100.`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalF]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"100.`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalF]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Output",
  CellLabel->"Out[120]=",
  CellTags->"Temperature convertions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"{", 
        RowBox[{
          RowBox[{"100.", " ", 
            TagBox[
              StyleBox["\[Degree]\[DoubleStruckCapitalK]",
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}], ",", 
          RowBox[{"100.", " ", 
            TagBox[
              StyleBox["\[Degree]\[DoubleStruckCapitalC]",
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}], ",", 
          RowBox[{"100.", " ", 
            TagBox[
              StyleBox["\[Degree]\[DoubleStruckCapitalF]",
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}], ",", 
          RowBox[{"100.", " ", 
            TagBox[
              StyleBox["\[Degree]\[DoubleStruckCapitalR]",
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}]}], "}"}], 
      "//", \(UnitConvert[Unit["\<\[DoubleStruckCapitalF]\>"]]\)}]], "Input",
  CellLabel->"In[121]:=",
  CellTags->"Temperature convertions"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"180.`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalF]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"671.67`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalF]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"559.67`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalF]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"100.`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalF]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Output",
  CellLabel->"Out[121]=",
  CellTags->"Temperature convertions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"{", 
        RowBox[{
          RowBox[{"246.15", " ", 
            TagBox[
              StyleBox["\[Degree]\[DoubleStruckCapitalK]",
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}], ",", 
          RowBox[{\(-27. \), " ", 
            TagBox[
              StyleBox["\[Degree]\[DoubleStruckCapitalC]",
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}], ",", 
          RowBox[{\(-16.6\), " ", 
            TagBox[
              StyleBox["\[Degree]\[DoubleStruckCapitalF]",
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}], ",", 
          RowBox[{"443.07", " ", 
            TagBox[
              StyleBox["\[Degree]\[DoubleStruckCapitalR]",
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}]}], "}"}], 
      "//", \(UnitConvert[Unit["\<\[DoubleStruckCapitalF]\>"]]\)}]], "Input",
  CellLabel->"In[122]:=",
  CellTags->"Temperature convertions"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"443.07`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalF]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"443.07`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalF]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"443.07`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalF]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"443.07`", " ", 
          TagBox[
            StyleBox["\<\"\[DoubleStruckCapitalF]\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Output",
  CellLabel->"Out[122]=",
  CellTags->"Temperature convertions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Dimension incompatibility", "Subsubsection",
  CellTags->"Dimension incompatibility"],

Cell["\<\
Unit package only check the compatibility of dimensions when all values are \
numerics.\
\>", "Text",
  CellTags->"Dimension incompatibility"],

Cell["Here there are not an obvious error", "MathCaption",
  CellTags->"Dimension incompatibility"],

Cell[CellGroupData[{

Cell[BoxData[
    \(v = 3\ Unit[ft\/s] + a\ Unit[1\/h] // UnitSimplify\)], "Input",
  CellLabel->"In[123]:=",
  CellTags->"Dimension incompatibility"],

Cell[BoxData[
    FractionBox[
      RowBox[{
        RowBox[{"25", " ", "a", " ", 
          TagBox[
            StyleBox["\<\"Hz\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], "+", 
        RowBox[{"82296", " ", 
          TagBox[
            StyleBox[\("m"\/"s"\),
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "90000"]], "Output",
  CellLabel->"Out[123]=",
  CellTags->"Dimension incompatibility"]
}, Closed]],

Cell[TextData[{
  "This produce an obviuos error, but is not detected for Unit package (this \
is because we refuse to modificate the function ",
  Cell[BoxData[
      \(Plus\)]],
  ")"
}], "MathCaption",
  CellTags->"Dimension incompatibility"],

Cell[CellGroupData[{

Cell[BoxData[
    \(v /. a \[Rule] 2\)], "Input",
  CellLabel->"In[124]:=",
  CellTags->"Dimension incompatibility"],

Cell[BoxData[
    FractionBox[
      RowBox[{
        RowBox[{"50", " ", 
          TagBox[
            StyleBox["\<\"Hz\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], "+", 
        RowBox[{"82296", " ", 
          TagBox[
            StyleBox[\("m"\/"s"\),
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "90000"]], "Output",
  CellLabel->"Out[124]=",
  CellTags->"Dimension incompatibility"]
}, Closed]],

Cell["This detect the error", "MathCaption",
  CellTags->"Dimension incompatibility"],

Cell[CellGroupData[{

Cell[BoxData[
    \(v /. a \[Rule] 2 // UnitSimplify\)], "Input",
  CellLabel->"In[125]:=",
  CellTags->"Dimension incompatibility"],

Cell[BoxData[
    RowBox[{\(UnitConvert::"badPlus"\), \(\(:\)\(\ \)\), "\<\"Can't add \
\\!\\(\\(\\(\\(50\\\\ \\*TagBox[StyleBox[\\\"\\\\\\\"Hz\\\\\\\"\\\", \
Rule[FontSlant, Plain], Rule[ShowStringCharacters, False], Rule[FontColor, \
GrayLevel[0.5`]]], Unit]\\)\\) + \\(\\(82296\\\\ \
\\*TagBox[StyleBox[\\(\\\"m\\\"\\/\\\"s\\\"\\), Rule[FontSlant, Plain], \
Rule[ShowStringCharacters, False], Rule[FontColor, GrayLevel[0.5`]]], \
Unit]\\)\\)\\)\\/90000\\).\"\>"}]], "Message",
  CellLabel->"From In[125]:=",
  CellTags->"Dimension incompatibility"],

Cell[BoxData[
    FractionBox[
      RowBox[{
        RowBox[{"25", " ", 
          TagBox[
            StyleBox["\<\"Hz\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], "+", 
        RowBox[{"41148", " ", 
          TagBox[
            StyleBox[\("m"\/"s"\),
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "45000"]], "Output",
  CellLabel->"Out[125]=",
  CellTags->"Dimension incompatibility"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Constants", "Subsubsection",
  CellTags->"Constants"],

Cell[TextData[{
  "Unit package provide some few usefull constants. The values and almost \
symbols abreviations are taken from ",
  ButtonBox["http://physics.nist.gov/constants",
    ButtonStyle->"Hyperlink"],
  ". Names coincides with those provides in the standard ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " package  for constants, ",
  ButtonBox["PhysicalConstants",
    ButtonStyle->"AddOnsLink"],
  ", by Stephen Wolfram",
  StyleBox[".",
    FontSlant->"Italic"]
}], "Text",
  CellTags->"Constants"],

Cell[BoxData[GridBox[{
        {"Names", "Symbols"},
        {\(SpeedOfLight, VacuumSpeedOfLight\), \(c\_0, c\)},
        {\(MagneticConstant, VacuumPermeability\), \(\[Mu]\_0\)},
        {\(ElectricConstant, VacuumPermittivity\), \(\[Epsilon]\_0\)},
        {\(VacuumCharacteristicImpedance\), \(Z\_0\)},
        {\(NewtonianConstantOfGravitation, GravitationalConstant\), "G"},
        {\(StandardAccelerationOfGravity, AccelerationDueToGravity\), "g"},
        {"PlanckConstant", "\[HBar]"},
        {"PlanckMass", \(m\_P\)},
        {"PlanckTemperature", \(T\_P\)},
        {"PlanckLength", \(l\_P\)},
        {"PlanckTime", \(t\_P\)}
        }]], "DefinitionBox",
  GridBoxOptions->{RowSpacings->0.4,
  RowLines->{True, False}},
  CellTags->"Constants"],

Cell["Unit Package Universal Constants", "Caption",
  CellTags->"Constants"],

Cell[BoxData[GridBox[{
        {"Names", "Symbols"},
        {\(ElementaryCharge, ElectronCharge\), \(\(e\^-\), e\)},
        {"MagneticFluxQuantum", \(\[CapitalPhi]\_0\)},
        {"ConductanceQuantum", \(G\_0\)},
        {"JosephsonConstant", \(K\_J\)},
        {"vonKlitzingConstant", \(R\_K\)},
        {"BohrMagneton", \(\[Mu]\_B\)},
        {"NuclearMagneton", \(\[Mu]\_N\)}
        }]], "DefinitionBox",
  GridBoxOptions->{RowSpacings->0.4,
  RowLines->{True, False}},
  CellTags->"Constants"],

Cell["Unit Package Electromagnetics Constants", "Caption",
  CellTags->"Constants"],

Cell[BoxData[GridBox[{
        {"Names", "Symbol"},
        {\(AvogadroNumber, AvogadroConstant\), \(N\_A\)},
        {"AtomicMassConstant", \(m\_u\)},
        {"FaradayConstant", \(\(F\_K\)\(\ \)\( (*\ 1\ *) \)\)},
        {"BoltzmannConstant", "k"},
        {"StefanBoltzmannConstant", "\[Sigma]"},
        {"FirstRadiationConstant", \(c\_1\)},
        {\(SpectralRadianceFirstRadiationConstant\), \(c\_\(1  L\)\)},
        {"SecondRadiationConstant", \(c\_2\)},
        {\(WienDisplacementLawConstant\), "b"},
        {"LoschmidtConstant", " "}
        }]], "DefinitionBox",
  GridBoxOptions->{RowSpacings->0.4,
  RowLines->{True, False}},
  CellTags->"Constants"],

Cell["Unit Package Physico-Chemical Constants", "Caption",
  CellTags->"Constants"],

Cell[TextData[{
  Cell[BoxData[
      \( (*\ 1\ *) \)]],
  " The standard symbol for Faraday constant's is ",
  Cell[BoxData[
      \(F\)]],
  ", used by ",
  Cell[BoxData[
      \(Farad\)]],
  " (SI unit of ",
  Cell[BoxData[
      \(ElectricCapacitance\)]],
  ")."
}], "SmallText",
  CellTags->"Constants"],

Cell[BoxData[GridBox[{
        {"Names", "Symbol"},
        {"StandardTemperature", \(T\_0\)},
        {"StandardAtmosphere", \(P\_0\)},
        {\(IdealGasVolume, MolarVolume\), \(V\_0\)},
        {\(IdealGasConstant, MolarGasConstant\), "R"}
        }]], "DefinitionBox",
  GridBoxOptions->{RowSpacings->0.4,
  RowLines->{True, False}},
  CellTags->"Constants"],

Cell["Unit Package Chemical Constants", "Caption",
  CellTags->"Constants"],

Cell[BoxData[GridBox[{
        {"Names", "Symbol"},
        {"FineStructureConstant", "\[Alpha]"},
        {"RydbergConstant", \(R\_\[Infinity]\)},
        {"BohrRadius", \(a\_0\)},
        {"HartreeEnergy", \(E\_h\)}
        }]], "DefinitionBox",
  GridBoxOptions->{RowSpacings->0.4,
  RowLines->{True, False}},
  CellTags->"Constants"],

Cell["Unit Package Atomic and Nuclear - General Constants", "Caption",
  CellTags->"Constants"],

Cell[BoxData[GridBox[{
        {"Names", "Symbol"},
        {"ElectronMass", \(m\_e\)},
        {\(ElectronComptonWavelength\), \(\[Lambda]\_\(C\_e\)\)},
        {"ClassicalElectronRadius", \(r\_e\)},
        {"ThomsonCrossSection", \(\[Sigma]\_e\)},
        {"ElectronMagneticMoment", \(\[Mu]\_e\)},
        {\(ElectronMagneticMomentAnomaly\), \(a\_e\)},
        {"ElectronGFactor", \(g\_e\)}
        }]], "DefinitionBox",
  GridBoxOptions->{RowSpacings->0.4,
  RowLines->{True, False}},
  CellTags->"Constants"],

Cell[TextData[{
  "Unit Package Atomic and Nuclear - Electron (",
  Cell[BoxData[
      \(\(e\^-\)\)]],
  ") Constants"
}], "Caption",
  CellTags->"Constants"],

Cell[BoxData[GridBox[{
        {"Names", "Symbol"},
        {"MuonMass", \(m\_\[Mu]\)},
        {"MuonComptonWavelength", \(\[Lambda]\_\(C\_\[Mu]\)\)},
        {"MuonMagneticMoment", \(\[Mu]\_\[Mu]\)},
        {\(MuonMagneticMomentAnomaly\), \(a\_\[Mu]\)},
        {"MuonGFactor", \(g\_\[Mu]\)}
        }]], "DefinitionBox",
  GridBoxOptions->{RowSpacings->0.4,
  RowLines->{True, False}},
  CellTags->"Constants"],

Cell[TextData[{
  "Unit Package Atomic and Nuclear - ",
  "Muon",
  " (",
  Cell[BoxData[
      \(\(\[Mu]\^-\)\)]],
  ") Constants"
}], "Caption",
  CellTags->"Constants"],

Cell[BoxData[GridBox[{
        {"Names", "Symbol"},
        {"TauMass", \(m\_\[Tau]\)},
        {"TauComptonWavelength", \(\[Lambda]\_\(C\_\[Tau]\)\)}
        }]], "DefinitionBox",
  GridBoxOptions->{RowSpacings->0.4,
  RowLines->{True, False}},
  CellTags->"Constants"],

Cell[TextData[{
  "Unit Package Atomic and Nuclear - ",
  "Tau",
  " (",
  Cell[BoxData[
      \(\(\[Tau]\^-\)\)]],
  ") Constants"
}], "Caption",
  CellTags->"Constants"],

Cell[BoxData[GridBox[{
        {"Names", "Symbol"},
        {"ProtonMass", \(m\_p\)},
        {"ProtonComptonWavelength", \(\[Lambda]\_\(C\_p\)\)},
        {"ProtonMagneticMoment", \(\[Mu]\_p\)},
        {"ProtonGFactor", \(g\_p\)},
        {"ProtonGyromagneticRatio", \(\[Gamma]\_p\)}
        }]], "DefinitionBox",
  GridBoxOptions->{RowSpacings->0.4,
  RowLines->{True, False}},
  CellTags->"Constants"],

Cell[TextData[{
  "Unit Package Atomic and Nuclear - ",
  "Tau",
  " (",
  Cell[BoxData[
      \(\(\[Tau]\^-\)\)]],
  ") Constants"
}], "Caption",
  CellTags->"Constants"],

Cell[BoxData[GridBox[{
        {"Names", "Symbol"},
        {"NeutronMass", \(m\_n\)},
        {"NeutronComptonWavelength", \(\[Lambda]\_\(C\_n\)\)},
        {"NeutronMagneticMoment", \(\[Mu]\_n\)},
        {"NeutronGFactor", \(g\_n\)}
        }]], "DefinitionBox",
  GridBoxOptions->{RowSpacings->0.4,
  RowLines->{True, False}},
  CellTags->"Constants"],

Cell[TextData[{
  "Unit Package Atomic and Nuclear - Neutron (",
  Cell[BoxData[
      \(n\)]],
  "),  Deuteron (",
  Cell[BoxData[
      \(d\)]],
  ") , Helion (",
  Cell[BoxData[
      \(h\)]],
  ") & Alpha (",
  Cell[BoxData[
      \(\[Alpha]\)]],
  ") Constants"
}], "Caption",
  CellTags->"Constants"],

Cell[BoxData[GridBox[{
        {"Names", "Symbol"},
        {"DeuteronMass", \(m\_d\)},
        {"DeuteronMagneticMoment", \(\[Mu]\_d\)}
        }]], "DefinitionBox",
  GridBoxOptions->{RowSpacings->0.4,
  RowLines->{True, False}},
  CellTags->"Constants"],

Cell["Unit Package Atomic and Nuclear - Constants", "Caption",
  CellTags->"Constants"],

Cell[TextData[{
  "To obtain more information, preced like ",
  Cell[BoxData[
      \(Unit\)]]
}], "MathCaption",
  CellTags->"Constants"],

Cell[CellGroupData[{

Cell[BoxData[
    \(UnitI@Unit["\<\[HBar]\>"]\)], "Input",
  CellLabel->"In[126]:=",
  CellTags->"Constants"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"Information About: \"\>", \
"\<\"\\!\\(\\*TagBox[StyleBox[\\\"\\\\\\\"\[HBar]\\\\\\\"\\\", \
Rule[FontSlant, Plain], Rule[ShowStringCharacters, False], Rule[FontColor, \
GrayLevel[0.5`]]], Unit]\\) (Constant)\"\>"},
          {"\<\" \"\>", "\<\"------------------------------\"\>"},
          {"\<\"Relative Uncertainty\"\>", \
"\<\"\\!\\(1.1000000000000002`*^-40\\)\"\>"},
          {"\<\"Dimensions:        \"\>", \
"\<\"\\!\\(\\\"\\\\!\\\\(\\\\*TagBox[StyleBox[\\\\\\\"\\\\\\\\\\\\\\\"Action\\\
\\\\\\\\\\\\\"\\\\\\\", Rule[FontSlant, Plain], Rule[ShowStringCharacters, \
False], Rule[FontColor, GrayLevel[0.5`]]], Unit]\\\\)\\\" \[Rule] \\\"\\\\!\\\
\\(\\\\*TagBox[StyleBox[\\\\(\\\\(\\\\\\\"Length\\\\\\\"\\\\^2\\\\\\\\ \\\\\\\
\"Mass\\\\\\\"\\\\)\\\\/\\\\\\\"Time\\\\\\\"\\\\), Rule[FontSlant, Plain], \
Rule[ShowStringCharacters, False], Rule[FontColor, GrayLevel[0.5`]]], Unit]\\\
\\)\\\"\\)\"\>"},
          {"\<\"Other Names:       \"\>", "\<\"\\!\\({\\\"PlanckConstant\\\"}\
\\)\"\>"},
          {"\<\"\\!\\(UnitCGS\\) Equivalent:\"\>", 
            RowBox[{"6.626069000000001`*^-27", " ", 
              TagBox[
                StyleBox[\(\("cm"\^2\ "gr"\)\/"s"\),
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}]},
          {"\<\"\\!\\(UnitFPS\\) Equivalent:\"\>", 
            RowBox[{"1.572390038750013`*^-32", " ", 
              TagBox[
                StyleBox[\(\("ft"\^2\ "lb"\)\/"s"\),
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}]},
          {"\<\"\\!\\(UnitMKS\\) Equivalent:\"\>", 
            RowBox[{"6.626069000000001`*^-34", " ", 
              TagBox[
                StyleBox[\(\("kg"\ "m"\^2\)\/"s"\),
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}]}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ BoxForm`e$, TableAlignments -> Left]]]], "Output",
  CellLabel->"Out[126]//StandardForm=",
  CellTags->"Constants"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(UnitI@Unit[\*"\"\<\!\(c\_0\)\>\""]\)], "Input",
  CellLabel->"In[127]:=",
  CellTags->"Constants"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"Information About: \"\>", \
"\<\"\\!\\(\\*TagBox[StyleBox[\\\"\\\\\\\"\\\\\\\\!\\\\\\\\(c\\\\\\\\_0\\\\\\\
\\)\\\\\\\"\\\", Rule[FontSlant, Plain], Rule[ShowStringCharacters, False], \
Rule[FontColor, GrayLevel[0.5`]]], Unit]\\) (Constant)\"\>"},
          {"\<\" \"\>", "\<\"------------------------------\"\>"},
          {"\<\"Relative Uncertainty\"\>", "\<\"\\!\\(0.`\\)\"\>"},
          {"\<\"Dimensions:        \"\>", \
"\<\"\\!\\(\\\"\\\\!\\\\(\\\\*TagBox[StyleBox[\\\\\\\"\\\\\\\\\\\\\\\"Speed\\\
\\\\\\\\\\\\\"\\\\\\\", Rule[FontSlant, Plain], Rule[ShowStringCharacters, \
False], Rule[FontColor, GrayLevel[0.5`]]], Unit]\\\\)\\\" \[Rule] \\\"\\\\!\\\
\\(\\\\*TagBox[StyleBox[\\\\(\\\\\\\"Length\\\\\\\"\\\\/\\\\\\\"Time\\\\\\\"\\\
\\), Rule[FontSlant, Plain], Rule[ShowStringCharacters, False], \
Rule[FontColor, GrayLevel[0.5`]]], Unit]\\\\)\\\"\\)\"\>"},
          {"\<\"Other Names:       \"\>", "\<\"\\!\\({\\\"c\\\", \
\\\"SpeedOfLight\\\", \\\"VacuumSpeedOfLight\\\"}\\)\"\>"},
          {"\<\"\\!\\(UnitCGS\\) Equivalent:\"\>", 
            RowBox[{"2.99792458`*^10", " ", 
              TagBox[
                StyleBox["\<\"Kyne\"\>",
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}]},
          {"\<\"\\!\\(UnitFPS\\) Equivalent:\"\>", 
            RowBox[{"9.835710564304461`*^8", " ", 
              TagBox[
                StyleBox[\("ft"\/"s"\),
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}]},
          {"\<\"\\!\\(UnitMKS\\) Equivalent:\"\>", 
            RowBox[{"2.99792458`*^8", " ", 
              TagBox[
                StyleBox[\("m"\/"s"\),
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}]}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ BoxForm`e$, TableAlignments -> Left]]]], "Output",
  CellLabel->"Out[127]//StandardForm=",
  CellTags->"Constants"]
}, Closed]],

Cell["Example: Attraction between two mass", "MathCaption",
  CellTags->"Constants"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{\(F \[Equal] G\ \(m\_1\ m\_2\)\/d\^2\), "/.", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{\(m\_1\), "\[Rule]", 
              RowBox[{"1", " ", 
                InterpretationBox[
                  StyleBox["kg",
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit[ kg]]}]}], ",", 
            RowBox[{\(m\_2\), "\[Rule]", 
              RowBox[{"1", 
                InterpretationBox[
                  StyleBox["kg",
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit[ kg]]}]}], ",", 
            RowBox[{"d", "\[Rule]", 
              RowBox[{"1.", " ", 
                InterpretationBox[
                  StyleBox["m",
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit[ "m"]]}]}]}], "}"}]}], 
      "/.", \(G \[Rule] Unit[G]\)}]], "Input",
  CellLabel->"In[128]:=",
  CellTags->"Constants"],

Cell[BoxData[
    RowBox[{"F", "\[Equal]", 
      RowBox[{"6.6742`*^-11", " ", 
        TagBox[
          StyleBox["\<\"N\"\>",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}]}]], "Output",
  CellLabel->"Out[128]=",
  CellTags->"Constants"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      \(UnitK\)]],
  " and ",
  Cell[BoxData[
      \(UnitS\)]],
  " utilities"
}], "Subsubsection",
  CellTags->"UnitK and UnitS utilities"],

Cell[TextData[{
  Cell[BoxData[
      \(UnitK\)]],
  " is a small utility that try to replace symbols that coincides with \
constants names with the value of the constant."
}], "Text",
  CellTags->"UnitK and UnitS utilities"],

Cell[BoxData[
    FormBox[GridBox[{
          {
            RowBox[{
              StyleBox["\<\"UnitK[\"\>",
                "MR"], 
              StyleBox["\<\"expr\"\>",
                "TI"], 
              StyleBox["\<\"]\"\>",
                "MR"], 
              StyleBox["\<\"\"\>",
                "MR"]}], Cell[BoxData[
                FormBox[
                  RowBox[{"Substitute", " ", "in", " ", 
                    StyleBox["\<\"expr\"\>",
                      "TI"], " ", "symbols", " ", "of", " ", "defined", " ", 
                    "constants", " ", "with", " ", "constants", 
                    " ", \(\(values\)\(.\)\)}], TraditionalForm]]]}
          },
        ColumnAlignments->{Right, Left}], TraditionalForm]], "DefinitionBox",
  GridBoxOptions->{RowSpacings->0.4,
  RowLines->False},
  CellTags->"UnitK and UnitS utilities"],

Cell["UnitK utility", "Caption",
  CellTags->"UnitK and UnitS utilities"],

Cell["Example: Universal gas constant", "MathCaption",
  CellTags->"UnitK and UnitS utilities"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(P\_0\) V\_0 \[Equal] R\ T\_0 // UnitK\)], "Input",
  CellLabel->"In[129]:=",
  CellTags->"UnitK and UnitS utilities"],

Cell[BoxData[
    RowBox[{
      FractionBox[
        RowBox[{"101325", " ", 
          TagBox[
            StyleBox["\<\"J\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], "26867751292540600329549352"], "\[Equal]", 
      FractionBox[
        RowBox[{"5463", " ", 
          TagBox[
            StyleBox["\<\"J\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], "1448591492039422112164360"]}]], "Output",
  CellLabel->"Out[129]=",
  CellTags->"UnitK and UnitS utilities"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Subtract @@ N[%]\)], "Input",
  CellLabel->"In[130]:=",
  CellTags->"UnitK and UnitS utilities"],

Cell[BoxData[
    RowBox[{"1.9577768812063801`*^-28", " ", 
      TagBox[
        StyleBox["\<\"J\"\>",
          ShowStringCharacters->False,
          FontSlant->"Plain",
          FontColor->GrayLevel[0.500008]],
        Unit]}]], "Output",
  CellLabel->"Out[130]=",
  CellTags->"UnitK and UnitS utilities"]
}, Closed]],

Cell[TextData[{
  "There are also other utility, ",
  Cell[BoxData[
      \(UnitS\)]],
  " to convert Stephen Wolfram's units package to ",
  Cell[BoxData[
      \(Unit\)]],
  " function."
}], "Text",
  CellTags->"UnitK and UnitS utilities"],

Cell[BoxData[
    FormBox[GridBox[{
          {
            RowBox[{
              StyleBox["\<\"UnitS[\"\>",
                "MR"], 
              StyleBox["\<\"expr\"\>",
                "TI"], 
              StyleBox["\<\"]\"\>",
                "MR"], 
              StyleBox["\<\"\"\>",
                "MR"]}], Cell[BoxData[
                FormBox[
                  RowBox[{
                    RowBox[{"Substitute", " ", "in", " ", 
                      StyleBox["\<\"expr\"\>",
                        "TI"], " ", "symbolsof", " ", "defined", " ", "units",
                       " ", "with", " ", "unit", " ", \(definition . \ By\), 
                      " ", "default"}], ",", 
                    " ", \(UnitS\ only\ substitute\ units\ names\ larger\ \
than\ 4\ \(\(letters\)\(.\)\)\)}], TraditionalForm]]]},
          {
            RowBox[{
              StyleBox["\<\"UnitConvert[\"\>",
                "MR"], 
              StyleBox["\<\"expt\"\>",
                "TI"], 
              StyleBox["\<\",\"\>",
                "MR"], 
              StyleBox["\<\"length\"\>",
                "TI"], 
              StyleBox["\<\"]\"\>",
                "MR"]}], Cell[BoxData[
                \(TraditionalForm\`Do\ the\ substitution\ with\ the\ \
specified\ \(\(length\)\(.\)\(\ \)\)\)]]}
          },
        ColumnAlignments->{Right, Left}], TraditionalForm]], "DefinitionBox",
  GridBoxOptions->{RowSpacings->0.4,
  RowLines->False},
  CellTags->"UnitK and UnitS utilities"],

Cell["UnitS utility", "Caption",
  CellTags->"UnitK and UnitS utilities"],

Cell[TextData[{
  "You don't need to load ",
  ButtonBox["Miscellaneous`Units`",
    ButtonStyle->"AddOnsLink"],
  " package to migrate"
}], "MathCaption",
  CellTags->"UnitK and UnitS utilities"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(37500\ Mile\)\/\(1397\ Hour\) // UnitS\)], "Input",
  CellLabel->"In[131]:=",
  CellTags->"UnitK and UnitS utilities"],

Cell[BoxData[
    RowBox[{"12", " ", 
      TagBox[
        StyleBox[\("m"\/"s"\),
          ShowStringCharacters->False,
          FontSlant->"Plain",
          FontColor->GrayLevel[0.500008]],
        Unit]}]], "Output",
  CellLabel->"Out[131]=",
  CellTags->"UnitK and UnitS utilities"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Setting up your out unit", "Subsubsection",
  CellTags->"Setting up your out unit"],

Cell["\<\
You can define a complete unit system, with your preferred form to output \
each unit. But probably you don't want to to change all the unit system. This \
section is for do few modifications in the given systems.\
\>", "Text",
  CellTags->"Setting up your out unit"],

Cell[TextData[StyleBox["First Example",
  FontWeight->"Bold"]], "Text",
  CellTags->"Setting up your out unit"],

Cell[TextData[{
  "By default, the frequency is expressed as ",
  Cell[BoxData[
      \(Hertz\)]]
}], "MathCaption",
  CellTags->"Setting up your out unit"],

Cell[CellGroupData[{

Cell[BoxData[
    \(1/Unit[min]\)], "Input",
  CellLabel->"In[132]:=",
  CellTags->"Setting up your out unit"],

Cell[BoxData[
    FractionBox[
      TagBox[
        StyleBox["\<\"Hz\"\>",
          ShowStringCharacters->False,
          FontSlant->"Plain",
          FontColor->GrayLevel[0.500008]],
        Unit], "60"]], "Output",
  CellLabel->"Out[132]=",
  CellTags->"Setting up your out unit"]
}, Closed]],

Cell[TextData[{
  "For expresse the frequencys as ",
  Cell[BoxData[
      FractionBox["1", 
        InterpretationBox[
          StyleBox["s",
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit[ s]]]]],
  " we cand do"
}], "MathCaption",
  CellTags->"Setting up your out unit"],

Cell[BoxData[
    \(\(Unit[Set, 
        UnitMKS, {Combined, "\<Hz\>", "\<s\>"\^\(-1\)}];\)\)], "Input",
  CellLabel->"In[133]:=",
  CellTags->"Setting up your out unit"],

Cell[CellGroupData[{

Cell[BoxData[
    \(1/Unit[min]\)], "Input",
  CellLabel->"In[134]:=",
  CellTags->"Setting up your out unit"],

Cell[BoxData[
    FractionBox[
      TagBox[
        StyleBox[\(1\/"s"\),
          ShowStringCharacters->False,
          FontSlant->"Plain",
          FontColor->GrayLevel[0.500008]],
        Unit], "60"]], "Output",
  CellLabel->"Out[134]=",
  CellTags->"Setting up your out unit"]
}, Closed]],

Cell["Other form is", "MathCaption",
  CellTags->"Setting up your out unit"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(Unit[Set, All];\)\), "\[IndentingNewLine]", 
    \(Unit[Set, "\<Hz\>" \[Rule] "\<s\>"\^\(-1\)]\)}], "Input",
  CellLabel->"In[282]:=",
  CellTags->"Setting up your out unit"],

Cell[BoxData[
    \("Rule \!\({\"Hz\" \[Rule] 1\/\"s\"}\) attached."\)], "Output",
  CellLabel->"Out[283]=",
  CellTags->"Setting up your out unit"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(1/Unit[min]\)], "Input",
  CellLabel->"In[284]:=",
  CellTags->"Setting up your out unit"],

Cell[BoxData[
    FractionBox[
      TagBox[
        StyleBox[\(1\/"s"\),
          ShowStringCharacters->False,
          FontSlant->"Plain",
          FontColor->GrayLevel[0.500008]],
        Unit], "60"]], "Output",
  CellLabel->"Out[284]=",
  CellTags->"Setting up your out unit"]
}, Closed]],

Cell["This restore the normal behavior", "MathCaption",
  CellTags->"Setting up your out unit"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Unit[Unset, "\<Hz\>" \[Rule] "\<s\>"\^\(-1\)]\)], "Input",
  CellLabel->"In[285]:=",
  CellTags->"Setting up your out unit"],

Cell[BoxData[
    \("Rule \!\({\"Hz\" \[Rule] 1\/\"s\"}\) deattached."\)], "Output",
  CellLabel->"Out[285]=",
  CellTags->"Setting up your out unit"]
}, Closed]],

Cell[TextData[StyleBox["Second Example",
  FontWeight->"Bold"]], "Text",
  CellTags->"Setting up your out unit"],

Cell[TextData[{
  "Usually, pressures are expressed in ",
  Cell[BoxData[
      \(Pascal\)]]
}], "MathCaption",
  CellTags->"Setting up your out unit"],

Cell[CellGroupData[{

Cell[BoxData[
    \(p := 3\ Unit[Atmosphere]; p\)], "Input",
  CellLabel->"In[287]:=",
  CellTags->"Setting up your out unit"],

Cell[BoxData[
    RowBox[{"303975", " ", 
      TagBox[
        StyleBox["\<\"Pa\"\>",
          ShowStringCharacters->False,
          FontSlant->"Plain",
          FontColor->GrayLevel[0.500008]],
        Unit]}]], "Output",
  CellLabel->"Out[287]=",
  CellTags->"Setting up your out unit"]
}, Closed]],

Cell[TextData[{
  "To change it to ",
  Cell[BoxData[
      \(Bar\)]],
  " let"
}], "MathCaption",
  CellTags->"Setting up your out unit"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Block[{Pa, Bar}, Unit[Set, Pa \[Rule] 10\^\(-5\)\ Bar]]\)], "Input",
  CellLabel->"In[288]:=",
  FormatType->TraditionalForm,
  CellTags->"Setting up your out unit"],

Cell[BoxData[
    \("Rule \!\({\"Pa\" \[Rule] \"Bar\"\/100000}\) attached."\)], "Output",
  CellLabel->"Out[288]=",
  CellTags->"Setting up your out unit"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(p\)], "Input",
  CellLabel->"In[289]:="],

Cell[BoxData[
    FractionBox[
      RowBox[{"12159", " ", 
        TagBox[
          StyleBox["\<\"Bar\"\>",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}], "4000"]], "Output",
  CellLabel->"Out[289]="]
}, Closed]],

Cell[TextData[StyleBox["Third Example",
  FontWeight->"Bold"]], "Text",
  CellTags->"Setting up your out unit"],

Cell["Other case can be Farad times seconds", "MathCaption",
  CellTags->"Setting up your out unit"],

Cell[CellGroupData[{

Cell[BoxData[
    \(x := 15\ Unit[A\ C/N]\/Unit[m/s\^2]; x\)], "Input",
  CellLabel->"In[290]:=",
  CellTags->"Setting up your out unit"],

Cell[BoxData[
    RowBox[{"15", " ", 
      TagBox[
        StyleBox[\(\("A"\^2\ "s"\^5\)\/\("kg"\ "m"\^2\)\),
          ShowStringCharacters->False,
          FontSlant->"Plain",
          FontColor->GrayLevel[0.500008]],
        Unit]}]], "Output",
  CellLabel->"Out[290]=",
  CellTags->"Setting up your out unit"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \({UnitD[x], UnitN[x]}\)], "Input",
  CellLabel->"In[291]:=",
  CellTags->"Setting up your out unit"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        TagBox[
          
          StyleBox[\(\("ElectricCurrent"\^2\ "Time"\^5\)\/\("Length"\^2\ \
"Mass"\)\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit], ",", 
        TagBox[
          
          StyleBox[\(\("ElectricCurrent"\^2\ "Time"\^5\)\/\("Length"\^2\ \
"Mass"\)\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}], "}"}]], "Output",
  CellLabel->"Out[291]=",
  CellTags->"Setting up your out unit"]
}, Closed]],

Cell["\<\
That dimension do not have any specific name. We can intruduce a name for \
Farad times seconds fast with\
\>", "MathCaption",
  CellTags->"Setting up your out unit"],

Cell[BoxData[
    \(\(Block[{A, s, kg, m, FS}, 
        Unit[Set, \(A\^2\ s\^5\)\/\(kg\ m\^2\) \[Rule] FS]];\)\)], "Input",
  CellLabel->"In[292]:=",
  CellTags->"Setting up your out unit"],

Cell[CellGroupData[{

Cell[BoxData[
    \(x\)], "Input",
  CellLabel->"In[293]:="],

Cell[BoxData[
    RowBox[{"15", " ", 
      TagBox[
        StyleBox["\<\"FS\"\>",
          ShowStringCharacters->False,
          FontSlant->"Plain",
          FontColor->GrayLevel[0.500008]],
        Unit]}]], "Output",
  CellLabel->"Out[293]="]
}, Closed]],

Cell[TextData[{
  StyleBox["Observation",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  ". ",
  Cell[BoxData[
      \(UnitD\)]],
  " can recognize dimensions of ",
  Cell[BoxData[
      \(p\)]]
}], "MathCaption",
  CellTags->"Setting up your out unit"],

Cell[CellGroupData[{

Cell[BoxData[
    \({p, UnitD[p], UnitN[p]}\)], "Input",
  CellLabel->"In[294]:=",
  CellTags->"Setting up your out unit"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        FractionBox[
          RowBox[{"12159", " ", 
            TagBox[
              StyleBox["\<\"Bar\"\>",
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}], "4000"], ",", 
        TagBox[
          StyleBox[\("Mass"\/\("Length"\ "Time"\^2\)\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit], ",", 
        TagBox[
          StyleBox["\<\"Pressure\"\>",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}], "}"}]], "Output",
  CellLabel->"Out[294]=",
  CellTags->"Setting up your out unit"]
}, Closed]],

Cell[TextData[{
  "but not of ",
  Cell[BoxData[
      \(x\)]]
}], "MathCaption",
  CellTags->"Setting up your out unit"],

Cell[CellGroupData[{

Cell[BoxData[
    \({x, UnitD[x], UnitN[x]}\)], "Input",
  CellLabel->"In[295]:=",
  CellTags->"Setting up your out unit"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"15", " ", 
          TagBox[
            StyleBox["\<\"FS\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        TagBox[
          StyleBox["\<\"FS\"\>",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit], ",", 
        TagBox[
          StyleBox["\<\"FS\"\>",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}], "}"}]], "Output",
  CellLabel->"Out[295]=",
  CellTags->"Setting up your out unit"]
}, Closed]],

Cell["\<\
We see latter (in Managing units dimensions) how to define a new dimension \
name better.\
\>", "MathCaption",
  CellTags->"Setting up your out unit"],

Cell[BoxData[
    \(\(Clear[x, p];\)\)], "Input",
  CellLabel->"In[296]:=",
  CellTags->"Setting up your out unit"]
}, Closed]],

Cell[CellGroupData[{

Cell["Unit prefixes", "Subsubsection",
  CellTags->"Unit prefixes"],

Cell["Unit package can recognize this words like prefixes", "Text",
  CellTags->"Unit prefixes"],

Cell[CellGroupData[{

Cell[BoxData[
    \(UnitI[Prefix]\)], "Input",
  CellLabel->"In[297]:=",
  CellTags->"Unit prefixes"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {"\<\"Prefixes\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
          {"\<\"=====================\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
          {GridBox[{
                {\("Percent" \[Rule] 0.01`\)}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {\("Gross" \[Rule] 144.`\)}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {\("Dozen" \[Rule] 12.`\)}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {\("BakersDozen" \[Rule] 13.`\)}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {\("Mole" \[Rule] \("mol" \[Rule] 6.0221367`*^23\)\)}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {\("Yotta" \[Rule] \("\[ScriptCapitalY]" \[Rule] 1.`*^24\)\)}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {\("Zetta" \[Rule] \("\[ScriptCapitalZ]" \[Rule] 1.`*^21\)\)}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {\("Exa" \[Rule] \("\[ScriptCapitalE]" \[Rule] 1.`*^18\)\)}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {\("Peta" \[Rule] \("\[ScriptCapitalP]" \[Rule] 1.`*^15\)\)}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {\("Tera" \[Rule] \("\[ScriptCapitalT]" \[Rule] 1.`*^12\)\)}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {\("Giga" \[Rule] \("\[ScriptCapitalG]" \[Rule] 1.`*^9\)\)}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {\("Mega" \[Rule] \("\[ScriptCapitalM]" \[Rule] 1.`*^6\)\)}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {\("Kilo" \[Rule] \("\[ScriptK]" \[Rule] 1000.`\)\)}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {\("Hecto" \[Rule] \("\[ScriptH]" \[Rule] 100.`\)\)}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {\("Deca" \[Rule] \("\[ScriptD]\[ScriptA]" \[Rule] 10.`\)\)}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {\("Deci" \[Rule] \("\[ScriptD]" \[Rule] 0.1`\)\)}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {\("Centi" \[Rule] \("\[ScriptC]" \[Rule] 0.01`\)\)}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {\("Milli" \[Rule] \("\[ScriptM]" \[Rule] 0.001`\)\)}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {\("Micro" \[Rule] \("\[Mu]" \[Rule] 1.`*^-6\)\)}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {\("Nano" \[Rule] \("\[ScriptN]" \[Rule] 1.`*^-9\)\)}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {\("Pico" \[Rule] \("\[ScriptP]" \[Rule] 1.`*^-12\)\)}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {\("Femto" \[Rule] \("\[ScriptF]" \[Rule] 1.`*^-15\)\)}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {\("Atto" \[Rule] \("\[ScriptA]" \[Rule] 1.`*^-18\)\)}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {\("Zepto" \[Rule] \("\[ScriptZ]" \[Rule] 1.`*^-21\)\)}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {\("Yocto" \[Rule] \("\[ScriptY]" \[Rule] 
                1.0000000000000001`*^-24\)\), "\<\"\"\>", "\<\"\"\>", "\<\"\"\
\>"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      TableForm[ {"Prefixes", "=====================", {{"Percent" -> .01}, {
        "Gross" -> 144.0}, {"Dozen" -> 12.0}, {"BakersDozen" -> 13.0}}, {{
        "Mole" -> ("mol" -> .60221366999999997*^24)}, {"Yotta" -> (
        "\[ScriptCapitalY]" -> .99999999999999998*^24)}, {"Zetta" -> (
        "\[ScriptCapitalZ]" -> .1*^22)}, {"Exa" -> (
        "\[ScriptCapitalE]" -> .1*^19)}}, {{"Peta" -> (
        "\[ScriptCapitalP]" -> .1*^16)}, {"Tera" -> (
        "\[ScriptCapitalT]" -> .1*^13)}, {"Giga" -> (
        "\[ScriptCapitalG]" -> .1*^10)}, {"Mega" -> (
        "\[ScriptCapitalM]" -> .1*^7)}}, {{"Kilo" -> (
        "\[ScriptK]" -> .1*^4)}, {"Hecto" -> ("\[ScriptH]" -> .1*^3)}, {
        "Deca" -> ("\[ScriptD]\[ScriptA]" -> .1*^2)}, {"Deci" -> (
        "\[ScriptD]" -> .10000000000000001)}}, {{"Centi" -> (
        "\[ScriptC]" -> .01)}, {"Milli" -> ("\[ScriptM]" -> .001)}, {
        "Micro" -> ("\[Mu]" -> .99999999999999995*^-6)}, {"Nano" -> (
        "\[ScriptN]" -> .10000000000000001*^-8)}}, {{"Pico" -> (
        "\[ScriptP]" -> .99999999999999998*^-12)}, {"Femto" -> (
        "\[ScriptF]" -> .10000000000000001*^-14)}, {"Atto" -> (
        "\[ScriptA]" -> .10000000000000001*^-17)}, {"Zepto" -> (
        "\[ScriptZ]" -> .99999999999999991*^-21)}}, {"Yocto" -> (
        "\[ScriptY]" -> .10000000000000001*^-23)}}, TableAlignments -> 
        Left]]], "Output",
  CellLabel->"Out[297]//StandardForm=",
  CellTags->"Unit prefixes"]
}, Closed]],

Cell["An Unit with prefix is converted to the default unit value", \
"MathCaption",
  CellTags->"Unit prefixes"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"5", " ", 
          InterpretationBox[
            StyleBox["\[ScriptK]",
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit[ "\[ScriptK]"]], " ", 
          InterpretationBox[
            StyleBox["m",
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit[ "m"]]}], ",", \(5\ Unit[\[ScriptK]\ m]\)}], "}"}]], "Input",\

  CellLabel->"In[299]:=",
  CellTags->"Unit prefixes"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"5000", " ", 
          TagBox[
            StyleBox["\<\"m\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"5000", " ", 
          TagBox[
            StyleBox["\<\"m\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Output",
  CellLabel->"Out[299]=",
  CellTags->"Unit prefixes"]
}, Closed]],

Cell["This set the default output unit to ", "MathCaption",
  CellTags->"Unit prefixes"],

Cell[CellGroupData[{

Cell[BoxData[{\(Unit[
        Set, "\<m\>" \[Rule] \(10\^\(-3\)\) "\<\[ScriptK]m\>"];\), "\
\[IndentingNewLine]", 
    RowBox[{"{", 
      RowBox[{
        RowBox[{"5", " ", 
          InterpretationBox[
            StyleBox["\[ScriptK]",
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit[ "\[ScriptK]"]], " ", 
          InterpretationBox[
            StyleBox["m",
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit[ "m"]]}], ",", \(5\ Unit["\<\[ScriptK]\>"]\ Unit["\<m\>"]\), 
        ",", \(5\ Unit[\[ScriptK]\ m]\)}], "}"}]}], "Input",
  CellLabel->"In[302]:=",
  CellTags->"Unit prefixes"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"5", " ", 
          TagBox[
            StyleBox["\<\"\[ScriptK]m\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"5", " ", 
          TagBox[
            StyleBox["\<\"\[ScriptK]m\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"5", " ", 
          TagBox[
            StyleBox["\<\"\[ScriptK]m\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Output",
  CellLabel->"Out[303]=",
  CellTags->"Unit prefixes"]
}, Closed]],

Cell["Two annotations:", "Text",
  CellTags->"Unit prefixes"],

Cell["\<\
\[FilledSmallSquare] We use script letters to abreviatte prefixes. But you \
can define the output unit in any form\
\>", "MathCaption",
  CellTags->"Unit prefixes"],

Cell[CellGroupData[{

Cell[BoxData[{\(Unit[
        Set, "\<m\>" \[Rule] \(10\^\(-3\)\) "\<km\>"];\), \
"\[IndentingNewLine]", 
    RowBox[{"{", 
      RowBox[{
        RowBox[{"5", " ", 
          InterpretationBox[
            StyleBox["\[ScriptK]",
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit[ "\[ScriptK]"]], " ", 
          InterpretationBox[
            StyleBox["m",
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit[ "m"]]}], 
        ",", \(5\ Unit["\<\[ScriptK]\>"]\ Unit["\<m\>"]\)}], "}"}]}], "Input",\

  CellLabel->"In[153]:=",
  CellTags->"Unit prefixes"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"5", " ", 
          TagBox[
            StyleBox["\<\"km\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"5", " ", 
          TagBox[
            StyleBox["\<\"km\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Output",
  CellLabel->"Out[154]=",
  CellTags->"Unit prefixes"]
}, Closed]],

Cell["\<\
\[FilledSmallSquare] Note that the first elment is a product, and the second \
is a unit string\
\>", "MathCaption",
  CellTags->"Unit prefixes"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"5", " ", 
          InterpretationBox[
            StyleBox["\[ScriptK]",
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit[ "\[ScriptK]"]], " ", 
          InterpretationBox[
            StyleBox["m",
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit[ "m"]]}], ",", 
        RowBox[{"5", " ", 
          InterpretationBox[
            StyleBox["km",
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit[ "km"]]}]}], "}"}]], "Input",
  CellLabel->"In[155]:=",
  CellTags->"Unit prefixes"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"5", " ", 
          TagBox[
            StyleBox["\<\"km\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"5", " ", 
          TagBox[
            StyleBox["\<\"km\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Output",
  CellLabel->"Out[155]=",
  CellTags->"Unit prefixes"]
}, Closed]],

Cell[BoxData[
    \(\(Unit[Set, All];\)\)], "Input",
  CellLabel->"In[304]:=",
  CellTags->"Unit prefixes"]
}, Closed]],

Cell[CellGroupData[{

Cell["Basic resolution of motion's problems", "Subsubsection",
  CellTags->"Basic resolution of motion's problems"],

Cell[BoxData[
    \(\(ClearAll[t, x, v, a, F, \[Alpha], \[Beta], m];\)\)], "Input",
  CellLabel->"In[157]:=",
  CellTags->"Basic resolution of motion's problems"],

Cell[TextData[{
  "A particle of mass ",
  Cell[BoxData[
      \(m\)]],
  " have the given velocity"
}], "Text",
  CellTags->"Basic resolution of motion's problems"],

Cell[BoxData[
    \(\(v[
          t_] = \[Alpha]\ \[ExponentialE]\^\(\(-\[Beta]\)\ t\)\/\@t;\)\)], \
"Input",
  CellLabel->"In[158]:=",
  CellTags->"Basic resolution of motion's problems"],

Cell["If the constants are given too,", "Text",
  CellTags->"Basic resolution of motion's problems"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{\({\[Alpha], \[Beta]}\), "=", 
      RowBox[{"{", 
        RowBox[{
          RowBox[{"9", " ", 
            TagBox[
              StyleBox[\(m\/\@s\),
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}], ",", 
          RowBox[{\(-4\), " ", \(10\^\(-4\)\), 
            TagBox[
              StyleBox[\(1\/s\),
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}]}], "}"}]}]], "Input",
  CellLabel->"In[159]:=",
  CellTags->"Basic resolution of motion's problems"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"9", " ", 
          TagBox[
            StyleBox[\("m"\/\@"s"\),
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"-", 
          FractionBox[
            TagBox[
              StyleBox["\<\"Hz\"\>",
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit], "2500"]}]}], "}"}]], "Output",
  CellLabel->"Out[159]=",
  CellTags->"Basic resolution of motion's problems"]
}, Closed]],

Cell["then", "Text",
  CellTags->"Basic resolution of motion's problems"],

Cell[CellGroupData[{

Cell[BoxData[
    \(v[t]\)], "Input",
  CellLabel->"In[160]:=",
  CellTags->"Basic resolution of motion's problems"],

Cell[BoxData[
    FractionBox[
      RowBox[{"9", " ", 
        SuperscriptBox["\[ExponentialE]", 
          FractionBox[
            RowBox[{"t", " ", 
              TagBox[
                StyleBox["\<\"Hz\"\>",
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}], "2500"]], " ", 
        TagBox[
          StyleBox[\("m"\/\@"s"\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}], \(\@t\)]], "Output",
  CellLabel->"Out[160]=",
  CellTags->"Basic resolution of motion's problems"]
}, Closed]],

Cell[TextData[{
  "The form of the velocity at any time not look very pretty because the time \
",
  Cell[BoxData[
      \(t\)]],
  " now has units. To have a more readable results we can specify units for \
the time (see that we not need to use PowerExpand)"
}], "Text",
  CellTags->"Basic resolution of motion's problems"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"v", "[", 
      RowBox[{"t", " ", 
        TagBox[
          StyleBox["min",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}], "]"}]], "Input",
  CellLabel->"In[161]:=",
  CellTags->"Basic resolution of motion's problems"],

Cell[BoxData[
    FractionBox[
      RowBox[{
      "3", " ", \(\@\(3\/5\)\), " ", \(\[ExponentialE]\^\(\(3\ t\)/125\)\), 
        " ", 
        TagBox[
          StyleBox[\("m"\/"s"\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}], \(2\ \@t\)]], "Output",
  CellLabel->"Out[161]=",
  CellTags->"Basic resolution of motion's problems"]
}, Closed]],

Cell[TextData[{
  "Specifically, for ",
  Cell[BoxData[
      RowBox[{"t", "=", 
        RowBox[{"2.", " ", 
          InterpretationBox[
            StyleBox["min",
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit[ min]]}]}]]]
}], "Text",
  CellTags->"Basic resolution of motion's problems"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"v", "[", 
      RowBox[{"2.", " ", 
        TagBox[
          StyleBox["min",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}], "]"}]], "Input",
  CellLabel->"In[162]:=",
  CellTags->"Basic resolution of motion's problems"],

Cell[BoxData[
    RowBox[{"0.8619816518905352`", " ", 
      TagBox[
        StyleBox[\("m"\/"s"\),
          ShowStringCharacters->False,
          FontSlant->"Plain",
          FontColor->GrayLevel[0.500008]],
        Unit]}]], "Output",
  CellLabel->"Out[162]=",
  CellTags->"Basic resolution of motion's problems"]
}, Closed]],

Cell["Also, we can Plot the velocity, taken Minuts", "Text",
  CellTags->"Basic resolution of motion's problems"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"Plot", "[", 
        RowBox[{
          RowBox[{"Evaluate", "@", 
            RowBox[{"Normal", "@", 
              RowBox[{"v", "[", 
                RowBox[{"t", " ", 
                  TagBox[
                    StyleBox["min",
                      ShowStringCharacters->False,
                      FontSlant->"Plain",
                      FontColor->GrayLevel[0.500008]],
                    Unit]}], "]"}]}]}], ",", \({t, 0, 120}\)}], "]"}], 
      ";"}]], "Input",
  CellLabel->"In[163]:=",
  CellTags->"Basic resolution of motion's problems"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00793651 -0.114983 0.309029 [
[.18254 .18155 -6 -9 ]
[.18254 .18155 6 0 ]
[.34127 .18155 -6 -9 ]
[.34127 .18155 6 0 ]
[.5 .18155 -6 -9 ]
[.5 .18155 6 0 ]
[.65873 .18155 -6 -9 ]
[.65873 .18155 6 0 ]
[.81746 .18155 -9 -9 ]
[.81746 .18155 9 0 ]
[.97619 .18155 -9 -9 ]
[.97619 .18155 9 0 ]
[.01131 .03953 -18 -4.5 ]
[.01131 .03953 0 4.5 ]
[.01131 .11679 -24 -4.5 ]
[.01131 .11679 0 4.5 ]
[.01131 .2713 -24 -4.5 ]
[.01131 .2713 0 4.5 ]
[.01131 .34856 -18 -4.5 ]
[.01131 .34856 0 4.5 ]
[.01131 .42582 -24 -4.5 ]
[.01131 .42582 0 4.5 ]
[.01131 .50307 -6 -4.5 ]
[.01131 .50307 0 4.5 ]
[.01131 .58033 -24 -4.5 ]
[.01131 .58033 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.18254 .19405 m
.18254 .2003 L
s
[(20)] .18254 .18155 0 1 Mshowa
.34127 .19405 m
.34127 .2003 L
s
[(40)] .34127 .18155 0 1 Mshowa
.5 .19405 m
.5 .2003 L
s
[(60)] .5 .18155 0 1 Mshowa
.65873 .19405 m
.65873 .2003 L
s
[(80)] .65873 .18155 0 1 Mshowa
.81746 .19405 m
.81746 .2003 L
s
[(100)] .81746 .18155 0 1 Mshowa
.97619 .19405 m
.97619 .2003 L
s
[(120)] .97619 .18155 0 1 Mshowa
.125 Mabswid
.06349 .19405 m
.06349 .1978 L
s
.10317 .19405 m
.10317 .1978 L
s
.14286 .19405 m
.14286 .1978 L
s
.22222 .19405 m
.22222 .1978 L
s
.2619 .19405 m
.2619 .1978 L
s
.30159 .19405 m
.30159 .1978 L
s
.38095 .19405 m
.38095 .1978 L
s
.42063 .19405 m
.42063 .1978 L
s
.46032 .19405 m
.46032 .1978 L
s
.53968 .19405 m
.53968 .1978 L
s
.57937 .19405 m
.57937 .1978 L
s
.61905 .19405 m
.61905 .1978 L
s
.69841 .19405 m
.69841 .1978 L
s
.7381 .19405 m
.7381 .1978 L
s
.77778 .19405 m
.77778 .1978 L
s
.85714 .19405 m
.85714 .1978 L
s
.89683 .19405 m
.89683 .1978 L
s
.93651 .19405 m
.93651 .1978 L
s
.25 Mabswid
0 .19405 m
1 .19405 L
s
.02381 .03953 m
.03006 .03953 L
s
[(0.5)] .01131 .03953 1 0 Mshowa
.02381 .11679 m
.03006 .11679 L
s
[(0.75)] .01131 .11679 1 0 Mshowa
.02381 .2713 m
.03006 .2713 L
s
[(1.25)] .01131 .2713 1 0 Mshowa
.02381 .34856 m
.03006 .34856 L
s
[(1.5)] .01131 .34856 1 0 Mshowa
.02381 .42582 m
.03006 .42582 L
s
[(1.75)] .01131 .42582 1 0 Mshowa
.02381 .50307 m
.03006 .50307 L
s
[(2)] .01131 .50307 1 0 Mshowa
.02381 .58033 m
.03006 .58033 L
s
[(2.25)] .01131 .58033 1 0 Mshowa
.125 Mabswid
.02381 .05498 m
.02756 .05498 L
s
.02381 .07043 m
.02756 .07043 L
s
.02381 .08589 m
.02756 .08589 L
s
.02381 .10134 m
.02756 .10134 L
s
.02381 .13224 m
.02756 .13224 L
s
.02381 .14769 m
.02756 .14769 L
s
.02381 .16314 m
.02756 .16314 L
s
.02381 .17859 m
.02756 .17859 L
s
.02381 .2095 m
.02756 .2095 L
s
.02381 .22495 m
.02756 .22495 L
s
.02381 .2404 m
.02756 .2404 L
s
.02381 .25585 m
.02756 .25585 L
s
.02381 .28675 m
.02756 .28675 L
s
.02381 .30221 m
.02756 .30221 L
s
.02381 .31766 m
.02756 .31766 L
s
.02381 .33311 m
.02756 .33311 L
s
.02381 .36401 m
.02756 .36401 L
s
.02381 .37946 m
.02756 .37946 L
s
.02381 .39491 m
.02756 .39491 L
s
.02381 .41037 m
.02756 .41037 L
s
.02381 .44127 m
.02756 .44127 L
s
.02381 .45672 m
.02756 .45672 L
s
.02381 .47217 m
.02756 .47217 L
s
.02381 .48762 m
.02756 .48762 L
s
.02381 .51853 m
.02756 .51853 L
s
.02381 .53398 m
.02756 .53398 L
s
.02381 .54943 m
.02756 .54943 L
s
.02381 .56488 m
.02756 .56488 L
s
.02381 .02408 m
.02756 .02408 L
s
.02381 .00863 m
.02756 .00863 L
s
.02381 .59578 m
.02756 .59578 L
s
.02381 .61123 m
.02756 .61123 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.02583 .61803 m
.02605 .56469 L
.02729 .433 L
.02846 .3609 L
.02954 .31511 L
.03053 .28315 L
.03279 .23193 L
.03396 .21244 L
.03506 .19707 L
.03756 .1694 L
.04 .14906 L
.04262 .13191 L
.04793 .10658 L
.05297 .0896 L
.0575 .07798 L
.06244 .06792 L
.07302 .05235 L
.07893 .04597 L
.08429 .04118 L
.09474 .03386 L
.10458 .02871 L
.11434 .02481 L
.12466 .02166 L
.13346 .0196 L
.14313 .01786 L
.14837 .01711 L
.15334 .01651 L
.16264 .01565 L
.16784 .01531 L
.17266 .01506 L
.17538 .01495 L
.17794 .01487 L
.18061 .0148 L
.18203 .01478 L
.18355 .01475 L
.18481 .01474 L
.18595 .01473 L
.18727 .01472 L
.18851 .01472 L
.18966 .01472 L
.19073 .01472 L
.19189 .01472 L
.19313 .01473 L
.19437 .01475 L
.1957 .01476 L
.19811 .01481 L
.20098 .01487 L
.2036 .01495 L
.20877 .01514 L
.21442 .0154 L
Mistroke
.22469 .01603 L
.24441 .01772 L
.26539 .02014 L
.30703 .02655 L
.34715 .03457 L
.38575 .04387 L
.4268 .05546 L
.46634 .06833 L
.50437 .08236 L
.54484 .09922 L
.5838 .11747 L
.62522 .13925 L
.66512 .16278 L
.7035 .18803 L
.74433 .218 L
.78365 .25021 L
.82145 .28462 L
.86171 .32537 L
.90045 .36904 L
.94164 .4208 L
.97619 .46892 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[163]:=",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40O003h00Oogoo8Goo003oOolQ
Ool00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo000KOol00`00Oomoo`3oOol3
Ool001]oo`03001oogoo0?moo`=oo`006goo0P00ogoo17oo000KOol00`00Oomoo`3oOol3Ool001]o
o`03001oogoo01aooah00<Qoo`006goo00<007ooOol05goo1@007Woo1@00`goo000KOol2000EOol3
000XOol6002mOol001]oo`03001oogoo019oo`80035oo`D00;Qoo`0027oo0P0017oo0P0017oo0P00
1Goo00<007ooOol047oo0P00>7oo1P00/Woo0007Ool01000Oomoo`0027oo00@007ooOol000Aoo`03
001oogoo00moo`03001oogoo03ioo`D00:eoo`001goo00@007ooOol000]oo`03001oogoo009oo`80
00moo`03001oogoo04Aoo`D00:Qoo`001goo00@007ooOol000Uoo`8000Eoo`03001oogoo00eoo`03
001oogoo04Yoo`@00:Aoo`001goo00@007ooOol000Uoo`03001oogoo00Aoo`03001oogoo00]oo`80
055oo`@00:1oo`0027oo0P002Woo0`0017oo00<007ooOol02Woo00<007ooOol0EGoo1000W7oo000K
Ool2000:Ool00`00Oomoo`1JOol3002IOol001]oo`03001oogoo00Uoo`03001oogoo05eoo`8009Mo
o`006goo00<007ooOol027oo00<007ooOol0H7oo0`00U7oo000KOol00`00Oomoo`08Ool00`00Oomo
o`1SOol2002BOol001]oo`8000Qoo`03001oogoo06Ioo`<008moo`006goo00<007ooOol01Woo00<0
07ooOol0JWoo0`00S7oo000KOol00`00Oomoo`06Ool00`00Oomoo`1]Ool40028Ool001]oo`03001o
ogoo00Eoo`03001oogoo079oo`<008Eoo`006goo0P001Woo00<007ooOol0MGoo0P00Pgoo000KOol0
0`00Oomoo`04Ool00`00Oomoo`1hOol20021Ool001]oo`03001oogoo00Aoo`03001oogoo07Yoo`80
07moo`006goo00<007ooOol017oo00<007ooOol0O7oo0P00OGoo000KOol20004Ool00`00Oomoo`1o
Ool2001kOol001]oo`03001oogoo00=oo`03001oogoo085oo`8007Uoo`000Woo0P0017oo0P001Goo
00<007ooOol00Woo0P001Goo00<007ooOol00goo00<007ooOol0Pgoo0P00Mgoo00001Goo001oogoo
00002Woo00D007ooOomoo`00009oo`03001oogoo009oo`03001oogoo00=oo`03001oogoo08Eoo`80
07Eoo`0000Eoo`00Oomoo`0000Yoo`03001oogoo00Aoo`03001oogoo009oo`8000Aoo`03001oogoo
08Moo`8007=oo`0000Eoo`00Oomoo`0000]oo`04001oogooOol20005Ool00`00Oomoo`02Ool00`00
Oomoo`2:Ool3001`Ool00005Ool007ooOol00008Ool01000Oomoo`000goo00<007ooOol017oo00<0
07ooOol00Woo00<007ooOol0SGoo0P00KWoo0002Ool20009Ool40003Ool30004Ool00`00Oomoo`02
Ool00`00Oomoo`2?Ool2001/Ool001]oo`8000=oo`03001oogoo095oo`8006Yoo`006goo00<007oo
Ool00Woo00<007ooOol0Tgoo0P00J7oo000KOol00`00Oomoo`02Ool00`00Oomoo`2EOol2001VOol0
01]oo`05001oogooOol0002JOol2001TOol001]oo`05001oogooOol0002LOol00`00Oomoo`1QOol0
01]oo`80009oo`03001oogoo01ioo`@000=oo`80029oo`<0009oo`80025oo`<000Aoo`80025oo`<0
00Aoo`8001ioo`D0009oo`8000Aoo`8001]oo`D00003Ool00000008000=oo`8000=oo`006goo00D0
07ooOomoo`00021oo`03001oogoo00=oo`04001oogoo000ROol01000Oomoo`000Woo00<007ooOol0
7Woo00@007ooOol0009oo`04001oogoo000POol01000Ool000000Woo00@007ooOol001moo`05001o
ogooOol00002Ool01000Oomoo`000Woo00<007ooOol06Woo00D007ooOomoo`0000Eoo`04001oogoo
0002Ool001]oo`05001oogooOol0000QOol00`00Oomoo`02Ool01000Oomoo`007goo1@0000Eoo`00
Oomoo`00021oo`04001oogoo0002Ool01000Oomoo`0087oo00<007ooOol00P0000Eoo`00Oomoo`00
01moo`05001oogooOol00002Ool01000Oomoo`000Woo00<007ooOol06Woo00<007ooOol00Woo00<0
07ooOol00Woo00@007ooOol0009oo`006goo00@007ooOol002=oo`05001oogooOol00002Ool00`00
Oomoo`0MOol01000Oomoo`000Woo00@007ooOol0021oo`<000=oo`04001oogoo000QOol20002Ool2
0002Ool00`00Oomoo`0MOol01@00Oomoogoo00000Woo00@007ooOol0009oo`03001oogoo01Yoo`03
001oogoo00=oo`05001oogooOol00002Ool10001Ool1Ool001]oo`800003Ool007oo021oo`04001o
ogoo0002Ool01000Oomoo`0087oo00<007oo00000Woo00@007ooOol0025oo`03001oogoo009oo`04
001oogoo000POol01000Oomoo`000Woo0P0000=oo`00Ool07Woo00D007ooOomoo`00009oo`04001o
ogoo0002Ool00`00Oomoo`0JOol01@00Oomoogoo00000Woo00@007ooOol0009oo`40005oo`5oo`00
6goo00@007ooOol0029oo`8000Aoo`80029oo`8000=oo`80029oo`<000=oo`80029oo`8000Aoo`<0
01ioo`8000Aoo`8000Aoo`8001aoo`8000Aoo`8000Aoo`8000=oo`006goo00@007ooOol00:Qoo`80
05Moo`006goo00@007ooOol00:Yoo`03001oogoo05Aoo`006goo0P0000=oo`00Ool0ZWoo0P00E7oo
000KOol01000Oomoo`00[Goo0P00DWoo000KOol01000Oomoo`00[goo00<007ooOol0Cgoo000KOol0
1000Oomoo`00/7oo00<007ooOol0CWoo000EOooo00090003Ool001]oo`04001oogoo0006Ool00`00
Oomoo`08Ool00`00Oomoo`07Ool00`00Oomoo`08Ool00`00Oomoo`07Ool00`00Oomoo`07Ool00`00
Oomoo`08Ool00`00Oomoo`07Ool00`00Oomoo`08Ool00`00Oomoo`07Ool00`00Oomoo`08Ool00`00
Oomoo`07Ool00`00Oomoo`08Ool00`00Oomoo`07Ool00`00Oomoo`07Ool00`00Oomoo`08Ool00`00
Oomoo`07Ool00`00Oomoo`03Ool00`00Oomoo`02Ool00`00Oomoo`07Ool00`00Oomoo`08Ool00`00
Oomoo`07Ool00`00Oomoo`08Ool00`00Oomoo`07Ool00`00Oomoo`08Ool00`00Oomoo`07Ool001]o
o`04001oogoo002dOol00`00Oomoo`1:Ool001]oo`03001oo`000;Ioo`03001oogoo04Uoo`006goo
0`00]goo0P00BGoo000KOol00`00Ool0002iOol00`00Oomoo`16Ool001]oo`03001oo`000;Yoo`03
001oogoo04Eoo`006goo00<007oo0000^goo00<007ooOol0A7oo000KOol3002lOol20014Ool001]o
o`03001oo`000;ioo`03001oogoo045oo`006goo00<007oo0000_goo00<007ooOol0@7oo000KOol0
0`00Ool00030Ool00`00Oomoo`0oOol001]oo`<00<5oo`03001oogoo03ioo`006goo00<007oo0000
`Woo0P00?Woo000KOol00`00Ool00034Ool00`00Oomoo`0kOol001]oo`03001oo`000<Eoo`03001o
ogoo03Yoo`006goo0`00aWoo00<007ooOol0>Goo000KOol00`00Ool00037Ool00`00Oomoo`0hOol0
0003Ool0000000<0009oo`8000=oo`@000=oo`8000Eoo`03001oo`000<Qoo`03001oogoo03Moo`00
0goo00<007ooOol01goo00<007ooOol00goo00@007ooOol000Aoo`03001oo`000<Uoo`03001oogoo
03Ioo`000goo00<007ooOol027oo00<007ooOol01Goo00<007ooOol00Woo0`00bWoo0P00=Woo0003
Ool00`00Oomoo`09Ool00`00Oomoo`02Ool20005Ool00`00Ool0003<Ool00`00Oomoo`0cOol000=o
o`03001oogoo00Moo`04001oogoo0003Ool00`00Oomoo`04Ool00`00Ool0003=Ool00`00Oomoo`0b
Ool0009oo`8000Yoo`8000Aoo`<000Aoo`03001oo`000<ioo`03001oogoo035oo`006goo0`00cgoo
00<007ooOol0<7oo000KOol00`00Ool0003@Ool00`00Oomoo`0_Ool001]oo`03001oo`000=5oo`03
001oogoo02ioo`006goo00<007oo0000dWoo00<007ooOol0;Goo000KOol2003DOol00`00Oomoo`0/
Ool001]oo`800=Eoo`03001oogoo02]oo`006goo0P00eWoo00<007ooOol0:Woo000KOol2003GOol0
0`00Oomoo`0YOol001]oo`800=Qoo`03001oogoo02Qoo`006goo0P00fGoo00<007ooOol09goo000K
Ool2003JOol00`00Oomoo`0VOol001]oo`800=]oo`03001oogoo02Eoo`006goo0P00g7oo00<007oo
Ool097oo000KOol2003MOol00`00Oomoo`0SOol000Moo`D0009oo`8000Aoo`8000Eoo`800=ioo`03
001oogoo029oo`002Goo00<007ooOol01goo00@007ooOol000Aoo`800=moo`03001oogoo025oo`00
2Goo00<007ooOol02Woo00<007ooOol00Woo0P00ggoo00<007ooOol08Goo0009Ool00`00Oomoo`08
Ool20005Ool2003POol00`00Oomoo`0POol000Uoo`03001oogoo00Qoo`03001oogoo00Aoo`800>5o
o`03001oogoo01moo`0027oo0P002Woo0`0017oo0P00hWoo00<007ooOol07Woo000KOol2003SOol0
0`00Oomoo`0MOol001]oo`800>Aoo`03001oogoo01aoo`006goo0P00iGoo00<007ooOol06goo000K
Ool2003VOol00`00Oomoo`0JOol001]oo`800>Moo`03001oogoo01Uoo`006goo0P00igoo00<007oo
Ool06Goo000KOol2003XOol00`00Oomoo`0HOol001]oo`800>Uoo`03001oogoo01Moo`006goo0P00
jWoo00<007ooOol05Woo000KOol2003ZOol00`00Oomoo`0FOol001]oo`800>]oo`03001oogoo01Eo
o`006goo0P00k7oo00<007ooOol057oo000KOol2003]Ool00`00Oomoo`0COol001]oo`800>eoo`03
001oogoo01=oo`006goo0P00kWoo00<007ooOol04Woo00000goo000000030002Ool20005Ool00`00
Oomoo`02Ool20005Ool2003_Ool00`00Oomoo`0AOol000=oo`03001oogoo00Uoo`05001oogooOol0
0002Ool00`00Oomoo`02Ool2003`Ool00`00Oomoo`0@Ool000=oo`03001oogoo00Uoo`03001oogoo
00Aoo`03001oogoo009oo`800?5oo`03001oogoo00moo`000goo00<007ooOol02Woo00@007ooOomo
o`8000Eoo`800?5oo`03001oogoo00moo`000goo00<007ooOol01goo00@007ooOol000=oo`03001o
ogoo00Aoo`800?9oo`03001oogoo00ioo`000Woo0P002Goo10000goo0`0017oo0P00lgoo00<007oo
Ool03Goo000KOol2003dOol00`00Oomoo`0<Ool001]oo`800?Aoo`03001oogoo00aoo`006goo0P00
mGoo00<007ooOol02goo000KOol2003fOol00`00Oomoo`0:Ool001]oo`800?Moo`03001oogoo00Uo
o`006goo0P00mgoo00<007ooOol02Goo000KOol2003hOol00`00Oomoo`08Ool001]oo`800?Uoo`03
001oogoo00Moo`006goo0P00ogoo17oo000KOol2003oOol4Ool001]oo`800?moo`Aoo`006goo0P00
ogoo17oo000KOol2003oOol4Ool001]oo`800?moo`Aoo`004goo100017oo0P00ogoo17oo000COol0
0`00Oomoo`05Ool00`00Oomoo`3oOol3Ool001Aoo`03001oogoo00Aoo`800?moo`Aoo`005Goo00<0
07ooOol00goo00<007ooOol0ogoo0goo000COol01000Oomoo`0017oo00<007ooOol0ogoo0goo000D
Ool20005Ool00`00Oomoo`3oOol3Ool001]oo`800?moo`Aoo`006goo00<007ooOol0ogoo0goo000K
Ool00`00Oomoo`3oOol3Ool001]oo`03001oogoo0?moo`=oo`006goo0P00ogoo17oo000KOol00`00
Oomoo`3oOol3Ool001]oo`03001oogoo0?moo`=oo`006goo00<007ooOol0ogoo0goo000KOol2003o
Ool4Ool001]oo`03001oogoo0?moo`=oo`006goo00<007ooOol0ogoo0goo000KOol00`00Oomoo`3o
Ool3Ool001]oo`800?moo`Aoo`006goo00<007ooOol0ogoo0goo00000goo000000020003Ool20003
Ool40003Ool20005Ool00`00Oomoo`3oOol3Ool00003Ool007oo00Yoo`03001oogoo00=oo`04001o
ogoo0004Ool00`00Oomoo`3oOol3Ool0009oo`03001oogoo00Uoo`03001oogoo00Eoo`03001oogoo
009oo`800?moo`Aoo`000goo00<007ooOol02Goo00<007ooOol00Woo0P001Goo00<007ooOol0ogoo
0goo00001Goo001oogoo000027oo00@007ooOol000=oo`03001oogoo00Aoo`03001oogoo0?moo`=o
o`000Woo0P002Woo0P0017oo0`0017oo00<007ooOol0ogoo0goo000KOol00`00Oomoo`3oOol3Ool0
01]oo`800?moo`Aoo`006goo00<007ooOol0ogoo0goo000KOol00`00Oomoo`3oOol3Ool001]oo`03
001oogoo0?moo`=oo`006goo0P00ogoo17oo000KOol00`00Oomoo`3oOol3Ool00?moob5oo`00ogoo
8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-13.063, 0.28452, 0.478646, \
0.0122926}},
  CellTags->"Basic resolution of motion's problems"]
}, Closed]],

Cell["\<\
Other Plot commands that produces the same result are (Note the time scale in \
the first example, and the slowly of the second example).\
\>", "Text",
  CellTags->"Basic resolution of motion's problems"],

Cell[BoxData[
    RowBox[{
      RowBox[{"Plot", "[", 
        RowBox[{
          RowBox[{"Evaluate", "@", 
            RowBox[{"Normal", "@", 
              RowBox[{"v", "[", 
                RowBox[{"t", " ", 
                  TagBox[
                    StyleBox["h",
                      ShowStringCharacters->False,
                      FontSlant->"Plain",
                      FontColor->GrayLevel[0.500008]],
                    Unit]}], "]"}]}]}], ",", \({t, 0, 2}\)}], "]"}], 
      ";"}]], "Input",
  CellLabel->"In[164]:=",
  CellTags->"Basic resolution of motion's problems"],

Cell[BoxData[
    RowBox[{
      RowBox[{"Plot", "[", 
        RowBox[{
          FractionBox[
            RowBox[{"v", "[", 
              RowBox[{"t", " ", 
                TagBox[
                  StyleBox["min",
                    ShowStringCharacters->False,
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit]}], "]"}], 
            TagBox[
              StyleBox[\(m\/s\),
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]], ",", \({t, 0, 120}\)}], "]"}], ";"}]], "Input",
  CellLabel->"In[165]:=",
  CellTags->"Basic resolution of motion's problems"],

Cell["The position and the acceleration at any time are", "Text",
  CellTags->"Basic resolution of motion's problems"],

Cell[CellGroupData[{

Cell[BoxData[
    \(x[t_] = \[Integral]\_0\%t v[u] \[DifferentialD]u\)], "Input",
  CellLabel->"In[166]:=",
  CellTags->"Basic resolution of motion's problems"],

Cell[BoxData[
    RowBox[{"450", " ", \(\@\[Pi]\), " ", 
      RowBox[{"Erfi", "[", 
        RowBox[{\(1\/50\), " ", \(\@t\), " ", 
          TagBox[
            StyleBox[\(1\/\@"s"\),
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], "]"}], " ", 
      TagBox[
        StyleBox["\<\"m\"\>",
          ShowStringCharacters->False,
          FontSlant->"Plain",
          FontColor->GrayLevel[0.500008]],
        Unit]}]], "Output",
  CellLabel->"Out[166]=",
  CellTags->"Basic resolution of motion's problems"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(a[t_] = \[PartialD]\_t v[t]\)], "Input",
  CellLabel->"In[167]:=",
  FormatType->TraditionalForm,
  CellTags->"Basic resolution of motion's problems"],

Cell[BoxData[
    RowBox[{
      FractionBox[
        RowBox[{"9", " ", 
          SuperscriptBox["\[ExponentialE]", 
            FractionBox[
              RowBox[{"t", " ", 
                TagBox[
                  StyleBox["\<\"Hz\"\>",
                    ShowStringCharacters->False,
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit]}], "2500"]], " ", 
          TagBox[
            StyleBox[\("m"\/"s"\^\(3/2\)\),
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], \(2500\ \@t\)], "-", 
      FractionBox[
        RowBox[{"9", " ", 
          SuperscriptBox["\[ExponentialE]", 
            FractionBox[
              RowBox[{"t", " ", 
                TagBox[
                  StyleBox["\<\"Hz\"\>",
                    ShowStringCharacters->False,
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit]}], "2500"]], " ", 
          TagBox[
            StyleBox[\("m"\/\@"s"\),
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], \(2\ t\^\(3/2\)\)]}]], "Output",
  CellLabel->"Out[167]=",
  CellTags->"Basic resolution of motion's problems"]
}, Closed]],

Cell["Again, more familiar forms are", "Text",
  CellTags->"Basic resolution of motion's problems"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"x", "[", 
      RowBox[{"t", " ", 
        TagBox[
          StyleBox["min",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}], "]"}]], "Input",
  CellLabel->"In[168]:=",
  CellTags->"Basic resolution of motion's problems"],

Cell[BoxData[
    RowBox[{
    "450", " ", \(\@\[Pi]\), " ", \(Erfi[1\/5\ \@\(3\/5\)\ \@t]\), " ", 
      TagBox[
        StyleBox["\<\"m\"\>",
          ShowStringCharacters->False,
          FontSlant->"Plain",
          FontColor->GrayLevel[0.500008]],
        Unit]}]], "Output",
  CellLabel->"Out[168]=",
  CellTags->"Basic resolution of motion's problems"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"a", "[", 
        RowBox[{"t", " ", 
          TagBox[
            StyleBox["min",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], "]"}], "//", "Together"}]], "Input",
  CellLabel->"In[169]:=",
  CellTags->"Basic resolution of motion's problems"],

Cell[BoxData[
    FractionBox[
      RowBox[{\(\@\(3\/5\)\), " ", \(\[ExponentialE]\^\(\(3\ t\)/125\)\), 
        " ", \((\(-125\) + 6\ t)\), " ", 
        TagBox[
          StyleBox[\("m"\/"s"\^2\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}], \(10000\ t\^\(3/2\)\)]], "Output",
  CellLabel->"Out[169]=",
  CellTags->"Basic resolution of motion's problems"]
}, Closed]],

Cell[TextData[{
  "For ",
  Cell[BoxData[
      FormBox[
        RowBox[{"t", "\[Equal]", 
          RowBox[{"2.", " ", 
            TagBox[
              StyleBox["min",
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}]}], TraditionalForm]]]
}], "Text",
  CellTags->"Basic resolution of motion's problems"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"x", "[", 
          RowBox[{"2.", " ", 
            TagBox[
              StyleBox["min",
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}], "]"}], ",", 
        RowBox[{"a", "[", 
          RowBox[{"2.", " ", 
            TagBox[
              StyleBox["min",
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}], "]"}]}], "}"}]], "Input",
  CellLabel->"In[170]:=",
  CellTags->"Basic resolution of motion's problems"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"200.38095702054582`", " ", 
          TagBox[
            StyleBox["\<\"m\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{\(-0.0032467975554543492`\), " ", 
          TagBox[
            StyleBox[\("m"\/"s"\^2\),
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Output",
  CellLabel->"Out[170]=",
  CellTags->"Basic resolution of motion's problems"]
}, Closed]],

Cell[TextData[{
  "Defining a value for the mass ",
  Cell[BoxData[
      \(m\)]],
  ", this is"
}], "Text",
  CellTags->"Basic resolution of motion's problems"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"m", "=", 
      RowBox[{"5", " ", 
        TagBox[
          StyleBox["kg",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}]}]], "Input",
  CellLabel->"In[171]:=",
  CellTags->"Basic resolution of motion's problems"],

Cell[BoxData[
    RowBox[{"5", " ", 
      TagBox[
        StyleBox["\<\"kg\"\>",
          ShowStringCharacters->False,
          FontSlant->"Plain",
          FontColor->GrayLevel[0.500008]],
        Unit]}]], "Output",
  CellLabel->"Out[171]=",
  CellTags->"Basic resolution of motion's problems"]
}, Closed]],

Cell["the force over the particle is", "Text",
  CellTags->"Basic resolution of motion's problems"],

Cell[CellGroupData[{

Cell[BoxData[
    \(F[t_] = m\ a[t]\)], "Input",
  CellLabel->"In[172]:=",
  CellTags->"Basic resolution of motion's problems"],

Cell[BoxData[
    RowBox[{"5", " ", 
      TagBox[
        StyleBox["\<\"kg\"\>",
          ShowStringCharacters->False,
          FontSlant->"Plain",
          FontColor->GrayLevel[0.500008]],
        Unit], " ", 
      RowBox[{"(", 
        RowBox[{
          FractionBox[
            RowBox[{"9", " ", 
              SuperscriptBox["\[ExponentialE]", 
                FractionBox[
                  RowBox[{"t", " ", 
                    TagBox[
                      StyleBox["\<\"Hz\"\>",
                        ShowStringCharacters->False,
                        FontSlant->"Plain",
                        FontColor->GrayLevel[0.500008]],
                      Unit]}], "2500"]], " ", 
              TagBox[
                StyleBox[\("m"\/"s"\^\(3/2\)\),
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}], \(2500\ \@t\)], "-", 
          FractionBox[
            RowBox[{"9", " ", 
              SuperscriptBox["\[ExponentialE]", 
                FractionBox[
                  RowBox[{"t", " ", 
                    TagBox[
                      StyleBox["\<\"Hz\"\>",
                        ShowStringCharacters->False,
                        FontSlant->"Plain",
                        FontColor->GrayLevel[0.500008]],
                      Unit]}], "2500"]], " ", 
              TagBox[
                StyleBox[\("m"\/\@"s"\),
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}], \(2\ t\^\(3/2\)\)]}], ")"}]}]], "Output",
  CellLabel->"Out[172]=",
  CellTags->"Basic resolution of motion's problems"]
}, Closed]],

Cell[TextData[{
  "To see ",
  Cell[BoxData[
      \(Newtons\)]],
  " in the answer, we must set units for the time"
}], "Text",
  CellTags->"Basic resolution of motion's problems"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"F", "[", 
        RowBox[{"t", " ", 
          TagBox[
            StyleBox["min",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], "]"}], "//", "Together"}]], "Input",
  CellLabel->"In[173]:=",
  CellTags->"Basic resolution of motion's problems"],

Cell[BoxData[
    FractionBox[
      RowBox[{\(\@\(3\/5\)\), " ", \(\[ExponentialE]\^\(\(3\ t\)/125\)\), 
        " ", \((\(-125\) + 6\ t)\), " ", 
        TagBox[
          StyleBox["\<\"N\"\>",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}], \(2000\ t\^\(3/2\)\)]], "Output",
  CellLabel->"Out[173]=",
  CellTags->"Basic resolution of motion's problems"]
}, Closed]],

Cell["Finally, we can Plot these results", "Text",
  CellTags->"Basic resolution of motion's problems"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{
          RowBox[{"Plot", "[", 
            RowBox[{
              RowBox[{"Evaluate", "@", 
                RowBox[{"Normal", "@", 
                  RowBox[{"#", "[", 
                    RowBox[{"t", " ", 
                      TagBox[
                        StyleBox["min",
                          ShowStringCharacters->False,
                          FontSlant->"Plain",
                          FontColor->GrayLevel[0.500008]],
                        Unit]}], "]"}]}]}], ",", \({t, 0, 120}\), 
              ",", \(AxesLabel \[Rule] {t, #}\)}], "]"}], "&"}], 
        "/@", \({x, v, a, F}\)}], ";"}]], "Input",
  CellLabel->"In[174]:=",
  CellTags->"Basic resolution of motion's problems"],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00793651 0.0147151 9.83336e-005 [
[.18254 .00222 -6 -9 ]
[.18254 .00222 6 0 ]
[.34127 .00222 -6 -9 ]
[.34127 .00222 6 0 ]
[.5 .00222 -6 -9 ]
[.5 .00222 6 0 ]
[.65873 .00222 -6 -9 ]
[.65873 .00222 6 0 ]
[.81746 .00222 -9 -9 ]
[.81746 .00222 9 0 ]
[.97619 .00222 -9 -9 ]
[.97619 .00222 9 0 ]
[1.025 .01472 0 -6.4375 ]
[1.025 .01472 10 6.4375 ]
[.01131 .11305 -24 -4.5 ]
[.01131 .11305 0 4.5 ]
[.01131 .21138 -24 -4.5 ]
[.01131 .21138 0 4.5 ]
[.01131 .30972 -24 -4.5 ]
[.01131 .30972 0 4.5 ]
[.01131 .40805 -24 -4.5 ]
[.01131 .40805 0 4.5 ]
[.01131 .50638 -24 -4.5 ]
[.01131 .50638 0 4.5 ]
[.01131 .60472 -24 -4.5 ]
[.01131 .60472 0 4.5 ]
[.02381 .64303 -5 0 ]
[.02381 .64303 5 12.875 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.18254 .01472 m
.18254 .02097 L
s
[(20)] .18254 .00222 0 1 Mshowa
.34127 .01472 m
.34127 .02097 L
s
[(40)] .34127 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(60)] .5 .00222 0 1 Mshowa
.65873 .01472 m
.65873 .02097 L
s
[(80)] .65873 .00222 0 1 Mshowa
.81746 .01472 m
.81746 .02097 L
s
[(100)] .81746 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(120)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.06349 .01472 m
.06349 .01847 L
s
.10317 .01472 m
.10317 .01847 L
s
.14286 .01472 m
.14286 .01847 L
s
.22222 .01472 m
.22222 .01847 L
s
.2619 .01472 m
.2619 .01847 L
s
.30159 .01472 m
.30159 .01847 L
s
.38095 .01472 m
.38095 .01847 L
s
.42063 .01472 m
.42063 .01847 L
s
.46032 .01472 m
.46032 .01847 L
s
.53968 .01472 m
.53968 .01847 L
s
.57937 .01472 m
.57937 .01847 L
s
.61905 .01472 m
.61905 .01847 L
s
.69841 .01472 m
.69841 .01847 L
s
.7381 .01472 m
.7381 .01847 L
s
.77778 .01472 m
.77778 .01847 L
s
.85714 .01472 m
.85714 .01847 L
s
.89683 .01472 m
.89683 .01847 L
s
.93651 .01472 m
.93651 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
gsave
1.025 .01472 -61 -10.4375 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(t) show
1.000 setlinewidth
grestore
.02381 .11305 m
.03006 .11305 L
s
[(1000)] .01131 .11305 1 0 Mshowa
.02381 .21138 m
.03006 .21138 L
s
[(2000)] .01131 .21138 1 0 Mshowa
.02381 .30972 m
.03006 .30972 L
s
[(3000)] .01131 .30972 1 0 Mshowa
.02381 .40805 m
.03006 .40805 L
s
[(4000)] .01131 .40805 1 0 Mshowa
.02381 .50638 m
.03006 .50638 L
s
[(5000)] .01131 .50638 1 0 Mshowa
.02381 .60472 m
.03006 .60472 L
s
[(6000)] .01131 .60472 1 0 Mshowa
.125 Mabswid
.02381 .03438 m
.02756 .03438 L
s
.02381 .05405 m
.02756 .05405 L
s
.02381 .07372 m
.02756 .07372 L
s
.02381 .09338 m
.02756 .09338 L
s
.02381 .13272 m
.02756 .13272 L
s
.02381 .15238 m
.02756 .15238 L
s
.02381 .17205 m
.02756 .17205 L
s
.02381 .19172 m
.02756 .19172 L
s
.02381 .23105 m
.02756 .23105 L
s
.02381 .25072 m
.02756 .25072 L
s
.02381 .27038 m
.02756 .27038 L
s
.02381 .29005 m
.02756 .29005 L
s
.02381 .32938 m
.02756 .32938 L
s
.02381 .34905 m
.02756 .34905 L
s
.02381 .36872 m
.02756 .36872 L
s
.02381 .38838 m
.02756 .38838 L
s
.02381 .42772 m
.02756 .42772 L
s
.02381 .44738 m
.02756 .44738 L
s
.02381 .46705 m
.02756 .46705 L
s
.02381 .48672 m
.02756 .48672 L
s
.02381 .52605 m
.02756 .52605 L
s
.02381 .54572 m
.02756 .54572 L
s
.02381 .56538 m
.02756 .56538 L
s
.02381 .58505 m
.02756 .58505 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.02381 .64303 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(x) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.02381 .01475 m
.02499 .02 L
.02605 .02202 L
.02846 .02526 L
.03279 .02943 L
.04262 .03623 L
.06244 .04619 L
.10458 .06229 L
.14451 .07547 L
.18292 .08755 L
.22379 .10034 L
.26314 .1129 L
.30098 .12542 L
.34126 .13939 L
.38004 .15364 L
.42126 .16979 L
.46097 .18651 L
.49916 .2038 L
.53981 .2237 L
.57894 .24449 L
.62052 .26856 L
.66059 .29392 L
.69914 .32056 L
.74014 .35159 L
.77963 .3844 L
.8176 .41898 L
.85802 .45942 L
.89693 .50226 L
.93829 .55252 L
.97619 .60332 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[174]:=",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40O003h00Oogoo8Goo0010Ool4
0003Ool2000OOol30002Ool2000NOol30004Ool2000NOol20004Ool2000JOol50002Ool20004Ool2
000HOol500000goo000000020003Ool2000DOol0041oo`03001oogoo00=oo`04001oogoo000OOol0
1000Oomoo`000Woo00<007ooOol06goo00@007ooOol0009oo`04001oogoo000LOol01000Oomoo`00
0Woo00@007ooOol001]oo`05001oogooOol00002Ool01000Oomoo`000Woo00<007ooOol05goo00D0
07ooOomoo`0000Eoo`04001oogoo000COol0045oo`03001oogoo009oo`04001oogoo000LOol50000
1Goo001oogoo00007Goo00@007ooOol0009oo`04001oogoo000LOol01000Oomoo`000Woo00@007oo
Ool001]oo`05001oogooOol00002Ool01000Oomoo`000Woo00<007ooOol05goo00<007ooOol00Woo
00<007ooOol00Woo00@007ooOol001=oo`00@Woo00D007ooOomoo`00009oo`03001oogoo01Yoo`04
001oogoo0002Ool01000Oomoo`007Goo0`000goo00@007ooOol001eoo`8000=oo`04001oogoo000K
Ool01@00Oomoogoo00000Woo00@007ooOol0009oo`03001oogoo01Moo`03001oogoo00=oo`05001o
ogooOol00002Ool00`00Oomoo`0AOol0041oo`04001oogoo0002Ool01000Oomoo`007Goo00<007oo
00000Woo00@007ooOol001ioo`03001oogoo009oo`04001oogoo000LOol01000Oomoo`000Woo00@0
07ooOol001]oo`05001oogooOol00002Ool01000Oomoo`000Woo00<007ooOol05goo00D007ooOomo
o`00009oo`04001oogoo0002Ool00`00Oomoo`0AOol0045oo`8000Aoo`8001moo`8000=oo`8001mo
o`<000=oo`8001ioo`8000Aoo`8001]oo`8000Aoo`8000Aoo`8001Uoo`8000Aoo`8000Aoo`8001Ao
o`00ogoo8Goo000NOol00`00Oomoo`3oOol001ioo`03001oogoo0?moo`007Woo00<007ooOol0m7oo
0P002Goo000NOol00`00Oomoo`3cOol01000Oomoo`0027oo000IOooc0008Ool00`00Oomoo`09Ool0
01ioo`8002Eoo`03001oogoo02=oo`03001oogoo02Aoo`03001oogoo02=oo`03001oogoo02=oo`03
001oogoo02Aoo`03001oogoo00]oo`D000Qoo`007Woo00<007oo0000lgoo00<007ooOol02Goo000N
Ool01000Oomoo`00oWoo000NOol20002Ool00`00Oomoo`3kOol001ioo`03001oogoo009oo`800?]o
o`007Woo00<007ooOol017oo0P00nGoo000NOol00`00Oomoo`06Ool3003fOol001ioo`03001oogoo
00Uoo`800?Aoo`007Woo0P0037oo0`00lGoo000NOol00`00Oomoo`0>Ool2003_Ool001ioo`03001o
ogoo011oo`<00>aoo`007Woo00<007ooOol04goo0`00jGoo000NOol00`00Oomoo`0FOol4003UOol0
01ioo`8001]oo`<00>9oo`007Woo00<007ooOol07Goo0`00ggoo000NOol00`00Oomoo`0POol3003L
Ool001ioo`03001oogoo02=oo`<00=Uoo`007Woo00<007ooOol09Woo0`00eWoo000NOol2000ZOol4
003BOol001ioo`03001oogoo02eoo`<00<moo`0017oo1@000Woo0P0017oo0P0017oo0P001Goo00<0
07ooOol0<7oo0`00c7oo0006Ool01@00Oomoogoo00000Woo00@007ooOol0009oo`04001oogoo0002
Ool00`00Oomoo`02Ool00`00Oomoo`0cOol30039Ool000Ioo`05001oogooOol00002Ool01000Oomo
o`000Woo00@007ooOol0009oo`03001oogoo009oo`<003Ioo`<00<Ioo`001Woo00D007ooOomoo`00
009oo`04001oogoo0002Ool01000Oomoo`000Woo00<007ooOol00Woo00<007ooOol0>Goo0`00`goo
0006Ool01@00Oomoogoo00000Woo00@007ooOol0009oo`04001oogoo0002Ool00`00Oomoo`02Ool0
0`00Oomoo`0lOol30030Ool000Eoo`8000Aoo`8000Aoo`8000Aoo`8000Eoo`03001oogoo03moo`<0
0;eoo`007Woo00<007ooOol0@Woo0P00^goo000NOol20015Ool3002hOol001ioo`03001oogoo04Mo
o`800;Ioo`007Woo00<007ooOol0BGoo0`00/goo000NOol00`00Oomoo`1<Ool3002`Ool001ioo`03
001oogoo04moo`@00:aoo`007Woo0P00E7oo0`00ZGoo000NOol00`00Oomoo`1FOol2002WOol001io
o`03001oogoo05Qoo`<00:Aoo`007Woo00<007ooOol0Fgoo0P00XWoo000NOol00`00Oomoo`1MOol3
002OOol001ioo`80065oo`8009eoo`007Woo00<007ooOol0HWoo0P00Vgoo000NOol00`00Oomoo`1T
Ool2002IOol001ioo`03001oogoo06Ioo`<009Ioo`007Woo0P00JWoo0P00U7oo000NOol00`00Oomo
o`1[Ool2002BOol001ioo`03001oogoo06eoo`80091oo`0017oo10000goo0P0017oo0P0017oo0P00
1Goo00<007ooOol0Kgoo0P00SWoo0004Ool00`00Oomoo`03Ool01000Oomoo`000Woo00@007ooOol0
009oo`04001oogoo0004Ool00`00Oomoo`1aOol2002<Ool000Eoo`03001oogoo009oo`04001oogoo
0002Ool01000Oomoo`000Woo00@007ooOol000Aoo`<007=oo`8008Yoo`001Woo00D007ooOomoo`00
009oo`04001oogoo0002Ool01000Oomoo`000Woo00<007ooOol00Woo00<007ooOol0MGoo0P00R7oo
0004Ool01000Oomoo`000Woo00@007ooOol0009oo`04001oogoo0002Ool01000Oomoo`0017oo00<0
07ooOol0Mgoo0P00QWoo0005Ool20004Ool20004Ool20004Ool20005Ool00`00Oomoo`1iOol20024
Ool001ioo`03001oogoo07]oo`80089oo`007Woo0P00OWoo0P00P7oo000NOol00`00Oomoo`1oOol2
001nOol001ioo`03001oogoo085oo`8007aoo`007Woo00<007ooOol0Pgoo0P00NWoo000NOol00`00
Oomoo`25Ool2001hOol001ioo`8008Qoo`8007Ioo`007Woo00<007ooOol0RGoo00<007ooOol0Lgoo
000NOol00`00Oomoo`2:Ool2001cOol001ioo`03001oogoo08aoo`80075oo`007Woo0P00Sgoo00<0
07ooOol0KWoo000NOol00`00Oomoo`2?Ool2001^Ool001ioo`03001oogoo095oo`03001oogoo06]o
o`007Woo00<007ooOol0TWoo0P00Jgoo000NOol00`00Oomoo`2DOol00`00Oomoo`1XOol001ioo`80
09Ioo`8006Qoo`007Woo00<007ooOol0Ugoo00<007ooOol0IGoo000NOol00`00Oomoo`2HOol2001U
Ool000Eoo`8000Aoo`8000Aoo`8000Aoo`8000Eoo`03001oogoo09Yoo`03001oogoo069oo`0017oo
00@007ooOol0009oo`04001oogoo0002Ool01000Oomoo`000Woo00@007ooOol000Aoo`03001oogoo
09]oo`03001oogoo065oo`001Woo00D007ooOomoo`00009oo`04001oogoo0002Ool01000Oomoo`00
0Woo00<007ooOol00Woo0`00W7oo0P00HGoo0007Ool01000Oomoo`000Woo00@007ooOol0009oo`04
001oogoo0002Ool00`00Oomoo`02Ool00`00Oomoo`2NOol00`00Oomoo`1NOol000Aoo`04001oogoo
0002Ool01000Oomoo`000Woo00@007ooOol0009oo`04001oogoo0004Ool00`00Oomoo`2OOol2001N
Ool000Eoo`8000Aoo`8000Aoo`8000Aoo`8000Eoo`03001oogoo0:5oo`03001oogoo05]oo`007Woo
00<007ooOol0XWoo0P00Fgoo000NOol2002UOol00`00Oomoo`1HOol001ioo`03001oogoo0:Eoo`03
001oogoo05Moo`007Woo00<007ooOol0YWoo0P00Egoo000NOol00`00Oomoo`2XOol00`00Oomoo`1D
Ool001ioo`800:Yoo`8005Aoo`007Woo00<007ooOol0Zgoo00<007ooOol0DGoo000NOol00`00Oomo
o`2/Ool00`00Oomoo`1@Ool001ioo`03001oogoo0:eoo`03001oogoo04moo`007Woo00<007ooOol0
[Woo00<007ooOol0CWoo000NOol2002`Ool2001>Ool001ioo`03001oogoo0;5oo`03001oogoo04]o
o`007Woo00<007ooOol0/Woo00<007ooOol0BWoo000NOol00`00Oomoo`2cOol00`00Oomoo`19Ool0
01ioo`03001oogoo0;Aoo`03001oogoo04Qoo`007Woo0P00]Woo00<007ooOol0Agoo000NOol00`00
Oomoo`2fOol00`00Oomoo`16Ool001ioo`03001oogoo0;Moo`03001oogoo04Eoo`001Woo0`000Woo
0P0017oo0P0017oo0P001Goo00<007ooOol0^7oo0P00AGoo0007Ool01000Oomoo`000Woo00@007oo
Ool0009oo`04001oogoo0002Ool00`00Oomoo`02Ool00`00Oomoo`2jOol00`00Oomoo`12Ool000Ao
o`D00005Ool007ooOol00002Ool01000Oomoo`000Woo00@007ooOol000Aoo`<00;]oo`03001oogoo
045oo`0017oo00@007ooOol0009oo`04001oogoo0002Ool01000Oomoo`000Woo00@007ooOol000Ao
o`03001oogoo0;aoo`03001oogoo041oo`001Goo00<007oo00000Woo00@007ooOol0009oo`04001o
ogoo0002Ool01000Oomoo`0017oo00<007ooOol0_Goo00<007ooOol0?goo0006Ool20003Ool20004
Ool20004Ool20005Ool00`00Oomoo`2nOol00`00Oomoo`0nOol001ioo`03001oogoo0;moo`03001o
ogoo03eoo`007Woo0P00`Goo00<007ooOol0?7oo000NOol00`00Oomoo`31Ool00`00Oomoo`0kOol0
01ioo`03001oogoo0<9oo`03001oogoo03Yoo`007Woo00<007ooOol0`goo00<007ooOol0>Goo000N
Ool20035Ool00`00Oomoo`0hOol001ioo`03001oogoo0<Eoo`03001oogoo03Moo`007Woo00<007oo
Ool0aWoo00<007ooOol0=Woo000NOol00`00Oomoo`37Ool00`00Oomoo`0eOol001ioo`03001oogoo
0<Qoo`03001oogoo03Aoo`007Woo0P00bWoo00<007ooOol0<goo000NOol00`00Oomoo`3:Ool00`00
Oomoo`0bOol001ioo`03001oogoo0<]oo`03001oogoo035oo`007Woo00<007ooOol0c7oo00<007oo
Ool0<7oo000NOol00`00Oomoo`3<Ool00`00Oomoo`0`Ool001ioo`800<ioo`03001oogoo02moo`00
7Woo00<007ooOol0cWoo00<007ooOol0;Woo000NOol00`00Oomoo`3?Ool00`00Oomoo`0]Ool000Eo
o`8000Aoo`8000Aoo`8000Aoo`8000Eoo`03001oogoo0=1oo`03001oogoo02aoo`0017oo00@007oo
Ool0009oo`04001oogoo0002Ool01000Oomoo`000Woo00@007ooOol000Aoo`03001oogoo0=5oo`03
001oogoo02]oo`001goo00@007ooOol0009oo`04001oogoo0002Ool01000Oomoo`000Woo00<007oo
Ool00Woo0`00dWoo00<007ooOol0:Woo0005Ool20003Ool01000Oomoo`000Woo00@007ooOol0009o
o`04001oogoo0004Ool00`00Oomoo`3COol00`00Oomoo`0YOol000Eoo`03001oogoo009oo`04001o
ogoo0002Ool01000Oomoo`000Woo00@007ooOol000Aoo`03001oogoo0==oo`03001oogoo02Uoo`00
1Goo0`000goo0P0017oo0P0017oo0P001Goo00<007ooOol0e7oo00<007ooOol0:7oo000NOol2003F
Ool00`00Oomoo`0WOol001ioo`03001oogoo0=Ioo`03001oogoo02Ioo`007Woo00<007ooOol0egoo
00<007ooOol09Goo000NOol00`00Oomoo`3HOol00`00Oomoo`0TOol001ioo`03001oogoo0=Qoo`03
001oogoo02Aoo`007Woo0P00fWoo00<007ooOol08goo000NOol00`00Oomoo`3JOol00`00Oomoo`0R
Ool001ioo`03001oogoo0=]oo`03001oogoo025oo`007Woo00<007ooOol0g7oo00<007ooOol087oo
000NOol00`00Oomoo`3LOol00`00Oomoo`0POol001ioo`800=ioo`03001oogoo01moo`007Woo00<0
07ooOol0gWoo00<007ooOol07Woo000NOol00`00Oomoo`3OOol00`00Oomoo`0MOol001ioo`03001o
ogoo0=moo`03001oogoo01eoo`007Woo00<007ooOol0h7oo00<007ooOol077oo000NOol2003ROol0
0`00Oomoo`0KOol001ioo`03001oogoo0>9oo`03001oogoo01Yoo`0017oo0`0017oo0P0017oo0P00
17oo0P001Goo00<007ooOol0hWoo00<007ooOol06Woo0004Ool01000Oomoo`000Woo00@007ooOol0
009oo`04001oogoo0002Ool01000Oomoo`0017oo00<007ooOol0hgoo00<007ooOol06Goo0004Ool0
1000Oomoo`000Woo00@007ooOol0009oo`04001oogoo0002Ool01000Oomoo`0017oo0`00i7oo00<0
07ooOol067oo0004Ool30003Ool01000Oomoo`000Woo00@007ooOol0009oo`04001oogoo0004Ool0
0`00Oomoo`3oOol000Eoo`03001oogoo009oo`04001oogoo0002Ool01000Oomoo`000Woo00@007oo
Ool000Aoo`03001oogoo0?moo`001Goo0`000goo0P0017oo0P0017oo0P001Goo00<007ooOol0ogoo
000NOol00`00Oomoo`3oOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003o
OolQOol00?moob5oo`00ogoo8Goo003oOolQOol001]oo`800003Ool000000?moo`5oo`0077oo00<0
07oo0000ogoo0Woo000MOol00`00Oomoo`3oOol1Ool001]oo`800003Ool000000?moo`5oo`00ogoo
8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00001\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-16.0796, -505.341, \
0.520712, 42.0267}},
  CellTags->"Basic resolution of motion's problems"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00793651 -0.114983 0.309029 [
[.18254 .18155 -6 -9 ]
[.18254 .18155 6 0 ]
[.34127 .18155 -6 -9 ]
[.34127 .18155 6 0 ]
[.5 .18155 -6 -9 ]
[.5 .18155 6 0 ]
[.65873 .18155 -6 -9 ]
[.65873 .18155 6 0 ]
[.81746 .18155 -9 -9 ]
[.81746 .18155 9 0 ]
[.97619 .18155 -9 -9 ]
[.97619 .18155 9 0 ]
[1.025 .19405 0 -6.4375 ]
[1.025 .19405 10 6.4375 ]
[.01131 .03953 -18 -4.5 ]
[.01131 .03953 0 4.5 ]
[.01131 .11679 -24 -4.5 ]
[.01131 .11679 0 4.5 ]
[.01131 .2713 -24 -4.5 ]
[.01131 .2713 0 4.5 ]
[.01131 .34856 -18 -4.5 ]
[.01131 .34856 0 4.5 ]
[.01131 .42582 -24 -4.5 ]
[.01131 .42582 0 4.5 ]
[.01131 .50307 -6 -4.5 ]
[.01131 .50307 0 4.5 ]
[.01131 .58033 -24 -4.5 ]
[.01131 .58033 0 4.5 ]
[.02381 .64303 -5.03125 0 ]
[.02381 .64303 5.03125 12.875 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.18254 .19405 m
.18254 .2003 L
s
[(20)] .18254 .18155 0 1 Mshowa
.34127 .19405 m
.34127 .2003 L
s
[(40)] .34127 .18155 0 1 Mshowa
.5 .19405 m
.5 .2003 L
s
[(60)] .5 .18155 0 1 Mshowa
.65873 .19405 m
.65873 .2003 L
s
[(80)] .65873 .18155 0 1 Mshowa
.81746 .19405 m
.81746 .2003 L
s
[(100)] .81746 .18155 0 1 Mshowa
.97619 .19405 m
.97619 .2003 L
s
[(120)] .97619 .18155 0 1 Mshowa
.125 Mabswid
.06349 .19405 m
.06349 .1978 L
s
.10317 .19405 m
.10317 .1978 L
s
.14286 .19405 m
.14286 .1978 L
s
.22222 .19405 m
.22222 .1978 L
s
.2619 .19405 m
.2619 .1978 L
s
.30159 .19405 m
.30159 .1978 L
s
.38095 .19405 m
.38095 .1978 L
s
.42063 .19405 m
.42063 .1978 L
s
.46032 .19405 m
.46032 .1978 L
s
.53968 .19405 m
.53968 .1978 L
s
.57937 .19405 m
.57937 .1978 L
s
.61905 .19405 m
.61905 .1978 L
s
.69841 .19405 m
.69841 .1978 L
s
.7381 .19405 m
.7381 .1978 L
s
.77778 .19405 m
.77778 .1978 L
s
.85714 .19405 m
.85714 .1978 L
s
.89683 .19405 m
.89683 .1978 L
s
.93651 .19405 m
.93651 .1978 L
s
.25 Mabswid
0 .19405 m
1 .19405 L
s
gsave
1.025 .19405 -61 -10.4375 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(t) show
1.000 setlinewidth
grestore
.02381 .03953 m
.03006 .03953 L
s
[(0.5)] .01131 .03953 1 0 Mshowa
.02381 .11679 m
.03006 .11679 L
s
[(0.75)] .01131 .11679 1 0 Mshowa
.02381 .2713 m
.03006 .2713 L
s
[(1.25)] .01131 .2713 1 0 Mshowa
.02381 .34856 m
.03006 .34856 L
s
[(1.5)] .01131 .34856 1 0 Mshowa
.02381 .42582 m
.03006 .42582 L
s
[(1.75)] .01131 .42582 1 0 Mshowa
.02381 .50307 m
.03006 .50307 L
s
[(2)] .01131 .50307 1 0 Mshowa
.02381 .58033 m
.03006 .58033 L
s
[(2.25)] .01131 .58033 1 0 Mshowa
.125 Mabswid
.02381 .05498 m
.02756 .05498 L
s
.02381 .07043 m
.02756 .07043 L
s
.02381 .08589 m
.02756 .08589 L
s
.02381 .10134 m
.02756 .10134 L
s
.02381 .13224 m
.02756 .13224 L
s
.02381 .14769 m
.02756 .14769 L
s
.02381 .16314 m
.02756 .16314 L
s
.02381 .17859 m
.02756 .17859 L
s
.02381 .2095 m
.02756 .2095 L
s
.02381 .22495 m
.02756 .22495 L
s
.02381 .2404 m
.02756 .2404 L
s
.02381 .25585 m
.02756 .25585 L
s
.02381 .28675 m
.02756 .28675 L
s
.02381 .30221 m
.02756 .30221 L
s
.02381 .31766 m
.02756 .31766 L
s
.02381 .33311 m
.02756 .33311 L
s
.02381 .36401 m
.02756 .36401 L
s
.02381 .37946 m
.02756 .37946 L
s
.02381 .39491 m
.02756 .39491 L
s
.02381 .41037 m
.02756 .41037 L
s
.02381 .44127 m
.02756 .44127 L
s
.02381 .45672 m
.02756 .45672 L
s
.02381 .47217 m
.02756 .47217 L
s
.02381 .48762 m
.02756 .48762 L
s
.02381 .51853 m
.02756 .51853 L
s
.02381 .53398 m
.02756 .53398 L
s
.02381 .54943 m
.02756 .54943 L
s
.02381 .56488 m
.02756 .56488 L
s
.02381 .02408 m
.02756 .02408 L
s
.02381 .00863 m
.02756 .00863 L
s
.02381 .59578 m
.02756 .59578 L
s
.02381 .61123 m
.02756 .61123 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.02381 .64303 -66.0313 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(v) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.02583 .61803 m
.02605 .56469 L
.02729 .433 L
.02846 .3609 L
.02954 .31511 L
.03053 .28315 L
.03279 .23193 L
.03396 .21244 L
.03506 .19707 L
.03756 .1694 L
.04 .14906 L
.04262 .13191 L
.04793 .10658 L
.05297 .0896 L
.0575 .07798 L
.06244 .06792 L
.07302 .05235 L
.07893 .04597 L
.08429 .04118 L
.09474 .03386 L
.10458 .02871 L
.11434 .02481 L
.12466 .02166 L
.13346 .0196 L
.14313 .01786 L
.14837 .01711 L
.15334 .01651 L
.16264 .01565 L
.16784 .01531 L
.17266 .01506 L
.17538 .01495 L
.17794 .01487 L
.18061 .0148 L
.18203 .01478 L
.18355 .01475 L
.18481 .01474 L
.18595 .01473 L
.18727 .01472 L
.18851 .01472 L
.18966 .01472 L
.19073 .01472 L
.19189 .01472 L
.19313 .01473 L
.19437 .01475 L
.1957 .01476 L
.19811 .01481 L
.20098 .01487 L
.2036 .01495 L
.20877 .01514 L
.21442 .0154 L
Mistroke
.22469 .01603 L
.24441 .01772 L
.26539 .02014 L
.30703 .02655 L
.34715 .03457 L
.38575 .04387 L
.4268 .05546 L
.46634 .06833 L
.50437 .08236 L
.54484 .09922 L
.5838 .11747 L
.62522 .13925 L
.66512 .16278 L
.7035 .18803 L
.74433 .218 L
.78365 .25021 L
.82145 .28462 L
.86171 .32537 L
.90045 .36904 L
.94164 .4208 L
.97619 .46892 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[174]:=",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40O003h00Oogoo8Goo000KOol0
0`00Oomoo`3oOol3Ool001]oo`03001oogoo0?moo`=oo`006goo00<007ooOol0ogoo0goo000KOol2
003oOol4Ool001]oo`03001oogoo01eooaD00=1oo`006goo00<007ooOol067oo1@005Goo2P00aWoo
000KOol2000FOol3000TOol50031Ool001]oo`03001oogoo01=oo`8002aoo`D00;aoo`0027oo0P00
17oo0P0017oo0P001Goo00<007ooOol047oo0`00<goo1@00]goo0007Ool01000Oomoo`0027oo00@0
07ooOol000Aoo`03001oogoo00ioo`8003]oo`D00;9oo`001goo00@007ooOol000]oo`03001oogoo
009oo`8000ioo`03001oogoo041oo`D00:eoo`001goo00@007ooOol000Uoo`8000Eoo`03001oogoo
00aoo`03001oogoo04Ioo`@00:Uoo`001goo00@007ooOol000Uoo`03001oogoo00Aoo`03001oogoo
00Yoo`8004eoo`<00:Ioo`0027oo0P002Woo0`0017oo00<007ooOol02Goo00<007ooOol0D7oo1000
XWoo000KOol20009Ool00`00Oomoo`1EOol3002OOol001]oo`03001oogoo00Moo`03001oogoo05Uo
o`<009aoo`006goo00<007ooOol01goo00<007ooOol0G7oo1000V7oo000KOol00`00Oomoo`06Ool0
0`00Oomoo`1QOol3002EOol001]oo`8000Moo`03001oogoo06Aoo`8009=oo`006goo00<007ooOol0
1Goo00<007ooOol0Igoo0`00T7oo000KOol00`00Oomoo`05Ool00`00Oomoo`1ZOol2002>Ool001]o
o`03001oogoo00Eoo`03001oogoo06aoo`<008]oo`006goo0P001Goo00<007ooOol0L7oo0P00RGoo
000KOol00`00Oomoo`04Ool00`00Oomoo`1bOol30026Ool001]oo`03001oogoo00Aoo`03001oogoo
07Eoo`8008Aoo`006goo00<007ooOol00goo00<007ooOol0N7oo0P00PWoo000KOol20004Ool00`00
Oomoo`1jOol20020Ool0009oo`8000Aoo`8000Eoo`03001oogoo009oo`8000Eoo`03001oogoo00=o
o`03001oogoo07aoo`8007ioo`0000Eoo`00Oomoo`0000Yoo`05001oogooOol00002Ool00`00Oomo
o`02Ool00`00Oomoo`03Ool00`00Oomoo`1nOol2001lOol00005Ool007ooOol0000:Ool00`00Oomo
o`04Ool00`00Oomoo`02Ool20003Ool00`00Oomoo`21Ool2001jOol00005Ool007ooOol0000;Ool0
1000Oomoogoo0P001Goo00<007ooOol00Woo00<007ooOol0Pgoo0P00N7oo00001Goo001oogoo0000
27oo00@007ooOol000=oo`03001oogoo00Aoo`03001oogoo009oo`03001oogoo08Eoo`8007Ioo`00
0Woo0P002Goo10000goo0`0017oo00D007ooOomoo`0008Yoo`8007Aoo`006goo0P000Woo00<007oo
Ool0RWoo0P00LWoo000KOol01@00Oomoogoo0000SWoo0P00L7oo000KOol01@00Oomoogoo0000T7oo
0P00KWoo000KOol01@00Oomoogoo0000TWoo0P00K7oo000KOol20002Ool00`00Oomoo`2BOol2001Z
Ool001]oo`05001oogooOol0000MOol40003Ool2000QOol30002Ool2000NOol30004Ool2000POol2
0004Ool2000LOol50002Ool20004Ool2000HOol500000goo000000020003Ool2000AOol001]oo`05
001oogooOol0000MOol00`00Oomoo`03Ool01000Oomoo`008Goo00@007ooOol0009oo`03001oogoo
01]oo`04001oogoo0002Ool01000Oomoo`007Woo00<007ooOol00P0000Eoo`00Oomoo`0001eoo`05
001oogooOol00002Ool01000Oomoo`000Woo00<007ooOol05goo00D007ooOomoo`0000Eoo`04001o
ogoo000@Ool001]oo`05001oogooOol0000NOol00`00Oomoo`02Ool01000Oomoo`007Woo1@0000Eo
o`00Oomoo`0001eoo`04001oogoo0002Ool01000Oomoo`007Woo00D007ooOol007oo0080009oo`03
001oogoo01]oo`05001oogooOol00002Ool01000Oomoo`000Woo00<007ooOol05goo00<007ooOol0
0Woo00<007ooOol00Woo00@007ooOol0011oo`006goo0P0000=oo`00Ool07goo00D007ooOomoo`00
009oo`03001oogoo01aoo`04001oogoo0002Ool01000Oomoo`007Goo0`000goo00@007ooOol001mo
o`8000=oo`800003Ool007oo01aoo`05001oogooOol00002Ool01000Oomoo`000Woo00<007ooOol0
5goo00<007ooOol00goo00D007ooOomoo`00009oo`03001oogoo00ioo`006goo00@007ooOol001io
o`04001oogoo0002Ool01000Oomoo`007goo00<007oo00000Woo00@007ooOol001ioo`03001oogoo
009oo`04001oogoo000NOol01000Oomoo`000Woo00@007oo000001eoo`05001oogooOol00002Ool0
1000Oomoo`000Woo00<007ooOol05goo00D007ooOomoo`00009oo`04001oogoo0002Ool00`00Oomo
o`0>Ool001]oo`04001oogoo000OOol20004Ool2000QOol20003Ool2000OOol30003Ool2000POol2
0004Ool200000goo001oo`0JOol20004Ool20004Ool2000IOol20004Ool20004Ool2000AOol001]o
o`04001oogoo002POol2001OOol001]oo`800003Ool007oo0:5oo`03001oogoo05aoo`006goo00@0
07ooOol00:=oo`8005aoo`006goo00<007oo0000YWoo00<007ooOol0DWoo0P001Goo000KOol00`00
Ool0002WOol00`00Oomoo`1@Ool01000Oomoo`0017oo000EOooj0009Ool00`00Oomoo`05Ool001]o
o`03001oo`0000Moo`03001oogoo00Ioo`03001oogoo00Moo`03001oogoo00Moo`03001oogoo00Mo
o`03001oogoo00Moo`03001oogoo00Moo`03001oogoo00Moo`03001oogoo00Moo`03001oogoo00Mo
o`03001oogoo00Moo`03001oogoo00Ioo`03001oogoo00Moo`03001oogoo00Moo`03001oogoo00Mo
o`03001oogoo00Moo`03001oogoo00Moo`03001oogoo009oo`03001oogoo009oo`03001oogoo00Mo
o`03001oogoo00Moo`03001oogoo00Moo`03001oogoo00Moo`03001oogoo00Ioo`03001oogoo00Mo
o`03001oogoo00aoo`D000Aoo`006goo00<007oo0000Zgoo00<007ooOol0C7oo00<007ooOol01Goo
000KOol00`00Ool0002/Ool00`00Oomoo`1COol001]oo`<00:eoo`8005=oo`006goo00<007oo0000
[goo00<007ooOol0D7oo000KOol00`00Ool0002`Ool00`00Oomoo`1?Ool001]oo`<00;5oo`03001o
ogoo04ioo`006goo00<007oo0000/Woo0P00CWoo000KOol00`00Ool0002dOol00`00Oomoo`1;Ool0
01]oo`03001oo`000;Eoo`03001oogoo04Yoo`006goo0`00]Woo00<007ooOol0BGoo000KOol00`00
Ool0002gOol20019Ool001]oo`03001oo`000;Uoo`03001oogoo04Ioo`006goo00<007oo0000^Woo
00<007ooOol0AGoo000KOol3002kOol00`00Oomoo`14Ool001]oo`800;eoo`8004Aoo`0000=oo`00
00000`000Woo0P000goo10000goo0P001Goo0P00_goo00<007ooOol0@Goo0003Ool00`00Oomoo`07
Ool00`00Oomoo`03Ool01000Oomoo`0017oo0P00`7oo00<007ooOol0@7oo0003Ool00`00Oomoo`08
Ool00`00Oomoo`05Ool00`00Oomoo`02Ool20031Ool00`00Oomoo`0oOol000=oo`03001oogoo00Uo
o`03001oogoo009oo`8000Eoo`800<9oo`8003moo`000goo00<007ooOol01goo00@007ooOol000=o
o`03001oogoo00Aoo`800<Aoo`03001oogoo03aoo`000Woo0P002Woo0P0017oo0`0017oo0P00aGoo
00<007ooOol0>goo000KOol20036Ool00`00Oomoo`0jOol001]oo`800<Moo`03001oogoo03Uoo`00
6goo0P00b7oo00<007ooOol0>7oo000KOol20039Ool00`00Oomoo`0gOol001]oo`800<Yoo`03001o
ogoo03Ioo`006goo0P00bWoo00<007ooOol0=Woo000KOol2003;Ool00`00Oomoo`0eOol001]oo`80
0<aoo`03001oogoo03Aoo`006goo0P00cGoo00<007ooOol0<goo000KOol2003>Ool00`00Oomoo`0b
Ool001]oo`800<moo`03001oogoo035oo`006goo0P00d7oo00<007ooOol0<7oo000KOol2003AOol0
0`00Oomoo`0_Ool000Moo`D0009oo`8000Aoo`8000Eoo`800=9oo`03001oogoo02ioo`002Goo00<0
07ooOol01goo00@007ooOol000Aoo`800==oo`03001oogoo02eoo`002Goo00<007ooOol02Woo00<0
07ooOol00Woo0P00dgoo00<007ooOol0;Goo0009Ool00`00Oomoo`08Ool20005Ool2003DOol00`00
Oomoo`0/Ool000Uoo`03001oogoo00Qoo`03001oogoo00Aoo`800=Eoo`03001oogoo02]oo`0027oo
0P002Woo0`0017oo0P00eWoo00<007ooOol0:Woo000KOol2003GOol00`00Oomoo`0YOol001]oo`80
0=Qoo`03001oogoo02Qoo`006goo0P00fGoo00<007ooOol09goo000KOol2003JOol00`00Oomoo`0V
Ool001]oo`800=]oo`03001oogoo02Eoo`006goo0P00fgoo00<007ooOol09Goo000KOol2003LOol0
0`00Oomoo`0TOol001]oo`800=eoo`03001oogoo02=oo`006goo0P00gWoo00<007ooOol08Woo000K
Ool00`00Oomoo`3NOol00`00Oomoo`0QOol001]oo`03001oogoo0=moo`03001oogoo021oo`006goo
00<007ooOol0ggoo00<007ooOol087oo000KOol2003QOol00`00Oomoo`0OOol001]oo`03001oogoo
0>5oo`03001oogoo01ioo`0000=oo`0000000`000Woo0P001Goo00<007ooOol00Woo0P001Goo00<0
07ooOol0hWoo00<007ooOol07Goo0003Ool00`00Oomoo`09Ool01@00Oomoogoo00000Woo00<007oo
Ool00Woo00<007ooOol0hgoo00<007ooOol077oo0003Ool00`00Oomoo`09Ool00`00Oomoo`04Ool0
0`00Oomoo`02Ool2003TOol00`00Oomoo`0LOol000=oo`03001oogoo00Yoo`04001oogooOol20005
Ool00`00Oomoo`3TOol00`00Oomoo`0KOol000=oo`03001oogoo00Moo`04001oogoo0003Ool00`00
Oomoo`04Ool00`00Oomoo`3UOol00`00Oomoo`0JOol0009oo`8000Uoo`@000=oo`<000Aoo`800>Io
o`03001oogoo01Yoo`006goo00<007ooOol0iWoo00<007ooOol06Goo000KOol00`00Oomoo`3WOol0
0`00Oomoo`0HOol001]oo`03001oogoo0>Moo`03001oogoo01Qoo`006goo0P00jGoo00<007ooOol0
5goo000KOol00`00Oomoo`3YOol00`00Oomoo`0FOol001]oo`03001oogoo0>Uoo`03001oogoo01Io
o`006goo00<007ooOol0jWoo00<007ooOol05Goo000KOol2003oOol4Ool001]oo`03001oogoo0?mo
o`=oo`006goo00<007ooOol0ogoo0goo000KOol00`00Oomoo`3oOol3Ool001]oo`800?moo`Aoo`00
6goo00<007ooOol0ogoo0goo000COol40004Ool00`00Oomoo`3oOol3Ool001=oo`03001oogoo00Eo
o`03001oogoo0?moo`=oo`0057oo00<007ooOol017oo0P00ogoo17oo000EOol00`00Oomoo`03Ool0
0`00Oomoo`3oOol3Ool001=oo`04001oogoo0004Ool00`00Oomoo`3oOol3Ool001Aoo`8000Eoo`03
001oogoo0?moo`=oo`006goo0P00ogoo17oo000KOol00`00Oomoo`3oOol3Ool001]oo`03001oogoo
0?moo`=oo`006goo00<007ooOol0ogoo0goo000KOol2003oOol4Ool001]oo`03001oogoo0?moo`=o
o`006goo00<007ooOol0ogoo0goo000KOol2003oOol4Ool001]oo`03001oogoo0?moo`=oo`006goo
00<007ooOol0ogoo0goo000KOol00`00Oomoo`3oOol3Ool001]oo`800?moo`Aoo`006goo00<007oo
Ool0ogoo0goo00000goo000000020003Ool20003Ool40003Ool20005Ool00`00Oomoo`3oOol3Ool0
0003Ool007oo00Yoo`03001oogoo00=oo`04001oogoo0004Ool00`00Oomoo`3oOol3Ool0009oo`03
001oogoo00Uoo`03001oogoo00Eoo`03001oogoo009oo`800?moo`Aoo`000goo00<007ooOol02Goo
00<007ooOol00Woo0P001Goo00<007ooOol0ogoo0goo00001Goo001oogoo000027oo00@007ooOol0
00=oo`03001oogoo00Aoo`03001oogoo0?moo`=oo`000Woo0P002Woo0P0017oo0`0017oo00<007oo
Ool0ogoo0goo000KOol2003oOol4Ool001]oo`03001oogoo0?moo`=oo`006goo00<007ooOol0ogoo
0goo000KOol00`00Oomoo`3oOol3Ool001]oo`800?moo`Aoo`006goo00<007ooOol0ogoo0goo000K
Ool00`00Oomoo`3oOol3Ool00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003o
OolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`006Woo0P00ogoo1Goo000JOol2003o
Ool5Ool001Uoo`04001oogoo003oOol4Ool001Qoo`80009oo`800?moo`=oo`00ogoo8Goo003oOolQ
Ool00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-13.6919, 0.348905, \
0.504847, 0.0129655}},
  CellTags->"Basic resolution of motion's problems"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00793651 0.581944 34.2229 [
[.18254 .56944 -6 -9 ]
[.18254 .56944 6 0 ]
[.34127 .56944 -6 -9 ]
[.34127 .56944 6 0 ]
[.5 .56944 -6 -9 ]
[.5 .56944 6 0 ]
[.65873 .56944 -6 -9 ]
[.65873 .56944 6 0 ]
[.81746 .56944 -9 -9 ]
[.81746 .56944 9 0 ]
[.97619 .56944 -9 -9 ]
[.97619 .56944 9 0 ]
[1.025 .58194 0 -6.4375 ]
[1.025 .58194 10 6.4375 ]
[.01131 .0686 -36 -4.5 ]
[.01131 .0686 0 4.5 ]
[.01131 .15416 -42 -4.5 ]
[.01131 .15416 0 4.5 ]
[.01131 .23972 -30 -4.5 ]
[.01131 .23972 0 4.5 ]
[.01131 .32527 -42 -4.5 ]
[.01131 .32527 0 4.5 ]
[.01131 .41083 -36 -4.5 ]
[.01131 .41083 0 4.5 ]
[.01131 .49639 -42 -4.5 ]
[.01131 .49639 0 4.5 ]
[.02381 .64303 -5 0 ]
[.02381 .64303 5 12.875 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.18254 .58194 m
.18254 .58819 L
s
[(20)] .18254 .56944 0 1 Mshowa
.34127 .58194 m
.34127 .58819 L
s
[(40)] .34127 .56944 0 1 Mshowa
.5 .58194 m
.5 .58819 L
s
[(60)] .5 .56944 0 1 Mshowa
.65873 .58194 m
.65873 .58819 L
s
[(80)] .65873 .56944 0 1 Mshowa
.81746 .58194 m
.81746 .58819 L
s
[(100)] .81746 .56944 0 1 Mshowa
.97619 .58194 m
.97619 .58819 L
s
[(120)] .97619 .56944 0 1 Mshowa
.125 Mabswid
.06349 .58194 m
.06349 .58569 L
s
.10317 .58194 m
.10317 .58569 L
s
.14286 .58194 m
.14286 .58569 L
s
.22222 .58194 m
.22222 .58569 L
s
.2619 .58194 m
.2619 .58569 L
s
.30159 .58194 m
.30159 .58569 L
s
.38095 .58194 m
.38095 .58569 L
s
.42063 .58194 m
.42063 .58569 L
s
.46032 .58194 m
.46032 .58569 L
s
.53968 .58194 m
.53968 .58569 L
s
.57937 .58194 m
.57937 .58569 L
s
.61905 .58194 m
.61905 .58569 L
s
.69841 .58194 m
.69841 .58569 L
s
.7381 .58194 m
.7381 .58569 L
s
.77778 .58194 m
.77778 .58569 L
s
.85714 .58194 m
.85714 .58569 L
s
.89683 .58194 m
.89683 .58569 L
s
.93651 .58194 m
.93651 .58569 L
s
.25 Mabswid
0 .58194 m
1 .58194 L
s
gsave
1.025 .58194 -61 -10.4375 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(t) show
1.000 setlinewidth
grestore
.02381 .0686 m
.03006 .0686 L
s
[(-0.015)] .01131 .0686 1 0 Mshowa
.02381 .15416 m
.03006 .15416 L
s
[(-0.0125)] .01131 .15416 1 0 Mshowa
.02381 .23972 m
.03006 .23972 L
s
[(-0.01)] .01131 .23972 1 0 Mshowa
.02381 .32527 m
.03006 .32527 L
s
[(-0.0075)] .01131 .32527 1 0 Mshowa
.02381 .41083 m
.03006 .41083 L
s
[(-0.005)] .01131 .41083 1 0 Mshowa
.02381 .49639 m
.03006 .49639 L
s
[(-0.0025)] .01131 .49639 1 0 Mshowa
.125 Mabswid
.02381 .08571 m
.02756 .08571 L
s
.02381 .10282 m
.02756 .10282 L
s
.02381 .11994 m
.02756 .11994 L
s
.02381 .13705 m
.02756 .13705 L
s
.02381 .17127 m
.02756 .17127 L
s
.02381 .18838 m
.02756 .18838 L
s
.02381 .20549 m
.02756 .20549 L
s
.02381 .2226 m
.02756 .2226 L
s
.02381 .25683 m
.02756 .25683 L
s
.02381 .27394 m
.02756 .27394 L
s
.02381 .29105 m
.02756 .29105 L
s
.02381 .30816 m
.02756 .30816 L
s
.02381 .34238 m
.02756 .34238 L
s
.02381 .3595 m
.02756 .3595 L
s
.02381 .37661 m
.02756 .37661 L
s
.02381 .39372 m
.02756 .39372 L
s
.02381 .42794 m
.02756 .42794 L
s
.02381 .44505 m
.02756 .44505 L
s
.02381 .46216 m
.02756 .46216 L
s
.02381 .47928 m
.02756 .47928 L
s
.02381 .5135 m
.02756 .5135 L
s
.02381 .53061 m
.02756 .53061 L
s
.02381 .54772 m
.02756 .54772 L
s
.02381 .56483 m
.02756 .56483 L
s
.02381 .05149 m
.02756 .05149 L
s
.02381 .03438 m
.02756 .03438 L
s
.02381 .01727 m
.02756 .01727 L
s
.02381 .00015 m
.02756 .00015 L
s
.02381 .59906 m
.02756 .59906 L
s
.02381 .61617 m
.02756 .61617 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.02381 .64303 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.02926 0 m
.02954 .05089 L
.03053 .16582 L
.03163 .25123 L
.03279 .31424 L
.03395 .35985 L
.0352 .39624 L
.03638 .42246 L
.03746 .44156 L
.03873 .45956 L
.04011 .4753 L
.04262 .49673 L
.04523 .51253 L
.04759 .52318 L
.05033 .53258 L
.0529 .53945 L
.05748 .54852 L
.06007 .55238 L
.06244 .55537 L
.0675 .5604 L
.07221 .56393 L
.07739 .56693 L
.08293 .56943 L
.08875 .57148 L
.09426 .57304 L
.10458 .57528 L
.11423 .57681 L
.12449 .57805 L
.14291 .57966 L
.15228 .58027 L
.16238 .58083 L
.18066 .58163 L
.2007 .58232 L
.2218 .5829 L
.25991 .58373 L
.30047 .58445 L
.33951 .58506 L
.38101 .58569 L
.42099 .58631 L
.45946 .58692 L
.50038 .58761 L
.53978 .58833 L
.57767 .58907 L
.61801 .58994 L
.65683 .59087 L
.69811 .59195 L
.73787 .59311 L
.77612 .59434 L
.81681 .5958 L
.856 .59736 L
Mistroke
.89763 .59921 L
.93775 .6012 L
.97619 .60332 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[174]:=",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40O003h00Oogoo8Goo003oOolQ
Ool00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo000/Ool2003bOol002aoo`03
001oo`000?5oo`00;7oo00<007oo0000lGoo000/Ool00`00Ool0003aOol002aoo`<00?5oo`00;7oo
00<007oo0000lGoo000/Ool00`00Ool0003aOol002aoo`03001oo`000?5oo`00;7oo0`00lGoo000/
Ool00`00Ool0003aOol002aoo`03001oo`000?5oo`00;7oo00<007oo0000lGoo000/Ool3003aOol0
02aoo`03001oo`000?5oo`003Woo0P0017oo0P0017oo0P000goo1@000Woo0P0017oo00<007oo0000
lGoo000=Ool01000Oomoo`0027oo00@007ooOol000Aoo`05001oogooOol00002Ool01`00Oomoogoo
001oo`000?5oo`003Goo00@007ooOol000Qoo`04001oogoo0004Ool00`00Oomoo`04Ool01000Oomo
ogoo0`00lGoo0007Ool40002Ool01000Oomoo`0027oo00@007ooOol000Aoo`03001oogoo009oo`80
00Aoo`03001oo`000?5oo`003Goo00@007ooOol000Qoo`04001oogoo0004Ool00`00Oomoo`02Ool0
0`00Oomoo`03Ool00`00Ool0003aOol000ioo`8000Yoo`8000Aoo`8000Aoo`<000=oo`03001oo`00
0?5oo`00;7oo0`00lGoo000/Ool00`00Ool0003aOol002aoo`03001oo`000?5oo`00;7oo00<007oo
0000lGoo000/Ool3003aOol002aoo`03001oo`000?5oo`00;7oo00<007oo0000lGoo000/Ool00`00
Ool0003aOol002aoo`<00?5oo`00;7oo00<007oo0000lGoo000/Ool00`00Ool0003aOol002aoo`03
001oo`000?5oo`00;7oo0`00lGoo000/Ool00`00Ool0003aOol000Qoo`8000Aoo`8000Aoo`8000=o
o`D00003Ool00000008000=oo`8000Aoo`03001oo`000?5oo`001goo00@007ooOol000Qoo`04001o
ogoo0004Ool01@00Oomoogoo00001Goo00@007ooOol000=oo`03001oo`000?5oo`001goo00@007oo
Ool000Qoo`04001oogoo0004Ool00`00Oomoo`02Ool00`00Oomoo`05Ool01000Oomoogoo0`00lGoo
00000goo000000020002Ool01000Oomoo`0027oo00@007ooOol000Aoo`03001oogoo00=oo`03001o
ogoo009oo`8000Aoo`03001oo`000?5oo`001goo00@007ooOol000Qoo`04001oogoo0004Ool01@00
Oomoogoo00000Woo00D007ooOomoo`0000Eoo`03001oo`000?5oo`0027oo0P002Woo0P0017oo0P00
17oo0P0017oo0`000goo00<007oo0000lGoo000/Ool3003aOol002aoo`03001oo`000?5oo`00;7oo
00<007oo0000lGoo000/Ool00`00Ool0003aOol002aoo`<00?5oo`00;7oo00<007oo0000lGoo000/
Ool00`00Ool0003aOol002aoo`03001oo`000?5oo`00;7oo0`00lGoo000/Ool00`00Ool0003aOol0
02aoo`03001oo`000?5oo`00;7oo00<007oo0000lGoo000/Ool3003aOol002aoo`03001oo`000?5o
o`0057oo0P0017oo0P0017oo0P000goo1@000Woo00<007oo0000lGoo000COol01000Oomoo`0027oo
00@007ooOol000Aoo`03001oogoo009oo`03001oo`000?5oo`004goo00@007ooOol000Qoo`04001o
ogoo0004Ool00`00Oomoo`02Ool3003aOol000eoo`@0009oo`04001oogoo0008Ool01000Oomoo`00
17oo00<007ooOol00Woo00<007oo0000lGoo000COol01000Oomoo`0027oo00@007ooOol000Aoo`03
001oogoo009oo`03001oo`000?5oo`0057oo0P002Woo0P0017oo0P0017oo00<007oo0000lGoo000/
Ool3003aOol002aoo`03001oo`000?5oo`00;7oo00<007oo0000lGoo000/Ool00`00Ool0003aOol0
02aoo`<00?5oo`00;7oo00<007oo0000lGoo000/Ool00`00Ool0003aOol002aoo`03001oo`000?5o
o`00;7oo0`00lGoo000/Ool00`00Ool0003aOol002aoo`03001oo`000?5oo`00;7oo0`00lGoo000/
Ool00`00Ool0003aOol000Qoo`8000Aoo`8000Aoo`8000Aoo`8000Eoo`03001oogoo009oo`8000Ao
o`03001oo`000?5oo`001goo00@007ooOol000Qoo`04001oogoo0002Ool01000Oomoo`0017oo00D0
07ooOomoo`00009oo`07001oogooOol007oo0000lGoo0007Ool01000Oomoo`0027oo00@007ooOol0
009oo`04001oogoo0004Ool00`00Oomoo`04Ool01000Oomoogoo0`00lGoo00000goo000000020002
Ool01000Oomoo`0027oo00@007ooOol0009oo`04001oogoo0005Ool01000Oomoogoo0P0017oo00<0
07oo0000lGoo0007Ool01000Oomoo`0027oo00@007ooOol0009oo`04001oogoo0002Ool01000Oomo
o`000goo00<007ooOol00goo00<007oo0000lGoo0008Ool2000:Ool20004Ool20003Ool40003Ool3
0003Ool00`00Ool0003aOol002aoo`800003Ool007oo0>moo`00;7oo00@007ooOol00?1oo`00;7oo
00@007ooOol00?1oo`00;7oo00@007ooOol00?1oo`00;7oo0P0000=oo`00Ool0kgoo000/Ool01000
Oomoo`00l7oo000/Ool01000Oomoo`00l7oo000/Ool01000Oomoo`00l7oo000/Ool200000goo001o
o`3_Ool002aoo`04001oogoo003`Ool002aoo`04001oogoo003`Ool002aoo`04001oogoo003`Ool0
02aoo`800003Ool007oo0>moo`00;7oo00@007ooOol00?1oo`003Woo0P0017oo0P0017oo0P0017oo
0P0017oo0P0017oo00@007ooOol00?1oo`003Goo00@007ooOol000Qoo`04001oogoo0002Ool01000
Oomoo`000Woo00@007ooOol000=oo`04001oogoo003`Ool000eoo`04001oogoo0008Ool01000Oomo
o`000Woo00@007ooOol000Eoo`04001oogooOol4003`Ool000Moo`@0009oo`04001oogoo0008Ool0
1000Oomoo`000Woo00@007ooOol000=oo`8000Aoo`04001oogoo003`Ool000eoo`04001oogoo0008
Ool01000Oomoo`000Woo00@007ooOol000=oo`03001oogoo00=oo`04001oogoo003`Ool000ioo`80
00Yoo`8000Aoo`8000Aoo`<000=oo`04001oogoo003`Ool002aoo`800003Ool007oo0>moo`00;7oo
00@007ooOol00?1oo`00;7oo00D007ooOomoo`000>moo`00;7oo00D007ooOomoo`000>moo`00;7oo
0P000Woo00<007ooOol0kGoo000/Ool01@00Oomoogoo0000kgoo000/Ool01@00Oomoogoo0000kgoo
000/Ool01@00Oomoogoo0000kgoo000/Ool20002Ool00`00Oomoo`3]Ool002aoo`05001oogooOol0
003_Ool002aoo`05001oogooOol0003_Ool002aoo`05001oogooOol0003_Ool002aoo`80009oo`03
001oogoo0>eoo`00;7oo00D007ooOomoo`000>moo`0027oo0P0017oo0P0017oo0P0017oo0P000goo
10000goo0P0017oo00<007ooOol00Woo00<007ooOol0k7oo0007Ool01000Oomoo`0027oo00@007oo
Ool0009oo`04001oogoo0002Ool00`00Oomoo`03Ool01000Oomoo`000goo00<007ooOol00Woo00<0
07ooOol0k7oo0007Ool01000Oomoo`0027oo00@007ooOol0009oo`04001oogoo0003Ool00`00Oomo
o`05Ool01000Oomoogoo0`000Woo00<007ooOol0k7oo00000goo000000020002Ool01000Oomoo`00
27oo00@007ooOol0009oo`04001oogoo0004Ool00`00Oomoo`02Ool20004Ool00`00Oomoo`02Ool0
0`00Oomoo`3/Ool000Moo`04001oogoo0008Ool01000Oomoo`000Woo00@007ooOol0009oo`04001o
ogoo0003Ool00`00Oomoo`03Ool00`00Oomoo`02Ool00`00Oomoo`3/Ool000Qoo`8000Yoo`8000Ao
o`8000Aoo`8000Aoo`<000=oo`03001oogoo009oo`03001oogoo0>aoo`00;7oo0P000goo00<007oo
Ool0k7oo000/Ool00`00Oomoo`02Ool00`00Oomoo`3/Ool002aoo`03001oogoo00=oo`03001oogoo
0>]oo`00;7oo00<007ooOol00goo00<007ooOol0jgoo000/Ool20005Ool00`00Oomoo`3ZOol002ao
o`03001oogoo00Aoo`03001oogoo01Ioo`@000=oo`8001ioo`<0009oo`8001aoo`<000Aoo`8001eo
o`8000Aoo`8001Qoo`D0009oo`8000Aoo`8001Ioo`D00003Ool00000008000=oo`80011oo`00;7oo
00<007ooOol017oo00<007ooOol05Woo00<007ooOol00goo00@007ooOol001ioo`04001oogoo0002
Ool00`00Oomoo`0IOol01000Oomoo`000Woo00@007ooOol001]oo`04001oogoo0002Ool01000Oomo
o`006Goo00D007ooOomoo`00009oo`04001oogoo0002Ool00`00Oomoo`0EOol01@00Oomoogoo0000
1Goo00@007ooOol000moo`00;7oo00<007ooOol017oo00<007ooOol05goo00<007ooOol00Woo00@0
07ooOol001]oo`D00005Ool007ooOol0000KOol01000Oomoo`000Woo00@007ooOol001]oo`04001o
ogoo0002Ool01000Oomoo`006Goo00D007ooOomoo`00009oo`04001oogoo0002Ool00`00Oomoo`0E
Ool00`00Oomoo`02Ool00`00Oomoo`02Ool01000Oomoo`003goo000/Ool20006Ool00`00Oomoo`0G
Ool01@00Oomoogoo00000Woo00<007ooOol06Goo00@007ooOol0009oo`04001oogoo000KOol30003
Ool01000Oomoo`0077oo0P000goo00@007ooOol001Uoo`05001oogooOol00002Ool01000Oomoo`00
0Woo00<007ooOol05Goo00<007ooOol00goo00D007ooOomoo`00009oo`03001oogoo00eoo`00;7oo
00<007ooOol01Woo00<007ooOol057oo00@007ooOol0009oo`04001oogoo000LOol00`00Ool00002
Ool01000Oomoo`0077oo00<007ooOol00Woo00@007ooOol001]oo`04001oogoo0002Ool01000Oomo
o`006Goo00D007ooOomoo`00009oo`04001oogoo0002Ool00`00Oomoo`0EOol01@00Oomoogoo0000
0Woo00@007ooOol0009oo`03001oogoo00eoo`00;7oo00<007ooOol01Woo00<007ooOol05Goo0P00
17oo0P007Woo0P000goo0P007Goo0`000goo0P007Goo0P0017oo0P006Goo0P0017oo0P0017oo0P00
5goo0P0017oo0P0017oo0P0047oo000/Ool00`00Oomoo`07Ool2003XOol002aoo`8000Yoo`800>Io
o`00;7oo00<007ooOol02goo00<007ooOol0hgoo000/Ool00`00Oomoo`0<Ool5003IOol20005Ool0
02aoo`03001oogoo015oo`T00<moo`04001oogoo0004Ool002MoonT000Qoo`03001oogoo00Eoo`00
;7oo00<007ooOol01goo00<007ooOol01Woo00<007ooOol01Woo00<007ooOol01Woo00<007ooOol0
1Woo00<007ooOol01goo00@007ooOomood4000Aoo`03001oogoo00Ioo`03001oogoo00Moo`03001o
ogoo00Ioo`03001oogoo00Ioo`03001oogoo00Ioo`03001oogoo00Ioo`03001oogoo00Moo`03001o
ogoo00Ioo`03001oogoo00Ioo`03001oogoo00Ioo`03001oogoo00]oo`D000Aoo`00;7oo00<007oo
Ool0NWoo9@00BWoo00<007ooOol01Goo000/Ool00`00Oomoo`2OOolK000gOol002aoo`800;]ooa`0
01]oo`00;7oo00<007ooOol0eWoo1@005Woo000/Ool00`00Oomoo`3aOol002aoo`03001oogoo0?5o
o`00;7oo0P00lWoo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo
003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol002Yoo`D00?5oo`00:Woo1000lWoo000]Ool0
0`00Oomoo`3`Ool002]oo`<00?9oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQ
Ool00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00
\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-24.4032, -0.0179494, \
0.543516, 0.000126045}},
  CellTags->"Basic resolution of motion's problems"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00793651 0.581944 6.84458 [
[.18254 .56944 -6 -9 ]
[.18254 .56944 6 0 ]
[.34127 .56944 -6 -9 ]
[.34127 .56944 6 0 ]
[.5 .56944 -6 -9 ]
[.5 .56944 6 0 ]
[.65873 .56944 -6 -9 ]
[.65873 .56944 6 0 ]
[.81746 .56944 -9 -9 ]
[.81746 .56944 9 0 ]
[.97619 .56944 -9 -9 ]
[.97619 .56944 9 0 ]
[1.025 .58194 0 -6.4375 ]
[1.025 .58194 10 6.4375 ]
[.01131 .03438 -30 -4.5 ]
[.01131 .03438 0 4.5 ]
[.01131 .17127 -30 -4.5 ]
[.01131 .17127 0 4.5 ]
[.01131 .30816 -30 -4.5 ]
[.01131 .30816 0 4.5 ]
[.01131 .44505 -30 -4.5 ]
[.01131 .44505 0 4.5 ]
[.02381 .64303 -5 0 ]
[.02381 .64303 5 12.875 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.18254 .58194 m
.18254 .58819 L
s
[(20)] .18254 .56944 0 1 Mshowa
.34127 .58194 m
.34127 .58819 L
s
[(40)] .34127 .56944 0 1 Mshowa
.5 .58194 m
.5 .58819 L
s
[(60)] .5 .56944 0 1 Mshowa
.65873 .58194 m
.65873 .58819 L
s
[(80)] .65873 .56944 0 1 Mshowa
.81746 .58194 m
.81746 .58819 L
s
[(100)] .81746 .56944 0 1 Mshowa
.97619 .58194 m
.97619 .58819 L
s
[(120)] .97619 .56944 0 1 Mshowa
.125 Mabswid
.06349 .58194 m
.06349 .58569 L
s
.10317 .58194 m
.10317 .58569 L
s
.14286 .58194 m
.14286 .58569 L
s
.22222 .58194 m
.22222 .58569 L
s
.2619 .58194 m
.2619 .58569 L
s
.30159 .58194 m
.30159 .58569 L
s
.38095 .58194 m
.38095 .58569 L
s
.42063 .58194 m
.42063 .58569 L
s
.46032 .58194 m
.46032 .58569 L
s
.53968 .58194 m
.53968 .58569 L
s
.57937 .58194 m
.57937 .58569 L
s
.61905 .58194 m
.61905 .58569 L
s
.69841 .58194 m
.69841 .58569 L
s
.7381 .58194 m
.7381 .58569 L
s
.77778 .58194 m
.77778 .58569 L
s
.85714 .58194 m
.85714 .58569 L
s
.89683 .58194 m
.89683 .58569 L
s
.93651 .58194 m
.93651 .58569 L
s
.25 Mabswid
0 .58194 m
1 .58194 L
s
gsave
1.025 .58194 -61 -10.4375 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(t) show
1.000 setlinewidth
grestore
.02381 .03438 m
.03006 .03438 L
s
[(-0.08)] .01131 .03438 1 0 Mshowa
.02381 .17127 m
.03006 .17127 L
s
[(-0.06)] .01131 .17127 1 0 Mshowa
.02381 .30816 m
.03006 .30816 L
s
[(-0.04)] .01131 .30816 1 0 Mshowa
.02381 .44505 m
.03006 .44505 L
s
[(-0.02)] .01131 .44505 1 0 Mshowa
.125 Mabswid
.02381 .0686 m
.02756 .0686 L
s
.02381 .10282 m
.02756 .10282 L
s
.02381 .13705 m
.02756 .13705 L
s
.02381 .20549 m
.02756 .20549 L
s
.02381 .23972 m
.02756 .23972 L
s
.02381 .27394 m
.02756 .27394 L
s
.02381 .34238 m
.02756 .34238 L
s
.02381 .37661 m
.02756 .37661 L
s
.02381 .41083 m
.02756 .41083 L
s
.02381 .47928 m
.02756 .47928 L
s
.02381 .5135 m
.02756 .5135 L
s
.02381 .54772 m
.02756 .54772 L
s
.02381 .00015 m
.02756 .00015 L
s
.02381 .61617 m
.02756 .61617 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.02381 .64303 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(F) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.02926 0 m
.02954 .05089 L
.03053 .16582 L
.03163 .25123 L
.03279 .31424 L
.03395 .35985 L
.0352 .39624 L
.03638 .42246 L
.03746 .44156 L
.03873 .45956 L
.04011 .4753 L
.04262 .49673 L
.04523 .51253 L
.04759 .52318 L
.05033 .53258 L
.0529 .53945 L
.05748 .54852 L
.06007 .55238 L
.06244 .55537 L
.0675 .5604 L
.07221 .56393 L
.07739 .56693 L
.08293 .56943 L
.08875 .57148 L
.09426 .57304 L
.10458 .57528 L
.11423 .57681 L
.12449 .57805 L
.14291 .57966 L
.15228 .58027 L
.16238 .58083 L
.18066 .58163 L
.2007 .58232 L
.2218 .5829 L
.25991 .58373 L
.30047 .58445 L
.33951 .58506 L
.38101 .58569 L
.42099 .58631 L
.45946 .58692 L
.50038 .58761 L
.53978 .58833 L
.57767 .58907 L
.61801 .58994 L
.65683 .59087 L
.69811 .59195 L
.73787 .59311 L
.77612 .59434 L
.81681 .5958 L
.856 .59736 L
Mistroke
.89763 .59921 L
.93775 .6012 L
.97619 .60332 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[174]:=",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40O003h00Oogoo8Goo003oOolQ
Ool00?moob5oo`008Goo00<007ooOol0o7oo000QOol2003mOol0025oo`800?eoo`008Goo0P00oGoo
000QOol2003mOol0025oo`800?eoo`008Goo0P00oGoo0008Ool20004Ool20004Ool20004Ool20005
Ool2003mOol000Moo`04001oogoo0008Ool01000Oomoo`000Woo00@007ooOol000Aoo`800?eoo`00
1goo00@007ooOol000Qoo`04001oogoo0002Ool01000Oomoo`0017oo0P00oGoo00000goo00000002
0002Ool01000Oomoo`0027oo00@007ooOol000=oo`8000Eoo`800?eoo`001goo00@007ooOol000Qo
o`04001oogoo0002Ool01000Oomoo`0017oo0P00oGoo0008Ool2000:Ool20004Ool20005Ool2003m
Ool0025oo`800?eoo`008Goo0P00oGoo000QOol2003mOol0025oo`800?eoo`008Goo0P00oGoo000Q
Ool2003mOol0025oo`800?eoo`008Goo0P00oGoo000QOol2003mOol0025oo`800?eoo`008Goo0P00
oGoo000QOol2003mOol0025oo`800?eoo`008Goo0P00oGoo000QOol2003mOol0025oo`800?eoo`00
8Goo0P00oGoo000QOol2003mOol0025oo`800?eoo`008Goo0P00oGoo000QOol2003mOol0025oo`80
0?eoo`008Goo0P00oGoo000QOol2003mOol0025oo`800?eoo`008Goo0P00oGoo000QOol2003mOol0
00Qoo`8000Aoo`8000Aoo`8000=oo`<000Eoo`800?eoo`001goo00@007ooOol000Qoo`04001oogoo
0002Ool01000Oomoo`0017oo0P00oGoo0007Ool01000Oomoo`0027oo00@007ooOol0009oo`04001o
ogoo0004Ool2003mOol00003Ool000000080009oo`04001oogoo0008Ool01000Oomoo`000Woo0`00
1Goo0P00oGoo0007Ool01000Oomoo`0027oo00@007ooOol000=oo`03001oogoo00Aoo`800?eoo`00
27oo0P002Woo0P0017oo0`0017oo0P00oGoo000QOol2003mOol0025oo`800?eoo`008Goo0P00oGoo
000QOol2003mOol0025oo`800?eoo`008Goo0P00oGoo000QOol2003mOol0025oo`800?eoo`008Goo
0P00oGoo000QOol2003mOol0025oo`800?eoo`008Goo0P00oGoo000QOol2003mOol0025oo`800?eo
o`008Goo0P00oGoo000QOol2003mOol0025oo`800?eoo`008Goo0P00oGoo000QOol2003mOol0025o
o`800?eoo`008Goo0P00oGoo000QOol2003mOol0025oo`800?eoo`008Goo0P00oGoo000QOol00`00
Ool0003lOol0025oo`03001oo`000?aoo`008Goo00<007oo0000o7oo0008Ool20004Ool20004Ool2
0005Ool30003Ool00`00Ool0003lOol000Moo`04001oogoo0008Ool01000Oomoo`001Goo00<007oo
Ool00Woo00<007oo0000o7oo0007Ool01000Oomoo`0027oo00@007ooOol0009oo`D000=oo`<00?ao
o`0000=oo`0000000P000Woo00@007ooOol000Qoo`04001oogoo0002Ool01000Oomoo`0017oo00<0
07oo0000o7oo0007Ool01000Oomoo`0027oo00@007ooOol000=oo`03001oo`0000Aoo`03001oo`00
0?aoo`0027oo0P002Woo0P001Goo0P0017oo00<007oo0000o7oo000QOol00`00Ool0003lOol0025o
o`03001oo`000?aoo`008Goo00<007oo0000o7oo000QOol00`00Ool0003lOol0025oo`03001oo`00
0?aoo`008Goo00<007oo0000o7oo000QOol00`00Ool0003lOol0025oo`03001oo`000?aoo`008Goo
00<007oo0000o7oo000QOol00`00Ool0003lOol0025oo`03001oo`000?aoo`008Goo00<007oo0000
o7oo000QOol00`00Ool0003lOol0025oo`03001oo`000?aoo`008Goo00<007oo0000o7oo000QOol0
0`00Ool0003lOol0025oo`03001oo`000?aoo`008Goo00<007oo0000o7oo000QOol00`00Ool0003l
Ool0025oo`03001oo`000?aoo`008Goo00<007oo0000o7oo000QOol00`00Ool0003lOol0025oo`04
001oogoo003kOol0025oo`04001oogoo003kOol0025oo`04001oogoo003kOol0025oo`04001oogoo
003kOol0025oo`04001oogoo003kOol0025oo`04001oogoo003kOol000Qoo`8000Aoo`8000Aoo`80
00=oo`@000Aoo`04001oogoo003kOol000Moo`04001oogoo0008Ool01000Oomoo`000Woo00<007oo
Ool01Goo00@007ooOol00?]oo`001goo00@007ooOol000Qoo`04001oogoo0003Ool00`00Oomoo`04
Ool200000goo001oo`3jOol00003Ool000000080009oo`04001oogoo0008Ool01000Oomoo`0017oo
00<007ooOol00goo00@007ooOol00?]oo`001goo00@007ooOol000Qoo`04001oogoo0002Ool01000
Oomoo`0017oo00@007ooOol00?]oo`0027oo0P002Woo0P0017oo0P001Goo00@007ooOol00?]oo`00
8Goo00@007ooOol00?]oo`008Goo00@007ooOol00?]oo`008Goo00D007ooOomoo`000?Yoo`008Goo
00D007ooOomoo`000?Yoo`008Goo00D007ooOomoo`000?Yoo`008Goo00D007ooOomoo`000?Yoo`00
8Goo00D007ooOomoo`000?Yoo`008Goo00D007ooOomoo`000?Yoo`008Goo00D007ooOomoo`000?Yo
o`008Goo00D007ooOomoo`000?Yoo`008Goo00D007ooOomoo`000?Yoo`008Goo00<007ooOol00Woo
00<007ooOol0mgoo000QOol00`00Oomoo`02Ool00`00Oomoo`3gOol0025oo`03001oogoo009oo`03
001oogoo0?Moo`008Goo00<007ooOol00Woo00<007ooOol0mgoo000QOol00`00Oomoo`02Ool00`00
Oomoo`3gOol0025oo`03001oogoo009oo`03001oogoo0?Moo`008Goo00<007ooOol00goo00<007oo
Ool0mWoo000QOol00`00Oomoo`03Ool00`00Oomoo`0HOol40003Ool2000POol30002Ool2000NOol3
0004Ool2000NOol20004Ool2000KOol50002Ool20004Ool2000HOol500000goo000000020003Ool2
000@Ool0025oo`03001oogoo00Aoo`03001oogoo01Moo`03001oogoo00=oo`04001oogoo000POol0
1000Oomoo`000Woo00<007ooOol06goo00@007ooOol0009oo`04001oogoo000LOol01000Oomoo`00
0Woo00@007ooOol001aoo`05001oogooOol00002Ool01000Oomoo`000Woo00<007ooOol05goo00D0
07ooOomoo`0000Eoo`04001oogoo000?Ool0025oo`03001oogoo00Aoo`03001oogoo01Qoo`03001o
ogoo009oo`04001oogoo000MOol500001Goo001oogoo00007Goo00@007ooOol0009oo`04001oogoo
000LOol01000Oomoo`000Woo00@007ooOol001aoo`05001oogooOol00002Ool01000Oomoo`000Woo
00<007ooOol05goo00<007ooOol00Woo00<007ooOol00Woo00@007ooOol000moo`008Goo00<007oo
Ool01Goo00<007ooOol067oo00D007ooOomoo`00009oo`03001oogoo01]oo`04001oogoo0002Ool0
1000Oomoo`007Goo0`000goo00@007ooOol001eoo`8000=oo`04001oogoo000LOol01@00Oomoogoo
00000Woo00@007ooOol0009oo`03001oogoo01Moo`03001oogoo00=oo`05001oogooOol00002Ool0
0`00Oomoo`0=Ool0025oo`03001oogoo00Eoo`03001oogoo01Ioo`04001oogoo0002Ool01000Oomo
o`007Woo00<007oo00000Woo00@007ooOol001ioo`03001oogoo009oo`04001oogoo000LOol01000
Oomoo`000Woo00@007ooOol001aoo`05001oogooOol00002Ool01000Oomoo`000Woo00<007ooOol0
5goo00D007ooOomoo`00009oo`04001oogoo0002Ool00`00Oomoo`0=Ool0025oo`03001oogoo00Io
o`03001oogoo01Ioo`8000Aoo`80021oo`8000=oo`8001moo`<000=oo`8001ioo`8000Aoo`8001ao
o`8000Aoo`8000Aoo`8001Uoo`8000Aoo`8000Aoo`80011oo`008Goo00<007ooOol01goo00<007oo
Ool0lWoo000QOol00`00Oomoo`08Ool3003aOol0025oo`03001oogoo00]oo`800>moo`008Goo00<0
07ooOol03Goo1@00hgoo0P001Goo000QOol00`00Oomoo`0BOol9003IOol01000Oomoo`0017oo000K
Oood0009Ool00`00Oomoo`05Ool0025oo`03001oogoo00Ioo`03001oogoo00Moo`03001oogoo00Mo
o`03001oogoo00Ioo`03001oogoo00Moo`03001oogoo00Moo`04001oogooOolk0004Ool00`00Oomo
o`07Ool00`00Oomoo`07Ool00`00Oomoo`06Ool00`00Oomoo`07Ool00`00Oomoo`07Ool00`00Oomo
o`06Ool00`00Oomoo`07Ool00`00Oomoo`07Ool00`00Oomoo`06Ool00`00Oomoo`07Ool00`00Oomo
o`07Ool00`00Oomoo`0;Ool50004Ool0025oo`03001oogoo02=oo`03001oogoo02Aoo`03001oogoo
02Aoo`03001oogoo009ooc0001Qoo`03001oogoo02Aoo`03001oogoo00aoo`03001oogoo00Eoo`00
8Goo00<007ooOol0YWoo7@00>Goo000QOol00`00Oomoo`33OolC000VOol0025oo`03001oogoo0=Io
oa0001Ioo`008Goo00<007ooOol0o7oo000QOol00`00Oomoo`3lOol0025oo`03001oogoo0?aoo`00
8Goo00<007ooOol0o7oo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo
8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol001moo`<00?ioo`0087oo00<007ooOol0
oGoo000POol00`00Oomoo`3mOol0021oo`800?ioo`0087oo00@007ooOol00?aoo`007goo1@00o7oo
003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-17.0889, -0.0872353, \
0.51711, 0.000599606}},
  CellTags->"Basic resolution of motion's problems"]
}, Closed]]
}, Closed]],

Cell[TextData[{
  StyleBox["Note",
    FontWeight->"Bold"],
  StyleBox[".",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  " The Differential total ",
  Cell[BoxData[
      \(Dt\)]],
  " can evaluate with units"
}], "Text",
  CellTags->"Basic resolution of motion's problems"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      FractionBox[
        RowBox[{"Dt", "[", 
          RowBox[{"v", "[", 
            RowBox[{"t", " ", 
              TagBox[
                StyleBox["min",
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}], "]"}], "]"}], 
        RowBox[{"Dt", "[", 
          RowBox[{"t", " ", 
            TagBox[
              StyleBox["min",
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}], "]"}]], "//", "Together"}]], "Input",
  CellLabel->"In[175]:=",
  CellTags->"Basic resolution of motion's problems"],

Cell[BoxData[
    FractionBox[
      RowBox[{\(\@\(3\/5\)\), " ", \(\[ExponentialE]\^\(\(3\ t\)/125\)\), 
        " ", \((\(-125\) + 6\ t)\), " ", 
        TagBox[
          StyleBox[\("m"\/"s"\^2\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}], \(10000\ t\^\(3/2\)\)]], "Output",
  CellLabel->"Out[175]=",
  CellTags->"Basic resolution of motion's problems"]
}, Closed]],

Cell["or ", "Text",
  CellTags->"Basic resolution of motion's problems"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{
        FractionBox[
          RowBox[{"Dt", "[", 
            RowBox[{"v", "[", 
              RowBox[{"t", " ", 
                TagBox[
                  StyleBox["min",
                    ShowStringCharacters->False,
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit]}], "]"}], "]"}], 
          RowBox[{"Dt", "[", 
            RowBox[{"t", " ", 
              TagBox[
                StyleBox["min",
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}], "]"}]], "\[Equal]", 
        RowBox[{"(", 
          RowBox[{\(Dt[v[t]]\/Dt[t]\), "/.", "\[InvisibleSpace]", 
            RowBox[{"t", "\[RuleDelayed]", 
              RowBox[{"t", " ", 
                TagBox[
                  StyleBox["min",
                    ShowStringCharacters->False,
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit]}]}]}], ")"}], "\[Equal]", 
        RowBox[{"(", 
          RowBox[{\(Dt[v[t], t]\), "/.", "\[InvisibleSpace]", 
            RowBox[{"t", "\[RuleDelayed]", 
              RowBox[{"t", " ", 
                TagBox[
                  StyleBox["min",
                    ShowStringCharacters->False,
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit]}]}]}], ")"}]}], "//", "Simplify"}]], "Input",
  CellLabel->"In[176]:=",
  CellTags->"Basic resolution of motion's problems"],

Cell[BoxData[
    \(True\)], "Output",
  CellLabel->"Out[176]=",
  CellTags->"Basic resolution of motion's problems"]
}, Closed]],

Cell[TextData[{
  "but not (",
  Cell[BoxData[
      InterpretationBox[
        StyleBox[\("m"\/"s"\),
          FontSlant->"Plain",
          FontColor->GrayLevel[0.500008]],
        Unit[ 
          Times[ "m", 
            Power[ "s", -1]]]]]],
  " is a bad unit for acceleration!)"
}], "Text",
  CellTags->"Basic resolution of motion's problems"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      FractionBox[
        RowBox[{"Dt", "[", 
          RowBox[{"v", "[", 
            RowBox[{"t", " ", 
              TagBox[
                StyleBox["min",
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}], "]"}], "]"}], \(Dt[t]\)], "//", 
      "Together"}]], "Input",
  CellLabel->"In[177]:=",
  CellTags->"Basic resolution of motion's problems"],

Cell[BoxData[
    FractionBox[
      RowBox[{
      "3", " ", \(\@\(3\/5\)\), " ", \(\[ExponentialE]\^\(\(3\ t\)/125\)\), 
        " ", \((\(-125\) + 6\ t)\), " ", 
        TagBox[
          StyleBox[\("m"\/"s"\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}], \(500\ t\^\(3/2\)\)]], "Output",
  CellLabel->"Out[177]=",
  CellTags->"Basic resolution of motion's problems"]
}, Closed]],

Cell["To end the example", "Text",
  CellTags->"Basic resolution of motion's problems"],

Cell[BoxData[
    \(\(ClearAll[x, v, a, F, \[Alpha], \[Beta], m, Subscript];\)\)], "Input",
  CellLabel->"In[178]:=",
  CellTags->"Basic resolution of motion's problems"]
}, Closed]],

Cell[CellGroupData[{

Cell["Basic resolution of plane motion's problems", "Subsubsection",
  CellTags->"Basic resolution of plane motion's problems"],

Cell[TextData[{
  "In this example, we work with ",
  Cell[BoxData[
      \(SetDelayed\)]],
  " and lists. (We recommend to work with ",
  Cell[BoxData[
      \(Set\)]],
  " when works withs units). The problem statement is the following: Given \
the position of a particle, find the velocity and the acceleration, and plot \
thems."
}], "Text",
  CellTags->"Basic resolution of plane motion's problems"],

Cell[BoxData[
    \(\(ClearAll[x, y, v, a, t, 
        tt, \[Alpha], \[Beta], \[Gamma]];\)\)], "Input",
  CellLabel->"In[179]:=",
  CellTags->"Basic resolution of plane motion's problems"],

Cell[BoxData[
    \(\({x[t_], 
          y[t_]} := {\(\[Alpha]\ t\^2\)\/\(t\^2 + \[Gamma]\), \(\[Beta]\ t\^3\
\)\/\(t\^2 + \[Gamma]\)};\)\)], "Input",
  CellLabel->"In[180]:=",
  CellTags->"Basic resolution of plane motion's problems"],

Cell[BoxData[
    RowBox[{
      RowBox[{\({\[Alpha], \[Beta], \[Gamma]}\), "=", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{"0.5", " ", 
              TagBox[
                StyleBox["m",
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}], ",", 
            RowBox[{"3", " ", 
              TagBox[
                StyleBox[\(m\/s\),
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}], ",", 
            RowBox[{"2", " ", 
              TagBox[
                StyleBox[\(s\^2\),
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}]}], "}"}]}], ";"}]], "Input",
  CellLabel->"In[181]:=",
  CellTags->"Basic resolution of plane motion's problems"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"{", 
        RowBox[{
          RowBox[{"x", "[", 
            RowBox[{"t", " ", 
              TagBox[
                StyleBox["s",
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}], "]"}], ",", 
          RowBox[{"y", "[", 
            RowBox[{"t", " ", 
              TagBox[
                StyleBox["s",
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}], "]"}]}], "}"}], "//", "Together"}]], "Input",
  CellLabel->"In[182]:=",
  CellTags->"Basic resolution of plane motion's problems"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        FractionBox[
          RowBox[{"0.5`", " ", \(t\^2\), " ", 
            TagBox[
              StyleBox["\<\"m\"\>",
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}], \(\(\(2.`\)\(\[InvisibleSpace]\)\) + t\^2\)], ",", 
        FractionBox[
          RowBox[{"3", " ", \(t\^3\), " ", 
            TagBox[
              StyleBox["\<\"m\"\>",
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}], \(2 + t\^2\)]}], "}"}]], "Output",
  CellLabel->"Out[182]=",
  CellTags->"Basic resolution of plane motion's problems"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"ParametricPlot", "[", 
        RowBox[{
          RowBox[{"Evaluate", "@", 
            RowBox[{"Normal", "@", 
              RowBox[{"{", 
                RowBox[{
                  RowBox[{"x", "[", 
                    RowBox[{"t", " ", 
                      TagBox[
                        StyleBox["s",
                          ShowStringCharacters->False,
                          FontSlant->"Plain",
                          FontColor->GrayLevel[0.500008]],
                        Unit]}], "]"}], ",", 
                  RowBox[{"y", "[", 
                    RowBox[{"t", " ", 
                      TagBox[
                        StyleBox["s",
                          ShowStringCharacters->False,
                          FontSlant->"Plain",
                          FontColor->GrayLevel[0.500008]],
                        Unit]}], "]"}]}], "}"}]}]}], ",", \({t, 0, 15}\)}], 
        "]"}], ";"}]], "Input",
  CellLabel->"In[183]:=",
  CellTags->"Basic resolution of plane motion's problems"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 1.92169 0.0147151 0.0131964 [
[.21598 .00222 -9 -9 ]
[.21598 .00222 9 0 ]
[.40815 .00222 -9 -9 ]
[.40815 .00222 9 0 ]
[.60032 .00222 -9 -9 ]
[.60032 .00222 9 0 ]
[.79249 .00222 -9 -9 ]
[.79249 .00222 9 0 ]
[.98466 .00222 -9 -9 ]
[.98466 .00222 9 0 ]
[.01131 .14668 -12 -4.5 ]
[.01131 .14668 0 4.5 ]
[.01131 .27864 -12 -4.5 ]
[.01131 .27864 0 4.5 ]
[.01131 .41061 -12 -4.5 ]
[.01131 .41061 0 4.5 ]
[.01131 .54257 -12 -4.5 ]
[.01131 .54257 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.21598 .01472 m
.21598 .02097 L
s
[(0.1)] .21598 .00222 0 1 Mshowa
.40815 .01472 m
.40815 .02097 L
s
[(0.2)] .40815 .00222 0 1 Mshowa
.60032 .01472 m
.60032 .02097 L
s
[(0.3)] .60032 .00222 0 1 Mshowa
.79249 .01472 m
.79249 .02097 L
s
[(0.4)] .79249 .00222 0 1 Mshowa
.98466 .01472 m
.98466 .02097 L
s
[(0.5)] .98466 .00222 0 1 Mshowa
.125 Mabswid
.06224 .01472 m
.06224 .01847 L
s
.10068 .01472 m
.10068 .01847 L
s
.13911 .01472 m
.13911 .01847 L
s
.17754 .01472 m
.17754 .01847 L
s
.25441 .01472 m
.25441 .01847 L
s
.29285 .01472 m
.29285 .01847 L
s
.33128 .01472 m
.33128 .01847 L
s
.36971 .01472 m
.36971 .01847 L
s
.44658 .01472 m
.44658 .01847 L
s
.48502 .01472 m
.48502 .01847 L
s
.52345 .01472 m
.52345 .01847 L
s
.56188 .01472 m
.56188 .01847 L
s
.63875 .01472 m
.63875 .01847 L
s
.67719 .01472 m
.67719 .01847 L
s
.71562 .01472 m
.71562 .01847 L
s
.75405 .01472 m
.75405 .01847 L
s
.83092 .01472 m
.83092 .01847 L
s
.86935 .01472 m
.86935 .01847 L
s
.90779 .01472 m
.90779 .01847 L
s
.94622 .01472 m
.94622 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .14668 m
.03006 .14668 L
s
[(10)] .01131 .14668 1 0 Mshowa
.02381 .27864 m
.03006 .27864 L
s
[(20)] .01131 .27864 1 0 Mshowa
.02381 .41061 m
.03006 .41061 L
s
[(30)] .01131 .41061 1 0 Mshowa
.02381 .54257 m
.03006 .54257 L
s
[(40)] .01131 .54257 1 0 Mshowa
.125 Mabswid
.02381 .04111 m
.02756 .04111 L
s
.02381 .0675 m
.02756 .0675 L
s
.02381 .09389 m
.02756 .09389 L
s
.02381 .12029 m
.02756 .12029 L
s
.02381 .17307 m
.02756 .17307 L
s
.02381 .19946 m
.02756 .19946 L
s
.02381 .22586 m
.02756 .22586 L
s
.02381 .25225 m
.02756 .25225 L
s
.02381 .30503 m
.02756 .30503 L
s
.02381 .33143 m
.02756 .33143 L
s
.02381 .35782 m
.02756 .35782 L
s
.02381 .38421 m
.02756 .38421 L
s
.02381 .437 m
.02756 .437 L
s
.02381 .46339 m
.02756 .46339 L
s
.02381 .48978 m
.02756 .48978 L
s
.02381 .51618 m
.02756 .51618 L
s
.02381 .56896 m
.02756 .56896 L
s
.02381 .59535 m
.02756 .59535 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.02381 .01472 m
.02397 .01472 L
.02441 .01472 L
.02525 .01472 L
.02638 .01472 L
.02917 .01474 L
.03332 .01477 L
.0392 .01483 L
.04689 .01493 L
.06419 .01521 L
.08629 .01568 L
.11031 .0163 L
.17391 .01848 L
.24592 .02181 L
.31311 .02578 L
.38868 .03135 L
.45356 .03724 L
.5546 .04908 L
.64154 .06301 L
.70743 .07727 L
.75367 .09031 L
.79124 .10379 L
.82304 .11828 L
.84662 .13177 L
.86726 .14645 L
.89515 .17313 L
.9055 .18618 L
.91476 .20007 L
.92895 .22732 L
.93895 .25333 L
.94626 .27818 L
.95229 .30447 L
.95685 .32967 L
.9604 .35381 L
.96348 .37944 L
.96593 .40405 L
.96809 .43015 L
.96984 .45525 L
.97128 .47935 L
.97259 .50496 L
.97368 .52959 L
.97468 .55575 L
.97553 .58092 L
.97619 .60332 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[183]:=",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40O003h00Oogoo8Goo000mOol2
0004Ool20003Ool5000TOol20004Ool20003Ool4000UOol20004Ool20004Ool2000WOol20004Ool2
0005Ool3000TOol20004Ool20004Ool20004Ool003aoo`04001oogoo000:Ool00`00Oomoo`0SOol0
1000Oomoo`0027oo00<007ooOol09Goo00@007ooOol000Qoo`04001oogoo000UOol01000Oomoo`00
2goo00<007ooOol08Woo00@007ooOol000Qoo`04001oogoo0003Ool003aoo`04001oogoo000:Ool0
0`00Oomoo`0SOol01000Oomoo`002Goo00<007ooOol097oo00@007ooOol000Yoo`03001oogoo02Ao
o`04001oogoo0008Ool5000SOol01000Oomoo`002goo00<007ooOol00Goo000lOol01000Oomoo`00
2Woo00<007ooOol08goo00@007ooOol000Yoo`03001oogoo02=oo`04001oogoo000;Ool00`00Oomo
o`0SOol01000Oomoo`0027oo00@007ooOol002Aoo`04001oogoo0009Ool20004Ool003aoo`04001o
ogoo000:Ool00`00Oomoo`0SOol01000Oomoo`0027oo00@007ooOol002Aoo`04001oogoo0008Ool0
1000Oomoo`009Goo00@007ooOol000Uoo`03001oo`0002Aoo`04001oogoo0009Ool00`00Oomoo`03
Ool003eoo`8000Yoo`8002Ioo`8000Yoo`8002Ioo`8000Yoo`8002Moo`8000]oo`8002Eoo`8000Yo
o`<000=oo`00ogoo8Goo000?Ool00`00Oomoo`3oOol?Ool000moo`03001oogoo0?moo`moo`003goo
00<007ooOol0ogoo3goo000?Ool00`00Oomoo`3oOol?Ool000Uoool0018000Ioo`003goo00<007oo
Ool027oo00<007ooOol01goo00<007ooOol027oo4`000Woo00<007ooOol01goo00<007ooOol027oo
00<007ooOol01goo00<007ooOol027oo00<007ooOol01goo00<007ooOol01goo00<007ooOol027oo
00<007ooOol01goo00<007ooOol027oo00<007ooOol01goo00<007ooOol027oo00<007ooOol01goo
00<007ooOol027oo00<007ooOol01goo00<007ooOol027oo00<007ooOol01goo00<007ooOol027oo
00<007ooOol01goo00<007ooOol027oo00<007ooOol01goo00<007ooOol027oo000?Ool00`00Oomo
o`0`OolC000SOol00`00Oomoo`0aOol00`00Oomoo`0bOol00`00Oomoo`0aOol00`00Oomoo`08Ool0
00moo`03001oogoo04=oo`l00;aoo`003goo00<007ooOol0DWoo2P00/Woo000?Ool00`00Oomoo`1L
Ool>002TOol000moo`03001oogoo06Yoo`d009Moo`003goo0P00N7oo2@00SWoo000?Ool00`00Oomo
o`20Ool:0024Ool000moo`03001oogoo08Yoo`L007eoo`003goo00<007ooOol0TGoo1P00Mgoo000?
Ool00`00Oomoo`2GOol6001aOol000moo`03001oogoo09eoo`H006]oo`003goo00<007ooOol0Xgoo
1P00IGoo000?Ool2002ZOol4001QOol000moo`03001oogoo0:eoo`D005aoo`003goo00<007ooOol0
/Woo1000F7oo000?Ool00`00Oomoo`2fOol4001DOol000moo`03001oogoo0;Yoo`<0055oo`003goo
00<007ooOol0_Goo0`00CWoo000?Ool00`00Oomoo`30Ool3001;Ool000moo`03001oogoo0<=oo`<0
04Qoo`003goo0P00agoo0`00AGoo000?Ool00`00Oomoo`39Ool40011Ool000moo`03001oogoo0<eo
o`<003ioo`003goo00<007ooOol0d7oo0P00?7oo000?Ool00`00Oomoo`3BOol2000jOol000moo`03
001oogoo0=Aoo`8003Qoo`003goo00<007ooOol0eWoo0P00=Woo000?Ool2003IOol2000dOol000mo
o`03001oogoo0=Yoo`80039oo`003goo00<007ooOol0g7oo0P00<7oo000?Ool00`00Oomoo`3NOol0
0`00Oomoo`0]Ool000moo`03001oogoo0=moo`03001oogoo02aoo`0000=oo`0000000`000Woo0P00
1Goo00<007ooOol0h7oo0P00;7oo0003Ool01@00Oomoogoo00000Woo00<007ooOol00Woo00<007oo
Ool0hWoo00<007ooOol0:Goo0003Ool01@00Oomoogoo00000Woo00<007ooOol00Woo0`00hgoo00<0
07ooOol0:7oo0003Ool01@00Oomoogoo00000Woo00<007ooOol00Woo00<007ooOol0i7oo00<007oo
Ool09goo0003Ool01@00Oomoogoo00000Woo00<007ooOol00Woo00<007ooOol0iGoo00<007ooOol0
9Woo0002Ool20004Ool20005Ool00`00Oomoo`3VOol00`00Oomoo`0UOol000moo`03001oogoo0>Mo
o`8002Eoo`003goo00<007ooOol0jGoo00<007ooOol08Woo000?Ool00`00Oomoo`3ZOol00`00Oomo
o`0QOol000moo`800>aoo`03001oogoo021oo`003goo00<007ooOol0k7oo00<007ooOol07goo000?
Ool00`00Oomoo`3/Ool00`00Oomoo`0OOol000moo`03001oogoo0>eoo`03001oogoo01ioo`003goo
00<007ooOol0kWoo00<007ooOol07Goo000?Ool00`00Oomoo`3^Ool00`00Oomoo`0MOol000moo`03
001oogoo0>moo`03001oogoo01aoo`003goo0P00l7oo00<007ooOol077oo000?Ool00`00Oomoo`3`
Ool00`00Oomoo`0KOol000moo`03001oogoo0?5oo`03001oogoo01Yoo`003goo00<007ooOol0lGoo
00<007ooOol06Woo000?Ool00`00Oomoo`3bOol00`00Oomoo`0IOol000moo`03001oogoo0?9oo`03
001oogoo01Uoo`003goo00<007ooOol0lgoo00<007ooOol067oo000?Ool00`00Oomoo`3cOol00`00
Oomoo`0HOol000moo`800?Eoo`03001oogoo01Moo`003goo00<007ooOol0m7oo00<007ooOol05goo
000?Ool00`00Oomoo`3eOol00`00Oomoo`0FOol000moo`03001oogoo0?Eoo`03001oogoo01Ioo`00
3goo00<007ooOol0mWoo00<007ooOol05Goo000?Ool00`00Oomoo`3fOol00`00Oomoo`0EOol000mo
o`03001oogoo0?Moo`03001oogoo01Aoo`003goo0P00n7oo00<007ooOol057oo000?Ool00`00Oomo
o`3gOol00`00Oomoo`0DOol000moo`03001oogoo0?Qoo`03001oogoo01=oo`003goo00<007ooOol0
n7oo00<007ooOol04goo000?Ool00`00Oomoo`3hOol00`00Oomoo`0COol00003Ool00000008000=o
o`8000Eoo`03001oogoo0?Qoo`03001oogoo01=oo`0000=oo`00Ool017oo00@007ooOol000Aoo`03
001oogoo0?Uoo`03001oogoo019oo`000Woo00<007ooOol00Woo00@007ooOol000Aoo`<00?Uoo`03
001oogoo019oo`000goo00D007ooOomoo`00009oo`03001oogoo009oo`03001oogoo0?Uoo`03001o
ogoo019oo`0000Eoo`00Oomoo`00009oo`04001oogoo0004Ool00`00Oomoo`3iOol00`00Oomoo`0B
Ool0009oo`8000Aoo`8000Eoo`03001oogoo0?Uoo`03001oogoo019oo`003goo00<007ooOol0nWoo
00<007ooOol04Goo000?Ool00`00Oomoo`3jOol00`00Oomoo`0AOol000moo`03001oogoo0?Yoo`03
001oogoo015oo`003goo0P00ngoo00<007ooOol04Goo000?Ool00`00Oomoo`3jOol00`00Oomoo`0A
Ool000moo`03001oogoo0?]oo`03001oogoo011oo`003goo00<007ooOol0ngoo00<007ooOol047oo
000?Ool00`00Oomoo`3kOol00`00Oomoo`0@Ool000moo`03001oogoo0?]oo`03001oogoo011oo`00
3goo00<007ooOol0o7oo00<007ooOol03goo000?Ool2003mOol00`00Oomoo`0?Ool000moo`03001o
ogoo0?aoo`03001oogoo00moo`003goo00<007ooOol0o7oo00<007ooOol03goo000?Ool00`00Oomo
o`3lOol00`00Oomoo`0?Ool000moo`03001oogoo0?eoo`03001oogoo00ioo`003goo00<007ooOol0
oGoo00<007ooOol03Woo000?Ool00`00Oomoo`3mOol00`00Oomoo`0>Ool000moo`03001oogoo0?eo
o`03001oogoo00ioo`003goo0P00oWoo00<007ooOol03Woo000?Ool00`00Oomoo`3mOol00`00Oomo
o`0>Ool000moo`03001oogoo0?eoo`03001oogoo00ioo`003goo00<007ooOol0oGoo00<007ooOol0
3Woo000?Ool00`00Oomoo`3mOol00`00Oomoo`0>Ool000moo`03001oogoo0?eoo`03001oogoo00io
o`003goo00<007ooOol0oGoo00<007ooOol03Woo000?Ool2003nOol00`00Oomoo`0>Ool000moo`03
001oogoo0?eoo`03001oogoo00ioo`003goo00<007ooOol0oWoo00<007ooOol03Goo000?Ool00`00
Oomoo`3nOol00`00Oomoo`0=Ool000moo`03001oogoo0?ioo`03001oogoo00eoo`000Woo0P0017oo
0P001Goo00<007ooOol0oWoo00<007ooOol03Goo00001Goo001oogoo00000Woo00@007ooOol000Ao
o`03001oogoo0?ioo`03001oogoo00eoo`000goo00D007ooOomoo`00009oo`03001oogoo009oo`<0
0?ioo`03001oogoo00eoo`0017oo00@007ooOol0009oo`03001oogoo009oo`03001oogoo0?ioo`03
001oogoo00eoo`0000Eoo`00Oomoo`00009oo`04001oogoo0004Ool00`00Oomoo`3oOol00`00Oomo
o`0<Ool0009oo`8000Aoo`8000Eoo`03001oogoo0?moo`03001oogoo00aoo`003goo00<007ooOol0
ogoo00<007ooOol037oo000?Ool00`00Oomoo`3oOol00`00Oomoo`0<Ool000moo`03001oogoo0?mo
o`03001oogoo00aoo`003goo0P00ogoo0Goo00<007ooOol037oo000?Ool00`00Oomoo`3oOol00`00
Oomoo`0<Ool000moo`03001oogoo0?moo`03001oogoo00aoo`003goo00<007ooOol0ogoo00<007oo
Ool037oo000?Ool00`00Oomoo`3oOol00`00Oomoo`0<Ool000moo`03001oogoo0?moo`03001oogoo
00aoo`003goo00<007ooOol0ogoo00<007ooOol037oo000?Ool2003oOol1Ool00`00Oomoo`0<Ool0
00moo`03001oogoo0?moo`03001oogoo00aoo`003goo00<007ooOol0ogoo0Goo00<007ooOol02goo
000?Ool00`00Oomoo`3oOol1Ool00`00Oomoo`0;Ool000moo`03001oogoo0?moo`5oo`03001oogoo
00]oo`003goo00<007ooOol0ogoo0Goo00<007ooOol02goo000?Ool00`00Oomoo`3oOol1Ool00`00
Oomoo`0;Ool000moo`03001oogoo0?moo`5oo`03001oogoo00]oo`003goo0P00ogoo0Woo00<007oo
Ool02goo000?Ool00`00Oomoo`3oOol1Ool00`00Oomoo`0;Ool000moo`03001oogoo0?moo`5oo`03
001oogoo00]oo`003goo00<007ooOol0ogoo0Goo00<007ooOol02goo000?Ool00`00Oomoo`3oOol1
Ool00`00Oomoo`0;Ool000moo`03001oogoo0?moo`5oo`03001oogoo00]oo`003goo00<007ooOol0
ogoo0Goo00<007ooOol02goo000?Ool2003oOol2Ool00`00Oomoo`0;Ool000moo`03001oogoo0?mo
o`5oo`03001oogoo00]oo`003goo00<007ooOol0ogoo0Goo00<007ooOol02goo000?Ool00`00Oomo
o`3oOol1Ool00`00Oomoo`0;Ool000moo`03001oogoo0?moo`5oo`03001oogoo00]oo`000goo0`00
0Woo0P001Goo00<007ooOol0ogoo0Goo00<007ooOol02goo0004Ool01000Oomoo`000Woo00<007oo
Ool00Woo00<007ooOol0ogoo0Goo00<007ooOol02goo00000goo0000000300001Goo001oogoo0000
17oo0`00ogoo0Goo00<007ooOol02goo00001Goo001oogoo00000Woo00@007ooOol000Aoo`03001o
ogoo0?moo`9oo`03001oogoo00Yoo`000Woo00<007oo00000Woo00@007ooOol000Aoo`03001oogoo
0?moo`9oo`03001oogoo00Yoo`000goo0P000goo0P001Goo00<007ooOol0ogoo0Woo00<007ooOol0
2Woo000?Ool00`00Oomoo`3oOol2Ool00`00Oomoo`0:Ool000moo`03001oogoo0?moo`9oo`03001o
ogoo00Yoo`003goo00<007ooOol0ogoo0Woo00<007ooOol02Woo000?Ool2003oOol3Ool00`00Oomo
o`0:Ool000moo`03001oogoo0?moo`9oo`03001oogoo00Yoo`003goo00<007ooOol0ogoo0Woo00<0
07ooOol02Woo000?Ool00`00Oomoo`3oOol2Ool00`00Oomoo`0:Ool000moo`03001oogoo0?moo`9o
o`03001oogoo00Yoo`003goo00<007ooOol0ogoo0Woo00<007ooOol02Woo000?Ool00`00Oomoo`3o
Ool2Ool00`00Oomoo`0:Ool000moo`800?moo`=oo`03001oogoo00Yoo`003goo00<007ooOol0ogoo
0Woo00<007ooOol02Woo000?Ool00`00Oomoo`3oOol2Ool00`00Oomoo`0:Ool000moo`03001oogoo
0?moo`moo`003goo00<007ooOol0ogoo3goo000?Ool00`00Oomoo`3oOol?Ool000moo`03001oogoo
0?moo`moo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-0.0299373, -3.44796, \
0.00190818, 0.277874}},
  CellTags->"Basic resolution of plane motion's problems"]
}, Closed]],

Cell[BoxData[
    \(v[t_] := \[PartialD]\_tt{x[tt], y[tt]} /. tt \[Rule] t\)], "Input",
  CellLabel->"In[184]:=",
  CellTags->"Basic resolution of plane motion's problems"],

Cell[CellGroupData[{

Cell[BoxData[
    \(v[t] // Together\)], "Input",
  CellLabel->"In[185]:=",
  CellTags->"Basic resolution of plane motion's problems"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        FractionBox[
          RowBox[{"2.`", " ", "t", " ", 
            RowBox[{"(", 
              TagBox[
                StyleBox[\("m"\ "s"\^2\),
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit], ")"}]}], 
          SuperscriptBox[
            RowBox[{"(", 
              RowBox[{\(t\^2\), "+", 
                RowBox[{"2.`", " ", 
                  TagBox[
                    StyleBox[\("s"\^2\),
                      ShowStringCharacters->False,
                      FontSlant->"Plain",
                      FontColor->GrayLevel[0.500008]],
                    Unit]}]}], ")"}], "2"]], ",", 
        FractionBox[
          RowBox[{"3", " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{\(t\^4\), " ", 
                  TagBox[
                    StyleBox[\("m"\/"s"\),
                      ShowStringCharacters->False,
                      FontSlant->"Plain",
                      FontColor->GrayLevel[0.500008]],
                    Unit]}], "+", 
                RowBox[{"6", " ", \(t\^2\), " ", 
                  RowBox[{"(", 
                    TagBox[
                      StyleBox[\("m"\ "s"\),
                        ShowStringCharacters->False,
                        FontSlant->"Plain",
                        FontColor->GrayLevel[0.500008]],
                      Unit], ")"}]}]}], ")"}]}], 
          SuperscriptBox[
            RowBox[{"(", 
              RowBox[{\(t\^2\), "+", 
                RowBox[{"2", " ", 
                  TagBox[
                    StyleBox[\("s"\^2\),
                      ShowStringCharacters->False,
                      FontSlant->"Plain",
                      FontColor->GrayLevel[0.500008]],
                    Unit]}]}], ")"}], "2"]]}], "}"}]], "Output",
  CellLabel->"Out[185]=",
  CellTags->"Basic resolution of plane motion's problems"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"v", "[", 
        RowBox[{"t", " ", 
          InterpretationBox[
            StyleBox["s",
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit[ s]]}], "]"}], "//", "UnitSimplify"}]], "Input",
  CellLabel->"In[186]:=",
  CellTags->"Basic resolution of plane motion's problems"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        FractionBox[
          RowBox[{"2.`", " ", "t", " ", 
            TagBox[
              StyleBox[\("m"\/"s"\),
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}], \(\((\(\(2.`\)\(\[InvisibleSpace]\)\) + t\^2)\)\^2\)], 
        ",", 
        FractionBox[
          RowBox[{"3", " ", \(t\^2\), " ", \((6 + t\^2)\), " ", 
            TagBox[
              StyleBox[\("m"\/"s"\),
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}], \(\((2 + t\^2)\)\^2\)]}], "}"}]], "Output",
  CellLabel->"Out[186]=",
  CellTags->"Basic resolution of plane motion's problems"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"ParametricPlot", "[", 
        RowBox[{
          RowBox[{"Evaluate", "@", 
            RowBox[{"Normal", "@", 
              RowBox[{"v", "[", 
                RowBox[{"t", " ", 
                  InterpretationBox[
                    StyleBox["s",
                      FontSlant->"Plain",
                      FontColor->GrayLevel[0.500008]],
                    Unit[ s]]}], "]"}]}]}], ",", \({t, 0, 15}\)}], "]"}], 
      ";"}]], "Input",
  CellLabel->"In[187]:=",
  FormatType->TraditionalForm,
  CellTags->"Basic resolution of plane motion's problems"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 4.14737 0.0147151 0.174401 [
[.23118 .00222 -12 -9 ]
[.23118 .00222 12 0 ]
[.43855 .00222 -9 -9 ]
[.43855 .00222 9 0 ]
[.64591 .00222 -12 -9 ]
[.64591 .00222 12 0 ]
[.85328 .00222 -9 -9 ]
[.85328 .00222 9 0 ]
[.01131 .10192 -18 -4.5 ]
[.01131 .10192 0 4.5 ]
[.01131 .18912 -6 -4.5 ]
[.01131 .18912 0 4.5 ]
[.01131 .27632 -18 -4.5 ]
[.01131 .27632 0 4.5 ]
[.01131 .36352 -6 -4.5 ]
[.01131 .36352 0 4.5 ]
[.01131 .45072 -18 -4.5 ]
[.01131 .45072 0 4.5 ]
[.01131 .53792 -6 -4.5 ]
[.01131 .53792 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.23118 .01472 m
.23118 .02097 L
s
[(0.05)] .23118 .00222 0 1 Mshowa
.43855 .01472 m
.43855 .02097 L
s
[(0.1)] .43855 .00222 0 1 Mshowa
.64591 .01472 m
.64591 .02097 L
s
[(0.15)] .64591 .00222 0 1 Mshowa
.85328 .01472 m
.85328 .02097 L
s
[(0.2)] .85328 .00222 0 1 Mshowa
.125 Mabswid
.06528 .01472 m
.06528 .01847 L
s
.10676 .01472 m
.10676 .01847 L
s
.14823 .01472 m
.14823 .01847 L
s
.1897 .01472 m
.1897 .01847 L
s
.27265 .01472 m
.27265 .01847 L
s
.31413 .01472 m
.31413 .01847 L
s
.3556 .01472 m
.3556 .01847 L
s
.39707 .01472 m
.39707 .01847 L
s
.48002 .01472 m
.48002 .01847 L
s
.52149 .01472 m
.52149 .01847 L
s
.56297 .01472 m
.56297 .01847 L
s
.60444 .01472 m
.60444 .01847 L
s
.68739 .01472 m
.68739 .01847 L
s
.72886 .01472 m
.72886 .01847 L
s
.77034 .01472 m
.77034 .01847 L
s
.81181 .01472 m
.81181 .01847 L
s
.89476 .01472 m
.89476 .01847 L
s
.93623 .01472 m
.93623 .01847 L
s
.9777 .01472 m
.9777 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .10192 m
.03006 .10192 L
s
[(0.5)] .01131 .10192 1 0 Mshowa
.02381 .18912 m
.03006 .18912 L
s
[(1)] .01131 .18912 1 0 Mshowa
.02381 .27632 m
.03006 .27632 L
s
[(1.5)] .01131 .27632 1 0 Mshowa
.02381 .36352 m
.03006 .36352 L
s
[(2)] .01131 .36352 1 0 Mshowa
.02381 .45072 m
.03006 .45072 L
s
[(2.5)] .01131 .45072 1 0 Mshowa
.02381 .53792 m
.03006 .53792 L
s
[(3)] .01131 .53792 1 0 Mshowa
.125 Mabswid
.02381 .03216 m
.02756 .03216 L
s
.02381 .0496 m
.02756 .0496 L
s
.02381 .06704 m
.02756 .06704 L
s
.02381 .08448 m
.02756 .08448 L
s
.02381 .11936 m
.02756 .11936 L
s
.02381 .1368 m
.02756 .1368 L
s
.02381 .15424 m
.02756 .15424 L
s
.02381 .17168 m
.02756 .17168 L
s
.02381 .20656 m
.02756 .20656 L
s
.02381 .224 m
.02756 .224 L
s
.02381 .24144 m
.02756 .24144 L
s
.02381 .25888 m
.02756 .25888 L
s
.02381 .29376 m
.02756 .29376 L
s
.02381 .3112 m
.02756 .3112 L
s
.02381 .32864 m
.02756 .32864 L
s
.02381 .34608 m
.02756 .34608 L
s
.02381 .38096 m
.02756 .38096 L
s
.02381 .3984 m
.02756 .3984 L
s
.02381 .41584 m
.02756 .41584 L
s
.02381 .43328 m
.02756 .43328 L
s
.02381 .46816 m
.02756 .46816 L
s
.02381 .4856 m
.02756 .4856 L
s
.02381 .50304 m
.02756 .50304 L
s
.02381 .52048 m
.02756 .52048 L
s
.02381 .55536 m
.02756 .55536 L
s
.02381 .5728 m
.02756 .5728 L
s
.02381 .59024 m
.02756 .59024 L
s
.02381 .60768 m
.02756 .60768 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.02381 .01472 m
.06219 .01498 L
.09705 .0157 L
.13712 .01707 L
.17477 .0189 L
.24094 .02343 L
.3112 .03014 L
.38612 .03959 L
.46209 .05182 L
.58753 .07884 L
.69988 .11235 L
.78762 .14754 L
.86365 .18877 L
.89715 .21254 L
.92221 .23438 L
.94225 .25628 L
.95114 .2682 L
.95819 .27933 L
.96367 .28963 L
.96841 .30065 L
.97171 .31053 L
.97393 .3195 L
.97485 .32461 L
.97558 .33004 L
.97619 .33971 L
.97614 .34553 L
.97581 .35099 L
.97528 .35583 L
.97447 .36104 L
.97344 .36606 L
.97205 .37152 L
.96844 .38236 L
.9642 .39214 L
.95948 .40107 L
.94896 .41707 L
.93573 .433 L
.90751 .45914 L
.87222 .48397 L
.82978 .50741 L
.74673 .5415 L
.67154 .56374 L
.58986 .58136 L
.55565 .58706 L
.52004 .59203 L
.49051 .59545 L
.46065 .59827 L
.43117 .60044 L
.41865 .60118 L
.40545 .60185 L
.39286 .60236 L
Mistroke
.38158 .60273 L
.37115 .603 L
.36547 .60311 L
.36041 .60319 L
.3555 .60325 L
.35105 .60328 L
.34625 .60331 L
.34126 .60332 L
.33699 .60331 L
.33307 .60329 L
.32882 .60326 L
.32436 .60321 L
.3197 .60315 L
.31467 .60306 L
.30478 .60282 L
.29596 .60255 L
.28799 .60226 L
.27102 .60145 L
.25417 .60042 L
.22676 .59821 L
.20505 .59595 L
.17004 .59125 L
.1409 .58617 L
.10222 .57731 L
.07921 .57044 L
.06348 .56471 L
.05342 .5604 L
.04668 .55711 L
.04155 .55431 L
.03796 .55213 L
.03536 .55041 L
.03324 .5489 L
.03166 .54768 L
.03034 .54659 L
.02934 .5457 L
.02855 .54496 L
.02788 .54429 L
.02734 .54373 L
.02691 .54325 L
.02652 .54281 L
.02622 .54245 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[187]:=",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40O003h00Oogoo8Goo0013Ool2
0004Ool20004Ool20004Ool2000XOol20004Ool20003Ool5000UOol20004Ool20003Ool50002Ool2
000XOol20004Ool20003Ool4000QOol0049oo`04001oogoo0008Ool01000Oomoo`000Woo00@007oo
Ool002Ioo`04001oogoo000:Ool00`00Oomoo`0TOol01000Oomoo`002Woo00D007ooOomoo`00009o
o`03001oogoo02Aoo`04001oogoo0008Ool00`00Oomoo`0ROol0049oo`04001oogoo0008Ool01000
Oomoo`001Goo00<007ooOol097oo00@007ooOol000Yoo`03001oogoo02Aoo`04001oogoo000:Ool0
0`00Oomoo`04Ool00`00Oomoo`0TOol01000Oomoo`002Goo00<007ooOol08Goo0012Ool01000Oomo
o`0027oo00@007ooOol000=oo`8002Moo`04001oogoo000:Ool00`00Oomoo`0TOol01000Oomoo`00
2Woo00<007ooOol00Woo0P009goo00@007ooOol000Yoo`03001oogoo021oo`00@Woo00@007ooOol0
00Qoo`04001oogoo0003Ool00`00Oomoo`0VOol01000Oomoo`002Woo00<007ooOol097oo00@007oo
Ool000Yoo`03001oogoo009oo`03001oogoo02Ioo`04001oogoo0008Ool01000Oomoo`008Goo0013
Ool2000:Ool20004Ool3000WOol2000:Ool2000WOol2000:Ool20004Ool3000WOol2000:Ool2000R
Ool00?moob5oo`005Goo00<007ooOol0ogoo2Goo000EOol00`00Oomoo`3oOol9Ool001Eoo`03001o
ogoo0?moo`Uoo`005Goo00<007ooOol0ogoo2Goo000>Oooo000C000001Eoo`03001oogoo00Qoo`03
001oogoo00Qoo`04001oogooOolD000:Ool00`00Oomoo`09Ool00`00Oomoo`08Ool00`00Oomoo`08
Ool00`00Oomoo`08Ool00`00Oomoo`09Ool00`00Oomoo`08Ool00`00Oomoo`08Ool00`00Oomoo`09
Ool00`00Oomoo`08Ool00`00Oomoo`08Ool00`00Oomoo`08Ool00`00Oomoo`09Ool00`00Oomoo`08
Ool00`00Oomoo`08Ool00`00Oomoo`09Ool00`00Oomoo`08Ool00`00Oomoo`08Ool00`00Oomoo`08
Ool00`00Oomoo`05Ool001Eoo`03001oogoo02]oo`T00003Ool007oo03Moo`03001oogoo03Eoo`03
001oogoo03Ioo`03001oogoo02Ioo`005Goo00<007ooOol0=7oo3P00aWoo000EOol00`00Oomoo`12
Ool=002iOol001Eoo`80051oo`H00;=oo`005Goo00<007ooOol0EGoo1`00[7oo000EOol00`00Oomo
o`1LOol7002UOol001Eoo`03001oogoo06=oo`L009ioo`005Goo00<007ooOol0JWoo1`00Ugoo000E
Ool2001bOol6002AOol001Eoo`03001oogoo07Moo`@008eoo`005Goo00<007ooOol0Ngoo1000RGoo
000EOol00`00Oomoo`1oOol40025Ool001Eoo`8008Aoo`D0081oo`005Goo00<007ooOol0R7oo1000
O7oo000EOol00`00Oomoo`2<Ool4001hOol001Eoo`03001oogoo091oo`@007Aoo`005Goo00<007oo
Ool0U7oo1000L7oo000EOol2002IOol4001/Ool001Eoo`03001oogoo09aoo`<006Uoo`005Goo00<0
07ooOol0Wgoo1000IGoo0002Ool20004Ool20004Ool20005Ool00`00Oomoo`2SOol3001ROol00005
Ool007ooOol00008Ool01000Oomoo`0017oo00<007ooOol0YWoo0`00Ggoo00001Goo001oogoo0000
2goo00<007ooOol00Woo0`00ZGoo1000Fgoo00001Goo001oogoo00002Goo0P001Goo00<007ooOol0
[Goo0`00F7oo00001Goo001oogoo00002Goo00<007ooOol017oo00<007ooOol0/7oo1000E7oo0002
Ool2000:Ool30004Ool00`00Oomoo`2dOol3001AOol001Eoo`03001oogoo0;Moo`8004moo`005Goo
0P00^Woo0`00C7oo000EOol00`00Oomoo`2lOol30019Ool001Eoo`03001oogoo0;moo`8004Moo`00
5Goo00<007ooOol0`Goo0`00A7oo000EOol20035Ool30011Ool001Eoo`03001oogoo0<Moo`8003mo
o`005Goo00<007ooOol0bGoo0`00?7oo000EOol00`00Oomoo`3<Ool2000jOol001Eoo`03001oogoo
0<ioo`8003Qoo`005Goo0P00dGoo0P00=Woo000EOol00`00Oomoo`3BOol00`00Oomoo`0cOol001Eo
o`03001oogoo0==oo`8003=oo`005Goo00<007ooOol0eGoo0P00<Goo000EOol00`00Oomoo`3GOol0
0`00Oomoo`0^Ool001Eoo`800=Uoo`8002ioo`005Goo00<007ooOol0fWoo0P00;7oo000EOol00`00
Oomoo`3LOol00`00Oomoo`0YOol000eoo`D000=oo`03001oogoo0=eoo`8002Uoo`003goo00<007oo
Ool00goo00<007ooOol0ggoo0P009goo000?Ool00`00Oomoo`03Ool3003QOol00`00Oomoo`0TOol0
00moo`03001oogoo00=oo`03001oogoo0>9oo`8002Aoo`003goo00<007ooOol00goo00<007ooOol0
i7oo0P008Woo000>Ool20005Ool00`00Oomoo`3VOol00`00Oomoo`0OOol001Eoo`800>Qoo`8001mo
o`005Goo00<007ooOol0jGoo0P007Goo000EOol00`00Oomoo`3[Ool00`00Oomoo`0JOol001Eoo`03
001oogoo0>aoo`03001oogoo01Uoo`005Goo00<007ooOol0kGoo00<007ooOol067oo000EOol2003_
Ool00`00Oomoo`0GOol001Eoo`03001oogoo0>moo`03001oogoo01Ioo`005Goo00<007ooOol0l7oo
00<007ooOol05Goo000EOol00`00Oomoo`3aOol00`00Oomoo`0DOol001Eoo`03001oogoo0?9oo`03
001oogoo01=oo`005Goo0P00m7oo00<007ooOol04Woo000EOol00`00Oomoo`3dOol00`00Oomoo`0A
Ool001Eoo`03001oogoo0?Eoo`03001oogoo011oo`005Goo00<007ooOol0mWoo00<007ooOol03goo
000EOol00`00Oomoo`3gOol00`00Oomoo`0>Ool001Eoo`800?Uoo`03001oogoo00eoo`005Goo00<0
07ooOol0n7oo00<007ooOol03Goo00000goo000000030002Ool20004Ool20005Ool00`00Oomoo`3i
Ool00`00Oomoo`0<Ool000=oo`03001oogoo00Moo`04001oogoo0004Ool00`00Oomoo`3jOol00`00
Oomoo`0;Ool000=oo`03001oogoo00Yoo`03001oogoo009oo`<00?Yoo`03001oogoo00]oo`000goo
00<007ooOol027oo0P001Goo00<007ooOol0ngoo00<007ooOol02Woo0003Ool00`00Oomoo`08Ool0
0`00Oomoo`04Ool00`00Oomoo`3lOol00`00Oomoo`09Ool0009oo`8000Yoo`<000Aoo`03001oogoo
0?aoo`03001oogoo00Uoo`005Goo00<007ooOol0oGoo00<007ooOol027oo000EOol2003nOol00`00
Oomoo`08Ool001Eoo`03001oogoo0?ioo`03001oogoo00Moo`005Goo00<007ooOol0oWoo00<007oo
Ool01goo000EOol00`00Oomoo`3nOol00`00Oomoo`07Ool001Eoo`03001oogoo0?moo`03001oogoo
00Ioo`005Goo0P00ogoo0Goo00<007ooOol01Woo000EOol00`00Oomoo`3oOol00`00Oomoo`06Ool0
01Eoo`03001oogoo0?moo`03001oogoo00Ioo`005Goo00<007ooOol0ogoo0Goo00<007ooOol01Goo
000EOol00`00Oomoo`3oOol1Ool00`00Oomoo`05Ool001Eoo`800?moo`9oo`03001oogoo00Eoo`00
5Goo00<007ooOol0ogoo0Goo00<007ooOol01Goo000EOol00`00Oomoo`3oOol1Ool00`00Oomoo`05
Ool001Eoo`03001oogoo0?moo`5oo`03001oogoo00Eoo`005Goo0P00ogoo0Woo00<007ooOol01Goo
000EOol00`00Oomoo`3oOol1Ool00`00Oomoo`05Ool001Eoo`03001oogoo0?moo`5oo`03001oogoo
00Eoo`003Goo100017oo00<007ooOol0ogoo0Goo00<007ooOol01Goo000=Ool00`00Oomoo`05Ool0
0`00Oomoo`3oOol1Ool00`00Oomoo`05Ool000ioo`03001oogoo00Aoo`<00?moo`03001oogoo00Io
o`003goo00<007ooOol00goo00<007ooOol0ogoo00<007ooOol01Woo000=Ool01000Oomoo`0017oo
00<007ooOol0ogoo00<007ooOol01Woo000>Ool20005Ool00`00Oomoo`3oOol00`00Oomoo`06Ool0
01Eoo`03001oogoo0?ioo`03001oogoo00Moo`005Goo0P00ogoo00<007ooOol01goo000EOol00`00
Oomoo`3nOol00`00Oomoo`07Ool001Eoo`03001oogoo0?eoo`03001oogoo00Qoo`005Goo00<007oo
Ool0oGoo00<007ooOol027oo000EOol00`00Oomoo`3lOol00`00Oomoo`09Ool001Eoo`800?aoo`03
001oogoo00Yoo`005Goo00<007ooOol0ngoo00<007ooOol02Woo000EOol00`00Oomoo`3jOol00`00
Oomoo`0;Ool001Eoo`03001oogoo0?Yoo`03001oogoo00]oo`005Goo0P00nWoo00<007ooOol037oo
000EOol00`00Oomoo`3iOol00`00Oomoo`0<Ool001Eoo`03001oogoo0?Qoo`03001oogoo00eoo`00
5Goo00<007ooOol0mgoo00<007ooOol03Woo000EOol00`00Oomoo`3fOol00`00Oomoo`0?Ool001Eo
o`800?Ioo`03001oogoo011oo`005Goo00<007ooOol0m7oo00<007ooOol04Goo000EOol00`00Oomo
o`3cOol00`00Oomoo`0BOol00003Ool00000008000=oo`8000Aoo`8000Eoo`03001oogoo0?9oo`03
001oogoo01=oo`0000=oo`00Ool02Woo00@007ooOol000Aoo`03001oogoo0?1oo`8001Ioo`000Woo
00<007ooOol02goo00<007ooOol00Woo0`00kgoo00<007ooOol05Woo0003Ool00`00Oomoo`08Ool2
0005Ool00`00Oomoo`3^Ool00`00Oomoo`0GOol00005Ool007ooOol00009Ool00`00Oomoo`04Ool0
0`00Oomoo`3]Ool00`00Oomoo`0HOol0009oo`8000Yoo`<000Aoo`03001oogoo0>aoo`03001oogoo
01Uoo`005Goo00<007ooOol0jWoo0P0077oo000EOol2003ZOol00`00Oomoo`0LOol001Eoo`03001o
ogoo0>Qoo`03001oogoo01eoo`005Goo00<007ooOol0iWoo0P0087oo000EOol00`00Oomoo`3UOol0
0`00Oomoo`0POol001Eoo`800>Eoo`03001oogoo025oo`005Goo00<007ooOol0hWoo0P0097oo000E
Ool00`00Oomoo`3POol2000VOol001Eoo`03001oogoo0=ioo`8002Qoo`005Goo00<007ooOol0g7oo
0P00:Woo000EOol2003KOol2000/Ool001Eoo`03001oogoo0=Moo`<002ioo`005Goo00<007ooOol0
eGoo0P00<Goo000EOol00`00Oomoo`3BOol3000cOol001Eoo`03001oogoo0=1oo`8003Ioo`005Goo
0P00cgoo0P00>7oo000EOol00`00Oomoo`3;Ool3000jOol001Eoo`03001oogoo0<Uoo`8003eoo`00
3Woo0P001Goo00<007ooOol0aWoo0`00?goo000=Ool01000Oomoo`0017oo00<007ooOol0a7oo0P00
@Woo000?Ool00`00Oomoo`03Ool30031Ool30014Ool0011oo`03001oogoo009oo`800;moo`<004Mo
o`003Goo00@007ooOol000Aoo`<00;]oo`<004Yoo`003Woo0P001Goo00<007ooOol00P00]Woo0`00
CGoo000EOol20003Ool00`00Oomoo`2`Ool3001@Ool001Eoo`03001oogoo00=oo`03001oogoo0:ao
o`<005=oo`005Goo00<007ooOol017oo0`00Z7oo0`00EWoo000EOol00`00Oomoo`07Ool3002QOol4
001IOol001Eoo`03001oogoo00Yoo`@009Moo`H005eoo`005Goo0P003goo0`00Sgoo1@00Hgoo000E
Ool00`00Oomoo`0AOol30026Ool6001XOol001Eoo`03001oogoo01Aoo`@007eoo`D006ioo`005Goo
00<007ooOol067oo1000MGoo1000Lgoo000EOol00`00Oomoo`0LOol5001YOol7001gOol001Eoo`80
029oo`T005Moo`T007ioo`005Goo00<007ooOol0:Woo1`00B7oo2000Qgoo000EOol00`00Oomoo`0a
Ool7000iOol8002?Ool001Eoo`03001oogoo03QoocT009Moo`005Goo0P00ogoo2Woo000EOol00`00
Oomoo`3oOol9Ool001Eoo`03001oogoo0?moo`Uoo`005Goo00<007ooOol0ogoo2Goo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-0.0189669, -0.265442, \
0.000886216, 0.0210748}},
  CellTags->"Basic resolution of plane motion's problems"]
}, Closed]],

Cell[BoxData[
    \(a[t_] := \[PartialD]\_tt v[tt] /. tt \[Rule] t\)], "Input",
  CellLabel->"In[188]:=",
  CellTags->"Basic resolution of plane motion's problems"],

Cell[CellGroupData[{

Cell[BoxData[
    \(a[t] // Together\)], "Input",
  CellLabel->"In[189]:=",
  CellTags->"Basic resolution of plane motion's problems"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        FractionBox[
          RowBox[{
            RowBox[{\(-6.`\), " ", \(t\^2\), " ", 
              RowBox[{"(", 
                TagBox[
                  StyleBox[\("m"\ "s"\^2\),
                    ShowStringCharacters->False,
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit], ")"}]}], "+", 
            RowBox[{"4.`", " ", 
              RowBox[{"(", 
                TagBox[
                  StyleBox[\("m"\ "s"\^4\),
                    ShowStringCharacters->False,
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit], ")"}]}]}], 
          SuperscriptBox[
            RowBox[{"(", 
              RowBox[{\(t\^2\), "+", 
                RowBox[{"2.`", " ", 
                  TagBox[
                    StyleBox[\("s"\^2\),
                      ShowStringCharacters->False,
                      FontSlant->"Plain",
                      FontColor->GrayLevel[0.500008]],
                    Unit]}]}], ")"}], "3"]], ",", 
        RowBox[{"-", 
          FractionBox[
            RowBox[{"12", " ", 
              RowBox[{"(", 
                RowBox[{
                  RowBox[{\(t\^3\), " ", 
                    RowBox[{"(", 
                      TagBox[
                        StyleBox[\("m"\ "s"\),
                          ShowStringCharacters->False,
                          FontSlant->"Plain",
                          FontColor->GrayLevel[0.500008]],
                        Unit], ")"}]}], "-", 
                  RowBox[{"6", " ", "t", " ", 
                    RowBox[{"(", 
                      TagBox[
                        StyleBox[\("m"\ "s"\^3\),
                          ShowStringCharacters->False,
                          FontSlant->"Plain",
                          FontColor->GrayLevel[0.500008]],
                        Unit], ")"}]}]}], ")"}]}], 
            SuperscriptBox[
              RowBox[{"(", 
                RowBox[{\(t\^2\), "+", 
                  RowBox[{"2", " ", 
                    TagBox[
                      StyleBox[\("s"\^2\),
                        ShowStringCharacters->False,
                        FontSlant->"Plain",
                        FontColor->GrayLevel[0.500008]],
                      Unit]}]}], ")"}], "3"]]}]}], "}"}]], "Output",
  CellLabel->"Out[189]=",
  CellTags->"Basic resolution of plane motion's problems"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"a", "[", 
        RowBox[{"t", " ", 
          InterpretationBox[
            StyleBox["s",
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit[ s]]}], "]"}], "//", "UnitSimplify"}]], "Input",
  CellLabel->"In[190]:=",
  CellTags->"Basic resolution of plane motion's problems"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        FractionBox[
          RowBox[{\((\(\(4.`\)\(\[InvisibleSpace]\)\) - 6.`\ t\^2)\), " ", 
            TagBox[
              StyleBox[\("m"\/"s"\^2\),
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}], \(\((\(\(2.`\)\(\[InvisibleSpace]\)\) + t\^2)\)\^3\)], 
        ",", 
        RowBox[{"-", 
          FractionBox[
            RowBox[{"12", " ", "t", " ", \((\(-6\) + t\^2)\), " ", 
              TagBox[
                StyleBox[\("m"\/"s"\^2\),
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}], \(\((2 + t\^2)\)\^3\)]}]}], "}"}]], "Output",
  CellLabel->"Out[190]=",
  CellTags->"Basic resolution of plane motion's problems"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"ParametricPlot", "[", 
        RowBox[{
          RowBox[{"Evaluate", "@", 
            RowBox[{"Normal", "@", 
              RowBox[{"a", "[", 
                RowBox[{"t", " ", 
                  InterpretationBox[
                    StyleBox["s",
                      FontSlant->"Plain",
                      FontColor->GrayLevel[0.500008]],
                    Unit[ s]]}], "]"}]}]}], ",", \({t, 0, 15}\)}], "]"}], 
      ";"}]], "Input",
  CellLabel->"In[191]:=",
  CellTags->"Basic resolution of plane motion's problems"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.214286 1.52381 0.0315469 0.184986 [
[.0619 .01905 -12 -9 ]
[.0619 .01905 12 0 ]
[.36667 .01905 -9 -9 ]
[.36667 .01905 9 0 ]
[.51905 .01905 -9 -9 ]
[.51905 .01905 9 0 ]
[.67143 .01905 -9 -9 ]
[.67143 .01905 9 0 ]
[.82381 .01905 -9 -9 ]
[.82381 .01905 9 0 ]
[.97619 .01905 -9 -9 ]
[.97619 .01905 9 0 ]
[.20179 .12404 -18 -4.5 ]
[.20179 .12404 0 4.5 ]
[.20179 .21653 -6 -4.5 ]
[.20179 .21653 0 4.5 ]
[.20179 .30903 -18 -4.5 ]
[.20179 .30903 0 4.5 ]
[.20179 .40152 -6 -4.5 ]
[.20179 .40152 0 4.5 ]
[.20179 .49401 -18 -4.5 ]
[.20179 .49401 0 4.5 ]
[.20179 .58651 -6 -4.5 ]
[.20179 .58651 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.0619 .03155 m
.0619 .0378 L
s
[(-0.1)] .0619 .01905 0 1 Mshowa
.36667 .03155 m
.36667 .0378 L
s
[(0.1)] .36667 .01905 0 1 Mshowa
.51905 .03155 m
.51905 .0378 L
s
[(0.2)] .51905 .01905 0 1 Mshowa
.67143 .03155 m
.67143 .0378 L
s
[(0.3)] .67143 .01905 0 1 Mshowa
.82381 .03155 m
.82381 .0378 L
s
[(0.4)] .82381 .01905 0 1 Mshowa
.97619 .03155 m
.97619 .0378 L
s
[(0.5)] .97619 .01905 0 1 Mshowa
.125 Mabswid
.09238 .03155 m
.09238 .0353 L
s
.12286 .03155 m
.12286 .0353 L
s
.15333 .03155 m
.15333 .0353 L
s
.18381 .03155 m
.18381 .0353 L
s
.24476 .03155 m
.24476 .0353 L
s
.27524 .03155 m
.27524 .0353 L
s
.30571 .03155 m
.30571 .0353 L
s
.33619 .03155 m
.33619 .0353 L
s
.39714 .03155 m
.39714 .0353 L
s
.42762 .03155 m
.42762 .0353 L
s
.4581 .03155 m
.4581 .0353 L
s
.48857 .03155 m
.48857 .0353 L
s
.54952 .03155 m
.54952 .0353 L
s
.58 .03155 m
.58 .0353 L
s
.61048 .03155 m
.61048 .0353 L
s
.64095 .03155 m
.64095 .0353 L
s
.7019 .03155 m
.7019 .0353 L
s
.73238 .03155 m
.73238 .0353 L
s
.76286 .03155 m
.76286 .0353 L
s
.79333 .03155 m
.79333 .0353 L
s
.85429 .03155 m
.85429 .0353 L
s
.88476 .03155 m
.88476 .0353 L
s
.91524 .03155 m
.91524 .0353 L
s
.94571 .03155 m
.94571 .0353 L
s
.03143 .03155 m
.03143 .0353 L
s
.00095 .03155 m
.00095 .0353 L
s
.25 Mabswid
0 .03155 m
1 .03155 L
s
.21429 .12404 m
.22054 .12404 L
s
[(0.5)] .20179 .12404 1 0 Mshowa
.21429 .21653 m
.22054 .21653 L
s
[(1)] .20179 .21653 1 0 Mshowa
.21429 .30903 m
.22054 .30903 L
s
[(1.5)] .20179 .30903 1 0 Mshowa
.21429 .40152 m
.22054 .40152 L
s
[(2)] .20179 .40152 1 0 Mshowa
.21429 .49401 m
.22054 .49401 L
s
[(2.5)] .20179 .49401 1 0 Mshowa
.21429 .58651 m
.22054 .58651 L
s
[(3)] .20179 .58651 1 0 Mshowa
.125 Mabswid
.21429 .05005 m
.21804 .05005 L
s
.21429 .06854 m
.21804 .06854 L
s
.21429 .08704 m
.21804 .08704 L
s
.21429 .10554 m
.21804 .10554 L
s
.21429 .14254 m
.21804 .14254 L
s
.21429 .16104 m
.21804 .16104 L
s
.21429 .17954 m
.21804 .17954 L
s
.21429 .19803 m
.21804 .19803 L
s
.21429 .23503 m
.21804 .23503 L
s
.21429 .25353 m
.21804 .25353 L
s
.21429 .27203 m
.21804 .27203 L
s
.21429 .29053 m
.21804 .29053 L
s
.21429 .32753 m
.21804 .32753 L
s
.21429 .34602 m
.21804 .34602 L
s
.21429 .36452 m
.21804 .36452 L
s
.21429 .38302 m
.21804 .38302 L
s
.21429 .42002 m
.21804 .42002 L
s
.21429 .43852 m
.21804 .43852 L
s
.21429 .45702 m
.21804 .45702 L
s
.21429 .47551 m
.21804 .47551 L
s
.21429 .51251 m
.21804 .51251 L
s
.21429 .53101 m
.21804 .53101 L
s
.21429 .54951 m
.21804 .54951 L
s
.21429 .56801 m
.21804 .56801 L
s
.21429 .01305 m
.21804 .01305 L
s
.21429 .605 m
.21804 .605 L
s
.25 Mabswid
.21429 0 m
.21429 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.97619 .03155 m
.97541 .06236 L
.97334 .0903 L
.96935 .12234 L
.96403 .15232 L
.95092 .20458 L
.93163 .25924 L
.9047 .31622 L
.87027 .37215 L
.79594 .45877 L
.75431 .49454 L
.7071 .52728 L
.66489 .55071 L
.61799 .57117 L
.58942 .58102 L
.56293 .58847 L
.53775 .59413 L
.52493 .59649 L
.51114 .59863 L
.49765 .60034 L
.48532 .60156 L
.46137 .60303 L
.43996 .60332 L
.41778 .6026 L
.40617 .6018 L
.39371 .60062 L
.37152 .59767 L
.35052 .59385 L
.33165 .58954 L
.29096 .57724 L
.25112 .56085 L
.19283 .52766 L
.14017 .48524 L
.09652 .43625 L
.07853 .41016 L
.06292 .38291 L
.05177 .3594 L
.04209 .33438 L
.03531 .31232 L
.03062 .29275 L
.02717 .27332 L
.02588 .26344 L
.02535 .2585 L
.02487 .25326 L
.02428 .24466 L
.02394 .2368 L
.02384 .23211 L
.02381 .22772 L
.02392 .21965 L
.02419 .21259 L
Mistroke
.02466 .20527 L
.02524 .19856 L
.02589 .19263 L
.02793 .17871 L
.03033 .1664 L
.03704 .14169 L
.04439 .12198 L
.05327 .10335 L
.06311 .08672 L
.07999 .06446 L
.09722 .04735 L
.11207 .03597 L
.1242 .02863 L
.13636 .02286 L
.14615 .01932 L
.15543 .01687 L
.1596 .01606 L
.16382 .01543 L
.16723 .01506 L
.16885 .01493 L
.17055 .01483 L
.17195 .01477 L
.17271 .01474 L
.17339 .01473 L
.17401 .01472 L
.17467 .01472 L
.17528 .01472 L
.17584 .01472 L
.17647 .01473 L
.17714 .01475 L
.17775 .01477 L
.17831 .01479 L
.17962 .01486 L
.18081 .01494 L
.18304 .01515 L
.18528 .01543 L
.18863 .01599 L
.19181 .01669 L
.19694 .01822 L
.20046 .01962 L
.20335 .02102 L
.20717 .02336 L
.20941 .02509 L
.2108 .02636 L
.21179 .02739 L
.21243 .02816 L
.2129 .02878 L
.21322 .02925 L
.21345 .02961 L
.21363 .02992 L
Mistroke
.21376 .03016 L
.21385 .03034 L
.21393 .03051 L
.21399 .03064 L
.21404 .03076 L
.21408 .03085 L
.21411 .03092 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[191]:=",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40O003h00Oogoo8Goo000?Ool2
0004Ool20003Ool50012Ool20004Ool20003Ool5000KOol20004Ool20003Ool4000LOol20004Ool2
0004Ool2000MOol20004Ool20005Ool3000JOol20004Ool20004Ool20006Ool000ioo`04001oogoo
000:Ool00`00Oomoo`11Ool01000Oomoo`002Woo00<007ooOol06Woo00@007ooOol000Qoo`03001o
ogoo01aoo`04001oogoo0008Ool01000Oomoo`006goo00@007ooOol000]oo`03001oogoo01Qoo`04
001oogoo0008Ool01000Oomoo`001Goo000>Ool01000Oomoo`002Woo00<007ooOol07goo00<007oo
Ool07goo00@007ooOol000Yoo`03001oogoo01Yoo`04001oogoo0009Ool00`00Oomoo`0KOol01000
Oomoo`002Woo00<007ooOol06Woo00@007ooOol000Qoo`D001Uoo`04001oogoo000;Ool00`00Oomo
o`03Ool000Qoo`@0009oo`04001oogoo000:Ool00`00Oomoo`0OOol00`00Oomoo`0OOol01000Oomo
o`002Woo00<007ooOol06Woo00@007ooOol000Yoo`03001oogoo01Yoo`04001oogoo000;Ool00`00
Oomoo`0IOol01000Oomoo`0027oo00@007ooOol001Yoo`04001oogoo0009Ool20006Ool000ioo`04
001oogoo000:Ool00`00Oomoo`0OOol00`00Oomoo`0OOol01000Oomoo`002Woo00<007ooOol06Woo
00@007ooOol000Qoo`04001oogoo000KOol01000Oomoo`0027oo00@007ooOol001]oo`04001oogoo
0009Ool00`00Ool0000JOol01000Oomoo`002Goo00<007ooOol01Goo000?Ool2000:Ool2000QOol0
0`00Oomoo`0POol2000:Ool2000MOol2000:Ool2000MOol2000:Ool2000MOol2000;Ool2000KOol2
000:Ool30005Ool0035oo`D000Qoo`800>1oo`00;Goo10001Goo100017oo00<007ooOol0ggoo000Z
Ool3000=Ool20002Ool00`00Oomoo`3OOol002Moo`<0019oo`03001oo`000>5oo`0097oo0`005Woo
0P00hGoo0002Oooo000J0005Ool0009oo`03001oogoo00Eoo`03001oogoo00Ioo`03001oogoo00Io
o`03001oogoo009oo`04001oogoo0008Ool00`00Oomoo`05Ool00`00Oomoo`06Ool00`00Oomoo`05
Ool00`00Oomoo`06Ool00`00Oomoo`05Ool00`00Oomoo`06Ool00`00Oomoo`05Ool00`00Oomoo`06
Ool00`00Oomoo`06Ool00`00Oomoo`05Ool00`00Oomoo`06Ool00`00Oomoo`05Ool00`00Oomoo`06
Ool00`00Oomoo`05Ool00`00Oomoo`06Ool00`00Oomoo`05Ool00`00Oomoo`06Ool00`00Oomoo`05
Ool00`00Oomoo`06Ool00`00Oomoo`06Ool00`00Oomoo`05Ool00`00Oomoo`06Ool00`00Oomoo`05
Ool00`00Oomoo`06Ool00`00Oomoo`05Ool00`00Oomoo`06Ool00`00Oomoo`05Ool00`00Oomoo`0:
Ool001=oo`03001oogoo00Yoo`03001oogoo01]oo`03001oogoo02Moo`03001oogoo02Qoo`03001o
ogoo02Qoo`03001oogoo02Qoo`03001oogoo02Moo`03001oogoo00Yoo`007Woo0P007Woo00<007oo
Ool0dWoo00<007ooOol02Woo000MOol00`00Oomoo`0NOol00`00Oomoo`3BOol00`00Oomoo`0:Ool0
01aoo`03001oogoo01moo`800==oo`03001oogoo00Yoo`006goo00<007ooOol087oo00<007ooOol0
dWoo00<007ooOol02Woo000JOol00`00Oomoo`0QOol00`00Oomoo`3BOol00`00Oomoo`0:Ool001Uo
o`03001oogoo029oo`03001oogoo0=9oo`03001oogoo00Yoo`0067oo00<007ooOol08goo00<007oo
Ool0dWoo00<007ooOol02Woo000GOol00`00Oomoo`0TOol2003COol00`00Oomoo`0:Ool001Moo`03
001oogoo02Aoo`03001oogoo0=9oo`03001oogoo00Yoo`005Woo00<007ooOol09Goo00<007ooOol0
dWoo00<007ooOol02Woo000EOol00`00Oomoo`0VOol00`00Oomoo`3BOol00`00Oomoo`0:Ool001Ao
o`03001oogoo02Moo`03001oogoo0=9oo`03001oogoo00Yoo`0057oo00<007ooOol09goo00<007oo
Ool0dWoo00<007ooOol02Woo000COol00`00Oomoo`0XOol2003COol00`00Oomoo`0:Ool0019oo`03
001oogoo02Uoo`03001oogoo0=9oo`03001oogoo00Yoo`004Woo00<007ooOol0:Goo00<007ooOol0
dWoo00<007ooOol02Woo000AOol00`00Oomoo`0ZOol00`00Oomoo`3BOol00`00Oomoo`0:Ool0015o
o`03001oogoo02Yoo`03001oogoo0=5oo`03001oogoo00]oo`0047oo00<007ooOol0:goo0P00dWoo
00<007ooOol02goo000@Ool00`00Oomoo`0[Ool00`00Oomoo`3AOol00`00Oomoo`0;Ool000moo`03
001oogoo02aoo`03001oogoo0=5oo`03001oogoo00]oo`003goo00<007ooOol067oo0P0017oo0P00
17oo0P001Woo00<007ooOol0d7oo00<007ooOol037oo000>Ool00`00Oomoo`0HOol01000Oomoo`00
27oo00@007ooOol000Eoo`03001oogoo0=1oo`03001oogoo00aoo`003Woo00<007ooOol067oo00@0
07ooOol000]oo`03001oogoo00=oo`800=5oo`03001oogoo00aoo`003Goo00<007ooOol06Goo00@0
07ooOol000Uoo`8000Ioo`03001oogoo0=1oo`03001oogoo00aoo`003Goo00<007ooOol06Goo00@0
07ooOol000Uoo`03001oogoo00Eoo`03001oogoo0=1oo`03001oogoo00aoo`003Goo00<007ooOol0
6Woo0P002Woo0`001Goo00<007ooOol0d7oo00<007ooOol037oo000<Ool00`00Oomoo`0_Ool00`00
Oomoo`3?Ool00`00Oomoo`0=Ool000aoo`03001oogoo02moo`800=1oo`03001oogoo00eoo`0037oo
00<007ooOol0;goo00<007ooOol0cgoo00<007ooOol03Goo000;Ool00`00Oomoo`0`Ool00`00Oomo
o`3?Ool00`00Oomoo`0=Ool000]oo`03001oogoo031oo`03001oogoo0<moo`03001oogoo00eoo`00
2goo00<007ooOol0<7oo00<007ooOol0cgoo00<007ooOol03Goo000;Ool00`00Oomoo`0`Ool2003?
Ool00`00Oomoo`0>Ool000Yoo`03001oogoo035oo`03001oogoo0<ioo`03001oogoo00ioo`002Woo
00<007ooOol0<Goo00<007ooOol0cWoo00<007ooOol03Woo000:Ool00`00Oomoo`0aOol00`00Oomo
o`3>Ool00`00Oomoo`0>Ool000Uoo`03001oogoo039oo`03001oogoo0<eoo`03001oogoo00moo`00
2Goo00<007ooOol0<Woo00<007ooOol0cGoo00<007ooOol03goo0009Ool00`00Oomoo`0bOol2003>
Ool00`00Oomoo`0?Ool000Uoo`03001oogoo039oo`03001oogoo0<eoo`03001oogoo00moo`002Goo
00<007ooOol0<Woo00<007ooOol0c7oo00<007ooOol047oo0009Ool00`00Oomoo`0bOol00`00Oomo
o`3<Ool00`00Oomoo`0@Ool000Uoo`03001oogoo039oo`03001oogoo0<aoo`03001oogoo011oo`00
2Goo00<007ooOol0<Woo0P00cGoo00<007ooOol047oo0009Ool00`00Oomoo`0bOol00`00Oomoo`3;
Ool00`00Oomoo`0AOol000Uoo`03001oogoo039oo`03001oogoo0<]oo`03001oogoo015oo`0027oo
00<007ooOol0:Woo1@0017oo00<007ooOol0bgoo00<007ooOol04Goo0008Ool00`00Oomoo`0/Ool0
0`00Oomoo`04Ool00`00Oomoo`3:Ool00`00Oomoo`0BOol000Qoo`03001oogoo02aoo`03001oogoo
00Aoo`800<]oo`03001oogoo019oo`0027oo00<007ooOol0;7oo00<007ooOol017oo00<007ooOol0
bWoo00<007ooOol04Woo0008Ool00`00Oomoo`0/Ool00`00Oomoo`04Ool00`00Oomoo`39Ool00`00
Oomoo`0COol000Qoo`03001oogoo02]oo`8000Ioo`03001oogoo0<Uoo`03001oogoo01=oo`0027oo
00<007ooOol0<goo00<007ooOol0bGoo00<007ooOol04goo0008Ool00`00Oomoo`0cOol20039Ool0
0`00Oomoo`0DOol000Qoo`03001oogoo03=oo`03001oogoo0<Qoo`03001oogoo01Aoo`0027oo00<0
07ooOol0<goo00<007ooOol0b7oo00<007ooOol057oo0008Ool00`00Oomoo`0cOol00`00Oomoo`37
Ool00`00Oomoo`0EOol000Qoo`03001oogoo03=oo`03001oogoo0<Moo`03001oogoo01Eoo`002Goo
00<007ooOol0<Woo0P00b7oo00<007ooOol05Goo0009Ool00`00Oomoo`0bOol00`00Oomoo`36Ool0
0`00Oomoo`0FOol000Uoo`03001oogoo039oo`03001oogoo0<Ioo`03001oogoo01Ioo`002Goo00<0
07ooOol0<Woo00<007ooOol0aGoo00<007ooOol05goo0009Ool00`00Oomoo`0bOol00`00Oomoo`35
Ool00`00Oomoo`0GOol000Uoo`03001oogoo039oo`800<Eoo`03001oogoo01Qoo`002Goo00<007oo
Ool0<Woo00<007ooOol0a7oo00<007ooOol067oo0009Ool00`00Oomoo`0bOol00`00Oomoo`33Ool0
0`00Oomoo`0IOol000Uoo`03001oogoo039oo`03001oogoo0<=oo`03001oogoo01Uoo`002Woo00<0
07ooOol0<Goo00<007ooOol0`Woo00<007ooOol06Woo000:Ool00`00Oomoo`0aOol00`00Oomoo`32
Ool00`00Oomoo`0JOol000Yoo`03001oogoo035oo`800<9oo`03001oogoo01]oo`002Woo00<007oo
Ool0<Goo00<007ooOol0`Goo00<007ooOol06goo000;Ool00`00Oomoo`0`Ool00`00Oomoo`30Ool0
0`00Oomoo`0LOol000]oo`03001oogoo01]oo`D0009oo`8000Aoo`8000Ioo`03001oogoo0<1oo`03
001oogoo01aoo`002goo00<007ooOol07Goo00<007ooOol01goo00@007ooOol000Eoo`03001oogoo
0;moo`03001oogoo01eoo`0037oo00<007ooOol077oo00<007ooOol02Woo00<007ooOol00goo0P00
`7oo00<007ooOol07Goo000<Ool00`00Oomoo`0LOol00`00Oomoo`08Ool20006Ool00`00Oomoo`2n
Ool00`00Oomoo`0NOol000aoo`03001oogoo01aoo`03001oogoo00Qoo`03001oogoo00Eoo`03001o
ogoo0;ioo`03001oogoo01ioo`0037oo00<007ooOol06goo0P002Woo0`001Goo00<007ooOol0_Goo
00<007ooOol07goo000<Ool00`00Oomoo`0_Ool00`00Oomoo`2mOol00`00Oomoo`0OOol000eoo`03
001oogoo02ioo`800;eoo`03001oogoo021oo`003Goo00<007ooOol0;Woo00<007ooOol0_7oo00<0
07ooOol087oo000=Ool00`00Oomoo`0^Ool00`00Oomoo`2kOol00`00Oomoo`0QOol000eoo`03001o
ogoo02ioo`03001oogoo0;]oo`03001oogoo025oo`003Woo00<007ooOol0;Goo00<007ooOol0^Woo
00<007ooOol08Woo000>Ool00`00Oomoo`0]Ool2002jOol00`00Oomoo`0SOol000moo`03001oogoo
02aoo`03001oogoo0;Uoo`03001oogoo02=oo`003goo00<007ooOol0;7oo00<007ooOol0^7oo00<0
07ooOol097oo000@Ool00`00Oomoo`0[Ool00`00Oomoo`2hOol00`00Oomoo`0TOol0011oo`03001o
ogoo02]oo`03001oogoo0;Moo`03001oogoo02Eoo`0047oo00<007ooOol0:goo0P00^7oo00<007oo
Ool09Goo000AOol00`00Oomoo`0ZOol00`00Oomoo`2fOol00`00Oomoo`0VOol0015oo`03001oogoo
02Yoo`03001oogoo0;Ioo`03001oogoo02Ioo`004Woo00<007ooOol0:Goo00<007ooOol0]Goo00<0
07ooOol09goo000BOol00`00Oomoo`0YOol00`00Oomoo`2dOol00`00Oomoo`0XOol001=oo`03001o
ogoo02Qoo`03001oogoo0;=oo`03001oogoo02Uoo`004goo00<007ooOol0:7oo0P00/goo00<007oo
Ool0:Woo000DOol00`00Oomoo`0WOol00`00Oomoo`2aOol00`00Oomoo`0[Ool001Aoo`03001oogoo
02Moo`03001oogoo0;5oo`03001oogoo02]oo`005Goo00<007ooOol07Goo10001Goo00<007ooOol0
/7oo00<007ooOol0;7oo000FOol00`00Oomoo`0LOol00`00Oomoo`06Ool00`00Oomoo`2_Ool00`00
Oomoo`0]Ool001Moo`03001oogoo01aoo`03001oogoo00Eoo`800:moo`03001oogoo02ioo`005goo
00<007ooOol07Goo00<007ooOol017oo00<007ooOol0[Goo00<007ooOol0;goo000HOol00`00Oomo
o`0JOol01000Oomoo`001Goo00<007ooOol0[7oo00<007ooOol0<7oo000IOol00`00Oomoo`0JOol2
0006Ool00`00Oomoo`2[Ool00`00Oomoo`0aOol001Uoo`03001oogoo029oo`03001oogoo0:Yoo`03
001oogoo039oo`006Woo00<007ooOol08Goo0P00Zgoo00<007ooOol0<Woo000JOol00`00Oomoo`0Q
Ool00`00Oomoo`2YOol00`00Oomoo`0cOol001]oo`03001oogoo021oo`03001oogoo0:Qoo`03001o
ogoo03Aoo`0077oo00<007ooOol07goo00<007ooOol0Ygoo00<007ooOol0=Goo000LOol00`00Oomo
o`0OOol00`00Oomoo`2VOol00`00Oomoo`0fOol001eoo`03001oogoo01ioo`800:Ioo`03001oogoo
03Moo`007Woo00<007ooOol07Goo00<007ooOol0Y7oo00<007ooOol0>7oo000OOol00`00Oomoo`0L
Ool00`00Oomoo`2SOol00`00Oomoo`0iOol0021oo`03001oogoo01]oo`03001oogoo0:=oo`03001o
ogoo03Uoo`008Goo00<007ooOol06Woo00<007ooOol0XWoo00<007ooOol0>Woo000ROol00`00Oomo
o`0IOol2002ROol00`00Oomoo`0kOol002=oo`03001oogoo01Qoo`03001oogoo0:1oo`03001oogoo
03aoo`008goo00<007ooOol067oo00<007ooOol0Wgoo00<007ooOol0?Goo000TOol00`00Oomoo`0G
Ool00`00Oomoo`2NOol00`00Oomoo`0nOol002Eoo`03001oogoo01Ioo`03001oogoo09aoo`80045o
o`009Woo00<007ooOol05Goo00<007ooOol0Vgoo00<007ooOol0@Goo000WOol00`00Oomoo`0DOol2
002KOol00`00Oomoo`12Ool002Qoo`03001oogoo01=oo`03001oogoo09Uoo`03001oogoo04=oo`00
:Goo00<007ooOol04Woo00<007ooOol0V7oo00<007ooOol0A7oo000YOol40003Ool20004Ool20006
Ool00`00Oomoo`2FOol20017Ool002Uoo`04001oo`000008Ool01000Oomoo`001Goo00<007ooOol0
UGoo00<007ooOol0Agoo000ZOol01000Oomoo`002Woo00<007ooOol00goo0P00UGoo00<007ooOol0
B7oo000[Ool01000Oomoo`001goo0P001Woo00<007ooOol0TWoo0P00Bgoo000YOol01000Oomoo`00
0Woo00<007ooOol017oo00<007ooOol01Goo00<007ooOol0TGoo00<007ooOol0Bgoo000ZOol20004
Ool20004Ool30005Ool00`00Oomoo`2?Ool2001>Ool0039oo`03001oogoo00Uoo`03001oogoo08io
o`03001oogoo04ioo`00<goo00<007ooOol027oo0P00SWoo00<007ooOol0Cgoo000dOol00`00Oomo
o`07Ool00`00Oomoo`2;Ool2001BOol003Eoo`8000Moo`03001oogoo08Yoo`03001oogoo059oo`00
=goo00<007ooOol017oo00<007ooOol0R7oo0P00EGoo000hOol00`00Oomoo`03Ool00`00Oomoo`27
Ool00`00Oomoo`1EOol003Uoo`8000=oo`8008Ioo`8005Qoo`00>goo0P0000=oo`00Ool0Q7oo0P00
FWoo000mOol20024Ool00`00Oomoo`1JOol003ioo`80085oo`8005eoo`00?Woo00@007oo000007eo
o`8005moo`00?Woo0P000Woo0P00NGoo0P00HGoo000nOol00`00Oomoo`03Ool2001eOol2001SOol0
03ioo`03001oogoo00Eoo`80075oo`8006Eoo`00?Woo00<007ooOol01goo0P00K7oo0`00Igoo000n
Ool00`00Oomoo`09Ool2001WOol3001ZOol003ioo`8000aoo`8006=oo`8006eoo`00?Woo00<007oo
Ool03Goo0P00GWoo0`00Kgoo000nOol00`00Oomoo`0?Ool2001JOol2001bOol003ioo`03001oogoo
015oo`<005Aoo`<007Aoo`00=Woo0P001Woo00<007ooOol057oo0`00CWoo0`00Mgoo000eOol01000
Oomoo`001Goo00<007ooOol05goo0`00Agoo1000NWoo000gOol00`00Oomoo`04Ool2000KOol30010
Ool4001nOol003Qoo`03001oogoo00=oo`03001oogoo01eoo`@003Qoo`@0089oo`00=Goo00@007oo
Ool000Eoo`03001oogoo025oo`D002eoo`H008Ioo`00=Woo0P001Woo00<007ooOol09Woo1P008goo
1000S7oo000nOol00`00Oomoo`0/OolS002@Ool003ioo`800>1oo`00?Woo00<007ooOol0ggoo000n
Ool00`00Oomoo`3OOol003ioo`03001oogoo0=moo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-0.145665, -0.241101, \
0.00234066, 0.019281}},
  CellTags->"Basic resolution of plane motion's problems"]
}, Closed]],

Cell[BoxData[
    \(\(Clear[x, y, v, a, \[Alpha], \[Beta], \[Gamma]];\)\)], "Input",
  CellLabel->"In[192]:=",
  CellTags->"Basic resolution of plane motion's problems"],

Cell[TextData[{
  StyleBox["Warning",
    FontWeight->"Bold"],
  ": Sometimes, ",
  Cell[BoxData[
      \(Simplify\)]],
  " crashes the MathKernel (I'm don't know why). But ",
  Cell[BoxData[
      \(UnitSimplify\)]],
  " works."
}], "Warning",
  CellTags->"Basic resolution of plane motion's problems"]
}, Closed]],

Cell[CellGroupData[{

Cell["Dimensionless Numbers", "Subsubsection",
  CellTags->"Dimensionless Numbers"],

Cell[TextData[{
  "This examples are taken from \"",
  StyleBox["Perry\[CloseCurlyQuote]s chemical engineers\[CloseCurlyQuote] \
handbook. \[LongDash] 7th ed. / prepared by a staff of specialists under the \
editorial direction of late editor Robert H. Perry : editor, Don W. Green : \
associate editor, James O\[CloseCurlyQuote]Hara Maloney. ISBN 0-07-049841-5",
    FontSlant->"Italic"],
  "\" published by \"",
  StyleBox["The McGraw-Hill Companies, Inc",
    FontSlant->"Italic"],
  "\"."
}], "Text",
  CellTags->"Dimensionless Numbers"],

Cell[BoxData[
    \(ClearAll["\<Global`*\>"]\)], "Input",
  CellLabel->"In[193]:=",
  CellTags->"Dimensionless Numbers"],

Cell[BoxData[
    \(\(SetOptions[Unit, N \[Rule] 4];\)\)], "Input",
  CellLabel->"In[194]:=",
  CellTags->"Dimensionless Numbers"],

Cell[BoxData[{
    \(\(SetAttributes[\[ScriptCapitalP]\[ScriptR]\[ScriptI]\[ScriptN]\
\[ScriptT], {HoldAll, Listable}];\)\), "\n", 
    \(\(\[ScriptCapitalP]\[ScriptR]\[ScriptI]\[ScriptN]\[ScriptT][
          Set[x_, y_]] := Print[HoldForm@x \[Equal] Set[x, y]];\)\)}], "Input",\

  CellLabel->"In[195]:=",
  CellTags->"Dimensionless Numbers"],

Cell[TextData[{
  "Example ",
  StyleBox["1.",
    FontWeight->"Bold"],
  " Calculation of a Reynolds Number"
}], "MathCaption",
  CellTags->"Dimensionless Numbers"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{
      "\[ScriptCapitalP]\[ScriptR]\[ScriptI]\[ScriptN]\[ScriptT]", "[", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{"\[ScriptCapitalD]", "=", 
              RowBox[{"3", " ", 
                TagBox[
                  StyleBox["in",
                    ShowStringCharacters->False,
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit]}]}], ",", 
            RowBox[{"V", "=", 
              RowBox[{"6", " ", 
                TagBox[
                  StyleBox[\(ft\/s\),
                    ShowStringCharacters->False,
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit]}]}], ",", 
            RowBox[{"\[Rho]", "=", 
              RowBox[{"0.08", " ", 
                TagBox[
                  StyleBox[\(lb\/ft\^3\),
                    ShowStringCharacters->False,
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit]}]}], ",", 
            RowBox[{"\[Mu]", "=", 
              RowBox[{"0.015", " ", 
                TagBox[
                  StyleBox[\(\[ScriptC]\ Poise\),
                    ShowStringCharacters->False,
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit]}]}], 
            ",", \(N\_Re = \(\[ScriptCapitalD]\ V\ \[Rho]\)\/\[Mu]\)}], "}"}],
         "]"}], ";"}]], "Input",
  CellLabel->"In[197]:=",
  CellTags->"Dimensionless Numbers"],

Cell[BoxData[
    RowBox[{
      TagBox["\[ScriptCapitalD]",
        HoldForm], "\[Equal]", 
      RowBox[{"0.0762`3.69897000433602", " ", 
        TagBox[
          StyleBox["\<\"m\"\>",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}]}]], "Print",
  CellLabel->"From In[197]:=",
  CellTags->"Dimensionless Numbers"],

Cell[BoxData[
    RowBox[{
      TagBox["V",
        HoldForm], "\[Equal]", 
      RowBox[{"1.8288000000000000001`3.6989700043360183", " ", 
        TagBox[
          StyleBox[\("m"\/"s"\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}]}]], "Print",
  CellLabel->"From In[197]:=",
  CellTags->"Dimensionless Numbers"],

Cell[BoxData[
    RowBox[{
      TagBox["\[Rho]",
        HoldForm], "\[Equal]", 
      RowBox[{"1.2814770826168103`", " ", 
        TagBox[
          StyleBox[\("kg"\/"m"\^3\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}]}]], "Print",
  CellLabel->"From In[197]:=",
  CellTags->"Dimensionless Numbers"],

Cell[BoxData[
    RowBox[{
      TagBox["\[Mu]",
        HoldForm], "\[Equal]", 
      RowBox[{"0.000015`", " ", 
        TagBox[
          StyleBox[\("kg"\/\("m"\ "s"\)\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}]}]], "Print",
  CellLabel->"From In[197]:=",
  CellTags->"Dimensionless Numbers"],

Cell[BoxData[
    RowBox[{
      TagBox[\(N\_Re\),
        HoldForm], "\[Equal]", "11905.311666543286`"}]], "Print",
  CellLabel->"From In[197]:=",
  CellTags->"Dimensionless Numbers"]
}, Closed]],

Cell[TextData[{
  "Example ",
  StyleBox["2.",
    FontWeight->"Bold"],
  " Calculation of a Prandtl Number"
}], "MathCaption",
  CellTags->"Dimensionless Numbers"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{
      "\[ScriptCapitalP]\[ScriptR]\[ScriptI]\[ScriptN]\[ScriptT]", "[", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{\(C\_p\), "=", 
              RowBox[{"0.47", " ", 
                TagBox[
                  StyleBox[\(\(BTU\ \[DoubleStruckCapitalF]\)\/lb\),
                    ShowStringCharacters->False,
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit]}]}], ",", 
            RowBox[{"\[Mu]", "=", 
              RowBox[{"15", " ", 
                TagBox[
                  StyleBox[\(\[ScriptC]\ Poise\),
                    ShowStringCharacters->False,
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit]}]}], ",", 
            RowBox[{"k", "=", 
              RowBox[{"0.065", " ", 
                TagBox[
                  StyleBox[\(\(BTU\ \[DoubleStruckCapitalF]\)\/\(h\ ft\)\),
                    ShowStringCharacters->False,
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit]}]}], ",", \(N\_Pr = \(C\_p\ \[Mu]\)\/k\)}], "}"}], 
        "]"}], ";"}]], "Input",
  CellLabel->"In[198]:=",
  CellTags->"Dimensionless Numbers"],

Cell[BoxData[
    RowBox[{
      TagBox[\(C\_p\),
        HoldForm], "\[Equal]", 
      RowBox[{"607.3468258707334`", " ", 
        TagBox[
          StyleBox[\(\("m"\^2\ "\[DoubleStruckCapitalK]"\)\/"s"\^2\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}]}]], "Print",
  CellLabel->"From In[198]:=",
  CellTags->"Dimensionless Numbers"],

Cell[BoxData[
    RowBox[{
      TagBox["\[Mu]",
        HoldForm], "\[Equal]", 
      RowBox[{"0.0150000000000000003`3.5228787452803374", " ", 
        TagBox[
          StyleBox[\("kg"\/\("m"\ "s"\)\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}]}]], "Print",
  CellLabel->"From In[198]:=",
  CellTags->"Dimensionless Numbers"],

Cell[BoxData[
    RowBox[{
      TagBox["k",
        HoldForm], "\[Equal]", 
      RowBox[{"0.034721665289524`", " ", 
        TagBox[
          StyleBox[\(\("kg"\ "m"\ "\[DoubleStruckCapitalK]"\)\/"s"\^3\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}]}]], "Print",
  CellLabel->"From In[198]:=",
  CellTags->"Dimensionless Numbers"],

Cell[BoxData[
    RowBox[{
      TagBox[\(N\_Pr\),
        HoldForm], "\[Equal]", "262.3780372311138`"}]], "Print",
  CellLabel->"From In[198]:=",
  CellTags->"Dimensionless Numbers"]
}, Closed]],

Cell[TextData[{
  "Example ",
  StyleBox["3.",
    FontWeight->"Bold"],
  " Calculation of a ",
  "Nusselt",
  " Number"
}], "MathCaption",
  CellTags->"Dimensionless Numbers"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{
      "\[ScriptCapitalP]\[ScriptR]\[ScriptI]\[ScriptN]\[ScriptT]", "[", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{"\[ScriptCapitalD]", "=", 
              RowBox[{"1.5", " ", 
                TagBox[
                  StyleBox["in",
                    ShowStringCharacters->False,
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit]}]}], ",", 
            RowBox[{"k", "=", 
              RowBox[{"0.07", " ", 
                TagBox[
                  StyleBox[\(\(BTU\ \[DoubleStruckCapitalF]\)\/\(h\ ft\)\),
                    ShowStringCharacters->False,
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit]}]}], ",", 
            RowBox[{"h", "=", 
              RowBox[{"200", " ", 
                TagBox[
                  
                  StyleBox[\(\(BTU\ \[DoubleStruckCapitalF]\)\/\(h\ ft\^2\)\),
                    
                    ShowStringCharacters->False,
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit]}]}], ",", \(N\_Nu = \(h\ \[ScriptCapitalD]\)\/k\)}], 
          "}"}], "]"}], ";"}]], "Input",
  CellLabel->"In[199]:=",
  CellTags->"Dimensionless Numbers"],

Cell[BoxData[
    RowBox[{
      TagBox["\[ScriptCapitalD]",
        HoldForm], "\[Equal]", 
      RowBox[{"0.038099999999999995`", " ", 
        TagBox[
          StyleBox["\<\"m\"\>",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}]}]], "Print",
  CellLabel->"From In[199]:=",
  CellTags->"Dimensionless Numbers"],

Cell[BoxData[
    RowBox[{
      TagBox["k",
        HoldForm], "\[Equal]", 
      RowBox[{"0.03739256261948739`", " ", 
        TagBox[
          StyleBox[\(\("kg"\ "m"\ "\[DoubleStruckCapitalK]"\)\/"s"\^3\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}]}]], "Print",
  CellLabel->"From In[199]:=",
  CellTags->"Dimensionless Numbers"],

Cell[BoxData[
    RowBox[{
      TagBox["h",
        HoldForm], "\[Equal]", 
      RowBox[{"350.5114606251160901812`3.221848749616356", " ", 
        TagBox[
          StyleBox[\(\("kg"\ "\[DoubleStruckCapitalK]"\)\/"s"\^3\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}]}]], "Print",
  CellLabel->"From In[199]:=",
  CellTags->"Dimensionless Numbers"],

Cell[BoxData[
    RowBox[{
      TagBox[\(N\_Nu\),
        HoldForm], "\[Equal]", "357.14285714285705`"}]], "Print",
  CellLabel->"From In[199]:=",
  CellTags->"Dimensionless Numbers"]
}, Closed]],

Cell[TextData[{
  "Example ",
  StyleBox["4.",
    FontWeight->"Bold"],
  " Calculation of a Grashof Number"
}], "MathCaption",
  CellTags->"Dimensionless Numbers"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{
      "\[ScriptCapitalP]\[ScriptR]\[ScriptI]\[ScriptN]\[ScriptT]", "[", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{"L", "=", 
              RowBox[{"3", " ", 
                TagBox[
                  StyleBox["ft",
                    ShowStringCharacters->False,
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit]}]}], ",", 
            RowBox[{"\[Rho]", "=", 
              RowBox[{"0.0725", " ", 
                TagBox[
                  StyleBox[\(lb\/ft\^3\),
                    ShowStringCharacters->False,
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit]}]}], ",", 
            RowBox[{"g", "=", 
              TagBox[
                StyleBox["g",
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}], ",", 
            RowBox[{"\[Beta]", "=", 
              RowBox[{"0.00168", " ", 
                TagBox[
                  StyleBox[\(1\/\[DoubleStruckCapitalR]\),
                    ShowStringCharacters->False,
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit]}]}], ",", 
            RowBox[{"\[CapitalDelta]T", "=", 
              RowBox[{"99", " ", 
                TagBox[
                  StyleBox["\[DoubleStruckCapitalR]",
                    ShowStringCharacters->False,
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit]}]}], ",", 
            RowBox[{"\[Mu]", "=", 
              RowBox[{"0.019", " ", 
                TagBox[
                  StyleBox[\(\[ScriptC]\ Poise\),
                    ShowStringCharacters->False,
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit]}]}], 
            ",", \(N\_Gr = \(L\^3\) \(\[Rho]\^2\) 
                g\ \[Beta]\ \[CapitalDelta]T/\[Mu]\^2\)}], "}"}], "]"}], 
      ";"}]], "Input",
  CellLabel->"In[200]:=",
  CellTags->"Dimensionless Numbers"],

Cell[BoxData[
    RowBox[{
      TagBox["L",
        HoldForm], "\[Equal]", 
      RowBox[{"0.9144000000000000001`3.6989700043360183", " ", 
        TagBox[
          StyleBox["\<\"m\"\>",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}]}]], "Print",
  CellLabel->"From In[200]:=",
  CellTags->"Dimensionless Numbers"],

Cell[BoxData[
    RowBox[{
      TagBox["\[Rho]",
        HoldForm], "\[Equal]", 
      RowBox[{"1.1613386061214843`", " ", 
        TagBox[
          StyleBox[\("kg"\/"m"\^3\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}]}]], "Print",
  CellLabel->"From In[200]:=",
  CellTags->"Dimensionless Numbers"],

Cell[BoxData[
    RowBox[{
      TagBox["g",
        HoldForm], "\[Equal]", 
      RowBox[{"9.80665`3.9999999999999996", " ", 
        TagBox[
          StyleBox[\("m"\/"s"\^2\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}]}]], "Print",
  CellLabel->"From In[200]:=",
  CellTags->"Dimensionless Numbers"],

Cell[BoxData[
    RowBox[{
      TagBox["\[Beta]",
        HoldForm], "\[Equal]", 
      RowBox[{"0.003024`", " ", 
        TagBox[
          StyleBox[\(1\/"\[DoubleStruckCapitalK]"\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}]}]], "Print",
  CellLabel->"From In[200]:=",
  CellTags->"Dimensionless Numbers"],

Cell[BoxData[
    RowBox[{
      TagBox["\[CapitalDelta]T",
        HoldForm], "\[Equal]", 
      RowBox[{"55.0000000000000000006`3.6989700043360183", " ", 
        TagBox[
          StyleBox["\<\"\[DoubleStruckCapitalK]\"\>",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}]}]], "Print",
  CellLabel->"From In[200]:=",
  CellTags->"Dimensionless Numbers"],

Cell[BoxData[
    RowBox[{
      TagBox["\[Mu]",
        HoldForm], "\[Equal]", 
      RowBox[{"0.000019`", " ", 
        TagBox[
          StyleBox[\("kg"\/\("m"\ "s"\)\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}]}]], "Print",
  CellLabel->"From In[200]:=",
  CellTags->"Dimensionless Numbers"],

Cell[BoxData[
    RowBox[{
      TagBox[\(N\_Gr\),
        HoldForm], "\[Equal]", "4.658910087094511`*^9"}]], "Print",
  CellLabel->"From In[200]:=",
  CellTags->"Dimensionless Numbers"]
}, Closed]],

Cell[TextData[{
  "Example ",
  StyleBox["5.",
    FontWeight->"Bold"],
  " Calculation of a Schmidt Number"
}], "MathCaption",
  CellTags->"Dimensionless Numbers"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{
      "\[ScriptCapitalP]\[ScriptR]\[ScriptI]\[ScriptN]\[ScriptT]", "[", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{"\[Mu]", "=", 
              RowBox[{"0.02", " ", 
                TagBox[
                  StyleBox[\(\[ScriptC]\ Poise\),
                    ShowStringCharacters->False,
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit]}]}], ",", 
            RowBox[{"\[Rho]", "=", 
              RowBox[{"0.08", " ", 
                TagBox[
                  StyleBox[\(lb\/ft\^3\),
                    ShowStringCharacters->False,
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit]}]}], ",", 
            RowBox[{"\[ScriptD]", "=", 
              RowBox[{"1.", " ", 
                TagBox[
                  StyleBox[\(ft\^2\/h\),
                    ShowStringCharacters->False,
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit]}]}], ",", \(N\_Sc = \[Mu]\/\(\[Rho]\ \[ScriptD]\)\)}],
           "}"}], "]"}], ";"}]], "Input",
  CellLabel->"In[201]:=",
  CellTags->"Dimensionless Numbers"],

Cell[BoxData[
    RowBox[{
      TagBox["\[Mu]",
        HoldForm], "\[Equal]", 
      RowBox[{"0.00002`", " ", 
        TagBox[
          StyleBox[\("kg"\/\("m"\ "s"\)\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}]}]], "Print",
  CellLabel->"From In[201]:=",
  CellTags->"Dimensionless Numbers"],

Cell[BoxData[
    RowBox[{
      TagBox["\[Rho]",
        HoldForm], "\[Equal]", 
      RowBox[{"1.2814770826168103`", " ", 
        TagBox[
          StyleBox[\("kg"\/"m"\^3\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}]}]], "Print",
  CellLabel->"From In[201]:=",
  CellTags->"Dimensionless Numbers"],

Cell[BoxData[
    RowBox[{
      TagBox["\[ScriptD]",
        HoldForm], "\[Equal]", 
      RowBox[{"0.00002580639999999999`", " ", 
        TagBox[
          StyleBox[\("m"\^2\/"s"\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}]}]], "Print",
  CellLabel->"From In[201]:=",
  CellTags->"Dimensionless Numbers"],

Cell[BoxData[
    RowBox[{
      TagBox[\(N\_Sc\),
        HoldForm], "\[Equal]", "0.6047720716320003`"}]], "Print",
  CellLabel->"From In[201]:=",
  CellTags->"Dimensionless Numbers"]
}, Closed]],

Cell[TextData[{
  "Example ",
  StyleBox["6.",
    FontWeight->"Bold"],
  " Calculation of a ",
  "Archimedes",
  " Number"
}], "MathCaption",
  CellTags->"Dimensionless Numbers"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{
      "\[ScriptCapitalP]\[ScriptR]\[ScriptI]\[ScriptN]\[ScriptT]", "[", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{"d", "=", 
              RowBox[{"2", " ", 
                TagBox[
                  StyleBox[\(\[ScriptM]\ m\),
                    ShowStringCharacters->False,
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit]}]}], ",", 
            RowBox[{\(\[Rho]\_f\), "=", 
              RowBox[{"0.0175", " ", 
                TagBox[
                  StyleBox[\(lb\/ft\^3\),
                    ShowStringCharacters->False,
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit]}]}], ",", 
            RowBox[{\(\[Rho]\_p\), "=", 
              RowBox[{"168.5", " ", 
                TagBox[
                  StyleBox[\(lb\/ft\^3\),
                    ShowStringCharacters->False,
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit]}]}], ",", 
            RowBox[{"g", "=", 
              TagBox[
                StyleBox["g",
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit]}], ",", 
            RowBox[{"\[Mu]", "=", 
              RowBox[{"0.04", " ", 
                TagBox[
                  StyleBox[\(\[ScriptC]\ Poise\),
                    ShowStringCharacters->False,
                    FontSlant->"Plain",
                    FontColor->GrayLevel[0.500008]],
                  Unit]}]}], 
            ",", \(N\_Ar = \(\(d\^3\) \(\[Rho]\_f\) \((\[Rho]\_p - \[Rho]\_f)\
\) g\)\/\[Mu]\^2\)}], "}"}], "]"}], ";"}]], "Input",
  CellLabel->"In[202]:=",
  CellTags->"Dimensionless Numbers"],

Cell[BoxData[
    RowBox[{
      TagBox["d",
        HoldForm], "\[Equal]", 
      RowBox[{"0.002`3.698970004336018", " ", 
        TagBox[
          StyleBox["\<\"m\"\>",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}]}]], "Print",
  CellLabel->"From In[202]:=",
  CellTags->"Dimensionless Numbers"],

Cell[BoxData[
    RowBox[{
      TagBox[\(\[Rho]\_f\),
        HoldForm], "\[Equal]", 
      RowBox[{"0.2803231118224273`", " ", 
        TagBox[
          StyleBox[\("kg"\/"m"\^3\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}]}]], "Print",
  CellLabel->"From In[202]:=",
  CellTags->"Dimensionless Numbers"],

Cell[BoxData[
    RowBox[{
      TagBox[\(\[Rho]\_p\),
        HoldForm], "\[Equal]", 
      RowBox[{"2699.1111052616566`", " ", 
        TagBox[
          StyleBox[\("kg"\/"m"\^3\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}]}]], "Print",
  CellLabel->"From In[202]:=",
  CellTags->"Dimensionless Numbers"],

Cell[BoxData[
    RowBox[{
      TagBox["g",
        HoldForm], "\[Equal]", 
      RowBox[{"9.80665`3.9999999999999996", " ", 
        TagBox[
          StyleBox[\("m"\/"s"\^2\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}]}]], "Print",
  CellLabel->"From In[202]:=",
  CellTags->"Dimensionless Numbers"],

Cell[BoxData[
    RowBox[{
      TagBox["\[Mu]",
        HoldForm], "\[Equal]", 
      RowBox[{"0.00004`", " ", 
        TagBox[
          StyleBox[\("kg"\/\("m"\ "s"\)\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}]}]], "Print",
  CellLabel->"From In[202]:=",
  CellTags->"Dimensionless Numbers"],

Cell[BoxData[
    RowBox[{
      TagBox[\(N\_Ar\),
        HoldForm], "\[Equal]", "37095.84262296955`"}]], "Print",
  CellLabel->"From In[202]:=",
  CellTags->"Dimensionless Numbers"]
}, Closed]],

Cell["This compare the results with given numbers in the book", "MathCaption",
  CellTags->"Dimensionless Numbers"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{\({N\_Re - 11904, N\_Pr - 262.4, N\_Nu - 357.1, 
        N\_Gr - 4.66\ 10\^9, N\_Sc - 0.605, N\_Ar - 37064}\), Cell[
      ""]}]], "Input",
  CellLabel->"In[203]:=",
  CellTags->"Dimensionless Numbers"],

Cell[BoxData[
    \({1.3116665432862646`, \(-0.021962768886169215`\), 
      0.042857142857030794`, \(-1.089912905488968`*^6\), \
\(-0.00022792836799967464`\), 31.842622969546937`}\)], "Output",
  CellLabel->"Out[203]=",
  CellTags->"Dimensionless Numbers"]
}, Closed]],

Cell[BoxData[
    \(\(SetOptions[Unit, N \[Rule] False];\)\)], "Input",
  CellLabel->"In[204]:=",
  CellTags->"Dimensionless Numbers"]
}, Closed]],

Cell[CellGroupData[{

Cell["Automatic convertions", "Subsubsection",
  CellTags->"Automatic convertions"],

Cell[TextData[{
  "\"",
  StyleBox["Automatic convertion",
    FontSlant->"Italic"],
  "\" meaning that under some manipulations (those that call ",
  Cell[BoxData[
      \(Unit\)]],
  " routines, for example), the unit is converted to default unit system \
stored in ",
  Cell[BoxData[
      \($Unit\)]]
}], "Text",
  CellTags->"Automatic convertions"],

Cell["These is a list containing some units", "MathCaption",
  CellTags->"Automatic convertions"],

Cell[CellGroupData[{

Cell[BoxData[
    \(X = {a\ Unit[N], f[x]\ Unit[N\ m], Unit[N/lb]}\)], "Input",
  CellLabel->"In[305]:=",
  FormatType->TraditionalForm,
  CellTags->"Automatic convertions"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"a", " ", 
          TagBox[
            StyleBox["\<\"N\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{\(f[x]\), " ", 
          TagBox[
            StyleBox["\<\"J\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        FractionBox[
          RowBox[{"11023113", " ", 
            TagBox[
              StyleBox[\("m"\/"s"\^2\),
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}], "5000000"]}], "}"}]], "Output",
  CellLabel->"Out[305]=",
  CellTags->"Automatic convertions"]
}, Closed]],

Cell["\<\
Some callings do automatic convertions to default unit system, others not\
\>", "MathCaption",
  CellTags->"Automatic convertions"],

Cell[CellGroupData[{

Cell[BoxData[
    \(UnitFPS[X] // N\)], "Input",
  CellLabel->"In[311]:=",
  CellTags->"Automatic convertions"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"0.2248090247334889`", " ", "a", " ", 
          TagBox[
            StyleBox["\<\"lbf\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"0.7375624171046226`", " ", \(f[x]\), " ", 
          RowBox[{"(", 
            TagBox[
              StyleBox[\("ft"\ "lbf"\),
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit], ")"}]}], ",", 
        RowBox[{"7.233013779527559`", " ", 
          TagBox[
            StyleBox[\("ft"\/"s"\^2\),
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Output",
  CellLabel->"Out[311]=",
  CellTags->"Automatic convertions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      FractionBox[
        RowBox[{\(UnitFPS[X]\), " ", 
          TagBox[
            StyleBox["m",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], 
        TagBox[
          StyleBox["cm",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]], "//", "N"}]], "Input",
  CellLabel->"In[310]:=",
  CellTags->"Automatic convertions"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"100.`", " ", "a", " ", 
          TagBox[
            StyleBox["\<\"N\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"100.00000000000001`", " ", \(f[x]\), " ", 
          TagBox[
            StyleBox["\<\"J\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"723.301377952756`", " ", 
          TagBox[
            StyleBox[\("ft"\/"s"\^2\),
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Output",
  CellLabel->"Out[310]=",
  CellTags->"Automatic convertions"]
}, Closed]],

Cell["\<\
This implementation is intended to operate at the input of units, and when \
some operations are doing with quantities that have units.\
\>", "Text",
  CellTags->"Automatic convertions"],

Cell["This unit is converted ", "MathCaption",
  CellTags->"Automatic convertions"],

Cell[CellGroupData[{

Cell[BoxData[
    \(12\ Unit[Yard]\)], "Input",
  CellLabel->"In[209]:=",
  CellTags->"Automatic convertions"],

Cell[BoxData[
    FractionBox[
      RowBox[{"6858", " ", 
        TagBox[
          StyleBox["\<\"m\"\>",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}], "625"]], "Output",
  CellLabel->"Out[209]=",
  CellTags->"Automatic convertions"]
}, Closed]],

Cell["but this other not", "MathCaption",
  CellTags->"Automatic convertions"],

Cell[CellGroupData[{

Cell[BoxData[
    \(12\ Unit["\<Yard\>"]\)], "Input",
  CellLabel->"In[210]:=",
  CellTags->"Automatic convertions"],

Cell[BoxData[
    RowBox[{"12", " ", 
      TagBox[
        StyleBox["\<\"Yard\"\>",
          ShowStringCharacters->False,
          FontSlant->"Plain",
          FontColor->GrayLevel[0.500008]],
        Unit]}]], "Output",
  CellLabel->"Out[210]=",
  CellTags->"Automatic convertions"]
}, Closed]],

Cell[TextData[{
  "The \"",
  StyleBox["automatic",
    FontSlant->"Italic"],
  "\" convertion can be done with"
}], "MathCaption",
  CellTags->"Automatic convertions"],

Cell[CellGroupData[{

Cell[BoxData[
    \(12\ Unit["\<Yard\>"] // UnitSimplify\)], "Input",
  CellLabel->"In[211]:=",
  CellTags->"Automatic convertions"],

Cell[BoxData[
    FractionBox[
      RowBox[{"6858", " ", 
        TagBox[
          StyleBox["\<\"m\"\>",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}], "625"]], "Output",
  CellLabel->"Out[211]=",
  CellTags->"Automatic convertions"]
}, Closed]],

Cell["\<\
Unit package can do automatic convertions. This functionally is only provided \
to some pedagogical application, and consistency, but is not the form \
recomended to work with the package.\
\>", "Text",
  CellTags->"Automatic convertions"],

Cell["\<\
This option can force a Unit package to do automatics convertions\
\>", "MathCaption",
  CellTags->"Automatic convertions"],

Cell[BoxData[
    \(\(SetOptions[Unit, Automatic \[Rule] True];\)\)], "Input",
  CellLabel->"In[212]:=",
  CellTags->"Automatic convertions"],

Cell[TextData[{
  StyleBox["Warning",
    FontWeight->"Bold"],
  ": This option make ",
  Cell[BoxData[
      \(Unit\)]],
  " more slowly. Also, some functionalities of Unit package will be lost.\n\
Evrery unit is converted to the system stored in ",
  Cell[BoxData[
      \($Unit\)]]
}], "MathCaption",
  CellTags->"Automatic convertions"],

Cell[CellGroupData[{

Cell[BoxData[
    \({12\ Unit[Yard], 12\ Unit["\<Yard\>"]}\)], "Input",
  CellLabel->"In[213]:=",
  CellTags->"Automatic convertions"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        FractionBox[
          RowBox[{"6858", " ", 
            TagBox[
              StyleBox["\<\"m\"\>",
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}], "625"], ",", 
        FractionBox[
          RowBox[{"6858", " ", 
            TagBox[
              StyleBox["\<\"m\"\>",
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}], "625"]}], "}"}]], "Output",
  CellLabel->"Out[213]=",
  CellTags->"Automatic convertions"]
}, Closed]],

Cell["Some functionalities now are lost", "MathCaption",
  CellTags->"Automatic convertions"],

Cell[CellGroupData[{

Cell[BoxData[
    \(UnitFPS[X]\)], "Input",
  CellLabel->"In[214]:=",
  CellTags->"Automatic convertions"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"a", " ", 
          TagBox[
            StyleBox["\<\"N\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        FractionBox[
          RowBox[{"5243667312500001", " ", \(f[x]\), " ", 
            TagBox[
              StyleBox["\<\"J\"\>",
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}], "5243667312500000"], ",", 
        FractionBox[
          RowBox[{"11023113", " ", 
            TagBox[
              StyleBox[\("m"\/"s"\^2\),
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}], "5000000"]}], "}"}]], "Output",
  CellLabel->"Out[214]=",
  CellTags->"Automatic convertions"]
}, Closed]],

Cell["This restore the normal behavior", "MathCaption",
  CellTags->"Automatic convertions"],

Cell[BoxData[
    \(\(SetOptions[Unit, Automatic \[Rule] False];\)\)], "Input",
  CellLabel->"In[318]:=",
  CellTags->"Automatic convertions"],

Cell[BoxData[
    \(\(Clear[X];\)\)], "Input",
  CellLabel->"In[319]:=",
  CellTags->"Automatic convertions"]
}, Closed]],

Cell[CellGroupData[{

Cell["Precision", "Subsubsection",
  CellTags->"Precision"],

Cell[TextData[{
  "Usually, calculations involving units taken approximate numbers. By \
default, Unit package considerer unit quantities as exact numbers. The option \
",
  Cell[BoxData[
      \(N \[Rule] True\)]],
  " make any numeric factor of a unit to be a ",
  Cell[BoxData[
      \(Real\)]],
  " number, applying ",
  Cell[BoxData[
      \(N\)]],
  ". The option ",
  Cell[BoxData[
      RowBox[{"N", "\[Rule]", 
        StyleBox["n",
          "MR"]}]]],
  " can control the precision of the results. (",
  Cell[BoxData[
      \(n\)]],
  " is really the second argument of ",
  Cell[BoxData[
      \(N[x, n]\)]],
  ". See ",
  ButtonBox["N",
    ButtonStyle->"RefGuideLink"],
  " help to learn how to use it)."
}], "Text",
  CellTags->"Precision"],

Cell["This is a list containing some units", "MathCaption",
  CellTags->"Precision"],

Cell[CellGroupData[{

Cell[BoxData[
    \(X = {3\ a\ Unit[N], f[x]\ Unit[N\ m], Unit[N/lb]}\)], "Input",
  CellLabel->"In[217]:=",
  FormatType->TraditionalForm,
  CellTags->"Precision"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"3", " ", "a", " ", 
          TagBox[
            StyleBox["\<\"N\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{\(f[x]\), " ", 
          TagBox[
            StyleBox["\<\"J\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        FractionBox[
          RowBox[{"11023113", " ", 
            TagBox[
              StyleBox[\("m"\/"s"\^2\),
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}], "5000000"]}], "}"}]], "Output",
  CellLabel->"Out[217]=",
  CellTags->"Precision"]
}, Closed]],

Cell["Usually, units calculus looks like this", "MathCaption",
  CellTags->"Precision"],

Cell[CellGroupData[{

Cell[BoxData[
    \(UnitFPS[X]\)], "Input",
  CellLabel->"In[218]:=",
  CellTags->"Precision"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        FractionBox[
          RowBox[{"50000", " ", "a", " ", 
            TagBox[
              StyleBox["\<\"lbf\"\>",
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}], "74137"], ",", 
        FractionBox[
          RowBox[{"61880511", " ", \(f[x]\), " ", 
            RowBox[{"(", 
              TagBox[
                StyleBox[\("ft"\ "lbf"\),
                  ShowStringCharacters->False,
                  FontSlant->"Plain",
                  FontColor->GrayLevel[0.500008]],
                Unit], ")"}]}], "83898677"], ",", 
        FractionBox[
          RowBox[{"3674371", " ", 
            TagBox[
              StyleBox[\("ft"\/"s"\^2\),
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit]}], "508000"]}], "}"}]], "Output",
  CellLabel->"Out[218]=",
  CellTags->"Precision"]
}, Closed]],

Cell[TextData[{
  "This option can force a Unit package to convert any factor of ",
  Cell[BoxData[
      \(Unit\)]],
  " in ",
  Cell[BoxData[
      \(Real\)]]
}], "MathCaption",
  CellTags->"Precision"],

Cell[BoxData[
    \(\(SetOptions[Unit, N \[Rule] True];\)\)], "Input",
  CellLabel->"In[219]:=",
  CellTags->"Precision"],

Cell[TextData[{
  StyleBox["Warning",
    FontWeight->"Bold"],
  ": This option make ",
  Cell[BoxData[
      \(Unit\)]],
  " more slowly."
}], "MathCaption",
  CellTags->"Precision"],

Cell[CellGroupData[{

Cell[BoxData[
    \(X\)], "Input",
  CellLabel->"In[220]:=",
  CellTags->"Precision"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"3.`", " ", "a", " ", 
          TagBox[
            StyleBox["\<\"N\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{\(f[x]\), " ", 
          TagBox[
            StyleBox["\<\"J\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"2.2046226`", " ", 
          TagBox[
            StyleBox[\("m"\/"s"\^2\),
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Output",
  CellLabel->"Out[220]=",
  CellTags->"Precision"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(UnitFPS[X]\)], "Input",
  CellLabel->"In[221]:=",
  CellTags->"Precision"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"0.6744270742004668`", " ", "a", " ", 
          TagBox[
            StyleBox["\<\"lbf\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"0.7375624171046226`", " ", \(f[x]\), " ", 
          RowBox[{"(", 
            TagBox[
              StyleBox[\("ft"\ "lbf"\),
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit], ")"}]}], ",", 
        RowBox[{"7.2330137795275595`", " ", 
          TagBox[
            StyleBox[\("ft"\/"s"\^2\),
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Output",
  CellLabel->"Out[221]=",
  CellTags->"Precision"]
}, Closed]],

Cell["This modify the precision of unit's coefficients", "MathCaption",
  CellTags->"Precision"],

Cell[BoxData[
    \(\(SetOptions[Unit, N \[Rule] 4];\)\)], "Input",
  CellLabel->"In[222]:=",
  CellTags->"Precision"],

Cell[CellGroupData[{

Cell[BoxData[
    \(X\)], "Input",
  CellLabel->"In[223]:=",
  CellTags->"Precision"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"3.`4.000000000000001", " ", "a", " ", 
          TagBox[
            StyleBox["\<\"N\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{\(f[x]\), " ", 
          TagBox[
            StyleBox["\<\"J\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{"2.2046226`4.000000000000002", " ", 
          TagBox[
            StyleBox[\("m"\/"s"\^2\),
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Output",
  CellLabel->"Out[223]=",
  CellTags->"Precision"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(UnitFPS[X]\)], "Input",
  CellLabel->"In[224]:=",
  CellTags->"Precision"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"0.6744270742004667035`3.698970004336019", " ", "a", " ", 
          TagBox[
            StyleBox["\<\"lbf\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        RowBox[{
        "0.7375624171046225199`3.999999999999999", " ", \(f[x]\), " ", 
          RowBox[{"(", 
            TagBox[
              StyleBox[\("ft"\ "lbf"\),
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit], ")"}]}], ",", 
        RowBox[{"7.2330137795275590552`3.698970004336019", " ", 
          TagBox[
            StyleBox[\("ft"\/"s"\^2\),
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}]}], "}"}]], "Output",
  CellLabel->"Out[224]=",
  CellTags->"Precision"]
}, Closed]],

Cell["This restore the normal behavior", "MathCaption",
  CellTags->"Precision"],

Cell[BoxData[
    \(\(SetOptions[Unit, N \[Rule] False];\)\)], "Input",
  CellLabel->"In[225]:=",
  CellTags->"Precision"],

Cell[BoxData[
    \(\(Clear[X];\)\)], "Input",
  CellLabel->"In[226]:=",
  CellTags->"Precision"]
}, Closed]],

Cell[CellGroupData[{

Cell["Format", "Subsubsection",
  CellTags->"Format"],

Cell[TextData[{
  Cell[BoxData[
      \(Unit\)]],
  " format can be changed. In theory, valid changes are valid options of the \
function ",
  ButtonBox["StyleBox",
    ButtonStyle->"RefGuideLink"],
  " (that's really a lot of chances, see ",
  Cell[BoxData[
      \(Options[StyleBox]\)]],
  ")."
}], "Text",
  CellTags->"Format"],

Cell[TextData[{
  "Change the ",
  Cell[BoxData[
      \(Unit\)]],
  " format, and see the result"
}], "MathCaption",
  CellTags->"Format"],

Cell[BoxData[
    \(\(SetOptions[Unit, 
        StyleBox \[Rule] {FontColor \[Rule] 
              RGBColor[0.5, 0.3, 0.1]}];\)\)], "Input",
  CellLabel->"In[227]:=",
  CellTags->"Format"],

Cell[CellGroupData[{

Cell[BoxData[
    \({3\ a\ Unit[N], f[x]\ Unit[N\ m], Unit[N\/lb]}\)], "Input",
  CellLabel->"In[228]:=",
  CellTags->"Format"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"3", " ", "a", " ", 
          TagBox[
            StyleBox["\<\"N\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->RGBColor[0.500008, 0.300008, 0.100008]],
            Unit]}], ",", 
        RowBox[{\(f[x]\), " ", 
          TagBox[
            StyleBox["\<\"J\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->RGBColor[0.500008, 0.300008, 0.100008]],
            Unit]}], ",", 
        FractionBox[
          RowBox[{"11023113", " ", 
            TagBox[
              StyleBox[\("m"\/"s"\^2\),
                ShowStringCharacters->False,
                FontSlant->"Plain",
                FontColor->RGBColor[0.500008, 0.300008, 0.100008]],
              Unit]}], "5000000"]}], "}"}]], "Output",
  CellLabel->"Out[228]=",
  CellTags->"Format"]
}, Closed]],

Cell["This restore the normal behavior", "MathCaption",
  CellTags->"Format"],

Cell[BoxData[
    \(\(SetOptions[Unit, 
        StyleBox \[Rule] {FontColor \[Rule] GrayLevel[0.5]}];\)\)], "Input",
  CellLabel->"In[229]:=",
  CellTags->"Format"]
}, Closed]],

Cell[CellGroupData[{

Cell["Setting up your unit system (FPS)", "Subsubsection",
  CellTags->"Setting up your unit system (FPS)"],

Cell["We go to define the system FPS, that is Feet-Pound-Second. ", "Text",
  CellTags->"Setting up your unit system (FPS)"],

Cell["First, clear some symbols", "MathCaption",
  CellTags->"Setting up your unit system (FPS)"],

Cell[BoxData[
    \(Unit[Set, All]; ClearAll[\[ScriptCapitalM], F, m, a, p];\)], "Input",
  CellLabel->"In[320]:=",
  FormatType->TraditionalForm,
  CellTags->"Setting up your unit system (FPS)"],

Cell["Clear the system FPS too", "MathCaption",
  CellTags->"Setting up your unit system (FPS)"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Unit[Unset, UnitFPS]\)], "Input",
  CellLabel->"In[321]:=",
  CellTags->"Setting up your unit system (FPS)"],

Cell[BoxData[
    \("UnitFPS system are cleared."\)], "Output",
  CellLabel->"Out[321]=",
  CellTags->"Setting up your unit system (FPS)"]
}, Closed]],

Cell[TextData[{
  "This list contain some definitions of the system ",
  Cell[BoxData[
      \(FPS\)]]
}], "MathCaption",
  CellTags->"Setting up your unit system (FPS)"],

Cell[BoxData[
    \(\(\[ScriptCapitalM] = {\[IndentingNewLine]{Base, Length, Foot, Feet, 
            ft}, \[IndentingNewLine]{Base, Mass, AvoirdupoisPound, Pound, 
            lb}, \[IndentingNewLine]{Base, Time, Second, 
            s}, \[IndentingNewLine]{Equivalence, m, 
            1250/381\ ft}, \[IndentingNewLine]{Equivalence, kg, 
            2.2046226\ lb}, \[IndentingNewLine]{Derived, Force, Poundforce, 
            lbf, 32.1740\ ft\ lb\ s\^\(-2\)}, \[IndentingNewLine]{Combined, 
            Energy, ft\ lb}};\)\)], "Input",
  CellLabel->"In[322]:=",
  FormatType->TraditionalForm,
  CellTags->"Setting up your unit system (FPS)"],

Cell[TextData[{
  "The symbols in ",
  Cell[BoxData[
      \(\[ScriptCapitalM]\)]],
  " must be \"clearing\". We can check this instance with"
}], "MathCaption",
  CellTags->"Setting up your unit system (FPS)"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Variables[\[ScriptCapitalM]]\)], "Input",
  CellLabel->"In[323]:=",
  CellTags->"Setting up your unit system (FPS)"],

Cell[BoxData[
    \({AvoirdupoisPound, Base, Combined, Derived, Energy, Equivalence, Feet, 
      Foot, Force, ft, kg, lb, lbf, Length, m, Mass, Pound, Poundforce, s, 
      Second, Time}\)], "Output",
  CellLabel->"Out[323]=",
  CellTags->"Setting up your unit system (FPS)"]
}, Closed]],

Cell["Also, we can wrapping all the symbols in a string, like", "MathCaption",
  CellTags->"Setting up your unit system (FPS)"],

Cell[BoxData[
    \(\({"\<Base\>", "\<Temperature\>", "\<Rankine\>", "\<\
\[DoubleStruckCapitalR]\>"};\)\)], "Input",
  CellLabel->"In[324]:=",
  FormatType->TraditionalForm,
  CellTags->"Setting up your unit system (FPS)"],

Cell[TextData[{
  "Calling ",
  Cell[BoxData[
      RowBox[{"Unit", "[", 
        RowBox[{"Set", ",", 
          StyleBox["sys",
            FontSlant->"Italic"], ",", 
          StyleBox["M",
            FontSlant->"Italic"]}], "]"}]]],
  " we do the followings assignaments"
}], "MathCaption",
  CellTags->"Setting up your unit system (FPS)"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Unit[Set, fps, \[ScriptCapitalM]]\)], "Input",
  CellLabel->"In[325]:=",
  CellTags->"Setting up your unit system (FPS)"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"Rules for: fps\"\>", "\<\"\"\>"},
          {"\<\"--------------------- \"\>", "\<\"\"\>"},
          {"\<\"Unit[Base,fps]\"\>", "\<\"\\!\\({\\(\\(\\\"Length\\\" \[Rule] \
\\\"ft\\\"\\)\\), \\(\\(\\\"Mass\\\" \[Rule] \\\"lb\\\"\\)\\), \\(\\(\\\"Time\
\\\" \[Rule] \\\"s\\\"\\)\\)}\\)\"\>"},
          {"\<\"Unit[Derived,fps]\"\>", "\<\"\\!\\({\\\"lbf\\\" \[Rule] \
\\(32.174`\\\\ \\\"ft\\\"\\\\ \\\"lb\\\"\\)\\/\\\"s\\\"\\^2}\\)\"\>"},
          {"\<\"Unit[Combined,fps]\"\>", "\<\"\\!\\({\\\"Energy\\\" \[Rule] \
\\(\\(\\\"ft\\\"\\\\ \\\"lb\\\"\\)\\)}\\)\"\>"},
          {"\<\"Unit[Equivalence,fps]\"\>", "\<\"\\!\\({\\(\\(\\\"kg\\\" \
\[Rule] \\(\\(2.2046226`\\\\ \\\"lb\\\"\\)\\)\\)\\), \\(\\(\\\"m\\\" \[Rule] \
\\(1250\\\\ \\\"ft\\\"\\)\\/381\\)\\)}\\)\"\>"},
          {"\<\"Unit[Names,fps]\"\>", "\<\"\\!\\({\\(\\(\\\"Poundforce\\\" \
\[Rule] \\\"lbf\\\"\\)\\), \\(\\(\\\"Second\\\" \[Rule] \\\"s\\\"\\)\\), \
\\(\\(\\\"AvoirdupoisPound\\\" \[Rule] \\\"Pound\\\"\\)\\), \\(\\(\\\"Pound\\\
\" \[Rule] \\\"lb\\\"\\)\\), \\(\\(\\\"Foot\\\" \[Rule] \\\"Feet\\\"\\)\\), \
\\(\\(\\\"Feet\\\" \[Rule] \\\"ft\\\"\\)\\)}\\)\"\>"},
          {"\<\"Unit[Dimensions,fps]\"\>", "\<\"\\!\\({\\(\\(\\\"Energy\\\" \
\[Rule] \\(\\(\\\"ft\\\"\\\\ \\\"lb\\\"\\)\\)\\)\\), \\(\\(\\\"Force\\\" \
\[Rule] \\\"lbf\\\"\\)\\), \\(\\(\\\"Length\\\" \[Rule] \\\"ft\\\"\\)\\), \\(\
\\(\\\"Mass\\\" \[Rule] \\\"lb\\\"\\)\\), \\(\\(\\\"Time\\\" \[Rule] \
\\\"s\\\"\\)\\)}\\)\"\>"},
          {"\<\"--------------------- \"\>", "\<\"\"\>"},
          {"\<\"Avaibles Systems:\"\>", "\<\"\\!\\({fps, UnitCGS, UnitMKS}\\)\
\"\>"},
          {"\<\"Default System:\"\>", "\<\"\\!\\(fps\\)\"\>"},
          {"\<\"--------------------- \"\>", "\<\"\"\>"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ BoxForm`e$, TableAlignments -> Left]]]], "Output",
  CellLabel->"Out[325]//StandardForm=",
  CellTags->"Setting up your unit system (FPS)"]
}, Closed]],

Cell[TextData[{
  "This output is the same that generate ",
  Cell[BoxData[
      \(UnitI[fps]\)]],
  ". The meaning of ",
  Cell[BoxData[
      \(Base\)]],
  " and ",
  Cell[BoxData[
      \(Equivalence\)]],
  " are evident. In ",
  Cell[BoxData[
      \(Names\)]],
  " we store intermediate names of all units. The explaining of ",
  Cell[BoxData[
      \(Derived\)]],
  " and ",
  Cell[BoxData[
      \(Combine\)]],
  " are the follow."
}], "Text",
  CellTags->"Setting up your unit system (FPS)"],

Cell[TextData[{
  StyleBox["Derived",
    FontWeight->"Bold"],
  ". A derived unit is a unique symbol that represent a dimension. "
}], "Text",
  CellTags->"Setting up your unit system (FPS)"],

Cell["This quantity", "MathCaption",
  CellTags->"Setting up your unit system (FPS)"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(a = 36. \ Unit[cm\ s\^\(-2\)]; m = 200\ Unit[gr]; 
    v = 16\ Unit[cm\ s\^\(-1\)];\), "\[IndentingNewLine]", 
    \(P = m\ a\ v\)}], "Input",
  CellLabel->"In[326]:=",
  CellTags->"Setting up your unit system (FPS)"],

Cell[BoxData[
    RowBox[{"0.01152`", " ", 
      TagBox[
        StyleBox[\(\("kg"\ "m"\^2\)\/"s"\^3\),
          ShowStringCharacters->False,
          FontSlant->"Plain",
          FontColor->GrayLevel[0.500008]],
        Unit]}]], "Output",
  CellLabel->"Out[327]=",
  CellTags->"Setting up your unit system (FPS)"]
}, Closed]],

Cell["have dimensions", "MathCaption",
  CellTags->"Setting up your unit system (FPS)"],

Cell[CellGroupData[{

Cell[BoxData[
    \(UnitN[P]\)], "Input",
  CellLabel->"In[328]:=",
  CellTags->"Setting up your unit system (FPS)"],

Cell[BoxData[
    TagBox[
      StyleBox["\<\"Power\"\>",
        ShowStringCharacters->False,
        FontSlant->"Plain",
        FontColor->GrayLevel[0.500008]],
      Unit]], "Output",
  CellLabel->"Out[328]=",
  CellTags->"Setting up your unit system (FPS)"]
}, Closed]],

Cell["The correct definition for FPS include", "MathCaption",
  CellTags->"Setting up your unit system (FPS)"],

Cell[BoxData[
    \(\(Unit[Set, 
        fps, {Derived, Power, Horsepower, HP, 
          550\ ft\ lbf\ s\^\(-1\)}];\)\)], "Input",
  CellLabel->"In[329]:=",
  CellTags->"Setting up your unit system (FPS)"],

Cell["Now, we obtain", "MathCaption",
  CellTags->"Setting up your unit system (FPS)"],

Cell[CellGroupData[{

Cell[BoxData[
    \(P = m\ a\ v\)], "Input",
  CellLabel->"In[330]:=",
  CellTags->"Setting up your unit system (FPS)"],

Cell[BoxData[
    RowBox[{"0.00001544857181172053`", " ", 
      TagBox[
        StyleBox["\<\"HP\"\>",
          ShowStringCharacters->False,
          FontSlant->"Plain",
          FontColor->GrayLevel[0.500008]],
        Unit]}]], "Output",
  CellLabel->"Out[330]=",
  CellTags->"Setting up your unit system (FPS)"]
}, Closed]],

Cell[TextData[{
  StyleBox["Combined",
    FontWeight->"Bold"],
  ". A combined unit is the ",
  StyleBox["form",
    FontSlant->"Italic"],
  " to represent a dimension."
}], "Text",
  CellTags->"Setting up your unit system (FPS)"],

Cell["This pressure", "MathCaption",
  CellTags->"Setting up your unit system (FPS)"],

Cell[CellGroupData[{

Cell[BoxData[
    \(p = \(m\ a\)\/\(9\ Unit[in\^2]\)\)], "Input",
  CellLabel->"In[331]:=",
  FormatType->TraditionalForm,
  CellTags->"Setting up your unit system (FPS)"],

Cell[BoxData[
    RowBox[{"12.4000248000496`", " ", 
      TagBox[
        StyleBox[\("kg"\/\("m"\ "s"\^2\)\),
          ShowStringCharacters->False,
          FontSlant->"Plain",
          FontColor->GrayLevel[0.500008]],
        Unit]}]], "Output",
  CellLabel->"Out[331]=",
  CellTags->"Setting up your unit system (FPS)"]
}, Closed]],

Cell[TextData[{
  "not is in the defined ",
  StyleBox["form",
    FontSlant->"Italic"],
  " for system FPS. We can do this with"
}], "MathCaption",
  CellTags->"Setting up your unit system (FPS)"],

Cell[BoxData[
    \(\(Unit[Set, fps, {Combined, Pressure, lbf\/in\^2}];\)\)], "Input",
  CellLabel->"In[332]:=",
  CellTags->"Setting up your unit system (FPS)"],

Cell[TextData[{
  "The ",
  StyleBox["form",
    FontSlant->"Italic"],
  " of pressure is now correct"
}], "MathCaption",
  CellTags->"Setting up your unit system (FPS)"],

Cell[CellGroupData[{

Cell[BoxData[
    \(p = \(m\ a\)\/\(9\ Unit[in\^2]\)\)], "Input",
  CellLabel->"In[333]:=",
  FormatType->TraditionalForm,
  CellTags->"Setting up your unit system (FPS)"],

Cell[BoxData[
    RowBox[{"0.001798472197867911`", " ", 
      TagBox[
        StyleBox[\("lbf"\/"in"\^2\),
          ShowStringCharacters->False,
          FontSlant->"Plain",
          FontColor->GrayLevel[0.500008]],
        Unit]}]], "Output",
  CellLabel->"Out[333]=",
  CellTags->"Setting up your unit system (FPS)"]
}, Closed]],

Cell[TextData[{
  "The system ",
  Cell[BoxData[
      \(FPS\)]],
  " is more complete "
}], "MathCaption",
  CellTags->"Setting up your unit system (FPS)"],

Cell[CellGroupData[{

Cell[BoxData[
    \(UnitI[fps]\)], "Input",
  CellLabel->"In[334]:=",
  CellTags->"Setting up your unit system (FPS)"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"Rules for: fps\"\>", "\<\"\"\>"},
          {"\<\"--------------------- \"\>", "\<\"\"\>"},
          {"\<\"Unit[Base,fps]\"\>", "\<\"\\!\\({\\(\\(\\\"Length\\\" \[Rule] \
\\\"ft\\\"\\)\\), \\(\\(\\\"Mass\\\" \[Rule] \\\"lb\\\"\\)\\), \\(\\(\\\"Time\
\\\" \[Rule] \\\"s\\\"\\)\\)}\\)\"\>"},
          {"\<\"Unit[Derived,fps]\"\>", "\<\"\\!\\({\\(\\(\\\"HP\\\" \[Rule] \
\\(\\(550\\\\ \\\"ft\\\"\\\\ \\\"lbf\\\"\\\\ \
\\(\\(\\\"Power\\\"[\\(\\(\\\"s\\\", \\(\\(-1\\)\\)\\)\\)]\\)\\)\\)\\)\\)\\), \
\\(\\(\\\"lbf\\\" \[Rule] \\(\\(32.174`\\\\ \\\"ft\\\"\\\\ \\\"lb\\\"\\\\ \\(\
\\(\\\"Power\\\"[\\(\\(\\\"s\\\", \\(\\(-2\\)\\)\\)\\)]\\)\\)\\)\\)\\)\\)}\\)\
\"\>"},
          {"\<\"Unit[Combined,fps]\"\>", "\<\"\\!\\({\\(\\(\\\"Energy\\\" \
\[Rule] \\(\\(\\\"ft\\\"\\\\ \\\"lb\\\"\\)\\)\\)\\), \\(\\(\\\"Pressure\\\" \
\[Rule] \\\"lbf\\\"\\/\\\"in\\\"\\^2\\)\\)}\\)\"\>"},
          {"\<\"Unit[Equivalence,fps]\"\>", "\<\"\\!\\({\\(\\(\\\"kg\\\" \
\[Rule] \\(\\(2.2046226`\\\\ \\\"lb\\\"\\)\\)\\)\\), \\(\\(\\\"m\\\" \[Rule] \
\\(1250\\\\ \\\"ft\\\"\\)\\/381\\)\\)}\\)\"\>"},
          {"\<\"Unit[Names,fps]\"\>", "\<\"\\!\\({\\(\\(\\\"Horsepower\\\" \
\[Rule] \\\"HP\\\"\\)\\), \\(\\(\\\"Poundforce\\\" \[Rule] \\\"lbf\\\"\\)\\), \
\\(\\(\\\"AvoirdupoisPound\\\" \[Rule] \\\"Pound\\\"\\)\\), \\(\\(\\\"Pound\\\
\" \[Rule] \\\"lb\\\"\\)\\), \\(\\(\\\"Foot\\\" \[Rule] \\\"Feet\\\"\\)\\), \
\\(\\(\\\"Feet\\\" \[Rule] \\\"ft\\\"\\)\\), \\(\\(\\\"Second\\\" \[Rule] \
\\\"s\\\"\\)\\)}\\)\"\>"},
          {"\<\"Unit[Dimensions,fps]\"\>", "\<\"\\!\\({\\(\\(\\\"Energy\\\" \
\[Rule] \\(\\(\\\"ft\\\"\\\\ \\\"lb\\\"\\)\\)\\)\\), \\(\\(\\\"Force\\\" \
\[Rule] \\\"lbf\\\"\\)\\), \\(\\(\\\"Length\\\" \[Rule] \\\"ft\\\"\\)\\), \\(\
\\(\\\"Mass\\\" \[Rule] \\\"lb\\\"\\)\\), \\(\\(\\\"Power\\\" \[Rule] \
\\\"HP\\\"\\)\\), \\(\\(\\\"Pressure\\\" \[Rule] \\\"lbf\\\"\\/\\\"in\\\"\\^2\
\\)\\), \\(\\(\\\"Time\\\" \[Rule] \\\"s\\\"\\)\\)}\\)\"\>"},
          {"\<\"--------------------- \"\>", "\<\"\"\>"},
          {"\<\"Avaibles Systems:\"\>", "\<\"\\!\\({fps, UnitCGS, UnitMKS}\\)\
\"\>"},
          {"\<\"Default System:\"\>", "\<\"\\!\\(fps\\)\"\>"},
          {"\<\"--------------------- \"\>", "\<\"\"\>"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ BoxForm`e$, TableAlignments -> Left]]]], "Output",
  CellLabel->"Out[334]//StandardForm=",
  CellTags->"Setting up your unit system (FPS)"]
}, Closed]],

Cell["Restore some things", "MathCaption",
  CellTags->"Setting up your unit system (FPS)"],

Cell[BoxData[
    \(\(Clear[\[ScriptCapitalM], F, m, a, p];\)\)], "Input",
  CellLabel->"In[335]:=",
  FormatType->TraditionalForm,
  CellTags->"Setting up your unit system (FPS)"],

Cell["If you make same mistake setting units, do", "MathCaption",
  CellTags->"Setting up your unit system (FPS)"],

Cell[BoxData[
    \(\(Unit[Set, All];\)\)], "Input",
  CellLabel->"In[336]:=",
  CellTags->"Setting up your unit system (FPS)"]
}, Closed]],

Cell[CellGroupData[{

Cell["Managing units dimensions", "Subsubsection",
  CellTags->"Managing units dimensions"],

Cell[TextData[{
  "Units dimensions are stored in an special \"unit system\", called ",
  Cell[BoxData[
      \(UnitDIM\)]],
  ", that have some functionalities closed than other untis systems.  We \
assume in this section that ",
  Cell[BoxData[
      \(Time\)]],
  ", ",
  Cell[BoxData[
      \(Length\)]],
  ", etc are cleared symbols. (If not, wrapps all in strings)."
}], "Text",
  CellTags->"Managing units dimensions"],

Cell[BoxData[
    FormBox[GridBox[{
          {
            StyleBox["\<\"UnitDIM\"\>",
              "MR"], Cell[BoxData[
                \(TraditionalForm\`Symbol\ to\ refer\ dimensions\ names\ in\ \
Unit\ \(\(Package\)\(.\)\)\)]]}
          },
        ColumnAlignments->{Right, Left}], TraditionalForm]], "DefinitionBox",
  GridBoxOptions->{RowSpacings->0.4,
  RowLines->False},
  CellTags->"Managing units dimensions"],

Cell["We see that Farad times seconds do not have any special name", \
"MathCaption",
  CellTags->"Managing units dimensions"],

Cell[CellGroupData[{

Cell[BoxData[
    \(x = 15\ Unit[A\ C/N]\/Unit[m/s\^2]\)], "Input",
  CellLabel->"In[247]:=",
  CellTags->"Managing units dimensions"],

Cell[BoxData[
    RowBox[{"15", " ", 
      TagBox[
        StyleBox[\(\("A"\^2\ "s"\^5\)\/\("kg"\ "m"\^2\)\),
          ShowStringCharacters->False,
          FontSlant->"Plain",
          FontColor->GrayLevel[0.500008]],
        Unit]}]], "Output",
  CellLabel->"Out[247]=",
  CellTags->"Managing units dimensions"]
}, Closed]],

Cell["This set a new dimension", "MathCaption",
  CellTags->"Managing units dimensions"],

Cell[BoxData[
    \(\(Unit[Set, 
        UnitDIM, {Derived, 
          FTimesS, \(ElectricCurrent\^2\ Time\^5\)\/\(Length\^2\ \
Mass\)}];\)\)], "Input",
  CellLabel->"In[248]:=",
  CellTags->"Managing units dimensions"],

Cell[TextData[{
  "There are not any special form to the new dimension, but ",
  Cell[BoxData[
      \(UnitN\)]],
  " can recognize the new name"
}], "MathCaption",
  CellTags->"Managing units dimensions"],

Cell[CellGroupData[{

Cell[BoxData[
    \({x, UnitD[x], UnitN[x]}\)], "Input",
  CellLabel->"In[249]:=",
  CellTags->"Managing units dimensions"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"15", " ", 
          TagBox[
            StyleBox[\(\("A"\^2\ "s"\^5\)\/\("kg"\ "m"\^2\)\),
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        TagBox[
          
          StyleBox[\(\("ElectricCurrent"\^2\ "Time"\^5\)\/\("Length"\^2\ \
"Mass"\)\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit], ",", 
        TagBox[
          StyleBox["\<\"FTimesS\"\>",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}], "}"}]], "Output",
  CellLabel->"Out[249]=",
  CellTags->"Managing units dimensions"]
}, Closed]],

Cell[TextData[{
  "This set ",
  Cell[BoxData[
      \(FS\)]],
  " as special symbol for ",
  Cell[BoxData[
      \(FTimesS\)]]
}], "MathCaption",
  CellTags->"Managing units dimensions"],

Cell[BoxData[
    \(\(Unit[Set, 
        UnitMKS, {Derived, FTimesS, 
          FS, \(A\^2\ s\^5\)\/\(kg\ m\^2\)}];\)\)], "Input",
  CellLabel->"In[250]:=",
  CellTags->"Managing units dimensions"],

Cell["Now we have a good output for all", "MathCaption",
  CellTags->"Managing units dimensions"],

Cell[CellGroupData[{

Cell[BoxData[
    \({x = 15\ Unit[A\ C/N]\/Unit[m/s\^2], UnitD[x], UnitN[x]}\)], "Input",
  CellLabel->"In[251]:=",
  CellTags->"Managing units dimensions"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"15", " ", 
          TagBox[
            StyleBox["\<\"FS\"\>",
              ShowStringCharacters->False,
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit]}], ",", 
        TagBox[
          
          StyleBox[\(\("ElectricCurrent"\^2\ "Time"\^5\)\/\("Length"\^2\ \
"Mass"\)\),
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit], ",", 
        TagBox[
          StyleBox["\<\"FTimesS\"\>",
            ShowStringCharacters->False,
            FontSlant->"Plain",
            FontColor->GrayLevel[0.500008]],
          Unit]}], "}"}]], "Output",
  CellLabel->"Out[251]=",
  CellTags->"Managing units dimensions"]
}, Closed]],

Cell["If you make same mistake setting units, do", "MathCaption",
  CellTags->"Managing units dimensions"],

Cell[BoxData[
    \(\(Unit[Set, All];\)\)], "Input",
  CellLabel->"In[252]:=",
  CellTags->"Managing units dimensions"]
}, Closed]],

Cell[CellGroupData[{

Cell["Notations", "Subsubsection",
  CellTags->"Notations"],

Cell["Clear something", "Text",
  CellTags->"Notations"],

Cell[BoxData[
    \(\(Clear[\[ScriptCapitalP]\[ScriptR]\[ScriptI]\[ScriptN]\[ScriptT], \
\[Alpha], \[Beta], m, t, x, v, a, F];\)\)], "Input",
  CellLabel->"In[253]:=",
  CellTags->"Notations"],

Cell["An utility function.", "Text",
  CellTags->"Notations"],

Cell[BoxData[{
    \(\(SetAttributes[\[ScriptCapitalP]\[ScriptR]\[ScriptI]\[ScriptN]\
\[ScriptT], {HoldAll, Listable}];\)\), "\n", 
    \(\(\[ScriptCapitalP]\[ScriptR]\[ScriptI]\[ScriptN]\[ScriptT][
          f : \((Set | SetDelayed)\)[x_, y_]] := \[IndentingNewLine]\((Print[
            HoldForm@x \[Equal] y]; 
          Evaluate[f[x, y]];)\);\)\), "\[IndentingNewLine]", 
    \(\(\[ScriptCapitalP]\[ScriptR]\[ScriptI]\[ScriptN]\[ScriptT][x_, 
          y_: \((Simplify[N[#, 2]] &)\)] := \[IndentingNewLine]Print[
          HoldForm@x \[Equal] y[x]];\)\)}], "Input",
  CellLabel->"In[254]:=",
  CellTags->"Notations"],

Cell[TextData[{
  "Remove the defined notation for ",
  Cell[BoxData[
      \(Unit\)]]
}], "Text",
  CellTags->"Notations"],

Cell[BoxData[{
    \(\(Unprotect[Unit];\)\), "\[IndentingNewLine]", 
    \(\(FormatValues@Unit = {};\)\), "\[IndentingNewLine]", 
    \(\(Protect[Unit];\)\)}], "Input",
  CellLabel->"In[257]:=",
  CellTags->"Notations"],

Cell[TextData[{
  "With ",
  Cell[BoxData[
      \(Notation\)]],
  " package"
}], "Text",
  CellTags->"Notations"],

Cell[BoxData[{
    \(\(Utilities`Notation`AutoLoadNotationPalette\  = \ 
        False;\)\), "\[IndentingNewLine]", 
    \(\(Needs["\<Utilities`Notation`\>"];\)\)}], "Input",
  CellLabel->"In[260]:=",
  CellTags->"Notations"],

Cell[TextData[{
  "we can define the notations for for ",
  Cell[BoxData[
      \(Unit[u]\)]],
  " with the secuence ",
  Cell[BoxData[
      \("u\[ControlKey]\[LeftModified]-\[RightModified].\[ControlKey]\
\[LeftModified]\[SpaceIndicator]\[RightModified]"\)]]
}], "Text",
  CellTags->"Notations"],

Cell[BoxData[
    RowBox[{
      RowBox[{"Notation", "[", 
        RowBox[{
          TagBox[\(u_\_ . \),
            NotationBoxTag,
            TagStyle->"NotationTemplateStyle"], "\[DoubleLongLeftRightArrow]",
           
          TagBox[\(Unit[u_]\),
            NotationBoxTag,
            TagStyle->"NotationTemplateStyle"]}], "]"}], ";"}]], "Input",
  CellLabel->"In[262]:=",
  CellTags->"Notations"],

Cell["Now", "Text",
  CellTags->"Notations"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\[ScriptCapitalP]\[ScriptR]\[ScriptI]\[ScriptN]\[ScriptT]@{{\[Alpha], \
\[Beta], m} = {9\ \(\(m\/\@s\)\_ . \), \(\(-4\)\ 10\^\(-4\)\)\/\(s\_ . \), 
              5\ \(kg\_ . \)}, \[IndentingNewLine]v[
              t_] = \(\[Alpha]\ \[ExponentialE]\^\(\(-\[Beta]\)\ t\)\)\/\@t, 
          v[t\ \(min\_ . \)], \[IndentingNewLine]x[
              t_] = \[Integral]\_0\%t v[u] \[DifferentialD]u, 
          x[t\ \(min\_ . \)], \[IndentingNewLine]a[t_] = \[PartialD]\_t v[t], 
          a[t\ \(min\_ . \)], \[IndentingNewLine]F[t_] = m\ a[t], 
          F[t\ \(min\_ . \)]};\)\)], "Input",
  CellLabel->"In[263]:=",
  CellTags->"Notations"],

Cell[BoxData[
    RowBox[{
      TagBox[\({\[Alpha], \[Beta], m}\),
        HoldForm], 
      "\[Equal]", \({9\ \(\("m"\/\@"s"\)\_ . \), \(-\(\("Hz"\_ . \
\)\/2500\)\), 5\ \("kg"\_ . \)}\)}]], "Print",
  CellLabel->"From In[263]:=",
  CellTags->"Notations"],

Cell[BoxData[
    RowBox[{
      TagBox[\(v[t_]\),
        HoldForm], 
      "\[Equal]", \(\(9\ \[ExponentialE]\^\(\(t\ \("Hz"\_ . \)\)\/2500\)\ \
\(\("m"\/\@"s"\)\_ . \)\)\/\@t\)}]], "Print",
  CellLabel->"From In[263]:=",
  CellTags->"Notations"],

Cell[BoxData[
    RowBox[{
      TagBox[\(v[t\ \(min\_ . \)]\),
        HoldForm], 
      "\[Equal]", \(\(1.1618950038622250656`2.000000000000001\ \
\[ExponentialE]\^\(0.0239999999999999993`1.6989700043360185\ t\)\ \
\(\("m"\/"s"\)\_ . \)\)\/\@t\)}]], "Print",
  CellLabel->"From In[263]:=",
  CellTags->"Notations"],

Cell[BoxData[
    RowBox[{
      TagBox[\(x[t_]\),
        HoldForm], 
      "\[Equal]", \(450\ \@\[Pi]\ Erfi[
          1\/50\ \@t\ \(\(1\/\@"s"\)\_ . \)]\ \("m"\_ . \)\)}]], "Print",
  CellLabel->"From In[263]:=",
  CellTags->"Notations"],

Cell[BoxData[
    RowBox[{
      TagBox[\(x[t\ \(min\_ . \)]\),
        HoldForm], 
      "\[Equal]", \(797.604232908`1.9999999999999998\ Erfi[
          0.1549193338482966754`1.9999999999999998\ \@t]\ \("m"\_ . \)\)}]], \
"Print",
  CellLabel->"From In[263]:=",
  CellTags->"Notations"],

Cell[BoxData[
    RowBox[{
      TagBox[\(a[t_]\),
        HoldForm], 
      "\[Equal]", \(\(9\ \[ExponentialE]\^\(\(t\ \("Hz"\_ . \)\)\/2500\)\ \
\(\("m"\/"s"\^\(3/2\)\)\_ . \)\)\/\(2500\ \@t\) - \(9\ \[ExponentialE]\^\(\(t\
\ \("Hz"\_ . \)\)\/2500\)\ \(\("m"\/\@"s"\)\_ . \)\)\/\(2\ t\^\(3/2\)\)\)}]], \
"Print",
  CellLabel->"From In[263]:=",
  CellTags->"Notations"],

Cell[BoxData[
    RowBox[{
      TagBox[\(a[t\ \(min\_ . \)]\),
        HoldForm], 
      "\[Equal]", \
\(\(\[ExponentialE]\^\(0.0239999999999999993`1.6989700043360185\ t\)\ \
\((\(-0.0096824583655185422`1.9999999999999998\) + 
                0.00046475800154489`1.9999999999999998\ t)\)\ \(\("m"\/"s"\^2\
\)\_ . \)\)\/t\^\(3/2\)\)}]], "Print",
  CellLabel->"From In[263]:=",
  CellTags->"Notations"],

Cell[BoxData[
    RowBox[{
      TagBox[\(F[t_]\),
        HoldForm], 
      "\[Equal]", \(5\ \("kg"\_ . \)\ \((\(9\ \[ExponentialE]\^\(\(t\ \
\("Hz"\_ . \)\)\/2500\)\ \(\("m"\/"s"\^\(3/2\)\)\_ . \)\)\/\(2500\ \@t\) - \
\(9\ \[ExponentialE]\^\(\(t\ \("Hz"\_ . \)\)\/2500\)\ \(\("m"\/\@"s"\)\_ . \)\
\)\/\(2\ t\^\(3/2\)\))\)\)}]], "Print",
  CellLabel->"From In[263]:=",
  CellTags->"Notations"],

Cell[BoxData[
    RowBox[{
      TagBox[\(F[t\ \(min\_ . \)]\),
        HoldForm], 
      "\[Equal]", \
\(\(\[ExponentialE]\^\(0.0239999999999999993`1.6989700043360185\ t\)\ \
\((\(-0.048412291827592711`1.6989700043360187\) + 
                0.0023237900077244502`1.6989700043360185\ t)\)\ \("N"\_ . \
\)\)\/t\^\(3/2\)\)}]], "Print",
  CellLabel->"From In[263]:=",
  CellTags->"Notations"]
}, Closed]],

Cell[TextData[{
  "have a very similar look that notation with ",
  Cell[BoxData[
      \(Format\)]],
  ", but is better at the time of input units with the keyboard. "
}], "Text",
  CellTags->"Notations"],

Cell[TextData[{
  "Another chance is (",
  Cell[BoxData[
      \(\(\(\[Cross]\& . \)\(u\)\) \[Rule] 
        "\[EscapeKey]cross\[EscapeKey] \[ControlKey]\[LeftModified]7\
\[RightModified].\[ControlKey]\[LeftModified]\[SpaceIndicator]\[RightModified]\
u"\)]],
  ")"
}], "Text",
  CellTags->"Notations"],

Cell[BoxData[{
    RowBox[{
      RowBox[{"Notation", "[", 
        RowBox[{
          TagBox[\(\(\[Cross]\& . \)\(u_\)\),
            NotationBoxTag,
            TagStyle->"NotationTemplateStyle"], "\[DoubleLongLeftRightArrow]",
           
          TagBox[\(Unit[u_]\),
            NotationBoxTag,
            TagStyle->"NotationTemplateStyle"]}], "]"}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"Notation", "[", 
        RowBox[{
          TagBox[\(a_\(\[Cross]\& . \)u_\),
            NotationBoxTag,
            TagStyle->"NotationTemplateStyle"], "\[DoubleLongLeftRightArrow]",
           
          TagBox[\(a_\ Unit[u_]\),
            NotationBoxTag,
            TagStyle->"NotationTemplateStyle"]}], "]"}], ";"}]}], "Input",
  CellLabel->"In[264]:=",
  CellTags->"Notations"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\[ScriptCapitalP]\[ScriptR]\[ScriptI]\[ScriptN]\[ScriptT][{{\[Alpha], \
\[Beta], m} = {9\(\[Cross]\& . \)\(m\/\@s\), \(-\(4\/10\^4\)\)\(\[Cross]\& . \
\)Hz, 5\(\[Cross]\& . \)kg}, \[IndentingNewLine]v[
              t_] = \(\[Alpha]\ \[ExponentialE]\^\(\(-\[Beta]\)\ t\)\)\/\@t, 
          v[t\(\[Cross]\& . \)min], \[IndentingNewLine]x[
              t_] = \[Integral]\_0\%t v[u] \[DifferentialD]u, 
          x[t\(\[Cross]\& . \)min], \[IndentingNewLine]a[
              t_] = \[PartialD]\_t v[t], 
          a[t\(\[Cross]\& . \)min], \[IndentingNewLine]F[t_] = m\ a[t], 
          F[t\(\[Cross]\& . \)min]}];\)\)], "Input",
  CellLabel->"In[266]:=",
  CellTags->"Notations"],

Cell[BoxData[
    RowBox[{
      TagBox[\({\[Alpha], \[Beta], m}\),
        HoldForm], 
      "\[Equal]", \({9\(\[Cross]\& . \)\("m"\/\@"s"\), \((\(-\(1\/2500\)\))\)\
\(\[Cross]\& . \)"Hz", 5\(\[Cross]\& . \)"kg"}\)}]], "Print",
  CellLabel->"From In[266]:=",
  CellTags->"Notations"],

Cell[BoxData[
    RowBox[{
      TagBox[\(v[t_]\),
        HoldForm], 
      "\[Equal]", \(\(\(9\ \[ExponentialE]\^\(\(t\/2500\)\(\[Cross]\& . \
\)"Hz"\)\)\/\@t\)\(\[Cross]\& . \)\("m"\/\@"s"\)\)}]], "Print",
  CellLabel->"From In[266]:=",
  CellTags->"Notations"],

Cell[BoxData[
    RowBox[{
      TagBox[\(v[t\(\[Cross]\& . \)min]\),
        HoldForm], 
      "\[Equal]", \(\(\(1.1618950038622250656`2.000000000000001\ \
\[ExponentialE]\^\(0.0239999999999999993`1.6989700043360185\ t\)\)\/\@t\)\(\
\[Cross]\& . \)\("m"\/"s"\)\)}]], "Print",
  CellLabel->"From In[266]:=",
  CellTags->"Notations"],

Cell[BoxData[
    RowBox[{
      TagBox[\(x[t_]\),
        HoldForm], 
      "\[Equal]", \(\((450\ \@\[Pi]\ Erfi[\(\@t\/50\)\(\[Cross]\& . \
\)\(1\/\@"s"\)])\)\(\[Cross]\& . \)"m"\)}]], "Print",
  CellLabel->"From In[266]:=",
  CellTags->"Notations"],

Cell[BoxData[
    RowBox[{
      TagBox[\(x[t\(\[Cross]\& . \)min]\),
        HoldForm], 
      "\[Equal]", \(\((797.604232908`1.9999999999999998\ Erfi[
              0.1549193338482966754`1.9999999999999998\ \@t])\)\(\[Cross]\& . \
\)"m"\)}]], "Print",
  CellLabel->"From In[266]:=",
  CellTags->"Notations"],

Cell[BoxData[
    RowBox[{
      TagBox[\(a[t_]\),
        HoldForm], 
      "\[Equal]", \(\(\(9\ \[ExponentialE]\^\(\(t\/2500\)\(\[Cross]\& . \
\)"Hz"\)\)\/\(2500\ \@t\)\)\(\[Cross]\& . \)\("m"\/"s"\^\(3/2\)\) - \(\(9\ \
\[ExponentialE]\^\(\(t\/2500\)\(\[Cross]\& . \)"Hz"\)\)\/\(2\ \
t\^\(3/2\)\)\)\(\[Cross]\& . \)\("m"\/\@"s"\)\)}]], "Print",
  CellLabel->"From In[266]:=",
  CellTags->"Notations"],

Cell[BoxData[
    RowBox[{
      TagBox[\(a[t\(\[Cross]\& . \)min]\),
        HoldForm], 
      "\[Equal]", \
\(\(\(\[ExponentialE]\^\(0.0239999999999999993`1.6989700043360185\ t\)\ \
\((\(-0.0096824583655185422`1.9999999999999998\) + 
                  0.00046475800154489`1.9999999999999998\ \
t)\)\)\/t\^\(3/2\)\)\(\[Cross]\& . \)\("m"\/"s"\^2\)\)}]], "Print",
  CellLabel->"From In[266]:=",
  CellTags->"Notations"],

Cell[BoxData[
    RowBox[{
      TagBox[\(F[t_]\),
        HoldForm], 
      "\[Equal]", \(\((5\ \((\(\(9\ \
\[ExponentialE]\^\(\(t\/2500\)\(\[Cross]\& . \)"Hz"\)\)\/\(2500\ \@t\)\)\(\
\[Cross]\& . \)\("m"\/"s"\^\(3/2\)\) - \(\(9\ \
\[ExponentialE]\^\(\(t\/2500\)\(\[Cross]\& . \)"Hz"\)\)\/\(2\ \
t\^\(3/2\)\)\)\(\[Cross]\& . \)\("m"\/\@"s"\))\))\)\(\[Cross]\& . \
\)"kg"\)}]], "Print",
  CellLabel->"From In[266]:=",
  CellTags->"Notations"],

Cell[BoxData[
    RowBox[{
      TagBox[\(F[t\(\[Cross]\& . \)min]\),
        HoldForm], 
      "\[Equal]", \
\(\(\(\[ExponentialE]\^\(0.0239999999999999993`1.6989700043360185\ t\)\ \
\((\(-0.048412291827592711`1.6989700043360187\) + 
                  0.0023237900077244502`1.6989700043360185\ \
t)\)\)\/t\^\(3/2\)\)\(\[Cross]\& . \)"N"\)}]], "Print",
  CellLabel->"From In[266]:=",
  CellTags->"Notations"]
}, Closed]],

Cell["\<\
This form have the advantage that units appears separates of the values, at \
the end.\
\>", "Text",
  CellTags->"Notations"],

Cell["Clear asigned variables", "Text",
  CellTags->"Notations"],

Cell[BoxData[
    \(\(Clear[\[ScriptCapitalP]\[ScriptR]\[ScriptI]\[ScriptN]\[ScriptT], \
\[Alpha], \[Beta], m, x, v, a, F];\)\)], "Input",
  CellLabel->"In[267]:=",
  CellTags->"Notations"],

Cell["This restaures Unit package", "Text",
  CellTags->"Notations"],

Cell[BoxData[{
    RowBox[{
      RowBox[{"RemoveNotation", "[", 
        RowBox[{
          TagBox[\(u_\_ . \),
            NotationBoxTag,
            TagStyle->"NotationTemplateStyle"], "\[DoubleLongLeftRightArrow]",
           
          TagBox[\(Unit[u_]\),
            NotationBoxTag,
            TagStyle->"NotationTemplateStyle"]}], "]"}], ";"}], "\n", 
    RowBox[{
      RowBox[{"RemoveNotation", "[", 
        RowBox[{
          TagBox[\(\(\[Cross]\& . \)\(u_\)\),
            NotationBoxTag,
            TagStyle->"NotationTemplateStyle"], "\[DoubleLongLeftRightArrow]",
           
          TagBox[\(Unit[u_]\),
            NotationBoxTag,
            TagStyle->"NotationTemplateStyle"]}], "]"}], ";"}], "\n", 
    RowBox[{
      RowBox[{"RemoveNotation", "[", 
        RowBox[{
          TagBox[\(a_\(\[Cross]\& . \)u_\),
            NotationBoxTag,
            TagStyle->"NotationTemplateStyle"], "\[DoubleLongLeftRightArrow]",
           
          TagBox[\(a_\ Unit[u_]\),
            NotationBoxTag,
            TagStyle->"NotationTemplateStyle"]}], "]"}], 
      ";"}], "\[IndentingNewLine]", \(Unit[Set, All];\)}], "Input",
  CellLabel->"In[268]:=",
  CellTags->"Notations"]
}, Closed]],

Cell[CellGroupData[{

Cell["Money", "Subsubsection",
  CellTags->"Money"],

Cell[TextData[{
  "Unit package don't provide (",
  StyleBox["yet",
    FontSlant->"Italic"],
  ") specials names for country's moneys. Only have the dimension ",
  Cell[BoxData[
      \(Money\)]],
  " and the symbol (string, really) ",
  Cell[BoxData[
      \($\)]],
  " to manage this \"entity\". Calculus with money looks nothing pretty"
}], "Text",
  CellTags->"Money"],

Cell[CellGroupData[{

Cell[BoxData[
    \(10\ Unit[$/V]\)], "Input",
  CellLabel->"In[272]:=",
  CellTags->"Money"],

Cell[BoxData[
    RowBox[{"10", " ", 
      TagBox[
        StyleBox[\(\("A"\ "s"\^3\ "$"\)\/\("kg"\ "m"\^2\)\),
          ShowStringCharacters->False,
          FontSlant->"Plain",
          FontColor->GrayLevel[0.500008]],
        Unit]}]], "Output",
  CellLabel->"Out[272]=",
  CellTags->"Money"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["To do ...", "Subsubsection",
  CellTags->"To do ..."],

Cell[TextData[{
  "Future versions of ",
  Cell[BoxData[
      \(Unit\)]],
  " may include"
}], "Text",
  CellTags->"To do ..."],

Cell["\<\
\[FilledSmallSquare] Full definition of International System. Thats include: \
\
\>", "Text",
  CellTags->"To do ..."],

Cell[TextData[{
  "\t",
  "\[EmptyVerySmallSquare] ",
  "Set up the chemical and thermodynamical molar units. Units like ",
  Cell[BoxData[
      \(kmol\)]],
  " have a very extensive use in technical chemistry and thermodynamics."
}], "Text",
  CellTags->"To do ..."],

Cell[TextData[{
  "\t\[EmptyVerySmallSquare] A full implementation of radians requires \
modificate basics ",
  StyleBox["Mathematica'",
    FontSlant->"Italic"],
  "s functions -this if we considerer that radians are not dimensionless. The \
problem is not ",
  Cell[BoxData[
      RowBox[{"y", "=", 
        RowBox[{"Cos", "[", 
          RowBox[{"x", " ", 
            InterpretationBox[
              StyleBox["rad",
                FontSlant->"Plain",
                FontColor->GrayLevel[0.500008]],
              Unit[ FE`Conversion`Private`rad]]}], "]"}]}]]],
  ", the problem is ",
  Cell[BoxData[
      RowBox[{"x", "=", 
        RowBox[{\(ArcCos[y]\), " ", 
          InterpretationBox[
            StyleBox["rad",
              FontSlant->"Plain",
              FontColor->GrayLevel[0.500008]],
            Unit[ FE`Conversion`Private`rad]]}]}]]],
  "."
}], "Text",
  CellTags->"To do ..."],

Cell["\<\
\t\[EmptyVerySmallSquare] A faster version of this package, with the chance \
to set SI as the only unit system and take out some utilities.\
\>", "Text",
  CellTags->"To do ..."],

Cell[TextData[{
  "\t\[EmptyVerySmallSquare] Inclusion of logarithmic scales, like ",
  Cell[BoxData[
      \(pH\)]],
  "."
}], "Text",
  CellTags->"To do ..."],

Cell["\<\
\[FilledSmallSquare] More utilities for managing dimensions. Thats include: \
Automatic recognition of new dimensions, lists of units by dimension name, \
etc.\
\>", "Text",
  CellTags->"To do ..."],

Cell[TextData[{
  "\[FilledSmallSquare] Implementation of automatic recognition of prefixes \
to input and output units,  maybe with the news  functions from ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " 5.1 to manipulate strings."
}], "Text",
  CellTags->"To do ..."],

Cell[TextData[{
  "\[FilledSmallSquare] Implementation of international moneys convertion, \
maybe with the new functions from ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " 5.1 to download chain taxes."
}], "Text",
  CellTags->"To do ..."],

Cell["\<\
\[FilledSmallSquare] Spanish documentation! (For me too!).\
\>", "Text",
  CellTags->"To do ..."]
}, Closed]],

Cell[CellGroupData[{

Cell["References", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->"References"],

Cell["\<\
\[FilledVerySmallSquare] A lot of Unit convertion values (and units names \
too) are taken from\
\>", "Text",
  CellTags->"References"],

Cell[TextData[{
  "\t",
  ButtonBox["Miscellaneous`Units`",
    ButtonStyle->"AddOnsLink"],
  ", \n\tby ",
  StyleBox["Stephen Wolfram",
    FontSlant->"Italic"],
  ", \n\tand with ",
  Cell[BoxData[
      \(Copyright\)]],
  ": ",
  StyleBox["Copyright 1987-2003, Wolfram Research, Inc",
    FontSlant->"Italic"],
  "."
}], "Text",
  CellTags->"References"],

Cell[TextData[{
  "\[FilledVerySmallSquare] The values of constants and almost symbols \
abreviations are taken from",
  StyleBox[": ",
    FontSlant->"Italic"]
}], "Text",
  CellTags->"References"],

Cell[TextData[StyleBox["\t\" Fundamental Physical Constants --- Complete \
Listing.  From:  http://physics.nist.gov/constants \"\n\t\" Source: Peter J. \
Mohr and Barry N. Taylor, CODATA Recommended Values of the  \"\n\t\"        \
Fundamental Physical Constants: 2002, \"\n\t\"        To be published. \"",
  FontSlant->"Italic"]], "Text",
  CellTags->"References"],

Cell["\<\
\[FilledVerySmallSquare] Some units values are taken from (an a very good \
reference for SI system too):\
\>", "Text",
  CellTags->"References"],

Cell[TextData[{
  "\t",
  StyleBox["\" Taylor, B. N.\"\n\t\"Guide for the Use of the International \
System of Units (SI).\" \n\t\" NIST Special Publication 811, 1995 Edition. \"\
\n\t\" http://physics.nist.gov/Document/sp811.pdf. \" ",
    FontSlant->"Italic"]
}], "Text",
  CellTags->"References"],

Cell[TextData[{
  "\[FilledVerySmallSquare] Units and ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " (apart of the online help) from"
}], "Text",
  CellTags->"References"],

Cell[TextData[{
  "\t",
  StyleBox["\" Eric Weisstein's world of physics. \"\n\t\" \
www.scienceworld.wolfram.com/physics/topics/UnitsandDimensionalAnalysis.html. \
\"",
    FontSlant->"Italic"]
}], "Text",
  CellTags->"References"],

Cell["\<\
An extensive practical use of units can find in\
\>", "Text"],

Cell[TextData[{
  "\t\"",
  StyleBox["Perry\[CloseCurlyQuote]s chemical engineers\[CloseCurlyQuote] \
handbook. \[LongDash] 7th ed. / prepared by a staff of specialists under the \
editorial direction of late editor Robert H. Perry : editor, Don W. Green : \
associate editor, James O\[CloseCurlyQuote]Hara Maloney. ISBN 0-07-049841-5",
    FontSlant->"Italic"],
  "\" "
}], "Text"],

Cell["published by ", "Text"],

Cell[TextData[{
  "\"",
  StyleBox["The McGraw-Hill Companies, Inc",
    FontSlant->"Italic"],
  "\" "
}], "Text"],

Cell["\[Copyright] 2004, Alvaro D\[IAcute]az Falconi", "Caption",
  CellTags->"References"]
}, Closed]]
}, Closed]]
},
FrontEndVersion->"5.0 for Microsoft Windows",
ScreenRectangle->{{0, 800}, {0, 547}},
AutoGeneratedPackage->Automatic,
WindowToolbars->{},
WindowSize->{565, 433},
WindowMargins->{{Automatic, 12}, {Automatic, -2}},
Visible->True,
IndexCreationOptions->{"Format"->"SectionReferences"},
ShowCellLabel->False,
InputAliases->{"intt"->RowBox[ {"\[Integral]", 
        RowBox[ {"\[SelectionPlaceholder]", 
          RowBox[ {"\[DifferentialD]", "\[Placeholder]"}]}]}], 
    "dintt"->RowBox[ {
        SubsuperscriptBox[ 
        "\[Integral]", "\[SelectionPlaceholder]", "\[Placeholder]"], 
        RowBox[ {"\[Placeholder]", 
          RowBox[ {"\[DifferentialD]", "\[Placeholder]"}]}]}], 
    "sumt"->RowBox[ {
        UnderoverscriptBox[ "\[Sum]", 
          RowBox[ {"\[SelectionPlaceholder]", "=", "\[Placeholder]"}], 
          "\[Placeholder]"], "\[Placeholder]"}], "prodt"->RowBox[ {
        UnderoverscriptBox[ "\[Product]", 
          RowBox[ {"\[SelectionPlaceholder]", "=", "\[Placeholder]"}], 
          "\[Placeholder]"], "\[Placeholder]"}], "dt"->RowBox[ {
        SubscriptBox[ "\[PartialD]", "\[Placeholder]"], " ", 
        "\[SelectionPlaceholder]"}], "notation"->RowBox[ {"Notation", "[", 
        RowBox[ {
          TagBox[ 
          "\[Placeholder]", NotationBoxTag, TagStyle -> 
            "NotationTemplateStyle"], " ", "\[DoubleLongLeftRightArrow]", " ",
           
          TagBox[ 
          "\[Placeholder]", NotationBoxTag, TagStyle -> 
            "NotationTemplateStyle"]}], "]"}], 
    "notation>"->RowBox[ {"Notation", "[", 
        RowBox[ {
          TagBox[ 
          "\[Placeholder]", NotationBoxTag, TagStyle -> 
            "NotationTemplateStyle"], " ", "\[DoubleLongRightArrow]", " ", 
          TagBox[ 
          "\[Placeholder]", NotationBoxTag, TagStyle -> 
            "NotationTemplateStyle"]}], "]"}], 
    "notation<"->RowBox[ {"Notation", "[", 
        RowBox[ {
          TagBox[ 
          "\[Placeholder]", NotationBoxTag, TagStyle -> 
            "NotationTemplateStyle"], " ", "\[DoubleLongLeftArrow]", " ", 
          TagBox[ 
          "\[Placeholder]", NotationBoxTag, TagStyle -> 
            "NotationTemplateStyle"]}], "]"}], 
    "symb"->RowBox[ {"Symbolize", "[", 
        TagBox[ 
        "\[Placeholder]", NotationBoxTag, TagStyle -> 
          "NotationTemplateStyle"], "]"}], 
    "infixnotation"->RowBox[ {"InfixNotation", "[", 
        RowBox[ {
          TagBox[ 
          "\[Placeholder]", NotationBoxTag, TagStyle -> 
            "NotationTemplateStyle"], ",", "\[Placeholder]"}], "]"}], 
    "addia"->RowBox[ {"AddInputAlias", "[", 
        RowBox[ {"\"\[Placeholder]\"", "\[Rule]", 
          TagBox[ 
          "\[Placeholder]", NotationBoxTag, TagStyle -> 
            "NotationTemplateStyle"]}], "]"}], 
    "pattwraper"->TagBox[ 
      "\[Placeholder]", NotationPatternTag, TagStyle -> 
        "NotationPatternWrapperStyle"], 
    "madeboxeswraper"->TagBox[ 
      "\[Placeholder]", NotationMadeBoxesTag, TagStyle -> 
        "NotationMadeBoxesWrapperStyle"]},
Magnification->1,
StyleDefinitions -> Notebook[{
  
  Cell[CellGroupData[{
  Cell["Style Definitions for On-line Help", "Subtitle"],
  
  Cell["\<\
These styles are carefully tuned for all aspects of the online help. It's \
recommended that they remain unchanged.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell["Style Environment Names", "Section"],
  
  Cell[StyleData[All, "Working"],
    PageWidth->WindowWidth,
    ShowCellBracket->False,
    CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
    ShowAutoStyles->False,
    ScriptMinSize->9],
  
  Cell[StyleData[All, "Brackets"],
    PageWidth->WindowWidth,
    ShowCellBracket->True,
    CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
    ShowAutoStyles->False,
    ScriptMinSize->9],
  
  Cell[StyleData[All, "Presentation"],
    PageWidth->WindowWidth,
    ShowCellBracket->False,
    CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
    ShowAutoStyles->False,
    ScriptMinSize->9],
  
  Cell[StyleData[All, "SlideShow"],
    PageWidth->WindowWidth,
    ScrollingOptions->{"PagewiseDisplay"->True},
    ShowCellBracket->False,
    ScriptMinSize->9],
  
  Cell[StyleData[All, "Printout"],
    PageWidth->PaperWidth,
    ShowCellBracket->False,
    ShowAutoStyles->False,
    ScriptMinSize->5,
    PrivateFontOptions->{"FontType"->"Outline"}],
  
  Cell[StyleData[All, "EnhancedPrintout"],
    PageWidth->PaperWidth,
    ShowCellBracket->True,
    ScriptMinSize->5,
    FontFamily->"Palatino",
    PrivateFontOptions->{"FontType"->"Outline"}],
  
  Cell[StyleData[All, "EnhancedPrintoutNonGray"],
    PageWidth->PaperWidth,
    ShowCellBracket->False,
    ScriptMinSize->5,
    FontFamily->"Palatino",
    PrivateFontOptions->{"FontType"->"Outline"}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Notebook Options", "Section"],
  
  Cell["\<\
  The options defined for the style below will be used at the Notebook level. \
 \
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Notebook"],
    PageHeaders->{{Cell[ 
            TextData[ {
              CounterBox[ "Page"]}], "PageNumber"], None, Cell[ 
            TextData[ {"Printed from the ", 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              " Help Browser"}], "PageHeader"]}, {Cell[ 
            TextData[ {"Printed from the ", 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              " Help Browser"}], "PageHeader"], None, Cell[ 
            TextData[ {
              CounterBox[ "Page"]}], "PageNumber"]}},
    PageFooters->{{None, Cell[ 
            
            TextData[ {
              "\[Copyright]1988-2003 Wolfram Research, Inc. All rights \
reserved."}], "PageFooter"], None}, {None, Cell[ 
            
            TextData[ {
              "\[Copyright]1988-2003 Wolfram Research, Inc. All rights \
reserved."}], "PageFooter"], None}},
    PageHeaderLines->{True, True},
    PageFooterLines->{True, True},
    PrintingOptions->{"FacingPages"->True},
    CellLabelAutoDelete->False,
    CellFrameLabelMargins->6,
    StyleMenuListing->None],
  
  Cell[StyleData["Notebook", "Printout"],
    PageHeaders->{{Cell[ 
            TextData[ {
              CounterBox[ "Page"]}], "PageNumber"], None, Cell[ 
            TextData[ {"Printed from the ", 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              " Help Browser"}], "PageHeader"]}, {Cell[ 
            TextData[ {"Printed from the ", 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              " Help Browser"}], "PageHeader"], None, Cell[ 
            TextData[ {
              CounterBox[ "Page"]}], "PageNumber"]}},
    PageFooters->{{None, Cell[ 
            
            TextData[ {
              "\[Copyright]1988-2003 Wolfram Research, Inc. All rights \
reserved."}], "PageFooter"], None}, {None, Cell[ 
            
            TextData[ {
              "\[Copyright]1988-2003 Wolfram Research, Inc. All rights \
reserved."}], "PageFooter"], None}},
    PageHeaderLines->{True, True},
    PageFooterLines->{True, True},
    PrintingOptions->{"FacingPages"->True}],
  
  Cell[StyleData["Notebook", "EnhancedPrintout"],
    PageFooters->{{None, None, None}, {None, None, None}},
    PageHeaderLines->{True, True},
    PageFooterLines->{False, False},
    PrintingOptions->{"PrintingMargins"->{{54, 54}, {36, 72}},
    "PageSize"->{594, 657},
    "PrintRegistrationMarks"->True,
    "FirstPageHeader"->False,
    "FacingPages"->True,
    "FirstPageFace"->Right}]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Headings", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Chapter"],
    CellFrame->{{0, 0}, {0.5, 0}},
    CellMargins->{{27, 27}, {10, 40}},
    CellGroupingRules->{"TitleGrouping", 0},
    PageBreakBelow->False,
    DefaultNewInlineCellStyle->"None",
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-.35999999999999999, \
-.10000000000000001}, {0, 0}}, BoxBaselineShift -> -.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm], "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm]},
    LanguageCategory->"NaturalLanguage",
    CounterIncrements->"Title",
    CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}, {
        "Subtitle", 0}, {"Subsubtitle", 0}},
    FontFamily->"Helvetica",
    FontSize->24,
    FontWeight->"Plain",
    FontColor->RGBColor[0.592157, 0.313726, 0.313726]],
  
  Cell[StyleData["Chapter", "Presentation"],
    FontSize->36],
  
  Cell[StyleData["Chapter", "Printout"],
    CellMargins->{{2, 10}, {6, 30}},
    FontSize->24],
  
  Cell[StyleData["Chapter", "EnhancedPrintout"],
    CellMargins->{{2, 10}, {6, 30}},
    FontFamily->"Frutiger 55 Roman",
    FontSize->24,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["Chapter", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 10}, {6, 30}},
    FontFamily->"Frutiger 55 Roman",
    FontSize->24]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Section"],
    CellMargins->{{27, 27}, {12, 18}},
    CellGroupingRules->{"SectionGrouping", 30},
    PageBreakBelow->False,
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-.35999999999999999, \
-.10000000000000001}, {0, 0}}, BoxBaselineShift -> -.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm], "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm]},
    CounterIncrements->"Section",
    FontFamily->"Helvetica",
    FontSize->20,
    FontWeight->"Bold",
    FontColor->RGBColor[0.592157, 0.313726, 0.313726]],
  
  Cell[StyleData["Section", "Presentation"],
    FontSize->30],
  
  Cell[StyleData["Section", "SlideShow"],
    CellFrame->{{0, 0}, {0, 0.5}},
    ShowCellBracket->False,
    CellMargins->{{0, 0}, {5, 0}},
    PageBreakBelow->False,
    CellFrameMargins->{{36, 36}, {Inherited, 15}},
    FontFamily->"Helvetica",
    FontSize->18,
    FontWeight->"Bold",
    FontColor->GrayLevel[1],
    Background->RGBColor[0.408011, 0.440726, 0.8]],
  
  Cell[StyleData["Section", "Printout"],
    CellMargins->{{2, 0}, {0, 18}},
    PageBreakBelow->False,
    FontSize->18],
  
  Cell[StyleData["Section", "EnhancedPrintout"],
    CellFrame->{{0, 0}, {0.5, 0}},
    CellMargins->{{2, 2}, {5, 30}},
    CellGroupingRules->{"SectionGrouping", 30},
    PageBreakBelow->False,
    CellFrameMargins->8,
    CounterIncrements->"Section",
    CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}},
    FontFamily->"Frutiger 65 Bold",
    FontSize->16,
    FontWeight->"Plain",
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["Section", "EnhancedPrintoutNonGray"],
    CellFrame->{{0, 0}, {0.5, 0}},
    CellMargins->{{2, Inherited}, {5, 30}},
    CellGroupingRules->{"SectionGrouping", 30},
    PageBreakBelow->False,
    CellFrameMargins->8,
    CounterIncrements->"Section",
    CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}},
    FontFamily->"Frutiger 65 Bold",
    FontSize->16,
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subsection"],
    CellDingbat->None,
    CellMargins->{{27, 27}, {0, 18}},
    CellElementSpacings->{"ClosedGroupTopMargin"->18},
    CellGroupingRules->{"SectionGrouping", 40},
    PageBreakBelow->False,
    CellFrameLabelMargins->6,
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-.35999999999999999, \
-.10000000000000001}, {0, 0}}, BoxBaselineShift -> -.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm], "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm]},
    FontFamily->"Helvetica",
    FontSize->16,
    FontWeight->"Bold",
    FontColor->RGBColor[0.592157, 0.313726, 0.313726]],
  
  Cell[StyleData["Subsection", "Presentation"],
    FontSize->24],
  
  Cell[StyleData["Subsection", "SlideShow"],
    CellDingbat->None,
    CellMargins->{{70, 0}, {4, 12}},
    FontSize->12],
  
  Cell[StyleData["Subsection", "Printout"],
    CellMargins->{{2, 0}, {5, 24}},
    FontSize->12],
  
  Cell[StyleData["Subsection", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {5, 20}},
    FontFamily->"Frutiger 65 Bold",
    FontSize->12,
    FontWeight->"Plain",
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["Subsection", "EnhancedPrintoutNonGray"],
    CellMargins->{{9, 0}, {5, 20}},
    FontFamily->"Frutiger 65 Bold",
    FontSize->12,
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subsubsection"],
    CellMargins->{{27, 27}, {0, 18}},
    CellElementSpacings->{"ClosedGroupTopMargin"->18},
    CellGroupingRules->{"SectionGrouping", 50},
    PageBreakBelow->False,
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-.35999999999999999, \
-.10000000000000001}, {0, 0}}, BoxBaselineShift -> -.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm], "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm]},
    FontFamily->"Helvetica",
    FontSize->12,
    FontWeight->"Bold",
    FontColor->RGBColor[0.592157, 0.313726, 0.313726]],
  
  Cell[StyleData["Subsubsection", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Subsubsection", "Printout"],
    CellMargins->{{2, 0}, {3, 8}},
    FontSize->10],
  
  Cell[StyleData["Subsubsection", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {3, 8}},
    FontFamily->"Frutiger 65 Bold",
    FontSize->10,
    FontWeight->"Plain",
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["Subsubsection", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {3, 8}},
    FontFamily->"Frutiger 65 Bold",
    FontSize->10,
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SubsubsectionColor"],
    CellMargins->{{27, 27}, {0, 18}},
    CellElementSpacings->{"ClosedGroupTopMargin"->18},
    CellGroupingRules->{"SectionGrouping", 50},
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-.35999999999999999, \
-.10000000000000001}, {0, 0}}, BoxBaselineShift -> -.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm], "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm]},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->12,
    FontWeight->"Bold",
    FontColor->RGBColor[0.297993, 0, 0.454994]],
  
  Cell[StyleData["SubsubsectionColor", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["SubsubsectionColor", "Printout"],
    CellMargins->{{2, 0}, {0, 18}},
    PageBreakBelow->False,
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SubsectionIcon"],
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{46, 27}, {0, 18}},
    CellElementSpacings->{"ClosedGroupTopMargin"->8},
    CellGroupingRules->{"SectionGrouping", 40},
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-.35999999999999999, \
-.10000000000000001}, {0, 0}}, BoxBaselineShift -> -.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm], "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm]},
    CounterIncrements->"Section",
    FontFamily->"Helvetica",
    FontSize->16,
    FontWeight->"Bold",
    FontColor->RGBColor[0.592157, 0.313726, 0.313726]],
  
  Cell[StyleData["SubsectionIcon", "Presentation"],
    FontSize->24],
  
  Cell[StyleData["SubsectionIcon", "Printout"],
    CellDingbat->"\[FilledSquare]",
    ShowGroupOpenCloseIcon->False,
    CellMargins->{{16, 0}, {0, 18}},
    PageBreakBelow->False,
    FontSize->14]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SubsubsectionIcon"],
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{46, 27}, {0, 8}},
    CellElementSpacings->{"ClosedGroupTopMargin"->4},
    CellGroupingRules->{"SectionGrouping", 50},
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-.35999999999999999, \
-.10000000000000001}, {0, 0}}, BoxBaselineShift -> -.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm], "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm]},
    CounterIncrements->"Subsection",
    CounterAssignments->{{"Subsubsection", 0}},
    FontFamily->"Helvetica",
    FontSize->12,
    FontWeight->"Bold",
    FontColor->RGBColor[0.592157, 0.313726, 0.313726]],
  
  Cell[StyleData["SubsubsectionIcon", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["SubsubsectionIcon", "Printout"],
    ShowGroupOpenCloseIcon->False,
    CellMargins->{{2, 0}, {0, 18}},
    PageBreakBelow->False,
    FontSize->10]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Text", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Text"],
    CellMargins->{{27, 27}, {0, 8}},
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-.35999999999999999, \
-.10000000000000001}, {0, 0}}, BoxBaselineShift -> -.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm], "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm]},
    ParagraphSpacing->{0, 8},
    FontSize->12],
  
  Cell[StyleData["Text", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Text", "SlideShow"],
    CellMargins->{{36, 24}, {4, 4}},
    Hyphenation->False,
    FontSize->14],
  
  Cell[StyleData["Text", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    Hyphenation->True,
    FontSize->10],
  
  Cell[StyleData["Text", "EnhancedPrintout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["Text", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["CompactText"],
    CellMargins->{{27, 27}, {0, 8}},
    ParagraphSpacing->{0, 0},
    StyleMenuListing->None,
    FontSize->10],
  
  Cell[StyleData["CompactText", "Presentation"],
    FontSize->15],
  
  Cell[StyleData["CompactText", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    Hyphenation->True,
    FontSize->8],
  
  Cell[StyleData["CompactText", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->8],
  
  Cell[StyleData["CompactText", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->8]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Compact12Text"],
    CellMargins->{{27, 27}, {0, 8}},
    ParagraphSpacing->{0, 0},
    StyleMenuListing->None],
  
  Cell[StyleData["Compact12Text", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Compact12Text", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    Hyphenation->True,
    FontSize->10],
  
  Cell[StyleData["Compact12Text", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["Compact12Text", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TextSans"],
    CellMargins->{{27, 27}, {0, 8}},
    CellHorizontalScrolling->True,
    ParagraphSpacing->{0, 8},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->10],
  
  Cell[StyleData["TextSans", "Presentation"],
    FontSize->15],
  
  Cell[StyleData["TextSans", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    Hyphenation->True,
    FontSize->8],
  
  Cell[StyleData["TextSans", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    Hyphenation->True,
    FontFamily->"Frutiger 55 Roman",
    FontSize->8],
  
  Cell[StyleData["TextSans", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    Hyphenation->True,
    FontFamily->"Frutiger 55 Roman",
    FontSize->8]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemizedText"],
    CellMargins->{{66, 4}, {4, 4}},
    LineSpacing->{1, 3},
    ParagraphIndent->-22,
    CounterIncrements->"ItemizedText",
    StyleMenuListing->None],
  
  Cell[StyleData["ItemizedText", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemizedText", "Printout"],
    CellMargins->{{16, 4}, {2, 4}},
    Hyphenation->True,
    FontSize->10],
  
  Cell[StyleData["ItemizedText", "EnhancedPrintout"],
    CellMargins->{{16, 4}, {2, 4}},
    Hyphenation->True,
    LineSpacing->{1, 1},
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["ItemizedText", "EnhancedPrintoutNonGray"],
    Hyphenation->True,
    LineSpacing->{1, 1},
    ParagraphIndent->-18,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemizedTextNote"],
    CellMargins->{{88, 4}, {4, 0}},
    LineSpacing->{1, 2},
    CounterIncrements->"Text",
    StyleMenuListing->None],
  
  Cell[StyleData["ItemizedTextNote", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemizedTextNote", "Printout"],
    CellMargins->{{34, 4}, {4, 1}},
    Hyphenation->True,
    FontSize->10],
  
  Cell[StyleData["ItemizedTextNote", "EnhancedPrintout"],
    CellMargins->{{39, 4}, {4, 1}},
    Hyphenation->True,
    LineSpacing->{1, 1},
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["ItemizedTextNote", "EnhancedPrintoutNonGray"],
    CellMargins->{{39, 4}, {4, 1}},
    Hyphenation->True,
    LineSpacing->{1, 1},
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["IndentedText"],
    CellMargins->{{66, 4}, {0, 6}},
    LineSpacing->{1, 3},
    CounterIncrements->"Text",
    StyleMenuListing->None],
  
  Cell[StyleData["IndentedText", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["IndentedText", "SlideShow"],
    CellMargins->{{80, 24}, {5, 5}},
    Hyphenation->False,
    FontSize->13],
  
  Cell[StyleData["IndentedText", "Printout"],
    CellMargins->{{16, 4}, {2, 4}},
    Hyphenation->True,
    FontSize->10],
  
  Cell[StyleData["IndentedText", "EnhancedPrintout"],
    CellMargins->{{39, Inherited}, {Inherited, Inherited}},
    Hyphenation->True,
    LineSpacing->{1, 1},
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["IndentedText", "EnhancedPrintoutNonGray"],
    Hyphenation->True,
    LineSpacing->{1, 1},
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemizedList"],
    CellMargins->{{58, 4}, {4, 4}},
    CellFrameLabels->{{Cell[ 
            TextData[ {
              StyleBox[ 
                CounterBox[ "ItemizedList"], "TB"], 
              StyleBox[ ".", "TB"]}], CellBaseline -> Baseline, CellSize -> {
            24, Inherited}, TextAlignment -> Right], Inherited}, {
        Inherited, Inherited}},
    LineSpacing->{1, 3},
    CounterIncrements->"ItemizedList",
    StyleMenuListing->None],
  
  Cell[StyleData["ItemizedList", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemizedList", "Printout"],
    CellMargins->{{9, 4}, {2, 4}},
    Hyphenation->True,
    FontSize->10],
  
  Cell[StyleData["ItemizedList", "EnhancedPrintout"],
    CellMargins->{{9, 4}, {2, 4}},
    Hyphenation->True,
    LineSpacing->{1, 1},
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["ItemizedList", "EnhancedPrintoutNonGray"],
    Hyphenation->True,
    LineSpacing->{1, 1},
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemizedSubList"],
    CellMargins->{{92, 4}, {4, 4}},
    CellFrameLabels->{{Cell[ 
            TextData[ {
              StyleBox[ 
                CounterBox[ "ItemizedSubList"], "TB"], 
              StyleBox[ ".", "TB"]}], CellBaseline -> Baseline, CellSize -> {
            24, Inherited}, TextAlignment -> Right], Inherited}, {
        Inherited, Inherited}},
    CounterIncrements->"ItemizedSubList",
    StyleMenuListing->None,
    CounterBoxOptions->{CounterFunction:>(Part[ 
        CharacterRange[ "a", "z"], #]&)}],
  
  Cell[StyleData["ItemizedSubList", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemizedSubList", "Printout"],
    CellMargins->{{34, 4}, {4, 1}},
    Hyphenation->True,
    FontSize->10],
  
  Cell[StyleData["ItemizedSubList", "EnhancedPrintout"],
    CellMargins->{{26, 4}, {2, 4}},
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["ItemizedSubList", "EnhancedPrintoutNonGray"],
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemizedSubListNote"],
    CellMargins->{{110, 4}, {4, 4}},
    CounterIncrements->"ItemizedSubList",
    StyleMenuListing->None,
    CounterBoxOptions->{CounterFunction:>(Part[ 
        CharacterRange[ "a", "z"], #]&)}],
  
  Cell[StyleData["ItemizedSubListNote", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemizedSubListNote", "Printout"],
    CellMargins->{{34, 4}, {4, 1}},
    Hyphenation->True,
    FontSize->10],
  
  Cell[StyleData["ItemizedSubListNote", "EnhancedPrintout"],
    CellMargins->{{56, 4}, {2, 4}},
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["ItemizedSubListNote", "EnhancedPrintoutNonGray"],
    CellMargins->{{48, 4}, {2, 4}},
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["BulletedList"],
    CellMargins->{{76, 4}, {4, 4}},
    CellFrameLabels->{{
      Cell[ "\[Bullet]", "BulletedList", CellBaseline -> Baseline], 
          Inherited}, {Inherited, Inherited}},
    LineSpacing->{1, 3},
    CounterIncrements->"BulletText",
    StyleMenuListing->None],
  
  Cell[StyleData["BulletedList", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["BulletedList", "Printout"],
    CellMargins->{{16, 4}, {4, 1}},
    Hyphenation->True,
    FontSize->10],
  
  Cell[StyleData["BulletedList", "EnhancedPrintout"],
    CellMargins->{{26, 4}, {2, 4}},
    Hyphenation->True,
    LineSpacing->{1, 1},
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["BulletedList", "EnhancedPrintoutNonGray"],
    Hyphenation->True,
    LineSpacing->{1, 1},
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ListNote"],
    CellMargins->{{88, 4}, {4, 0}},
    LineSpacing->{1, 2},
    CounterIncrements->"ListNote",
    StyleMenuListing->None],
  
  Cell[StyleData["ListNote", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ListNote", "Printout"],
    CellMargins->{{34, 4}, {4, 1}},
    Hyphenation->True,
    FontSize->10],
  
  Cell[StyleData["ListNote", "EnhancedPrintout"],
    CellMargins->{{39, 4}, {4, 1}},
    Hyphenation->True,
    LineSpacing->{1, 1},
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["ListNote", "EnhancedPrintoutNonGray"],
    CellMargins->{{39, 4}, {4, 1}},
    Hyphenation->True,
    LineSpacing->{1, 1},
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MathCaption"],
    CellFrame->{{0, 0}, {0, 0.5}},
    CellMargins->{{66, 12}, {2, 20}},
    PageBreakBelow->False,
    CellFrameMargins->{{8, 8}, {8, 2}},
    CellFrameColor->GrayLevel[0.700008],
    CellFrameLabelMargins->4,
    LineSpacing->{1, 1},
    ParagraphSpacing->{0, 8},
    FontColor->GrayLevel[0.2]],
  
  Cell[StyleData["MathCaption", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["MathCaption", "SlideShow"],
    ShowCellBracket->False,
    CellMargins->{{36, 36}, {6, 6}}],
  
  Cell[StyleData["MathCaption", "Printout"],
    CellMargins->{{9, 0}, {0, 14}},
    Hyphenation->True,
    FontSize->9,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["MathCaption", "EnhancedPrintout"],
    CellMargins->{{9, 0}, {0, 14}},
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->9,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["MathCaption", "EnhancedPrintoutNonGray"],
    CellMargins->{{9, 0}, {0, 14}},
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->9,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SmallText"],
    CellMargins->{{27, 27}, {0, 8}},
    LineSpacing->{1, 3},
    ParagraphSpacing->{0.7, 0},
    CounterIncrements->"SmallText",
    FontSize->9],
  
  Cell[StyleData["SmallText", "Presentation"],
    FontSize->14],
  
  Cell[StyleData["SmallText", "Printout"],
    CellMargins->{{2, 2}, {5, 5}},
    TextJustification->1,
    Hyphenation->True,
    FontSize->7],
  
  Cell[StyleData["SmallText", "EnhancedPrintout"],
    CellMargins->{{2, 2}, {5, 5}},
    TextJustification->1,
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->7],
  
  Cell[StyleData["SmallText", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 2}, {5, 5}},
    TextJustification->1,
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->7]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Input/Output", "Section"],
  
  Cell["\<\
The cells in this section define styles used for input and output to the \
kernel.  Be careful when modifying, renaming, or removing these styles, \
because the front end associates special meanings with these style names.    \
\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Input"],
    ShowCellBracket->True,
    CellMargins->{{66, 4}, {3, 8}},
    Evaluatable->True,
    CellGroupingRules->"InputGrouping",
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    CellLabelAutoDelete->False,
    CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}},
    DefaultFormatType->DefaultInputFormatType,
    ShowSpecialCharacters->Automatic,
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    LanguageCategory->"Mathematica",
    FormatType->StandardForm,
    ShowStringCharacters->True,
    NumberMarks->True,
    FontWeight->"Bold"],
  
  Cell[StyleData["Input", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Input", "SlideShow"],
    ShowCellBracket->True,
    CellMargins->{{100, 50}, {0, 6}},
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    CellFrameMargins->{{8, 8}, {4, 8}},
    Background->RGBColor[1, 1, 0.8]],
  
  Cell[StyleData["Input", "Printout"],
    ShowCellBracket->False,
    CellMargins->{{39, 0}, {4, 6}},
    FontSize->9],
  
  Cell[StyleData["Input", "EnhancedPrintout"],
    ShowCellBracket->False,
    CellMargins->{{39, 0}, {4, 6}},
    FontSize->9],
  
  Cell[StyleData["Input", "EnhancedPrintoutNonGray"],
    ShowCellBracket->False,
    CellMargins->{{39, 0}, {4, 6}},
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Output"],
    ShowCellBracket->True,
    CellMargins->{{66, 4}, {8, 2}},
    CellEditDuplicate->True,
    CellGroupingRules->"OutputGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    CellLabelAutoDelete->False,
    CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}},
    DefaultFormatType->DefaultOutputFormatType,
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    AutoItalicWords->{},
    LanguageCategory->None,
    FormatType->StandardForm],
  
  Cell[StyleData["Output", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Output", "SlideShow"],
    ShowCellBracket->True,
    CellMargins->{{100, 50}, {6, 0}},
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    CellFrameMargins->{{8, 8}, {8, 4}},
    Background->RGBColor[1, 1, 0.8]],
  
  Cell[StyleData["Output", "Printout"],
    ShowCellBracket->False,
    CellMargins->{{39, 0}, {6, 4}},
    FontSize->9],
  
  Cell[StyleData["Output", "EnhancedPrintout"],
    ShowCellBracket->False,
    CellMargins->{{39, 0}, {6, 4}},
    FontSize->9],
  
  Cell[StyleData["Output", "EnhancedPrintoutNonGray"],
    ShowCellBracket->False,
    CellMargins->{{39, 0}, {6, 4}},
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["InputOnly"],
    ShowCellBracket->True,
    CellMargins->{{66, 4}, {8, 8}},
    Evaluatable->True,
    CellGroupingRules->"InputGrouping",
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    CellLabelAutoDelete->False,
    CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}},
    DefaultFormatType->DefaultInputFormatType,
    ShowSpecialCharacters->Automatic,
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    LanguageCategory->"Mathematica",
    FormatType->StandardForm,
    ShowStringCharacters->True,
    NumberMarks->True,
    StyleMenuListing->None,
    FontWeight->"Bold"],
  
  Cell[StyleData["InputOnly", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["InputOnly", "SlideShow"],
    ShowCellBracket->True,
    CellMargins->{{100, 50}, {6, 6}},
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    Background->RGBColor[1, 1, 0.8]],
  
  Cell[StyleData["InputOnly", "Printout"],
    ShowCellBracket->False,
    CellMargins->{{39, 0}, {6, 6}},
    FontSize->9],
  
  Cell[StyleData["InputOnly", "EnhancedPrintout"],
    ShowCellBracket->False,
    CellMargins->{{39, 0}, {6, 6}},
    FontSize->9],
  
  Cell[StyleData["InputOnly", "EnhancedPrintoutNonGray"],
    ShowCellBracket->False,
    CellMargins->{{39, 0}, {6, 6}},
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Message"],
    ShowCellBracket->True,
    CellMargins->{{66, 4}, {4, 2}},
    CellGroupingRules->"OutputGrouping",
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    ShowCellLabel->False,
    CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}},
    DefaultFormatType->DefaultOutputFormatType,
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    AutoStyleOptions->{"UnmatchedBracketStyle"->None},
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    AutoItalicWords->{},
    LanguageCategory->None,
    FormatType->InputForm,
    CounterIncrements->"Message",
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->10,
    FontColor->RGBColor[0.6, 0.100008, 0.100008]],
  
  Cell[StyleData["Message", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Message", "SlideShow"],
    CellMargins->{{100, 50}, {6, 6}},
    FontSize->10,
    FontColor->RGBColor[0.699992, 0.4, 0]],
  
  Cell[StyleData["Message", "Printout"],
    ShowCellBracket->False,
    CellMargins->{{39, Inherited}, {Inherited, Inherited}},
    FontSize->9,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["Message", "EnhancedPrintout"],
    ShowCellBracket->False,
    CellMargins->{{39, Inherited}, {Inherited, Inherited}},
    FontFamily->"Courier",
    FontSize->9,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["Message", "EnhancedPrintoutNonGray"],
    ShowCellBracket->False,
    CellMargins->{{39, Inherited}, {Inherited, Inherited}},
    FontFamily->"Courier",
    FontSize->9,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Print"],
    ShowCellBracket->True,
    CellMargins->{{66, 4}, {4, 2}},
    CellGroupingRules->"OutputGrouping",
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    ShowCellLabel->False,
    CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}},
    DefaultFormatType->DefaultOutputFormatType,
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    AutoItalicWords->{},
    LanguageCategory->None,
    FormatType->InputForm,
    StyleMenuListing->None],
  
  Cell[StyleData["Print", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Print", "SlideShow"],
    CellMargins->{{100, 50}, {6, 6}}],
  
  Cell[StyleData["Print", "Printout"],
    ShowCellBracket->False,
    CellMargins->{{57, Inherited}, {Inherited, Inherited}},
    FontSize->9],
  
  Cell[StyleData["Print", "EnhancedPrintout"],
    ShowCellBracket->False,
    CellMargins->{{57, Inherited}, {Inherited, Inherited}},
    FontFamily->"Courier Std",
    FontSize->9],
  
  Cell[StyleData["Print", "EnhancedPrintoutNonGray"],
    ShowCellBracket->False,
    CellMargins->{{57, Inherited}, {Inherited, Inherited}},
    FontFamily->"Courier Std",
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Graphics"],
    ShowCellBracket->True,
    CellMargins->{{66, 4}, {4, 2}},
    CellGroupingRules->"GraphicsGrouping",
    PageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    ShowCellLabel->False,
    DefaultFormatType->Utilities`Notation`Private`DefaultFormatTypeForOutput,
    LanguageCategory->None,
    FormatType->InputForm,
    StyleMenuListing->None,
    FontWeight->"Plain"],
  
  Cell[StyleData["Graphics", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Graphics", "SlideShow"],
    ShowCellBracket->True,
    CellMargins->{{100, 50}, {6, 0}},
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    CellFrameMargins->{{8, 8}, {4, 4}},
    Background->RGBColor[1, 1, 0.8]],
  
  Cell[StyleData["Graphics", "Printout"],
    ShowCellBracket->False,
    CellMargins->{{39, Inherited}, {Inherited, Inherited}},
    ImageSize->{250, 250},
    FontSize->9],
  
  Cell[StyleData["Graphics", "EnhancedPrintout"],
    ShowCellBracket->False,
    CellMargins->{{32, Inherited}, {Inherited, Inherited}},
    ImageSize->{250, 250},
    FontFamily->"Courier Std",
    FontSize->9],
  
  Cell[StyleData["Graphics", "EnhancedPrintoutNonGray"],
    ShowCellBracket->False,
    CellMargins->{{32, Inherited}, {Inherited, Inherited}},
    ImageSize->{250, 250},
    FontFamily->"Courier Std",
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["CellLabel"],
    LanguageCategory->None,
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->9,
    FontWeight->"Plain",
    FontColor->RGBColor[0.269993, 0.308507, 0.6]],
  
  Cell[StyleData["CellLabel", "Presentation"],
    FontSize->14],
  
  Cell[StyleData["CellLabel", "SlideShow"],
    FontColor->RGBColor[0.699992, 0.4, 0]],
  
  Cell[StyleData["CellLabel", "Printout"],
    FontFamily->"Courier",
    FontSize->8,
    FontSlant->"Oblique",
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["CellLabel", "EnhancedPrintout"],
    FontFamily->"Courier Std",
    FontSize->8,
    FontSlant->"Oblique",
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["CellLabel", "EnhancedPrintoutNonGray"],
    FontFamily->"Courier Std",
    FontSize->8,
    FontSlant->"Oblique",
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Name"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->9,
    FontWeight->"Plain",
    FontSlant->"Italic",
    FontColor->RGBColor[0.269993, 0.308507, 0.6]],
  
  Cell[StyleData["Name", "Presentation"],
    FontSize->14],
  
  Cell[StyleData["Name", "Printout"],
    FontSize->7,
    FontSlant->"Oblique",
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["Name", "EnhancedPrintout"],
    FontFamily->"Frutiger 56 Italic",
    FontSize->7,
    FontSlant->"Plain",
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["Name", "EnhancedPrintoutNonGray"],
    FontFamily->"Frutiger 56 Italic",
    FontSize->7,
    FontSlant->"Plain",
    FontColor->GrayLevel[0]]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Hyperlinks", "Section"],
  
  Cell["\<\
The cells below define styles useful for making hypertext ButtonBoxes.  The \
\"Hyperlink\" style is for links within the same Notebook, or between \
Notebooks. The others point to the various sections of the help browser. \
These styles will modify individual words or letters in a cell exclusive of \
the cell tag.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Hyperlink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookLocate[ #2]}]&),
    Active->True,
    ButtonNote->ButtonData}],
  
  Cell[StyleData["Hyperlink", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["Hyperlink", "EnhancedPrintout"],
    FontFamily->"Palatino",
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["Hyperlink", "EnhancedPrintoutNonGray"],
    FontFamily->"Palatino",
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MainBookLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "MainBook", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["MainBookLink", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["MainBookLink", "EnhancedPrintout"],
    FontFamily->"Palatino",
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["MainBookLink", "EnhancedPrintoutNonGray"],
    FontFamily->"Palatino",
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MainBookLinkMR"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontFamily->"Courier",
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "MainBook", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["MainBookLinkMR", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["MainBookLinkMR", "EnhancedPrintout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["MainBookLinkMR", "EnhancedPrintoutNonGray"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["AddOnsLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontFamily->"Courier",
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "AddOns", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["AddOnsLink", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["AddOnsLink", "EnhancedPrintout"],
    FontFamily->"WRICourier",
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["AddOnsLink", "EnhancedPrintoutNonGray"],
    FontFamily->"WRICourier",
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["AddOnsLinkText"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontFamily->"Times",
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "AddOns", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["AddOnsLinkText", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["AddOnsLinkText", "EnhancedPrintout"],
    FontFamily->"Palatino",
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["AddOnsLinkText", "EnhancedPrintoutNonGray"],
    FontFamily->"Palatino",
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["RefGuideLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontFamily->"Courier",
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "RefGuide", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["RefGuideLink", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["RefGuideLink", "EnhancedPrintout"],
    FontFamily->"WRICourier",
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["RefGuideLink", "EnhancedPrintoutNonGray"],
    FontFamily->"WRICourier",
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["GettingStartedLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "GettingStarted", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["GettingStartedLink", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["GettingStartedLink", "EnhancedPrintout"],
    FontFamily->"Palatino",
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["GettingStartedLink", "EnhancedPrintoutNonGray"],
    FontFamily->"Palatino",
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DemosLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "Demos", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["DemosLink", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["DemosLink", "EnhancedPrintout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["DemosLink", "EnhancedPrintoutNonGray"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TourLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "Tour", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["TourLink", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["TourLink", "EnhancedPrintout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["TourLink", "EnhancedPrintoutNonGray"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["OtherInformationLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "OtherInformation", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["OtherInformationLink", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["OtherInformationLink", "EnhancedPrintout"],
    FontFamily->"Palatino",
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["OtherInformationLink", "EnhancedPrintoutNonGray"],
    FontFamily->"Palatino",
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["OtherInformationLinkMR"],
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "OtherInformation", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["OtherInformationLinkMR", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["OtherInformationLinkMR", "EnhancedPrintout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["OtherInformationLinkMR", "EnhancedPrintoutNonGray"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MasterIndexLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "MasterIndex", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["MasterIndexLink", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["MasterIndexLink", "EnhancedPrintout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["MasterIndexLink", "EnhancedPrintoutNonGray"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Palette Styles", "Section"],
  
  Cell["\<\
The cells below define styles that define standard ButtonFunctions, for use \
in palette buttons.\
\>", "Text"],
  
  Cell[StyleData["Paste"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookApply[ 
          FrontEnd`InputNotebook[ ], #, After]}]&)}],
  
  Cell[StyleData["Evaluate"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookApply[ 
          FrontEnd`InputNotebook[ ], #, All], 
        SelectionEvaluate[ 
          FrontEnd`InputNotebook[ ], All]}]&)}],
  
  Cell[StyleData["EvaluateCell"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookApply[ 
          FrontEnd`InputNotebook[ ], #, All], 
        FrontEnd`SelectionMove[ 
          FrontEnd`InputNotebook[ ], All, Cell, 1], 
        FrontEnd`SelectionEvaluateCreateCell[ 
          FrontEnd`InputNotebook[ ], All]}]&)}],
  
  Cell[StyleData["CopyEvaluate"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`SelectionCreateCell[ 
          FrontEnd`InputNotebook[ ], All], 
        FrontEnd`NotebookApply[ 
          FrontEnd`InputNotebook[ ], #, All], 
        FrontEnd`SelectionEvaluate[ 
          FrontEnd`InputNotebook[ ], All]}]&)}],
  
  Cell[StyleData["CopyEvaluateCell"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`SelectionCreateCell[ 
          FrontEnd`InputNotebook[ ], All], 
        FrontEnd`NotebookApply[ 
          FrontEnd`InputNotebook[ ], #, All], 
        FrontEnd`SelectionEvaluateCreateCell[ 
          FrontEnd`InputNotebook[ ], All]}]&)}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Inline Formatting", "Section"],
  
  Cell["\<\
These styles are for modifying individual words or letters in a cell \
exclusive of the cell tag.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["JT"],
    StyleMenuListing->None,
    FontFamily->"JFontText"],
  
  Cell[StyleData["JT", "Printout"]],
  
  Cell[StyleData["JT", "EnhancedPrintout"]],
  
  Cell[StyleData["JT", "EnhancedPrintoutNonGray"]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["JS"],
    StyleMenuListing->None,
    FontFamily->"JFontSans"],
  
  Cell[StyleData["JS", "Printout"]],
  
  Cell[StyleData["JS", "EnhancedPrintout"]],
  
  Cell[StyleData["JS", "EnhancedPrintoutNonGray"]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["JSB"],
    StyleMenuListing->None,
    FontFamily->"JFontSansBold"],
  
  Cell[StyleData["JSB", "Printout"]],
  
  Cell[StyleData["JSB", "EnhancedPrintout"]],
  
  Cell[StyleData["JSB", "EnhancedPrintoutNonGray"]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["RM"],
    StyleMenuListing->None,
    FontWeight->"Plain",
    FontSlant->"Plain"],
  
  Cell[StyleData["RM", "Printout"]],
  
  Cell[StyleData["RM", "EnhancedPrintout"]],
  
  Cell[StyleData["RM", "EnhancedPrintoutNonGray"]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["BF"],
    StyleMenuListing->None,
    FontWeight->"Bold"],
  
  Cell[StyleData["BF", "Printout"]],
  
  Cell[StyleData["BF", "EnhancedPrintout"]],
  
  Cell[StyleData["BF", "EnhancedPrintoutNonGray"]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["IT"],
    StyleMenuListing->None,
    FontSlant->"Italic"],
  
  Cell[StyleData["IT", "Printout"]],
  
  Cell[StyleData["IT", "EnhancedPrintout"]],
  
  Cell[StyleData["IT", "EnhancedPrintoutNonGray"]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TR"],
    StyleMenuListing->None,
    FontFamily->"Times",
    FontWeight->"Plain",
    FontSlant->"Plain"],
  
  Cell[StyleData["TR", "Printout"]],
  
  Cell[StyleData["TR", "EnhancedPrintout"],
    FontFamily->"Palatino"],
  
  Cell[StyleData["TR", "EnhancedPrintoutNonGray"],
    FontFamily->"Palatino"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TI"],
    StyleMenuListing->None,
    FontFamily->"Times",
    FontSlant->"Italic"],
  
  Cell[StyleData["TI", "Printout"]],
  
  Cell[StyleData["TI", "EnhancedPrintout"],
    FontFamily->"Palatino"],
  
  Cell[StyleData["TI", "EnhancedPrintoutNonGray"],
    FontFamily->"Palatino"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TB"],
    StyleMenuListing->None,
    FontFamily->"Times",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  
  Cell[StyleData["TB", "Printout"]],
  
  Cell[StyleData["TB", "EnhancedPrintout"],
    FontFamily->"Palatino"],
  
  Cell[StyleData["TB", "EnhancedPrintoutNonGray"],
    FontFamily->"Palatino"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TBI"],
    StyleMenuListing->None,
    FontFamily->"Times",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  
  Cell[StyleData["TBI", "Printout"]],
  
  Cell[StyleData["TBI", "EnhancedPrintout"],
    FontFamily->"Palatino"],
  
  Cell[StyleData["TBI", "EnhancedPrintoutNonGray"],
    FontFamily->"Palatino"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MR"],
    Hyphenation->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    AutoItalicWords->{},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontWeight->"Plain",
    FontSlant->"Plain"],
  
  Cell[StyleData["MR", "Printout"]],
  
  Cell[StyleData["MR", "EnhancedPrintout"],
    FontFamily->"Courier Std"],
  
  Cell[StyleData["MR", "EnhancedPrintoutNonGray"],
    FontFamily->"Courier Std"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MO"],
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontWeight->"Plain",
    FontSlant->"Italic"],
  
  Cell[StyleData["MO", "Printout"],
    FontSlant->"Oblique"],
  
  Cell[StyleData["MO", "EnhancedPrintout"],
    FontFamily->"Courier Std",
    FontSlant->"Oblique"],
  
  Cell[StyleData["MO", "EnhancedPrintoutNonGray"],
    FontFamily->"Courier Std",
    FontSlant->"Oblique"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MB"],
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  
  Cell[StyleData["MB", "Printout"]],
  
  Cell[StyleData["MB", "EnhancedPrintout"],
    FontFamily->"Courier Std"],
  
  Cell[StyleData["MB", "EnhancedPrintoutNonGray"],
    FontFamily->"Courier Std"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MBO"],
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  
  Cell[StyleData["MBO", "Printout"],
    FontSlant->"Oblique"],
  
  Cell[StyleData["MBO", "EnhancedPrintout"],
    FontFamily->"Courier Std",
    FontSlant->"Oblique"],
  
  Cell[StyleData["MBO", "EnhancedPrintoutNonGray"],
    FontFamily->"Courier Std",
    FontSlant->"Oblique"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SR"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Plain",
    FontSlant->"Plain"],
  
  Cell[StyleData["SR", "Printout"]],
  
  Cell[StyleData["SR", "EnhancedPrintout"],
    FontFamily->"Frutiger 55 Roman"],
  
  Cell[StyleData["SR", "EnhancedPrintoutNonGray"],
    FontFamily->"Frutiger 55 Roman"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SO"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Plain",
    FontSlant->"Italic"],
  
  Cell[StyleData["SO", "Printout"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Plain",
    FontSlant->"Italic"],
  
  Cell[StyleData["SO", "EnhancedPrintout"],
    FontFamily->"Frutiger 56 Italic",
    FontSlant->"Plain"],
  
  Cell[StyleData["SO", "EnhancedPrintoutNonGray"],
    FontFamily->"Frutiger 56 Italic",
    FontSlant->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SB"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  
  Cell[StyleData["SB", "Printout"],
    StyleMenuListing->None],
  
  Cell[StyleData["SB", "EnhancedPrintout"],
    FontFamily->"Frutiger 65 Bold",
    FontWeight->"Plain"],
  
  Cell[StyleData["SB", "EnhancedPrintoutNonGray"],
    FontFamily->"Frutiger 65 Bold",
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SBColor"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  
  Cell[StyleData["SBColor", "Printout"],
    StyleMenuListing->None],
  
  Cell[StyleData["SBColor", "EnhancedPrintout"],
    FontFamily->"Frutiger 65 Bold",
    FontWeight->"Plain"],
  
  Cell[StyleData["SBColor", "EnhancedPrintoutNonGray"],
    FontFamily->"Frutiger 65 Bold",
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SBO"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  
  Cell[StyleData["SBO", "Printout"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  
  Cell[StyleData["SBO", "EnhancedPrintout"],
    FontFamily->"Frutiger 66 BoldItalic",
    FontWeight->"Plain",
    FontSlant->"Plain"],
  
  Cell[StyleData["SBO", "EnhancedPrintoutNonGray"],
    FontFamily->"Frutiger 66 BoldItalic",
    FontWeight->"Plain",
    FontSlant->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["M4"],
    ShowCellBracket->True,
    StyleMenuListing->None,
    FontFamily->"Mathematica4",
    CharacterEncoding->"Mathematica4"],
  
  Cell[StyleData["M4", "Printout"],
    ShowCellBracket->True,
    StyleMenuListing->None,
    FontFamily->"Mathematica4",
    CharacterEncoding->"Mathematica4"],
  
  Cell[StyleData["M4", "EnhancedPrintout"],
    ShowCellBracket->True,
    StyleMenuListing->None,
    FontFamily->"Mathematica4",
    CharacterEncoding->"Mathematica4"],
  
  Cell[StyleData["M4", "EnhancedPrintoutNonGray"],
    ShowCellBracket->True,
    StyleMenuListing->None,
    FontFamily->"Mathematica4",
    CharacterEncoding->"Mathematica4"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SO10"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->10,
    FontWeight->"Plain",
    FontSlant->"Italic"],
  
  Cell[StyleData["SO10", "Printout"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->8,
    FontWeight->"Plain",
    FontSlant->"Italic"],
  
  Cell[StyleData["SO10", "EnhancedPrintout"],
    StyleMenuListing->None,
    FontFamily->"Frutiger 56 Italic",
    FontSize->8,
    FontWeight->"Plain",
    FontSlant->"Plain"],
  
  Cell[StyleData["SO10", "EnhancedPrintoutNonGray"],
    StyleMenuListing->None,
    FontFamily->"Frutiger 56 Italic",
    FontSize->8,
    FontWeight->"Plain",
    FontSlant->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["S9"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->9,
    FontWeight->"Plain"],
  
  Cell[StyleData["S9", "Printout"],
    FontSize->9,
    FontWeight->"Plain"],
  
  Cell[StyleData["S9", "EnhancedPrintout"],
    FontFamily->"Frutiger 55 Roman",
    FontSize->9,
    FontWeight->"Plain"],
  
  Cell[StyleData["S9", "EnhancedPrintoutNonGray"],
    FontFamily->"Frutiger 55 Roman",
    FontSize->9,
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["S10"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->10,
    FontWeight->"Plain"],
  
  Cell[StyleData["S10", "Printout"],
    FontSize->10,
    FontWeight->"Plain"],
  
  Cell[StyleData["S10", "EnhancedPrintout"],
    FontFamily->"Frutiger 55 Roman",
    FontSize->10,
    FontWeight->"Plain"],
  
  Cell[StyleData["S10", "EnhancedPrintoutNonGray"],
    FontFamily->"Frutiger 55 Roman",
    FontSize->10,
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SB9"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->9,
    FontWeight->"Bold",
    PrivateFontOptions->{"OperatorSubstitution"->False}],
  
  Cell[StyleData["SB9", "Printout"],
    FontSize->7],
  
  Cell[StyleData["SB9", "EnhancedPrintout"],
    FontFamily->"Frutiger 65 Bold",
    FontSize->7,
    FontWeight->"Plain"],
  
  Cell[StyleData["SB9", "EnhancedPrintoutNonGray"],
    FontFamily->"Frutiger 65 Bold",
    FontSize->7,
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SB10"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->10,
    FontWeight->"Bold"],
  
  Cell[StyleData["SB10", "Printout"],
    FontSize->8],
  
  Cell[StyleData["SB10", "EnhancedPrintout"],
    FontFamily->"Frutiger 65 Bold",
    FontSize->8,
    FontWeight->"Plain"],
  
  Cell[StyleData["SB10", "EnhancedPrintoutNonGray"],
    FontFamily->"Frutiger 65 Bold",
    FontSize->8,
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MR10"],
    Hyphenation->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    SingleLetterItalics->False,
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontSize->10,
    FontWeight->"Plain",
    FontSlant->"Plain"],
  
  Cell[StyleData["MR10", "Printout"],
    FontSize->7],
  
  Cell[StyleData["MR10", "EnhancedPrintout"],
    FontFamily->"Courier Std",
    FontSize->7],
  
  Cell[StyleData["MR10", "EnhancedPrintoutNonGray"],
    FontFamily->"Courier Std",
    FontSize->7]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["C1"],
    StyleMenuListing->None,
    FontColor->RGBColor[0.4, 0, 1]],
  
  Cell[StyleData["C1", "Printout"],
    FontSize->10,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["C1", "EnhancedPrintout"],
    FontFamily->"Palatino",
    FontSize->10,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["C1", "EnhancedPrintoutNonGray"],
    FontFamily->"Palatino",
    FontSize->10,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["C1MR"],
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontColor->RGBColor[0.4, 0, 1]],
  
  Cell[StyleData["C1MR", "Printout"],
    FontSize->10,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["C1MR", "EnhancedPrintout"],
    FontFamily->"Courier Std",
    FontSize->10,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["C1MR", "EnhancedPrintoutNonGray"],
    FontFamily->"Courier Std",
    FontSize->10,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SmallCaps"],
    StyleMenuListing->None,
    Magnification->0.8],
  
  Cell[StyleData["SmallCaps", "Printout"]],
  
  Cell[StyleData["SmallCaps", "EnhancedPrintout"],
    FontFamily->"Palatino"],
  
  Cell[StyleData["SmallCaps", "EnhancedPrintoutNonGray"],
    FontFamily->"Palatino"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["KeyboardChars"],
    StyleMenuListing->None,
    FontSize->12],
  
  Cell[StyleData["KeyboardChars", "Printout"],
    FontSize->10],
  
  Cell[StyleData["KeyboardChars", "EnhancedPrintout"],
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["KeyboardChars", "EnhancedPrintoutNonGray"],
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Emphasis Boxes and Pictures", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Box"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxFrame->0.5,
    BoxMargins->True},
    GridBoxOptions->{ColumnSpacings->1}],
  
  Cell[StyleData["Box", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Box", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["Box", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["Box", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DoubleBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxFrame->0.5,
    BoxMargins->True},
    GridBoxOptions->{ColumnSpacings->2,
    RowAlignments->Top}],
  
  Cell[StyleData["DoubleBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["DoubleBox", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["DoubleBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["DoubleBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["1ColumnBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxFrame->0.5,
    BoxMargins->True},
    GridBoxOptions->{ColumnSpacings->1}],
  
  Cell[StyleData["1ColumnBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["1ColumnBox", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["1ColumnBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["1ColumnBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["2ColumnBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    SingleLetterItalics->False,
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxFrame->0.5,
    BoxMargins->True},
    GridBoxOptions->{ColumnWidths->{0.31, 0.67}}],
  
  Cell[StyleData["2ColumnBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["2ColumnBox", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->9,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["2ColumnBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->9,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["2ColumnBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->9,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["2ColumnEvenBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxFrame->0.5,
    BoxMargins->True},
    GridBoxOptions->{ColumnWidths->0.46}],
  
  Cell[StyleData["2ColumnEvenBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["2ColumnEvenBox", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["2ColumnEvenBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["2ColumnEvenBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["2ColumnSmallBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxFrame->0.5,
    BoxMargins->True},
    GridBoxOptions->{ColumnSpacings->1.5,
    ColumnWidths->0.35,
    ColumnAlignments->{Right, Left}}],
  
  Cell[StyleData["2ColumnSmallBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["2ColumnSmallBox", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["2ColumnSmallBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["2ColumnSmallBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["3ColumnBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxFrame->0.5,
    BoxMargins->True},
    GridBoxOptions->{ColumnWidths->0.32}],
  
  Cell[StyleData["3ColumnBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["3ColumnBox", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["3ColumnBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["3ColumnBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["3ColumnSmallBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxFrame->0.5,
    BoxMargins->True},
    GridBoxOptions->{ColumnSpacings->1.5,
    ColumnWidths->0.24,
    ColumnAlignments->{Right, Center, Left}}],
  
  Cell[StyleData["3ColumnSmallBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["3ColumnSmallBox", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["3ColumnSmallBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["3ColumnSmallBox", "EnhancedPrintoutNonGray"],
    CellFrame->0.5,
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["4ColumnBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    SingleLetterItalics->False,
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxFrame->0.5,
    BoxMargins->True},
    GridBoxOptions->{ColumnWidths->{0.13, 0.35, 0.13, 0.35}}],
  
  Cell[StyleData["4ColumnBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["4ColumnBox", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["4ColumnBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["4ColumnBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["5ColumnBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxFrame->0.5,
    BoxMargins->True},
    GridBoxOptions->{ColumnWidths->0.202}],
  
  Cell[StyleData["5ColumnBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["5ColumnBox", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->9,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["5ColumnBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->9,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["5ColumnBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->9,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["6ColumnBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxFrame->0.5,
    BoxMargins->True},
    GridBoxOptions->{ColumnWidths->{0.12, 0.22, 0.12, 0.12, 0.22, 0.12}}],
  
  Cell[StyleData["6ColumnBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["6ColumnBox", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["6ColumnBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["6ColumnBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["FramedBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    FontWeight->"Plain",
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["FramedBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["FramedBox", "Printout"],
    CellMargins->{{2, 4}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]],
  
  Cell[StyleData["FramedBox", "EnhancedPrintout"],
    CellMargins->{{2, 4}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1]],
  
  Cell[StyleData["FramedBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 4}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DefinitionBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    FontWeight->"Plain",
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.4, 0.6},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["DefinitionBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["DefinitionBox", "Printout"],
    CellMargins->{{2, 4}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]],
  
  Cell[StyleData["DefinitionBox", "EnhancedPrintout"],
    CellMargins->{{2, 4}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1]],
  
  Cell[StyleData["DefinitionBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 4}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DefinitionBox3Col"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    FontWeight->"Plain",
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.35, 0.2, 0.45},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["DefinitionBox3Col", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["DefinitionBox3Col", "Printout"],
    CellMargins->{{2, 4}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]],
  
  Cell[StyleData["DefinitionBox3Col", "EnhancedPrintout"],
    CellMargins->{{2, 4}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1]],
  
  Cell[StyleData["DefinitionBox3Col", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 4}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DefinitionBox4Col"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    FontWeight->"Plain",
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.15, 0.35, 0.15, 0.35},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["DefinitionBox4Col", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["DefinitionBox4Col", "Printout"],
    CellMargins->{{2, 4}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]],
  
  Cell[StyleData["DefinitionBox4Col", "EnhancedPrintout"],
    CellMargins->{{2, 4}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1]],
  
  Cell[StyleData["DefinitionBox4Col", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 4}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DefinitionBox5Col"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    FontWeight->"Plain",
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->0.2,
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["DefinitionBox5Col", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["DefinitionBox5Col", "Printout"],
    CellMargins->{{2, 4}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]],
  
  Cell[StyleData["DefinitionBox5Col", "EnhancedPrintout"],
    CellMargins->{{2, 4}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1]],
  
  Cell[StyleData["DefinitionBox5Col", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 4}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DefinitionBox6Col"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    FontWeight->"Plain",
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.13, 0.24, 0.13, 0.13, 0.24, 0.13},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["DefinitionBox6Col", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["DefinitionBox6Col", "Printout"],
    CellMargins->{{2, 4}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]],
  
  Cell[StyleData["DefinitionBox6Col", "EnhancedPrintout"],
    CellMargins->{{2, 4}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1]],
  
  Cell[StyleData["DefinitionBox6Col", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 4}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TopBox"],
    CellFrame->{{0.5, 0.5}, {0, 0.5}},
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakBelow->False,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    FontWeight->"Plain",
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.31, 0.62},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["TopBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["TopBox", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    Background->GrayLevel[1]],
  
  Cell[StyleData["TopBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    Background->GrayLevel[1]],
  
  Cell[StyleData["TopBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MiddleBox"],
    CellFrame->{{0.5, 0.5}, {0, 0}},
    CellMargins->{{27, 12}, {0, -7}},
    CellHorizontalScrolling->True,
    PageBreakAbove->False,
    PageBreakBelow->False,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    FontWeight->"Plain",
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.31, 0.62},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["MiddleBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["MiddleBox", "Printout"],
    CellMargins->{{2, 0}, {0, 2}},
    CellFrameColor->GrayLevel[0],
    Background->GrayLevel[1]],
  
  Cell[StyleData["MiddleBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 4}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    Background->GrayLevel[1]],
  
  Cell[StyleData["MiddleBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 4}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["BottomBox"],
    CellFrame->{{0.5, 0.5}, {0.5, 0}},
    CellMargins->{{27, 12}, {0, -7}},
    CellHorizontalScrolling->True,
    PageBreakAbove->False,
    PageBreakBelow->False,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    FontWeight->"Plain",
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.31, 0.62},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["BottomBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["BottomBox", "Printout"],
    CellMargins->{{2, 0}, {0, -5}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1],
    GridBoxOptions->{RowMinHeight->2.2}],
  
  Cell[StyleData["BottomBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, -5}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1],
    GridBoxOptions->{RowMinHeight->2.2}],
  
  Cell[StyleData["BottomBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, -5}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1],
    GridBoxOptions->{RowMinHeight->2.2}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TopSpanBox"],
    CellFrame->{{0.5, 0.5}, {0, 0.5}},
    CellMargins->{{27, 12}, {-2, 8}},
    CellHorizontalScrolling->True,
    PageBreakBelow->False,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    FontWeight->"Plain",
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.9, 0.03},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["TopSpanBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["TopSpanBox", "Printout"],
    CellMargins->{{2, 0}, {-2, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]],
  
  Cell[StyleData["TopSpanBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {-4, 8}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1]],
  
  Cell[StyleData["TopSpanBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {-4, 8}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MiddleSpanBox"],
    CellFrame->{{0.5, 0.5}, {0, 0}},
    CellMargins->{{27, 12}, {0, 0}},
    CellHorizontalScrolling->True,
    PageBreakAbove->False,
    PageBreakBelow->False,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    FontWeight->"Plain",
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.9, 0.03},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["MiddleSpanBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["MiddleSpanBox", "Printout"],
    CellMargins->{{2, 0}, {-5, 0}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1],
    GridBoxOptions->{RowMinHeight->1.8}],
  
  Cell[StyleData["MiddleSpanBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {-7, 0}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1],
    GridBoxOptions->{RowMinHeight->1.8}],
  
  Cell[StyleData["MiddleSpanBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {-7, 0}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1],
    GridBoxOptions->{RowMinHeight->1.8}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Picture"],
    CellMargins->{{27, Inherited}, {4, 4}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["Picture", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Picture", "Printout"],
    CellMargins->{{2, Inherited}, {4, 4}},
    Magnification->0.65],
  
  Cell[StyleData["Picture", "EnhancedPrintout"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.65],
  
  Cell[StyleData["Picture", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.65]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["OpenCloseItemizedPicture"],
    CellMargins->{{88, 4}, {4, 4}},
    PrivateCellOptions->{"DefaultCellGroupOpen"->False},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["OpenCloseItemizedPicture", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["OpenCloseItemizedPicture", "Printout"],
    CellMargins->{{76, 2}, {0, 0}},
    CellElementSpacings->{"CellMinHeight"->1,
    "ClosedCellHeight"->0},
    CellOpen->False],
  
  Cell[StyleData["OpenCloseItemizedPicture", "EnhancedPrintout"],
    CellMargins->{{76, 2}, {0, 0}},
    CellElementSpacings->{"CellMinHeight"->1,
    "ClosedCellHeight"->0},
    CellOpen->False],
  
  Cell[StyleData["OpenCloseItemizedPicture", "EnhancedPrintoutNonGray"],
    CellMargins->{{76, 2}, {0, 0}},
    CellElementSpacings->{"CellMinHeight"->1,
    "ClosedCellHeight"->0},
    CellOpen->False]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemizedPicture"],
    CellMargins->{{88, 4}, {4, 4}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["ItemizedPicture", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemizedPicture", "Printout"],
    CellMargins->{{77, 2}, {4, -4}},
    Magnification->0.5],
  
  Cell[StyleData["ItemizedPicture", "EnhancedPrintout"],
    CellMargins->{{78, 2}, {12, -6}},
    Magnification->0.5],
  
  Cell[StyleData["ItemizedPicture", "EnhancedPrintoutNonGray"],
    CellMargins->{{75, 2}, {4, -6}},
    Magnification->0.5]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ListGraphic"],
    CellMargins->{{88, 4}, {4, 4}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["ListGraphic", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ListGraphic", "Printout"],
    CellMargins->{{77, 2}, {4, -4}},
    Magnification->0.5],
  
  Cell[StyleData["ListGraphic", "EnhancedPrintout"],
    CellMargins->{{78, 2}, {12, -6}},
    Magnification->0.5],
  
  Cell[StyleData["ListGraphic", "EnhancedPrintoutNonGray"],
    CellMargins->{{75, 2}, {4, -6}},
    Magnification->0.5]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ListNoteBox"],
    CellFrame->0.5,
    CellMargins->{{88, 12}, {8, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxMargins->{{1, 1}, {1.5, 1.5}}},
    GridBoxOptions->{ColumnSpacings->1}],
  
  Cell[StyleData["ListNoteBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ListNoteBox", "Printout"],
    CellMargins->{{77, 4}, {6, 2}},
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["ListNoteBox", "EnhancedPrintout"],
    CellMargins->{{39, 4}, {6, 2}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["ListNoteBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{77, 4}, {6, 2}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PictureGroup"],
    CellMargins->{{41, 4}, {0, 4}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["PictureGroup", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["PictureGroup", "Printout"],
    CellMargins->{{76, 2}, {0, 0}},
    CellElementSpacings->{"CellMinHeight"->1,
    "ClosedCellHeight"->0},
    CellOpen->False],
  
  Cell[StyleData["PictureGroup", "EnhancedPrintout"],
    CellMargins->{{76, 2}, {0, 0}},
    CellElementSpacings->{"CellMinHeight"->1,
    "ClosedCellHeight"->0},
    CellOpen->False],
  
  Cell[StyleData["PictureGroup", "EnhancedPrintoutNonGray"],
    CellMargins->{{76, 2}, {0, 0}},
    CellElementSpacings->{"CellMinHeight"->1,
    "ClosedCellHeight"->0},
    CellOpen->False]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Sound"],
    ShowCellBracket->True,
    CellMargins->{{27, Inherited}, {0, 8}},
    StyleMenuListing->None],
  
  Cell[StyleData["Sound", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Sound", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10],
  
  Cell[StyleData["Sound", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10],
  
  Cell[StyleData["Sound", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Caption"],
    CellMargins->{{27, 4}, {0, 3}},
    PageBreakAbove->False,
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->9],
  
  Cell[StyleData["Caption", "Presentation"],
    FontSize->14],
  
  Cell[StyleData["Caption", "Printout"],
    CellMargins->{{2, 4}, {2, 0}},
    FontSize->7],
  
  Cell[StyleData["Caption", "EnhancedPrintout"],
    CellMargins->{{2, 4}, {2, 2}},
    FontFamily->"Frutiger 55 Roman",
    FontSize->7],
  
  Cell[StyleData["Caption", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 4}, {2, -2}},
    FontFamily->"Frutiger 55 Roman",
    FontSize->7]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Tables", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["2ColumnTable"],
    CellMargins->{{35, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    LineIndent->0,
    StyleMenuListing->None,
    GridBoxOptions->{ColumnWidths->{0.34, 0.64},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["2ColumnTable", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["2ColumnTable", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->9],
  
  Cell[StyleData["2ColumnTable", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->9],
  
  Cell[StyleData["2ColumnTable", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["2ColumnEvenTable"],
    CellMargins->{{35, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    LineIndent->0,
    StyleMenuListing->None,
    GridBoxOptions->{ColumnWidths->0.49,
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["2ColumnEvenTable", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["2ColumnEvenTable", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->9],
  
  Cell[StyleData["2ColumnEvenTable", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->9],
  
  Cell[StyleData["2ColumnEvenTable", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["3ColumnTable"],
    CellMargins->{{35, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    LineIndent->0,
    StyleMenuListing->None,
    GridBoxOptions->{ColumnWidths->{0.28, 0.28, 0.43},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["3ColumnTable", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["3ColumnTable", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->9],
  
  Cell[StyleData["3ColumnTable", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->9],
  
  Cell[StyleData["3ColumnTable", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->9]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Formulas and Programming", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["InlineFormula"],
    CellMargins->{{27, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    LanguageCategory->"Formula",
    AutoSpacing->True,
    ScriptLevel->1,
    SingleLetterItalics->True,
    SpanMaxSize->Infinity,
    StyleMenuListing->None,
    GridBoxOptions->{ColumnWidths->Automatic}],
  
  Cell[StyleData["InlineFormula", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10],
  
  Cell[StyleData["InlineFormula", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10],
  
  Cell[StyleData["InlineFormula", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["InlineOutput"],
    CellMargins->{{27, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    LanguageCategory->None,
    StyleMenuListing->None,
    FontFamily->"Courier"],
  
  Cell[StyleData["InlineOutput", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->9.5],
  
  Cell[StyleData["InlineOutput", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->9.5],
  
  Cell[StyleData["InlineOutput", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->9.5]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DisplayFormula"],
    CellMargins->{{66, Inherited}, {Inherited, 10}},
    CellHorizontalScrolling->True,
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    LanguageCategory->"Formula",
    ScriptLevel->0,
    SingleLetterItalics->True,
    SpanMaxSize->Infinity,
    StyleMenuListing->None,
    UnderoverscriptBoxOptions->{LimitsPositioning->True},
    GridBoxOptions->{ColumnWidths->Automatic}],
  
  Cell[StyleData["DisplayFormula", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["DisplayFormula", "Printout"]],
  
  Cell[StyleData["DisplayFormula", "EnhancedPrintout"],
    FontFamily->"Palatino"],
  
  Cell[StyleData["DisplayFormula", "EnhancedPrintoutNonGray"],
    FontFamily->"Palatino"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DisplayMath"],
    CellMargins->{{66, 10}, {7, 7}},
    Evaluatable->False,
    CellGroupingRules->"InputGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    DefaultFormatType->DefaultInputFormatType,
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    AutoItalicWords->{},
    LanguageCategory->"Formula",
    FormatType->InputForm,
    ShowStringCharacters->True,
    NumberMarks->True,
    CounterIncrements->"Input"],
  
  Cell[StyleData["DisplayMath", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["DisplayMath", "Printout"],
    CellMargins->{{39, 0}, {6, 6}},
    FontSize->9],
  
  Cell[StyleData["DisplayMath", "EnhancedPrintout"],
    CellMargins->{{39, 0}, {4, 6}},
    FontFamily->"WRICourier",
    FontSize->9],
  
  Cell[StyleData["DisplayMath", "EnhancedPrintoutNonGray"],
    CellMargins->{{39, 0}, {4, 6}},
    FontFamily->"WRICourier",
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["NumberedEquation"],
    CellMargins->{{66, 27}, {7, 7}},
    CellFrameLabels->{{None, Cell[ 
            TextData[ {"(", 
              CounterBox[ "NumberedEquation"], ")"}]]}, {None, None}},
    DefaultFormatType->DefaultInputFormatType,
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    LanguageCategory->"Formula",
    CounterIncrements->"NumberedEquation",
    FormatTypeAutoConvert->False],
  
  Cell[StyleData["NumberedEquation", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["NumberedEquation", "Printout"],
    CellMargins->{{39, 55}, {0, 10}},
    FontSize->10],
  
  Cell[StyleData["NumberedEquation", "EnhancedPrintout"],
    CellMargins->{{39, 55}, {0, 10}},
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["NumberedEquation", "EnhancedPrintoutNonGray"],
    CellMargins->{{39, 55}, {0, 10}},
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["EquationNumber"],
    CellMargins->{{66, Inherited}, {Inherited, Inherited}},
    LineSpacing->{1.83, 0},
    LanguageCategory->"Formula"],
  
  Cell[StyleData["EquationNumber", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["EquationNumber", "Printout"],
    LineSpacing->{1.7, 0}],
  
  Cell[StyleData["EquationNumber", "EnhancedPrintout"],
    LineSpacing->{1.7, 0},
    FontFamily->"Palatino"],
  
  Cell[StyleData["EquationNumber", "EnhancedPrintoutNonGray"],
    LineSpacing->{1.7, 0},
    FontFamily->"Palatino"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Program"],
    CellMargins->{{66, Inherited}, {Inherited, 10}},
    CellHorizontalScrolling->True,
    ShowSpecialCharacters->Automatic,
    AutoItalicWords->{},
    LanguageCategory->"Formula",
    FontFamily->"Courier"],
  
  Cell[StyleData["Program", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Program", "Printout"],
    CellMargins->{{42, 30}, {Inherited, 4}},
    FontSize->9.5],
  
  Cell[StyleData["Program", "EnhancedPrintout"],
    CellMargins->{{42, 30}, {Inherited, 4}},
    FontFamily->"WRICourier",
    FontSize->9.5],
  
  Cell[StyleData["Program", "EnhancedPrintoutNonGray"],
    CellMargins->{{42, 30}, {Inherited, 4}},
    FontFamily->"WRICourier",
    FontSize->9.5]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Unique Help Browser Styles", "Section"],
  
  Cell[CellGroupData[{
  
  Cell["\<\
Standard Styles
\
\>", "Subsection"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["InspectorLevel1"],
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{27, 10}, {2, 7}},
    CellGroupingRules->{"SectionGrouping", 60},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    ParagraphIndent->-38,
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->16,
    FontWeight->"Bold"],
  
  Cell[StyleData["InspectorLevel1", "Presentation"],
    FontSize->24],
  
  Cell[StyleData["InspectorLevel1", "SlideShow"],
    HyphenationOptions->{"HyphenationCharacter"->"-"}],
  
  Cell[StyleData["InspectorLevel1", "Printout"],
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->14]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["InspectorLevel2"],
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{27, 4}, {0, 14}},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->14,
    FontWeight->"Bold"],
  
  Cell[StyleData["InspectorLevel2", "Presentation"],
    FontSize->21],
  
  Cell[StyleData["InspectorLevel2", "SlideShow"],
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{48, 10}, {2, 12}},
    CellGroupingRules->{"SectionGrouping", 70},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    ParagraphIndent->-27,
    FontFamily->"Helvetica",
    FontSize->14,
    FontWeight->"Bold"],
  
  Cell[StyleData["InspectorLevel2", "Printout"],
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->12]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ObjectName"],
    CellFrame->{{0, 0}, {0.5, 0}},
    CellMargins->{{0, 0}, {0, 0}},
    CellGroupingRules->{"SectionGrouping", 50},
    CellFrameMargins->{{27, 12}, {3, 15}},
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontSize->18,
    FontWeight->"Bold",
    Background->RGBColor[0.960784, 0.878431, 0.666667]],
  
  Cell[StyleData["ObjectName", "Presentation"],
    FontSize->24],
  
  Cell[StyleData["ObjectName", "SlideShow"],
    CellMargins->{{72, 4}, {1, 14}},
    CellGroupingRules->{"SectionGrouping", 90},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontSize->12,
    FontWeight->"Bold"],
  
  Cell[StyleData["ObjectName", "Printout"],
    CellMargins->{{2, 0}, {1, 10}},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->12]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SubObjectNameClosed"],
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{27, 4}, {1, 10}},
    PrivateCellOptions->{"DefaultCellGroupOpen"->False},
    CellGroupingRules->{"SectionGrouping", 90},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontSize->14,
    FontWeight->"Bold"],
  
  Cell[StyleData["SubObjectNameClosed", "Presentation"],
    FontSize->21],
  
  Cell[StyleData["SubObjectNameClosed", "SlideShow"],
    CellMargins->{{72, 4}, {1, 14}},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontSize->12,
    FontWeight->"Bold"],
  
  Cell[StyleData["SubObjectNameClosed", "Printout"],
    CellMargins->{{2, 0}, {1, 10}},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->12]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SubObjectName"],
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{27, 4}, {1, 10}},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontSize->18,
    FontWeight->"Bold"],
  
  Cell[StyleData["SubObjectName", "Presentation"],
    FontSize->24],
  
  Cell[StyleData["SubObjectName", "SlideShow"],
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{90, 4}, {1, 14}},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontFamily->"Courier",
    FontSize->12],
  
  Cell[StyleData["SubObjectName", "Printout"],
    CellMargins->{{2, 0}, {1, 10}},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontFamily->"Courier",
    FontSize->12]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["GroupObjectName"],
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{27, 4}, {0, 14}},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontSize->18,
    FontWeight->"Bold"],
  
  Cell[StyleData["GroupObjectName", "Presentation"],
    FontSize->24],
  
  Cell[StyleData["GroupObjectName", "SlideShow"],
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{72, 10}, {2, 12}},
    CellGroupingRules->{"SectionGrouping", 70},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    ParagraphIndent->-27,
    CounterIncrements->"Outline2",
    FontFamily->"Courier",
    FontSize->12,
    FontWeight->"Bold"],
  
  Cell[StyleData["GroupObjectName", "Printout"],
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->14]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["GroupObjectNameClosed"],
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{27, 4}, {0, 14}},
    PrivateCellOptions->{"DefaultCellGroupOpen"->False},
    CellGroupingRules->{"SectionGrouping", 80},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontSize->18,
    FontWeight->"Bold"],
  
  Cell[StyleData["GroupObjectNameClosed", "Presentation"],
    FontSize->24],
  
  Cell[StyleData["GroupObjectNameClosed", "SlideShow"],
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{72, 10}, {2, 12}},
    CellGroupingRules->{"SectionGrouping", 70},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    ParagraphIndent->-27,
    CounterIncrements->"Outline2",
    FontFamily->"Courier",
    FontSize->12,
    FontWeight->"Bold"],
  
  Cell[StyleData["GroupObjectNameClosed", "Printout"],
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->14]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ObjectNameWarningMessages"],
    CellMargins->{{27, 4}, {1, 10}},
    CellGroupingRules->{"SectionGrouping", 65},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontSize->18,
    FontWeight->"Bold"],
  
  Cell[StyleData["ObjectNameWarningMessages", "Presentation"],
    FontSize->24],
  
  Cell[StyleData["ObjectNameWarningMessages", "SlideShow"],
    CellMargins->{{10, 4}, {1, 10}},
    CellGroupingRules->{"SectionGrouping", 65},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontFamily->"Courier",
    FontSize->16,
    FontWeight->"Bold"],
  
  Cell[StyleData["ObjectNameWarningMessages", "Printout"],
    CellMargins->{{2, 0}, {1, 10}},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->12]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Command"],
    CellFrame->{{0, 0}, {0.5, 0}},
    CellMargins->{{0, 0}, {0, 0}},
    CellFrameMargins->{{27, 12}, {3, 15}},
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    CounterIncrements->"Section",
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->18,
    FontWeight->"Bold",
    Background->RGBColor[0.960784, 0.878431, 0.666667]],
  
  Cell[StyleData["Command", "Presentation"],
    FontSize->24],
  
  Cell[StyleData["Command", "Printout"],
    CellMargins->{{2, 0}, {0, 14}},
    PageBreakBelow->False,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->14]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["CharacterName"],
    CellFrame->{{0, 0}, {0.5, 0}},
    CellMargins->{{0, 0}, {0, 0}},
    CellFrameMargins->{{27, 27}, {8, 8}},
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216]],
  
  Cell[StyleData["CharacterName", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["CharacterName", "SlideShow"],
    CellMargins->{{72, 4}, {1, 14}},
    CellGroupingRules->{"SectionGrouping", 90},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontSize->12,
    FontWeight->"Bold"],
  
  Cell[StyleData["CharacterName", "Printout"],
    CellMargins->{{2, 0}, {0, 4}},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Usage"],
    CellFrame->{{0, 0}, {0.5, 0}},
    CellMargins->{{0, 0}, {0, 0}},
    CellFrameMargins->{{27, 27}, {8, 8}},
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    Hyphenation->False,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    ParagraphSpacing->{0, 6},
    ParagraphIndent->-10,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216]],
  
  Cell[StyleData["Usage", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Usage", "SlideShow"],
    CellFrame->{{0, 0}, {0.5, 0.5}},
    CellMargins->{{72, 4}, {0, 4}},
    CellFrameMargins->5,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    ParagraphSpacing->{0, 6},
    ParagraphIndent->-10,
    StyleMenuListing->None],
  
  Cell[StyleData["Usage", "Printout"],
    CellMargins->{{2, 0}, {0, 4}},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    FontSize->10,
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ErrorMessage"],
    CellFrame->{{0, 0}, {0.5, 0.5}},
    ShowCellBracket->True,
    CellMargins->{{27, 4}, {0, 4}},
    CellGroupingRules->"OutputGrouping",
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    ShowCellLabel->False,
    CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}},
    CellFrameMargins->5,
    DefaultFormatType->DefaultOutputFormatType,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FormatType->InputForm,
    StyleMenuListing->None,
    FontColor->RGBColor[0, 0, 1]],
  
  Cell[StyleData["ErrorMessage", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ErrorMessage", "SlideShow"],
    CellMargins->{{72, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None],
  
  Cell[StyleData["ErrorMessage", "Printout"],
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->9,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Notes"],
    CellMargins->{{27, 27}, {0, 8}},
    CellHorizontalScrolling->True,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    ParagraphSpacing->{0, 6},
    ParagraphIndent->-10,
    StyleMenuListing->None,
    FontFamily->"Times"],
  
  Cell[StyleData["Notes", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Notes", "SlideShow"],
    CellMargins->{{72, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    ParagraphSpacing->{0, 6},
    ParagraphIndent->-10,
    StyleMenuListing->None,
    FontFamily->"Times"],
  
  Cell[StyleData["Notes", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    Hyphenation->True,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["NotesList"],
    CellMargins->{{20, 4}, {2, 8}},
    CellHorizontalScrolling->True,
    ScriptLevel->1,
    SingleLetterItalics->True,
    StyleMenuListing->None,
    FontFamily->"Times"],
  
  Cell[StyleData["NotesList", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["NotesList", "SlideShow"],
    CellMargins->{{82, 4}, {2, 8}},
    CellHorizontalScrolling->True,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    ScriptLevel->1,
    SingleLetterItalics->True,
    StyleMenuListing->None,
    FontFamily->"Times"],
  
  Cell[StyleData["NotesList", "Printout"],
    CellMargins->{{12, 0}, {2, 8}},
    Hyphenation->True,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ReferenceSection"],
    CellFrame->{{0, 0}, {0, 0.5}},
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{27, 4}, {0, 10}},
    CellGroupingRules->{"SectionGrouping", 30},
    CellFrameMargins->12,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Bold"],
  
  Cell[StyleData["ReferenceSection", "Presentation"],
    FontSize->20],
  
  Cell[StyleData["ReferenceSection", "Printout"],
    CellMargins->{{3, 0}, {0, 10}},
    PageBreakBelow->False,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->9,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Reference"],
    CellMargins->{{27, 27}, {0, 8}},
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-.35999999999999999, \
-.10000000000000001}, {0, 0}}, BoxBaselineShift -> -.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm], "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm]},
    ParagraphSpacing->{0, 8},
    FontSize->12],
  
  Cell[StyleData["Reference", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Reference", "SlideShow"],
    CellMargins->{{27, 27}, {4, 4}},
    Hyphenation->False,
    FontSize->14],
  
  Cell[StyleData["Reference", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    Hyphenation->True,
    FontSize->10],
  
  Cell[StyleData["Reference", "EnhancedPrintout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["Reference", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ExampleSection"],
    CellFrame->{{0, 0}, {0, 0.5}},
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{27, 4}, {0, 10}},
    CellGroupingRules->{"SectionGrouping", 70},
    CellFrameMargins->12,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Bold"],
  
  Cell[StyleData["ExampleSection", "Presentation"],
    FontSize->20],
  
  Cell[StyleData["ExampleSection", "Printout"],
    CellMargins->{{3, 0}, {0, 10}},
    PageBreakBelow->False,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->9,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ExampleText"],
    CellMargins->{{27, 40}, {0, 18}},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    ParagraphSpacing->{0, 6},
    StyleMenuListing->None,
    FontColor->RGBColor[0, 0, 0.4]],
  
  Cell[StyleData["ExampleText", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ExampleText", "Printout"],
    CellMargins->{{2, 80}, {0, 8}},
    PageBreakBelow->False,
    Hyphenation->True,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->8,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ExampleSubsection"],
    ShowCellBracket->True,
    CellMargins->{{27, 4}, {0, 16}},
    CellGroupingRules->{"SectionGrouping", 80},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->10,
    FontWeight->"Bold"],
  
  Cell[StyleData["ExampleSubsection", "Presentation"],
    FontSize->15],
  
  Cell[StyleData["ExampleSubsection", "Printout"],
    CellMargins->{{12, 0}, {0, 16}},
    PageBreakBelow->False,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->7]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MessagesSection"],
    CellFrame->{{0, 0}, {0, 0.5}},
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{27, 4}, {0, 10}},
    CellGroupingRules->{"SectionGrouping", 70},
    CellFrameMargins->12,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Bold"],
  
  Cell[StyleData["MessagesSection", "Presentation"],
    FontSize->20],
  
  Cell[StyleData["MessagesSection", "Printout"],
    CellMargins->{{3, 0}, {0, 10}},
    PageBreakBelow->False,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->9,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TemplateSection"],
    CellFrame->{{0, 0}, {0, 0.5}},
    CellMargins->{{27, 4}, {0, 10}},
    PrivateCellOptions->{"DefaultCellGroupOpen"->True},
    CellGroupingRules->{"SectionGrouping", 70},
    CellFrameMargins->12,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Bold"],
  
  Cell[StyleData["TemplateSection", "Presentation"],
    FontSize->20],
  
  Cell[StyleData["TemplateSection", "Printout"],
    CellMargins->{{3, 0}, {0, 10}},
    PageBreakBelow->False,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->9,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["LineHead"],
    CellFrame->{{0, 0}, {0.5, 0}},
    CellMargins->{{27, 4}, {8, 18}},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    CounterIncrements->"Subsection",
    CounterAssignments->{{"Subsubsection", 0}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->12,
    FontWeight->"Bold"],
  
  Cell[StyleData["LineHead", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["LineHead", "Printout"],
    CellMargins->{{2, 0}, {8, 18}},
    PageBreakBelow->False,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["FlushInput"],
    CellMargins->{{27, 4}, {1, 4}},
    Evaluatable->True,
    CellGroupingRules->"InputGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    CellLabelAutoDelete->False,
    CellLabelMargins->{{23, Inherited}, {Inherited, Inherited}},
    DefaultFormatType->DefaultInputFormatType,
    ShowSpecialCharacters->Automatic,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FormatType->StandardForm,
    ShowStringCharacters->True,
    NumberMarks->True,
    StyleMenuListing->None,
    FontWeight->"Bold"],
  
  Cell[StyleData["FlushInput", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["FlushInput", "Printout"],
    CellMargins->{{2, 0}, {1, 4}},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["FlushOutput"],
    CellMargins->{{27, Inherited}, {Inherited, Inherited}},
    CellEditDuplicate->True,
    CellGroupingRules->"OutputGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    CellLabelAutoDelete->False,
    CellLabelMargins->{{23, Inherited}, {Inherited, Inherited}},
    DefaultFormatType->DefaultOutputFormatType,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FormatType->StandardForm,
    StyleMenuListing->None],
  
  Cell[StyleData["FlushOutput", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["FlushOutput", "Printout"],
    CellMargins->{{2, Inherited}, {Inherited, Inherited}},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DialogItem"],
    CellDingbat->"\[EmptyDiamond]",
    CellMargins->{{27, 4}, {0, 12}},
    CellGroupingRules->{"SectionGrouping", 70},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->10,
    FontWeight->"Bold"],
  
  Cell[StyleData["DialogItem", "Presentation"],
    FontSize->15],
  
  Cell[StyleData["DialogItem", "Printout"],
    CellMargins->{{12, 0}, {0, 12}},
    PageBreakBelow->False,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->8]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["GroupDivider"],
    CellMargins->{{27, Inherited}, {Inherited, Inherited}},
    CellEditDuplicate->True,
    CellGroupingRules->{"TitleGrouping", 0},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None],
  
  Cell[StyleData["GroupDivider", "Presentation"],
    FontSize->18]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Highlight"],
    CellFrame->0.5,
    CellMargins->{{27, 4}, {0, 18}},
    CellFrameColor->GrayLevel[0.800015],
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->12,
    Background->GrayLevel[0.950011]],
  
  Cell[StyleData["Highlight", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Highlight", "Printout"],
    CellMargins->{{2, 0}, {0, 18}},
    Hyphenation->True,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    LineSpacing->{1, 3},
    FontSize->8]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["UserNotes"],
    CellFrame->{{3, 0}, {0, 0}},
    CellMargins->{{27, 4}, {0, 8}},
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    ParagraphIndent->-7,
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->10],
  
  Cell[StyleData["UserNotes", "Presentation"],
    FontSize->15],
  
  Cell[StyleData["UserNotes", "Printout"],
    CellMargins->{{2, 0}, {0, 4}},
    Hyphenation->True,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    LineSpacing->{1, 3},
    FontSize->8],
  
  Cell[StyleData["UserNotes", "EnhancedPrintout"],
    CellMargins->{{0, 0}, {0, 4}},
    Hyphenation->True,
    LineSpacing->{1, 3},
    FontFamily->"Frutiger 55 Roman",
    FontSize->8],
  
  Cell[StyleData["UserNotes", "EnhancedPrintoutNonGray"],
    CellMargins->{{0, 0}, {0, 4}},
    Hyphenation->True,
    LineSpacing->{1, 3},
    FontFamily->"Frutiger 55 Roman",
    FontSize->8]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MoreInfo"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    ParagraphIndent->-7,
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->10,
    Background->RGBColor[0.964706, 0.929412, 0.839216]],
  
  Cell[StyleData["MoreInfo", "Presentation"],
    FontSize->15],
  
  Cell[StyleData["MoreInfo", "Printout"],
    CellMargins->{{2, 0}, {0, 4}},
    Hyphenation->True,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    LineSpacing->{1, 3},
    FontSize->8]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["UserTips"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    ParagraphIndent->-7,
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->10,
    Background->RGBColor[0.964706, 0.929412, 0.839216]],
  
  Cell[StyleData["UserTips", "Presentation"],
    FontSize->15],
  
  Cell[StyleData["UserTips", "Printout"],
    CellMargins->{{2, 0}, {0, 4}},
    CellFrameColor->GrayLevel[0.800015],
    Hyphenation->True,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    LineSpacing->{1, 3},
    FontSize->8,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["UserTips", "EnhancedPrintout"],
    CellMargins->{{0, 0}, {0, 4}},
    CellFrameColor->GrayLevel[0],
    Hyphenation->True,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    LineSpacing->{1, 3},
    FontFamily->"Frutiger 55 Roman",
    FontSize->8,
    Background->GrayLevel[0.700008]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Theorem"],
    CellFrame->{{4, 0}, {0, 0}},
    CellMargins->{{27, 62}, {0, 14}},
    CellFrameMargins->4,
    CellFrameColor->RGBColor[0, 0, 0.8],
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    LineSpacing->{1, 1},
    ParagraphSpacing->{0, 8}],
  
  Cell[StyleData["Theorem", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Theorem", "Printout"],
    CellMargins->{{2, 0}, {0, 14}},
    CellFrameMargins->3,
    CellFrameColor->GrayLevel[0.8],
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->9,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Commentary"],
    CellFrame->{{2, 0}, {0, 0}},
    CellMargins->{{36, 10}, {7, 7}},
    PageBreakBelow->False,
    CellFrameMargins->8,
    CellFrameColor->RGBColor[0, 0.2, 1],
    LineSpacing->{1, 3},
    FontSlant->"Italic"],
  
  Cell[StyleData["Commentary", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Commentary", "Printout"],
    CellMargins->{{36, 0}, {6, 6}},
    CellFrameColor->GrayLevel[0.8],
    FontSize->10],
  
  Cell[StyleData["Commentary", "EnhancedPrintout"],
    CellMargins->{{36, 0}, {6, 6}},
    CellFrameColor->GrayLevel[0.8],
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["Commentary", "EnhancedPrintoutNonGray"],
    CellMargins->{{36, 0}, {6, 6}},
    CellFrameColor->GrayLevel[0.8],
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Level1Icon"],
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{48, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    ParagraphSpacing->{0, 8},
    StyleMenuListing->None],
  
  Cell[StyleData["Level1Icon", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Level1Icon", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Level2Icon"],
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{48, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    ParagraphSpacing->{0, 8},
    StyleMenuListing->None],
  
  Cell[StyleData["Level2Icon", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Level2Icon", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["CopyrightHead"],
    CellMargins->{{27, 4}, {0, 8}},
    PageBreakAbove->False,
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->12,
    FontWeight->"Bold"],
  
  Cell[StyleData["CopyrightHead", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["CopyrightHead", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Copyright"],
    CellMargins->{{27, 4}, {0, 8}},
    PageBreakAbove->False,
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->10],
  
  Cell[StyleData["Copyright", "Presentation"],
    FontSize->15],
  
  Cell[StyleData["Copyright", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    FontSize->8],
  
  Cell[StyleData["Copyright", "EnhancedPrintout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    FontFamily->"Frutiger 55 Roman",
    FontSize->7]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["RegisterSubsection"],
    CellDingbat->None,
    CellMargins->{{27, 27}, {0, 18}},
    CellElementSpacings->{"ClosedGroupTopMargin"->18},
    CellGroupingRules->{"SectionGrouping", 45},
    CellFrameLabelMargins->6,
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-.35999999999999999, \
-.10000000000000001}, {0, 0}}, BoxBaselineShift -> -.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm], "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm]},
    FontFamily->"Helvetica",
    FontSize->16],
  
  Cell[StyleData["RegisterSubsection", "Presentation"],
    FontSize->24],
  
  Cell[StyleData["RegisterSubsection", "SlideShow"],
    CellDingbat->None,
    CellMargins->{{70, 0}, {4, 12}},
    FontSize->12],
  
  Cell[StyleData["RegisterSubsection", "Printout"],
    CellMargins->{{9, 0}, {5, 24}},
    FontSize->12],
  
  Cell[StyleData["RegisterSubsection", "EnhancedPrintout"],
    CellMargins->{{9, 0}, {5, 20}},
    FontFamily->"Frutiger 55 Roman",
    FontSize->12],
  
  Cell[StyleData["RegisterSubsection", "EnhancedPrintoutNonGray"],
    CellMargins->{{9, 0}, {5, 20}},
    FontFamily->"Frutiger 55 Roman",
    FontSize->12]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["RegisterSubsubsection"],
    CellMargins->{{27, 27}, {0, 18}},
    CellElementSpacings->{"ClosedGroupTopMargin"->18},
    CellGroupingRules->{"SectionGrouping", 50},
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-.35999999999999999, \
-.10000000000000001}, {0, 0}}, BoxBaselineShift -> -.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm], "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm]},
    FontFamily->"Helvetica",
    FontWeight->"Bold",
    FontColor->RGBColor[0.592157, 0.313726, 0.313726]],
  
  Cell[StyleData["RegisterSubsubsection", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["RegisterSubsubsection", "Printout"],
    CellMargins->{{2, 0}, {3, 8}},
    FontSize->10],
  
  Cell[StyleData["RegisterSubsubsection", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {3, 8}},
    FontFamily->"Frutiger 65 Bold",
    FontSize->10,
    FontWeight->"Plain",
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["RegisterSubsubsection", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {3, 8}},
    FontFamily->"Frutiger 65 Bold",
    FontSize->10,
    FontWeight->"Plain",
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["RegisterText"],
    CellMargins->{{27, 4}, {0, 8}},
    PageBreakAbove->False,
    StyleMenuListing->None,
    FontSize->10],
  
  Cell[StyleData["RegisterText", "Presentation"],
    FontSize->15],
  
  Cell[StyleData["RegisterText", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    FontSize->8],
  
  Cell[StyleData["RegisterText", "EnhancedPrintout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    FontFamily->"Palatino",
    FontSize->7]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["CaptionHead"],
    CellMargins->{{27, 4}, {0, 8}},
    PageBreakAbove->False,
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->12,
    FontWeight->"Bold"],
  
  Cell[StyleData["CaptionHead", "Presentation"],
    FontSize->15],
  
  Cell[StyleData["CaptionHead", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    FontSize->8],
  
  Cell[StyleData["CaptionHead", "EnhancedPrintout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    FontFamily->"Palatino",
    FontSize->7]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["CaptionText"],
    CellMargins->{{66, 4}, {0, 8}},
    PageBreakAbove->False,
    StyleMenuListing->None],
  
  Cell[StyleData["CaptionText", "Presentation"],
    FontSize->15],
  
  Cell[StyleData["CaptionText", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    FontSize->8],
  
  Cell[StyleData["CaptionText", "EnhancedPrintout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    FontFamily->"Palatino",
    FontSize->7]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["BulletText"],
    CellMargins->{{76, 4}, {4, 4}},
    CellFrameLabels->{{
      Cell[ "\[Bullet]", "BulletText", CellBaseline -> Baseline], 
          Inherited}, {Inherited, Inherited}},
    Hyphenation->False,
    LineSpacing->{1, 3},
    CounterIncrements->"BulletText",
    StyleMenuListing->None],
  
  Cell[StyleData["BulletText", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["BulletText", "Printout"],
    FontSize->10],
  
  Cell[StyleData["BulletText", "EnhancedPrintout"],
    CellMargins->{{16, 4}, {2, 4}},
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["BulletText", "EnhancedPrintoutNonGray"],
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["HelpLabels"],
    CellMargins->{{88, 4}, {0, 8}},
    StyleMenuListing->None],
  
  Cell[StyleData["HelpLabels", "Presentation"],
    FontSize->15],
  
  Cell[StyleData["HelpLabels", "Printout"],
    CellMargins->{{34, 2}, {6, 6}},
    FontSize->10],
  
  Cell[StyleData["HelpLabels", "EnhancedPrintout"],
    CellMargins->{{34, 2}, {6, 6}},
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Manual.nb Merge", "Subsection"],
  
  Cell[CellGroupData[{
  
  Cell["Function List", "Subsubsection"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["FunctionName"],
    CellDingbat->"\[FilledSquare]",
    CellMargins->{{24, 10}, {10, 12}},
    CellGroupingRules->{"SectionGrouping", 40},
    PageBreakBelow->False,
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontSize->14,
    FontWeight->"Bold",
    CellTags->"FunctionName"],
  
  Cell[StyleData["FunctionName", "Presentation"],
    FontSize->21],
  
  Cell[StyleData["FunctionName", "Printout"],
    CellMargins->{{9, 0}, {10, 10}},
    FontSize->12],
  
  Cell[StyleData["FunctionName", "EnhancedPrintout"],
    CellMargins->{{9, 0}, {10, 10}},
    FontFamily->"Courier",
    FontSize->12],
  
  Cell[StyleData["FunctionName", "EnhancedPrintoutNonGray"],
    CellMargins->{{9, 0}, {10, 10}},
    FontFamily->"Courier",
    FontSize->12]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["FunctionSubsection"],
    CellDingbat->"\[FilledSquare]",
    CellMargins->{{36, 10}, {0, 6}},
    CellGroupingRules->{"SectionGrouping", 60},
    PageBreakBelow->False,
    StyleMenuListing->None,
    FontWeight->"Bold",
    CellTags->"FunctionSubsection"],
  
  Cell[StyleData["FunctionSubsection", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["FunctionSubsection", "Printout"],
    CellMargins->{{30, 0}, {0, 6}}],
  
  Cell[StyleData["FunctionSubsection", "EnhancedPrintout"],
    CellMargins->{{30, 0}, {0, 6}},
    FontFamily->"Palatino",
    FontSize->11],
  
  Cell[StyleData["FunctionSubsection", "EnhancedPrintoutNonGray"],
    CellMargins->{{30, 0}, {0, 6}},
    FontFamily->"Palatino",
    FontSize->11]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["FunctionDescription"],
    CellMargins->{{36, 10}, {4, 0}},
    LineSpacing->{1, 3},
    ParagraphSpacing->{0.7, 0},
    CounterIncrements->"Text",
    StyleMenuListing->None,
    FontWeight->"Plain"],
  
  Cell[StyleData["FunctionDescription", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["FunctionDescription", "Printout"],
    CellMargins->{{30, 0}, {4, 0}},
    FontSize->11],
  
  Cell[StyleData["FunctionDescription", "EnhancedPrintout"],
    CellMargins->{{30, 0}, {4, 0}},
    TextJustification->0,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["FunctionDescription", "EnhancedPrintoutNonGray"],
    CellMargins->{{30, 0}, {4, 0}},
    TextJustification->0,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["FunctionDescriptionRuled"],
    CellFrame->{{0, 0}, {0.25, 0.25}},
    CellMargins->{{36, 10}, {4, 0}},
    LineSpacing->{1, 3},
    ParagraphSpacing->{0.7, 0},
    CounterIncrements->"Text",
    StyleMenuListing->None],
  
  Cell[StyleData["FunctionDescriptionRuled", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["FunctionDescriptionRuled", "Printout"],
    CellMargins->{{30, 0}, {4, 0}},
    FontSize->11],
  
  Cell[StyleData["FunctionDescriptionRuled", "EnhancedPrintout"],
    CellMargins->{{30, 0}, {4, 0}},
    TextJustification->0,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["FunctionDescriptionRuled", "EnhancedPrintoutNonGray"],
    CellMargins->{{30, 0}, {4, 0}},
    TextJustification->0,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["FunctionDescriptionRuleTop"],
    CellFrame->{{0, 0}, {0, 0.25}},
    CellMargins->{{36, 10}, {4, 0}},
    LineSpacing->{1, 3},
    ParagraphSpacing->{0.7, 0},
    CounterIncrements->"Text",
    StyleMenuListing->None],
  
  Cell[StyleData["FunctionDescriptionRuleTop", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["FunctionDescriptionRuleTop", "Printout"],
    CellMargins->{{30, 0}, {4, 0}},
    FontSize->11],
  
  Cell[StyleData["FunctionDescriptionRuleTop", "EnhancedPrintout"],
    CellMargins->{{30, 0}, {4, 0}},
    TextJustification->0,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["FunctionDescriptionRuleTop", "EnhancedPrintoutNonGray"],
    CellMargins->{{30, 0}, {4, 0}},
    TextJustification->0,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["FunctionDescriptionRuleBottom"],
    CellFrame->{{0, 0}, {0.25, 0}},
    CellMargins->{{36, 10}, {4, 0}},
    LineSpacing->{1, 3},
    ParagraphSpacing->{0.7, 0},
    CounterIncrements->"Text",
    StyleMenuListing->None],
  
  Cell[StyleData["FunctionDescriptionRuleBottom", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["FunctionDescriptionRuleBottom", "Printout"],
    CellMargins->{{30, 0}, {4, 0}},
    FontSize->11],
  
  Cell[StyleData["FunctionDescriptionRuleBottom", "EnhancedPrintout"],
    CellMargins->{{30, 0}, {4, 0}},
    TextJustification->0,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["FunctionDescriptionRuleBottom", "EnhancedPrintoutNonGray"],
    CellMargins->{{30, 0}, {4, 0}},
    TextJustification->0,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["FunctionExample"],
    CellMargins->{{36, 10}, {4, 0}},
    StyleMenuListing->None,
    FontSize->10],
  
  Cell[StyleData["FunctionExample", "Presentation"],
    FontSize->15],
  
  Cell[StyleData["FunctionExample", "Printout"],
    CellMargins->{{30, 0}, {4, 0}},
    FontSize->9],
  
  Cell[StyleData["FunctionExample", "EnhancedPrintout"],
    CellMargins->{{30, 0}, {4, 0}},
    FontFamily->"Palatino",
    FontSize->9],
  
  Cell[StyleData["FunctionExample", "EnhancedPrintoutNonGray"],
    CellMargins->{{30, 0}, {4, 0}},
    FontFamily->"Palatino",
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["FunctionTextNote"],
    CellMargins->{{36, 4}, {0, 4}},
    LineSpacing->{1, 3},
    ParagraphSpacing->{0, 4},
    LineIndent->0,
    StyleMenuListing->None],
  
  Cell[StyleData["FunctionTextNote", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["FunctionTextNote", "Printout"],
    CellMargins->{{36, 4}, {0, 4}},
    FontSize->9],
  
  Cell[StyleData["FunctionTextNote", "EnhancedPrintout"],
    CellMargins->{{36, 4}, {0, 4}},
    FontFamily->"Palatino",
    FontSize->8],
  
  Cell[StyleData["FunctionTextNote", "EnhancedPrintoutNonGray"],
    CellMargins->{{36, 4}, {0, 4}},
    FontFamily->"Palatino",
    FontSize->8]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["3ColumnFunctionTable"],
    CellMargins->{{36, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->2,
    ColumnWidths->{0.28, 0.28, 0.43},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["3ColumnFunctionTable", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["3ColumnFunctionTable", "Printout"],
    CellMargins->{{30, 0}, {0, 8}},
    FontSize->10],
  
  Cell[StyleData["3ColumnFunctionTable", "EnhancedPrintout"],
    CellMargins->{{30, 0}, {0, 8}},
    FontSize->10],
  
  Cell[StyleData["3ColumnFunctionTable", "EnhancedPrintoutNonGray"],
    CellMargins->{{30, 0}, {0, 8}},
    FontSize->10]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Browser Emulation", "Subsubsection"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TextNormal"],
    CellMargins->{{12, 10}, {7, 7}},
    LineSpacing->{1, 3},
    CounterIncrements->"Text",
    StyleMenuListing->None,
    FontFamily->"Times",
    FontSize->12],
  
  Cell[StyleData["TextNormal", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["TextNormal", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["BrowserEmulation"],
    CellMargins->{{12, 1}, {7, 24}},
    CellGroupingRules->{"SectionGrouping", 70},
    LineSpacing->{1, 3},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    GridBoxOptions->{ColumnWidths->0.25,
    ColumnAlignments->{Left},
    GridFrame->True,
    GridFrameMargins->0.5,
    ColumnLines->True}],
  
  Cell[StyleData["BrowserEmulation", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["BrowserEmulation", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["CategoryDefs"],
    CellMargins->{{300, 10}, {7, 7}},
    LineSpacing->{1, 3},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    Background->RGBColor[1, 0.8, 0.6],
    GridBoxOptions->{ColumnAlignments->{Left},
    GridFrame->False,
    RowLines->True,
    ColumnLines->True}],
  
  Cell[StyleData["CategoryDefs", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["CategoryDefs", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Category1"],
    ShowCellBracket->False,
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{12, 10}, {7, 7}},
    CellGroupingRules->{"SectionGrouping", 50},
    StyleMenuListing->None,
    FontSize->16,
    FontWeight->"Bold"],
  
  Cell[StyleData["Category1", "Presentation"],
    FontSize->24],
  
  Cell[StyleData["Category1", "Printout"],
    CellMargins->{{2, 2}, {6, 6}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Category2"],
    ShowCellBracket->False,
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{85, 10}, {7, 7}},
    CellGroupingRules->{"SectionGrouping", 60},
    StyleMenuListing->None,
    FontSize->14,
    FontWeight->"Bold",
    FontColor->RGBColor[0, 0, 0.500008]],
  
  Cell[StyleData["Category2", "Presentation"],
    FontSize->21],
  
  Cell[StyleData["Category2", "Printout"],
    CellMargins->{{2, 2}, {6, 6}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Category3"],
    ShowCellBracket->False,
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{157, 10}, {7, 7}},
    CellGroupingRules->{"SectionGrouping", 70},
    StyleMenuListing->None,
    FontSize->12,
    FontWeight->"Bold",
    FontColor->RGBColor[0.2, 0, 0.4]],
  
  Cell[StyleData["Category3", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Category3", "Printout"],
    CellMargins->{{2, 2}, {6, 6}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Category4"],
    ShowCellBracket->False,
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{230, 10}, {7, 7}},
    CellGroupingRules->{"SectionGrouping", 80},
    StyleMenuListing->None,
    FontWeight->"Bold",
    FontColor->RGBColor[0, 0.300008, 0.4]],
  
  Cell[StyleData["Category4", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Category4", "Printout"],
    CellMargins->{{2, 2}, {6, 6}}]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Misc", "Subsubsection"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["4ColumnTable"],
    CellMargins->{{10, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->2,
    ColumnWidths->0.25,
    ColumnAlignments->{Left, Center}}],
  
  Cell[StyleData["4ColumnTable", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["4ColumnTable", "Printout"],
    CellMargins->{{2, 0}, {0, 8}}],
  
  Cell[StyleData["4ColumnTable", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}}],
  
  Cell[StyleData["4ColumnTable", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["5ColumnTable"],
    CellMargins->{{10, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->2,
    ColumnWidths->0.2,
    ColumnAlignments->{Left, Center}}],
  
  Cell[StyleData["5ColumnTable", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["5ColumnTable", "Printout"],
    CellMargins->{{2, 0}, {0, 8}}],
  
  Cell[StyleData["5ColumnTable", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}}],
  
  Cell[StyleData["5ColumnTable", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["6ColumnTable"],
    CellMargins->{{10, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->2,
    ColumnWidths->0.16,
    ColumnAlignments->{Left, Center}}],
  
  Cell[StyleData["6ColumnTable", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["6ColumnTable", "Printout"],
    CellMargins->{{2, 0}, {0, 8}}],
  
  Cell[StyleData["6ColumnTable", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}}],
  
  Cell[StyleData["6ColumnTable", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["7ColumnTable"],
    CellMargins->{{10, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->2,
    ColumnWidths->0.14,
    ColumnAlignments->{Left, Center}}],
  
  Cell[StyleData["7ColumnTable", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["7ColumnTable", "Printout"],
    CellMargins->{{2, 0}, {0, 8}}],
  
  Cell[StyleData["7ColumnTable", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}}],
  
  Cell[StyleData["7ColumnTable", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["8ColumnTable"],
    CellMargins->{{10, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->2,
    ColumnWidths->0.12,
    ColumnAlignments->{Left, Center}}],
  
  Cell[StyleData["8ColumnTable", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["8ColumnTable", "Printout"],
    CellMargins->{{2, 0}, {0, 8}}],
  
  Cell[StyleData["8ColumnTable", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}}],
  
  Cell[StyleData["8ColumnTable", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ABItemizedText"],
    CellMargins->{{20, 4}, {0, 5}},
    LineSpacing->{1, 3},
    ParagraphIndent->-21,
    CounterIncrements->"ItemizedText",
    StyleMenuListing->None],
  
  Cell[StyleData["ABItemizedText", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ABItemizedText", "Printout"],
    Hyphenation->True,
    ParagraphIndent->-21,
    FontSize->11],
  
  Cell[StyleData["ABItemizedText", "EnhancedPrintout"],
    Hyphenation->True,
    ParagraphIndent->-21,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["ABItemizedText", "EnhancedPrintoutNonGray"],
    Hyphenation->True,
    ParagraphIndent->-21,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ChapNumber"],
    CellMargins->{{27, Inherited}, {20, 40}},
    CellGroupingRules->{"TitleGrouping", 0},
    PageBreakBelow->False,
    DefaultNewInlineCellStyle->"None",
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-.35999999999999999, \
-.10000000000000001}, {0, 0}}, BoxBaselineShift -> -.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm], "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm]},
    LanguageCategory->"NaturalLanguage",
    CounterIncrements->"Title",
    CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}, {
        "Subtitle", 0}, {"Subsubtitle", 0}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->42,
    FontWeight->"Plain",
    FontColor->RGBColor[0.592157, 0.313726, 0.313726]],
  
  Cell[StyleData["ChapNumber", "Presentation"],
    FontSize->63],
  
  Cell[StyleData["ChapNumber", "Printout"],
    CellMargins->{{2, 10}, {15, 30}},
    FontSize->36],
  
  Cell[StyleData["ChapNumber", "EnhancedPrintout"],
    CellMargins->{{2, 10}, {15, 30}},
    FontFamily->"Frutiger 55 Roman",
    FontSize->36,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["ChapNumber", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 10}, {15, 30}},
    FontFamily->"Frutiger 55 Roman",
    FontSize->36,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ChapTitle"],
    CellMargins->{{27, Inherited}, {80, 10}},
    CellGroupingRules->{"TitleGrouping", 0},
    PageBreakBelow->False,
    DefaultNewInlineCellStyle->"None",
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-.35999999999999999, \
-.10000000000000001}, {0, 0}}, BoxBaselineShift -> -.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm], "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm]},
    LanguageCategory->"NaturalLanguage",
    CounterIncrements->"Title",
    CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}, {
        "Subtitle", 0}, {"Subsubtitle", 0}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->36,
    FontWeight->"Bold",
    FontColor->RGBColor[0.592157, 0.313726, 0.313726]],
  
  Cell[StyleData["ChapTitle", "Presentation"],
    FontSize->54],
  
  Cell[StyleData["ChapTitle", "Printout"],
    CellMargins->{{2, 10}, {80, 6}},
    FontSize->30],
  
  Cell[StyleData["ChapTitle", "EnhancedPrintout"],
    CellMargins->{{2, 10}, {80, 6}},
    FontFamily->"Frutiger 65 Bold",
    FontSize->30,
    FontWeight->"Plain",
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["ChapTitle", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 10}, {80, 6}},
    FontFamily->"Frutiger 65 Bold",
    FontSize->30,
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemDingbat"],
    CellSize->{22, 14},
    TextAlignment->Right,
    StyleMenuListing->None,
    FontWeight->"Bold"],
  
  Cell[StyleData["ItemDingbat", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemDingbat", "Printout"],
    CellSize->{22, 13.125}],
  
  Cell[StyleData["ItemDingbat", "EnhancedPrintout"],
    CellSize->{22, 11}],
  
  Cell[StyleData["ItemDingbat", "EnhancedPrintoutNonGray"],
    CellSize->{22, 11}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Item1"],
    CellMargins->{{19, 4}, {4, 4}},
    ParagraphIndent->-22,
    CounterIncrements->"Item1",
    StyleMenuListing->None],
  
  Cell[StyleData["Item1", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Item1", "Printout"],
    CellMargins->{{12, 0}, {2, 4}},
    FontSize->10],
  
  Cell[StyleData["Item1", "EnhancedPrintout"],
    CellMargins->{{16, 0}, {2, 4}},
    FontSize->10],
  
  Cell[StyleData["Item1", "EnhancedPrintoutNonGray"],
    CellMargins->{{16, 0}, {2, 4}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Item1Continued"],
    CellMargins->{{41, 4}, {4, 1}},
    CounterIncrements->"Item1Continued",
    StyleMenuListing->None],
  
  Cell[StyleData["Item1Continued", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Item1Continued", "Printout"],
    CellMargins->{{34, 0}, {4, 1}},
    FontSize->10],
  
  Cell[StyleData["Item1Continued", "EnhancedPrintout"],
    CellMargins->{{39, 0}, {4, 1}},
    FontSize->10],
  
  Cell[StyleData["Item1Continued", "EnhancedPrintoutNonGray"],
    CellMargins->{{39, 0}, {4, 1}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Item2"],
    CellMargins->{{32, 4}, {4, 4}},
    ParagraphIndent->-22,
    CounterIncrements->"Item2",
    StyleMenuListing->None],
  
  Cell[StyleData["Item2", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Item2", "Printout"],
    CellMargins->{{26, 0}, {4, 4}},
    ParagraphIndent->-22,
    FontSize->10],
  
  Cell[StyleData["Item2", "EnhancedPrintout"],
    CellMargins->{{29, 0}, {2, 4}},
    ParagraphIndent->-22,
    FontSize->10],
  
  Cell[StyleData["Item2", "EnhancedPrintoutNonGray"],
    CellMargins->{{29, 0}, {2, 4}},
    ParagraphIndent->-22,
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Item2Continued"],
    CellMargins->{{54, 4}, {4, 1}},
    CounterIncrements->"Item2Continued",
    StyleMenuListing->None],
  
  Cell[StyleData["Item2Continued", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Item2Continued", "Printout"],
    CellMargins->{{27, 0}, {4, 1}}],
  
  Cell[StyleData["Item2Continued", "EnhancedPrintout"],
    CellMargins->{{52, 0}, {4, 1}},
    FontSize->10],
  
  Cell[StyleData["Item2Continued", "EnhancedPrintoutNonGray"],
    CellMargins->{{52, 0}, {4, 1}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Item3"],
    CellMargins->{{45, 4}, {4, 4}},
    ParagraphIndent->-23,
    CounterIncrements->"Item3",
    StyleMenuListing->None],
  
  Cell[StyleData["Item3", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Item3", "Printout"],
    CellMargins->{{27, 0}, {2, 4}}],
  
  Cell[StyleData["Item3", "EnhancedPrintout"],
    CellMargins->{{42, 0}, {2, 4}},
    FontSize->10],
  
  Cell[StyleData["Item3", "EnhancedPrintoutNonGray"],
    CellMargins->{{42, 0}, {2, 4}},
    StyleMenuListing->None]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Item3Continued"],
    CellMargins->{{67, 4}, {4, 1}},
    CounterIncrements->"Item3Continued",
    StyleMenuListing->None],
  
  Cell[StyleData["Item3Continued", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Item3Continued", "Printout"],
    CellMargins->{{27, 0}, {4, 1}}],
  
  Cell[StyleData["Item3Continued", "EnhancedPrintout"],
    CellMargins->{{65, 0}, {4, 1}},
    FontSize->10],
  
  Cell[StyleData["Item3Continued", "EnhancedPrintoutNonGray"],
    CellMargins->{{65, 0}, {4, 1}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemizedBulletText"],
    CellMargins->{{19, 4}, {0, 5}},
    LineSpacing->{1, 3},
    ParagraphIndent->-22,
    CounterIncrements->"ItemizedBulletText",
    StyleMenuListing->None],
  
  Cell[StyleData["ItemizedBulletText", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemizedBulletText", "Printout"],
    Hyphenation->True,
    ParagraphIndent->-20,
    FontSize->11],
  
  Cell[StyleData["ItemizedBulletText", "EnhancedPrintout"],
    Hyphenation->True,
    ParagraphIndent->-19,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["ItemizedBulletText", "EnhancedPrintoutNonGray"],
    Hyphenation->True,
    ParagraphIndent->-19,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["NoteBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {8, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxMargins->{{1, 1}, {1.5, 1.5}}},
    GridBoxOptions->{ColumnSpacings->1}],
  
  Cell[StyleData["NoteBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["NoteBox", "Printout"],
    CellMargins->{{2, 4}, {6, 2}},
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["NoteBox", "EnhancedPrintout"],
    CellMargins->{{2, 2}, {6, 2}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["NoteBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 4}, {6, 2}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemizedNoteBox"],
    CellFrame->0.5,
    CellMargins->{{41, 4}, {8, 2}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxMargins->{{1, 1}, {1.5, 1.5}}},
    GridBoxOptions->{ColumnSpacings->1}],
  
  Cell[StyleData["ItemizedNoteBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemizedNoteBox", "Printout"],
    CellMargins->{{39, 4}, {6, 2}},
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["ItemizedNoteBox", "EnhancedPrintout"],
    CellMargins->{{39, 4}, {6, 2}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["ItemizedNoteBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{39, 4}, {6, 2}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemizedTopBox"],
    CellFrame->{{0.5, 0.5}, {0, 0.5}},
    CellMargins->{{37, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    CellFrameMargins->{{8, 8}, {0, 8}},
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.31, 0.62},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["ItemizedTopBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemizedTopBox", "Printout"],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["ItemizedTopBox", "EnhancedPrintout"],
    CellMargins->{{39, 4}, {0, 6}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["ItemizedTopBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{39, 4}, {0, 6}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemizedBottomBox"],
    CellFrame->{{0.5, 0.5}, {0.5, 0}},
    CellMargins->{{37, 4}, {4, 0}},
    CellHorizontalScrolling->True,
    CellFrameMargins->{{8, 8}, {8, 0}},
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.31, 0.62},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["ItemizedBottomBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemizedBottomBox", "Printout"],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["ItemizedBottomBox", "EnhancedPrintout"],
    CellMargins->{{39, 4}, {6, 0}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["ItemizedBottomBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{39, 4}, {6, 0}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MiddleSpacedBox"],
    CellFrame->{{0.5, 0.5}, {0, 0}},
    CellMargins->{{27, 12}, {0, -7}},
    CellHorizontalScrolling->True,
    PageBreakAbove->False,
    PageBreakBelow->False,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    FontWeight->"Plain",
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.31, 0.62},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["MiddleSpacedBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["MiddleSpacedBox", "Printout"],
    CellMargins->{{2, 0}, {0, 0}},
    Background->GrayLevel[1],
    GridBoxOptions->{RowMinHeight->1.8}],
  
  Cell[StyleData["MiddleSpacedBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 0}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    Background->GrayLevel[1],
    GridBoxOptions->{RowMinHeight->1.8}],
  
  Cell[StyleData["MiddleSpacedBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 0}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    Background->GrayLevel[1],
    GridBoxOptions->{RowMinHeight->1.8}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemizedNote"],
    CellMargins->{{41, 4}, {0, 12}},
    LineSpacing->{1, 2},
    CounterIncrements->"Text",
    StyleMenuListing->None],
  
  Cell[StyleData["ItemizedNote", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemizedNote", "Printout"],
    CellMargins->{{38, 4}, {0, 9}},
    Hyphenation->True,
    FontSize->11],
  
  Cell[StyleData["ItemizedNote", "EnhancedPrintout"],
    CellMargins->{{38, 4}, {0, 0}},
    TextJustification->1,
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["ItemizedNote", "EnhancedPrintoutNonGray"],
    CellMargins->{{38, 4}, {0, 0}},
    TextJustification->1,
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemizedNoteBelow"],
    CellMargins->{{41, 4}, {0, 8}},
    LineSpacing->{1, 2},
    CounterIncrements->"Text",
    StyleMenuListing->None],
  
  Cell[StyleData["ItemizedNoteBelow", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemizedNoteBelow", "Printout"],
    CellMargins->{{38, 4}, {0, 12}},
    Hyphenation->True,
    FontSize->11],
  
  Cell[StyleData["ItemizedNoteBelow", "EnhancedPrintout"],
    CellMargins->{{38, 4}, {0, 8}},
    TextJustification->1,
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["ItemizedNoteBelow", "EnhancedPrintoutNonGray"],
    CellMargins->{{38, 4}, {0, 8}},
    TextJustification->1,
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemizedTextBelowPic"],
    CellMargins->{{19, 4}, {0, 8}},
    LineSpacing->{1, 3},
    ParagraphIndent->-22,
    CounterIncrements->"ItemizedText",
    StyleMenuListing->None],
  
  Cell[StyleData["ItemizedTextBelowPic", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemizedTextBelowPic", "Printout"],
    CellMargins->{{20, 4}, {2, 12}},
    Hyphenation->True,
    ParagraphIndent->-18,
    FontSize->11],
  
  Cell[StyleData["ItemizedTextBelowPic", "EnhancedPrintout"],
    CellMargins->{{20, 4}, {2, 12}},
    Hyphenation->True,
    ParagraphIndent->-17,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["ItemizedTextBelowPic", "EnhancedPrintoutNonGray"],
    CellMargins->{{20, 4}, {2, 12}},
    Hyphenation->True,
    ParagraphIndent->-17,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemizedTextNote2"],
    CellMargins->{{41, 4}, {0, 4}},
    LineSpacing->{1, 2},
    CounterIncrements->"Text",
    StyleMenuListing->None],
  
  Cell[StyleData["ItemizedTextNote2", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemizedTextNote2", "Printout"],
    CellMargins->{{38, 4}, {0, 2}},
    Hyphenation->True,
    FontSize->11],
  
  Cell[StyleData["ItemizedTextNote2", "EnhancedPrintout"],
    CellMargins->{{38, 4}, {0, 2}},
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["ItemizedTextNote2", "EnhancedPrintoutNonGray"],
    CellMargins->{{38, 4}, {0, 2}},
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["NumberedItem1"],
    CellMargins->{{48, 4}, {4, 4}},
    CellGroupingRules->{"SectionGrouping", 15},
    ParagraphIndent->-23,
    CounterIncrements->"NumberedItem1",
    StyleMenuListing->None],
  
  Cell[StyleData["NumberedItem1", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["NumberedItem1", "Printout"],
    CellMargins->{{12, 0}, {0, 8}}],
  
  Cell[StyleData["NumberedItem1", "EnhancedPrintout"],
    CellMargins->{{12, 0}, {0, 8}}],
  
  Cell[StyleData["NumberedItem1", "EnhancedPrintoutNonGray"],
    CellMargins->{{12, 0}, {0, 8}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["NumberedItem2"],
    CellMargins->{{71, 4}, {3, 3}},
    CellGroupingRules->{"SectionGrouping", 15},
    ParagraphIndent->-21,
    CounterIncrements->"NumberedItem2",
    StyleMenuListing->None],
  
  Cell[StyleData["NumberedItem2", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["NumberedItem2", "Printout"],
    CellMargins->{{27, 0}, {0, 4}}],
  
  Cell[StyleData["NumberedItem2", "EnhancedPrintout"],
    CellMargins->{{27, 0}, {0, 4}}],
  
  Cell[StyleData["NumberedItem2", "EnhancedPrintoutNonGray"],
    CellMargins->{{27, 0}, {0, 4}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["NumberedItem3"],
    CellMargins->{{94, 4}, {2, 2}},
    CellGroupingRules->{"SectionGrouping", 15},
    ParagraphIndent->-23,
    CounterIncrements->"NumberedItem3",
    StyleMenuListing->None],
  
  Cell[StyleData["NumberedItem3", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["NumberedItem3", "Printout"],
    CellMargins->{{27, 0}, {0, 4}}],
  
  Cell[StyleData["NumberedItem3", "EnhancedPrintout"],
    CellMargins->{{27, 0}, {0, 4}}],
  
  Cell[StyleData["NumberedItem3", "EnhancedPrintoutNonGray"],
    CellMargins->{{27, 0}, {0, 4}},
    StyleMenuListing->None]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PageHeaderBold"],
    CellMargins->{{0, 0}, {2, 0}},
    StyleMenuListing->None,
    FontSize->8,
    FontWeight->"Bold",
    FontSlant->"Italic"],
  
  Cell[StyleData["PageHeaderBold", "Printout"]],
  
  Cell[StyleData["PageHeaderBold", "EnhancedPrintout"],
    FontFamily->"Frutiger"],
  
  Cell[StyleData["PageHeaderBold", "EnhancedPrintoutNonGray"],
    FontFamily->"Frutiger"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SingleRowTable"],
    CellMargins->{{10, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->2,
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["SingleRowTable", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["SingleRowTable", "Printout"],
    CellMargins->{{2, 0}, {0, 8}}],
  
  Cell[StyleData["SingleRowTable", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}}],
  
  Cell[StyleData["SingleRowTable", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subsubsubsection"],
    CellMargins->{{27, 4}, {0, 18}},
    CellElementSpacings->{"ClosedGroupTopMargin"->18},
    StyleMenuListing->None,
    FontSize->12,
    FontWeight->"Bold"],
  
  Cell[StyleData["Subsubsubsection", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Subsubsubsection", "Printout"],
    CellMargins->{{2, 0}, {3, 8}},
    FontSize->10],
  
  Cell[StyleData["Subsubsubsection", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {3, 8}},
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["Subsubsubsection", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {3, 8}},
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subsubtitle"],
    CellMargins->{{27, Inherited}, {20, 15}},
    CellGroupingRules->{"TitleGrouping", 20},
    PageBreakBelow->False,
    DefaultNewInlineCellStyle->"None",
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-.35999999999999999, \
-.10000000000000001}, {0, 0}}, BoxBaselineShift -> -.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm], "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm]},
    LanguageCategory->"NaturalLanguage",
    CounterIncrements->"Subsubtitle",
    CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->14,
    FontSlant->"Italic"],
  
  Cell[StyleData["Subsubtitle", "Presentation"],
    FontSize->21],
  
  Cell[StyleData["Subsubtitle", "Printout"],
    CellMargins->{{2, 10}, {8, 10}},
    FontSize->12],
  
  Cell[StyleData["Subsubtitle", "EnhancedPrintout"],
    CellMargins->{{2, 10}, {8, 10}},
    FontFamily->"Frutiger 55 Roman",
    FontSize->12],
  
  Cell[StyleData["Subsubtitle", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 10}, {8, 10}},
    FontFamily->"Frutiger 55 Roman",
    FontSize->12]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subtitle"],
    CellMargins->{{27, Inherited}, {20, 15}},
    CellGroupingRules->{"TitleGrouping", 10},
    PageBreakBelow->False,
    DefaultNewInlineCellStyle->"None",
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-.35999999999999999, \
-.10000000000000001}, {0, 0}}, BoxBaselineShift -> -.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm], "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm]},
    LanguageCategory->"NaturalLanguage",
    CounterIncrements->"Subtitle",
    CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}, {
        "Subsubtitle", 0}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->24],
  
  Cell[StyleData["Subtitle", "Presentation"],
    FontSize->36],
  
  Cell[StyleData["Subtitle", "Printout"],
    CellMargins->{{2, 10}, {10, 15}},
    FontSize->24],
  
  Cell[StyleData["Subtitle", "EnhancedPrintout"],
    CellMargins->{{2, 10}, {10, 15}},
    FontFamily->"Frutiger 55 Roman",
    FontSize->24],
  
  Cell[StyleData["Subtitle", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 10}, {10, 15}},
    FontFamily->"Frutiger 55 Roman",
    FontSize->24]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TextBelow"],
    CellMargins->{{27, 4}, {0, 14}},
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-.35999999999999999, \
-.10000000000000001}, {0, 0}}, BoxBaselineShift -> -.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm], "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm]},
    ParagraphSpacing->{0, 8},
    StyleMenuListing->None,
    FontSize->12],
  
  Cell[StyleData["TextBelow", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["TextBelow", "Printout"],
    CellMargins->{{2, 2}, {6, 12}},
    TextJustification->1,
    Hyphenation->True,
    FontSize->10],
  
  Cell[StyleData["TextBelow", "EnhancedPrintout"],
    CellMargins->{{2, 2}, {6, 12}},
    TextJustification->1,
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["TextBelow", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 2}, {6, 12}},
    TextJustification->1,
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Title"],
    CellMargins->{{27, Inherited}, {20, 40}},
    CellGroupingRules->{"TitleGrouping", 0},
    PageBreakBelow->False,
    DefaultNewInlineCellStyle->"None",
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-.35999999999999999, \
-.10000000000000001}, {0, 0}}, BoxBaselineShift -> -.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm], "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm]},
    LanguageCategory->"NaturalLanguage",
    CounterIncrements->"Title",
    CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}, {
        "Subtitle", 0}, {"Subsubtitle", 0}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->36,
    FontWeight->"Bold"],
  
  Cell[StyleData["Title", "Presentation"],
    FontSize->54],
  
  Cell[StyleData["Title", "Printout"],
    CellMargins->{{2, 10}, {15, 30}},
    FontSize->30],
  
  Cell[StyleData["Title", "EnhancedPrintout"],
    CellMargins->{{2, 10}, {15, 30}},
    FontFamily->"Frutiger 65 Bold",
    FontSize->30.5,
    FontWeight->"Plain"],
  
  Cell[StyleData["Title", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 10}, {15, 30}},
    FontFamily->"Frutiger 65 Bold",
    FontSize->30.5,
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Undersubsection"],
    CellMargins->{{10, 4}, {0, 18}},
    CellElementSpacings->{"ClosedGroupTopMargin"->18},
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-.35999999999999999, \
-.10000000000000001}, {0, 0}}, BoxBaselineShift -> -.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm], "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm]},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->12,
    FontWeight->"Bold"],
  
  Cell[StyleData["Undersubsection", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Undersubsection", "Printout"],
    CellMargins->{{2, 0}, {7, 10}},
    FontSize->10],
  
  Cell[StyleData["Undersubsection", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {7, 8}},
    FontFamily->"Frutiger 65 Bold",
    FontSize->10,
    FontWeight->"Plain"],
  
  Cell[StyleData["Undersubsection", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {7, 8}},
    FontFamily->"Frutiger 65 Bold",
    FontSize->10,
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SectionFirst"],
    CellMargins->{{27, 27}, {12, 18}},
    CellGroupingRules->{"SectionGrouping", 30},
    PageBreakBelow->False,
    CounterIncrements->"Section",
    FontFamily->"Helvetica",
    FontSize->20,
    FontWeight->"Bold",
    FontColor->RGBColor[0.592157, 0.313726, 0.313726]],
  
  Cell[StyleData["SectionFirst", "Presentation"],
    FontSize->30],
  
  Cell[StyleData["SectionFirst", "Printout"],
    CellMargins->{{2, 0}, {0, 6}},
    PageBreakBelow->False,
    FontSize->18],
  
  Cell[StyleData["SectionFirst", "EnhancedPrintout"],
    CellFrame->{{0, 0}, {0.5, 0}},
    CellMargins->{{2, Inherited}, {5, 6}},
    CellGroupingRules->{"SectionGrouping", 30},
    PageBreakBelow->False,
    CellFrameMargins->8,
    CounterIncrements->"Section",
    CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}},
    FontFamily->"Frutiger 65 Bold",
    FontSize->16,
    FontWeight->"Plain",
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["SectionFirst", "EnhancedPrintoutNonGray"],
    CellFrame->{{0, 0}, {0.5, 0}},
    CellMargins->{{2, Inherited}, {5, 6}},
    CellGroupingRules->{"SectionGrouping", 30},
    PageBreakBelow->False,
    CellFrameMargins->8,
    CounterIncrements->"Section",
    CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}},
    FontFamily->"Frutiger 65 Bold",
    FontSize->16,
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SubsectionFirst"],
    CellDingbat->None,
    CellMargins->{{27, 27}, {0, 18}},
    CellElementSpacings->{"ClosedGroupTopMargin"->18},
    CellGroupingRules->{"SectionGrouping", 40},
    PageBreakBelow->False,
    FontFamily->"Helvetica",
    FontSize->16,
    FontWeight->"Bold",
    FontColor->RGBColor[0.592157, 0.313726, 0.313726]],
  
  Cell[StyleData["SubsectionFirst", "Presentation"],
    FontSize->24],
  
  Cell[StyleData["SubsectionFirst", "SlideShow"],
    CellDingbat->None,
    CellMargins->{{70, 0}, {4, 6}},
    FontSize->12],
  
  Cell[StyleData["SubsectionFirst", "Printout"],
    CellMargins->{{9, 0}, {5, 6}},
    CellBracketOptions->{"Color"->RGBColor[1, 0, 0]},
    FontSize->12],
  
  Cell[StyleData["SubsectionFirst", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {5, 6}},
    CellBracketOptions->{"Color"->RGBColor[1, 0, 0]},
    FontFamily->"Frutiger 65 Bold",
    FontSize->12,
    FontWeight->"Plain",
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["SubsectionFirst", "EnhancedPrintoutNonGray"],
    CellMargins->{{9, 0}, {5, 6}},
    CellBracketOptions->{"Color"->RGBColor[1, 0, 0]},
    FontFamily->"Frutiger 65 Bold",
    FontSize->12,
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SubsubsectionFirst"],
    CellMargins->{{27, 27}, {0, 18}},
    CellElementSpacings->{"ClosedGroupTopMargin"->18},
    CellGroupingRules->{"SectionGrouping", 50},
    PageBreakBelow->False,
    FontFamily->"Helvetica",
    FontSize->12,
    FontWeight->"Bold",
    FontColor->RGBColor[0.592157, 0.313726, 0.313726]],
  
  Cell[StyleData["SubsubsectionFirst", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["SubsubsectionFirst", "Printout"],
    CellMargins->{{2, 0}, {3, 3}},
    CellBracketOptions->{"Color"->RGBColor[1, 0, 0]},
    FontSize->10],
  
  Cell[StyleData["SubsubsectionFirst", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {3, 3}},
    CellBracketOptions->{"Color"->RGBColor[1, 0, 0]},
    FontFamily->"Frutiger 65 Bold",
    FontSize->10,
    FontWeight->"Plain",
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["SubsubsectionFirst", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {3, 3}},
    CellBracketOptions->{"Color"->RGBColor[1, 0, 0]},
    FontFamily->"Frutiger 65 Bold",
    FontSize->10,
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SubsubsubsectionFirst"],
    CellMargins->{{10, 4}, {0, 12}},
    CellElementSpacings->{"ClosedGroupTopMargin"->18},
    StyleMenuListing->None,
    FontSize->12,
    FontWeight->"Bold"],
  
  Cell[StyleData["SubsubsubsectionFirst", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["SubsubsubsectionFirst", "Printout"],
    CellMargins->{{2, 0}, {3, 3}},
    FontSize->10],
  
  Cell[StyleData["SubsubsubsectionFirst", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {3, 3}},
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["SubsubsubsectionFirst", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {3, 3}},
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell["Spacer Cell", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Spacer"],
    CellMargins->{{10, 10}, {0, 0}},
    CellElementSpacings->{"CellMinHeight"->2,
    "ClosedCellHeight"->1},
    CellOpen->False,
    StyleMenuListing->None],
  
  Cell[StyleData["Spacer", "Printout"],
    CellOpen->True,
    FontSize->3]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DiscretionaryHyphen"],
    StyleMenuListing->None,
    FontSize->0.0625,
    FontColor->GrayLevel[1]],
  
  Cell[StyleData["DiscretionaryHyphen", "Printout"],
    FontSize->10,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["DiscretionaryHyphen", "EnhancedPrintout"],
    FontSize->10,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["DiscretionaryHyphen", "EnhancedPrintoutNonGray"],
    FontSize->10,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PictureSmaller1"],
    CellMargins->{{10, Inherited}, {4, 4}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["PictureSmaller1", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["PictureSmaller1", "Printout"],
    CellMargins->{{2, Inherited}, {4, 4}},
    Magnification->0.63],
  
  Cell[StyleData["PictureSmaller1", "EnhancedPrintout"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.63],
  
  Cell[StyleData["PictureSmaller1", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.63]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PictureSmaller2"],
    CellMargins->{{10, Inherited}, {4, 4}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["PictureSmaller2", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["PictureSmaller2", "Printout"],
    CellMargins->{{2, Inherited}, {4, 4}},
    Magnification->0.61],
  
  Cell[StyleData["PictureSmaller2", "EnhancedPrintout"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.61],
  
  Cell[StyleData["PictureSmaller2", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.61]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PictureSmaller3"],
    CellMargins->{{10, Inherited}, {4, 4}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["PictureSmaller3", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["PictureSmaller3", "Printout"],
    CellMargins->{{2, Inherited}, {4, 4}},
    Magnification->0.59],
  
  Cell[StyleData["PictureSmaller3", "EnhancedPrintout"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.59],
  
  Cell[StyleData["PictureSmaller3", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.59]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PictureSmaller4"],
    CellMargins->{{10, Inherited}, {4, 4}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["PictureSmaller4", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["PictureSmaller4", "Printout"],
    CellMargins->{{2, Inherited}, {4, 4}},
    Magnification->0.57],
  
  Cell[StyleData["PictureSmaller4", "EnhancedPrintout"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.57],
  
  Cell[StyleData["PictureSmaller4", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.57]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PictureSmaller5"],
    CellMargins->{{10, Inherited}, {4, 4}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["PictureSmaller5", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["PictureSmaller5", "Printout"],
    CellMargins->{{2, Inherited}, {4, 4}},
    Magnification->0.55],
  
  Cell[StyleData["PictureSmaller5", "EnhancedPrintout"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.55],
  
  Cell[StyleData["PictureSmaller5", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.55]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PictureSmaller6"],
    CellMargins->{{10, Inherited}, {4, 4}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["PictureSmaller6", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["PictureSmaller6", "Printout"],
    CellMargins->{{2, Inherited}, {4, 4}},
    Magnification->0.53],
  
  Cell[StyleData["PictureSmaller6", "EnhancedPrintout"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.53],
  
  Cell[StyleData["PictureSmaller6", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.53]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemPicture"],
    CellMargins->{{41, Inherited}, {4, 2}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["ItemPicture", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemPicture", "Printout"],
    CellMargins->{{55, Inherited}, {8, -4}},
    Magnification->0.65],
  
  Cell[StyleData["ItemPicture", "EnhancedPrintout"],
    CellMargins->{{60, Inherited}, {10, -3}},
    Magnification->0.65],
  
  Cell[StyleData["ItemPicture", "EnhancedPrintoutNonGray"],
    CellMargins->{{60, Inherited}, {10, -3}},
    Magnification->0.65]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemPictureSmaller1"],
    CellMargins->{{41, Inherited}, {4, 2}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["ItemPictureSmaller1", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemPictureSmaller1", "Printout"],
    CellMargins->{{56, Inherited}, {9, -3}},
    Magnification->0.63],
  
  Cell[StyleData["ItemPictureSmaller1", "EnhancedPrintout"],
    CellMargins->{{63, Inherited}, {10, -3}},
    Magnification->0.63],
  
  Cell[StyleData["ItemPictureSmaller1", "EnhancedPrintoutNonGray"],
    CellMargins->{{63, Inherited}, {10, -3}},
    Magnification->0.63]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemPictureSmaller2"],
    CellMargins->{{41, Inherited}, {4, 2}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["ItemPictureSmaller2", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemPictureSmaller2", "Printout"],
    CellMargins->{{58, Inherited}, {8, -4}},
    Magnification->0.61],
  
  Cell[StyleData["ItemPictureSmaller2", "EnhancedPrintout"],
    CellMargins->{{65, Inherited}, {11, -3}},
    Magnification->0.61],
  
  Cell[StyleData["ItemPictureSmaller2", "EnhancedPrintoutNonGray"],
    CellMargins->{{65, Inherited}, {11, -3}},
    Magnification->0.61]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemPictureSmaller3"],
    CellMargins->{{41, Inherited}, {4, 2}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["ItemPictureSmaller3", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemPictureSmaller3", "Printout"],
    CellMargins->{{61, Inherited}, {10, -2}},
    Magnification->0.59],
  
  Cell[StyleData["ItemPictureSmaller3", "EnhancedPrintout"],
    CellMargins->{{67, Inherited}, {11, -3}},
    Magnification->0.59],
  
  Cell[StyleData["ItemPictureSmaller3", "EnhancedPrintoutNonGray"],
    CellMargins->{{67, Inherited}, {11, -3}},
    Magnification->0.59]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemPictureSmaller4"],
    CellMargins->{{41, Inherited}, {4, 2}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["ItemPictureSmaller4", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemPictureSmaller4", "Printout"],
    CellMargins->{{63, Inherited}, {10, -2}},
    Magnification->0.57],
  
  Cell[StyleData["ItemPictureSmaller4", "EnhancedPrintout"],
    CellMargins->{{69, Inherited}, {12, -4}},
    Magnification->0.57],
  
  Cell[StyleData["ItemPictureSmaller4", "EnhancedPrintoutNonGray"],
    CellMargins->{{69, Inherited}, {12, -4}},
    Magnification->0.57]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemPictureSmaller5"],
    CellMargins->{{41, Inherited}, {4, 2}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["ItemPictureSmaller5", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemPictureSmaller5", "Printout"],
    CellMargins->{{65, Inherited}, {11, -2}},
    Magnification->0.55],
  
  Cell[StyleData["ItemPictureSmaller5", "EnhancedPrintout"],
    CellMargins->{{71, Inherited}, {13, -2}},
    Magnification->0.55],
  
  Cell[StyleData["ItemPictureSmaller5", "EnhancedPrintoutNonGray"],
    CellMargins->{{71, Inherited}, {13, -2}},
    Magnification->0.55]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemPictureSmaller6"],
    CellMargins->{{41, Inherited}, {4, 2}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["ItemPictureSmaller6", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemPictureSmaller6", "Printout"],
    CellMargins->{{67, Inherited}, {12, -2}},
    Magnification->0.53],
  
  Cell[StyleData["ItemPictureSmaller6", "EnhancedPrintout"],
    CellMargins->{{74, Inherited}, {13, -3}},
    Magnification->0.53],
  
  Cell[StyleData["ItemPictureSmaller6", "EnhancedPrintoutNonGray"],
    CellMargins->{{74, Inherited}, {13, -3}},
    Magnification->0.53]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PictureBigger1"],
    CellMargins->{{10, Inherited}, {4, 4}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["PictureBigger1", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["PictureBigger1", "Printout"],
    CellMargins->{{2, Inherited}, {4, 4}},
    Magnification->0.68],
  
  Cell[StyleData["PictureBigger1", "EnhancedPrintout"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.68],
  
  Cell[StyleData["PictureBigger1", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.68]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PictureBigger2"],
    CellMargins->{{10, Inherited}, {4, 4}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["PictureBigger2", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["PictureBigger2", "Printout"],
    CellMargins->{{2, Inherited}, {4, 4}},
    Magnification->0.71],
  
  Cell[StyleData["PictureBigger2", "EnhancedPrintout"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.71],
  
  Cell[StyleData["PictureBigger2", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.71]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PictureBigger3"],
    CellMargins->{{10, Inherited}, {4, 4}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["PictureBigger3", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["PictureBigger3", "Printout"],
    CellMargins->{{2, Inherited}, {4, 4}},
    Magnification->0.74],
  
  Cell[StyleData["PictureBigger3", "EnhancedPrintout"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.74],
  
  Cell[StyleData["PictureBigger3", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.74]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PictureBigger4"],
    CellMargins->{{10, Inherited}, {4, 4}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["PictureBigger4", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["PictureBigger4", "Printout"],
    CellMargins->{{2, Inherited}, {4, 4}},
    Magnification->0.77],
  
  Cell[StyleData["PictureBigger4", "EnhancedPrintout"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.77],
  
  Cell[StyleData["PictureBigger4", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.77]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PictureBigger5"],
    CellMargins->{{10, Inherited}, {4, 4}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["PictureBigger5", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["PictureBigger5", "Printout"],
    CellMargins->{{2, Inherited}, {4, 4}},
    Magnification->0.8],
  
  Cell[StyleData["PictureBigger5", "EnhancedPrintout"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.8],
  
  Cell[StyleData["PictureBigger5", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.8]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PictureBigger6"],
    CellMargins->{{10, Inherited}, {4, 4}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["PictureBigger6", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["PictureBigger6", "Printout"],
    CellMargins->{{2, Inherited}, {4, 4}},
    Magnification->0.83],
  
  Cell[StyleData["PictureBigger6", "EnhancedPrintout"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.83],
  
  Cell[StyleData["PictureBigger6", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.83]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemPictureBigger1"],
    CellMargins->{{41, Inherited}, {4, 2}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["ItemPictureBigger1", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemPictureBigger1", "Printout"],
    CellMargins->{{50, Inherited}, {9, -3}},
    Magnification->0.68],
  
  Cell[StyleData["ItemPictureBigger1", "EnhancedPrintout"],
    CellMargins->{{57, Inherited}, {10, -3}},
    Magnification->0.68],
  
  Cell[StyleData["ItemPictureBigger1", "EnhancedPrintoutNonGray"],
    CellMargins->{{57, Inherited}, {10, -3}},
    Magnification->0.68]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemPictureBigger2"],
    CellMargins->{{41, Inherited}, {4, 2}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["ItemPictureBigger2", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemPictureBigger2", "Printout"],
    CellMargins->{{48, Inherited}, {8, -4}},
    Magnification->0.71],
  
  Cell[StyleData["ItemPictureBigger2", "EnhancedPrintout"],
    CellMargins->{{54, Inherited}, {10, -3}},
    Magnification->0.71],
  
  Cell[StyleData["ItemPictureBigger2", "EnhancedPrintoutNonGray"],
    CellMargins->{{54, Inherited}, {10, -3}},
    Magnification->0.71]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemPictureBigger3"],
    CellMargins->{{41, Inherited}, {4, 2}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["ItemPictureBigger3", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemPictureBigger3", "Printout"],
    CellMargins->{{46, Inherited}, {10, -2}},
    Magnification->0.74],
  
  Cell[StyleData["ItemPictureBigger3", "EnhancedPrintout"],
    CellMargins->{{52, Inherited}, {10, -3}},
    Magnification->0.74],
  
  Cell[StyleData["ItemPictureBigger3", "EnhancedPrintoutNonGray"],
    CellMargins->{{52, Inherited}, {10, -3}},
    Magnification->0.74]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemPictureBigger4"],
    CellMargins->{{41, Inherited}, {4, 2}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["ItemPictureBigger4", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemPictureBigger4", "Printout"],
    CellMargins->{{45, Inherited}, {10, -2}},
    Magnification->0.77],
  
  Cell[StyleData["ItemPictureBigger4", "EnhancedPrintout"],
    CellMargins->{{50, Inherited}, {10, -3}},
    Magnification->0.77],
  
  Cell[StyleData["ItemPictureBigger4", "EnhancedPrintoutNonGray"],
    CellMargins->{{50, Inherited}, {10, -3}},
    Magnification->0.77]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemPictureBigger5"],
    CellMargins->{{41, Inherited}, {4, 2}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["ItemPictureBigger5", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemPictureBigger5", "Printout"],
    CellMargins->{{43, Inherited}, {11, -2}},
    Magnification->0.8],
  
  Cell[StyleData["ItemPictureBigger5", "EnhancedPrintout"],
    CellMargins->{{49, Inherited}, {10, -3}},
    Magnification->0.8],
  
  Cell[StyleData["ItemPictureBigger5", "EnhancedPrintoutNonGray"],
    CellMargins->{{49, Inherited}, {10, -3}},
    Magnification->0.8]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemPictureBigger6"],
    CellMargins->{{41, Inherited}, {4, 2}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["ItemPictureBigger6", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemPictureBigger6", "Printout"],
    CellMargins->{{43, Inherited}, {12, -2}},
    Magnification->0.83],
  
  Cell[StyleData["ItemPictureBigger6", "EnhancedPrintout"],
    CellMargins->{{46, Inherited}, {8, -2}},
    Magnification->0.83],
  
  Cell[StyleData["ItemPictureBigger6", "EnhancedPrintoutNonGray"],
    CellMargins->{{46, Inherited}, {8, -2}},
    Magnification->0.83]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ScreenGraphic"],
    CellMargins->{{12, Inherited}, {0, 8}},
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["ScreenGraphic", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ScreenGraphic", "Printout"],
    CellMargins->{{2, Inherited}, {0, 8}}],
  
  Cell[StyleData["ScreenGraphic", "EnhancedPrintout"],
    CellMargins->{{2, Inherited}, {0, 8}},
    CellElementSpacings->{"CellMinHeight"->2,
    "ClosedCellHeight"->2},
    CellOpen->False],
  
  Cell[StyleData["ScreenGraphic", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, Inherited}, {0, 8}},
    CellElementSpacings->{"CellMinHeight"->2,
    "ClosedCellHeight"->2},
    CellOpen->False]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PrintGraphic"],
    CellMargins->{{12, Inherited}, {0, 8}},
    CellElementSpacings->{"CellMinHeight"->2,
    "ClosedCellHeight"->2},
    CellOpen->False,
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["PrintGraphic", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["PrintGraphic", "Printout"],
    CellMargins->{{2, Inherited}, {0, 8}},
    CellElementSpacings->{"CellMinHeight"->2,
    "ClosedCellHeight"->2},
    CellOpen->False],
  
  Cell[StyleData["PrintGraphic", "EnhancedPrintout"],
    CellMargins->{{2, Inherited}, {0, 8}},
    CellElementSpacings->{"CellMinHeight"->12},
    CellOpen->True],
  
  Cell[StyleData["PrintGraphic", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, Inherited}, {0, 8}},
    CellElementSpacings->{"CellMinHeight"->12},
    CellOpen->True]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SmallTextSans"],
    CellMargins->{{10, 4}, {8, 8}},
    TextJustification->1,
    LineSpacing->{1, 2},
    FontFamily->"Helvetica",
    FontSize->9],
  
  Cell[StyleData["SmallTextSans", "Presentation"],
    FontSize->14],
  
  Cell[StyleData["SmallTextSans", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    Hyphenation->True,
    FontSize->7],
  
  Cell[StyleData["SmallTextSans", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    Hyphenation->True,
    LineSpacing->{1, 1},
    ParagraphSpacing->{0, -2},
    FontFamily->"Frutiger 55 Roman",
    FontSize->7]
  }, Closed]]
  }, Closed]]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["AuthorTools", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["BilateralCell"],
    CellMargins->{{27, 4}, {0, 8}},
    StyleMenuListing->None,
    FontSize->12,
    GridBoxOptions->{ColumnWidths->{0.33, 0.6},
    RowAlignments->Top,
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["BilateralCell", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["BilateralCell", "SlideShow"],
    CellMargins->{{36, 24}, {4, 4}},
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["BilateralCell", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    FontSize->10],
  
  Cell[StyleData["BilateralCell", "EnhancedPrintout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["BilateralCell", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["RuledPageBreak"],
    CellFrame->{{0, 0}, {0.25, 0}},
    CellMargins->{{27, 4}, {12, 0}},
    CellFrameMargins->{{0, 0}, {1, 0}},
    FontSize->8],
  
  Cell[StyleData["RuledPageBreak", "Presentation"],
    FontSize->12],
  
  Cell[StyleData["RuledPageBreak", "SlideShow"],
    CellMargins->{{36, 24}, {4, 4}}],
  
  Cell[StyleData["RuledPageBreak", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    PageBreakBelow->True,
    FontSize->1],
  
  Cell[StyleData["RuledPageBreak", "EnhancedPrintout"],
    CellMargins->{{2, 2}, {6, 6}},
    PageBreakBelow->True],
  
  Cell[StyleData["RuledPageBreak", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 2}, {6, 6}},
    PageBreakBelow->True]
  }, Closed]],
  
  Cell[StyleData["PaletteTitle"],
    CellFrame->{{0, 0}, {1, 0}},
    CellMargins->{{4, 0}, {Inherited, 0}},
    StyleMenuListing->None,
    ButtonStyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->14,
    FontWeight->"Bold",
    FontColor->GrayLevel[1],
    Background->RGBColor[0, 0.32549, 0.537255],
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "AddOns", #2]}]&),
    ButtonEvaluator->None,
    ButtonStyle->"PaletteButton",
    ButtonMargins->3}],
  
  Cell[StyleData["PaletteButton"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->12,
    FontWeight->"Bold",
    FontColor->GrayLevel[1],
    ButtonBoxOptions->{ButtonEvaluator->"Local",
    Active->True,
    ButtonMargins->6,
    Background->RGBColor[0.329412, 0.584314, 0.694118]}],
  
  Cell[StyleData["PaletteButton2"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->12,
    FontWeight->"Bold",
    FontColor->GrayLevel[1],
    ButtonBoxOptions->{ButtonEvaluator->"Local",
    Active->True,
    ButtonMargins->4,
    Background->RGBColor[0.537255, 0.72549, 0.843137]}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Outline Styles", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Outline1"],
    CellMargins->{{27, 10}, {7, 7}},
    CellGroupingRules->{"SectionGrouping", 50},
    ParagraphIndent->-38,
    CounterIncrements->"Outline1",
    FontSize->18,
    FontWeight->"Bold",
    CounterBoxOptions->{
    CounterFunction:>Utilities`Notation`Private`CapitalRomanNumeral}],
  
  Cell[StyleData["Outline1", "Presentation"],
    FontSize->27],
  
  Cell[StyleData["Outline1", "Printout"],
    CounterBoxOptions->{
    CounterFunction:>Utilities`Notation`Private`CapitalRomanNumeral}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Outline2"],
    CellMargins->{{57, 10}, {6, 6}},
    CellGroupingRules->{"SectionGrouping", 60},
    ParagraphIndent->-27,
    CounterIncrements->"Outline2",
    FontSize->15,
    FontWeight->"Bold",
    CounterBoxOptions->{CounterFunction:>(Part[ 
        CharacterRange[ "A", "Z"], #]&)}],
  
  Cell[StyleData["Outline2", "Presentation"],
    FontSize->23],
  
  Cell[StyleData["Outline2", "Printout"],
    CounterBoxOptions->{CounterFunction:>(Part[ 
        CharacterRange[ "A", "Z"], #]&)}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Outline3"],
    CellMargins->{{87, 10}, {5, 5}},
    CellGroupingRules->{"SectionGrouping", 70},
    ParagraphIndent->-21,
    CounterIncrements->"Outline3",
    FontSize->12,
    CounterBoxOptions->{CounterFunction:>Identity}],
  
  Cell[StyleData["Outline3", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Outline3", "Printout"],
    CounterBoxOptions->{CounterFunction:>Identity}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Outline4"],
    CellMargins->{{117, 10}, {4, 4}},
    CellGroupingRules->{"SectionGrouping", 80},
    ParagraphIndent->-18,
    CounterIncrements->"Outline4",
    FontSize->10,
    CounterBoxOptions->{CounterFunction:>(Part[ 
        CharacterRange[ "a", "z"], #]&)}],
  
  Cell[StyleData["Outline4", "Presentation"],
    FontSize->15],
  
  Cell[StyleData["Outline4", "Printout"]]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Slide Show Styles", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SlideShowNavigationBar"],
    Editable->False,
    CellFrame->True,
    CellMargins->{{0, 0}, {3, 3}},
    CellElementSpacings->{"CellMinHeight"->0.8125},
    CellGroupingRules->{"SectionGrouping", 30},
    CellFrameMargins->False,
    CellFrameColor->GrayLevel[1],
    CellFrameLabelMargins->False,
    TextAlignment->Center,
    CounterIncrements->"SlideShowNavigationBar",
    StyleMenuListing->None,
    FontSize->10,
    Background->GrayLevel[0.8],
    Magnification->1,
    GridBoxOptions->{GridBaseline->Center,
    RowSpacings->0,
    ColumnSpacings->0,
    ColumnWidths->{3.5, 3.5, 3.5, 3.5, 13, 5, 4},
    RowAlignments->Baseline,
    ColumnAlignments->{
      Center, Center, Center, Center, Center, Center, Right, Center}}],
  
  Cell[StyleData["SlideShowNavigationBar", "SlideShow"],
    Deletable->False,
    ShowCellBracket->False,
    CellMargins->{{-1, -1}, {-1, -1}},
    PageBreakAbove->True,
    CellFrameMargins->{{1, 1}, {0, 0}}],
  
  Cell[StyleData["SlideShowNavigationBar", "Printout"],
    CellMargins->{{18, 4}, {4, 4}},
    LineSpacing->{1, 3},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SlideShowSection"],
    CellFrame->{{0, 0}, {0, 0.5}},
    CellMargins->{{0, 0}, {10, 0}},
    CellGroupingRules->{"SectionGrouping", 40},
    PageBreakBelow->False,
    CellFrameMargins->{{12, 4}, {6, 12}},
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-.35999999999999999, \
-.10000000000000001}, {0, 0}}, BoxBaselineShift -> -.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-.074999999999999997, \
-.085000000000000006}, {0, 0}}, BoxBaselineShift -> .5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm], "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-.17499999999999999, 0}, {0, 0}}]}], 
            TextForm], Inherited},
    CounterIncrements->"Section",
    CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->18,
    FontWeight->"Plain",
    FontColor->GrayLevel[1],
    Background->RGBColor[0.408011, 0.440726, 0.8]],
  
  Cell[StyleData["SlideShowSection", "Presentation"],
    FontSize->27],
  
  Cell[StyleData["SlideShowSection", "SlideShow"],
    ShowCellBracket->False,
    PageBreakAbove->True],
  
  Cell[StyleData["SlideShowSection", "Printout"],
    CellMargins->{{18, 30}, {0, 30}},
    CellFrameMargins->5,
    FontSize->14]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SlideHyperlink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontSize->26,
    FontColor->GrayLevel[0.400015],
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookLocate[ #2]}]&),
    Active->True,
    ButtonMinHeight->0.85,
    ButtonMargins->0.5,
    ButtonNote->None}],
  
  Cell[StyleData["SlideHyperlink", "SlideShow"]],
  
  Cell[StyleData["SlideHyperlink", "Printout"],
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SlideTOCLink"],
    CellMargins->{{24, Inherited}, {Inherited, Inherited}},
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontFamily->"Helvetica",
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookLocate[ #2]}]&),
    Active->True,
    ButtonMargins->1.5,
    ButtonNote->ButtonData}],
  
  Cell[StyleData["SlideTOCLink", "SlideShow"]],
  
  Cell[StyleData["SlideTOCLink", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SlideTOC"],
    CellDingbat->"\[Bullet]",
    CellMargins->{{18, Inherited}, {Inherited, Inherited}},
    StyleMenuListing->None,
    FontFamily->"Helvetica"],
  
  Cell[StyleData["SlideTOC", "SlideShow"],
    FontSize->14],
  
  Cell[StyleData["SlideTOC", "Printout"],
    FontSize->10,
    FontColor->GrayLevel[0]]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Title Page, Contents, and Index", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ContentsTitle"],
    CellMargins->{{21, 4}, {12, 24}},
    FontFamily->"Helvetica",
    FontSize->24,
    FontWeight->"Bold",
    FontColor->RGBColor[0.592157, 0.313726, 0.313726]],
  
  Cell[StyleData["ContentsTitle", "Presentation"],
    FontSize->36],
  
  Cell[StyleData["ContentsTitle", "Printout"],
    CellMargins->{{12, 0}, {102, 89}},
    PageBreakBelow->False,
    FontSize->30.5,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["ContentsTitle", "EnhancedPrintout"],
    CellMargins->{{2, Inherited}, {15, 30}},
    PageBreakBelow->False,
    FontFamily->"Frutiger 65 Bold",
    FontSize->30.5,
    FontWeight->"Plain",
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ContentsSection"],
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{35, 4}, {3, 18}},
    CellGroupingRules->{"SectionGrouping", 70},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->12,
    FontWeight->"Bold"],
  
  Cell[StyleData["ContentsSection", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ContentsSection", "Printout"],
    CellMargins->{{20, 0}, {3, 18}},
    PageBreakBelow->False,
    FontSize->11],
  
  Cell[StyleData["ContentsSection", "EnhancedPrintout"],
    CellMargins->{{20, 0}, {3, 18}},
    PageBreakBelow->False,
    FontFamily->"Frutiger 65 Bold",
    FontSize->11,
    FontWeight->"Plain"],
  
  Cell[StyleData["ContentsSection", "EnhancedPrintoutNonGray"],
    CellMargins->{{20, 0}, {3, 18}},
    PageBreakBelow->False,
    FontFamily->"Frutiger 65 Bold",
    FontSize->11,
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["IndexSection"],
    CellDingbat->"\[FilledSquare]",
    CellMargins->{{20, 4}, {5, 20}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->12,
    FontWeight->"Bold"],
  
  Cell[StyleData["IndexSection", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["IndexSection", "Printout"],
    CellMargins->{{12, 0}, {5, 20}},
    PageBreakBelow->False,
    FontSize->12]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Contents"],
    ShowGroupOpenCloseIcon->False,
    CellMargins->{{50, 4}, {0, 5}},
    CellGroupingRules->{"SectionGrouping", 90},
    StyleMenuListing->None],
  
  Cell[StyleData["Contents", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Contents", "Printout"],
    CellMargins->{{40, 4}, {0, 5}},
    FontSize->11],
  
  Cell[StyleData["Contents", "EnhancedPrintout"],
    CellMargins->{{40, 5}, {0, 5}},
    FontFamily->"Palatino",
    FontSize->11],
  
  Cell[StyleData["Contents", "EnhancedPrintoutNonGray"],
    CellMargins->{{40, 5}, {0, 5}},
    FontFamily->"Palatino",
    FontSize->11]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Index"],
    CellMargins->{{21, 4}, {0, 0}},
    ParagraphIndent->-48,
    StyleMenuListing->None],
  
  Cell[StyleData["Index", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Index", "Printout"],
    CellMargins->{{13, 0}, {0, 0}},
    FontSize->9],
  
  Cell[StyleData["Index", "EnhancedPrintout"],
    CellMargins->{{13, 0}, {0, 0}},
    FontFamily->"Palatino",
    FontSize->9],
  
  Cell[StyleData["Index", "EnhancedPrintoutNonGray"],
    CellMargins->{{13, 0}, {0, 0}},
    FontFamily->"Palatino",
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["IndexSubentry"],
    CellMargins->{{36, 4}, {0, 0}},
    ParagraphIndent->-48],
  
  Cell[StyleData["IndexSubentry", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["IndexSubentry", "Printout"],
    CellMargins->{{24, 0}, {0, 0}},
    FontSize->9],
  
  Cell[StyleData["IndexSubentry", "EnhancedPrintout"],
    CellMargins->{{24, 0}, {0, 0}},
    FontFamily->"Palatino",
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Index2Column"],
    CellMargins->{{21, 4}, {0, 8}},
    ParagraphIndent->-20,
    TabSpacings->1,
    StyleMenuListing->None,
    FontSize->10,
    GridBoxOptions->{ColumnWidths->0.5,
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["Index2Column", "Presentation"],
    FontSize->15],
  
  Cell[StyleData["Index2Column", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    FontSize->8],
  
  Cell[StyleData["Index2Column", "EnhancedPrintout"],
    CellMargins->{{2, 2}, {1, 1}},
    LineSpacing->{1, 0.2},
    FontFamily->"Palatino",
    FontSize->8],
  
  Cell[StyleData["Index2Column", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 2}, {1, 1}},
    LineSpacing->{1, 0.2},
    FontFamily->"Palatino",
    FontSize->8]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Leader"],
    TabFilling->".",
    StyleMenuListing->None,
    FontFamily->"Times",
    FontSize->12,
    FontWeight->"Plain"],
  
  Cell[StyleData["Leader", "Printout"],
    FontSize->10],
  
  Cell[StyleData["Leader", "EnhancedPrintout"],
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["LeaderNoDots"],
    TabFilling->" ",
    StyleMenuListing->None,
    FontFamily->"Times",
    FontSize->12,
    FontWeight->"Plain"],
  
  Cell[StyleData["LeaderNoDots", "Printout"],
    FontSize->10],
  
  Cell[StyleData["LeaderNoDots", "EnhancedPrintout"],
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PageLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookLocate[ #2]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["PageLink", "Printout"],
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["PageLink", "EnhancedPrintout"],
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TOCPage"],
    CellSize->{22, Inherited},
    TextAlignment->Right,
    StyleMenuListing->None,
    FontSize->12,
    FontWeight->"Plain"],
  
  Cell[StyleData["TOCPage", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["TOCPage", "Printout"],
    FontSize->10],
  
  Cell[StyleData["TOCPage", "EnhancedPrintout"],
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TOCTitle"],
    CellMargins->{{20, 0}, {1, 8}},
    CellGroupingRules->{"SectionGrouping", 70},
    TabSpacings->46,
    CounterIncrements->"TOCTitle",
    CounterAssignments->{{"TOCSection", 0}},
    FontFamily->"Helvetica",
    FontSize->12,
    FontWeight->"Bold"],
  
  Cell[StyleData["TOCTitle", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["TOCTitle", "Printout"],
    CellMargins->{{12, 0}, {1, 8}},
    PageBreakBelow->False,
    TabSpacings->47.4,
    FontSize->11],
  
  Cell[StyleData["TOCTitle", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {2, 10}},
    PageBreakBelow->False,
    TabSpacings->49.3,
    FontFamily->"Frutiger 65 Bold",
    FontSize->10,
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TOCSection"],
    CellMargins->{{48, 0}, {1, 1}},
    CellGroupingRules->{"SectionGrouping", 75},
    TabSpacings->42.9,
    CounterIncrements->"TOCSection",
    CounterAssignments->{{"TOCSubsection", 0}},
    FontFamily->"Helvetica",
    FontSize->12],
  
  Cell[StyleData["TOCSection", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["TOCSection", "Printout"],
    CellMargins->{{30, 0}, {1, 1}},
    PageBreakBelow->False,
    FontSize->12],
  
  Cell[StyleData["TOCSection", "EnhancedPrintout"],
    CellMargins->{{26, 0}, {1, 3}},
    PageBreakBelow->False,
    TabSpacings->46.45,
    FontFamily->"Frutiger",
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TOCSubsection"],
    CellMargins->{{76, 0}, {1, 1}},
    CellGroupingRules->{"SectionGrouping", 80},
    TabSpacings->39.8,
    CounterIncrements->"TOCSubsection",
    CounterAssignments->{{"TOCSubsubsection", 0}},
    FontSize->12],
  
  Cell[StyleData["TOCSubsection", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["TOCSubsection", "Printout"],
    CellMargins->{{70, 0}, {1, 1}},
    PageBreakBelow->False,
    FontSize->10],
  
  Cell[StyleData["TOCSubsection", "EnhancedPrintout"],
    CellMargins->{{38, 0}, {1, 1}},
    PageBreakBelow->False,
    TabSpacings->45.15,
    FontFamily->"Palatino",
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TOCSubsubsection"],
    CellMargins->{{104, 0}, {1, 1}},
    CellGroupingRules->{"SectionGrouping", 85},
    TabSpacings->36.7,
    CounterIncrements->"TOCSubsubsection",
    FontSize->12],
  
  Cell[StyleData["TOCSubsubsection", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["TOCSubsubsection", "Printout"],
    CellMargins->{{96, 0}, {1, 1}},
    PageBreakBelow->False,
    FontSize->9],
  
  Cell[StyleData["TOCSubsubsection", "EnhancedPrintout"],
    CellMargins->{{96, 0}, {1, 1}},
    PageBreakBelow->False,
    FontFamily->"Palatino",
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TOCTitleDingbat"],
    CellSize->{34, Inherited},
    TextAlignment->Right],
  
  Cell[StyleData["TOCTitleDingbat", "EnhancedPrintout"],
    FontFamily->"Frutiger",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TOCSectionDingbat"],
    CellSize->{38, Inherited},
    TextAlignment->Right],
  
  Cell[StyleData["TOCSectionDingbat", "EnhancedPrintout"],
    FontFamily->"Frutiger",
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TOCSubsectionDingbat"],
    CellSize->{54, Inherited},
    TextAlignment->Right],
  
  Cell[StyleData["TOCSubsectionDingbat", "EnhancedPrintout"],
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TOCTitleCondensed"],
    CellMargins->{{20, 0}, {1, 8}},
    CellGroupingRules->{"SectionGrouping", 70},
    TabSpacings->50.4,
    CounterIncrements->"TOCTitleCondensed",
    CounterAssignments->{{"TOCSectionCondensed", 0}, {
        "TOCSubsectionCondensed", 0}},
    FontFamily->"Helvetica",
    FontSize->12,
    FontWeight->"Bold"],
  
  Cell[StyleData["TOCTitleCondensed", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["TOCTitleCondensed", "Printout"],
    CellMargins->{{12, 0}, {1, 8}},
    PageBreakBelow->False,
    FontSize->11],
  
  Cell[StyleData["TOCTitleCondensed", "EnhancedPrintout"],
    CellMargins->{{12, 0}, {1, 8}},
    PageBreakBelow->False,
    FontFamily->"Frutiger 65 Bold",
    FontSize->11,
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TOCSectionCondensed"],
    CellMargins->{{48, 0}, {1, 1}},
    CellGroupingRules->{"SectionGrouping", 75},
    TabSpacings->47.4,
    CounterIncrements->"TOCSectionCondensed",
    CounterAssignments->{{"TOCSubsection", 0}},
    FontFamily->"Helvetica",
    FontSize->10,
    FontWeight->"Bold",
    FontColor->GrayLevel[0.2]],
  
  Cell[StyleData["TOCSectionCondensed", "Presentation"],
    FontSize->15],
  
  Cell[StyleData["TOCSectionCondensed", "Printout"],
    CellMargins->{{36, 0}, {1, 1}},
    PageBreakBelow->False,
    FontSize->11],
  
  Cell[StyleData["TOCSectionCondensed", "EnhancedPrintout"],
    CellMargins->{{36, 0}, {1, 1}},
    PageBreakBelow->False,
    FontFamily->"Palatino",
    FontSize->11]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TOCSubsectionCondensed"],
    PageWidth->470,
    CellMargins->{{76, 0}, {1, 1}},
    CellGroupingRules->{"SectionGrouping", 80},
    TextJustification->1,
    FontSize->12],
  
  Cell[StyleData["TOCSubsectionCondensed", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["TOCSubsectionCondensed", "Printout"],
    CellMargins->{{72, 0}, {1, 1}},
    PageBreakBelow->False,
    Hyphenation->True,
    FontSize->10],
  
  Cell[StyleData["TOCSubsectionCondensed", "EnhancedPrintout"],
    CellMargins->{{72, 0}, {1, 1}},
    PageBreakBelow->False,
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TOCSubsubsectionCondensed"],
    CellMargins->{{104, 0}, {1, 1}},
    CellGroupingRules->{"SectionGrouping", 85},
    TabSpacings->39.3,
    CounterIncrements->"TOCSubsubsectionCondensed",
    FontSize->12],
  
  Cell[StyleData["TOCSubsubsectionCondensed", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["TOCSubsubsectionCondensed", "Printout"],
    CellMargins->{{96, 0}, {1, 1}},
    PageBreakBelow->False,
    FontSize->9],
  
  Cell[StyleData["TOCSubsubsectionCondensed", "EnhancedPrintout"],
    CellMargins->{{96, 0}, {1, 1}},
    PageBreakBelow->False,
    FontFamily->"Palatino",
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TitlePageGraphic"],
    CellMargins->{{0, 0}, {100, 20}},
    Evaluatable->False,
    PageBreakBelow->False,
    TextAlignment->Center],
  
  Cell[StyleData["TitlePageGraphic", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["TitlePageGraphic", "Printout"],
    CellMargins->{{0, 0}, {230, 88}}],
  
  Cell[StyleData["TitlePageGraphic", "EnhancedPrintout"],
    CellMargins->{{0, 0}, {230, 88}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TitlePageLogo"],
    CellMargins->{{0, 0}, {0, 0}}],
  
  Cell[StyleData["TitlePageLogo", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["TitlePageLogo", "Printout"]],
  
  Cell[StyleData["TitlePageLogo", "EnhancedPrintout"]]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Horizontal Lines", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Line1"],
    CellFrame->{{0, 0}, {0, 0.5}},
    CellMargins->{{10, 4}, {-16, 9}},
    StyleMenuListing->None,
    FontSize->2],
  
  Cell[StyleData["Line1", "Presentation"],
    FontSize->3],
  
  Cell[StyleData["Line1", "Printout"],
    CellMargins->{{2, 0}, {-16, 9}}]
  }, Closed]],
  
  Cell["\<\

The item above is horizontal 0.5 pt line\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ProgramTop"],
    CellFrame->{{0.5, 0.5}, {0, 0.5}},
    CellMargins->{{27, 4}, {-18, 18}},
    LineSpacing->{1, -4},
    StyleMenuListing->None,
    FontSize->4],
  
  Cell[StyleData["ProgramTop", "Presentation"],
    FontSize->6],
  
  Cell[StyleData["ProgramTop", "Printout"],
    CellMargins->{{2, 0}, {-18, 18}}]
  }, Closed]],
  
  Cell["\<\

The item above is a ProgramTop line
\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ProgramBottom"],
    CellFrame->{{0.5, 0.5}, {0.5, 0}},
    CellMargins->{{27, 4}, {-10, -2}},
    LineSpacing->{1, -4},
    StyleMenuListing->None,
    FontSize->4],
  
  Cell[StyleData["ProgramBottom", "Presentation"],
    FontSize->6],
  
  Cell[StyleData["ProgramBottom", "Printout"],
    CellMargins->{{2, 0}, {-10, -2}}]
  }, Closed]],
  
  Cell["\<\

The item above is a ProgramBottom line
\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SessionLabel"],
    CellFrame->{{0.5, 0}, {0, 0.5}},
    CellMargins->{{27, 4}, {-4, 18}},
    LineSpacing->{1, 0},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->9],
  
  Cell[StyleData["SessionLabel", "Presentation"],
    FontSize->14],
  
  Cell[StyleData["SessionLabel", "Printout"],
    CellMargins->{{2, 0}, {-4, 18}},
    FontSize->7]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Page Headers and Footers", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PageHeader"],
    CellMargins->{{0, 0}, {2, 0}},
    StyleMenuListing->None,
    FontSize->8,
    FontSlant->"Italic"],
  
  Cell[StyleData["PageHeader", "Printout"]],
  
  Cell[StyleData["PageHeader", "EnhancedPrintout"],
    FontFamily->"Frutiger 55 Roman"],
  
  Cell[StyleData["PageHeader", "EnhancedPrintoutNonGray"],
    FontFamily->"Frutiger 55 Roman"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PageNumber"],
    CellMargins->{{0, 0}, {2, 0}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->8,
    FontWeight->"Bold"],
  
  Cell[StyleData["PageNumber", "Printout"]],
  
  Cell[StyleData["PageNumber", "EnhancedPrintout"],
    FontFamily->"Frutiger 65 Bold",
    FontWeight->"Plain"],
  
  Cell[StyleData["PageNumber", "EnhancedPrintoutNonGray"],
    FontFamily->"Frutiger 65 Bold",
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PageFooter"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->6],
  
  Cell[StyleData["PageFooter", "Printout"]],
  
  Cell[StyleData["PageFooter", "EnhancedPrintout"],
    FontFamily->"Frutiger 55 Roman"],
  
  Cell[StyleData["PageFooter", "EnhancedPrintoutNonGray"],
    FontFamily->"Frutiger 55 Roman"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["For compatibility", "Subsection"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Header"],
    CellMargins->{{0, 0}, {2, 0}},
    StyleMenuListing->None,
    FontSize->8,
    FontSlant->"Italic"],
  
  Cell[StyleData["Header", "Printout"]],
  
  Cell[StyleData["Header", "EnhancedPrintout"],
    FontFamily->"Frutiger 55 Roman",
    FontSlant->"Plain"],
  
  Cell[StyleData["Header", "EnhancedPrintoutNonGray"],
    FontFamily->"Frutiger 55 Roman",
    FontSlant->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Footer"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->6],
  
  Cell[StyleData["Footer", "Printout"]],
  
  Cell[StyleData["Footer", "EnhancedPrintout"],
    FontFamily->"Frutiger 55 Roman"],
  
  Cell[StyleData["Footer", "EnhancedPrintoutNonGray"],
    FontFamily->"Frutiger 55 Roman"]
  }, Closed]]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["FormatType Styles", "Section"],
  
  Cell["\<\
The cells below define styles that are mixed in with the styles of most \
cells.  If a cell's FormatType matches the name of one of the styles defined \
below, then that style is applied between the cell's style and its own \
options. This is particularly true of Input and Output.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["CellExpression"],
    PageWidth->Infinity,
    CellMargins->{{6, Inherited}, {Inherited, Inherited}},
    ShowCellLabel->False,
    ShowSpecialCharacters->False,
    AllowInlineCells->False,
    Hyphenation->False,
    AutoItalicWords->{},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontSize->12,
    Background->GrayLevel[1]],
  
  Cell[StyleData["CellExpression", "EnhancedPrintout"],
    FontFamily->"Courier Std",
    FontSize->10],
  
  Cell[StyleData["CellExpression", "EnhancedPrintoutNonGray"],
    FontFamily->"Courier Std",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["InputForm"],
    InputAutoReplacements->{},
    AllowInlineCells->False,
    Hyphenation->False,
    StyleMenuListing->None,
    FontFamily->"Courier"],
  
  Cell[StyleData["InputForm", "EnhancedPrintout"],
    FontFamily->"Courier Std"],
  
  Cell[StyleData["InputForm", "EnhancedPrintoutNonGray"],
    FontFamily->"Courier Std"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["OutputForm"],
    PageWidth->Infinity,
    TextAlignment->Left,
    LineSpacing->{0.6, 1},
    StyleMenuListing->None,
    FontFamily->"Courier"],
  
  Cell[StyleData["OutputForm", "EnhancedPrintout"],
    FontFamily->"Courier Std"],
  
  Cell[StyleData["OutputForm", "EnhancedPrintoutNonGray"],
    FontFamily->"Courier Std"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["StandardForm"],
    InputAutoReplacements->{
      "->"->"\[Rule]", ":>"->"\[RuleDelayed]", "<="->"\[LessEqual]", 
        ">="->"\[GreaterEqual]", "!="->"\[NotEqual]", "=="->"\[Equal]", 
        Inherited},
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    LineSpacing->{1.25, 0},
    StyleMenuListing->None,
    FontFamily->"Courier"],
  
  Cell[StyleData["StandardForm", "EnhancedPrintout"],
    FontFamily->"Courier Std"],
  
  Cell[StyleData["StandardForm", "EnhancedPrintoutNonGray"],
    FontFamily->"Courier Std"]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Automatic Styles", "Section"],
  
  Cell["\<\
The cells below define styles that are used to affect the display of certain \
types of objects in typeset expressions.  For example, \"UnmatchedBracket\" \
style defines how unmatched bracket, curly bracket, and parenthesis \
characters are displayed (typically by coloring them to make them stand out).\
\
\>", "Text"],
  
  Cell[StyleData["UnmatchedBracket"],
    StyleMenuListing->None]
  }, Closed]]
  }, Open  ]],
  
  Cell[CellGroupData[{
  
  Cell["Notation Package Styles", "Section",
    CellTags->"NotationPackage"],
  
  Cell["\<\
The cells below define certain styles needed by the Notation package. These \
styles serve to make visible otherwise invisible tagboxes.\
\>", "Text",
    CellTags->"NotationPackage"],
  
  Cell[StyleData["NotationTemplateStyle"],
    StyleMenuListing->None,
    Background->RGBColor[1, 1, 0.850004],
    TagBoxOptions->{SyntaxForm->"symbol"},
    CellTags->"NotationPackage"],
  
  Cell[StyleData["NotationPatternWrapperStyle"],
    StyleMenuListing->None,
    Background->RGBColor[1, 0.900008, 0.979995],
    TagBoxOptions->{SyntaxForm->"symbol"},
    CellTags->"NotationPackage"],
  
  Cell[StyleData["NotationMadeBoxesWrapperStyle"],
    StyleMenuListing->None,
    Background->RGBColor[0.900008, 0.889998, 1],
    TagBoxOptions->{SyntaxForm->"symbol"},
    CellTags->"NotationPackage"]
  }, Closed]]
  }]
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "Unit tour"->{
    Cell[1776, 53, 125, 6, 40, "Subsection",
      CellTags->"Unit tour"],
    Cell[1904, 61, 90, 1, 17, "Caption",
      CellTags->"Unit tour"],
    Cell[438088, 6363, 107, 3, 35, "Subsubsection",
      Evaluatable->False,
      CellTags->"Unit tour"],
    Cell[438198, 6368, 198, 4, 25, "Text",
      CellTags->"Unit tour"],
    Cell[438399, 6374, 248, 5, 49, "Input",
      CellTags->"Unit tour"],
    Cell[438650, 6381, 70, 1, 41, "MathCaption",
      CellTags->"Unit tour"],
    Cell[438723, 6384, 107, 3, 29, "Input",
      CellTags->"Unit tour"],
    Cell[438833, 6389, 210, 7, 41, "MathCaption",
      CellTags->"Unit tour"],
    Cell[439068, 6400, 172, 4, 49, "Input",
      CellTags->"Unit tour"],
    Cell[439243, 6406, 571, 18, 38, "Output",
      CellTags->"Unit tour"],
    Cell[439829, 6427, 136, 4, 41, "MathCaption",
      CellTags->"Unit tour"],
    Cell[439990, 6435, 126, 3, 41, "Input",
      CellTags->"Unit tour"],
    Cell[440119, 6440, 287, 9, 27, "Output",
      CellTags->"Unit tour"],
    Cell[440421, 6452, 77, 1, 41, "MathCaption",
      CellTags->"Unit tour"],
    Cell[440501, 6455, 102, 3, 29, "Input",
      CellTags->"Unit tour"],
    Cell[440628, 6462, 127, 3, 41, "Input",
      CellTags->"Unit tour"],
    Cell[440758, 6467, 295, 9, 40, "Output",
      CellTags->"Unit tour"],
    Cell[441068, 6479, 103, 3, 29, "Input",
      CellTags->"Unit tour"],
    Cell[441174, 6484, 89, 1, 41, "MathCaption",
      CellTags->"Unit tour"],
    Cell[441288, 6489, 133, 4, 29, "Input",
      CellTags->"Unit tour"],
    Cell[441424, 6495, 2086, 46, 159, "Output",
      CellTags->"Unit tour"],
    Cell[443525, 6544, 173, 6, 41, "MathCaption",
      CellTags->"Unit tour"],
    Cell[443723, 6554, 135, 4, 29, "Input",
      CellTags->"Unit tour"],
    Cell[443861, 6560, 405, 9, 29, "Output",
      CellTags->"Unit tour"],
    Cell[444281, 6572, 109, 2, 41, "MathCaption",
      CellTags->"Unit tour"],
    Cell[444415, 6578, 927, 27, 29, "Input",
      CellTags->"Unit tour"],
    Cell[445345, 6607, 937, 26, 27, "Output",
      CellTags->"Unit tour"],
    Cell[446297, 6636, 88, 1, 41, "MathCaption",
      CellTags->"Unit tour"],
    Cell[446410, 6641, 151, 4, 29, "Input",
      CellTags->"Unit tour"],
    Cell[446564, 6647, 635, 19, 40, "Output",
      CellTags->"Unit tour"],
    Cell[447236, 6671, 122, 4, 29, "Input",
      CellTags->"Unit tour"],
    Cell[447361, 6677, 542, 16, 43, "Output",
      CellTags->"Unit tour"],
    Cell[447940, 6698, 122, 4, 29, "Input",
      CellTags->"Unit tour"],
    Cell[448065, 6704, 498, 16, 27, "Output",
      CellTags->"Unit tour"],
    Cell[448600, 6725, 126, 4, 29, "Input",
      CellTags->"Unit tour"],
    Cell[448729, 6731, 233, 8, 27, "Output",
      CellTags->"Unit tour"],
    Cell[448977, 6742, 408, 15, 58, "MathCaption",
      CellTags->"Unit tour"],
    Cell[449410, 6761, 140, 4, 29, "Input",
      CellTags->"Unit tour"],
    Cell[449553, 6767, 273, 9, 38, "Output",
      CellTags->"Unit tour"],
    Cell[449841, 6779, 477, 22, 59, "MathCaption",
      CellTags->"Unit tour"],
    Cell[450343, 6805, 165, 4, 49, "Input",
      CellTags->"Unit tour"],
    Cell[450511, 6811, 523, 9, 35, "Message",
      CellTags->"Unit tour"],
    Cell[451071, 6825, 121, 3, 29, "Input",
      CellTags->"Unit tour"],
    Cell[451195, 6830, 115, 3, 27, "Output",
      CellTags->"Unit tour"],
    Cell[451347, 6838, 119, 3, 29, "Input",
      CellTags->"Unit tour"],
    Cell[451469, 6843, 582, 18, 27, "Output",
      CellTags->"Unit tour"],
    Cell[452066, 6864, 299, 11, 41, "MathCaption",
      CellTags->"Unit tour"],
    Cell[452390, 6879, 402, 11, 41, "Input",
      CellTags->"Unit tour"],
    Cell[452795, 6892, 445, 12, 40, "Output",
      CellTags->"Unit tour"],
    Cell[453255, 6907, 98, 1, 41, "MathCaption",
      CellTags->"Unit tour"],
    Cell[453378, 6912, 221, 5, 82, "Input",
      CellTags->"Unit tour"],
    Cell[453602, 6919, 410, 11, 40, "Output",
      CellTags->"Unit tour"],
    Cell[454027, 6933, 123, 5, 41, "MathCaption",
      CellTags->"Unit tour"],
    Cell[454175, 6942, 1952, 54, 50, "Input",
      CellTags->"Unit tour"],
    Cell[456130, 6998, 2113, 54, 61, "Output",
      CellTags->"Unit tour"],
    Cell[458280, 7057, 100, 3, 29, "Input",
      CellTags->"Unit tour"],
    Cell[458383, 7062, 340, 10, 60, "Output",
      CellTags->"Unit tour"],
    Cell[458738, 7075, 147, 5, 41, "MathCaption",
      CellTags->"Unit tour"],
    Cell[458910, 7084, 524, 17, 29, "Input",
      CellTags->"Unit tour"],
    Cell[459437, 7103, 292, 9, 27, "Output",
      CellTags->"Unit tour"],
    Cell[459744, 7115, 175, 4, 41, "MathCaption",
      CellTags->"Unit tour"],
    Cell[459944, 7123, 603, 18, 29, "Input",
      CellTags->"Unit tour"],
    Cell[460550, 7143, 635, 18, 27, "Output",
      CellTags->"Unit tour"],
    Cell[461222, 7166, 621, 18, 29, "Input",
      CellTags->"Unit tour"],
    Cell[461846, 7186, 638, 18, 27, "Output",
      CellTags->"Unit tour"],
    Cell[462499, 7207, 97, 1, 41, "MathCaption",
      CellTags->"Unit tour"],
    Cell[462621, 7212, 108, 3, 29, "Input",
      CellTags->"Unit tour"],
    Cell[462732, 7217, 2366, 51, 185, "Output",
      CellTags->"Unit tour"],
    Cell[465113, 7271, 87, 1, 41, "MathCaption",
      CellTags->"Unit tour"],
    Cell[465225, 7276, 233, 6, 62, "Input",
      CellTags->"Unit tour"],
    Cell[465461, 7284, 290, 9, 40, "Output",
      CellTags->"Unit tour"],
    Cell[465788, 7298, 154, 4, 49, "Input",
      CellTags->"Unit tour"],
    Cell[465945, 7304, 274, 9, 38, "Output",
      CellTags->"Unit tour"],
    Cell[466234, 7316, 103, 1, 41, "MathCaption",
      CellTags->"Unit tour"],
    Cell[466362, 7321, 225, 6, 49, "Input",
      CellTags->"Unit tour"],
    Cell[466590, 7329, 1037, 29, 48, "Output",
      CellTags->"Unit tour"],
    Cell[467664, 7363, 163, 4, 49, "Input",
      CellTags->"Unit tour"],
    Cell[467830, 7369, 1002, 27, 40, "Output",
      CellTags->"Unit tour"],
    Cell[468847, 7399, 121, 3, 29, "Input",
      CellTags->"Unit tour"],
    Cell[468971, 7404, 95, 1, 41, "MathCaption",
      CellTags->"Unit tour"],
    Cell[469091, 7409, 432, 9, 122, "Input",
      CellTags->"Unit tour"],
    Cell[469526, 7420, 1177, 32, 46, "Output",
      CellTags->"Unit tour"],
    Cell[470718, 7455, 166, 4, 29, "Input",
      CellTags->"Unit tour"],
    Cell[470887, 7461, 130, 3, 41, "MathCaption",
      CellTags->"Unit tour"],
    Cell[471042, 7468, 172, 4, 49, "Input",
      CellTags->"Unit tour"],
    Cell[471217, 7474, 782, 24, 27, "Output",
      CellTags->"Unit tour"],
    Cell[472036, 7503, 376, 9, 69, "Input",
      CellTags->"Unit tour"],
    Cell[472415, 7514, 750, 23, 27, "Output",
      CellTags->"Unit tour"],
    Cell[473180, 7540, 95, 1, 41, "MathCaption",
      CellTags->"Unit tour"],
    Cell[473278, 7543, 102, 3, 29, "Input",
      CellTags->"Unit tour"],
    Cell[473383, 7548, 53, 1, 41, "MathCaption",
      CellTags->"Unit tour"],
    Cell[473439, 7551, 99, 3, 29, "Input",
      CellTags->"Unit tour"],
    Cell[473541, 7556, 72, 1, 41, "MathCaption",
      CellTags->"Unit tour"],
    Cell[473616, 7559, 154, 3, 25, "Text",
      CellTags->"Unit tour"]},
  "Installation notes"->{
    Cell[2019, 66, 125, 3, 35, "Subsubsection",
      Evaluatable->False,
      CellTags->"Installation notes"],
    Cell[2147, 71, 235, 6, 42, "Text",
      Evaluatable->False,
      CellTags->"Installation notes"],
    Cell[2385, 79, 311, 13, 25, "Text",
      Evaluatable->False,
      CellTags->"Installation notes"],
    Cell[2721, 96, 215, 4, 69, "Input",
      CellTags->"Installation notes"],
    Cell[3118, 109, 433, 16, 42, "Text",
      Evaluatable->False,
      CellTags->"Installation notes"],
    Cell[3576, 129, 276, 5, 89, "Input",
      CellTags->"Installation notes"],
    Cell[3855, 136, 226, 5, 46, "Output",
      CellTags->"Installation notes"],
    Cell[4096, 144, 167, 5, 25, "Text",
      CellTags->"Installation notes"],
    Cell[4266, 151, 160208, 2289, 247, 134171, 1963, "GraphicsData", 
    "PostScript", "Text",
      CellTags->"Installation notes"],
    Cell[164477, 2442, 199, 7, 25, "Text",
      Evaluatable->False,
      CellTags->"Installation notes"],
    Cell[164679, 2451, 273046, 3893, 235, 219632, 3229, "GraphicsData", 
    "PostScript", "Text",
      CellTags->"Installation notes"],
    Cell[437728, 6346, 245, 7, 42, "Text",
      CellTags->"Installation notes"]},
  "Introducing units"->{
    Cell[473807, 7567, 75, 1, 35, "Subsubsection",
      CellTags->"Introducing units"],
    Cell[473885, 7570, 123, 3, 25, "Text",
      CellTags->"Introducing units"],
    Cell[474011, 7575, 78, 1, 41, "MathCaption",
      CellTags->"Introducing units"],
    Cell[474092, 7578, 116, 3, 29, "Input",
      CellTags->"Introducing units"],
    Cell[474211, 7583, 130, 5, 41, "MathCaption",
      CellTags->"Introducing units"],
    Cell[474366, 7592, 100, 3, 29, "Input",
      CellTags->"Introducing units"],
    Cell[474961, 7607, 92, 1, 41, "MathCaption",
      CellTags->"Introducing units"],
    Cell[475078, 7612, 398, 11, 29, "Input",
      CellTags->"Introducing units"],
    Cell[475479, 7625, 811, 25, 70, "Output",
      CellTags->"Introducing units"],
    Cell[476327, 7655, 105, 3, 29, "Input",
      CellTags->"Introducing units"],
    Cell[476435, 7660, 135, 2, 70, "Output",
      CellTags->"Introducing units"],
    Cell[476585, 7665, 314, 15, 41, "MathCaption",
      CellTags->"Introducing units"],
    Cell[476902, 7682, 147, 4, 31, "Input",
      CellTags->"Introducing units"],
    Cell[477052, 7688, 282, 8, 41, "MathCaption",
      CellTags->"Introducing units"],
    Cell[477337, 7698, 623, 18, 40, "Input",
      CellTags->"Introducing units"],
    Cell[477963, 7718, 259, 9, 41, "MathCaption",
      CellTags->"Introducing units"],
    Cell[478225, 7729, 1039, 29, 40, "Input",
      CellTags->"Introducing units"],
    Cell[479267, 7760, 182, 6, 41, "MathCaption",
      CellTags->"Introducing units"],
    Cell[479474, 7770, 196, 4, 60, "Input",
      CellTags->"Introducing units"],
    Cell[479673, 7776, 811, 25, 70, "Output",
      CellTags->"Introducing units"],
    Cell[480521, 7806, 105, 3, 29, "Input",
      CellTags->"Introducing units"],
    Cell[480629, 7811, 152, 3, 70, "Output",
      CellTags->"Introducing units"],
    Cell[480796, 7817, 144, 4, 41, "MathCaption",
      CellTags->"Introducing units"],
    Cell[480965, 7825, 122, 3, 41, "Input",
      CellTags->"Introducing units"],
    Cell[481090, 7830, 326, 10, 70, "Output",
      CellTags->"Introducing units"],
    Cell[481453, 7845, 131, 3, 41, "Input",
      CellTags->"Introducing units"],
    Cell[481587, 7850, 330, 10, 70, "Output",
      CellTags->"Introducing units"]},
  "Info3312025924-1924540"->{
    Cell[474469, 7597, 477, 7, 70, "Print",
      CellTags->"Info3312025924-1924540"]},
  "Information utility"->{
    Cell[481966, 7866, 79, 1, 35, "Subsubsection",
      CellTags->"Information utility"],
    Cell[482048, 7869, 159, 6, 25, "Text",
      CellTags->"Information utility"],
    Cell[482210, 7877, 2510, 71, 196, "DefinitionBox",
      CellTags->"Information utility"],
    Cell[484723, 7950, 78, 1, 17, "Caption",
      CellTags->"Information utility"],
    Cell[484804, 7953, 183, 6, 41, "MathCaption",
      CellTags->"Information utility"],
    Cell[485012, 7963, 145, 4, 29, "Input",
      CellTags->"Information utility"],
    Cell[485160, 7969, 415, 9, 70, "Output",
      CellTags->"Information utility"],
    Cell[485590, 7981, 339, 12, 41, "MathCaption",
      CellTags->"Information utility"],
    Cell[485954, 7997, 147, 4, 29, "Input",
      CellTags->"Information utility"],
    Cell[486104, 8003, 1964, 43, 70, "Output",
      CellTags->"Information utility"],
    Cell[488083, 8049, 429, 15, 41, "MathCaption",
      CellTags->"Information utility"],
    Cell[488537, 8068, 163, 4, 49, "Input",
      CellTags->"Information utility"],
    Cell[488703, 8074, 2017, 44, 70, "Output",
      CellTags->"Information utility"],
    Cell[490735, 8121, 112, 3, 29, "Input",
      CellTags->"Information utility"],
    Cell[490850, 8126, 98, 1, 41, "MathCaption",
      CellTags->"Information utility"],
    Cell[490973, 8131, 106, 3, 29, "Input",
      CellTags->"Information utility"],
    Cell[491082, 8136, 167, 4, 70, "Output",
      CellTags->"Information utility"]},
  "Default unit system"->{
    Cell[491298, 8146, 79, 1, 35, "Subsubsection",
      CellTags->"Default unit system"],
    Cell[491380, 8149, 133, 3, 25, "Text",
      CellTags->"Default unit system"],
    Cell[491516, 8154, 576, 16, 60, "DefinitionBox",
      CellTags->"Default unit system"],
    Cell[492095, 8172, 66, 1, 17, "Caption",
      CellTags->"Default unit system"],
    Cell[492164, 8175, 75, 1, 41, "MathCaption",
      CellTags->"Default unit system"],
    Cell[492264, 8180, 98, 3, 29, "Input",
      CellTags->"Default unit system"],
    Cell[492365, 8185, 101, 3, 27, "Output",
      CellTags->"Default unit system"],
    Cell[492481, 8191, 109, 1, 41, "MathCaption",
      CellTags->"Default unit system"],
    Cell[492593, 8194, 113, 3, 29, "Input",
      CellTags->"Default unit system"],
    Cell[492731, 8201, 124, 3, 41, "Input",
      CellTags->"Default unit system"],
    Cell[492858, 8206, 328, 10, 48, "Output",
      CellTags->"Default unit system"],
    Cell[493223, 8221, 133, 3, 41, "Input",
      CellTags->"Default unit system"],
    Cell[493359, 8226, 336, 10, 48, "Output",
      CellTags->"Default unit system"],
    Cell[493710, 8239, 78, 1, 41, "MathCaption",
      CellTags->"Default unit system"],
    Cell[493791, 8242, 113, 3, 29, "Input",
      CellTags->"Default unit system"]},
  "Dimensions of units"->{
    Cell[493941, 8250, 79, 1, 35, "Subsubsection",
      CellTags->"Dimensions of units"],
    Cell[494023, 8253, 210, 9, 25, "Text",
      CellTags->"Dimensions of units"],
    Cell[494236, 8264, 907, 25, 60, "DefinitionBox",
      CellTags->"Dimensions of units"],
    Cell[495146, 8291, 73, 1, 17, "Caption",
      CellTags->"Dimensions of units"],
    Cell[495222, 8294, 95, 1, 41, "MathCaption",
      CellTags->"Dimensions of units"],
    Cell[495342, 8299, 200, 5, 29, "Input",
      CellTags->"Dimensions of units"],
    Cell[495545, 8306, 1152, 33, 48, "Output",
      CellTags->"Dimensions of units"],
    Cell[496712, 8342, 77, 1, 41, "MathCaption",
      CellTags->"Dimensions of units"],
    Cell[496814, 8347, 138, 4, 29, "Input",
      CellTags->"Dimensions of units"],
    Cell[496955, 8353, 223, 6, 48, "Output",
      CellTags->"Dimensions of units"],
    Cell[497193, 8362, 88, 1, 41, "MathCaption",
      CellTags->"Dimensions of units"],
    Cell[497306, 8367, 132, 4, 29, "Input",
      CellTags->"Dimensions of units"],
    Cell[497441, 8373, 1015, 30, 45, "Output",
      CellTags->"Dimensions of units"],
    Cell[498471, 8406, 149, 4, 41, "MathCaption",
      CellTags->"Dimensions of units"],
    Cell[498645, 8414, 132, 4, 29, "Input",
      CellTags->"Dimensions of units"],
    Cell[498780, 8420, 972, 30, 45, "Output",
      CellTags->"Dimensions of units"],
    Cell[499767, 8453, 106, 3, 29, "Input",
      CellTags->"Dimensions of units"],
    Cell[499876, 8458, 170, 6, 41, "MathCaption",
      CellTags->"Dimensions of units"],
    Cell[500071, 8468, 201, 4, 46, "Input",
      CellTags->"Dimensions of units"],
    Cell[500275, 8474, 498, 16, 27, "Output",
      CellTags->"Dimensions of units"],
    Cell[500810, 8495, 175, 4, 49, "Input",
      CellTags->"Dimensions of units"],
    Cell[500988, 8501, 1064, 34, 27, "Output",
      CellTags->"Dimensions of units"],
    Cell[502089, 8540, 231, 5, 69, "Input",
      CellTags->"Dimensions of units"],
    Cell[502323, 8547, 1074, 34, 38, "Output",
      CellTags->"Dimensions of units"],
    Cell[503434, 8586, 238, 5, 69, "Input",
      CellTags->"Dimensions of units"],
    Cell[503675, 8593, 1405, 40, 27, "Output",
      CellTags->"Dimensions of units"],
    Cell[505095, 8636, 113, 3, 29, "Input",
      CellTags->"Dimensions of units"]},
  "Simplification of units"->{
    Cell[505245, 8644, 87, 1, 35, "Subsubsection",
      CellTags->"Simplification of units"],
    Cell[505335, 8647, 178, 5, 25, "Text",
      CellTags->"Simplification of units"],
    Cell[505516, 8654, 2969, 86, 60, "DefinitionBox",
      CellTags->"Simplification of units"],
    Cell[508488, 8742, 70, 1, 17, "Caption",
      CellTags->"Simplification of units"],
    Cell[508561, 8745, 192, 8, 41, "MathCaption",
      CellTags->"Simplification of units"],
    Cell[508778, 8757, 117, 3, 29, "Input",
      CellTags->"Simplification of units"],
    Cell[508898, 8762, 288, 6, 46, "Output",
      CellTags->"Simplification of units"],
    Cell[509201, 8771, 195, 8, 41, "MathCaption",
      CellTags->"Simplification of units"],
    Cell[509399, 8781, 129, 3, 29, "Input",
      CellTags->"Simplification of units"],
    Cell[509553, 8788, 1788, 55, 134, "Input",
      CellTags->"Simplification of units"],
    Cell[511344, 8845, 328, 10, 45, "Output",
      CellTags->"Simplification of units"],
    Cell[511687, 8858, 135, 6, 41, "MathCaption",
      CellTags->"Simplification of units"],
    Cell[511847, 8868, 655, 19, 29, "Input",
      CellTags->"Simplification of units"],
    Cell[512505, 8889, 402, 11, 40, "Output",
      CellTags->"Simplification of units"],
    Cell[512922, 8903, 135, 5, 41, "MathCaption",
      CellTags->"Simplification of units"],
    Cell[513082, 8912, 137, 3, 29, "Input",
      CellTags->"Simplification of units"],
    Cell[513222, 8917, 350, 10, 60, "Output",
      CellTags->"Simplification of units"],
    Cell[513587, 8930, 129, 3, 29, "Input",
      CellTags->"Simplification of units"],
    Cell[513719, 8935, 400, 18, 42, "Text",
      CellTags->"Simplification of units"]},
  "Convertions between unit systems"->{
    Cell[514156, 8958, 105, 1, 35, "Subsubsection",
      CellTags->"Convertions between unit systems"],
    Cell[514264, 8961, 178, 4, 25, "Text",
      CellTags->"Convertions between unit systems"],
    Cell[514445, 8967, 1262, 36, 78, "DefinitionBox",
      CellTags->"Convertions between unit systems"],
    Cell[515710, 9005, 95, 1, 17, "Caption",
      CellTags->"Convertions between unit systems"],
    Cell[515808, 9008, 107, 1, 41, "MathCaption",
      CellTags->"Convertions between unit systems"],
    Cell[515940, 9013, 213, 5, 29, "Input",
      CellTags->"Convertions between unit systems"],
    Cell[516156, 9020, 1165, 33, 48, "Output",
      CellTags->"Convertions between unit systems"],
    Cell[517336, 9056, 159, 6, 41, "MathCaption",
      CellTags->"Convertions between unit systems"],
    Cell[517520, 9066, 139, 3, 29, "Input",
      CellTags->"Convertions between unit systems"],
    Cell[517662, 9071, 1916, 58, 118, "Output",
      CellTags->"Convertions between unit systems"],
    Cell[519593, 9132, 159, 6, 41, "MathCaption",
      CellTags->"Convertions between unit systems"],
    Cell[519777, 9142, 140, 3, 29, "Input",
      CellTags->"Convertions between unit systems"],
    Cell[519920, 9147, 2031, 59, 112, "Output",
      CellTags->"Convertions between unit systems"],
    Cell[521966, 9209, 120, 3, 29, "Input",
      CellTags->"Convertions between unit systems"]},
  "Convertions between units"->{
    Cell[522123, 9217, 91, 1, 35, "Subsubsection",
      CellTags->"Convertions between units"],
    Cell[522217, 9220, 195, 6, 25, "Text",
      CellTags->"Convertions between units"],
    Cell[522415, 9228, 1812, 49, 60, "DefinitionBox",
      CellTags->"Convertions between units"],
    Cell[524230, 9279, 84, 1, 17, "Caption",
      CellTags->"Convertions between units"],
    Cell[524317, 9282, 163, 5, 41, "MathCaption",
      CellTags->"Convertions between units"],
    Cell[524505, 9291, 541, 17, 29, "Input",
      CellTags->"Convertions between units"],
    Cell[525049, 9310, 309, 9, 27, "Output",
      CellTags->"Convertions between units"],
    Cell[525373, 9322, 144, 3, 41, "MathCaption",
      CellTags->"Convertions between units"],
    Cell[525542, 9329, 162, 4, 30, "Input",
      CellTags->"Convertions between units"],
    Cell[525707, 9335, 296, 9, 27, "Output",
      CellTags->"Convertions between units"],
    Cell[526040, 9349, 154, 3, 30, "Input",
      CellTags->"Convertions between units"],
    Cell[526197, 9354, 602, 18, 43, "Output",
      CellTags->"Convertions between units"],
    Cell[526814, 9375, 162, 5, 41, "MathCaption",
      CellTags->"Convertions between units"],
    Cell[527001, 9384, 312, 9, 29, "Input",
      CellTags->"Convertions between units"],
    Cell[527316, 9395, 105, 3, 27, "Output",
      CellTags->"Convertions between units"],
    Cell[527436, 9401, 166, 4, 41, "MathCaption",
      CellTags->"Convertions between units"],
    Cell[527627, 9409, 664, 20, 49, "Input",
      CellTags->"Convertions between units"],
    Cell[528294, 9431, 615, 18, 27, "Output",
      CellTags->"Convertions between units"],
    Cell[528924, 9452, 176, 6, 41, "MathCaption",
      CellTags->"Convertions between units"],
    Cell[529125, 9462, 121, 3, 29, "Input",
      CellTags->"Convertions between units"],
    Cell[529249, 9467, 307, 9, 27, "Output",
      CellTags->"Convertions between units"],
    Cell[529571, 9479, 152, 4, 41, "MathCaption",
      CellTags->"Convertions between units"],
    Cell[529748, 9487, 144, 3, 29, "Input",
      CellTags->"Convertions between units"],
    Cell[529895, 9492, 546, 9, 20, "Message",
      CellTags->"Convertions between units"],
    Cell[530444, 9503, 340, 10, 27, "Output",
      CellTags->"Convertions between units"],
    Cell[530799, 9516, 116, 3, 29, "Input",
      CellTags->"Convertions between units"]},
  "Temperature convertions"->{
    Cell[530952, 9524, 87, 1, 35, "Subsubsection",
      CellTags->"Temperature convertions"],
    Cell[531042, 9527, 843, 26, 59, "Text",
      CellTags->"Temperature convertions"],
    Cell[531888, 9555, 133, 3, 41, "MathCaption",
      CellTags->"Temperature convertions"],
    Cell[532046, 9562, 1112, 32, 29, "Input",
      CellTags->"Temperature convertions"],
    Cell[533161, 9596, 1175, 32, 27, "Output",
      CellTags->"Temperature convertions"],
    Cell[534351, 9631, 182, 4, 41, "MathCaption",
      CellTags->"Temperature convertions"],
    Cell[534558, 9639, 1148, 32, 29, "Input",
      CellTags->"Temperature convertions"],
    Cell[535709, 9673, 1178, 32, 27, "Output",
      CellTags->"Temperature convertions"],
    Cell[536902, 9708, 95, 1, 41, "MathCaption",
      CellTags->"Temperature convertions"],
    Cell[537022, 9713, 1158, 32, 29, "Input",
      CellTags->"Temperature convertions"],
    Cell[538183, 9747, 1193, 32, 27, "Output",
      CellTags->"Temperature convertions"],
    Cell[539391, 9782, 91, 1, 41, "MathCaption",
      CellTags->"Temperature convertions"],
    Cell[539485, 9785, 118, 3, 29, "Input",
      CellTags->"Temperature convertions"],
    Cell[539628, 9792, 1112, 32, 29, "Input",
      CellTags->"Temperature convertions"],
    Cell[540743, 9826, 1149, 32, 27, "Output",
      CellTags->"Temperature convertions"],
    Cell[541929, 9863, 1148, 32, 29, "Input",
      CellTags->"Temperature convertions"],
    Cell[543080, 9897, 1167, 32, 27, "Output",
      CellTags->"Temperature convertions"],
    Cell[544284, 9934, 1158, 32, 29, "Input",
      CellTags->"Temperature convertions"],
    Cell[545445, 9968, 1169, 32, 27, "Output",
      CellTags->"Temperature convertions"],
    Cell[546629, 10003, 118, 3, 29, "Input",
      CellTags->"Temperature convertions"],
    Cell[546750, 10008, 129, 5, 41, "MathCaption",
      CellTags->"Temperature convertions"],
    Cell[546904, 10017, 1254, 34, 29, "Input",
      CellTags->"Temperature convertions"],
    Cell[548161, 10053, 1149, 32, 27, "Output",
      CellTags->"Temperature convertions"],
    Cell[549347, 10090, 1290, 34, 29, "Input",
      CellTags->"Temperature convertions"],
    Cell[550640, 10126, 1153, 32, 27, "Output",
      CellTags->"Temperature convertions"],
    Cell[551830, 10163, 1300, 34, 29, "Input",
      CellTags->"Temperature convertions"],
    Cell[553133, 10199, 1157, 32, 27, "Output",
      CellTags->"Temperature convertions"]},
  "Dimension incompatibility"->{
    Cell[554339, 10237, 91, 1, 35, "Subsubsection",
      CellTags->"Dimension incompatibility"],
    Cell[554433, 10240, 152, 4, 25, "Text",
      CellTags->"Dimension incompatibility"],
    Cell[554588, 10246, 99, 1, 41, "MathCaption",
      CellTags->"Dimension incompatibility"],
    Cell[554712, 10251, 150, 3, 41, "Input",
      CellTags->"Dimension incompatibility"],
    Cell[554865, 10256, 606, 18, 46, "Output",
      CellTags->"Dimension incompatibility"],
    Cell[555486, 10277, 245, 7, 58, "MathCaption",
      CellTags->"Dimension incompatibility"],
    Cell[555756, 10288, 116, 3, 29, "Input",
      CellTags->"Dimension incompatibility"],
    Cell[555875, 10293, 596, 18, 46, "Output",
      CellTags->"Dimension incompatibility"],
    Cell[556486, 10314, 85, 1, 41, "MathCaption",
      CellTags->"Dimension incompatibility"],
    Cell[556596, 10319, 132, 3, 29, "Input",
      CellTags->"Dimension incompatibility"],
    Cell[556731, 10324, 551, 9, 41, "Message",
      CellTags->"Dimension incompatibility"],
    Cell[557285, 10335, 596, 18, 46, "Output",
      CellTags->"Dimension incompatibility"]},
  "Constants"->{
    Cell[557930, 10359, 59, 1, 35, "Subsubsection",
      CellTags->"Constants"],
    Cell[557992, 10362, 522, 15, 59, "Text",
      CellTags->"Constants"],
    Cell[558517, 10379, 758, 16, 302, "DefinitionBox",
      CellTags->"Constants"],
    Cell[559278, 10397, 76, 1, 17, "Caption",
      CellTags->"Constants"],
    Cell[559357, 10400, 500, 12, 154, "DefinitionBox",
      CellTags->"Constants"],
    Cell[559860, 10414, 83, 1, 17, "Caption",
      CellTags->"Constants"],
    Cell[559946, 10417, 667, 15, 216, "DefinitionBox",
      CellTags->"Constants"],
    Cell[560616, 10434, 83, 1, 17, "Caption",
      CellTags->"Constants"],
    Cell[560702, 10437, 308, 14, 24, "SmallText",
      CellTags->"Constants"],
    Cell[561013, 10453, 363, 9, 114, "DefinitionBox",
      CellTags->"Constants"],
    Cell[561379, 10464, 75, 1, 17, "Caption",
      CellTags->"Constants"],
    Cell[561457, 10467, 337, 9, 90, "DefinitionBox",
      CellTags->"Constants"],
    Cell[561797, 10478, 95, 1, 17, "Caption",
      CellTags->"Constants"],
    Cell[561895, 10481, 513, 12, 132, "DefinitionBox",
      CellTags->"Constants"],
    Cell[562411, 10495, 159, 6, 17, "Caption",
      CellTags->"Constants"],
    Cell[562573, 10503, 414, 10, 116, "DefinitionBox",
      CellTags->"Constants"],
    Cell[562990, 10515, 171, 8, 17, "Caption",
      CellTags->"Constants"],
    Cell[563164, 10525, 270, 7, 66, "DefinitionBox",
      CellTags->"Constants"],
    Cell[563437, 10534, 171, 8, 17, "Caption",
      CellTags->"Constants"],
    Cell[563611, 10544, 405, 10, 116, "DefinitionBox",
      CellTags->"Constants"],
    Cell[564019, 10556, 171, 8, 17, "Caption",
      CellTags->"Constants"],
    Cell[564193, 10566, 355, 9, 92, "DefinitionBox",
      CellTags->"Constants"],
    Cell[564551, 10577, 306, 15, 17, "Caption",
      CellTags->"Constants"],
    Cell[564860, 10594, 256, 7, 64, "DefinitionBox",
      CellTags->"Constants"],
    Cell[565119, 10603, 87, 1, 17, "Caption",
      CellTags->"Constants"],
    Cell[565209, 10606, 138, 5, 41, "MathCaption",
      CellTags->"Constants"],
    Cell[565372, 10615, 109, 3, 29, "Input",
      CellTags->"Constants"],
    Cell[565484, 10620, 2367, 51, 185, "Output",
      CellTags->"Constants"],
    Cell[567888, 10676, 118, 3, 29, "Input",
      CellTags->"Constants"],
    Cell[568009, 10681, 2307, 49, 165, "Output",
      CellTags->"Constants"],
    Cell[570331, 10733, 84, 1, 41, "MathCaption",
      CellTags->"Constants"],
    Cell[570440, 10738, 1051, 28, 39, "Input",
      CellTags->"Constants"],
    Cell[571494, 10768, 328, 10, 27, "Output",
      CellTags->"Constants"]},
  "UnitK and UnitS utilities"->{
    Cell[571871, 10784, 173, 8, 35, "Subsubsection",
      CellTags->"UnitK and UnitS utilities"],
    Cell[572047, 10794, 225, 6, 42, "Text",
      CellTags->"UnitK and UnitS utilities"],
    Cell[572275, 10802, 857, 22, 62, "DefinitionBox",
      CellTags->"UnitK and UnitS utilities"],
    Cell[573135, 10826, 73, 1, 17, "Caption",
      CellTags->"UnitK and UnitS utilities"],
    Cell[573211, 10829, 95, 1, 41, "MathCaption",
      CellTags->"UnitK and UnitS utilities"],
    Cell[573331, 10834, 139, 3, 29, "Input",
      CellTags->"UnitK and UnitS utilities"],
    Cell[573473, 10839, 674, 19, 40, "Output",
      CellTags->"UnitK and UnitS utilities"],
    Cell[574184, 10863, 116, 3, 29, "Input",
      CellTags->"UnitK and UnitS utilities"],
    Cell[574303, 10868, 310, 9, 27, "Output",
      CellTags->"UnitK and UnitS utilities"],
    Cell[574628, 10880, 241, 9, 25, "Text",
      CellTags->"UnitK and UnitS utilities"],
    Cell[574872, 10891, 1492, 39, 98, "DefinitionBox",
      CellTags->"UnitK and UnitS utilities"],
    Cell[576367, 10932, 73, 1, 17, "Caption",
      CellTags->"UnitK and UnitS utilities"],
    Cell[576443, 10935, 196, 6, 41, "MathCaption",
      CellTags->"UnitK and UnitS utilities"],
    Cell[576664, 10945, 140, 3, 42, "Input",
      CellTags->"UnitK and UnitS utilities"],
    Cell[576807, 10950, 289, 9, 38, "Output",
      CellTags->"UnitK and UnitS utilities"]},
  "Setting up your out unit"->{
    Cell[577145, 10965, 89, 1, 35, "Subsubsection",
      CellTags->"Setting up your out unit"],
    Cell[577237, 10968, 277, 5, 42, "Text",
      CellTags->"Setting up your out unit"],
    Cell[577517, 10975, 111, 2, 25, "Text",
      CellTags->"Setting up your out unit"],
    Cell[577631, 10979, 156, 5, 41, "MathCaption",
      CellTags->"Setting up your out unit"],
    Cell[577812, 10988, 110, 3, 29, "Input",
      CellTags->"Setting up your out unit"],
    Cell[577925, 10993, 286, 9, 40, "Output",
      CellTags->"Setting up your out unit"],
    Cell[578226, 11005, 319, 11, 45, "MathCaption",
      CellTags->"Setting up your out unit"],
    Cell[578548, 11018, 170, 4, 30, "Input",
      CellTags->"Setting up your out unit"],
    Cell[578743, 11026, 110, 3, 29, "Input",
      CellTags->"Setting up your out unit"],
    Cell[578856, 11031, 284, 9, 48, "Output",
      CellTags->"Setting up your out unit"],
    Cell[579155, 11043, 76, 1, 41, "MathCaption",
      CellTags->"Setting up your out unit"],
    Cell[579256, 11048, 197, 4, 50, "Input",
      CellTags->"Setting up your out unit"],
    Cell[579456, 11054, 148, 3, 40, "Output",
      CellTags->"Setting up your out unit"],
    Cell[579641, 11062, 110, 3, 29, "Input",
      CellTags->"Setting up your out unit"],
    Cell[579754, 11067, 284, 9, 48, "Output",
      CellTags->"Setting up your out unit"],
    Cell[580053, 11079, 95, 1, 41, "MathCaption",
      CellTags->"Setting up your out unit"],
    Cell[580173, 11084, 144, 3, 30, "Input",
      CellTags->"Setting up your out unit"],
    Cell[580320, 11089, 150, 3, 40, "Output",
      CellTags->"Setting up your out unit"],
    Cell[580485, 11095, 112, 2, 25, "Text",
      CellTags->"Setting up your out unit"],
    Cell[580600, 11099, 151, 5, 41, "MathCaption",
      CellTags->"Setting up your out unit"],
    Cell[580776, 11108, 126, 3, 29, "Input",
      CellTags->"Setting up your out unit"],
    Cell[580905, 11113, 292, 9, 27, "Output",
      CellTags->"Setting up your out unit"],
    Cell[581212, 11125, 138, 6, 41, "MathCaption",
      CellTags->"Setting up your out unit"],
    Cell[581375, 11135, 185, 4, 30, "Input",
      CellTags->"Setting up your out unit"],
    Cell[581563, 11141, 155, 3, 40, "Output",
      CellTags->"Setting up your out unit"],
    Cell[582125, 11165, 111, 2, 25, "Text",
      CellTags->"Setting up your out unit"],
    Cell[582239, 11169, 100, 1, 41, "MathCaption",
      CellTags->"Setting up your out unit"],
    Cell[582364, 11174, 137, 3, 43, "Input",
      CellTags->"Setting up your out unit"],
    Cell[582504, 11179, 316, 9, 45, "Output",
      CellTags->"Setting up your out unit"],
    Cell[582857, 11193, 119, 3, 29, "Input",
      CellTags->"Setting up your out unit"],
    Cell[582979, 11198, 636, 20, 45, "Output",
      CellTags->"Setting up your out unit"],
    Cell[583630, 11221, 176, 4, 41, "MathCaption",
      CellTags->"Setting up your out unit"],
    Cell[583809, 11227, 189, 4, 46, "Input",
      CellTags->"Setting up your out unit"],
    Cell[584349, 11250, 258, 11, 41, "MathCaption",
      CellTags->"Setting up your out unit"],
    Cell[584632, 11265, 122, 3, 29, "Input",
      CellTags->"Setting up your out unit"],
    Cell[584757, 11270, 815, 24, 42, "Output",
      CellTags->"Setting up your out unit"],
    Cell[585587, 11297, 121, 5, 41, "MathCaption",
      CellTags->"Setting up your out unit"],
    Cell[585733, 11306, 122, 3, 29, "Input",
      CellTags->"Setting up your out unit"],
    Cell[585858, 11311, 738, 23, 27, "Output",
      CellTags->"Setting up your out unit"],
    Cell[586611, 11337, 160, 4, 41, "MathCaption",
      CellTags->"Setting up your out unit"],
    Cell[586774, 11343, 115, 3, 29, "Input",
      CellTags->"Setting up your out unit"]},
  "Unit prefixes"->{
    Cell[586926, 11351, 67, 1, 35, "Subsubsection",
      CellTags->"Unit prefixes"],
    Cell[586996, 11354, 96, 1, 25, "Text",
      CellTags->"Unit prefixes"],
    Cell[587117, 11359, 101, 3, 29, "Input",
      CellTags->"Unit prefixes"],
    Cell[587221, 11364, 7823, 186, 167, "Output",
      CellTags->"Unit prefixes"],
    Cell[595059, 11553, 112, 2, 41, "MathCaption",
      CellTags->"Unit prefixes"],
    Cell[595196, 11559, 530, 16, 29, "Input",
      CellTags->"Unit prefixes"],
    Cell[595729, 11577, 581, 18, 27, "Output",
      CellTags->"Unit prefixes"],
    Cell[596325, 11598, 88, 1, 41, "MathCaption",
      CellTags->"Unit prefixes"],
    Cell[596438, 11603, 690, 18, 50, "Input",
      CellTags->"Unit prefixes"],
    Cell[597131, 11623, 835, 25, 27, "Output",
      CellTags->"Unit prefixes"],
    Cell[597981, 11651, 61, 1, 25, "Text",
      CellTags->"Unit prefixes"],
    Cell[598045, 11654, 175, 4, 41, "MathCaption",
      CellTags->"Unit prefixes"],
    Cell[598245, 11662, 650, 19, 50, "Input",
      CellTags->"Unit prefixes"],
    Cell[598898, 11683, 577, 18, 27, "Output",
      CellTags->"Unit prefixes"],
    Cell[599490, 11704, 155, 4, 41, "MathCaption",
      CellTags->"Unit prefixes"],
    Cell[599670, 11712, 693, 21, 29, "Input",
      CellTags->"Unit prefixes"],
    Cell[600366, 11735, 577, 18, 27, "Output",
      CellTags->"Unit prefixes"],
    Cell[600958, 11756, 107, 3, 29, "Input",
      CellTags->"Unit prefixes"]},
  "Basic resolution of motion's problems"->{
    Cell[601102, 11764, 115, 1, 35, "Subsubsection",
      CellTags->"Basic resolution of motion's problems"],
    Cell[601220, 11767, 162, 3, 29, "Input",
      CellTags->"Basic resolution of motion's problems"],
    Cell[601385, 11772, 165, 6, 25, "Text",
      CellTags->"Basic resolution of motion's problems"],
    Cell[601553, 11780, 189, 5, 50, "Input",
      CellTags->"Basic resolution of motion's problems"],
    Cell[601745, 11787, 100, 1, 25, "Text",
      CellTags->"Basic resolution of motion's problems"],
    Cell[601870, 11792, 690, 19, 47, "Input",
      CellTags->"Basic resolution of motion's problems"],
    Cell[602563, 11813, 642, 19, 44, "Output",
      CellTags->"Basic resolution of motion's problems"],
    Cell[603220, 11835, 73, 1, 25, "Text",
      CellTags->"Basic resolution of motion's problems"],
    Cell[603318, 11840, 116, 3, 29, "Input",
      CellTags->"Basic resolution of motion's problems"],
    Cell[603437, 11845, 678, 19, 66, "Output",
      CellTags->"Basic resolution of motion's problems"],
    Cell[604130, 11867, 324, 8, 42, "Text",
      CellTags->"Basic resolution of motion's problems"],
    Cell[604479, 11879, 336, 10, 29, "Input",
      CellTags->"Basic resolution of motion's problems"],
    Cell[604818, 11891, 425, 12, 69, "Output",
      CellTags->"Basic resolution of motion's problems"],
    Cell[605258, 11906, 341, 11, 25, "Text",
      CellTags->"Basic resolution of motion's problems"],
    Cell[605624, 11921, 337, 10, 29, "Input",
      CellTags->"Basic resolution of motion's problems"],
    Cell[605964, 11933, 318, 9, 38, "Output",
      CellTags->"Basic resolution of motion's problems"],
    Cell[606297, 11945, 113, 1, 25, "Text",
      CellTags->"Basic resolution of motion's problems"],
    Cell[606435, 11950, 595, 16, 29, "Input",
      CellTags->"Basic resolution of motion's problems"],
    Cell[607033, 11968, 13884, 466, 184, 4996, 351, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->"Basic resolution of motion's problems"],
    Cell[620932, 12437, 214, 4, 42, "Text",
      CellTags->"Basic resolution of motion's problems"],
    Cell[621149, 12443, 591, 16, 29, "Input",
      CellTags->"Basic resolution of motion's problems"],
    Cell[621743, 12461, 725, 20, 48, "Input",
      CellTags->"Basic resolution of motion's problems"],
    Cell[622471, 12483, 118, 1, 25, "Text",
      CellTags->"Basic resolution of motion's problems"],
    Cell[622614, 12488, 160, 3, 40, "Input",
      CellTags->"Basic resolution of motion's problems"],
    Cell[622777, 12493, 605, 17, 44, "Output",
      CellTags->"Basic resolution of motion's problems"],
    Cell[623419, 12515, 170, 4, 29, "Input",
      CellTags->"Basic resolution of motion's problems"],
    Cell[623592, 12521, 1365, 37, 66, "Output",
      CellTags->"Basic resolution of motion's problems"],
    Cell[624972, 12561, 99, 1, 25, "Text",
      CellTags->"Basic resolution of motion's problems"],
    Cell[625096, 12566, 336, 10, 29, "Input",
      CellTags->"Basic resolution of motion's problems"],
    Cell[625435, 12578, 362, 10, 49, "Output",
      CellTags->"Basic resolution of motion's problems"],
    Cell[625834, 12593, 385, 11, 29, "Input",
      CellTags->"Basic resolution of motion's problems"],
    Cell[626222, 12606, 450, 11, 66, "Output",
      CellTags->"Basic resolution of motion's problems"],
    Cell[626687, 12620, 409, 13, 25, "Text",
      CellTags->"Basic resolution of motion's problems"],
    Cell[627121, 12637, 684, 20, 29, "Input",
      CellTags->"Basic resolution of motion's problems"],
    Cell[627808, 12659, 645, 18, 38, "Output",
      CellTags->"Basic resolution of motion's problems"],
    Cell[628468, 12680, 161, 6, 25, "Text",
      CellTags->"Basic resolution of motion's problems"],
    Cell[628654, 12690, 330, 10, 29, "Input",
      CellTags->"Basic resolution of motion's problems"],
    Cell[628987, 12702, 300, 9, 27, "Output",
      CellTags->"Basic resolution of motion's problems"],
    Cell[629302, 12714, 99, 1, 25, "Text",
      CellTags->"Basic resolution of motion's problems"],
    Cell[629426, 12719, 127, 3, 29, "Input",
      CellTags->"Basic resolution of motion's problems"],
    Cell[629556, 12724, 1735, 45, 83, "Output",
      CellTags->"Basic resolution of motion's problems"],
    Cell[631306, 12772, 181, 6, 25, "Text",
      CellTags->"Basic resolution of motion's problems"],
    Cell[631512, 12782, 385, 11, 29, "Input",
      CellTags->"Basic resolution of motion's problems"],
    Cell[631900, 12795, 445, 11, 66, "Output",
      CellTags->"Basic resolution of motion's problems"],
    Cell[632360, 12809, 103, 1, 25, "Text",
      CellTags->"Basic resolution of motion's problems"],
    Cell[632488, 12814, 760, 19, 49, "Input",
      CellTags->"Basic resolution of motion's problems"],
    Cell[633273, 12837, 14953, 468, 184, 5911, 351, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->"Basic resolution of motion's problems"],
    Cell[648229, 13307, 15812, 538, 184, 6934, 423, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->"Basic resolution of motion's problems"],
    Cell[664044, 13847, 14592, 499, 184, 6487, 393, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->"Basic resolution of motion's problems"],
    Cell[678639, 14348, 12420, 421, 184, 5706, 333, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->"Basic resolution of motion's problems"],
    Cell[691086, 14773, 281, 11, 25, "Text",
      CellTags->"Basic resolution of motion's problems"],
    Cell[691392, 14788, 740, 21, 43, "Input",
      CellTags->"Basic resolution of motion's problems"],
    Cell[692135, 14811, 450, 11, 66, "Output",
      CellTags->"Basic resolution of motion's problems"],
    Cell[692600, 14825, 72, 1, 25, "Text",
      CellTags->"Basic resolution of motion's problems"],
    Cell[692697, 14830, 1623, 42, 43, "Input",
      CellTags->"Basic resolution of motion's problems"],
    Cell[694323, 14874, 117, 3, 27, "Output",
      CellTags->"Basic resolution of motion's problems"],
    Cell[694455, 14880, 350, 12, 29, "Text",
      CellTags->"Basic resolution of motion's problems"],
    Cell[694830, 14896, 490, 14, 43, "Input",
      CellTags->"Basic resolution of motion's problems"],
    Cell[695323, 14912, 462, 12, 66, "Output",
      CellTags->"Basic resolution of motion's problems"],
    Cell[695800, 14927, 87, 1, 25, "Text",
      CellTags->"Basic resolution of motion's problems"],
    Cell[695890, 14930, 170, 3, 29, "Input",
      CellTags->"Basic resolution of motion's problems"]},
  "Basic resolution of plane motion's problems"->{
    Cell[696097, 14938, 127, 1, 35, "Subsubsection",
      CellTags->"Basic resolution of plane motion's problems"],
    Cell[696227, 14941, 404, 11, 59, "Text",
      CellTags->"Basic resolution of plane motion's problems"],
    Cell[696634, 14954, 188, 4, 29, "Input",
      CellTags->"Basic resolution of plane motion's problems"],
    Cell[696825, 14960, 235, 5, 46, "Input",
      CellTags->"Basic resolution of plane motion's problems"],
    Cell[697063, 14967, 991, 27, 39, "Input",
      CellTags->"Basic resolution of plane motion's problems"],
    Cell[698079, 14998, 753, 21, 29, "Input",
      CellTags->"Basic resolution of plane motion's problems"],
    Cell[698835, 15021, 769, 20, 43, "Output",
      CellTags->"Basic resolution of plane motion's problems"],
    Cell[699641, 15046, 1054, 26, 29, "Input",
      CellTags->"Basic resolution of plane motion's problems"],
    Cell[700698, 15074, 12433, 376, 184, 3744, 263, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->"Basic resolution of plane motion's problems"],
    Cell[713146, 15453, 172, 3, 29, "Input",
      CellTags->"Basic resolution of plane motion's problems"],
    Cell[713343, 15460, 134, 3, 29, "Input",
      CellTags->"Basic resolution of plane motion's problems"],
    Cell[713480, 15465, 2000, 52, 51, "Output",
      CellTags->"Basic resolution of plane motion's problems"],
    Cell[715517, 15522, 365, 10, 29, "Input",
      CellTags->"Basic resolution of plane motion's problems"],
    Cell[715885, 15534, 813, 21, 51, "Output",
      CellTags->"Basic resolution of plane motion's problems"],
    Cell[716735, 15560, 603, 16, 29, "Input",
      CellTags->"Basic resolution of plane motion's problems"],
    Cell[717341, 15578, 13096, 450, 184, 4911, 344, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->"Basic resolution of plane motion's problems"],
    Cell[730452, 16031, 164, 3, 29, "Input",
      CellTags->"Basic resolution of plane motion's problems"],
    Cell[730641, 16038, 134, 3, 29, "Input",
      CellTags->"Basic resolution of plane motion's problems"],
    Cell[730778, 16043, 2490, 63, 46, "Output",
      CellTags->"Basic resolution of plane motion's problems"],
    Cell[733305, 16111, 365, 10, 29, "Input",
      CellTags->"Basic resolution of plane motion's problems"],
    Cell[733673, 16123, 895, 22, 51, "Output",
      CellTags->"Basic resolution of plane motion's problems"],
    Cell[734605, 16150, 572, 15, 29, "Input",
      CellTags->"Basic resolution of plane motion's problems"],
    Cell[735180, 16167, 16771, 532, 184, 5539, 388, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->"Basic resolution of plane motion's problems"],
    Cell[751966, 16702, 169, 3, 29, "Input",
      CellTags->"Basic resolution of plane motion's problems"],
    Cell[752138, 16707, 303, 11, 25, "Warning",
      CellTags->"Basic resolution of plane motion's problems"]},
  "Dimensionless Numbers"->{
    Cell[752478, 16723, 83, 1, 35, "Subsubsection",
      CellTags->"Dimensionless Numbers"],
    Cell[752564, 16726, 541, 12, 59, "Text",
      CellTags->"Dimensionless Numbers"],
    Cell[753108, 16740, 120, 3, 29, "Input",
      CellTags->"Dimensionless Numbers"],
    Cell[753231, 16745, 130, 3, 29, "Input",
      CellTags->"Dimensionless Numbers"],
    Cell[753364, 16750, 343, 7, 49, "Input",
      CellTags->"Dimensionless Numbers"],
    Cell[753710, 16759, 165, 6, 41, "MathCaption",
      CellTags->"Dimensionless Numbers"],
    Cell[753900, 16769, 1580, 41, 43, "Input",
      CellTags->"Dimensionless Numbers"],
    Cell[755483, 16812, 404, 12, 23, "Print",
      CellTags->"Dimensionless Numbers"],
    Cell[755890, 16826, 406, 12, 34, "Print",
      CellTags->"Dimensionless Numbers"],
    Cell[756299, 16840, 394, 12, 36, "Print",
      CellTags->"Dimensionless Numbers"],
    Cell[756696, 16854, 389, 12, 37, "Print",
      CellTags->"Dimensionless Numbers"],
    Cell[757088, 16868, 184, 5, 23, "Print",
      CellTags->"Dimensionless Numbers"],
    Cell[757287, 16876, 164, 6, 41, "MathCaption",
      CellTags->"Dimensionless Numbers"],
    Cell[757476, 16886, 1298, 32, 43, "Input",
      CellTags->"Dimensionless Numbers"],
    Cell[758777, 16920, 426, 12, 39, "Print",
      CellTags->"Dimensionless Numbers"],
    Cell[759206, 16934, 420, 12, 37, "Print",
      CellTags->"Dimensionless Numbers"],
    Cell[759629, 16948, 424, 12, 36, "Print",
      CellTags->"Dimensionless Numbers"],
    Cell[760056, 16962, 183, 5, 23, "Print",
      CellTags->"Dimensionless Numbers"],
    Cell[760254, 16970, 176, 8, 41, "MathCaption",
      CellTags->"Dimensionless Numbers"],
    Cell[760455, 16982, 1348, 34, 42, "Input",
      CellTags->"Dimensionless Numbers"],
    Cell[761806, 17018, 402, 12, 23, "Print",
      CellTags->"Dimensionless Numbers"],
    Cell[762211, 17032, 426, 12, 36, "Print",
      CellTags->"Dimensionless Numbers"],
    Cell[762640, 17046, 442, 12, 36, "Print",
      CellTags->"Dimensionless Numbers"],
    Cell[763085, 17060, 184, 5, 23, "Print",
      CellTags->"Dimensionless Numbers"],
    Cell[763284, 17068, 164, 6, 41, "MathCaption",
      CellTags->"Dimensionless Numbers"],
    Cell[763473, 17078, 2220, 57, 63, "Input",
      CellTags->"Dimensionless Numbers"],
    Cell[765696, 17137, 405, 12, 23, "Print",
      CellTags->"Dimensionless Numbers"],
    Cell[766104, 17151, 394, 12, 36, "Print",
      CellTags->"Dimensionless Numbers"],
    Cell[766501, 17165, 395, 12, 34, "Print",
      CellTags->"Dimensionless Numbers"],
    Cell[766899, 17179, 401, 12, 36, "Print",
      CellTags->"Dimensionless Numbers"],
    Cell[767303, 17193, 443, 12, 23, "Print",
      CellTags->"Dimensionless Numbers"],
    Cell[767749, 17207, 389, 12, 37, "Print",
      CellTags->"Dimensionless Numbers"],
    Cell[768141, 17221, 186, 5, 23, "Print",
      CellTags->"Dimensionless Numbers"],
    Cell[768342, 17229, 164, 6, 41, "MathCaption",
      CellTags->"Dimensionless Numbers"],
    Cell[768531, 17239, 1257, 32, 46, "Input",
      CellTags->"Dimensionless Numbers"],
    Cell[769791, 17273, 388, 12, 37, "Print",
      CellTags->"Dimensionless Numbers"],
    Cell[770182, 17287, 394, 12, 36, "Print",
      CellTags->"Dimensionless Numbers"],
    Cell[770579, 17301, 401, 12, 39, "Print",
      CellTags->"Dimensionless Numbers"],
    Cell[770983, 17315, 184, 5, 23, "Print",
      CellTags->"Dimensionless Numbers"],
    Cell[771182, 17323, 179, 8, 41, "MathCaption",
      CellTags->"Dimensionless Numbers"],
    Cell[771386, 17335, 1871, 48, 82, "Input",
      CellTags->"Dimensionless Numbers"],
    Cell[773260, 17385, 388, 12, 23, "Print",
      CellTags->"Dimensionless Numbers"],
    Cell[773651, 17399, 399, 12, 36, "Print",
      CellTags->"Dimensionless Numbers"],
    Cell[774053, 17413, 399, 12, 36, "Print",
      CellTags->"Dimensionless Numbers"],
    Cell[774455, 17427, 395, 12, 34, "Print",
      CellTags->"Dimensionless Numbers"],
    Cell[774853, 17441, 388, 12, 37, "Print",
      CellTags->"Dimensionless Numbers"],
    Cell[775244, 17455, 183, 5, 23, "Print",
      CellTags->"Dimensionless Numbers"],
    Cell[775442, 17463, 115, 1, 41, "MathCaption",
      CellTags->"Dimensionless Numbers"],
    Cell[775582, 17468, 228, 5, 33, "Input",
      CellTags->"Dimensionless Numbers"],
    Cell[775813, 17475, 257, 5, 27, "Output",
      CellTags->"Dimensionless Numbers"],
    Cell[776085, 17483, 134, 3, 29, "Input",
      CellTags->"Dimensionless Numbers"]},
  "Automatic convertions"->{
    Cell[776256, 17491, 83, 1, 35, "Subsubsection",
      CellTags->"Automatic convertions"],
    Cell[776342, 17494, 353, 12, 42, "Text",
      CellTags->"Automatic convertions"],
    Cell[776698, 17508, 97, 1, 41, "MathCaption",
      CellTags->"Automatic convertions"],
    Cell[776820, 17513, 173, 4, 29, "Input",
      CellTags->"Automatic convertions"],
    Cell[776996, 17519, 876, 26, 46, "Output",
      CellTags->"Automatic convertions"],
    Cell[777887, 17548, 141, 3, 41, "MathCaption",
      CellTags->"Automatic convertions"],
    Cell[778053, 17555, 111, 3, 29, "Input",
      CellTags->"Automatic convertions"],
    Cell[778167, 17560, 945, 26, 40, "Output",
      CellTags->"Automatic convertions"],
    Cell[779149, 17591, 536, 17, 41, "Input",
      CellTags->"Automatic convertions"],
    Cell[779688, 17610, 881, 25, 40, "Output",
      CellTags->"Automatic convertions"],
    Cell[780584, 17638, 196, 4, 42, "Text",
      CellTags->"Automatic convertions"],
    Cell[780783, 17644, 83, 1, 41, "MathCaption",
      CellTags->"Automatic convertions"],
    Cell[780891, 17649, 110, 3, 29, "Input",
      CellTags->"Automatic convertions"],
    Cell[781004, 17654, 325, 10, 40, "Output",
      CellTags->"Automatic convertions"],
    Cell[781344, 17667, 78, 1, 41, "MathCaption",
      CellTags->"Automatic convertions"],
    Cell[781447, 17672, 116, 3, 29, "Input",
      CellTags->"Automatic convertions"],
    Cell[781566, 17677, 287, 9, 27, "Output",
      CellTags->"Automatic convertions"],
    Cell[781868, 17689, 168, 6, 41, "MathCaption",
      CellTags->"Automatic convertions"],
    Cell[782061, 17699, 132, 3, 29, "Input",
      CellTags->"Automatic convertions"],
    Cell[782196, 17704, 325, 10, 40, "Output",
      CellTags->"Automatic convertions"],
    Cell[782536, 17717, 249, 5, 42, "Text",
      CellTags->"Automatic convertions"],
    Cell[782788, 17724, 133, 3, 41, "MathCaption",
      CellTags->"Automatic convertions"],
    Cell[782924, 17729, 141, 3, 29, "Input",
      CellTags->"Automatic convertions"],
    Cell[783068, 17734, 340, 11, 66, "MathCaption",
      CellTags->"Automatic convertions"],
    Cell[783433, 17749, 134, 3, 29, "Input",
      CellTags->"Automatic convertions"],
    Cell[783570, 17754, 675, 20, 40, "Output",
      CellTags->"Automatic convertions"],
    Cell[784260, 17777, 93, 1, 41, "MathCaption",
      CellTags->"Automatic convertions"],
    Cell[784378, 17782, 106, 3, 29, "Input",
      CellTags->"Automatic convertions"],
    Cell[784487, 17787, 957, 27, 46, "Output",
      CellTags->"Automatic convertions"],
    Cell[785459, 17817, 92, 1, 41, "MathCaption",
      CellTags->"Automatic convertions"],
    Cell[785554, 17820, 142, 3, 29, "Input",
      CellTags->"Automatic convertions"],
    Cell[785699, 17825, 109, 3, 29, "Input",
      CellTags->"Automatic convertions"]},
  "Precision"->{
    Cell[785845, 17833, 59, 1, 35, "Subsubsection",
      CellTags->"Precision"],
    Cell[785907, 17836, 755, 28, 76, "Text",
      CellTags->"Precision"],
    Cell[786665, 17866, 84, 1, 41, "MathCaption",
      CellTags->"Precision"],
    Cell[786774, 17871, 164, 4, 29, "Input",
      CellTags->"Precision"],
    Cell[786941, 17877, 874, 26, 46, "Output",
      CellTags->"Precision"],
    Cell[787830, 17906, 87, 1, 41, "MathCaption",
      CellTags->"Precision"],
    Cell[787942, 17911, 94, 3, 29, "Input",
      CellTags->"Precision"],
    Cell[788039, 17916, 1038, 29, 48, "Output",
      CellTags->"Precision"],
    Cell[789092, 17948, 204, 8, 41, "MathCaption",
      CellTags->"Precision"],
    Cell[789299, 17958, 121, 3, 29, "Input",
      CellTags->"Precision"],
    Cell[789423, 17963, 183, 8, 41, "MathCaption",
      CellTags->"Precision"],
    Cell[789631, 17975, 85, 3, 29, "Input",
      CellTags->"Precision"],
    Cell[789719, 17980, 831, 25, 38, "Output",
      CellTags->"Precision"],
    Cell[790587, 18010, 94, 3, 29, "Input",
      CellTags->"Precision"],
    Cell[790684, 18015, 934, 26, 40, "Output",
      CellTags->"Precision"],
    Cell[791633, 18044, 96, 1, 41, "MathCaption",
      CellTags->"Precision"],
    Cell[791732, 18047, 118, 3, 29, "Input",
      CellTags->"Precision"],
    Cell[791875, 18054, 85, 3, 29, "Input",
      CellTags->"Precision"],
    Cell[791963, 18059, 865, 25, 38, "Output",
      CellTags->"Precision"],
    Cell[792865, 18089, 94, 3, 29, "Input",
      CellTags->"Precision"],
    Cell[792962, 18094, 1003, 27, 40, "Output",
      CellTags->"Precision"],
    Cell[793980, 18124, 80, 1, 41, "MathCaption",
      CellTags->"Precision"],
    Cell[794063, 18127, 122, 3, 29, "Input",
      CellTags->"Precision"],
    Cell[794188, 18132, 97, 3, 29, "Input",
      CellTags->"Precision"]},
  "Format"->{
    Cell[794322, 18140, 53, 1, 35, "Subsubsection",
      CellTags->"Format"],
    Cell[794378, 18143, 330, 12, 42, "Text",
      CellTags->"Format"],
    Cell[794711, 18157, 139, 6, 41, "MathCaption",
      CellTags->"Format"],
    Cell[794853, 18165, 188, 5, 29, "Input",
      CellTags->"Format"],
    Cell[795066, 18174, 127, 3, 41, "Input",
      CellTags->"Format"],
    Cell[795196, 18179, 928, 26, 46, "Output",
      CellTags->"Format"],
    Cell[796139, 18208, 77, 1, 41, "MathCaption",
      CellTags->"Format"],
    Cell[796219, 18211, 164, 4, 29, "Input",
      CellTags->"Format"]},
  "Setting up your unit system (FPS)"->{
    Cell[796420, 18220, 107, 1, 35, "Subsubsection",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[796530, 18223, 124, 1, 25, "Text",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[796657, 18226, 97, 1, 41, "MathCaption",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[796757, 18229, 195, 4, 29, "Input",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[796955, 18235, 96, 1, 41, "MathCaption",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[797076, 18240, 128, 3, 29, "Input",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[797207, 18245, 138, 3, 27, "Output",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[797360, 18251, 170, 5, 41, "MathCaption",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[797533, 18258, 645, 11, 172, "Input",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[798181, 18271, 210, 6, 41, "MathCaption",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[798416, 18281, 136, 3, 29, "Input",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[798555, 18286, 276, 5, 65, "Output",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[798846, 18294, 127, 1, 41, "MathCaption",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[798976, 18297, 223, 5, 29, "Input",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[799202, 18304, 344, 11, 41, "MathCaption",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[799571, 18319, 141, 3, 29, "Input",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[799715, 18324, 2095, 37, 217, "Output",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[801825, 18364, 500, 21, 42, "Text",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[802328, 18387, 192, 5, 25, "Text",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[802523, 18394, 85, 1, 41, "MathCaption",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[802633, 18399, 238, 5, 50, "Input",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[802874, 18406, 319, 9, 43, "Output",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[803208, 18418, 87, 1, 41, "MathCaption",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[803320, 18423, 116, 3, 29, "Input",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[803439, 18428, 262, 8, 27, "Output",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[803716, 18439, 110, 1, 41, "MathCaption",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[803829, 18442, 206, 5, 30, "Input",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[804038, 18449, 86, 1, 41, "MathCaption",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[804149, 18454, 119, 3, 29, "Input",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[804271, 18459, 318, 9, 27, "Output",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[804604, 18471, 231, 8, 25, "Text",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[804838, 18481, 85, 1, 41, "MathCaption",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[804948, 18486, 171, 4, 41, "Input",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[805122, 18492, 325, 9, 41, "Output",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[805462, 18504, 197, 6, 41, "MathCaption",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[805662, 18512, 161, 3, 41, "Input",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[805826, 18517, 170, 6, 41, "MathCaption",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[806021, 18527, 171, 4, 41, "Input",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[806195, 18533, 322, 9, 40, "Output",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[806532, 18545, 156, 6, 41, "MathCaption",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[806713, 18555, 118, 3, 29, "Input",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[806834, 18560, 2571, 44, 225, "Output",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[809420, 18607, 91, 1, 41, "MathCaption",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[809514, 18610, 180, 4, 29, "Input",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[809697, 18616, 114, 1, 41, "MathCaption",
      CellTags->"Setting up your unit system (FPS)"],
    Cell[809814, 18619, 127, 3, 29, "Input",
      CellTags->"Setting up your unit system (FPS)"]},
  "Managing units dimensions"->{
    Cell[809978, 18627, 91, 1, 35, "Subsubsection",
      CellTags->"Managing units dimensions"],
    Cell[810072, 18630, 425, 13, 59, "Text",
      CellTags->"Managing units dimensions"],
    Cell[810500, 18645, 422, 11, 43, "DefinitionBox",
      CellTags->"Managing units dimensions"],
    Cell[810925, 18658, 126, 2, 41, "MathCaption",
      CellTags->"Managing units dimensions"],
    Cell[811076, 18664, 134, 3, 43, "Input",
      CellTags->"Managing units dimensions"],
    Cell[811213, 18669, 317, 9, 45, "Output",
      CellTags->"Managing units dimensions"],
    Cell[811545, 18681, 88, 1, 41, "MathCaption",
      CellTags->"Managing units dimensions"],
    Cell[811636, 18684, 219, 6, 46, "Input",
      CellTags->"Managing units dimensions"],
    Cell[811858, 18692, 205, 6, 41, "MathCaption",
      CellTags->"Managing units dimensions"],
    Cell[812088, 18702, 123, 3, 29, "Input",
      CellTags->"Managing units dimensions"],
    Cell[812214, 18707, 837, 25, 45, "Output",
      CellTags->"Managing units dimensions"],
    Cell[813066, 18735, 187, 8, 41, "MathCaption",
      CellTags->"Managing units dimensions"],
    Cell[813256, 18745, 197, 5, 46, "Input",
      CellTags->"Managing units dimensions"],
    Cell[813456, 18752, 97, 1, 41, "MathCaption",
      CellTags->"Managing units dimensions"],
    Cell[813578, 18757, 156, 3, 43, "Input",
      CellTags->"Managing units dimensions"],
    Cell[813737, 18762, 809, 25, 45, "Output",
      CellTags->"Managing units dimensions"],
    Cell[814561, 18790, 106, 1, 41, "MathCaption",
      CellTags->"Managing units dimensions"],
    Cell[814670, 18793, 119, 3, 29, "Input",
      CellTags->"Managing units dimensions"]},
  "Notations"->{
    Cell[814826, 18801, 59, 1, 35, "Subsubsection",
      CellTags->"Notations"],
    Cell[814888, 18804, 56, 1, 25, "Text",
      CellTags->"Notations"],
    Cell[814947, 18807, 192, 4, 29, "Input",
      CellTags->"Notations"],
    Cell[815142, 18813, 61, 1, 25, "Text",
      CellTags->"Notations"],
    Cell[815206, 18816, 620, 11, 109, "Input",
      CellTags->"Notations"],
    Cell[815829, 18829, 123, 5, 25, "Text",
      CellTags->"Notations"],
    Cell[815955, 18836, 219, 5, 69, "Input",
      CellTags->"Notations"],
    Cell[816177, 18843, 114, 6, 25, "Text",
      CellTags->"Notations"],
    Cell[816294, 18851, 225, 5, 49, "Input",
      CellTags->"Notations"],
    Cell[816522, 18858, 297, 9, 25, "Text",
      CellTags->"Notations"],
    Cell[816822, 18869, 408, 12, 30, "Input",
      CellTags->"Notations"],
    Cell[817233, 18883, 44, 1, 25, "Text",
      CellTags->"Notations"],
    Cell[817302, 18888, 658, 11, 172, "Input",
      CellTags->"Notations"],
    Cell[817963, 18901, 257, 7, 41, "Print",
      CellTags->"Notations"],
    Cell[818223, 18910, 248, 7, 63, "Print",
      CellTags->"Notations"],
    Cell[818474, 18919, 316, 8, 48, "Print",
      CellTags->"Notations"],
    Cell[818793, 18929, 240, 7, 41, "Print",
      CellTags->"Notations"],
    Cell[819036, 18938, 287, 8, 26, "Print",
      CellTags->"Notations"],
    Cell[819326, 18948, 370, 9, 63, "Print",
      CellTags->"Notations"],
    Cell[819699, 18959, 401, 10, 44, "Print",
      CellTags->"Notations"],
    Cell[820103, 18971, 394, 9, 81, "Print",
      CellTags->"Notations"],
    Cell[820500, 18982, 390, 10, 39, "Print",
      CellTags->"Notations"],
    Cell[820905, 18995, 205, 6, 25, "Text",
      CellTags->"Notations"],
    Cell[821113, 19003, 301, 9, 25, "Text",
      CellTags->"Notations"],
    Cell[821417, 19014, 809, 23, 49, "Input",
      CellTags->"Notations"],
    Cell[822251, 19041, 699, 12, 168, "Input",
      CellTags->"Notations"],
    Cell[822953, 19055, 284, 7, 40, "Print",
      CellTags->"Notations"],
    Cell[823240, 19064, 264, 7, 48, "Print",
      CellTags->"Notations"],
    Cell[823507, 19073, 332, 8, 43, "Print",
      CellTags->"Notations"],
    Cell[823842, 19083, 250, 7, 46, "Print",
      CellTags->"Notations"],
    Cell[824095, 19092, 309, 8, 26, "Print",
      CellTags->"Notations"],
    Cell[824407, 19102, 402, 9, 48, "Print",
      CellTags->"Notations"],
    Cell[824812, 19113, 419, 10, 39, "Print",
      CellTags->"Notations"],
    Cell[825234, 19125, 442, 11, 51, "Print",
      CellTags->"Notations"],
    Cell[825679, 19138, 408, 10, 39, "Print",
      CellTags->"Notations"],
    Cell[826102, 19151, 135, 4, 25, "Text",
      CellTags->"Notations"],
    Cell[826240, 19157, 64, 1, 25, "Text",
      CellTags->"Notations"],
    Cell[826307, 19160, 189, 4, 29, "Input",
      CellTags->"Notations"],
    Cell[826499, 19166, 68, 1, 25, "Text",
      CellTags->"Notations"],
    Cell[826570, 19169, 1195, 33, 90, "Input",
      CellTags->"Notations"]},
  "Money"->{
    Cell[827802, 19207, 51, 1, 35, "Subsubsection",
      CellTags->"Money"],
    Cell[827856, 19210, 373, 12, 42, "Text",
      CellTags->"Money"],
    Cell[828254, 19226, 93, 3, 29, "Input",
      CellTags->"Money"],
    Cell[828350, 19231, 299, 9, 45, "Output",
      CellTags->"Money"]},
  "To do ..."->{
    Cell[828698, 19246, 59, 1, 35, "Subsubsection",
      CellTags->"To do ..."],
    Cell[828760, 19249, 128, 6, 25, "Text",
      CellTags->"To do ..."],
    Cell[828891, 19257, 128, 4, 25, "Text",
      CellTags->"To do ..."],
    Cell[829022, 19263, 268, 8, 42, "Text",
      CellTags->"To do ..."],
    Cell[829293, 19273, 902, 27, 42, "Text",
      CellTags->"To do ..."],
    Cell[830198, 19302, 189, 4, 42, "Text",
      CellTags->"To do ..."],
    Cell[830390, 19308, 160, 6, 25, "Text",
      CellTags->"To do ..."],
    Cell[830553, 19316, 208, 5, 42, "Text",
      CellTags->"To do ..."],
    Cell[830764, 19323, 281, 7, 42, "Text",
      CellTags->"To do ..."],
    Cell[831048, 19332, 252, 7, 42, "Text",
      CellTags->"To do ..."],
    Cell[831303, 19341, 107, 3, 25, "Text",
      CellTags->"To do ..."]},
  "References"->{
    Cell[831447, 19349, 109, 3, 35, "Subsubsection",
      Evaluatable->False,
      CellTags->"References"],
    Cell[831559, 19354, 145, 4, 25, "Text",
      CellTags->"References"],
    Cell[831707, 19360, 357, 15, 75, "Text",
      CellTags->"References"],
    Cell[832067, 19377, 198, 6, 25, "Text",
      CellTags->"References"],
    Cell[832268, 19385, 366, 5, 100, "Text",
      CellTags->"References"],
    Cell[832637, 19392, 155, 4, 25, "Text",
      CellTags->"References"],
    Cell[832795, 19398, 299, 7, 100, "Text",
      CellTags->"References"],
    Cell[833097, 19407, 183, 6, 25, "Text",
      CellTags->"References"],
    Cell[833283, 19415, 232, 7, 50, "Text",
      CellTags->"References"],
    Cell[834126, 19447, 91, 1, 17, "Caption",
      CellTags->"References"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"Unit tour", 1088029, 28278},
  {"Installation notes", 1095236, 28468},
  {"Introducing units", 1096472, 28500},
  {"Info3312025924-1924540", 1098784, 28555},
  {"Information utility", 1098899, 28558},
  {"Default unit system", 1100406, 28593},
  {"Dimensions of units", 1101730, 28624},
  {"Simplification of units", 1104093, 28679},
  {"Convertions between unit systems", 1105858, 28718},
  {"Convertions between units", 1107297, 28747},
  {"Temperature convertions", 1109736, 28800},
  {"Dimension incompatibility", 1112234, 28855},
  {"Constants", 1113374, 28880},
  {"UnitK and UnitS utilities", 1116036, 28947},
  {"Setting up your out unit", 1117476, 28978},
  {"Unit prefixes", 1121271, 29061},
  {"Basic resolution of motion's problems", 1122782, 29098},
  {"Basic resolution of plane motion's problems", 1129421, 29226},
  {"Dimensionless Numbers", 1132369, 29280},
  {"Automatic convertions", 1136922, 29383},
  {"Precision", 1139795, 29448},
  {"Format", 1141657, 29497},
  {"Setting up your unit system (FPS)", 1142295, 29514},
  {"Managing units dimensions", 1146995, 29607},
  {"Notations", 1148706, 29644},
  {"Money", 1151726, 29725},
  {"To do ...", 1152035, 29734},
  {"References", 1152877, 29757}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 125, 6, 40, "Subsection",
  CellTags->"Unit tour"],
Cell[1904, 61, 90, 1, 17, "Caption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{
Cell[2019, 66, 125, 3, 35, "Subsubsection",
  Evaluatable->False,
  CellTags->"Installation notes"],
Cell[2147, 71, 235, 6, 42, "Text",
  Evaluatable->False,
  CellTags->"Installation notes"],
Cell[2385, 79, 311, 13, 25, "Text",
  Evaluatable->False,
  CellTags->"Installation notes"],

Cell[CellGroupData[{
Cell[2721, 96, 215, 4, 69, "Input",
  CellTags->"Installation notes"],
Cell[2939, 102, 164, 4, 46, "Output"]
}, Open  ]],
Cell[3118, 109, 433, 16, 42, "Text",
  Evaluatable->False,
  CellTags->"Installation notes"],

Cell[CellGroupData[{
Cell[3576, 129, 276, 5, 89, "Input",
  CellTags->"Installation notes"],
Cell[3855, 136, 226, 5, 46, "Output",
  CellTags->"Installation notes"]
}, Open  ]],
Cell[4096, 144, 167, 5, 25, "Text",
  CellTags->"Installation notes"],
Cell[4266, 151, 160208, 2289, 247, 134171, 1963, "GraphicsData", \
"PostScript", "Text",
  CellTags->"Installation notes"],
Cell[164477, 2442, 199, 7, 25, "Text",
  Evaluatable->False,
  CellTags->"Installation notes"],
Cell[164679, 2451, 273046, 3893, 235, 219632, 3229, "GraphicsData", \
"PostScript", "Text",
  CellTags->"Installation notes"],
Cell[437728, 6346, 245, 7, 42, "Text",
  CellTags->"Installation notes"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[438022, 6359, 41, 0, 39, "Subsection"],

Cell[CellGroupData[{
Cell[438088, 6363, 107, 3, 35, "Subsubsection",
  Evaluatable->False,
  CellTags->"Unit tour"],
Cell[438198, 6368, 198, 4, 25, "Text",
  CellTags->"Unit tour"],
Cell[438399, 6374, 248, 5, 49, "Input",
  CellTags->"Unit tour"],
Cell[438650, 6381, 70, 1, 41, "MathCaption",
  CellTags->"Unit tour"],
Cell[438723, 6384, 107, 3, 29, "Input",
  CellTags->"Unit tour"],
Cell[438833, 6389, 210, 7, 41, "MathCaption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{
Cell[439068, 6400, 172, 4, 49, "Input",
  CellTags->"Unit tour"],
Cell[439243, 6406, 571, 18, 38, "Output",
  CellTags->"Unit tour"]
}, Closed]],
Cell[439829, 6427, 136, 4, 41, "MathCaption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{
Cell[439990, 6435, 126, 3, 41, "Input",
  CellTags->"Unit tour"],
Cell[440119, 6440, 287, 9, 27, "Output",
  CellTags->"Unit tour"]
}, Closed]],
Cell[440421, 6452, 77, 1, 41, "MathCaption",
  CellTags->"Unit tour"],
Cell[440501, 6455, 102, 3, 29, "Input",
  CellTags->"Unit tour"],

Cell[CellGroupData[{
Cell[440628, 6462, 127, 3, 41, "Input",
  CellTags->"Unit tour"],
Cell[440758, 6467, 295, 9, 40, "Output",
  CellTags->"Unit tour"]
}, Closed]],
Cell[441068, 6479, 103, 3, 29, "Input",
  CellTags->"Unit tour"],
Cell[441174, 6484, 89, 1, 41, "MathCaption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{
Cell[441288, 6489, 133, 4, 29, "Input",
  CellTags->"Unit tour"],
Cell[441424, 6495, 2086, 46, 159, "Output",
  CellTags->"Unit tour"]
}, Closed]],
Cell[443525, 6544, 173, 6, 41, "MathCaption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{
Cell[443723, 6554, 135, 4, 29, "Input",
  CellTags->"Unit tour"],
Cell[443861, 6560, 405, 9, 29, "Output",
  CellTags->"Unit tour"]
}, Closed]],
Cell[444281, 6572, 109, 2, 41, "MathCaption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{
Cell[444415, 6578, 927, 27, 29, "Input",
  CellTags->"Unit tour"],
Cell[445345, 6607, 937, 26, 27, "Output",
  CellTags->"Unit tour"]
}, Closed]],
Cell[446297, 6636, 88, 1, 41, "MathCaption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{
Cell[446410, 6641, 151, 4, 29, "Input",
  CellTags->"Unit tour"],
Cell[446564, 6647, 635, 19, 40, "Output",
  CellTags->"Unit tour"]
}, Closed]],

Cell[CellGroupData[{
Cell[447236, 6671, 122, 4, 29, "Input",
  CellTags->"Unit tour"],
Cell[447361, 6677, 542, 16, 43, "Output",
  CellTags->"Unit tour"]
}, Closed]],

Cell[CellGroupData[{
Cell[447940, 6698, 122, 4, 29, "Input",
  CellTags->"Unit tour"],
Cell[448065, 6704, 498, 16, 27, "Output",
  CellTags->"Unit tour"]
}, Closed]],

Cell[CellGroupData[{
Cell[448600, 6725, 126, 4, 29, "Input",
  CellTags->"Unit tour"],
Cell[448729, 6731, 233, 8, 27, "Output",
  CellTags->"Unit tour"]
}, Closed]],
Cell[448977, 6742, 408, 15, 58, "MathCaption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{
Cell[449410, 6761, 140, 4, 29, "Input",
  CellTags->"Unit tour"],
Cell[449553, 6767, 273, 9, 38, "Output",
  CellTags->"Unit tour"]
}, Closed]],
Cell[449841, 6779, 477, 22, 59, "MathCaption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{
Cell[450343, 6805, 165, 4, 49, "Input",
  CellTags->"Unit tour"],
Cell[450511, 6811, 523, 9, 35, "Message",
  CellTags->"Unit tour"]
}, Closed]],

Cell[CellGroupData[{
Cell[451071, 6825, 121, 3, 29, "Input",
  CellTags->"Unit tour"],
Cell[451195, 6830, 115, 3, 27, "Output",
  CellTags->"Unit tour"]
}, Closed]],

Cell[CellGroupData[{
Cell[451347, 6838, 119, 3, 29, "Input",
  CellTags->"Unit tour"],
Cell[451469, 6843, 582, 18, 27, "Output",
  CellTags->"Unit tour"]
}, Closed]],
Cell[452066, 6864, 299, 11, 41, "MathCaption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{
Cell[452390, 6879, 402, 11, 41, "Input",
  CellTags->"Unit tour"],
Cell[452795, 6892, 445, 12, 40, "Output",
  CellTags->"Unit tour"]
}, Closed]],
Cell[453255, 6907, 98, 1, 41, "MathCaption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{
Cell[453378, 6912, 221, 5, 82, "Input",
  CellTags->"Unit tour"],
Cell[453602, 6919, 410, 11, 40, "Output",
  CellTags->"Unit tour"]
}, Closed]],
Cell[454027, 6933, 123, 5, 41, "MathCaption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{
Cell[454175, 6942, 1952, 54, 50, "Input",
  CellTags->"Unit tour"],
Cell[456130, 6998, 2113, 54, 61, "Output",
  CellTags->"Unit tour"]
}, Closed]],

Cell[CellGroupData[{
Cell[458280, 7057, 100, 3, 29, "Input",
  CellTags->"Unit tour"],
Cell[458383, 7062, 340, 10, 60, "Output",
  CellTags->"Unit tour"]
}, Closed]],
Cell[458738, 7075, 147, 5, 41, "MathCaption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{
Cell[458910, 7084, 524, 17, 29, "Input",
  CellTags->"Unit tour"],
Cell[459437, 7103, 292, 9, 27, "Output",
  CellTags->"Unit tour"]
}, Closed]],
Cell[459744, 7115, 175, 4, 41, "MathCaption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{
Cell[459944, 7123, 603, 18, 29, "Input",
  CellTags->"Unit tour"],
Cell[460550, 7143, 635, 18, 27, "Output",
  CellTags->"Unit tour"]
}, Closed]],

Cell[CellGroupData[{
Cell[461222, 7166, 621, 18, 29, "Input",
  CellTags->"Unit tour"],
Cell[461846, 7186, 638, 18, 27, "Output",
  CellTags->"Unit tour"]
}, Closed]],
Cell[462499, 7207, 97, 1, 41, "MathCaption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{
Cell[462621, 7212, 108, 3, 29, "Input",
  CellTags->"Unit tour"],
Cell[462732, 7217, 2366, 51, 185, "Output",
  CellTags->"Unit tour"]
}, Closed]],
Cell[465113, 7271, 87, 1, 41, "MathCaption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{
Cell[465225, 7276, 233, 6, 62, "Input",
  CellTags->"Unit tour"],
Cell[465461, 7284, 290, 9, 40, "Output",
  CellTags->"Unit tour"]
}, Closed]],

Cell[CellGroupData[{
Cell[465788, 7298, 154, 4, 49, "Input",
  CellTags->"Unit tour"],
Cell[465945, 7304, 274, 9, 38, "Output",
  CellTags->"Unit tour"]
}, Closed]],
Cell[466234, 7316, 103, 1, 41, "MathCaption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{
Cell[466362, 7321, 225, 6, 49, "Input",
  CellTags->"Unit tour"],
Cell[466590, 7329, 1037, 29, 48, "Output",
  CellTags->"Unit tour"]
}, Closed]],

Cell[CellGroupData[{
Cell[467664, 7363, 163, 4, 49, "Input",
  CellTags->"Unit tour"],
Cell[467830, 7369, 1002, 27, 40, "Output",
  CellTags->"Unit tour"]
}, Closed]],
Cell[468847, 7399, 121, 3, 29, "Input",
  CellTags->"Unit tour"],
Cell[468971, 7404, 95, 1, 41, "MathCaption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{
Cell[469091, 7409, 432, 9, 122, "Input",
  CellTags->"Unit tour"],
Cell[469526, 7420, 1177, 32, 46, "Output",
  CellTags->"Unit tour"]
}, Closed]],
Cell[470718, 7455, 166, 4, 29, "Input",
  CellTags->"Unit tour"],
Cell[470887, 7461, 130, 3, 41, "MathCaption",
  CellTags->"Unit tour"],

Cell[CellGroupData[{
Cell[471042, 7468, 172, 4, 49, "Input",
  CellTags->"Unit tour"],
Cell[471217, 7474, 782, 24, 27, "Output",
  CellTags->"Unit tour"]
}, Closed]],

Cell[CellGroupData[{
Cell[472036, 7503, 376, 9, 69, "Input",
  CellTags->"Unit tour"],
Cell[472415, 7514, 750, 23, 27, "Output",
  CellTags->"Unit tour"]
}, Closed]],
Cell[473180, 7540, 95, 1, 41, "MathCaption",
  CellTags->"Unit tour"],
Cell[473278, 7543, 102, 3, 29, "Input",
  CellTags->"Unit tour"],
Cell[473383, 7548, 53, 1, 41, "MathCaption",
  CellTags->"Unit tour"],
Cell[473439, 7551, 99, 3, 29, "Input",
  CellTags->"Unit tour"],
Cell[473541, 7556, 72, 1, 41, "MathCaption",
  CellTags->"Unit tour"],
Cell[473616, 7559, 154, 3, 25, "Text",
  CellTags->"Unit tour"]
}, Closed]],

Cell[CellGroupData[{
Cell[473807, 7567, 75, 1, 35, "Subsubsection",
  CellTags->"Introducing units"],
Cell[473885, 7570, 123, 3, 25, "Text",
  CellTags->"Introducing units"],
Cell[474011, 7575, 78, 1, 41, "MathCaption",
  CellTags->"Introducing units"],
Cell[474092, 7578, 116, 3, 29, "Input",
  CellTags->"Introducing units"],
Cell[474211, 7583, 130, 5, 41, "MathCaption",
  CellTags->"Introducing units"],

Cell[CellGroupData[{
Cell[474366, 7592, 100, 3, 29, "Input",
  CellTags->"Introducing units"],
Cell[474469, 7597, 477, 7, 70, "Print",
  CellTags->"Info3312025924-1924540"]
}, Closed]],
Cell[474961, 7607, 92, 1, 41, "MathCaption",
  CellTags->"Introducing units"],

Cell[CellGroupData[{
Cell[475078, 7612, 398, 11, 29, "Input",
  CellTags->"Introducing units"],
Cell[475479, 7625, 811, 25, 70, "Output",
  CellTags->"Introducing units"]
}, Closed]],

Cell[CellGroupData[{
Cell[476327, 7655, 105, 3, 29, "Input",
  CellTags->"Introducing units"],
Cell[476435, 7660, 135, 2, 70, "Output",
  CellTags->"Introducing units"]
}, Closed]],
Cell[476585, 7665, 314, 15, 41, "MathCaption",
  CellTags->"Introducing units"],
Cell[476902, 7682, 147, 4, 31, "Input",
  CellTags->"Introducing units"],
Cell[477052, 7688, 282, 8, 41, "MathCaption",
  CellTags->"Introducing units"],
Cell[477337, 7698, 623, 18, 40, "Input",
  CellTags->"Introducing units"],
Cell[477963, 7718, 259, 9, 41, "MathCaption",
  CellTags->"Introducing units"],
Cell[478225, 7729, 1039, 29, 40, "Input",
  CellTags->"Introducing units"],
Cell[479267, 7760, 182, 6, 41, "MathCaption",
  CellTags->"Introducing units"],

Cell[CellGroupData[{
Cell[479474, 7770, 196, 4, 60, "Input",
  CellTags->"Introducing units"],
Cell[479673, 7776, 811, 25, 70, "Output",
  CellTags->"Introducing units"]
}, Closed]],

Cell[CellGroupData[{
Cell[480521, 7806, 105, 3, 29, "Input",
  CellTags->"Introducing units"],
Cell[480629, 7811, 152, 3, 70, "Output",
  CellTags->"Introducing units"]
}, Closed]],
Cell[480796, 7817, 144, 4, 41, "MathCaption",
  CellTags->"Introducing units"],

Cell[CellGroupData[{
Cell[480965, 7825, 122, 3, 41, "Input",
  CellTags->"Introducing units"],
Cell[481090, 7830, 326, 10, 70, "Output",
  CellTags->"Introducing units"]
}, Closed]],

Cell[CellGroupData[{
Cell[481453, 7845, 131, 3, 41, "Input",
  CellTags->"Introducing units"],
Cell[481587, 7850, 330, 10, 70, "Output",
  CellTags->"Introducing units"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[481966, 7866, 79, 1, 35, "Subsubsection",
  CellTags->"Information utility"],
Cell[482048, 7869, 159, 6, 25, "Text",
  CellTags->"Information utility"],
Cell[482210, 7877, 2510, 71, 196, "DefinitionBox",
  CellTags->"Information utility"],
Cell[484723, 7950, 78, 1, 17, "Caption",
  CellTags->"Information utility"],
Cell[484804, 7953, 183, 6, 41, "MathCaption",
  CellTags->"Information utility"],

Cell[CellGroupData[{
Cell[485012, 7963, 145, 4, 29, "Input",
  CellTags->"Information utility"],
Cell[485160, 7969, 415, 9, 70, "Output",
  CellTags->"Information utility"]
}, Closed]],
Cell[485590, 7981, 339, 12, 41, "MathCaption",
  CellTags->"Information utility"],

Cell[CellGroupData[{
Cell[485954, 7997, 147, 4, 29, "Input",
  CellTags->"Information utility"],
Cell[486104, 8003, 1964, 43, 70, "Output",
  CellTags->"Information utility"]
}, Closed]],
Cell[488083, 8049, 429, 15, 41, "MathCaption",
  CellTags->"Information utility"],

Cell[CellGroupData[{
Cell[488537, 8068, 163, 4, 49, "Input",
  CellTags->"Information utility"],
Cell[488703, 8074, 2017, 44, 70, "Output",
  CellTags->"Information utility"]
}, Closed]],
Cell[490735, 8121, 112, 3, 29, "Input",
  CellTags->"Information utility"],
Cell[490850, 8126, 98, 1, 41, "MathCaption",
  CellTags->"Information utility"],

Cell[CellGroupData[{
Cell[490973, 8131, 106, 3, 29, "Input",
  CellTags->"Information utility"],
Cell[491082, 8136, 167, 4, 70, "Output",
  CellTags->"Information utility"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[491298, 8146, 79, 1, 35, "Subsubsection",
  CellTags->"Default unit system"],
Cell[491380, 8149, 133, 3, 25, "Text",
  CellTags->"Default unit system"],
Cell[491516, 8154, 576, 16, 60, "DefinitionBox",
  CellTags->"Default unit system"],
Cell[492095, 8172, 66, 1, 17, "Caption",
  CellTags->"Default unit system"],
Cell[492164, 8175, 75, 1, 41, "MathCaption",
  CellTags->"Default unit system"],

Cell[CellGroupData[{
Cell[492264, 8180, 98, 3, 29, "Input",
  CellTags->"Default unit system"],
Cell[492365, 8185, 101, 3, 27, "Output",
  CellTags->"Default unit system"]
}, Closed]],
Cell[492481, 8191, 109, 1, 41, "MathCaption",
  CellTags->"Default unit system"],
Cell[492593, 8194, 113, 3, 29, "Input",
  CellTags->"Default unit system"],

Cell[CellGroupData[{
Cell[492731, 8201, 124, 3, 41, "Input",
  CellTags->"Default unit system"],
Cell[492858, 8206, 328, 10, 48, "Output",
  CellTags->"Default unit system"]
}, Closed]],

Cell[CellGroupData[{
Cell[493223, 8221, 133, 3, 41, "Input",
  CellTags->"Default unit system"],
Cell[493359, 8226, 336, 10, 48, "Output",
  CellTags->"Default unit system"]
}, Closed]],
Cell[493710, 8239, 78, 1, 41, "MathCaption",
  CellTags->"Default unit system"],
Cell[493791, 8242, 113, 3, 29, "Input",
  CellTags->"Default unit system"]
}, Closed]],

Cell[CellGroupData[{
Cell[493941, 8250, 79, 1, 35, "Subsubsection",
  CellTags->"Dimensions of units"],
Cell[494023, 8253, 210, 9, 25, "Text",
  CellTags->"Dimensions of units"],
Cell[494236, 8264, 907, 25, 60, "DefinitionBox",
  CellTags->"Dimensions of units"],
Cell[495146, 8291, 73, 1, 17, "Caption",
  CellTags->"Dimensions of units"],
Cell[495222, 8294, 95, 1, 41, "MathCaption",
  CellTags->"Dimensions of units"],

Cell[CellGroupData[{
Cell[495342, 8299, 200, 5, 29, "Input",
  CellTags->"Dimensions of units"],
Cell[495545, 8306, 1152, 33, 48, "Output",
  CellTags->"Dimensions of units"]
}, Closed]],
Cell[496712, 8342, 77, 1, 41, "MathCaption",
  CellTags->"Dimensions of units"],

Cell[CellGroupData[{
Cell[496814, 8347, 138, 4, 29, "Input",
  CellTags->"Dimensions of units"],
Cell[496955, 8353, 223, 6, 48, "Output",
  CellTags->"Dimensions of units"]
}, Closed]],
Cell[497193, 8362, 88, 1, 41, "MathCaption",
  CellTags->"Dimensions of units"],

Cell[CellGroupData[{
Cell[497306, 8367, 132, 4, 29, "Input",
  CellTags->"Dimensions of units"],
Cell[497441, 8373, 1015, 30, 45, "Output",
  CellTags->"Dimensions of units"]
}, Closed]],
Cell[498471, 8406, 149, 4, 41, "MathCaption",
  CellTags->"Dimensions of units"],

Cell[CellGroupData[{
Cell[498645, 8414, 132, 4, 29, "Input",
  CellTags->"Dimensions of units"],
Cell[498780, 8420, 972, 30, 45, "Output",
  CellTags->"Dimensions of units"]
}, Closed]],
Cell[499767, 8453, 106, 3, 29, "Input",
  CellTags->"Dimensions of units"],
Cell[499876, 8458, 170, 6, 41, "MathCaption",
  CellTags->"Dimensions of units"],

Cell[CellGroupData[{
Cell[500071, 8468, 201, 4, 46, "Input",
  CellTags->"Dimensions of units"],
Cell[500275, 8474, 498, 16, 27, "Output",
  CellTags->"Dimensions of units"]
}, Closed]],

Cell[CellGroupData[{
Cell[500810, 8495, 175, 4, 49, "Input",
  CellTags->"Dimensions of units"],
Cell[500988, 8501, 1064, 34, 27, "Output",
  CellTags->"Dimensions of units"]
}, Closed]],

Cell[CellGroupData[{
Cell[502089, 8540, 231, 5, 69, "Input",
  CellTags->"Dimensions of units"],
Cell[502323, 8547, 1074, 34, 38, "Output",
  CellTags->"Dimensions of units"]
}, Closed]],

Cell[CellGroupData[{
Cell[503434, 8586, 238, 5, 69, "Input",
  CellTags->"Dimensions of units"],
Cell[503675, 8593, 1405, 40, 27, "Output",
  CellTags->"Dimensions of units"]
}, Closed]],
Cell[505095, 8636, 113, 3, 29, "Input",
  CellTags->"Dimensions of units"]
}, Closed]],

Cell[CellGroupData[{
Cell[505245, 8644, 87, 1, 35, "Subsubsection",
  CellTags->"Simplification of units"],
Cell[505335, 8647, 178, 5, 25, "Text",
  CellTags->"Simplification of units"],
Cell[505516, 8654, 2969, 86, 60, "DefinitionBox",
  CellTags->"Simplification of units"],
Cell[508488, 8742, 70, 1, 17, "Caption",
  CellTags->"Simplification of units"],
Cell[508561, 8745, 192, 8, 41, "MathCaption",
  CellTags->"Simplification of units"],

Cell[CellGroupData[{
Cell[508778, 8757, 117, 3, 29, "Input",
  CellTags->"Simplification of units"],
Cell[508898, 8762, 288, 6, 46, "Output",
  CellTags->"Simplification of units"]
}, Closed]],
Cell[509201, 8771, 195, 8, 41, "MathCaption",
  CellTags->"Simplification of units"],
Cell[509399, 8781, 129, 3, 29, "Input",
  CellTags->"Simplification of units"],

Cell[CellGroupData[{
Cell[509553, 8788, 1788, 55, 134, "Input",
  CellTags->"Simplification of units"],
Cell[511344, 8845, 328, 10, 45, "Output",
  CellTags->"Simplification of units"]
}, Closed]],
Cell[511687, 8858, 135, 6, 41, "MathCaption",
  CellTags->"Simplification of units"],

Cell[CellGroupData[{
Cell[511847, 8868, 655, 19, 29, "Input",
  CellTags->"Simplification of units"],
Cell[512505, 8889, 402, 11, 40, "Output",
  CellTags->"Simplification of units"]
}, Closed]],
Cell[512922, 8903, 135, 5, 41, "MathCaption",
  CellTags->"Simplification of units"],

Cell[CellGroupData[{
Cell[513082, 8912, 137, 3, 29, "Input",
  CellTags->"Simplification of units"],
Cell[513222, 8917, 350, 10, 60, "Output",
  CellTags->"Simplification of units"]
}, Closed]],
Cell[513587, 8930, 129, 3, 29, "Input",
  CellTags->"Simplification of units"],
Cell[513719, 8935, 400, 18, 42, "Text",
  CellTags->"Simplification of units"]
}, Closed]],

Cell[CellGroupData[{
Cell[514156, 8958, 105, 1, 35, "Subsubsection",
  CellTags->"Convertions between unit systems"],
Cell[514264, 8961, 178, 4, 25, "Text",
  CellTags->"Convertions between unit systems"],
Cell[514445, 8967, 1262, 36, 78, "DefinitionBox",
  CellTags->"Convertions between unit systems"],
Cell[515710, 9005, 95, 1, 17, "Caption",
  CellTags->"Convertions between unit systems"],
Cell[515808, 9008, 107, 1, 41, "MathCaption",
  CellTags->"Convertions between unit systems"],

Cell[CellGroupData[{
Cell[515940, 9013, 213, 5, 29, "Input",
  CellTags->"Convertions between unit systems"],
Cell[516156, 9020, 1165, 33, 48, "Output",
  CellTags->"Convertions between unit systems"]
}, Closed]],
Cell[517336, 9056, 159, 6, 41, "MathCaption",
  CellTags->"Convertions between unit systems"],

Cell[CellGroupData[{
Cell[517520, 9066, 139, 3, 29, "Input",
  CellTags->"Convertions between unit systems"],
Cell[517662, 9071, 1916, 58, 118, "Output",
  CellTags->"Convertions between unit systems"]
}, Closed]],
Cell[519593, 9132, 159, 6, 41, "MathCaption",
  CellTags->"Convertions between unit systems"],

Cell[CellGroupData[{
Cell[519777, 9142, 140, 3, 29, "Input",
  CellTags->"Convertions between unit systems"],
Cell[519920, 9147, 2031, 59, 112, "Output",
  CellTags->"Convertions between unit systems"]
}, Closed]],
Cell[521966, 9209, 120, 3, 29, "Input",
  CellTags->"Convertions between unit systems"]
}, Closed]],

Cell[CellGroupData[{
Cell[522123, 9217, 91, 1, 35, "Subsubsection",
  CellTags->"Convertions between units"],
Cell[522217, 9220, 195, 6, 25, "Text",
  CellTags->"Convertions between units"],
Cell[522415, 9228, 1812, 49, 60, "DefinitionBox",
  CellTags->"Convertions between units"],
Cell[524230, 9279, 84, 1, 17, "Caption",
  CellTags->"Convertions between units"],
Cell[524317, 9282, 163, 5, 41, "MathCaption",
  CellTags->"Convertions between units"],

Cell[CellGroupData[{
Cell[524505, 9291, 541, 17, 29, "Input",
  CellTags->"Convertions between units"],
Cell[525049, 9310, 309, 9, 27, "Output",
  CellTags->"Convertions between units"]
}, Closed]],
Cell[525373, 9322, 144, 3, 41, "MathCaption",
  CellTags->"Convertions between units"],

Cell[CellGroupData[{
Cell[525542, 9329, 162, 4, 30, "Input",
  CellTags->"Convertions between units"],
Cell[525707, 9335, 296, 9, 27, "Output",
  CellTags->"Convertions between units"]
}, Closed]],

Cell[CellGroupData[{
Cell[526040, 9349, 154, 3, 30, "Input",
  CellTags->"Convertions between units"],
Cell[526197, 9354, 602, 18, 43, "Output",
  CellTags->"Convertions between units"]
}, Closed]],
Cell[526814, 9375, 162, 5, 41, "MathCaption",
  CellTags->"Convertions between units"],

Cell[CellGroupData[{
Cell[527001, 9384, 312, 9, 29, "Input",
  CellTags->"Convertions between units"],
Cell[527316, 9395, 105, 3, 27, "Output",
  CellTags->"Convertions between units"]
}, Closed]],
Cell[527436, 9401, 166, 4, 41, "MathCaption",
  CellTags->"Convertions between units"],

Cell[CellGroupData[{
Cell[527627, 9409, 664, 20, 49, "Input",
  CellTags->"Convertions between units"],
Cell[528294, 9431, 615, 18, 27, "Output",
  CellTags->"Convertions between units"]
}, Closed]],
Cell[528924, 9452, 176, 6, 41, "MathCaption",
  CellTags->"Convertions between units"],

Cell[CellGroupData[{
Cell[529125, 9462, 121, 3, 29, "Input",
  CellTags->"Convertions between units"],
Cell[529249, 9467, 307, 9, 27, "Output",
  CellTags->"Convertions between units"]
}, Closed]],
Cell[529571, 9479, 152, 4, 41, "MathCaption",
  CellTags->"Convertions between units"],

Cell[CellGroupData[{
Cell[529748, 9487, 144, 3, 29, "Input",
  CellTags->"Convertions between units"],
Cell[529895, 9492, 546, 9, 20, "Message",
  CellTags->"Convertions between units"],
Cell[530444, 9503, 340, 10, 27, "Output",
  CellTags->"Convertions between units"]
}, Closed]],
Cell[530799, 9516, 116, 3, 29, "Input",
  CellTags->"Convertions between units"]
}, Closed]],

Cell[CellGroupData[{
Cell[530952, 9524, 87, 1, 35, "Subsubsection",
  CellTags->"Temperature convertions"],
Cell[531042, 9527, 843, 26, 59, "Text",
  CellTags->"Temperature convertions"],
Cell[531888, 9555, 133, 3, 41, "MathCaption",
  CellTags->"Temperature convertions"],

Cell[CellGroupData[{
Cell[532046, 9562, 1112, 32, 29, "Input",
  CellTags->"Temperature convertions"],
Cell[533161, 9596, 1175, 32, 27, "Output",
  CellTags->"Temperature convertions"]
}, Closed]],
Cell[534351, 9631, 182, 4, 41, "MathCaption",
  CellTags->"Temperature convertions"],

Cell[CellGroupData[{
Cell[534558, 9639, 1148, 32, 29, "Input",
  CellTags->"Temperature convertions"],
Cell[535709, 9673, 1178, 32, 27, "Output",
  CellTags->"Temperature convertions"]
}, Closed]],
Cell[536902, 9708, 95, 1, 41, "MathCaption",
  CellTags->"Temperature convertions"],

Cell[CellGroupData[{
Cell[537022, 9713, 1158, 32, 29, "Input",
  CellTags->"Temperature convertions"],
Cell[538183, 9747, 1193, 32, 27, "Output",
  CellTags->"Temperature convertions"]
}, Closed]],
Cell[539391, 9782, 91, 1, 41, "MathCaption",
  CellTags->"Temperature convertions"],
Cell[539485, 9785, 118, 3, 29, "Input",
  CellTags->"Temperature convertions"],

Cell[CellGroupData[{
Cell[539628, 9792, 1112, 32, 29, "Input",
  CellTags->"Temperature convertions"],
Cell[540743, 9826, 1149, 32, 27, "Output",
  CellTags->"Temperature convertions"]
}, Closed]],

Cell[CellGroupData[{
Cell[541929, 9863, 1148, 32, 29, "Input",
  CellTags->"Temperature convertions"],
Cell[543080, 9897, 1167, 32, 27, "Output",
  CellTags->"Temperature convertions"]
}, Closed]],

Cell[CellGroupData[{
Cell[544284, 9934, 1158, 32, 29, "Input",
  CellTags->"Temperature convertions"],
Cell[545445, 9968, 1169, 32, 27, "Output",
  CellTags->"Temperature convertions"]
}, Closed]],
Cell[546629, 10003, 118, 3, 29, "Input",
  CellTags->"Temperature convertions"],
Cell[546750, 10008, 129, 5, 41, "MathCaption",
  CellTags->"Temperature convertions"],

Cell[CellGroupData[{
Cell[546904, 10017, 1254, 34, 29, "Input",
  CellTags->"Temperature convertions"],
Cell[548161, 10053, 1149, 32, 27, "Output",
  CellTags->"Temperature convertions"]
}, Closed]],

Cell[CellGroupData[{
Cell[549347, 10090, 1290, 34, 29, "Input",
  CellTags->"Temperature convertions"],
Cell[550640, 10126, 1153, 32, 27, "Output",
  CellTags->"Temperature convertions"]
}, Closed]],

Cell[CellGroupData[{
Cell[551830, 10163, 1300, 34, 29, "Input",
  CellTags->"Temperature convertions"],
Cell[553133, 10199, 1157, 32, 27, "Output",
  CellTags->"Temperature convertions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[554339, 10237, 91, 1, 35, "Subsubsection",
  CellTags->"Dimension incompatibility"],
Cell[554433, 10240, 152, 4, 25, "Text",
  CellTags->"Dimension incompatibility"],
Cell[554588, 10246, 99, 1, 41, "MathCaption",
  CellTags->"Dimension incompatibility"],

Cell[CellGroupData[{
Cell[554712, 10251, 150, 3, 41, "Input",
  CellTags->"Dimension incompatibility"],
Cell[554865, 10256, 606, 18, 46, "Output",
  CellTags->"Dimension incompatibility"]
}, Closed]],
Cell[555486, 10277, 245, 7, 58, "MathCaption",
  CellTags->"Dimension incompatibility"],

Cell[CellGroupData[{
Cell[555756, 10288, 116, 3, 29, "Input",
  CellTags->"Dimension incompatibility"],
Cell[555875, 10293, 596, 18, 46, "Output",
  CellTags->"Dimension incompatibility"]
}, Closed]],
Cell[556486, 10314, 85, 1, 41, "MathCaption",
  CellTags->"Dimension incompatibility"],

Cell[CellGroupData[{
Cell[556596, 10319, 132, 3, 29, "Input",
  CellTags->"Dimension incompatibility"],
Cell[556731, 10324, 551, 9, 41, "Message",
  CellTags->"Dimension incompatibility"],
Cell[557285, 10335, 596, 18, 46, "Output",
  CellTags->"Dimension incompatibility"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[557930, 10359, 59, 1, 35, "Subsubsection",
  CellTags->"Constants"],
Cell[557992, 10362, 522, 15, 59, "Text",
  CellTags->"Constants"],
Cell[558517, 10379, 758, 16, 302, "DefinitionBox",
  CellTags->"Constants"],
Cell[559278, 10397, 76, 1, 17, "Caption",
  CellTags->"Constants"],
Cell[559357, 10400, 500, 12, 154, "DefinitionBox",
  CellTags->"Constants"],
Cell[559860, 10414, 83, 1, 17, "Caption",
  CellTags->"Constants"],
Cell[559946, 10417, 667, 15, 216, "DefinitionBox",
  CellTags->"Constants"],
Cell[560616, 10434, 83, 1, 17, "Caption",
  CellTags->"Constants"],
Cell[560702, 10437, 308, 14, 24, "SmallText",
  CellTags->"Constants"],
Cell[561013, 10453, 363, 9, 114, "DefinitionBox",
  CellTags->"Constants"],
Cell[561379, 10464, 75, 1, 17, "Caption",
  CellTags->"Constants"],
Cell[561457, 10467, 337, 9, 90, "DefinitionBox",
  CellTags->"Constants"],
Cell[561797, 10478, 95, 1, 17, "Caption",
  CellTags->"Constants"],
Cell[561895, 10481, 513, 12, 132, "DefinitionBox",
  CellTags->"Constants"],
Cell[562411, 10495, 159, 6, 17, "Caption",
  CellTags->"Constants"],
Cell[562573, 10503, 414, 10, 116, "DefinitionBox",
  CellTags->"Constants"],
Cell[562990, 10515, 171, 8, 17, "Caption",
  CellTags->"Constants"],
Cell[563164, 10525, 270, 7, 66, "DefinitionBox",
  CellTags->"Constants"],
Cell[563437, 10534, 171, 8, 17, "Caption",
  CellTags->"Constants"],
Cell[563611, 10544, 405, 10, 116, "DefinitionBox",
  CellTags->"Constants"],
Cell[564019, 10556, 171, 8, 17, "Caption",
  CellTags->"Constants"],
Cell[564193, 10566, 355, 9, 92, "DefinitionBox",
  CellTags->"Constants"],
Cell[564551, 10577, 306, 15, 17, "Caption",
  CellTags->"Constants"],
Cell[564860, 10594, 256, 7, 64, "DefinitionBox",
  CellTags->"Constants"],
Cell[565119, 10603, 87, 1, 17, "Caption",
  CellTags->"Constants"],
Cell[565209, 10606, 138, 5, 41, "MathCaption",
  CellTags->"Constants"],

Cell[CellGroupData[{
Cell[565372, 10615, 109, 3, 29, "Input",
  CellTags->"Constants"],
Cell[565484, 10620, 2367, 51, 185, "Output",
  CellTags->"Constants"]
}, Closed]],

Cell[CellGroupData[{
Cell[567888, 10676, 118, 3, 29, "Input",
  CellTags->"Constants"],
Cell[568009, 10681, 2307, 49, 165, "Output",
  CellTags->"Constants"]
}, Closed]],
Cell[570331, 10733, 84, 1, 41, "MathCaption",
  CellTags->"Constants"],

Cell[CellGroupData[{
Cell[570440, 10738, 1051, 28, 39, "Input",
  CellTags->"Constants"],
Cell[571494, 10768, 328, 10, 27, "Output",
  CellTags->"Constants"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[571871, 10784, 173, 8, 35, "Subsubsection",
  CellTags->"UnitK and UnitS utilities"],
Cell[572047, 10794, 225, 6, 42, "Text",
  CellTags->"UnitK and UnitS utilities"],
Cell[572275, 10802, 857, 22, 62, "DefinitionBox",
  CellTags->"UnitK and UnitS utilities"],
Cell[573135, 10826, 73, 1, 17, "Caption",
  CellTags->"UnitK and UnitS utilities"],
Cell[573211, 10829, 95, 1, 41, "MathCaption",
  CellTags->"UnitK and UnitS utilities"],

Cell[CellGroupData[{
Cell[573331, 10834, 139, 3, 29, "Input",
  CellTags->"UnitK and UnitS utilities"],
Cell[573473, 10839, 674, 19, 40, "Output",
  CellTags->"UnitK and UnitS utilities"]
}, Closed]],

Cell[CellGroupData[{
Cell[574184, 10863, 116, 3, 29, "Input",
  CellTags->"UnitK and UnitS utilities"],
Cell[574303, 10868, 310, 9, 27, "Output",
  CellTags->"UnitK and UnitS utilities"]
}, Closed]],
Cell[574628, 10880, 241, 9, 25, "Text",
  CellTags->"UnitK and UnitS utilities"],
Cell[574872, 10891, 1492, 39, 98, "DefinitionBox",
  CellTags->"UnitK and UnitS utilities"],
Cell[576367, 10932, 73, 1, 17, "Caption",
  CellTags->"UnitK and UnitS utilities"],
Cell[576443, 10935, 196, 6, 41, "MathCaption",
  CellTags->"UnitK and UnitS utilities"],

Cell[CellGroupData[{
Cell[576664, 10945, 140, 3, 42, "Input",
  CellTags->"UnitK and UnitS utilities"],
Cell[576807, 10950, 289, 9, 38, "Output",
  CellTags->"UnitK and UnitS utilities"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[577145, 10965, 89, 1, 35, "Subsubsection",
  CellTags->"Setting up your out unit"],
Cell[577237, 10968, 277, 5, 42, "Text",
  CellTags->"Setting up your out unit"],
Cell[577517, 10975, 111, 2, 25, "Text",
  CellTags->"Setting up your out unit"],
Cell[577631, 10979, 156, 5, 41, "MathCaption",
  CellTags->"Setting up your out unit"],

Cell[CellGroupData[{
Cell[577812, 10988, 110, 3, 29, "Input",
  CellTags->"Setting up your out unit"],
Cell[577925, 10993, 286, 9, 40, "Output",
  CellTags->"Setting up your out unit"]
}, Closed]],
Cell[578226, 11005, 319, 11, 45, "MathCaption",
  CellTags->"Setting up your out unit"],
Cell[578548, 11018, 170, 4, 30, "Input",
  CellTags->"Setting up your out unit"],

Cell[CellGroupData[{
Cell[578743, 11026, 110, 3, 29, "Input",
  CellTags->"Setting up your out unit"],
Cell[578856, 11031, 284, 9, 48, "Output",
  CellTags->"Setting up your out unit"]
}, Closed]],
Cell[579155, 11043, 76, 1, 41, "MathCaption",
  CellTags->"Setting up your out unit"],

Cell[CellGroupData[{
Cell[579256, 11048, 197, 4, 50, "Input",
  CellTags->"Setting up your out unit"],
Cell[579456, 11054, 148, 3, 40, "Output",
  CellTags->"Setting up your out unit"]
}, Closed]],

Cell[CellGroupData[{
Cell[579641, 11062, 110, 3, 29, "Input",
  CellTags->"Setting up your out unit"],
Cell[579754, 11067, 284, 9, 48, "Output",
  CellTags->"Setting up your out unit"]
}, Closed]],
Cell[580053, 11079, 95, 1, 41, "MathCaption",
  CellTags->"Setting up your out unit"],

Cell[CellGroupData[{
Cell[580173, 11084, 144, 3, 30, "Input",
  CellTags->"Setting up your out unit"],
Cell[580320, 11089, 150, 3, 40, "Output",
  CellTags->"Setting up your out unit"]
}, Closed]],
Cell[580485, 11095, 112, 2, 25, "Text",
  CellTags->"Setting up your out unit"],
Cell[580600, 11099, 151, 5, 41, "MathCaption",
  CellTags->"Setting up your out unit"],

Cell[CellGroupData[{
Cell[580776, 11108, 126, 3, 29, "Input",
  CellTags->"Setting up your out unit"],
Cell[580905, 11113, 292, 9, 27, "Output",
  CellTags->"Setting up your out unit"]
}, Closed]],
Cell[581212, 11125, 138, 6, 41, "MathCaption",
  CellTags->"Setting up your out unit"],

Cell[CellGroupData[{
Cell[581375, 11135, 185, 4, 30, "Input",
  CellTags->"Setting up your out unit"],
Cell[581563, 11141, 155, 3, 40, "Output",
  CellTags->"Setting up your out unit"]
}, Closed]],

Cell[CellGroupData[{
Cell[581755, 11149, 60, 2, 29, "Input"],
Cell[581818, 11153, 292, 9, 40, "Output"]
}, Closed]],
Cell[582125, 11165, 111, 2, 25, "Text",
  CellTags->"Setting up your out unit"],
Cell[582239, 11169, 100, 1, 41, "MathCaption",
  CellTags->"Setting up your out unit"],

Cell[CellGroupData[{
Cell[582364, 11174, 137, 3, 43, "Input",
  CellTags->"Setting up your out unit"],
Cell[582504, 11179, 316, 9, 45, "Output",
  CellTags->"Setting up your out unit"]
}, Closed]],

Cell[CellGroupData[{
Cell[582857, 11193, 119, 3, 29, "Input",
  CellTags->"Setting up your out unit"],
Cell[582979, 11198, 636, 20, 45, "Output",
  CellTags->"Setting up your out unit"]
}, Closed]],
Cell[583630, 11221, 176, 4, 41, "MathCaption",
  CellTags->"Setting up your out unit"],
Cell[583809, 11227, 189, 4, 46, "Input",
  CellTags->"Setting up your out unit"],

Cell[CellGroupData[{
Cell[584023, 11235, 60, 2, 29, "Input"],
Cell[584086, 11239, 248, 8, 27, "Output"]
}, Closed]],
Cell[584349, 11250, 258, 11, 41, "MathCaption",
  CellTags->"Setting up your out unit"],

Cell[CellGroupData[{
Cell[584632, 11265, 122, 3, 29, "Input",
  CellTags->"Setting up your out unit"],
Cell[584757, 11270, 815, 24, 42, "Output",
  CellTags->"Setting up your out unit"]
}, Closed]],
Cell[585587, 11297, 121, 5, 41, "MathCaption",
  CellTags->"Setting up your out unit"],

Cell[CellGroupData[{
Cell[585733, 11306, 122, 3, 29, "Input",
  CellTags->"Setting up your out unit"],
Cell[585858, 11311, 738, 23, 27, "Output",
  CellTags->"Setting up your out unit"]
}, Closed]],
Cell[586611, 11337, 160, 4, 41, "MathCaption",
  CellTags->"Setting up your out unit"],
Cell[586774, 11343, 115, 3, 29, "Input",
  CellTags->"Setting up your out unit"]
}, Closed]],

Cell[CellGroupData[{
Cell[586926, 11351, 67, 1, 35, "Subsubsection",
  CellTags->"Unit prefixes"],
Cell[586996, 11354, 96, 1, 25, "Text",
  CellTags->"Unit prefixes"],

Cell[CellGroupData[{
Cell[587117, 11359, 101, 3, 29, "Input",
  CellTags->"Unit prefixes"],
Cell[587221, 11364, 7823, 186, 167, "Output",
  CellTags->"Unit prefixes"]
}, Closed]],
Cell[595059, 11553, 112, 2, 41, "MathCaption",
  CellTags->"Unit prefixes"],

Cell[CellGroupData[{
Cell[595196, 11559, 530, 16, 29, "Input",
  CellTags->"Unit prefixes"],
Cell[595729, 11577, 581, 18, 27, "Output",
  CellTags->"Unit prefixes"]
}, Closed]],
Cell[596325, 11598, 88, 1, 41, "MathCaption",
  CellTags->"Unit prefixes"],

Cell[CellGroupData[{
Cell[596438, 11603, 690, 18, 50, "Input",
  CellTags->"Unit prefixes"],
Cell[597131, 11623, 835, 25, 27, "Output",
  CellTags->"Unit prefixes"]
}, Closed]],
Cell[597981, 11651, 61, 1, 25, "Text",
  CellTags->"Unit prefixes"],
Cell[598045, 11654, 175, 4, 41, "MathCaption",
  CellTags->"Unit prefixes"],

Cell[CellGroupData[{
Cell[598245, 11662, 650, 19, 50, "Input",
  CellTags->"Unit prefixes"],
Cell[598898, 11683, 577, 18, 27, "Output",
  CellTags->"Unit prefixes"]
}, Closed]],
Cell[599490, 11704, 155, 4, 41, "MathCaption",
  CellTags->"Unit prefixes"],

Cell[CellGroupData[{
Cell[599670, 11712, 693, 21, 29, "Input",
  CellTags->"Unit prefixes"],
Cell[600366, 11735, 577, 18, 27, "Output",
  CellTags->"Unit prefixes"]
}, Closed]],
Cell[600958, 11756, 107, 3, 29, "Input",
  CellTags->"Unit prefixes"]
}, Closed]],

Cell[CellGroupData[{
Cell[601102, 11764, 115, 1, 35, "Subsubsection",
  CellTags->"Basic resolution of motion's problems"],
Cell[601220, 11767, 162, 3, 29, "Input",
  CellTags->"Basic resolution of motion's problems"],
Cell[601385, 11772, 165, 6, 25, "Text",
  CellTags->"Basic resolution of motion's problems"],
Cell[601553, 11780, 189, 5, 50, "Input",
  CellTags->"Basic resolution of motion's problems"],
Cell[601745, 11787, 100, 1, 25, "Text",
  CellTags->"Basic resolution of motion's problems"],

Cell[CellGroupData[{
Cell[601870, 11792, 690, 19, 47, "Input",
  CellTags->"Basic resolution of motion's problems"],
Cell[602563, 11813, 642, 19, 44, "Output",
  CellTags->"Basic resolution of motion's problems"]
}, Closed]],
Cell[603220, 11835, 73, 1, 25, "Text",
  CellTags->"Basic resolution of motion's problems"],

Cell[CellGroupData[{
Cell[603318, 11840, 116, 3, 29, "Input",
  CellTags->"Basic resolution of motion's problems"],
Cell[603437, 11845, 678, 19, 66, "Output",
  CellTags->"Basic resolution of motion's problems"]
}, Closed]],
Cell[604130, 11867, 324, 8, 42, "Text",
  CellTags->"Basic resolution of motion's problems"],

Cell[CellGroupData[{
Cell[604479, 11879, 336, 10, 29, "Input",
  CellTags->"Basic resolution of motion's problems"],
Cell[604818, 11891, 425, 12, 69, "Output",
  CellTags->"Basic resolution of motion's problems"]
}, Closed]],
Cell[605258, 11906, 341, 11, 25, "Text",
  CellTags->"Basic resolution of motion's problems"],

Cell[CellGroupData[{
Cell[605624, 11921, 337, 10, 29, "Input",
  CellTags->"Basic resolution of motion's problems"],
Cell[605964, 11933, 318, 9, 38, "Output",
  CellTags->"Basic resolution of motion's problems"]
}, Closed]],
Cell[606297, 11945, 113, 1, 25, "Text",
  CellTags->"Basic resolution of motion's problems"],

Cell[CellGroupData[{
Cell[606435, 11950, 595, 16, 29, "Input",
  CellTags->"Basic resolution of motion's problems"],
Cell[607033, 11968, 13884, 466, 184, 4996, 351, "GraphicsData", "PostScript", \
"Graphics",
  CellTags->"Basic resolution of motion's problems"]
}, Closed]],
Cell[620932, 12437, 214, 4, 42, "Text",
  CellTags->"Basic resolution of motion's problems"],
Cell[621149, 12443, 591, 16, 29, "Input",
  CellTags->"Basic resolution of motion's problems"],
Cell[621743, 12461, 725, 20, 48, "Input",
  CellTags->"Basic resolution of motion's problems"],
Cell[622471, 12483, 118, 1, 25, "Text",
  CellTags->"Basic resolution of motion's problems"],

Cell[CellGroupData[{
Cell[622614, 12488, 160, 3, 40, "Input",
  CellTags->"Basic resolution of motion's problems"],
Cell[622777, 12493, 605, 17, 44, "Output",
  CellTags->"Basic resolution of motion's problems"]
}, Closed]],

Cell[CellGroupData[{
Cell[623419, 12515, 170, 4, 29, "Input",
  CellTags->"Basic resolution of motion's problems"],
Cell[623592, 12521, 1365, 37, 66, "Output",
  CellTags->"Basic resolution of motion's problems"]
}, Closed]],
Cell[624972, 12561, 99, 1, 25, "Text",
  CellTags->"Basic resolution of motion's problems"],

Cell[CellGroupData[{
Cell[625096, 12566, 336, 10, 29, "Input",
  CellTags->"Basic resolution of motion's problems"],
Cell[625435, 12578, 362, 10, 49, "Output",
  CellTags->"Basic resolution of motion's problems"]
}, Closed]],

Cell[CellGroupData[{
Cell[625834, 12593, 385, 11, 29, "Input",
  CellTags->"Basic resolution of motion's problems"],
Cell[626222, 12606, 450, 11, 66, "Output",
  CellTags->"Basic resolution of motion's problems"]
}, Closed]],
Cell[626687, 12620, 409, 13, 25, "Text",
  CellTags->"Basic resolution of motion's problems"],

Cell[CellGroupData[{
Cell[627121, 12637, 684, 20, 29, "Input",
  CellTags->"Basic resolution of motion's problems"],
Cell[627808, 12659, 645, 18, 38, "Output",
  CellTags->"Basic resolution of motion's problems"]
}, Closed]],
Cell[628468, 12680, 161, 6, 25, "Text",
  CellTags->"Basic resolution of motion's problems"],

Cell[CellGroupData[{
Cell[628654, 12690, 330, 10, 29, "Input",
  CellTags->"Basic resolution of motion's problems"],
Cell[628987, 12702, 300, 9, 27, "Output",
  CellTags->"Basic resolution of motion's problems"]
}, Closed]],
Cell[629302, 12714, 99, 1, 25, "Text",
  CellTags->"Basic resolution of motion's problems"],

Cell[CellGroupData[{
Cell[629426, 12719, 127, 3, 29, "Input",
  CellTags->"Basic resolution of motion's problems"],
Cell[629556, 12724, 1735, 45, 83, "Output",
  CellTags->"Basic resolution of motion's problems"]
}, Closed]],
Cell[631306, 12772, 181, 6, 25, "Text",
  CellTags->"Basic resolution of motion's problems"],

Cell[CellGroupData[{
Cell[631512, 12782, 385, 11, 29, "Input",
  CellTags->"Basic resolution of motion's problems"],
Cell[631900, 12795, 445, 11, 66, "Output",
  CellTags->"Basic resolution of motion's problems"]
}, Closed]],
Cell[632360, 12809, 103, 1, 25, "Text",
  CellTags->"Basic resolution of motion's problems"],

Cell[CellGroupData[{
Cell[632488, 12814, 760, 19, 49, "Input",
  CellTags->"Basic resolution of motion's problems"],

Cell[CellGroupData[{
Cell[633273, 12837, 14953, 468, 184, 5911, 351, "GraphicsData", "PostScript", \
"Graphics",
  CellTags->"Basic resolution of motion's problems"],
Cell[648229, 13307, 15812, 538, 184, 6934, 423, "GraphicsData", "PostScript", \
"Graphics",
  CellTags->"Basic resolution of motion's problems"],
Cell[664044, 13847, 14592, 499, 184, 6487, 393, "GraphicsData", "PostScript", \
"Graphics",
  CellTags->"Basic resolution of motion's problems"],
Cell[678639, 14348, 12420, 421, 184, 5706, 333, "GraphicsData", "PostScript", \
"Graphics",
  CellTags->"Basic resolution of motion's problems"]
}, Closed]]
}, Closed]],
Cell[691086, 14773, 281, 11, 25, "Text",
  CellTags->"Basic resolution of motion's problems"],

Cell[CellGroupData[{
Cell[691392, 14788, 740, 21, 43, "Input",
  CellTags->"Basic resolution of motion's problems"],
Cell[692135, 14811, 450, 11, 66, "Output",
  CellTags->"Basic resolution of motion's problems"]
}, Closed]],
Cell[692600, 14825, 72, 1, 25, "Text",
  CellTags->"Basic resolution of motion's problems"],

Cell[CellGroupData[{
Cell[692697, 14830, 1623, 42, 43, "Input",
  CellTags->"Basic resolution of motion's problems"],
Cell[694323, 14874, 117, 3, 27, "Output",
  CellTags->"Basic resolution of motion's problems"]
}, Closed]],
Cell[694455, 14880, 350, 12, 29, "Text",
  CellTags->"Basic resolution of motion's problems"],

Cell[CellGroupData[{
Cell[694830, 14896, 490, 14, 43, "Input",
  CellTags->"Basic resolution of motion's problems"],
Cell[695323, 14912, 462, 12, 66, "Output",
  CellTags->"Basic resolution of motion's problems"]
}, Closed]],
Cell[695800, 14927, 87, 1, 25, "Text",
  CellTags->"Basic resolution of motion's problems"],
Cell[695890, 14930, 170, 3, 29, "Input",
  CellTags->"Basic resolution of motion's problems"]
}, Closed]],

Cell[CellGroupData[{
Cell[696097, 14938, 127, 1, 35, "Subsubsection",
  CellTags->"Basic resolution of plane motion's problems"],
Cell[696227, 14941, 404, 11, 59, "Text",
  CellTags->"Basic resolution of plane motion's problems"],
Cell[696634, 14954, 188, 4, 29, "Input",
  CellTags->"Basic resolution of plane motion's problems"],
Cell[696825, 14960, 235, 5, 46, "Input",
  CellTags->"Basic resolution of plane motion's problems"],
Cell[697063, 14967, 991, 27, 39, "Input",
  CellTags->"Basic resolution of plane motion's problems"],

Cell[CellGroupData[{
Cell[698079, 14998, 753, 21, 29, "Input",
  CellTags->"Basic resolution of plane motion's problems"],
Cell[698835, 15021, 769, 20, 43, "Output",
  CellTags->"Basic resolution of plane motion's problems"]
}, Closed]],

Cell[CellGroupData[{
Cell[699641, 15046, 1054, 26, 29, "Input",
  CellTags->"Basic resolution of plane motion's problems"],
Cell[700698, 15074, 12433, 376, 184, 3744, 263, "GraphicsData", "PostScript", \
"Graphics",
  CellTags->"Basic resolution of plane motion's problems"]
}, Closed]],
Cell[713146, 15453, 172, 3, 29, "Input",
  CellTags->"Basic resolution of plane motion's problems"],

Cell[CellGroupData[{
Cell[713343, 15460, 134, 3, 29, "Input",
  CellTags->"Basic resolution of plane motion's problems"],
Cell[713480, 15465, 2000, 52, 51, "Output",
  CellTags->"Basic resolution of plane motion's problems"]
}, Closed]],

Cell[CellGroupData[{
Cell[715517, 15522, 365, 10, 29, "Input",
  CellTags->"Basic resolution of plane motion's problems"],
Cell[715885, 15534, 813, 21, 51, "Output",
  CellTags->"Basic resolution of plane motion's problems"]
}, Closed]],

Cell[CellGroupData[{
Cell[716735, 15560, 603, 16, 29, "Input",
  CellTags->"Basic resolution of plane motion's problems"],
Cell[717341, 15578, 13096, 450, 184, 4911, 344, "GraphicsData", "PostScript", \
"Graphics",
  CellTags->"Basic resolution of plane motion's problems"]
}, Closed]],
Cell[730452, 16031, 164, 3, 29, "Input",
  CellTags->"Basic resolution of plane motion's problems"],

Cell[CellGroupData[{
Cell[730641, 16038, 134, 3, 29, "Input",
  CellTags->"Basic resolution of plane motion's problems"],
Cell[730778, 16043, 2490, 63, 46, "Output",
  CellTags->"Basic resolution of plane motion's problems"]
}, Closed]],

Cell[CellGroupData[{
Cell[733305, 16111, 365, 10, 29, "Input",
  CellTags->"Basic resolution of plane motion's problems"],
Cell[733673, 16123, 895, 22, 51, "Output",
  CellTags->"Basic resolution of plane motion's problems"]
}, Closed]],

Cell[CellGroupData[{
Cell[734605, 16150, 572, 15, 29, "Input",
  CellTags->"Basic resolution of plane motion's problems"],
Cell[735180, 16167, 16771, 532, 184, 5539, 388, "GraphicsData", "PostScript", \
"Graphics",
  CellTags->"Basic resolution of plane motion's problems"]
}, Closed]],
Cell[751966, 16702, 169, 3, 29, "Input",
  CellTags->"Basic resolution of plane motion's problems"],
Cell[752138, 16707, 303, 11, 25, "Warning",
  CellTags->"Basic resolution of plane motion's problems"]
}, Closed]],

Cell[CellGroupData[{
Cell[752478, 16723, 83, 1, 35, "Subsubsection",
  CellTags->"Dimensionless Numbers"],
Cell[752564, 16726, 541, 12, 59, "Text",
  CellTags->"Dimensionless Numbers"],
Cell[753108, 16740, 120, 3, 29, "Input",
  CellTags->"Dimensionless Numbers"],
Cell[753231, 16745, 130, 3, 29, "Input",
  CellTags->"Dimensionless Numbers"],
Cell[753364, 16750, 343, 7, 49, "Input",
  CellTags->"Dimensionless Numbers"],
Cell[753710, 16759, 165, 6, 41, "MathCaption",
  CellTags->"Dimensionless Numbers"],

Cell[CellGroupData[{
Cell[753900, 16769, 1580, 41, 43, "Input",
  CellTags->"Dimensionless Numbers"],
Cell[755483, 16812, 404, 12, 23, "Print",
  CellTags->"Dimensionless Numbers"],
Cell[755890, 16826, 406, 12, 34, "Print",
  CellTags->"Dimensionless Numbers"],
Cell[756299, 16840, 394, 12, 36, "Print",
  CellTags->"Dimensionless Numbers"],
Cell[756696, 16854, 389, 12, 37, "Print",
  CellTags->"Dimensionless Numbers"],
Cell[757088, 16868, 184, 5, 23, "Print",
  CellTags->"Dimensionless Numbers"]
}, Closed]],
Cell[757287, 16876, 164, 6, 41, "MathCaption",
  CellTags->"Dimensionless Numbers"],

Cell[CellGroupData[{
Cell[757476, 16886, 1298, 32, 43, "Input",
  CellTags->"Dimensionless Numbers"],
Cell[758777, 16920, 426, 12, 39, "Print",
  CellTags->"Dimensionless Numbers"],
Cell[759206, 16934, 420, 12, 37, "Print",
  CellTags->"Dimensionless Numbers"],
Cell[759629, 16948, 424, 12, 36, "Print",
  CellTags->"Dimensionless Numbers"],
Cell[760056, 16962, 183, 5, 23, "Print",
  CellTags->"Dimensionless Numbers"]
}, Closed]],
Cell[760254, 16970, 176, 8, 41, "MathCaption",
  CellTags->"Dimensionless Numbers"],

Cell[CellGroupData[{
Cell[760455, 16982, 1348, 34, 42, "Input",
  CellTags->"Dimensionless Numbers"],
Cell[761806, 17018, 402, 12, 23, "Print",
  CellTags->"Dimensionless Numbers"],
Cell[762211, 17032, 426, 12, 36, "Print",
  CellTags->"Dimensionless Numbers"],
Cell[762640, 17046, 442, 12, 36, "Print",
  CellTags->"Dimensionless Numbers"],
Cell[763085, 17060, 184, 5, 23, "Print",
  CellTags->"Dimensionless Numbers"]
}, Closed]],
Cell[763284, 17068, 164, 6, 41, "MathCaption",
  CellTags->"Dimensionless Numbers"],

Cell[CellGroupData[{
Cell[763473, 17078, 2220, 57, 63, "Input",
  CellTags->"Dimensionless Numbers"],
Cell[765696, 17137, 405, 12, 23, "Print",
  CellTags->"Dimensionless Numbers"],
Cell[766104, 17151, 394, 12, 36, "Print",
  CellTags->"Dimensionless Numbers"],
Cell[766501, 17165, 395, 12, 34, "Print",
  CellTags->"Dimensionless Numbers"],
Cell[766899, 17179, 401, 12, 36, "Print",
  CellTags->"Dimensionless Numbers"],
Cell[767303, 17193, 443, 12, 23, "Print",
  CellTags->"Dimensionless Numbers"],
Cell[767749, 17207, 389, 12, 37, "Print",
  CellTags->"Dimensionless Numbers"],
Cell[768141, 17221, 186, 5, 23, "Print",
  CellTags->"Dimensionless Numbers"]
}, Closed]],
Cell[768342, 17229, 164, 6, 41, "MathCaption",
  CellTags->"Dimensionless Numbers"],

Cell[CellGroupData[{
Cell[768531, 17239, 1257, 32, 46, "Input",
  CellTags->"Dimensionless Numbers"],
Cell[769791, 17273, 388, 12, 37, "Print",
  CellTags->"Dimensionless Numbers"],
Cell[770182, 17287, 394, 12, 36, "Print",
  CellTags->"Dimensionless Numbers"],
Cell[770579, 17301, 401, 12, 39, "Print",
  CellTags->"Dimensionless Numbers"],
Cell[770983, 17315, 184, 5, 23, "Print",
  CellTags->"Dimensionless Numbers"]
}, Closed]],
Cell[771182, 17323, 179, 8, 41, "MathCaption",
  CellTags->"Dimensionless Numbers"],

Cell[CellGroupData[{
Cell[771386, 17335, 1871, 48, 82, "Input",
  CellTags->"Dimensionless Numbers"],
Cell[773260, 17385, 388, 12, 23, "Print",
  CellTags->"Dimensionless Numbers"],
Cell[773651, 17399, 399, 12, 36, "Print",
  CellTags->"Dimensionless Numbers"],
Cell[774053, 17413, 399, 12, 36, "Print",
  CellTags->"Dimensionless Numbers"],
Cell[774455, 17427, 395, 12, 34, "Print",
  CellTags->"Dimensionless Numbers"],
Cell[774853, 17441, 388, 12, 37, "Print",
  CellTags->"Dimensionless Numbers"],
Cell[775244, 17455, 183, 5, 23, "Print",
  CellTags->"Dimensionless Numbers"]
}, Closed]],
Cell[775442, 17463, 115, 1, 41, "MathCaption",
  CellTags->"Dimensionless Numbers"],

Cell[CellGroupData[{
Cell[775582, 17468, 228, 5, 33, "Input",
  CellTags->"Dimensionless Numbers"],
Cell[775813, 17475, 257, 5, 27, "Output",
  CellTags->"Dimensionless Numbers"]
}, Closed]],
Cell[776085, 17483, 134, 3, 29, "Input",
  CellTags->"Dimensionless Numbers"]
}, Closed]],

Cell[CellGroupData[{
Cell[776256, 17491, 83, 1, 35, "Subsubsection",
  CellTags->"Automatic convertions"],
Cell[776342, 17494, 353, 12, 42, "Text",
  CellTags->"Automatic convertions"],
Cell[776698, 17508, 97, 1, 41, "MathCaption",
  CellTags->"Automatic convertions"],

Cell[CellGroupData[{
Cell[776820, 17513, 173, 4, 29, "Input",
  CellTags->"Automatic convertions"],
Cell[776996, 17519, 876, 26, 46, "Output",
  CellTags->"Automatic convertions"]
}, Closed]],
Cell[777887, 17548, 141, 3, 41, "MathCaption",
  CellTags->"Automatic convertions"],

Cell[CellGroupData[{
Cell[778053, 17555, 111, 3, 29, "Input",
  CellTags->"Automatic convertions"],
Cell[778167, 17560, 945, 26, 40, "Output",
  CellTags->"Automatic convertions"]
}, Closed]],

Cell[CellGroupData[{
Cell[779149, 17591, 536, 17, 41, "Input",
  CellTags->"Automatic convertions"],
Cell[779688, 17610, 881, 25, 40, "Output",
  CellTags->"Automatic convertions"]
}, Closed]],
Cell[780584, 17638, 196, 4, 42, "Text",
  CellTags->"Automatic convertions"],
Cell[780783, 17644, 83, 1, 41, "MathCaption",
  CellTags->"Automatic convertions"],

Cell[CellGroupData[{
Cell[780891, 17649, 110, 3, 29, "Input",
  CellTags->"Automatic convertions"],
Cell[781004, 17654, 325, 10, 40, "Output",
  CellTags->"Automatic convertions"]
}, Closed]],
Cell[781344, 17667, 78, 1, 41, "MathCaption",
  CellTags->"Automatic convertions"],

Cell[CellGroupData[{
Cell[781447, 17672, 116, 3, 29, "Input",
  CellTags->"Automatic convertions"],
Cell[781566, 17677, 287, 9, 27, "Output",
  CellTags->"Automatic convertions"]
}, Closed]],
Cell[781868, 17689, 168, 6, 41, "MathCaption",
  CellTags->"Automatic convertions"],

Cell[CellGroupData[{
Cell[782061, 17699, 132, 3, 29, "Input",
  CellTags->"Automatic convertions"],
Cell[782196, 17704, 325, 10, 40, "Output",
  CellTags->"Automatic convertions"]
}, Closed]],
Cell[782536, 17717, 249, 5, 42, "Text",
  CellTags->"Automatic convertions"],
Cell[782788, 17724, 133, 3, 41, "MathCaption",
  CellTags->"Automatic convertions"],
Cell[782924, 17729, 141, 3, 29, "Input",
  CellTags->"Automatic convertions"],
Cell[783068, 17734, 340, 11, 66, "MathCaption",
  CellTags->"Automatic convertions"],

Cell[CellGroupData[{
Cell[783433, 17749, 134, 3, 29, "Input",
  CellTags->"Automatic convertions"],
Cell[783570, 17754, 675, 20, 40, "Output",
  CellTags->"Automatic convertions"]
}, Closed]],
Cell[784260, 17777, 93, 1, 41, "MathCaption",
  CellTags->"Automatic convertions"],

Cell[CellGroupData[{
Cell[784378, 17782, 106, 3, 29, "Input",
  CellTags->"Automatic convertions"],
Cell[784487, 17787, 957, 27, 46, "Output",
  CellTags->"Automatic convertions"]
}, Closed]],
Cell[785459, 17817, 92, 1, 41, "MathCaption",
  CellTags->"Automatic convertions"],
Cell[785554, 17820, 142, 3, 29, "Input",
  CellTags->"Automatic convertions"],
Cell[785699, 17825, 109, 3, 29, "Input",
  CellTags->"Automatic convertions"]
}, Closed]],

Cell[CellGroupData[{
Cell[785845, 17833, 59, 1, 35, "Subsubsection",
  CellTags->"Precision"],
Cell[785907, 17836, 755, 28, 76, "Text",
  CellTags->"Precision"],
Cell[786665, 17866, 84, 1, 41, "MathCaption",
  CellTags->"Precision"],

Cell[CellGroupData[{
Cell[786774, 17871, 164, 4, 29, "Input",
  CellTags->"Precision"],
Cell[786941, 17877, 874, 26, 46, "Output",
  CellTags->"Precision"]
}, Closed]],
Cell[787830, 17906, 87, 1, 41, "MathCaption",
  CellTags->"Precision"],

Cell[CellGroupData[{
Cell[787942, 17911, 94, 3, 29, "Input",
  CellTags->"Precision"],
Cell[788039, 17916, 1038, 29, 48, "Output",
  CellTags->"Precision"]
}, Closed]],
Cell[789092, 17948, 204, 8, 41, "MathCaption",
  CellTags->"Precision"],
Cell[789299, 17958, 121, 3, 29, "Input",
  CellTags->"Precision"],
Cell[789423, 17963, 183, 8, 41, "MathCaption",
  CellTags->"Precision"],

Cell[CellGroupData[{
Cell[789631, 17975, 85, 3, 29, "Input",
  CellTags->"Precision"],
Cell[789719, 17980, 831, 25, 38, "Output",
  CellTags->"Precision"]
}, Closed]],

Cell[CellGroupData[{
Cell[790587, 18010, 94, 3, 29, "Input",
  CellTags->"Precision"],
Cell[790684, 18015, 934, 26, 40, "Output",
  CellTags->"Precision"]
}, Closed]],
Cell[791633, 18044, 96, 1, 41, "MathCaption",
  CellTags->"Precision"],
Cell[791732, 18047, 118, 3, 29, "Input",
  CellTags->"Precision"],

Cell[CellGroupData[{
Cell[791875, 18054, 85, 3, 29, "Input",
  CellTags->"Precision"],
Cell[791963, 18059, 865, 25, 38, "Output",
  CellTags->"Precision"]
}, Closed]],

Cell[CellGroupData[{
Cell[792865, 18089, 94, 3, 29, "Input",
  CellTags->"Precision"],
Cell[792962, 18094, 1003, 27, 40, "Output",
  CellTags->"Precision"]
}, Closed]],
Cell[793980, 18124, 80, 1, 41, "MathCaption",
  CellTags->"Precision"],
Cell[794063, 18127, 122, 3, 29, "Input",
  CellTags->"Precision"],
Cell[794188, 18132, 97, 3, 29, "Input",
  CellTags->"Precision"]
}, Closed]],

Cell[CellGroupData[{
Cell[794322, 18140, 53, 1, 35, "Subsubsection",
  CellTags->"Format"],
Cell[794378, 18143, 330, 12, 42, "Text",
  CellTags->"Format"],
Cell[794711, 18157, 139, 6, 41, "MathCaption",
  CellTags->"Format"],
Cell[794853, 18165, 188, 5, 29, "Input",
  CellTags->"Format"],

Cell[CellGroupData[{
Cell[795066, 18174, 127, 3, 41, "Input",
  CellTags->"Format"],
Cell[795196, 18179, 928, 26, 46, "Output",
  CellTags->"Format"]
}, Closed]],
Cell[796139, 18208, 77, 1, 41, "MathCaption",
  CellTags->"Format"],
Cell[796219, 18211, 164, 4, 29, "Input",
  CellTags->"Format"]
}, Closed]],

Cell[CellGroupData[{
Cell[796420, 18220, 107, 1, 35, "Subsubsection",
  CellTags->"Setting up your unit system (FPS)"],
Cell[796530, 18223, 124, 1, 25, "Text",
  CellTags->"Setting up your unit system (FPS)"],
Cell[796657, 18226, 97, 1, 41, "MathCaption",
  CellTags->"Setting up your unit system (FPS)"],
Cell[796757, 18229, 195, 4, 29, "Input",
  CellTags->"Setting up your unit system (FPS)"],
Cell[796955, 18235, 96, 1, 41, "MathCaption",
  CellTags->"Setting up your unit system (FPS)"],

Cell[CellGroupData[{
Cell[797076, 18240, 128, 3, 29, "Input",
  CellTags->"Setting up your unit system (FPS)"],
Cell[797207, 18245, 138, 3, 27, "Output",
  CellTags->"Setting up your unit system (FPS)"]
}, Closed]],
Cell[797360, 18251, 170, 5, 41, "MathCaption",
  CellTags->"Setting up your unit system (FPS)"],
Cell[797533, 18258, 645, 11, 172, "Input",
  CellTags->"Setting up your unit system (FPS)"],
Cell[798181, 18271, 210, 6, 41, "MathCaption",
  CellTags->"Setting up your unit system (FPS)"],

Cell[CellGroupData[{
Cell[798416, 18281, 136, 3, 29, "Input",
  CellTags->"Setting up your unit system (FPS)"],
Cell[798555, 18286, 276, 5, 65, "Output",
  CellTags->"Setting up your unit system (FPS)"]
}, Closed]],
Cell[798846, 18294, 127, 1, 41, "MathCaption",
  CellTags->"Setting up your unit system (FPS)"],
Cell[798976, 18297, 223, 5, 29, "Input",
  CellTags->"Setting up your unit system (FPS)"],
Cell[799202, 18304, 344, 11, 41, "MathCaption",
  CellTags->"Setting up your unit system (FPS)"],

Cell[CellGroupData[{
Cell[799571, 18319, 141, 3, 29, "Input",
  CellTags->"Setting up your unit system (FPS)"],
Cell[799715, 18324, 2095, 37, 217, "Output",
  CellTags->"Setting up your unit system (FPS)"]
}, Closed]],
Cell[801825, 18364, 500, 21, 42, "Text",
  CellTags->"Setting up your unit system (FPS)"],
Cell[802328, 18387, 192, 5, 25, "Text",
  CellTags->"Setting up your unit system (FPS)"],
Cell[802523, 18394, 85, 1, 41, "MathCaption",
  CellTags->"Setting up your unit system (FPS)"],

Cell[CellGroupData[{
Cell[802633, 18399, 238, 5, 50, "Input",
  CellTags->"Setting up your unit system (FPS)"],
Cell[802874, 18406, 319, 9, 43, "Output",
  CellTags->"Setting up your unit system (FPS)"]
}, Closed]],
Cell[803208, 18418, 87, 1, 41, "MathCaption",
  CellTags->"Setting up your unit system (FPS)"],

Cell[CellGroupData[{
Cell[803320, 18423, 116, 3, 29, "Input",
  CellTags->"Setting up your unit system (FPS)"],
Cell[803439, 18428, 262, 8, 27, "Output",
  CellTags->"Setting up your unit system (FPS)"]
}, Closed]],
Cell[803716, 18439, 110, 1, 41, "MathCaption",
  CellTags->"Setting up your unit system (FPS)"],
Cell[803829, 18442, 206, 5, 30, "Input",
  CellTags->"Setting up your unit system (FPS)"],
Cell[804038, 18449, 86, 1, 41, "MathCaption",
  CellTags->"Setting up your unit system (FPS)"],

Cell[CellGroupData[{
Cell[804149, 18454, 119, 3, 29, "Input",
  CellTags->"Setting up your unit system (FPS)"],
Cell[804271, 18459, 318, 9, 27, "Output",
  CellTags->"Setting up your unit system (FPS)"]
}, Closed]],
Cell[804604, 18471, 231, 8, 25, "Text",
  CellTags->"Setting up your unit system (FPS)"],
Cell[804838, 18481, 85, 1, 41, "MathCaption",
  CellTags->"Setting up your unit system (FPS)"],

Cell[CellGroupData[{
Cell[804948, 18486, 171, 4, 41, "Input",
  CellTags->"Setting up your unit system (FPS)"],
Cell[805122, 18492, 325, 9, 41, "Output",
  CellTags->"Setting up your unit system (FPS)"]
}, Closed]],
Cell[805462, 18504, 197, 6, 41, "MathCaption",
  CellTags->"Setting up your unit system (FPS)"],
Cell[805662, 18512, 161, 3, 41, "Input",
  CellTags->"Setting up your unit system (FPS)"],
Cell[805826, 18517, 170, 6, 41, "MathCaption",
  CellTags->"Setting up your unit system (FPS)"],

Cell[CellGroupData[{
Cell[806021, 18527, 171, 4, 41, "Input",
  CellTags->"Setting up your unit system (FPS)"],
Cell[806195, 18533, 322, 9, 40, "Output",
  CellTags->"Setting up your unit system (FPS)"]
}, Closed]],
Cell[806532, 18545, 156, 6, 41, "MathCaption",
  CellTags->"Setting up your unit system (FPS)"],

Cell[CellGroupData[{
Cell[806713, 18555, 118, 3, 29, "Input",
  CellTags->"Setting up your unit system (FPS)"],
Cell[806834, 18560, 2571, 44, 225, "Output",
  CellTags->"Setting up your unit system (FPS)"]
}, Closed]],
Cell[809420, 18607, 91, 1, 41, "MathCaption",
  CellTags->"Setting up your unit system (FPS)"],
Cell[809514, 18610, 180, 4, 29, "Input",
  CellTags->"Setting up your unit system (FPS)"],
Cell[809697, 18616, 114, 1, 41, "MathCaption",
  CellTags->"Setting up your unit system (FPS)"],
Cell[809814, 18619, 127, 3, 29, "Input",
  CellTags->"Setting up your unit system (FPS)"]
}, Closed]],

Cell[CellGroupData[{
Cell[809978, 18627, 91, 1, 35, "Subsubsection",
  CellTags->"Managing units dimensions"],
Cell[810072, 18630, 425, 13, 59, "Text",
  CellTags->"Managing units dimensions"],
Cell[810500, 18645, 422, 11, 43, "DefinitionBox",
  CellTags->"Managing units dimensions"],
Cell[810925, 18658, 126, 2, 41, "MathCaption",
  CellTags->"Managing units dimensions"],

Cell[CellGroupData[{
Cell[811076, 18664, 134, 3, 43, "Input",
  CellTags->"Managing units dimensions"],
Cell[811213, 18669, 317, 9, 45, "Output",
  CellTags->"Managing units dimensions"]
}, Closed]],
Cell[811545, 18681, 88, 1, 41, "MathCaption",
  CellTags->"Managing units dimensions"],
Cell[811636, 18684, 219, 6, 46, "Input",
  CellTags->"Managing units dimensions"],
Cell[811858, 18692, 205, 6, 41, "MathCaption",
  CellTags->"Managing units dimensions"],

Cell[CellGroupData[{
Cell[812088, 18702, 123, 3, 29, "Input",
  CellTags->"Managing units dimensions"],
Cell[812214, 18707, 837, 25, 45, "Output",
  CellTags->"Managing units dimensions"]
}, Closed]],
Cell[813066, 18735, 187, 8, 41, "MathCaption",
  CellTags->"Managing units dimensions"],
Cell[813256, 18745, 197, 5, 46, "Input",
  CellTags->"Managing units dimensions"],
Cell[813456, 18752, 97, 1, 41, "MathCaption",
  CellTags->"Managing units dimensions"],

Cell[CellGroupData[{
Cell[813578, 18757, 156, 3, 43, "Input",
  CellTags->"Managing units dimensions"],
Cell[813737, 18762, 809, 25, 45, "Output",
  CellTags->"Managing units dimensions"]
}, Closed]],
Cell[814561, 18790, 106, 1, 41, "MathCaption",
  CellTags->"Managing units dimensions"],
Cell[814670, 18793, 119, 3, 29, "Input",
  CellTags->"Managing units dimensions"]
}, Closed]],

Cell[CellGroupData[{
Cell[814826, 18801, 59, 1, 35, "Subsubsection",
  CellTags->"Notations"],
Cell[814888, 18804, 56, 1, 25, "Text",
  CellTags->"Notations"],
Cell[814947, 18807, 192, 4, 29, "Input",
  CellTags->"Notations"],
Cell[815142, 18813, 61, 1, 25, "Text",
  CellTags->"Notations"],
Cell[815206, 18816, 620, 11, 109, "Input",
  CellTags->"Notations"],
Cell[815829, 18829, 123, 5, 25, "Text",
  CellTags->"Notations"],
Cell[815955, 18836, 219, 5, 69, "Input",
  CellTags->"Notations"],
Cell[816177, 18843, 114, 6, 25, "Text",
  CellTags->"Notations"],
Cell[816294, 18851, 225, 5, 49, "Input",
  CellTags->"Notations"],
Cell[816522, 18858, 297, 9, 25, "Text",
  CellTags->"Notations"],
Cell[816822, 18869, 408, 12, 30, "Input",
  CellTags->"Notations"],
Cell[817233, 18883, 44, 1, 25, "Text",
  CellTags->"Notations"],

Cell[CellGroupData[{
Cell[817302, 18888, 658, 11, 172, "Input",
  CellTags->"Notations"],
Cell[817963, 18901, 257, 7, 41, "Print",
  CellTags->"Notations"],
Cell[818223, 18910, 248, 7, 63, "Print",
  CellTags->"Notations"],
Cell[818474, 18919, 316, 8, 48, "Print",
  CellTags->"Notations"],
Cell[818793, 18929, 240, 7, 41, "Print",
  CellTags->"Notations"],
Cell[819036, 18938, 287, 8, 26, "Print",
  CellTags->"Notations"],
Cell[819326, 18948, 370, 9, 63, "Print",
  CellTags->"Notations"],
Cell[819699, 18959, 401, 10, 44, "Print",
  CellTags->"Notations"],
Cell[820103, 18971, 394, 9, 81, "Print",
  CellTags->"Notations"],
Cell[820500, 18982, 390, 10, 39, "Print",
  CellTags->"Notations"]
}, Closed]],
Cell[820905, 18995, 205, 6, 25, "Text",
  CellTags->"Notations"],
Cell[821113, 19003, 301, 9, 25, "Text",
  CellTags->"Notations"],
Cell[821417, 19014, 809, 23, 49, "Input",
  CellTags->"Notations"],

Cell[CellGroupData[{
Cell[822251, 19041, 699, 12, 168, "Input",
  CellTags->"Notations"],
Cell[822953, 19055, 284, 7, 40, "Print",
  CellTags->"Notations"],
Cell[823240, 19064, 264, 7, 48, "Print",
  CellTags->"Notations"],
Cell[823507, 19073, 332, 8, 43, "Print",
  CellTags->"Notations"],
Cell[823842, 19083, 250, 7, 46, "Print",
  CellTags->"Notations"],
Cell[824095, 19092, 309, 8, 26, "Print",
  CellTags->"Notations"],
Cell[824407, 19102, 402, 9, 48, "Print",
  CellTags->"Notations"],
Cell[824812, 19113, 419, 10, 39, "Print",
  CellTags->"Notations"],
Cell[825234, 19125, 442, 11, 51, "Print",
  CellTags->"Notations"],
Cell[825679, 19138, 408, 10, 39, "Print",
  CellTags->"Notations"]
}, Closed]],
Cell[826102, 19151, 135, 4, 25, "Text",
  CellTags->"Notations"],
Cell[826240, 19157, 64, 1, 25, "Text",
  CellTags->"Notations"],
Cell[826307, 19160, 189, 4, 29, "Input",
  CellTags->"Notations"],
Cell[826499, 19166, 68, 1, 25, "Text",
  CellTags->"Notations"],
Cell[826570, 19169, 1195, 33, 90, "Input",
  CellTags->"Notations"]
}, Closed]],

Cell[CellGroupData[{
Cell[827802, 19207, 51, 1, 35, "Subsubsection",
  CellTags->"Money"],
Cell[827856, 19210, 373, 12, 42, "Text",
  CellTags->"Money"],

Cell[CellGroupData[{
Cell[828254, 19226, 93, 3, 29, "Input",
  CellTags->"Money"],
Cell[828350, 19231, 299, 9, 45, "Output",
  CellTags->"Money"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[828698, 19246, 59, 1, 35, "Subsubsection",
  CellTags->"To do ..."],
Cell[828760, 19249, 128, 6, 25, "Text",
  CellTags->"To do ..."],
Cell[828891, 19257, 128, 4, 25, "Text",
  CellTags->"To do ..."],
Cell[829022, 19263, 268, 8, 42, "Text",
  CellTags->"To do ..."],
Cell[829293, 19273, 902, 27, 42, "Text",
  CellTags->"To do ..."],
Cell[830198, 19302, 189, 4, 42, "Text",
  CellTags->"To do ..."],
Cell[830390, 19308, 160, 6, 25, "Text",
  CellTags->"To do ..."],
Cell[830553, 19316, 208, 5, 42, "Text",
  CellTags->"To do ..."],
Cell[830764, 19323, 281, 7, 42, "Text",
  CellTags->"To do ..."],
Cell[831048, 19332, 252, 7, 42, "Text",
  CellTags->"To do ..."],
Cell[831303, 19341, 107, 3, 25, "Text",
  CellTags->"To do ..."]
}, Closed]],

Cell[CellGroupData[{
Cell[831447, 19349, 109, 3, 35, "Subsubsection",
  Evaluatable->False,
  CellTags->"References"],
Cell[831559, 19354, 145, 4, 25, "Text",
  CellTags->"References"],
Cell[831707, 19360, 357, 15, 75, "Text",
  CellTags->"References"],
Cell[832067, 19377, 198, 6, 25, "Text",
  CellTags->"References"],
Cell[832268, 19385, 366, 5, 100, "Text",
  CellTags->"References"],
Cell[832637, 19392, 155, 4, 25, "Text",
  CellTags->"References"],
Cell[832795, 19398, 299, 7, 100, "Text",
  CellTags->"References"],
Cell[833097, 19407, 183, 6, 25, "Text",
  CellTags->"References"],
Cell[833283, 19415, 232, 7, 50, "Text",
  CellTags->"References"],
Cell[833518, 19424, 71, 2, 25, "Text"],
Cell[833592, 19428, 382, 8, 59, "Text"],
Cell[833977, 19438, 29, 0, 25, "Text"],
Cell[834009, 19440, 114, 5, 25, "Text"],
Cell[834126, 19447, 91, 1, 17, "Caption",
  CellTags->"References"]
}, Closed]]
}, Closed]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

