(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    136010,       2986]*)
(*NotebookOutlinePosition[    136898,       3018]*)
(*  CellTagsIndexPosition[    136823,       3012]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Unit Formatted Source Code", "Subtitle"],

Cell["\[Copyright]2004, Alvaro D\[IAcute]az Falconi", "Packages"],

Cell[CellGroupData[{

Cell["Package Beginnings", "SubsectionIcon"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Commentaries\)], "SubsubsectionIcon"],

Cell["\<\
(* Context: 
   adMath`Unit` *)\
\>", "Input"],

Cell["\<\
(* Directory Path: 
   Addons/Applications/adMath/ *)\
\>", "Input"],

Cell["\<\
(* Help Directory Path: 
   Addons/Applications/adMathUnit/Documentation/English/ *)\
\>", "Input"],

Cell["\<\
(* Mathematica Version: 
   5.0 *)\
\>", "Input"],

Cell["\<\
(* Author: 
   Alvaro Diaz Falconi *)\
\>", "Input"],

Cell["\<\
(* Copyright: 
   2004 by Alvaro Diaz Falconi *)\
\>", "Input"],

Cell["\<\
(* Warnings: 
    
1. This package is not fully tested, and can contain some bugs.

2. Symbols: 
\t\tAngle,Temperature, Base, Derived, Combined, Equivalence, System, Author 
   protected but remain clearing.

3. Normal : function Normal modified. *)\
\>", "Input"],

Cell["\<\
(* Discusion: 
    
   Plus, Times and Simplify are not modified. This causes some inconvenients \
in the functionality of the package.
   
   I'm think that the best adventage of this package is that no introduce in \
Global a lot of symbols; only few protected symbols go to the Global context. \
*)\
\>", "Input"],

Cell[BoxData[
    \( (*\ Keywords : \[IndentingNewLine]AbAmpere, \ AbCoulomb, \ AbFarad, \ 
      AbHenry, \ AbMho, \ AbOhm, \ AbVolt, \ Acceleration, \ 
      AccelerationDueToGravity, \ Acre, \ Action, \ adMath, \ 
      AlphaParticleMass, \ Ampere, \ Angle, \ Angstrom, \ 
      AngularAcceleration, \ AngularMil, \ AngularSpeed, \ Apostilb, \ 
      ArcHour, \ ArcMinute, \ ArcSecond, \ Area, \ AssayTon, \ 
      AstronomicalUnit, \ Atmosphere, \ AtomicMassConstant, \ 
      AtomicMassUnit, \ Atto, \ Author, \ AvogadroConstant, \ 
      AvogadroNumber, \ AvoirdupoisOunce, \ AvoirdupoisPound, \ 
      BakersDozen, \ Bale, \ Barn, \ Barrel, \ Barye, \ Base, \ Baud, \ 
      Becquerel, \ Biot, \ BoardFoot, \ BohrMagneton, \ BohrRadius, \ Bolt, \ 
      BoltzmannConstant, \ BritishThermalUnit, \ Bucket, \ Bushel, \ Butt, \ 
      Byte, \ Cable, \ Caliber, \ Calorie, \ Candela, \ Candle, \ Carat, \ 
      Celsius, \ Cental, \ Centi, \ Centigrade, \ Centimeter, \ Century, \ 
      Chain, \ ChevalVapeur, \ Cicero, \ Circle, \ CircularMile, \ 
      ClassicalElectronRadius, \ Combined, \ ConductanceQuantum, \ Cord, \ 
      Couloumb, \ Cubit, \ Curie, \ Dalton, \ Deca, \ Decade, \ Deci, \ 
      Denier, \ Derived, \ DeuteronMagneticMoment, \ DeuteronMass, \ Didot, \ 
      DidotPoint, \ Diopter, \ Dozen, \ Drachma, \ Drop, \ 
      DynamicViscosity, \ Dyne, \ ElectricCapacitance, \ ElectricCharge, \ 
      ElectricConductance, \ ElectricConstant, \ ElectricCurrent, \ 
      ElectricDipoleMoment, \ ElectricDisplacement, \ 
      ElectricFieldStrength, \ ElectricPermittivity, \ 
      ElectricPolarizability, \ ElectricPotential, \ ElectricResistance, \ 
      ElectricResistivity, \ ElectronCharge, \ ElectronComptonWavelength, \ 
      ElectronGFactor, \ ElectronMagneticMoment, \ 
      ElectronMagneticMomentAnomaly, \ ElectronMass, \ ElectronVolt, \ 
      ElementaryCharge, \ Energy, \ Ephah, \ Equivalence, \ Fahrenheit, \ 
      Farad, \ FaradayConstant, \ Fathom, \ Feet, \ Femto, \ Fermi, \ 
      Fifth, \ FineStructureConstant, \ Firkin, \ FirstRadiationConstant, \ 
      FluidDram, \ FluidOunce, \ Foot, \ FootCandle, \ Force, \ Fortnight, \ 
      Frequency, \ Furlong, \ Galileo, \ Gallon, \ Gamma, \ Gauss, \ 
      Geepound, \ Giga, \ Gilbert, \ Gill, \ Grain, \ Gram, \ 
      GramsRadiation, \ GramWeight, \ GravitationalConstant, \ Gray, \ 
      Gross, \ GrossHundredweight, \ Hand, \ HartreeEnergy, \ HeatCapacity, \ 
      HeatInsulationCoefficient, \ HeatTransferCoefficient, \ Hectare, \ 
      Hecto, \ Hefner, \ HelionMass, \ Henry, \ Hertz, \ Hogshead, \ 
      Horsepower, \ Hour, \ Hundredweight, \ IdealGasConstant, \ 
      IdealGasVolume, \ Illuminance, \ ImperialGallon, \ ImperialPint, \ 
      Inch, \ InchMercury, \ InverseLength, \ Jerk, \ Jeroboam, \ Jigger, \ 
      JosephsonConstant, \ Joule, \ Kayser, \ Kelvin, \ Kilo, \ Kilogram, \ 
      KilogramForce, \ KilogramWeight, \ KinematicViscosity, \ Knot, \ 
      Kyne, \ Lambert, \ Last, \ League, \ Length, \ Libra, \ LightYear, \ 
      LinearFrequency, \ LinearMassDensity, \ Link, \ Liter, \ 
      LoschmidtConstant, \ Lumen, \ Lumerg, \ LuminousFlux, \ 
      LuminousIntensity, \ LuminousLuminance, \ MagneticConstant, \ 
      MagneticDipoleMoment, \ MagneticFlux, \ MagneticFluxDensity, \ 
      MagneticFluxQuantum, \ MagneticInductance, \ MagneticPermiability, \ 
      MagneticPolarizability, \ MagnetizingForce, \ Magnum, \ Mass, \ 
      MassDensity, \ Maxwell, \ Mega, \ Meter, \ MetricTon, \ Micro, \ 
      Micron, \ Mile, \ MilitarMil, \ Millennium, \ Milli, \ 
      MillimeterMercury, \ Mina, \ Minim, \ Minute, \ MolarElectricCharge, \ 
      MolarGasConstant, \ MolarVolume, \ Mole, \ MomentOfInertia, \ 
      Momentum, \ Money, \ Month, \ MuonComptonWavelength, \ MuonGFactor, \ 
      MuonMagneticMoment, \ MuonMagneticMomentAnomaly, \ MuonMass, \ Nano, \ 
      NauticalMile, \ NetHundredweight, \ NeutronComptonWavelength, \ 
      NeutronGFactor, \ NeutronMagneticMoment, \ NeutronMass, \ Newton, \ 
      NewtonianConstantOfGravitation, \ Nibble, \ Noggin, \ 
      NuclearMagneton, \ Obolos, \ Oersted, \ Omega, \ Omer, \ Ounce, \ 
      Parsec, \ Pascal, \ Peck, \ Pennyweight, \ Percent, \ Perch, \ Peta, \ 
      Phot, \ Pica, \ Pico, \ Pint, \ Planck, \ PlanckConstant, \ 
      PlanckLength, \ PlanckMass, \ PlanckTemperature, \ PlanckTime, \ 
      Point, \ Poise, \ Pole, \ Pondus, \ Pony, \ Pound, \ Poundal, \ 
      Poundforce, \ PoundForce, \ PoundsPerSquareInch, \ PoundWeight, \ 
      Power, \ Prefixes, \ Pressure, \ PrintersPoint, \ 
      ProtonComptonWavelength, \ ProtonGFactor, \ ProtonGyromagneticRatio, \ 
      ProtonMagneticMoment, \ ProtonMass, \ Puncheon, \ Quadrant, \ Quart, \ 
      Quintal, \ Radian, \ Rankine, \ RegisterTon, \ Rems, \ Revolution, \ 
      RevolutionsPerMinute, \ Reyn, \ Rhes, \ RightAngle, \ Roentgen, \ 
      Rontgen, \ Rood, \ Rope, \ Rutherford, \ Rydberg, \ RydbergConstant, \ 
      Seam, \ Second, \ SecondRadiationConstant, \ Section, \ Semicircle, \ 
      Shed, \ Shekel, \ ShortHundredweight, \ ShortTon, \ Shot, \ 
      SiderealSecond, \ SiderealYear, \ Siemens, \ Sievert, \ Skein, \ 
      Slug, \ SolarMass, \ SolidAngle, \ Span, \ SpecificHeatCapacity, \ 
      SpectralRadianceFirstRadiationConstant, \ Speed, \ SpeedOfLight, \ 
      Stadion, \ Stadium, \ StandardAccelerationOfGravity, \ 
      StandardAtmosphere, \ StandardTemperature, \ StatAmpere, \ 
      StatCoulomb, \ StatFarad, \ StatHenry, \ StatOhm, \ StatuteMile, \ 
      StatVolt, \ StefanBoltzmannConstant, \ Steradian, \ Stere, \ Stilb, \ 
      Stokes, \ Stone, \ SurfaceEnergyDensity, \ SurfacePowerDensity, \ 
      SurveyMile, \ System, \ Tablespoon, \ Talbot, \ Talent, \ 
      TauComptonWavelength, \ TauMass, \ Teaspoon, \ Temperature, \ Tera, \ 
      Tesla, \ Therm, \ ThermalConductivity, \ ThomsonCrossSection, \ Time, \ 
      TonForce, \ Tonne, \ Torr, \ Township, \ TropicalYear, \ TroyOunce, \ 
      UKGallon, \ UKPint, \ Unit, \ UnitCGS, \ UnitComplexExpand, \ 
      UnitConvert, \ UnitD, \ UnitDIM, \ UnitFPS, \ UnitFullSimplify, \ 
      UnitI, \ UnitMKS, \ UnitN, \ UnitPowerExpand, \ UnitQ, \ 
      UnitSimplify, \ VacuumCharacteristicImpedance, \ VacuumPermeability, \ 
      VacuumPermittivity, \ VacuumSpeedOfLight, \ Volt, \ Volume, \ 
      VolumeFlow, \ vonKlitzingConstant, \ Watt, \ Weber, \ Week, \ 
      WienDisplacementLawConstant, \ WineBottle, \ Yard, \ Year, \ Yocto, \ 
      Yotta, \ Zepto, \ Zetta\ *) \)], "Input"],

Cell["\<\
(* References:
\t[-1-] A lot of Unit convertion values (and units names too) are taken from
\t\tMiscellaneous`Units`,
\t\tby Stephen Wolfram,
\t\tand with Copyright: Copyright 1987-2003,Wolfram Research, Inc.
                    
\t[-2-] The values of constants and almost symbols abreviations are taken \
from:
   \t\t\t\" Fundamental Physical Constants --- Complete Listing.  \"
\t\t\t\" From:  http://physics.nist.gov/constants \"
            \" Source: Peter J. Mohr and Barry N. Taylor, CODATA Recommended \
Values of the  \"
            \"        Fundamental Physical Constants: 2002, \"
            \"        To be published. \"
                    
\t[-3-]  Some units values are taken from (an a very good reference for SI \
system too):
           \" Taylor, B. N.\"
           \"Guide for the Use of the International System of Units (SI).\"
           \" NIST Special Publication 811, 1995 Edition. \"
           \" http://physics.nist.gov/Document/sp811.pdf. \"

\t[-4-] Units and Mathematica (apart of the online help) from
           \" Eric Weisstein's world of physics. \"
           \" \
www.scienceworld.wolfram.com/physics/topics/UnitsandDimensionalAnalysis.html. \


\t[-5-] An extensive practical use of units can find in 
\t\t  \"Perry's chemical engineers' handbook. - 7th ed.
\t\t   prepared by a staff of specialists under the editorial direction
\t\t   of late editor Robert H. Perry : editor, 
\t\t   Don W. Green : associate editor, 
\t\t   James O'Hara Maloney. 
\t\t   ISBN 0-07-049841-5\"
\t       published by \"The McGraw-Hill Companies, Inc\" *)\
\>", "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Package\ Begin\)], "SubsubsectionIcon"],

Cell[BoxData[
    \(\(BeginPackage[\ "\<adMath`Unit`\>"\ ];\)\)], "Input",
  InitializationCell->True],

Cell[TextData[{
  "Print a warning for old versions of ",
  StyleBox["Mathematica",
    FontSlant->"Italic"]
}], "Text"],

Cell[BoxData[
    \(\(If[$VersionNumber \[LessEqual] 4.9999, \ 
        CellPrint\ @\ 
          Cell[BoxData[
              StyleBox["\<This version of Unit package is designed for run in \
Mathematica 5.0. To obtain an earlier version contact me at \
alvarodiazfalconi@yahoo.com\>", \ "\<Message\>", 
                FontWeight \[Rule] "\<Bold\>"]], \ "\<Output\>"]];\)\)], \
"Input",
  InitializationCell->True],

Cell["Clean", "Text"],

Cell[BoxData[{
    \(Unprotect["\<adMath`Unit`*\>"]; \), "\n", 
    \(\(ClearAll @@ 
        Complement[
          Names["\<adMath`Unit`*\>"], {"\<AutoLoadUnitPalette\>"}];\)\), "\n\
", 
    \(\(ClearAll["\<adMath`Unit`Private`*\>"];\)\)}], "Input",
  InitializationCell->True],

Cell["Declare here some exported public functions", "Text"],

Cell[BoxData[
    \(\({Unit, $Unit, UnitQ, \[IndentingNewLine]UnitD, UnitN, UnitK, UnitS, 
        UnitI, \[IndentingNewLine]UnitConvert, 
        UnitSimplify, \[IndentingNewLine]UnitFullSimplify, UnitPowerExpand, 
        UnitComplexExpand, \[IndentingNewLine]UnitDIM, UnitMKS, UnitCGS, 
        UnitFPS, \[IndentingNewLine]Temperature, 
        Angle, \[IndentingNewLine]Base, Derived, 
        Combined, \[IndentingNewLine]Equivalence, 
        System, \[IndentingNewLine]Author};\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Usage\ Mesages\)], "SubsubsectionIcon"],

Cell[TextData[{
  Cell[BoxData[
      \(Unit\)]],
  " usage"
}], "Text"],

Cell[BoxData[
    \(\(Unit::"\<usage\>" = "\<
X = Unit[x] represent the unit named x.\n
Setting Utilities: (SYS = UnitMKS|UnitCGS|UnitFPS):\n
> Unit[Set, All]        Restore original definitions.\n
> Unit[Set, SYS]        Set SYS as default (or $Unit = SYS)\n
> Unit[Set, a \[Rule] b]      Set b as default otput for a.\n
Dimension Utilities:    See UnitD, UnitN.\n
Information Utilities:  See UnitI.\n
See Also: UnitConvert, UnitSimplify.\>";\)\)], "Input",
  InitializationCell->True],

Cell[TextData[{
  Cell[BoxData[
      \(UnitI\)]],
  " usage"
}], "Text"],

Cell[BoxData[
    \(\(UnitI::"\<usage\>" = "\<
Unit package Information Utilities:\n
> UnitI[ X ]       Information about the unit X.\n
> UnitI[ SYS ]     Information about the unit system named SYS.\n
> UnitI[ Names ]   List of avaibles units.\n
> UnitI[ Prefix ]  List of avaibles prefixes.\n
> UnitI[ D ]       List of Base dimensions.\n
> UnitI[ N ]       List of avaibles dimensions names.\n
> UnitI[ Author ]  Information about the Author.\n\n
See Also: Unit, UnitCGS, UnitFPS, UnitMKS, UnitConvert, \
UnitSimplify.\>";\)\)], "Input",
  InitializationCell->True],

Cell[TextData[{
  Cell[BoxData[
      \(UnitQ\)]],
  " usage"
}], "Text"],

Cell[BoxData[
    \(\(UnitQ::usage = "\<UnitQ[x] is simplelly !FreeQ[x,Unit]. See Also: \
Unit.\>";\)\)], "Input",
  InitializationCell->True],

Cell[TextData[{
  Cell[BoxData[
      \($Unit\)]],
  " usage"
}], "Text"],

Cell[BoxData[
    \(\($Unit::"\<usage\>" = "\<$Unit = SYS  (SYS = UnitMKS|UnitCGS|UnitFPS) \
changes the output to the specified unit system. See Also: Unit.\>"\ ;\)\)], \
"Input",
  InitializationCell->True],

Cell[TextData[{
  Cell[BoxData[
      \(UnitD\)]],
  " usage"
}], "Text"],

Cell[BoxData[
    \(UnitD::"\<usage\>" = "\<UnitD[X] give the dimensions of X. See UnitI[D] \
for a list of defined dimensions. See Also: Unit.\>"\)], "Input",
  InitializationCell->True],

Cell[TextData[{
  Cell[BoxData[
      \(UnitN\)]],
  " usage"
}], "Text"],

Cell[BoxData[
    \(UnitN::"\<usage\>" = "\<UnitN[x] give the dimensions names of x. See \
UnitI[N] for a list of defined dimensions names. See Also: Unit.\>"\)], \
"Input",
  InitializationCell->True],

Cell[TextData[{
  Cell[BoxData[
      \(UnitK\)]],
  " usage"
}], "Text"],

Cell[BoxData[
    \(\(UnitK::"\<usage\>" = "\<
UnitK[expr] substitute in expr symbols of defined constants with constants \
values. See Also: Unit.\>";\)\)], "Input",
  InitializationCell->True],

Cell[TextData[{
  Cell[BoxData[
      \(UnitS\)]],
  " usage"
}], "Text"],

Cell[BoxData[
    \(\(UnitS::"\<usage\>" = "\<
UnitS[expr] substitute in expr symbols of defined units with unit definition. \
By default, UnitS only substitute units names larger than 4 letters. \
UnitS[expr, length] do the substitution with the specified length. See Also: \
Unit.\>";\)\)], "Input",
  InitializationCell->True],

Cell[TextData[{
  Cell[BoxData[
      \(UnitConvert\)]],
  " usage"
}], "Text"],

Cell[BoxData[
    \(UnitConvert::usage = "\<UnitConvert[ newsys ] [ oldunits ] convert \
oldunits to the unit system newsys.\nUnitConvert[ newunit ] [ oldunit ] \
convert oldunits to newunit. See Also: Unit.\>"\)], "Input",
  InitializationCell->True],

Cell[TextData[{
  Cell[BoxData[
      \(UnitSimplify\)]],
  " usage"
}], "Text"],

Cell[BoxData[
    \(\(UnitSimplify::"\<usage\>" = \[IndentingNewLine]"\<UnitSimplify[expr] \
simplify expr involving units. UnitSimplify[expr,assum] works like Simplify. \
See Also: Unit.\>";\)\)], "Input",
  InitializationCell->True],

Cell[TextData[{
  Cell[BoxData[
      \(UnitFullSimplify\)]],
  " usage"
}], "Text"],

Cell[BoxData[
    \(\(UnitFullSimplify::"\<usage\>" = \
\[IndentingNewLine]"\<UnitFullSimplify[expr] simplify expr involving units. \
UnitFullSimplify[expr,assum] works like UnitFullSimplify. See Also: Unit.\>";\
\)\)], "Input",
  InitializationCell->True],

Cell[TextData[{
  Cell[BoxData[
      \(UnitPowerExpand\)]],
  " usage"
}], "Text"],

Cell[BoxData[
    \(\(UnitPowerExpand::"\<usage\>" = \
\[IndentingNewLine]"\<UnitPowerExpand[expr] expands all powers of products \
and powers. See Also: Unit.\>";\)\)], "Input",
  InitializationCell->True],

Cell[TextData[{
  Cell[BoxData[
      \(UnitComplexExpand\)]],
  " usage"
}], "Text"],

Cell[BoxData[
    \(\(UnitComplexExpand::"\<usage\>" = \
\[IndentingNewLine]"\<UnitComplexExpand[expr] expands expr assuming that all \
variables are real. UnitComplexExpand[expr, {x1, x2, ... }] expands expr \
assuming that variables matching any of the xi are complex. See Also: \
Unit.\>";\)\)], "Input",
  InitializationCell->True],

Cell[TextData[{
  Cell[BoxData[
      \(UnitDIM\)]],
  " usage"
}], "Text"],

Cell[BoxData[
    \(UnitDIM::usage = \[IndentingNewLine]"\<UnitDIM is the symbol to refer \
for unit package dimensions names.\n    See Also: Unit.\>"\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Error\ Mesages\)], "SubsubsectionIcon"],

Cell[BoxData[
    \(\(Unit::"\<gshadw\>" = \[IndentingNewLine]"\<The symbol '`1`' has been \
cleaned from the global context by the Unit package.\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[{
    \(\(UnitConvert::"\<badUnit\>" = "\<Can't convert `1` to `2`.\>";\)\), "\
\[IndentingNewLine]", 
    \(\(UnitConvert::"\<badPlus\>" = "\<Can't add `1`.\>";\)\)}], "Input",
  InitializationCell->True,
  CellTags->"Message"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Package\ Post\ Begin\)], "SubsubsectionIcon"],

Cell[BoxData[
    \(Begin["\<`Private`\>"]; \)], "Input",
  InitializationCell->True],

Cell[TextData[{
  StyleBox["Remove them from the global context ", "Text"],
  Cell[BoxData[
      \(unitPublicFunctions\)]]
}], "Text"],

Cell[BoxData[
    \(\(unitPublicFunctions = \(("\<Global`\>" <> # &)\) /@ {\
\[IndentingNewLine]"\<Unit\>", "\<UnitQ\>", "\<UnitI\>", "\<UnitK\>", \
"\<UnitS\>", \[IndentingNewLine]"\<UnitConvert\>", "\<UnitSimplify\>", \
\[IndentingNewLine]"\<UnitFullSimplify\>", "\<UnitPowerExpand\>", \
"\<UnitComplexExpand\>", \[IndentingNewLine]"\<UnitDIM\>", "\<UnitMKS\>", \
"\<UnitCGS\>", "\<UnitFPS\>"};\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(With[{toclean = \((Names["\<Global`*\>"])\) \[Intersection] 
            unitPublicFunctions}, \[IndentingNewLine]If[
        toclean =!= {}, \[IndentingNewLine]\((Message[
                Unit::"\<gshadw\>", #1] &)\) \
/@ \[IndentingNewLine]\(\((StringDrop[#1, 7] &)\) /@ 
            toclean\); \[IndentingNewLine]Unprotect /@ 
          toclean; \[IndentingNewLine]ClearAll /@ 
          toclean; \[IndentingNewLine]Remove /@ toclean;]]\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(End[ (*`Private`*) ];\)\)], "Input",
  InitializationCell->True]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Begin `Private`", "SubsectionIcon"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Begin["`Private`"]\)], "SubsubsectionIcon"],

Cell[BoxData[
    \(\(Begin["\<`Private`\>"];\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(\( (*\ 
      This\ symbols\ can\ be\ preserve\ for\ better\ use\ *) \)\(\
\[IndentingNewLine]\)\(\(Unit[Base, x___] := 
        Unit["\<Base\>", x];\)\[IndentingNewLine]
    \(Unit[Derived, x___] := Unit["\<Derived\>", x];\)\[IndentingNewLine]
    \(Unit[Combined, x___] := Unit["\<Combined\>", x];\)\[IndentingNewLine]
    \(Unit[Equivalence, x___] := 
        Unit["\<Equivalence\>", x];\)\[IndentingNewLine]
    \(Unit[System, x___] := Unit["\<System\>", x];\)\[IndentingNewLine]
    \(Unit[Temperature, x___] := 
        Unit["\<Temperature\>", x];\)\[IndentingNewLine]
    \(Unit[Angle, x___] := Unit["\<Angle\>", x];\)\[IndentingNewLine]
    \(UnitI[Author] := UnitI["\<Author\>"];\)\)\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(myTable\)], "SubsubsectionIcon"],

Cell[BoxData[
    \(\(myTable[X_] := \[IndentingNewLine]StandardForm@
          TableForm[DeleteCases[X, Null], 
            TableAlignments \[Rule] Left];\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      \(ts\)]],
  " & ",
  Cell[BoxData[
      \(tsN\)]]
}], "SubsubsectionIcon"],

Cell[BoxData[{
    \(Attributes[ts] = {HoldFirst}\), "\[IndentingNewLine]", 
    \(\(ts[x_] := 
        ToString[Unevaluated@x, InputForm];\)\), "\[IndentingNewLine]", 
    \(\(ts[x_, y_] := 
        Sequence[\[IndentingNewLine]ToString[Unevaluated@x, 
            InputForm], \[IndentingNewLine]ToString[Unevaluated@y, 
            InputForm]];\)\)}], "Input",
  InitializationCell->True],

Cell[BoxData[{
    \(Attributes[tsN] = {HoldFirst}\), "\[IndentingNewLine]", 
    \(\(tsN[p_Symbol\_q__] := ToString[p\_q, StandardForm];\)\)}], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(UnitE\)], "SubsubsectionIcon"],

Cell[BoxData[{
    \(\(Attributes[UnitE] = {HoldFirst};\)\), "\[IndentingNewLine]", 
    \(\(UnitE[x_] := Unit[Evaluate@x];\)\)}], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ListToRules\)], "SubsubsectionIcon"],

Cell[BoxData[
    \(\(\( (*\ \(--\(-\ 
          ListToRules\)\)\ *) \)\(\[IndentingNewLine]\)\(ListToRules[
          x_] :=  (*\(Dispatch\)\(@\)*) \[IndentingNewLine]List @@ \
\((\(Unevaluated @@ x //. \[IndentingNewLine]{a_, b_, c__} \[RuleDelayed] 
                  Sequence[{a, b}, {b, c}]\) /. {a_, 
                  b_} \[RuleDelayed] \(a \[Rule] b\))\);\)\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ReverseRule\)], "SubsubsectionIcon"],

Cell[BoxData[
    \(\(\( (*\ \(--\(-\ ReverseRule\)\)\ *) \)\(\[IndentingNewLine]\)\(\(rr[
          t_] := Reverse[
          t /. \[InvisibleSpace]\((a_ \[Rule] 
                  b_)\) \[RuleDelayed] \(b \[Rule] a\)];\)\[IndentingNewLine]
    \(rrf[t_] := 
        Reverse[t /. \[InvisibleSpace]\((a_ \[Rule] 
                  b_)\) \[RuleDelayed] \(rrF[b] \[Rule] 
                a\)];\)\)\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(dpe\)], "SubsubsectionIcon"],

Cell[TextData[{
  Cell[BoxData[
      \(dpe\)]],
  " : Divide Power Expand"
}], "Text"],

Cell[BoxData[
    \(\(\( (*\ \(--\(-\ 
          dpe\)\)\ *) \)\(\[IndentingNewLine]\)\(\[IndentingNewLine]\)\(dpe[
          x_, n_] := 
        Block[{$Messages}, Rationalize[PowerExpand[x/n], 0]];\)\)\)], "Input",\

  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(Unit\ \(Dimensions : UnitD\) &\)\ UnitN\)], "SubsubsectionIcon"],

Cell["Attributes", "Text"],

Cell[BoxData[
    \(\(\( (*\ \(Unit\ D &\) 
        N\ are\ Listable\ and\ Constants\ \
*) \)\(\[IndentingNewLine]\)\(Attributes[
          UnitD] = \(Attributes[UnitN] = {Listable, 
            Constant}\);\)\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(UnitD\ code\)], "Text"],

Cell[BoxData[
    \(\(\( (*\ \(--\(-\ 
            Find\)\)\ Unit\ Dimensions\ *) \)\(\[IndentingNewLine]\)\(\(UnitD[
          x_ /; \(! UnitQ[x]\)] := 1;\)\[IndentingNewLine]
    \(UnitD[
          x_ /; UnitQ[
              x]] := \[IndentingNewLine]Module[{\[ScriptA], \[ScriptX]}, 
          x /. \[IndentingNewLine]\[ScriptA]_. \ Unit[\[ScriptX]_] \
\[RuleDelayed] \[IndentingNewLine]Module[{X = \[ScriptX], u, 
                    T = "\<Temperature\>", 
                    all = Unit["\<System\>", All]}, \[IndentingNewLine]X = 
                    X //. {"\<\[Degree]\[DoubleStruckCapitalC]\>" \[Rule] 
                          T, "\<\[Degree]\[DoubleStruckCapitalF]\>" \[Rule] 
                          T, "\<\[Degree]\[DoubleStruckCapitalK]\>" \[Rule] 
                          T, "\<\[Degree]\[DoubleStruckCapitalR]\>" \[Rule] 
                          T}; \[IndentingNewLine]X = 
                    X //. Times[a__, s_String] \[RuleDelayed] 
                        s /; \(! UnitQ[a, 
                              String]\); \[IndentingNewLine]X = \(X \
//. \[InvisibleSpace]table\) //. \[InvisibleSpace]Unit[Names, 
                        All]; \[IndentingNewLine]Do[
                    X = X //. \[InvisibleSpace]Unit["\<Derived\>", 
                          all\[LeftDoubleBracket]k\[RightDoubleBracket]], {k, 
                      Length@all}]; \[IndentingNewLine]X = 
                    X //. Unit["\<Equivalence\>", 
                        All]; \[IndentingNewLine]X = 
                    X //. rr@
                        Unit["\<Base\>", UnitDIM]; \[IndentingNewLine]n = 
                    X //. s_String \[RuleDelayed] 1; \[IndentingNewLine]X = 
                    dpe[X, n]; \[IndentingNewLine]UnitE[
                    X]] /; \(! UnitQ[\[ScriptA]]\)];\)\)\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(UnitN\ code\)], "Text"],

Cell[BoxData[
    \(\(\( (*\ \(--\(-\ 
            Find\)\)\ Unit\ Dimension\ \(\(Name\)\(.\)\)\ *) \)\(\
\[IndentingNewLine]\)\(UnitN[x_] := 
        Module[{u, 
            t}, \[IndentingNewLine]\(\(\(UnitD[x] /. 
                  Unit[t_] \[RuleDelayed] 
                    u[rrF[t]]\) //. \[IndentingNewLine]rrf@
                  Unit["\<Derived\>", UnitDIM]\) //. \[IndentingNewLine]rrF[
                  t_] \[RuleDelayed] t\) /. 
            u \[RuleDelayed] Unit];\)\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(uN &\)\ uS\)], "SubsubsectionIcon"],

Cell[TextData[{
  Cell[BoxData[
      \(uN\)]],
  " : Unit Normal"
}], "Text"],

Cell[BoxData[
    \(\(uN[x_] := x //. Unit[_] \[RuleDelayed] 1;\)\)], "Input",
  InitializationCell->True],

Cell[TextData[{
  Cell[BoxData[
      \(uS\)]],
  " : Unit String"
}], "Text"],

Cell[BoxData[
    \(\(uS[x_] := x //. Unit[u_] \[RuleDelayed] u;\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(uc\)], "SubsubsectionIcon"],

Cell["uc returns a list with coeff and units strings", "Text"],

Cell[BoxData[
    \(\(\( (*\ \(--\(-\ 
            Internal\)\)\ UnitConverter\ *) \)\(\[IndentingNewLine]\)\(\
\[IndentingNewLine]\)\(\(uc[x_] := uc[x, $unit];\)\[IndentingNewLine]
    \(uc[x_, 
          UnitMKS] := \[IndentingNewLine]Module[{X = x, n, s, t, 
            all = Unit["\<System\>", 
                All]}, \[IndentingNewLine]X = \(X \
//. \[InvisibleSpace]table\) //. \[InvisibleSpace]Unit[Names, 
                All]; \[IndentingNewLine]Do[
            X = X //. \[InvisibleSpace]Unit["\<Derived\>", 
                  a\[LeftDoubleBracket]k\[RightDoubleBracket]], {k, 
              Length@a}]; \[IndentingNewLine]X = 
            X //. \[InvisibleSpace]Unit["\<Equivalence\>", 
                All]; \[IndentingNewLine]n = 
            X //. \[InvisibleSpace]s_String \[RuleDelayed] 
                1; \[IndentingNewLine]X = dpe[X, n]; \[IndentingNewLine]X = 
            X //. \[InvisibleSpace]rr[
                Unit["\<Base\>", UnitMKS]]; \[IndentingNewLine]X = \(rrF[
                  X] //. \[InvisibleSpace]rrf[
                  Unit["\<Derived\>", UnitDIM]]\) //. 
              rrF[t_] \[RuleDelayed] t; \[IndentingNewLine]X = 
            X //. \[InvisibleSpace]Unit[Dimensions, 
                UnitMKS]; \[IndentingNewLine]X = \(X \
//. \[InvisibleSpace]Unit["\<Derived\>", 
                  UnitDIM]\) //. \[InvisibleSpace]Unit["\<Base\>", 
                UnitDIM]; \[IndentingNewLine]X = 
            X //. \[InvisibleSpace]Unit[Rule, All]; \[IndentingNewLine]{n, 
            X}];\)\[IndentingNewLine]
    \(uc[x_, 
          sys_Symbol] := \[IndentingNewLine]Module[{X = x, y, n, s, t, 
            all = Unit["\<System\>", 
                All]}, \[IndentingNewLine]X = \(\(X //. 
                  Unit["\<Derived\>", UnitDIM]\) //. Unit["\<Base\>", sys]\) //. 
              Unit["\<Base\>", 
                UnitMKS]; \[IndentingNewLine]X = \(X \
//. \[InvisibleSpace]table\) //. \[InvisibleSpace]Unit[Names, 
                All]; \[IndentingNewLine]Do[
            X = X //. \[InvisibleSpace]Unit["\<Derived\>", 
                  a\[LeftDoubleBracket]k\[RightDoubleBracket]], {k, 
              Length@a}]; \[IndentingNewLine]X = 
            X //. \[InvisibleSpace]Unit["\<Equivalence\>", 
                All]; \[IndentingNewLine]n = 
            X //. \[InvisibleSpace]s_String \[RuleDelayed] 
                1; \[IndentingNewLine]y = \(X = 
              dpe[X, n]\); \[IndentingNewLine]X = 
            X //. \[InvisibleSpace]rr[
                Unit["\<Base\>", UnitMKS]]; \[IndentingNewLine]X = \(rrF[
                  X] //. \[InvisibleSpace]rrf[
                  Unit["\<Derived\>", UnitDIM]]\) //. 
              rrF[t_] \[RuleDelayed] t; \[IndentingNewLine]X = 
            X //. \[InvisibleSpace]Unit[Dimensions, 
                sys]; \[IndentingNewLine]X = \(\(X \
//. \[InvisibleSpace]Unit["\<Derived\>", 
                    UnitDIM]\) //. \[InvisibleSpace]Unit["\<Base\>", 
                  sys]\) //. \[InvisibleSpace]Unit["\<Base\>", 
                UnitDIM]; \[IndentingNewLine]X = 
            X //. \[InvisibleSpace]Unit[Rule, 
                All]; \[IndentingNewLine]X = \(X //. \[InvisibleSpace]Unit[
                  Dimensions, sys]\) //. 
              Unit[Dimensions, 
                UnitMKS]; \[IndentingNewLine]y = \(y/
                  X //. \[InvisibleSpace]table\) //. \[InvisibleSpace]Unit[
                Names, All]; \[IndentingNewLine]Do[
            y = y //. \[InvisibleSpace]Unit["\<Derived\>", 
                  a\[LeftDoubleBracket]k\[RightDoubleBracket]], {k, 
              Length@a}]; \[IndentingNewLine]y = 
            y //. \[InvisibleSpace]Unit["\<Equivalence\>", 
                All]; \[IndentingNewLine]{y\ n, X}];\)\)\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      \(us\)]],
  " "
}], "SubsubsectionIcon"],

Cell["us call uc to simplify units and return units", "Text"],

Cell[BoxData[
    \(\(\( (*\ \(--\(-\ 
          UnitSimplify\)\)\ *) \)\(\[IndentingNewLine]\)\(\[IndentingNewLine]\
\)\(\(us[x_] := us[x, $unit];\)\[IndentingNewLine]
    \(us[x_ /; \(! UnitQ[x]\), ___] := x;\)\[IndentingNewLine]
    \(us[x_ /; UnitQ[x], sys_Symbol] := 
        x /. \[IndentingNewLine]Unit[u_] \[RuleDelayed] 
            UnitE[Times @@ uc[u, sys]];\)\)\)\)], "Input",
  CellLabel->"In[326]:=",
  InitializationCell->True],

Cell[BoxData[
    \(\(Print[u \[Rule] uc[u, sys]];\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(uPlus\  &\)\ uTimes\)], "SubsubsectionIcon"],

Cell[TextData[{
  Cell[BoxData[
      \(uPlus\)]],
  " simplify sums and some powers"
}], "Text"],

Cell[BoxData[
    \(\(\( (*\ \(--\(-\ 
          uPlus\)\)\ \
*) \)\(\[IndentingNewLine]\)\(\[IndentingNewLine]\)\(uPlus[
          X_] := \(X //. \[IndentingNewLine]HoldPattern[
                a_.  Unit[x_] + b_. \ Unit[x_]] \[RuleDelayed] \((a + b)\) 
                Unit[x]\) //. \[IndentingNewLine]\((a_. \ Unit[x_])\)\^n_ \
\[RuleDelayed] \(a\^n\) Unit[x]\^n;\)\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(numerical\)], "SubsubsectionIcon"],

Cell[TextData[{
  Cell[BoxData[
      \(numerical\)]],
  " apply ",
  Cell[BoxData[
      \(N\)]]
}], "Text"],

Cell[BoxData[
    \(\(\( (*\ \(--\(-\ 
          nUnit\)\)\ \
*) \)\(\[IndentingNewLine]\)\(\[IndentingNewLine]\)\(numerical[
          x_] := \[IndentingNewLine]With[{n = 
              N /. Options[Unit]}, \[IndentingNewLine]If[n === True, N[x], 
            N[x, n]]];\)\)\)], "Input",
  InitializationCell->True]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["    Normal", "SubsectionIcon"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Normal\)], "SubsubsectionIcon"],

Cell[BoxData[
    \(\(\( (*\ \(===\)\(===\)\(===\)\(\ \)\(NORMAL\ UNIT\)\(\ \
\)\(===\)\(===\)\(===\)\ \
*) \)\(\[IndentingNewLine]\)\(\[IndentingNewLine]\)\(\(Unprotect[
        Normal];\)\[IndentingNewLine]
    \(Normal[x_?UnitQ] := Normal[uN@x];\)\[IndentingNewLine]
    \(Protect[Normal];\)\)\)\)], "Input",
  InitializationCell->True]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["    Question", "SubsectionIcon"],

Cell[CellGroupData[{

Cell[BoxData[
    \(UnitQ\)], "SubsubsectionIcon"],

Cell[BoxData[
    \(\(\( (*\ \(===\)\(===\)\(===\)\(\ \)\(UnitQ\)\(\ \
\)\(===\)\(===\)\(===\)\ \
*) \)\(\[IndentingNewLine]\)\(\[IndentingNewLine]\)\( (*\ 
      Discussion : \[IndentingNewLine]UnitQ\ is\ not\ very\ sophisticated . \ 
            We\ need\ the\ question\ \[IndentingNewLine]in\ this\ form\ to\ \
recognize\ the\ word\ Unit, \ 
      not\ if\ x\ have\ units . \ 
          The\ other\ forms\ are\ only\ for\ test\ \(\(purposes\)\(.\)\)\ \
*) \)\(\[IndentingNewLine]\)\(\[IndentingNewLine]\)\( (*\ \(--\(-\ 
          Basic\)\)\ *) \)\(\[IndentingNewLine]\)\(\(UnitQ[
          x_] := \(! FreeQ[x, 
            Unit]\);\)\[IndentingNewLine]\[IndentingNewLine] (*\ \(--\(-\ \
\(Utitlity : \ f\)\)\)\  = \ And, \ Or\ *) \[IndentingNewLine]
    \(UnitQ[x_, f_[cmd__]] := 
        f @@ \(UnitQ[
              x, #] /@ {cmd}\);\)\[IndentingNewLine]\[IndentingNewLine] (*\ \
\(--\(-\ Names\)\)\  = \ any\ Unit\ *) \[IndentingNewLine]
    \(UnitQ[x_, Names] := 
        MemberQ[UnitI[Names], x];\)\[IndentingNewLine]\n (*\ \(--\(-\ 
          Real\)\)\ *) \[IndentingNewLine]
    \(UnitQ[x_, 
          Real] := \[Not] FreeQ[
            x, _Real];\)\[IndentingNewLine]\[IndentingNewLine] (*\ \(--\(-\ 
          Rational\)\)\ *) \[IndentingNewLine]
    \(UnitQ[x_, Rational] := \[IndentingNewLine]If[
          FreeQ[x, _Integer], \[IndentingNewLine]If[
            FreeQ[x, _Rational], \[IndentingNewLine]False, \
\[IndentingNewLine]True], \[IndentingNewLine]True];\)\[IndentingNewLine]\
\[IndentingNewLine] (*\ \(--\(-\ String\)\)\ *) \[IndentingNewLine]
    \(UnitQ[x_, 
          String] := \[Not] FreeQ[
            x, _String];\)\[IndentingNewLine]\[IndentingNewLine] (*\ \(--\(-\ 
          System\)\)\ *) \[IndentingNewLine]
    \(UnitQ[x_Symbol, "\<System\>"] := 
        MemberQ[Unit["\<System\>", All], 
          x];\)\[IndentingNewLine]\[IndentingNewLine] (*\ \(--\(-\ 
          Variables\)\)\ *) \[IndentingNewLine]
    \(UnitQ[x_, 
          Variables] := \[IndentingNewLine]\(! Cases[
              Flatten@{x}, _Symbol?\((\((\[InvisibleSpace]\(! \
NumericQ[#]\))\)\  && \ 
                      AtomQ[#] &)\), \[Infinity]] === {}\);\)\
\[IndentingNewLine]\[IndentingNewLine] (*\ \(--\(-\ \(Format : \ 
            Times\ and\ Powers\ of\ Strings\)\)\)\ *) \[IndentingNewLine]
    \(UnitQ[s_, Format] := 
        Module[{q, x, y, m}, \[IndentingNewLine]q[x_String] := 
            True; \[IndentingNewLine]q[x_String\^m_] := 
            UnitQ[m, Rational]; \[IndentingNewLine]q[x_\ y_] := 
            q[x] \[And] q[y]; \[IndentingNewLine]TrueQ@
            q[s]];\)\)\)\)], "Input",
  InitializationCell->True]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["    Information", "SubsectionIcon"],

Cell[CellGroupData[{

Cell[BoxData[
    \(UnitI\)], "SubsubsectionIcon"],

Cell[BoxData[
    \(Attributes[UnitI] = {HoldFirst}\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(\( (*\ \(--\(-\ 
            Little\)\)\ Information\ Utilities\ \
*) \)\(\[IndentingNewLine]\)\(\(UnitI["\<Author\>"] := {"\<(c) 2004\>", \
"\<Alvaro Diaz Falconi\>", "\<alvarodiazfalconi@yahoo.com\>"};\)\
\[IndentingNewLine]
    \(UnitI[Names] := \[IndentingNewLine]Union@
          Cases[{Unit[Rule, All], Unit[Names, All], 
              Unit[Table, 
                All]}, \[IndentingNewLine]_String, {0, \[Infinity]}];\)\
\[IndentingNewLine]
    \(UnitI[N] := \[IndentingNewLine]Union@
          Cases[Unit["\<Derived\>", 
                UnitDIM] /. \((a_ \[Rule] b_)\) \[RuleDelayed] 
                a, \[IndentingNewLine]_String, {0, \[Infinity]}];\)\
\[IndentingNewLine]
    \(UnitI[D] := \[IndentingNewLine]Union@
          Cases[Unit["\<Derived\>", 
                UnitDIM] /. \((a_ \[Rule] b_)\) \[RuleDelayed] 
                b, \[IndentingNewLine]_String, {0, \[Infinity]}];\)\)\)\)], \
"Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(\( (*\ \(===\)\(===\)\(\ \)\(INFORMATION\ Prefixes\)\ *) \)\(\
\[IndentingNewLine]\)\(\[IndentingNewLine]\)\(UnitI[Prefix] = 
        myTable@\(N@\n{"\<Prefixes\>", "\<=====================\>", \
\[IndentingNewLine]{{"\<Percent\>" \[Rule] 1/100}, {"\<Gross\>" \[Rule] 
                    144}, {"\<Dozen\>" \[Rule] 
                    12}, {"\<BakersDozen\>" \[Rule] 
                    13}}, \[IndentingNewLine]{{"\<Mole\>" \[Rule] \("\<mol\>" \
\[Rule] 6.0221367\ 10\^23\)}, {"\<Yotta\>" \[Rule] \("\<\[ScriptCapitalY]\>" \
\[Rule] 10\^24\)}, {"\<Zetta\>" \[Rule] \("\<\[ScriptCapitalZ]\>" \[Rule] 
                      10\^21\)}, {"\<Exa\>" \[Rule] \("\<\[ScriptCapitalE]\>" \
\[Rule] 10\^18\)}}, \[IndentingNewLine]{{"\<Peta\>" \[Rule] \("\<\
\[ScriptCapitalP]\>" \[Rule] 
                      10\^15\)}, {"\<Tera\>" \[Rule] \
\("\<\[ScriptCapitalT]\>" \[Rule] 
                      10\^12\)}, {"\<Giga\>" \[Rule] \
\("\<\[ScriptCapitalG]\>" \[Rule] 
                      10\^9\)}, {"\<Mega\>" \[Rule] \("\<\[ScriptCapitalM]\>" \
\[Rule] 10\^6\)}}, \[IndentingNewLine]{{"\<Kilo\>" \[Rule] \("\<\[ScriptK]\>" \
\[Rule] 10\^3\)}, {"\<Hecto\>" \[Rule] \("\<\[ScriptH]\>" \[Rule] 
                      100\)}, {"\<Deca\>" \[Rule] \
\("\<\[ScriptD]\[ScriptA]\>" \[Rule] 
                      10\)}, {"\<Deci\>" \[Rule] \("\<\[ScriptD]\>" \[Rule] 
                      10\^\(-1\)\)}}, \[IndentingNewLine]{{"\<Centi\>" \
\[Rule] \("\<\[ScriptC]\>" \[Rule] 
                      10\^\(-2\)\)}, {"\<Milli\>" \[Rule] \("\<\[ScriptM]\>" \
\[Rule] 10\^\(-3\)\)}, {"\<Micro\>" \[Rule] \("\<\[Mu]\>" \[Rule] 
                      10\^\(-6\)\)}, {"\<Nano\>" \[Rule] \("\<\[ScriptN]\>" \
\[Rule] 10\^\(-9\)\)}}, \[IndentingNewLine]{{"\<Pico\>" \[Rule] \("\<\
\[ScriptP]\>" \[Rule] 
                      10\^\(-12\)\)}, {"\<Femto\>" \[Rule] \("\<\[ScriptF]\>" \
\[Rule] 10\^\(-15\)\)}, {"\<Atto\>" \[Rule] \("\<\[ScriptA]\>" \[Rule] 
                      10\^\(-18\)\)}, {"\<Zepto\>" \[Rule] \("\<\[ScriptZ]\>" \
\[Rule] 10\^\(-21\)\)}}, \[IndentingNewLine]{"\<Yocto\>" \[Rule] \("\<\
\[ScriptY]\>" \[Rule] 10\^\(-24\)\)}}\);\)\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(\( (*\ \(===\)\(===\)\(\ \)\(INFORMATION\ UNIT\)\ *) \)\(\
\[IndentingNewLine]\)\(\[IndentingNewLine]\)\(\(UnitI[
          a__ . \ Unit[p_Symbol\_q__]] := 
        UnitI[a\ ToString[p\_q, StandardForm]] /; \(! UnitQ[
              a]\);\)\[IndentingNewLine]
    \(UnitI[a__ . \ Unit[x_Symbol]] := 
        UnitI[a\ ts@x] /; \(! UnitQ[a]\);\)\[IndentingNewLine]
    \(UnitI[a__ . \ Unit[x_]] := 
        UnitI[a\ x] /; \(! UnitQ[
              a]\);\)\[IndentingNewLine] (*\(UnitI[\[ScriptU]_?UnitQ] := 
          UnitI[uS@\[ScriptU]];\)*) \[IndentingNewLine]\[IndentingNewLine]
    \(UnitI[\[ScriptU]_] := 
        Module[{X, x, a, b, all, unf, M, uD, uN, uND, xn, xs, f, g, h, u, p, 
              q, m, cInfo, 
              list}, \[IndentingNewLine]x = \[ScriptU] // 
                uS //. \[InvisibleSpace]a___\ t_Symbol\^m_. \ b___ \
\[RuleDelayed] a\ ts[t]\^m\ b; \[IndentingNewLine]a = 
              x //. \[InvisibleSpace]_String \[Rule] 
                  1; \[IndentingNewLine]x = dpe[x, a]; \[IndentingNewLine]X = 
              UnitE[a\ x]; \[IndentingNewLine]\[IndentingNewLine]hu = \(Hold[\
\[ScriptU]] /. Unit \[Rule] Hold\) //. 
                Hold[x_] \[Rule] x; \[IndentingNewLine]cInfo = 
              If[NumericQ @@ 
                  UCR[hu], \[IndentingNewLine]{"\<Relative Uncertainty\>", 
                  g @@ UCR[
                      hu]}, \[IndentingNewLine]Null]; \[IndentingNewLine]\
\[IndentingNewLine]f[sys_] := 
              Module[{h = N@sys[X]}, \[IndentingNewLine]If[
                  h == X && 
                    Head[x] === 
                      String, \[IndentingNewLine]If[\(! FreeQ[
                        Unit["\<Base\>", sys], x]\), \[IndentingNewLine]h = 
                      x <> "\< is a Base Unit.\>", \[IndentingNewLine]h = 
                      x <> "\< is a Derived Unit.\>"], \[IndentingNewLine]h = 
                    g[h]]; h]; \[IndentingNewLine]g[u_] := 
              ToString[u, StandardForm]; \[IndentingNewLine]all = 
              Unit[Names, All] \[Union] \[IndentingNewLine]Flatten[
                  Cases[Unit[Table, All], \[IndentingNewLine]HoldPattern[
                      p_String \[Rule] 
                        q_String], {0, \[Infinity]}]]; \[IndentingNewLine]\
\[IndentingNewLine]uN = UnitN[X]; 
            uD = UnitD[X]; \[IndentingNewLine]If[{x} === 
                List @@ uD, \[IndentingNewLine]If[
                MemberQ[\[IndentingNewLine]Complement[\[IndentingNewLine]\
Cases[Unit[Definition, 
                        UnitDIM], _String, {0, \[Infinity]}], \
\[IndentingNewLine]{"\<Base\>", "\<Derived\>"}], \[IndentingNewLine]x], \
\[IndentingNewLine]Return[
                  g[uD] <> "\< is a dimension.\>"]]]; \[IndentingNewLine]\
\[IndentingNewLine]uND = 
              If[uN === uD, g[uN], 
                g[g[uN] \[Rule] g[uD]]]; \[IndentingNewLine]unf[t_] := 
              Flatten[Select[
                    all, \(! FreeQ[#1, 
                          t]\) &] /. \[InvisibleSpace]Rule \[Rule] 
                    List]; \[IndentingNewLine]un = 
              unf[x]; \[IndentingNewLine]un = 
              Complement[
                Union[Flatten[\((unf[#1] &)\) /@ 
                      un]], {x}]; \
\[IndentingNewLine]\[IndentingNewLine]myTable[{\[IndentingNewLine]{"\<\
Information About: \>", 
                  g[X] <> If[
                      NumericQ @@ 
                        UCR[hu], "\< (Constant)\>", "\<\>"]}, \
\[IndentingNewLine]{"\< \>", "\<------------------------------\>"}, \
\[IndentingNewLine]cInfo, \[IndentingNewLine]{"\<Dimensions:        \>", 
                  uND}, \[IndentingNewLine]{"\<Other Names:       \>", 
                  g[un]}, \[IndentingNewLine]Sequence @@ \(\(({g[#1] <> "\< \
Equivalent:\>", f[#1]} &)\) /@ Unit["\<System\>", All]\)}]] /; \(! UnitQ[a, 
              String]\);\)\)\)\)], "Input",
  InitializationCell->True]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["    Convert", "SubsectionIcon"],

Cell[CellGroupData[{

Cell[BoxData[
    \(uct\)], "SubsubsectionIcon"],

Cell["Temperature Converter", "Text"],

Cell[BoxData[{
    \(\(T0 = 
        27315/100;\)\[IndentingNewLine]\[IndentingNewLine] (*\ \(===\)\(===\)\
\(===\)\(\ \)\(AUTOMATIC\ CONVERTION\)\(\ \)\(===\)\(===\)\(===\)\ *) \
\[IndentingNewLine]\), "\[IndentingNewLine]", 
    \(\(Unit /: \ a_. \ Unit["\<\[Degree]\[DoubleStruckCapitalC]\>"] := 
        uct[a, "\<\[Degree]\[DoubleStruckCapitalC]\>", $unit];\)\), "\
\[IndentingNewLine]", 
    \(\(Unit /: \ a_. \ Unit["\<\[Degree]\[DoubleStruckCapitalK]\>"] := 
        uct[a, "\<\[Degree]\[DoubleStruckCapitalK]\>", $unit];\)\), "\
\[IndentingNewLine]", 
    \(\(Unit /: \ a_. \ Unit["\<\[Degree]\[DoubleStruckCapitalF]\>"] := 
        uct[a, "\<\[Degree]\[DoubleStruckCapitalF]\>", $unit];\)\), "\
\[IndentingNewLine]", 
    \(\(Unit /: \ a_. \ Unit["\<\[Degree]\[DoubleStruckCapitalR]\>"] := 
        uct[a, "\<\[Degree]\[DoubleStruckCapitalR]\>", $unit];\)\)}], "Input",\

  InitializationCell->True],

Cell[BoxData[
    \(\(\( (*\ \(===\)\(===\)\(===\)\(\ \)\(SCALE\ Temperature\ Converter\)\(\
\ \)\(===\)\(===\)\(===\)\ \
*) \)\(\[IndentingNewLine]\)\(\[IndentingNewLine]\)\( (*\ \(--\(-\ 
            Very\)\)\ basic\ question\ *) \)\(\[IndentingNewLine]\)\(\(uct[
          n_, "\<\[Degree]\[DoubleStruckCapitalK]\>", "\<\[Degree]\
\[DoubleStruckCapitalK]\>"] := 
        n\ Unit["\<\[DoubleStruckCapitalK]\>"];\)\[IndentingNewLine]
    \(uct[
          n_, "\<\[Degree]\[DoubleStruckCapitalR]\>", "\<\[Degree]\
\[DoubleStruckCapitalR]\>"] := 
        n\ Unit["\<\[DoubleStruckCapitalR]\>"];\)\[IndentingNewLine]\
\[IndentingNewLine] (*\ \(--\(-\ 
            UNITS\)\)\ and\ SYSTEM\ Converter\ *) \[IndentingNewLine]
    \(uct[n_, "\<\[Degree]\[DoubleStruckCapitalC]\>", y_] := 
        uct[n + T0, "\<\[Degree]\[DoubleStruckCapitalK]\>", 
          y];\)\[IndentingNewLine]
    \(uct[n_, "\<\[Degree]\[DoubleStruckCapitalF]\>", y_] := 
        uct[\((n - 32)\)\ 5/9 + T0, "\<\[Degree]\[DoubleStruckCapitalK]\>", 
          y];\)\[IndentingNewLine]
    \(uct[n_, "\<\[Degree]\[DoubleStruckCapitalR]\>", y_] := 
        uct[n\ 5/9, "\<\[Degree]\[DoubleStruckCapitalK]\>", 
          y];\)\[IndentingNewLine]\n (*\ \(--\(-\ 
            SYSTEM\)\)\ Converter\ *) \[IndentingNewLine]
    \(uct[n_, x_String, 
          sys_Symbol] := \[IndentingNewLine]uct[n, 
            x, "\<\[Degree]\>" <> \(("\<Temperature\>" /. 
                  Unit["\<Base\>", sys])\)] /; \[IndentingNewLine]MemberQ[
            Unit["\<System\>", All], 
            sys];\)\[IndentingNewLine]\[IndentingNewLine] (*\ \(--\(-\ \(UNIT \
: \ Converter\)\)\)\ *) \[IndentingNewLine]
    \(uct[
          n_, "\<\[Degree]\[DoubleStruckCapitalK]\>", "\<\[Degree]\
\[DoubleStruckCapitalC]\>"] := \((n - T0)\) 
          Unit["\<\[DoubleStruckCapitalC]\>"];\)\[IndentingNewLine]
    \(uct[
          n_, "\<\[Degree]\[DoubleStruckCapitalK]\>", "\<\[Degree]\
\[DoubleStruckCapitalF]\>"] := \((n - T0)\)\ 9/5 + 
          32\ Unit["\<\[DoubleStruckCapitalF]\>"];\)\n
    \(uct[
          n_, "\<\[Degree]\[DoubleStruckCapitalK]\>", "\<\[Degree]\
\[DoubleStruckCapitalR]\>"] := 
        n\ 9/
            5\ Unit["\<\[DoubleStruckCapitalR]\>"];\)\[IndentingNewLine]\
\[IndentingNewLine] (*\ \(===\)\(===\)\(\ \)\(NOT\ FORGET\)\(\ \)\(===\)\(\
===\)\ *) \[IndentingNewLine]\[IndentingNewLine] (*\ \(--\(-\ 
            Only\)\)\ the\ defined\ values\ *) \[IndentingNewLine]
    \(uct[n_, x_, y_] := n\ Unit[x];\)\)\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(UnitConvert\)], "SubsubsectionIcon"],

Cell[BoxData[
    \(\(\( (*\ \(--\(-\ 
            Temperature\)\)\ problem\ \
*) \)\(\[IndentingNewLine]\)\(\(\(UnitConvert[
            Unit["\<\[Degree]\[DoubleStruckCapitalC]\>"]]\)[
          x_ /; UnitQ[x]] := \(UnitConvert[
            Unit["\<\[DoubleStruckCapitalC]\>"]]\)[x];\)\[IndentingNewLine]
    \(\(UnitConvert[Unit["\<\[Degree]\[DoubleStruckCapitalK]\>"]]\)[
          x_ /; UnitQ[x]] := \(UnitConvert[
            Unit["\<\[DoubleStruckCapitalK]\>"]]\)[x];\)\[IndentingNewLine]
    \(\(UnitConvert[Unit["\<\[Degree]\[DoubleStruckCapitalF]\>"]]\)[
          x_ /; UnitQ[x]] := \(UnitConvert[
            Unit["\<\[DoubleStruckCapitalF]\>"]]\)[x];\)\[IndentingNewLine]
    \(\(UnitConvert[Unit["\<\[Degree]\[DoubleStruckCapitalR]\>"]]\)[
          x_ /; UnitQ[x]] := \(UnitConvert[
            Unit["\<\[DoubleStruckCapitalR]\>"]]\)[
          x];\)\[IndentingNewLine]\[IndentingNewLine] (*\ \(--\(-\ 
            Nothing\)\)\ to\ do\ *) \[IndentingNewLine]
    \(\(UnitConvert[_]\)[x_ /; \(! UnitQ[x]\)] := 
        x;\)\[IndentingNewLine]\[IndentingNewLine] (*\ \(--\(-\ 
            Listable\)\)\ on\ 2  nd\ arg\ *) \[IndentingNewLine]
    \(\(UnitConvert[y_]\)[x_List] := 
        UnitConvert[y] /@ 
          x;\)\[IndentingNewLine]\[IndentingNewLine] (*\ \(--\(-\ 
            Convertions\)\)\ between\ unit\ systems\ *) \[IndentingNewLine]
    \(\(UnitConvert[sys_Symbol:  $unit]\)[
          x_ /; UnitQ[x]] := \[IndentingNewLine]Module[{old, 
              u}, \[IndentingNewLine]old = $Unit; \[IndentingNewLine]$Unit = 
              UnitMKS; \[IndentingNewLine]u = 
              us[uPlus@x, 
                sys]; \[IndentingNewLine]If[\(! FreeQ[UnitN[u], 
                    Plus]\) \[And] 
                NumericQ[uN[x]], \[IndentingNewLine]Message[
                UnitConvert::"\<badPlus\>", 
                HoldForm[x]]]; \[IndentingNewLine]$Unit = 
              old; \[IndentingNewLine]u] /; 
          UnitQ[sys, "\<System\>"];\)\[IndentingNewLine]\[IndentingNewLine] \
(*\ \(--\(-\ Convertions\)\)\ between\ units\ *) \[IndentingNewLine]
    \(\(UnitConvert[y_Unit]\)[
          x_ /; UnitQ[x]] := \[IndentingNewLine]us[uPlus@\(us@x\)\/y]\ y /; 
          UnitN[x] == UnitN[y];\)\[IndentingNewLine]
    \(\(UnitConvert[y_Unit]\)[
          x_ /; UnitQ[x]] := \((\[IndentingNewLine]Message[
              UnitConvert::"\<badUnit\>", HoldForm@x, HoldForm@y]; 
            x)\) /; \[IndentingNewLine]UnitN[x] =!= UnitN[y] \[And] 
            NumericQ[uN@x];\)\)\)\)], "Input",
  InitializationCell->True]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["    Simplify", "SubsectionIcon"],

Cell[CellGroupData[{

Cell[BoxData[
    \(UnitSimplify\)], "SubsubsectionIcon"],

Cell[BoxData[
    \(\(\( (*\ \(===\)\(===\)\(===\)\(\ \)\(UnitSimplify\)\(\ \
\)\(===\)\(===\)\(===\)\ \
*) \)\(\[IndentingNewLine]\)\(\[IndentingNewLine]\)\(\(Options[
          UnitSimplify] = {Assumptions \[RuleDelayed] $Assumptions, 
          ComplexityFunction \[Rule] Automatic, TimeConstraint \[Rule] 300, 
          TransformationFunctions \[Rule] Automatic, 
          Trig \[Rule] True};\)\[IndentingNewLine]
    \(Options[UnitFullSimplify] = {Assumptions \[RuleDelayed] $Assumptions, 
          ComplexityFunction \[Rule] Automatic, ExcludedForms \[Rule] {}, 
          TimeConstraint \[Rule] \[Infinity], 
          TransformationFunctions \[Rule] Automatic, 
          Trig \[Rule] True};\)\[IndentingNewLine]\[IndentingNewLine]
    \(UnitSimplify[x_, opt___] := US[Simplify, x, opt];\)\[IndentingNewLine]
    \(UnitFullSimplify[x_, opt___] := 
        US[FullSimplify, x, opt];\)\[IndentingNewLine]
    \(UnitPowerExpand[x_] := US[PowerExpand, x];\)\[IndentingNewLine]
    \(UnitComplexExpand[x_, opt___] := 
        US[ComplexExpand, x, opt];\)\[IndentingNewLine]\[IndentingNewLine]
    \(US[F_, \[ScriptX]_ /; \(! UnitQ[\[ScriptX]]\), 
          opt___] := \[IndentingNewLine]F[Refine[\[ScriptX]], 
          opt];\)\[IndentingNewLine]\[IndentingNewLine]
    \(US[F_, \[ScriptX]_?UnitQ, 
          opt___] := \[IndentingNewLine]\[IndentingNewLine]Module[{X, x, 
            y}, \[IndentingNewLine]\[IndentingNewLine] (*\ \(--\(-\ 
                Convert\)\)\ *) \[IndentingNewLine]X = \
\(UnitConvert[$unit]\)[\[ScriptX]]; \[IndentingNewLine]\[IndentingNewLine] \
(*\ \(--\(-\ 
                  Modifiy\)\)\ some\ Unit\ definitions\ \
*) \[IndentingNewLine]Unprotect[
            Unit]; \[IndentingNewLine]Unit /: \(Unit[_] \[Element] 
                Reals =. \); \[IndentingNewLine]Unit /: \(Unit[_] > 
                0 =. \); \[IndentingNewLine]Unit /: \(Unit[_] \[GreaterEqual] 
                0 =. \); \[IndentingNewLine]Unit /: \(Unit[_] < 
                0 =. \); \[IndentingNewLine]Unit /: \(Unit[_] \[LessEqual] 
                0 =. \); \[IndentingNewLine]Protect[
            Unit]; \[IndentingNewLine]\[IndentingNewLine] (*\ \(--\(-\ 
                  Call\)\)\ Simplify\ *) \[IndentingNewLine]\
\[IndentingNewLine]Assuming[\[IndentingNewLine]\[IndentingNewLine]Thread[\(\
Greater[#, 0] &\)[
                Union@Cases[X, 
                    Unit[_], {0, \[Infinity]}]]], \[IndentingNewLine]\
\[IndentingNewLine] (*\ \(--\(-\ 
                    CoDomain\)\)\ of\ Unit\ function\ *) \[IndentingNewLine]X \
= X //. a_. \ x_Unit \[Element] Reals \[RuleDelayed] 
                  a \[Element] 
                    Reals; \[IndentingNewLine]\[IndentingNewLine] (*\ \(--\(-\
\ Numerical\)\)\ Functions\ *) \[IndentingNewLine]X = 
              X //. Abs[a_.  x_Unit] \[RuleDelayed] 
                  Abs[a] x; \[IndentingNewLine]X = 
              X //. Sign[a_.  x_Unit] \[RuleDelayed] 
                  Sign[a]; \[IndentingNewLine]X = 
              X //. Round[a_.  x_Unit] \[RuleDelayed] 
                  Round[a]\ x; \[IndentingNewLine]X = 
              X //. IntegerPart[a_.  x_Unit] \[RuleDelayed] 
                  IntegerPart[a]\ x; \[IndentingNewLine]X = 
              X //. FractionalPart[a_.  x_Unit] \[RuleDelayed] 
                  FractionalPart[a]\ x; \[IndentingNewLine]X = 
              X //. Ceiling[a_.  x_Unit] \[RuleDelayed] 
                  Ceiling[a]\ x; \[IndentingNewLine]X = 
              X //. Floor[a_.  x_Unit] \[RuleDelayed] 
                  Floor[a]\ x; \[IndentingNewLine]X = 
              X //. Re[a_.  x_Unit] \[RuleDelayed] 
                  Re[a]\ x; \[IndentingNewLine]X = 
              X //. Conjugate[a_.  x_Unit] \[RuleDelayed] 
                  Conjugate[a]\ x; \[IndentingNewLine]X = 
              X //. Im[a_.  x_Unit] \[RuleDelayed] 
                  Im[a] x; \[IndentingNewLine]X = 
              X //. Arg[a_.  x_Unit] \[RuleDelayed] 
                  Arg[a]; \[IndentingNewLine]\[IndentingNewLine] (*\ \(--\(-\ 
                    Vectorial\)\)\ Functions\ *) \[IndentingNewLine]X = 
              X //. Norm[a_.  x_Unit] \[RuleDelayed] 
                  Norm[a] x; \[IndentingNewLine]X = 
              X //. Dot[y_, a_.  x_Unit] \[RuleDelayed] 
                  Dot[y, a]\ x; \[IndentingNewLine]X = 
              X //. Dot[a_.  x_Unit, y_] \[RuleDelayed] 
                  Dot[a, y]\ x; \[IndentingNewLine]X = 
              X //. Cross[y_, a_.  x_Unit] \[RuleDelayed] 
                  Cross[y, a]\ x; \[IndentingNewLine]X = 
              X //. Cross[a_.  x_Unit, y_] \[RuleDelayed] 
                  Cross[a, y]\ x; \[IndentingNewLine]\[IndentingNewLine]X = 
              F[Refine[X], 
                opt]]; \[IndentingNewLine]\[IndentingNewLine] (*\ \(--\(-\ 
                  Restore\)\)\ Unit\ definitions\ \
*) \[IndentingNewLine]Unprotect[Unit]; \[IndentingNewLine]Unit /: 
            Unit[_] \[Element] Reals = True; \[IndentingNewLine]Unit /: 
            Unit[_] > 0 = True; \[IndentingNewLine]Unit /: 
            Unit[_] \[GreaterEqual] 0 = True; \[IndentingNewLine]Unit /: 
            Unit[_] < 0 = False; \[IndentingNewLine]Unit /: 
            Unit[_] \[LessEqual] 0 = False; \[IndentingNewLine]Protect[
            Unit]; \[IndentingNewLine]\[IndentingNewLine]X];\)\)\)\)], "Input",\

  InitializationCell->True]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["    UnitK", "SubsectionIcon"],

Cell[CellGroupData[{

Cell[BoxData[
    \(UnitK\)], "SubsubsectionIcon"],

Cell[BoxData[
    \(\(UnitK[
          X_] := \[IndentingNewLine]us[\(X /. 
              p_Symbol\_q__ \[RuleDelayed] 
                Unit[p\_q] /; 
                  NumericQ @@ 
                    UCR[tsN@
                        p\_q]\) /. \[IndentingNewLine]x_Symbol \[RuleDelayed] 
              Unit@\(ts@x\) /; NumericQ @@ UCR[ts@x]];\)\)], "Input",
  InitializationCell->True]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["    UnitS", "SubsectionIcon"],

Cell[CellGroupData[{

Cell[BoxData[
    \(UnitS\)], "SubsubsectionIcon"],

Cell[BoxData[{
    \(\(Options[
          UnitS] = {StringLength \[Rule] 3};\)\), "\[IndentingNewLine]", 
    \(\(UnitS[X_, opt___?OptionQ] := 
        UnitK[X /. 
            x_Symbol \[RuleDelayed] 
              Unit@\(ts@x\) /; \[IndentingNewLine]MemberQ[
                  Select[\[IndentingNewLine]UnitI[
                      Names], \[IndentingNewLine]StringLength[#] > \
\((\(StringLength /. Flatten@{opt}\) /. 
                            Options[UnitS])\) &], \[IndentingNewLine]ts@
                    x]];\)\)}], "Input",
  InitializationCell->True]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["    Unit", "SubsectionIcon"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Unit - Initialize\)], "SubsubsectionIcon"],

Cell[BoxData[
    \(\(Attributes[Unit] = {HoldFirst, Constant};\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(Options[
          Unit] = {\[IndentingNewLine]Automatic \[Rule] 
            False, \[IndentingNewLine]N \[Rule] 
            False, \[IndentingNewLine]StyleBox \[Rule] {FontColor \[Rule] 
                GrayLevel[0.5]}};\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(\( (*\ 
      Initialize\ *) \)\(\[IndentingNewLine]\)\(Unit[Rule, 
          All] = \[IndentingNewLine]\(Unit["\<System\>", 
            All] = \[IndentingNewLine]\(Unit[Names, 
              All] = \[IndentingNewLine]\(Unit[Table, 
                All] = {}\)\)\);\)\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(\( (*\ 
      Convertion\ *) \)\(\[IndentingNewLine]\)\(Unit[x_?UnitQ, y_?UnitQ] := 
        x/y;\)\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Unit\ Algebra\)], "SubsubsectionIcon"],

Cell[BoxData[
    \(\(\( (*\ \(--\(-\ Convert\)\)\ Unit[
          x]\ to\ Unit["\<x\>"]\ and\ Simplify\ \
*) \)\(\[IndentingNewLine]\)\(\(Unit[p_Symbol\_q__] := 
        us@\(Unit@\(Evaluate@tsN[p\_q]\)\)\ ;\)\[IndentingNewLine]
    \(Unit[a___\ x_Symbol\^m_. \ b___] := 
        Unit[Times@a]\ Unit[x]\^m\ Unit[Times@b];\)\[IndentingNewLine]
    \(Unit[x_Symbol\^m_. ] := 
        us[Unit@\(Evaluate@ts[x]\)]\^m;\)\[IndentingNewLine]\
\[IndentingNewLine] (*\ \(--\(-\ \(UpValue : \ 
            Unit\ of\ Powers\)\)\)\ *) \[IndentingNewLine]
    \(Unit /: Unit[x_]\^m_?NumericQ := 
        us[Unit[x\^m]];\)\[IndentingNewLine]\[IndentingNewLine] (*\ \(--\(-\ \
\(UpValue : \ Unit\ of\ Times\ of\ Units\)\)\)\ *) \[IndentingNewLine]
    \(Unit /: a_. \ \ Unit[x_]\ Unit[y_] := 
        a\ us@Unit[x\ y];\)\[IndentingNewLine]
    \(Unit /: a_. \ x_Unit\ y_Unit\^n_?NumericQ := 
        a\ us@Unit[
              x\[LeftDoubleBracket]1\[RightDoubleBracket]\ y\
\[LeftDoubleBracket]1\[RightDoubleBracket]\^n];\)\[IndentingNewLine]
    \(Unit /: 
        Times[a_ /; UnitQ[a], 
          Unit[x_]] := \[IndentingNewLine]With[{n = 
              uN[a]}, \[IndentingNewLine]With[{A = 
                  dpe[uS[a], n]}, \[IndentingNewLine]n\ us[
                    Unit[A\ x]] /; \[IndentingNewLine]\(! UnitQ[A, 
                      Variables]\) \[And] 
                  UnitQ[A, Format]] /; \[IndentingNewLine]\(! UnitQ[n, 
                String]\)];\)\[IndentingNewLine]\[IndentingNewLine] (*\ \
\(--\(-\ Out\)\)\ Numbers\ *) \[IndentingNewLine]
    \(Unit[x_] := Rationalize[x, 0] /; NumericQ[x];\)\[IndentingNewLine]
    \(Unit[a_\ x_] := 
        Rationalize[a, 0]\ Unit[x] /; 
          NumericQ[a] \[And] 
            UnitQ[x, String];\)\[IndentingNewLine]\n (*\ \(--\(-\ 
            Convert\)\)\ Reals\ Numbers\ inside\ Unit\ to\ Rationals\ \
*) \[IndentingNewLine]
    \(Unit[
          x_ /; UnitQ[x, Real]] := \[IndentingNewLine]With[{a = 
              Rationalize[x, 0]}, \[IndentingNewLine]Unit@\(Evaluate@
                a\) /; \(! UnitQ[a, 
                Real]\)];\)\[IndentingNewLine]\[IndentingNewLine] (*\ \(--\(-\
\ Out\)\)\ Unit\ from\ Unit\ \((Flatten\ on\ 1  st\ var)\)\ *) \n
    \(Unit[x_?UnitQ] := 
        us@\(EUnit@\(uS@
              x\)\);\)\[IndentingNewLine]\[IndentingNewLine] (*\ \(--\(-\ 
            Unit\)\)\ Listable\ on\ 1  st\ arg\ *) \[IndentingNewLine]
    \(Unit[x_List] := us[Unit /@ x];\)\)\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Unit\ Option\ N\)], "SubsubsectionIcon"],

Cell[BoxData[
    \(\(\( (*\ \(--\(-\ \(UpValue : \ Make\ reals\)\)\)\ *) \)\(\n\)\(Unit /: 
        Times[a_ /; UnitQ[a, Rational], 
          Unit[x_]] := \[IndentingNewLine]numerical[a]\ Unit[
              x] /; \((N /. Options[Unit])\) =!= False;\)\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Unit\ Option\ Automatic\)], "SubsubsectionIcon"],

Cell[BoxData[
    \(\(\( (*\ \(--\(-\ Unit\)\)\ Automatic\  - \ 
        Simplify\ Unit["\<x\>"]\ *) \)\(\[IndentingNewLine]\)\(Unit[
          x_ /; UnitQ[x, String]] := 
        With[{X = uc[x, $unit]}, \[IndentingNewLine]Unit@
                Evaluate[Times @@ X] /; 
              X\[LeftDoubleBracket]2\[RightDoubleBracket] =!= 
                x] /; \((Automatic /. Options[Unit])\) === 
            True;\)\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Unit[TagBox, StyleBox]\)], "SubsubsectionIcon"],

Cell[BoxData[
    \(\(Unit[TagBox, StyleBox] := 
        Block[{}, \[IndentingNewLine]\[IndentingNewLine]Unprotect[
            Unit]; \[IndentingNewLine]\[IndentingNewLine] (*\ \(--\(-\ 
                  Unit\)\)\ Format\ *) \[IndentingNewLine]Unit /: 
            MakeBoxes[Unit[x_], StandardForm] := \[IndentingNewLine]TagBox[
              StyleBox[\[IndentingNewLine]ToBoxes[Unevaluated[x], 
                  StandardForm], \[IndentingNewLine]FontSlant \[Rule] Plain, 
                ShowStringCharacters \[Rule] 
                  False, \[IndentingNewLine]Sequence @@ \((StyleBox /. 
                      Options[
                        Unit])\)], \[IndentingNewLine]Unit]; \
\[IndentingNewLine]Unit /: 
            MakeBoxes[Unit[x_], TraditionalForm] := \[IndentingNewLine]TagBox[
              StyleBox[\[IndentingNewLine]ToBoxes[Unevaluated[x], 
                  TraditionalForm], \[IndentingNewLine]FontSlant \[Rule] 
                  Plain, ShowStringCharacters \[Rule] 
                  False, \[IndentingNewLine]Sequence @@ \((StyleBox /. 
                      Options[
                        Unit])\)], \[IndentingNewLine]Unit]; \
\[IndentingNewLine]\[IndentingNewLine]Protect[
            Unit]; \[IndentingNewLine]\[IndentingNewLine]"\<Notation for Unit \
set to InterpretationBox.\>"];\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Unit[Set, All]\)], "SubsubsectionIcon"],

Cell[BoxData[
    \(\(Unit[Set, All] := 
        Block[{}, \[IndentingNewLine]Unit[TagBox, 
            StyleBox]; \[IndentingNewLine]Unit[Unset, 
            All]; \[IndentingNewLine]Unit[Set, 
            UnitDIM]; \[IndentingNewLine]Unit[Set, UnitFPS]; 
          Unit[Set, UnitCGS]; Unit[Set, UnitMKS]];\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Unit - Set\)], "SubsubsectionIcon"],

Cell[BoxData[
    \(\(\( (*\ \(--\(-\ 
            Attaching\)\)\ Rules\ *) \)\(\[IndentingNewLine]\)\(\
\[IndentingNewLine]\)\(\(Unit[Set, {p__Rule}] := 
        Unit[Set, p];\)\[IndentingNewLine]
    \(Unit[Set, 
          p__Rule] := \[IndentingNewLine]\((\(Unit[
                Set, #] &\) /@ {p}; \[IndentingNewLine]"\<Rules \>" <> 
            ToString[{p}, 
              StandardForm] <> "\< attached.\>")\);\)\[IndentingNewLine]\
\[IndentingNewLine]
    \(Unit[Set, 
          a_ \[Rule] b_] := \[IndentingNewLine]Module[{M = a \[Rule] b, 
            v}, \[IndentingNewLine]v = 
            Cases[Variables@{a, b}, _Symbol]; \[IndentingNewLine]M = {M} //. 
              Thread@Rule[
                  v, \((ToString[#, InputForm] &)\) /@ 
                    v]; \[IndentingNewLine]Unprotect[
            Unit]; \[IndentingNewLine]Unit[Rule, All] = 
            Union[Unit[Rule, All], M]; \[IndentingNewLine]Protect[
            Unit]; \[IndentingNewLine]"\<Rule \>" <> 
            ToString[M, 
              StandardForm] <> "\< attached.\>"];\)\[IndentingNewLine]\
\[IndentingNewLine] (*\ \(--\(-\ 
            Set\)\)\ Unit\ System\ *) \[IndentingNewLine]\[IndentingNewLine]
    \(Unit[Set, 
          system_Symbol, \[ScriptCapitalM]_List: {}] := \[IndentingNewLine]\
\[IndentingNewLine]Module[{s, x, y, X, Y, f, g, h, M, \[GothicCapitalM], 
            v, \[IndentingNewLine]union, all, list, a, b, c, m, 
            n, \[ScriptCapitalB], \[ScriptCapitalC], \[ScriptCapitalD], \
\[ScriptCapitalN], Q}, \[IndentingNewLine]\[IndentingNewLine]Unprotect[
            Unit]; \[IndentingNewLine]s = 
            ToString[Unevaluated @@ system, 
              InputForm]; \[IndentingNewLine]\[IndentingNewLine] (*\ 
            SYS[x]\  - \ Converter\ *) \[IndentingNewLine]Unprotect[
            Evaluate@s]; 
          ClearAll[
            Evaluate@s]; \[IndentingNewLine]\(Evaluate[system]\)[
              x_] := \[IndentingNewLine]With[{X = \(UnitConvert[system]\)[
                    x]}, X /; \[IndentingNewLine]FreeQ[X, 
                  UnitConvert]]; \[IndentingNewLine]If[
            system =!= UnitDIM, \[IndentingNewLine]\(Evaluate[
                  system]\)::usage = \[IndentingNewLine]s <> "\< is a symbol \
for one unit system.\n    See Also: UnitI[ \>" <> s <> "\< ].\n\>" <> 
                s <> "\<[x] convert the units in x.\n    See Also: Unit.\>"]; \
\[IndentingNewLine]Attributes[Evaluate@system] = {Listable, Protected, 
              ReadProtected}; \[IndentingNewLine]\[IndentingNewLine]If[\
\[ScriptCapitalM] === {}, \[IndentingNewLine]M = 
              Unit[Definition, system], \[IndentingNewLine]If[
              VectorQ[\[ScriptCapitalM]], \[IndentingNewLine]M = 
                Union[Unit[Definition, 
                    system], {\[ScriptCapitalM]}], \[IndentingNewLine]M = \
\[ScriptCapitalM]]; \[IndentingNewLine]v = 
              Cases[Variables@\[ScriptCapitalM], _Symbol]; \
\[IndentingNewLine]M = 
              M //. Thread@
                  Rule[v, \((ToString[#, InputForm] &)\) /@ 
                      v]; \[IndentingNewLine]If[
              FreeQ[{UnitDIM, UnitMKS, UnitCGS, UnitFPS}, 
                system], \[IndentingNewLine]Unit[Definition, system] = 
                M]]; \[IndentingNewLine]\[IndentingNewLine] (*\ 
            Auxiliar\ *) \[IndentingNewLine]union[x_, 
              all_:  Unit["\<System\>", 
                  All]] := \[IndentingNewLine]Module[{Q = {}, 
                m}, \[IndentingNewLine]Do[
                Q = Union[Q, 
                    Unit[Evaluate@x, 
                      all\[LeftDoubleBracket]m\[RightDoubleBracket]]], \
\[IndentingNewLine]{m, Length[all]}]; 
              Q]; \[IndentingNewLine]\[IndentingNewLine] (*\ Equivalence, 
            All\ *) \[IndentingNewLine]Unit["\<Equivalence\>", 
              All] = \[IndentingNewLine]union["\<Equivalence\>", \
\[IndentingNewLine]Complement[
                  Unit["\<System\>", 
                    All], {system}]] /. \[IndentingNewLine]\((a_ \[Rule] 
                    b_)\) \[RuleDelayed] 
                Module[{n, x}, \[IndentingNewLine]n = 
                    b /. x_String \[RuleDelayed] 
                        1; \[IndentingNewLine]Rationalize[b/n \[Rule] a/n, 
                    0]]; \[IndentingNewLine]\[IndentingNewLine] (*\ 
            Names\ *) \[IndentingNewLine]\[ScriptCapitalN] = \(Unit[Names, 
                system] = \[IndentingNewLine]List @@ \((\(\(\(\(list @@ 
                                Reverse@\[IndentingNewLine]Select[
                                    M, \[Not] FreeQ[#, "\<Base\>" | \
"\<Derived\>"] &] //. \[IndentingNewLine]{"\<Base\>", a_, b__, 
                                  c_} \[RuleDelayed] {b, 
                                  c}\) //. \[IndentingNewLine]{"\<Derived\>", 
                                a_, b__, 
                                c_} \[RuleDelayed] {b}\) //. {x_} \[Rule] 
                            Sequence[]\) //. \[IndentingNewLine]{a_, b_, 
                            c__} \[RuleDelayed] 
                          Sequence[{a, b}, {b, 
                              c}]\) /. \[IndentingNewLine]{a_, 
                          b_} \[RuleDelayed] \(a \[Rule] 
                          
                          b\))\) //. \[IndentingNewLine]\(("\<Derived\>" \
\[Rule] b_)\) \[RuleDelayed] 
                  Sequence[]\); \[IndentingNewLine]\[GothicCapitalM] = \(M \
//. \  (*\ quito\ names\ *) \[IndentingNewLine]{"\<Base\>", a_, X__, 
                    b_} \[RuleDelayed] {"\<Base\>", a, 
                    b}\) //. \[IndentingNewLine]{"\<Derived\>", a_, X___, b_, 
                  c_} \[RuleDelayed] {"\<Derived\>", a, b, 
                  c}; \[IndentingNewLine]\[IndentingNewLine] (*\ 
            Auxiliar\ *) \[IndentingNewLine]g[x_] := 
            Module[{y, 
                Y}, \[IndentingNewLine]y = \(list @@ 
                      Select[\[GothicCapitalM], 
                        MemberQ[#, x] &] /. \[IndentingNewLine]{a__, b_, 
                        c_} \[RuleDelayed] {b, c}\) /. 
                  list \[Rule] 
                    List; \[IndentingNewLine]Y = {}; \[IndentingNewLine]Do[
                Do[\[IndentingNewLine]AppendTo[Y, 
                    y\[LeftDoubleBracket]n, m\[RightDoubleBracket] \[Rule] 
                      y\[LeftDoubleBracket]n, 
                        m + 1\[RightDoubleBracket]], \[IndentingNewLine]{m, 
                    Length[y\[LeftDoubleBracket]n\[RightDoubleBracket]] - 
                      1}], {n, Length[y]}]; \[IndentingNewLine]Unit[x, 
                  system] = 
                Union@Y]; \[IndentingNewLine]\[IndentingNewLine] (*\ 
            Assignaments\ *) \[IndentingNewLine]\[ScriptCapitalB] = 
            g["\<Base\>"]; \[IndentingNewLine]\[ScriptCapitalC] = 
            g["\<Combined\>"]; \[IndentingNewLine]\[ScriptCapitalD] = 
            g["\<Derived\>"]; \[IndentingNewLine]Q = 
            g["\<Equivalence\>"]; \[IndentingNewLine]Unit[Dimensions, 
              system] = \[ScriptCapitalB] \[Union] \[ScriptCapitalC] \[Union] \
\[IndentingNewLine]\((\(\(list @@ 
                          Reverse@
                            Select[\[GothicCapitalM], \
\[IndentingNewLine]MemberQ[#, "\<Derived\>"] &] //. \[IndentingNewLine]{a_, 
                            b_, X___, c_, d_} \[RuleDelayed] {b, 
                            c}\) /. \[IndentingNewLine]{a_, 
                          b_} \[RuleDelayed] \(a \[Rule] 
                          b\)\) /. \[IndentingNewLine]list \[Rule] 
                      List)\) /. \[IndentingNewLine]{"\<Derived\>", a_, 
                  b_} \[RuleDelayed] \(a \[Rule] 
                  b\); \[IndentingNewLine]\[IndentingNewLine] (*\ 
            Others\ All\ *) \[IndentingNewLine]If[
            system =!= UnitDIM, \[IndentingNewLine]Unit["\<System\>", All] = 
              Union[Unit["\<System\>", 
                  All], {system}]; \[IndentingNewLine]$Unit = 
              system; \[IndentingNewLine]Unit[Names, All] = 
              Union[Unit[Names, 
                  All], \[ScriptCapitalN]]]; \[IndentingNewLine]\
\[IndentingNewLine]Protect[
            Unit]; \[IndentingNewLine]\[IndentingNewLine]Unprotect[
            UnitI]; \[IndentingNewLine]h[x_, y_:  system] := 
            ToString[Unit[Evaluate@x, y], 
              StandardForm]; \[IndentingNewLine]UnitI[
              Evaluate@
                system] \
:= \[IndentingNewLine]myTable[{\[IndentingNewLine]{"\<Rules for: \>" <> 
                    s, "\<\>"}, \[IndentingNewLine]{"\<--------------------- \
\>", "\<\>"}, \[IndentingNewLine]{"\<Unit[Base,\>" <> s <> "\<]\>", 
                  h["\<Base\>"]}, \[IndentingNewLine]{"\<Unit[Derived,\>" <> 
                    s <> "\<]\>", 
                  h["\<Derived\>"]}, \[IndentingNewLine]{"\<Unit[Combined,\>" \
<> s <> "\<]\>", 
                  h["\<Combined\>"]}, \
\[IndentingNewLine]{"\<Unit[Equivalence,\>" <> s <> "\<]\>", 
                  h["\<Equivalence\>"]}, \
\[IndentingNewLine]{"\<Unit[Names,\>" <> s <> "\<]\>", 
                  h[Names]}, \[IndentingNewLine]{"\<Unit[Dimensions,\>" <> 
                    s <> "\<]\>", 
                  h[Dimensions]}, \
\[IndentingNewLine]{"\<--------------------- \>", "\<\>"}, \
\[IndentingNewLine]{"\<Avaibles Systems:\>", 
                  h["\<System\>", 
                    All]}, \[IndentingNewLine]{"\<Default System:\>", 
                  h["\<System\>", 
                    Default]}, \[IndentingNewLine]{"\<--------------------- \
\>", "\<\>"}}]; \[IndentingNewLine]Protect[
            UnitI]; \[IndentingNewLine]\[IndentingNewLine]UnitI[
            system]];\)\)\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Unit - Unset\)], "SubsubsectionIcon"],

Cell[BoxData[
    \(\(\( (*\ \(--\(-\ 
            Deattaching\)\)\ Rules\ *) \)\(\[IndentingNewLine]\)\(\
\[IndentingNewLine]\)\(\(Unit[Unset, {p__Rule}] := 
        Unit[Unset, p];\)\[IndentingNewLine]
    \(Unit[Unset, 
          p__Rule] := \[IndentingNewLine]\((\(Unit[
                Unset, #] &\) /@ {p}; \[IndentingNewLine]"\<Rules \>" <> 
            ToString[{p}, 
              StandardForm] <> "\< deattached.\>")\);\)\[IndentingNewLine]\
\[IndentingNewLine]
    \(Unit[Unset, 
          a_ \[Rule] b_] := \[IndentingNewLine]Module[{M = a \[Rule] b, 
            v}, \[IndentingNewLine]v = 
            Cases[Variables@{a, b}, _Symbol]; \[IndentingNewLine]M = {M} //. 
              Thread@Rule[
                  v, \((ToString[#, InputForm] &)\) /@ 
                    v]; \[IndentingNewLine]Unprotect[
            Unit]; \[IndentingNewLine]Unit[Rule, All] = 
            Complement[Unit[Rule, All], M]; \[IndentingNewLine]Protect[
            Unit]; \[IndentingNewLine]"\<Rule \>" <> 
            ToString[M, 
              StandardForm] <> "\< deattached.\>"];\)\[IndentingNewLine]\
\[IndentingNewLine] (*\ \(--\(-\ 
            Uniting\)\)\ All\ *) \[IndentingNewLine]\[IndentingNewLine]
    \(Unit[Unset, All] := 
        Module[{sys, g, m, 
            x}, \[IndentingNewLine]\[IndentingNewLine]Unprotect[
            Unit]; \[IndentingNewLine]\[IndentingNewLine] (*\ 
            sys\ *) \[IndentingNewLine]sys = 
            Unit["\<System\>", All]; \[IndentingNewLine]g[x_] := 
            Block[{$Messages}, \[IndentingNewLine]Do[\[IndentingNewLine]Unit[
                    x, sys\[LeftDoubleBracket]
                      m\[RightDoubleBracket]] =. ; \
\[IndentingNewLine]Unprotect[
                  Evaluate[
                    sys]]; \[IndentingNewLine]\(Evaluate[
                      sys]\)::usage =. , \[IndentingNewLine]{m, 
                  Length[sys]}]]; \[IndentingNewLine]g /@ {Names, "\<Base\>", \
"\<Derived\>", "\<Combined\>", "\<Equivalence\>", 
              Dimensions}; \[IndentingNewLine]\[IndentingNewLine] (*\ 
            All\ *) \[IndentingNewLine]Unit[Rule, 
              All] = \(Unit["\<System\>", 
                All] = \(Unit[Names, 
                  All] = {}\)\); \[IndentingNewLine]$Unit =. ; \
\[IndentingNewLine]\[IndentingNewLine]Protect[
            Unit]; \[IndentingNewLine]\[IndentingNewLine]"\<All units systems \
are cleared.\>"];\)\[IndentingNewLine]\[IndentingNewLine] (*\ \(--\(-\ 
            Unseting\)\)\ system\ *) \n\[IndentingNewLine]
    \(Unit[Unset, 
          system_Symbol] \
:= \[IndentingNewLine]\[IndentingNewLine]Module[{def, all, 
            sys}, \[IndentingNewLine]\[IndentingNewLine]all = 
            Unit["\<System\>", 
              All]; \[IndentingNewLine]def = $unit; \[IndentingNewLine]If[
            def \[Congruent] system, 
            def = \(Complement[
                  all, {def}]\)\[LeftDoubleBracket]1\[RightDoubleBracket]]; \
\[IndentingNewLine]sys = 
            Complement[
              Unit["\<System\>", 
                All], {system} \[Union] {def}]; \[IndentingNewLine]Unit[
            Unset, All]; \[IndentingNewLine]\(Unit[Set, #] &\) /@ 
            sys; \[IndentingNewLine]Unit[Set, 
            def]; \[IndentingNewLine]ToString@
              system <> "\< system are cleared.\>"];\)\)\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Unit[Definition, UnitDIM]\)], "SubsubsectionIcon"],

Cell[BoxData[
    \(\(Unit[Definition, 
          UnitDIM] = \[IndentingNewLine]Module[{L, M, t, T, e, A, S, 
            i}, {\[IndentingNewLine]{"\<Base\>", "\<Length\>", "\<m\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<Mass\>", "\<kg\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<Time\>", "\<s\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<ElectricCurrent\>", "\<A\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<Temperature\>", "\<\[DoubleStruckCapitalK]\
\>"}, \[IndentingNewLine]{"\<Base\>", "\<Substance\>", "\<mol\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<LuminousIntensity\>", "\<cd\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<Angle\>", "\<rad\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<SolidAngle\>", "\<sr\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<Information\>", "\<bit\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<Money\>", "\<$\>"}, \
\[IndentingNewLine]{"\<Derived\>", "\<Acceleration\>", 
                L\/t\^2}, \[IndentingNewLine]{"\<Derived\>", "\<Action\>", \
\(L\^2\ M\)\/t}, \[IndentingNewLine]{"\<Derived\>", \
"\<AngularAcceleration\>", 
                A\/t\^2}, \[IndentingNewLine]{"\<Derived\>", \
"\<AngularSpeed\>", A\/t}, \[IndentingNewLine]{"\<Derived\>", "\<Area\>", 
                L\^2}, \[IndentingNewLine]{"\<Derived\>", "\<DynamicViscosity\
\>", M\/\(L\ t\)}, \[IndentingNewLine]{"\<Derived\>", \
"\<ElectricCapacitance\>", \(e\^2\ t\^4\)\/\(L\^2\ M\)}, \
\[IndentingNewLine]{"\<Derived\>", "\<ElectricCharge\>", 
                t\ e}, \[IndentingNewLine]{"\<Derived\>", \
"\<ElectricConductance\>", \(e\^2\ t\^3\)\/\(L\^2\ M\)}, \
\[IndentingNewLine]{"\<Derived\>", "\<ElectricDipoleMoment\>", 
                e\ L\ t}, \[IndentingNewLine]{"\<Derived\>", \
"\<ElectricDisplacement\>", \(e\ t\)\/L\^2}, \
\[IndentingNewLine]{"\<Derived\>", "\<ElectricFieldStrength\>", \(L\ M\)\/\(e\
\ t\^3\)}, \[IndentingNewLine]{"\<Derived\>", "\<ElectricPermittivity\>", \(e\
\^2\ t\^2\)\/\(L\ M\)}, \[IndentingNewLine]{"\<Derived\>", \
"\<ElectricPolarizability\>", \(e\^2\ t\^4\)\/M}, \
\[IndentingNewLine]{"\<Derived\>", "\<ElectricPotential\>", \(L\^2\ M\)\/\(e\ \
t\^3\)}, \[IndentingNewLine]{"\<Derived\>", "\<ElectricResistance\>", \(L\^2\ \
M\)\/\(e\^2\ t\^3\)}, \[IndentingNewLine]{"\<Derived\>", \
"\<ElectricResistivity\>", 
                L\^3\/\(e\^2\ t\^3\)}, \[IndentingNewLine]{"\<Derived\>", \
"\<Energy\>", \(L\^2\ M\)\/t\^2}, \[IndentingNewLine]{"\<Derived\>", "\<Force\
\>", \(L\ M\)\/t\^2}, \[IndentingNewLine]{"\<Derived\>", "\<Frequency\>", 
                1\/t}, \[IndentingNewLine]{"\<Derived\>", "\<HeatCapacity\>", \
\(L\^2\ M\)\/\(t\^2\ T\)}, \[IndentingNewLine]{"\<Derived\>", \
"\<HeatInsulationCoefficient\>", \(t\^3\ T\)\/M}, \
\[IndentingNewLine]{"\<Derived\>", "\<HeatTransferCoefficient\>", 
                M\/\(t\^3\ T\)}, \[IndentingNewLine]{"\<Derived\>", \
"\<Illuminance\>", 
                i\/\(L\^2\ S\^2\)}, \[IndentingNewLine]{"\<Derived\>", \
"\<InverseLength\>", 1\/L}, \[IndentingNewLine]{"\<Derived\>", "\<Jerk\>", 
                L\/t\^3}, \[IndentingNewLine]{"\<Derived\>", \
"\<KinematicViscosity\>", 
                L\^2\/t}, \[IndentingNewLine]{"\<Derived\>", \
"\<LinearFrequency\>", 
                1\/\(L\ t\)}, \[IndentingNewLine]{"\<Derived\>", \
"\<LinearMassDensity\>", 
                M\/L}, \[IndentingNewLine]{"\<Derived\>", "\<LuminousFlux\>", 
                i\ S}, \[IndentingNewLine]{"\<Derived\>", \
"\<LuminousLuminance\>", 
                i\/L\^2}, \[IndentingNewLine]{"\<Derived\>", \
"\<MagneticDipoleMoment\>", 
                e\ L\^2}, \[IndentingNewLine]{"\<Derived\>", \
"\<MagneticFlux\>", \(L\^2\ M\)\/\(e\ t\^2\)}, \[IndentingNewLine]{"\<Derived\
\>", "\<MagneticFluxDensity\>", 
                M\/\(e\ t\^2\)}, \[IndentingNewLine]{"\<Derived\>", \
"\<MagneticInductance\>", \(L\^2\ M\)\/\(e\^2\ t\^2\)}, \[IndentingNewLine]{"\
\<Derived\>", "\<MagneticPermiability\>", \(L\ M\)\/\(e\^2\ t\^2\)}, \
\[IndentingNewLine]{"\<Derived\>", "\<MagneticPolarizability\>", \(e\^2\ L\^2\
\ t\^2\)\/M}, \[IndentingNewLine]{"\<Derived\>", "\<MagnetizingForce\>", 
                e\/L}, \[IndentingNewLine]{"\<Derived\>", "\<MassDensity\>", 
                M\/L\^3}, \[IndentingNewLine]{"\<Derived\>", \
"\<MolarElectricCharge\>", \(e\ t\^3\)\/\(L\ M\)}, \
\[IndentingNewLine]{"\<Derived\>", "\<MomentOfInertia\>", 
                L\^2\ M}, \[IndentingNewLine]{"\<Derived\>", "\<Momentum\>", \
\(L\ M\)\/t}, \[IndentingNewLine]{"\<Derived\>", "\<Power\>", \(L\^2\ \
M\)\/t\^3}, \[IndentingNewLine]{"\<Derived\>", "\<Pressure\>", 
                M\/\(L\ t\^2\)}, \[IndentingNewLine]{"\<Derived\>", \
"\<SpecificHeatCapacity\>", 
                L\^2\/\(t\^2\ T\)}, \[IndentingNewLine]{"\<Derived\>", \
"\<Speed\>", 
                L\/t}, \[IndentingNewLine]{"\<Derived\>", \
"\<SurfaceEnergyDensity\>", 
                M\/t\^2}, \[IndentingNewLine]{"\<Derived\>", \
"\<SurfacePowerDensity\>", 
                M\/t\^3}, \[IndentingNewLine]{"\<Derived\>", \
"\<ThermalConductivity\>", \(L\ M\)\/\(t\^3\ T\)}, \
\[IndentingNewLine]{"\<Derived\>", "\<Volume\>", 
                L\^3}, \[IndentingNewLine]{"\<Derived\>", "\<VolumeFlow\>", 
                L\^3\/t}} /. \[InvisibleSpace]\[IndentingNewLine]{i \[Rule] "\
\<LuminousIntensity\>", S \[Rule] "\<SolidAngle\>", A \[Rule] "\<Angle\>", 
              e \[Rule] "\<ElectricCurrent\>", T \[Rule] "\<Temperature\>", 
              t \[Rule] "\<Time\>", M \[Rule] "\<Mass\>", 
              L \[Rule] "\<Length\>"}];\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Unit[Definition, UnitMKS]\)], "SubsubsectionIcon"],

Cell[BoxData[
    \(\(Unit[Definition, 
          UnitMKS] = {\[IndentingNewLine]{"\<Base\>", "\<Length\>", \
"\<Meter\>", "\<m\>"}, \[IndentingNewLine]{"\<Base\>", "\<Mass\>", \
"\<Kilogram\>", "\<Kg\>", "\<kg\>"}, \[IndentingNewLine]{"\<Base\>", \
"\<Time\>", "\<Second\>", "\<s\>"}, \[IndentingNewLine]{"\<Base\>", \
"\<ElectricCurrent\>", "\<Ampere\>", "\<Amp\>", "\<A\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<Temperature\>", "\<Kelvin\>", "\<\
\[DoubleStruckCapitalK]\>"}, \[IndentingNewLine]{"\<Base\>", "\<Substance\>", \
"\<Mole\>", "\<mol\>"}, \[IndentingNewLine]{"\<Base\>", \
"\<LuminousIntensity\>", "\<Candela\>", "\<cd\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<Angle\>", "\<Radian\>", "\<rad\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<SolidAngle\>", "\<Steradian\>", "\<sr\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<Information\>", "\<Bit\>", "\<bit\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<Money\>", "\<$\>"}, \
\[IndentingNewLine]{"\<Derived\>", "\<ElectricCapacitance\>", "\<F\>", \("\<s\
\>"\^4\ "\<A\>"\^2\)\/\("\<m\>"\^2\ "\<kg\>"\)}, \
\[IndentingNewLine]{"\<Derived\>", "\<ElectricConductance\>", "\<S\>", \("\<s\
\>"\^3\ "\<A\>"\^2\)\/\("\<m\>"\^2\ "\<kg\>"\)}, \
\[IndentingNewLine]{"\<Derived\>", "\<ElectricPotential\>", "\<V\>", \
\("\<m\>"\^2\ "\<kg\>"\)\/\("\<s\>"\^3\ "\<A\>"\)}, \
\[IndentingNewLine]{"\<Derived\>", "\<ElectricResistance\>", "\<\
\[CapitalOmega]\>", \("\<m\>"\^2\ "\<kg\>"\)\/\("\<s\>"\^3\ "\<A\>"\^2\)}, \
\[IndentingNewLine]{"\<Derived\>", "\<Energy\>", "\<J\>", \("\<m\>"\^2\ "\<kg\
\>"\)\/"\<s\>"\^2}, \[IndentingNewLine]{"\<Derived\>", "\<Force\>", "\<N\>", \
\("\<m\>"\ "\<kg\>"\)\/"\<s\>"\^2}, \[IndentingNewLine]{"\<Derived\>", \
"\<Frequency\>", "\<Hz\>", 
            1\/"\<s\>"}, \[IndentingNewLine]{"\<Derived\>", \
"\<Illuminance\>", "\<lx\>", "\<cd\>"\/\("\<m\>"\^2\ "\<sr\>"\^2\)}, \
\[IndentingNewLine]{"\<Derived\>", "\<LuminousFlux\>", "\<lm\>", "\<cd\>"\ \
"\<sr\>"}, \[IndentingNewLine]{"\<Derived\>", "\<MagneticFlux\>", "\<Wb\>", \
\("\<m\>"\^2\ "\<kg\>"\)\/\("\<s\>"\^2\ "\<A\>"\)}, \
\[IndentingNewLine]{"\<Derived\>", "\<MagneticFluxDensity\>", "\<T\>", \
"\<kg\>"\/\("\<s\>"\^2\ "\<A\>"\)}, \[IndentingNewLine]{"\<Derived\>", \
"\<MagneticInductance\>", "\<Hy\>", "\<H\>", \("\<m\>"\^2\ "\<kg\>"\)\/\("\<s\
\>"\^2\ "\<A\>"\^2\)}, \[IndentingNewLine]{"\<Derived\>", "\<Power\>", \
"\<W\>", \("\<m\>"\^2\ "\<kg\>"\)\/"\<s\>"\^3}, \
\[IndentingNewLine]{"\<Derived\>", "\<Pressure\>", "\<Pa\>", "\<kg\>"\/\("\<m\
\>"\ "\<s\>"\^2\)}, \[IndentingNewLine]{"\<Derived\>", "\<ElectricCharge\>", \
"\<C\>", "\<s\>"\ "\<A\>"}, \[IndentingNewLine]{"\<Combined\>", \
"\<Acceleration\>", "\<m\>"\/"\<s\>"\^2}, \[IndentingNewLine]{"\<Combined\>", \
"\<Action\>", \("\<kg\>"\ "\<m\>"\^2\)\/"\<s\>"}, \
\[IndentingNewLine]{"\<Combined\>", "\<AngularAcceleration\>", \
"\<rad\>"\/"\<s\>"\^2}, \[IndentingNewLine]{"\<Combined\>", \
"\<AngularSpeed\>", "\<rad\>"\/"\<s\>"}, \[IndentingNewLine]{"\<Combined\>", \
"\<Area\>", "\<m\>"\^2}, \[IndentingNewLine]{"\<Combined\>", \
"\<DynamicViscosity\>", "\<kg\>"\/\("\<m\>"\ "\<s\>"\)}, \
\[IndentingNewLine]{"\<Combined\>", "\<ElectricDipoleMoment\>", "\<A\>"\ "\<s\
\>"\ "\<m\>"}, \[IndentingNewLine]{"\<Combined\>", \
"\<ElectricDisplacement\>", "\<C\>"\/"\<m\>"\^2}, \
\[IndentingNewLine]{"\<Combined\>", "\<ElectricFieldStrength\>", \("\<kg\>"\ \
"\<m\>"\)\/\("\<A\>"\ "\<s\>"\^3\)}, \[IndentingNewLine]{"\<Combined\>", \
"\<ElectricPermittivity\>", "\<F\>"\/"\<m\>"}, \
\[IndentingNewLine]{"\<Combined\>", "\<ElectricPolarizability\>", \
\("\<A\>"\^2\ "\<s\>"\^4\)\/"\<kg\>"}, \[IndentingNewLine]{"\<Combined\>", \
"\<ElectricResistivity\>", "\<\[CapitalOmega]\>"\ "\<m\>"}, \
\[IndentingNewLine]{"\<Combined\>", "\<HeatCapacity\>", "\<J\>"\/"\<K\>"}, \
\[IndentingNewLine]{"\<Combined\>", "\<HeatInsulationCoefficient\>", \
\("\<s\>"\^3\ "\<K\>"\)\/"\<kg\>"}, \[IndentingNewLine]{"\<Combined\>", \
"\<HeatTransferCoefficient\>", "\<kg\>"\/\("\<s\>"\^3\ "\<K\>"\)}, \
\[IndentingNewLine]{"\<Combined\>", "\<InverseLength\>", 
            1\/"\<m\>"}, \[IndentingNewLine]{"\<Combined\>", "\<Jerk\>", "\<m\
\>"\/"\<s\>"\^3}, \[IndentingNewLine]{"\<Combined\>", \
"\<KinematicViscosity\>", "\<m\>"\^2\/"\<s\>"}, \
\[IndentingNewLine]{"\<Combined\>", "\<LinearFrequency\>", \
"\<Hz\>"\/"\<m\>"}, \[IndentingNewLine]{"\<Combined\>", \
"\<LinearMassDensity\>", "\<kg\>"\/"\<m\>"}, \
\[IndentingNewLine]{"\<Combined\>", "\<LuminousLuminance\>", \
"\<cd\>"\/"\<m\>"\^2}, \[IndentingNewLine]{"\<Combined\>", \
"\<MagneticDipoleMoment\>", "\<A\>"\ "\<m\>"\^2}, \
\[IndentingNewLine]{"\<Combined\>", "\<MagneticPermiability\>", "\<N\>"\/"\<A\
\>"\^2}, \[IndentingNewLine]{"\<Combined\>", "\<MagneticPolarizability\>", \
\("\<A\>"\^2\ "\<m\>"\^2\ "\<s\>"\^2\)\/"\<kg\>"}, \
\[IndentingNewLine]{"\<Combined\>", "\<MagnetizingForce\>", \
"\<A\>"\/"\<m\>"}, \[IndentingNewLine]{"\<Combined\>", "\<MassDensity\>", \
"\<kg\>"\/"\<m\>"\^3}, \[IndentingNewLine]{"\<Combined\>", \
"\<MolarElectricCharge\>", "\<C\>"\/"\<N\>"}, \[IndentingNewLine]{"\<Combined\
\>", "\<MomentOfInertia\>", "\<kg\>"\ "\<m\>"\^2}, \
\[IndentingNewLine]{"\<Combined\>", "\<Momentum\>", \("\<kg\>"\ \
"\<m\>"\)\/"\<s\>"}, \[IndentingNewLine]{"\<Combined\>", "\<Radioactivity\>", \
\("\<kg\>"\ "\<m\>"\^2\)\/"\<s\>"}, \[IndentingNewLine]{"\<Combined\>", \
"\<SpecificHeatCapacity\>", "\<m\>"\^2\/\("\<s\>"\^2\ "\<K\>"\)}, \
\[IndentingNewLine]{"\<Combined\>", "\<Speed\>", "\<m\>"\/"\<s\>"}, \
\[IndentingNewLine]{"\<Combined\>", "\<SurfaceEnergyDensity\>", "\<J\>"\/"\<m\
\>"\^2}, \[IndentingNewLine]{"\<Combined\>", "\<SurfacePowerDensity\>", \
"\<W\>"\/"\<m\>"\^2}, \[IndentingNewLine]{"\<Combined\>", \
"\<ThermalConductivity\>", \("\<kg\>"\ "\<m\>"\)\/\("\<s\>"\^3\ "\<K\>"\)}, \
\[IndentingNewLine]{"\<Combined\>", "\<Volume\>", "\<m\>"\^3}, \
\[IndentingNewLine]{"\<Combined\>", "\<VolumeFlow\>", \
"\<m\>"\^3\/"\<s\>"}};\)\)], "Input",
  CellLabel->"In[3]:=",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Unit[Definition, UnitCGS]\)], "SubsubsectionIcon"],

Cell[TextData[{
  "We don't define base unit for ",
  Cell[BoxData[
      \(ElectricCurrunt\)]],
  ". But, in fact, fall in ",
  Cell[BoxData[
      \(A\)]],
  ". We define as derived units that have specials names."
}], "Text"],

Cell[BoxData[
    \(\(Unit[Definition, 
          UnitCGS] = {\[IndentingNewLine]{"\<Equivalence\>", "\<m\>", 
            100\ "\<cm\>"}, \[IndentingNewLine]{"\<Equivalence\>", "\<kg\>", 
            1000\ "\<gr\>"}, \[IndentingNewLine]{"\<Base\>", "\<Length\>", \
"\<Centimeter\>", "\<cm\>"}, \[IndentingNewLine]{"\<Base\>", "\<Mass\>", \
"\<Gram\>", "\<gr\>"}, \[IndentingNewLine]{"\<Base\>", "\<Time\>", \
"\<Second\>", "\<s\>"}, \[IndentingNewLine]{"\<Base\>", "\<Temperature\>", \
"\<Kelvin\>", "\<\[DoubleStruckCapitalK]\>"}, \[IndentingNewLine]{"\<Base\>", \
"\<Substance\>", "\<Mole\>", "\<mol\>"}, \[IndentingNewLine]{"\<Base\>", \
"\<Angle\>", "\<Radian\>", "\<rad\>"}, \[IndentingNewLine]{"\<Base\>", \
"\<SolidAngle\>", "\<Steradian\>", "\<sr\>"}, \[IndentingNewLine]{"\<Base\>", \
"\<LuminousIntensity\>", "\<Candela\>", "\<cd\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<Information\>", "\<Bit\>", "\<bit\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<Money\>", "\<$\>"}, \
\[IndentingNewLine]{"\<Derived\>", "\<Acceleration\>", "\<Galileo\>", \
"\<Gal\>", "\<gal\>", "\<cm\>"\ "\<s\>"\^\(-2\)}, \
\[IndentingNewLine]{"\<Derived\>", "\<Energy\>", "\<Erg\>", "\<erg\>", \
"\<cm\>"\^2\ "\<gr\>"\ "\<s\>"\^\(-2\)}, \[IndentingNewLine]{"\<Derived\>", "\
\<Force\>", "\<Dyne\>", "\<dyn\>", "\<cm\>"\ "\<gr\>"\ "\<s\>"\^\(-2\)}, \
\[IndentingNewLine]{"\<Derived\>", "\<Frequency\>", "\<Hertz\>", "\<Hz\>", \
"\<s\>"\^\(-1\)}, \[IndentingNewLine]{"\<Derived\>", "\<Pressure\>", "\<Barye\
\>", "\<cm\>"\^\(-1\)\ "\<gr\>"\ "\<s\>"\^\(-2\)}, \
\[IndentingNewLine]{"\<Derived\>", "\<Speed\>", "\<Kyne\>", "\<cm\>"\ "\<s\>"\
\^\(-1\)}, \[IndentingNewLine]{"\<Derived\>", "\<DynamicViscosity\>", \
"\<Poise\>", "\<P\>", "\<dyn\>"\ "\<s\>"\ "\<cm\>"\^\(-2\)}, \
\[IndentingNewLine]{"\<Derived\>", "\<KinematicViscosity\>", "\<Stokes\>", \
"\<St\>", "\<cm\>"\^2\ "\<s\>"\^\(-1\)}, \[IndentingNewLine]{"\<Derived\>", "\
\<Illuminance\>", "\<Phot\>", "\<ph\>", "\<cd\>" "\<cm\>"\^\(-2\)\ "\<sr\>"\^\
\(-2\)}, \[IndentingNewLine]{"\<Derived\>", "\<LuminousLuminance\>", "\<Stilb\
\>", "\<sb\>", "\<cd\>"\ "\<cm\>"\^\(-2\)}, \
\[IndentingNewLine]{"\<Derived\>", "\<MagneticFlux\>", "\<abWeber\>", "\<abWb\
\>", "\<Maxwell\>", "\<Mx\>", 
            10\^\(-1\)\ "\<cm\>"\^2\ "\<gr\>"\ "\<s\>"\^\(-2\)\ "\<A\>"\^\(-1\
\)}, \[IndentingNewLine]{"\<Derived\>", "\<MagneticFluxDensity\>", "\<abTesla\
\>", "\<abT\>", "\<Gauss\>", "\<Gs\>", "\<Mx\>"\ "\<cm\>"\^\(-2\)}, \
\[IndentingNewLine]{"\<Derived\>", "\<ElectricCurrent\>", "\<Gilbert\>", \
"\<Gb\>", 
            1/\((4\ Pi)\)\ 10\ "\<A\>"}, \[IndentingNewLine]{"\<Combined\>", \
"\<Power\>", "\<erg\>"\ "\<s\>"\^\(-1\)}};\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Unit[Definition, UnitFPS]\)], "SubsubsectionIcon"],

Cell[BoxData[
    \(\(Unit[Definition, 
          UnitFPS] = {\[IndentingNewLine]{"\<Equivalence\>", "\<m\>", 
            5000/1524\ "\<ft\>"}, \[IndentingNewLine]{"\<Equivalence\>", \
"\<kg\>", 
            11023113\/5000000\ "\<lb\>"}, \
\[IndentingNewLine]{"\<Equivalence\>", "\<\[DoubleStruckCapitalK]\>", 
            9/5\ "\<\[DoubleStruckCapitalR]\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<Length\>", "\<Foot\>", "\<Feet\>", \
"\<ft\>"}, \[IndentingNewLine]{"\<Base\>", "\<Mass\>", \
"\<AvoirdupoisPound\>", "\<Pound\>", "\<lb\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<Time\>", "\<Second\>", "\<s\>"}, \
\[IndentingNewLine]{"\<Base\>", "\<Temperature\>", "\<Rankine\>", "\<\
\[DoubleStruckCapitalR]\>"}, \[IndentingNewLine]{"\<Base\>", "\<Angle\>", \
"\<Radian\>", "\<rad\>"}, \[IndentingNewLine]{"\<Base\>", "\<SolidAngle\>", "\
\<Steradian\>", "\<sr\>"}, \[IndentingNewLine]{"\<Base\>", "\<Money\>", \
"\<$\>"}, \[IndentingNewLine]{"\<Derived\>", "\<Frequency\>", "\<Hertz\>", \
"\<Hz\>", "\<s\>"\^\(-1\)}, \[IndentingNewLine]{"\<Derived\>", "\<Power\>", "\
\<Horsepower\>", "\<HP\>", 
            550\ \(41949360957\/41949338500\) "\<ft\>"\ "\<lbf\>"\ \
"\<s\>"\^\(-1\)}, \[IndentingNewLine]{"\<Derived\>", "\<Force\>", \
"\<PoundForce\>", "\<lbf\>", 
            32.1740\ \(817220528481\/817219600000\) "\<ft\>"\ "\<lb\>"\ \
"\<s\>"\^\(-2\)}, {"\<Combined\>", "\<Energy\>", "\<lbf\>"\ "\<ft\>"}, \
\[IndentingNewLine]{"\<Combined\>", "\<Pressure\>", "\<lbf\>"\ "\<in\>"\^\(-2\
\)}};\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(\( (*{"\<Derived\>", "\<Power\>", "\<Horsepower\>", "\<HP\>", 
        0.745700\ 10\^3\ "\<W\>"}, \[IndentingNewLine]{"\<Derived\>", \
"\<Force\>", "\<PoundWeight\>", "\<PoundForce\>", "\<lbf\>", 
        4.44822\ "\<N\>"}, *) \)\(\[IndentingNewLine]\)\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Unit[Prefix, All]\)], "SubsubsectionIcon"],

Cell[BoxData[
    \(\(\( (*\ \(--\(-\ \(MULTIPLIERS\ --\)\)\)\(-\)\ *) \)\(\
\[IndentingNewLine]\)\(\[IndentingNewLine]\)\(Unit[Prefix, All] = 
        ListToRules@{\[IndentingNewLine]{"\<Percent\>", 
              1/100}, \[IndentingNewLine]{"\<Gross\>", 
              144}, \[IndentingNewLine]{"\<Dozen\>", 
              12}, \[IndentingNewLine]{"\<BakersDozen\>", 
              13}, \[IndentingNewLine]{"\<Mole\>", "\<mol\>", 
              6.0221367\ 10\^23}, \[IndentingNewLine]{"\<Yotta\>", "\<\
\[ScriptCapitalY]\>", 
              10\^24}, \[IndentingNewLine]{"\<Zetta\>", \
"\<\[ScriptCapitalZ]\>", 
              10\^21}, \[IndentingNewLine]{"\<Exa\>", \
"\<\[ScriptCapitalE]\>", 
              10\^18}, \[IndentingNewLine]{"\<Peta\>", \
"\<\[ScriptCapitalP]\>", 
              10\^15}, \[IndentingNewLine]{"\<Tera\>", \
"\<\[ScriptCapitalT]\>", 
              10\^12}, \[IndentingNewLine]{"\<Giga\>", \
"\<\[ScriptCapitalG]\>", 
              10\^9}, \[IndentingNewLine]{"\<Mega\>", \
"\<\[ScriptCapitalM]\>", 
              10\^6}, \[IndentingNewLine]{"\<Kilo\>", "\<\[ScriptK]\>", 
              10\^3}, \[IndentingNewLine]{"\<Hecto\>", "\<\[ScriptH]\>", 
              100}, \[IndentingNewLine]{"\<Deca\>", \
"\<\[ScriptD]\[ScriptA]\>", 
              10}, \[IndentingNewLine]{"\<Deci\>", "\<\[ScriptD]\>", 
              10\^\(-1\)}, \[IndentingNewLine]{"\<Centi\>", "\<\[ScriptC]\>", 
              10\^\(-2\)}, \[IndentingNewLine]{"\<Milli\>", "\<\[ScriptM]\>", 
              10\^\(-3\)}, \[IndentingNewLine]{"\<Micro\>", "\<\[Mu]\>", 
              10\^\(-6\)}, \[IndentingNewLine]{"\<Nano\>", "\<\[ScriptN]\>", 
              10\^\(-9\)}, \[IndentingNewLine]{"\<Pico\>", "\<\[ScriptP]\>", 
              10\^\(-12\)}, \[IndentingNewLine]{"\<Femto\>", \
"\<\[ScriptF]\>", 
              10\^\(-15\)}, \[IndentingNewLine]{"\<Atto\>", "\<\[ScriptA]\>", 
              10\^\(-18\)}, \[IndentingNewLine]{"\<Zepto\>", \
"\<\[ScriptZ]\>", 
              10\^\(-21\)}, \[IndentingNewLine]{"\<Yocto\>", \
"\<\[ScriptY]\>", 10\^\(-24\)}};\)\)\)], "Input",
  InitializationCell->True,
  FormatType->TraditionalForm]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Unit[Angle, All]\)], "SubsubsectionIcon"],

Cell[BoxData[
    \(\(Unit["\<Angle\>", All] = 
        ListToRules@{\[IndentingNewLine]{"\<Radian\>", "\<rad\>", 
              1}, \[IndentingNewLine]{"\<Steradian\>", "\<sr\>", 
              1}};\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Unit[Temperature, All]\)], "SubsubsectionIcon"],

Cell[BoxData[
    \(\(\( (*\ \(--\(-\ \(Temperature\ --\)\)\)\(-\)\ *) \)\(\
\[IndentingNewLine]\)\(\[IndentingNewLine]\)\(Unit["\<Temperature\>", All] = 
        ListToRules@{\[IndentingNewLine]{"\<Centigrade\>", "\<Celsius\>", "\<\
\[DoubleStruckCapitalC]\>", "\<\[DoubleStruckCapitalK]\>"}, \
\[IndentingNewLine]{"\<Fahrenheit\>", "\<\[DoubleStruckCapitalF]\>", "\<\
\[DoubleStruckCapitalR]\>"}, \[IndentingNewLine]{"\<Rankine\>", "\<\
\[DoubleStruckCapitalR]\>", 
              5\/9\ "\<\[DoubleStruckCapitalK]\>"}, \
\[IndentingNewLine]{"\<Kelvin\>", "\<K\>", "\<\[DoubleStruckCapitalK]\>"}, \
\[IndentingNewLine]{"\<\[Degree]Centigrade\>", "\<\[Degree]Celsius\>", "\<\
\[Degree]C\>", "\<\[Degree]\[DoubleStruckCapitalC]\>"}, \[IndentingNewLine]{"\
\<\[Degree]Fahrenheit\>", "\<\[Degree]F\>", "\<\[Degree]\
\[DoubleStruckCapitalF]\>"}, \[IndentingNewLine]{"\<\[Degree]Rankine\>", "\<\
\[Degree]R\>", "\<\[Degree]\[DoubleStruckCapitalR]\>"}, \[IndentingNewLine]{"\
\<\[Degree]Kelvin\>", "\<\[Degree]K\>", \
"\<\[Degree]\[DoubleStruckCapitalK]\>"}};\)\)\)], "Input",
  InitializationCell->True,
  FormatType->TraditionalForm]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Unit[Constant, All]\)], "SubsubsectionIcon"],

Cell[BoxData[
    \(\(constants = {\[IndentingNewLine]\[IndentingNewLine]{ (*\ \(--\(-\ \
\(UNIVERSAL\ --\)\)\)\(-\)\ *) \[IndentingNewLine]"\<SpeedOfLight\>", \
"\<VacuumSpeedOfLight\>", \*"\"\<\!\(c\_0\)\>\"", "\<c\>", 0, 
            299792458\ "\<m\>"\ "\<s\>"\^\(-1\)}, \
\[IndentingNewLine]{"\<MagneticConstant\>", "\<VacuumPermeability\>", \*"\"\<\
\!\(\[Mu]\_0\)\>\"", 0, 
            4  \[Pi]\ \(10\^\(-7\)\) "\<N\>"\ "\<A\>"\^\(-2\)}, \
\[IndentingNewLine]{"\<ElectricConstant\>", "\<VacuumPermittivity\>", \*"\"\<\
\!\(\[Epsilon]\_0\)\>\"", 0, 
            8.854187817\ 10\^\(-12\)\ "\<F\>"\ "\<m\>"\^\(-1\)}, \
\[IndentingNewLine]{"\<VacuumCharacteristicImpedance\>", \
\*"\"\<\!\(Z\_0\)\>\"", 0, 
            376.730313461\ "\<Ohm\>"}, \
\[IndentingNewLine]{"\<NewtonianConstantOfGravitation\>", \
"\<GravitationalConstant\>", "\<G\>", 10\^\(-14\)\ , 
            6.6742\ 10\^\(-11\)\ "\<m\>"\^3\ "\<kg\>"\^\(-1\)\ \
"\<s\>"\^\(-2\)}, \[IndentingNewLine]{"\<StandardAccelerationOfGravity\>", \
"\<AccelerationDueToGravity\>", Gravity, "\<g\>", 0, 
            9.80665\ "\<m\>"\ "\<s\>"\^\(-2\)}, \
\[IndentingNewLine]{"\<PlanckConstant\>", "\<\[HBar]\>", 
            0.0000011\ 10\^\(-34\), 
            6.626069\ 10\^\(-34\)\ \ "\<J\>"\ "\<s\>"}, \[IndentingNewLine]{"\
\<PlanckMass\>", \*"\"\<\!\(m\_P\)\>\"", 0.00016\ 10\^\(-8\), 
            2.17645\ 10\^\(-8\)\ "\<kg\>"}, \
\[IndentingNewLine]{"\<PlanckTemperature\>", \*"\"\<\!\(T\_P\)\>\"", 
            0.00011\ 10\^32, 
            1.41679\ 10\^32\ "\<\[DoubleStruckCapitalK]\>"}, \
\[IndentingNewLine]{"\<PlanckLength\>", \*"\"\<\!\(l\_P\)\>\"", 
            0.00012\ 10\^\(-35\), 
            1.61624\ 10\^\(-35\)\ "\<m\>"}, \[IndentingNewLine]{"\<PlanckTime\
\>", \*"\"\<\!\(t\_P\)\>\"", 0.00040\ 10\^\(-44\), 
            5.39121\ 10\^\(-44\)\ "\<s\>"}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(--\(-\ \(ELECTROMAGNETIC\ --\)\)\)\(-\)\ \
*) \[IndentingNewLine]"\<ElementaryCharge\>", "\<ElectronCharge\>", \*"\"\<\!\
\(\(e\^-\)\)\>\"", "\<e\>", 0.00000014\ 10\^\(-19\), 
            1.60217653\ 10\^\(-19\)\ "\<C\>"}, \
\[IndentingNewLine]{"\<MagneticFluxQuantum\>", \
\*"\"\<\!\(\[CapitalPhi]\_0\)\>\"", 0.00000018\ 10\^\(-15\), 
            2.06783372\ 10\^\(-15\)\ "\<Wb\>"}, \
\[IndentingNewLine]{"\<ConductanceQuantum\>", \*"\"\<\!\(G\_0\)\>\"", 
            0.000000026\ 10\^\(-5\), 
            7.748091733\ 10\^\(-5\)\ "\<S\>"}, \
\[IndentingNewLine]{"\<JosephsonConstant\>", \*"\"\<\!\(K\_J\)\>\"", 
            4.1\ 10\^7, 
            483597.879\ 10\^9\ "\<Hz\>"\ "\<V\>"\^\(-1\)}, \
\[IndentingNewLine]{"\<vonKlitzingConstant\>", \*"\"\<\!\(R\_K\)\>\"", 
            0.000086, 
            25812.807449\ "\<Ohm\>"}, \[IndentingNewLine]{"\<BohrMagneton\>", \
\*"\"\<\!\(\[Mu]\_B\)\>\"", 0.000080\ 10\^\(-26\), 
            927.400949\ \(10\^\(-26\)\) "\<J\>"\ "\<T\>"\^\(-1\)}, \
\[IndentingNewLine]{"\<NuclearMagneton\>", \*"\"\<\!\(\[Mu]\_N\)\>\"", 
            0.00000043\ 10\^\(-27\), 
            5.05078343\ 10\^\(-27\)\ "\<J\>"\ "\<T\>"\^\(-1\)}, \
\[IndentingNewLine]\[IndentingNewLine]{ (*\ \(\(--\(-\ 
                      PHYSICO\)\)\ \(CHEMICAL\ --\)\)\(-\)\ \
*) \[IndentingNewLine]"\<AvogadroNumber\>", "\<AvogadroConstant\>", \*"\"\<\!\
\(N\_A\)\>\"", 0.0000010\ 10\^23, 
            6.0221415\ 10\^\(-23\)\ "\<mol\>"}, \
\[IndentingNewLine]{"\<AtomicMassConstant\>", \*"\"\<\!\(m\_u\)\>\"", 
            0.00000028\ 10\^\(-27\), 
            1.66053886\ 10\^\(-27\)\ "\<kg\>"}, \
\[IndentingNewLine]{"\<FaradayConstant\>", \*"\"\<\!\(F\_K\)\>\"", 0.0083, 
            96485.3383\ "\<C\>"\ "\<mol\>"\^\(-1\)}, \
\[IndentingNewLine]{"\<BoltzmannConstant\>", "\<k\>", 0.0000024\ 10\^\(-23\), 
            1.3806505\ 10\^\(-23\)\ "\<J\>"\ \
"\<\[DoubleStruckCapitalK]\>"\^\(-1\)}, \
\[IndentingNewLine]{"\<StefanBoltzmannConstant\>", "\<\[Sigma]\>", 
            0.000040\ 10\^\(-8\), 
            5.670400\ 10\^\(-8\)\ "\<W\>"\ "\<m\>"\^\(-2\)\ "\<\
\[DoubleStruckCapitalK]\>"\^\(-4\)}, \
\[IndentingNewLine]{"\<FirstRadiationConstant\>", \*"\"\<\!\(c\_1\)\>\"", 
            0.00000064\ 10\^\(-16\), 
            3.74177138\ 10\^\(-16\)\ "\<W\>"\ "\<m\>"\^2}, \
\[IndentingNewLine]{"\<SpectralRadianceFirstRadiationConstant\>", \
\*"\"\<\!\(c\_\(1  L\)\)\>\"", 0.00000020\ 10\^\(-16\), 
            
            1.19104282\ 10\^\(-16\)\ "\<W\>"\ "\<m\>"\^\(-2\)\ "\<sr\>"\^\(-1\
\)}, \[IndentingNewLine]{"\<SecondRadiationConstant\>", \
\*"\"\<\!\(c\_2\)\>\"", 0.0000025\ 10\^\(-2\), 
            1.438\ 7752\ 10\^\(-2\)\ "\<m\>"\ "\<\[DoubleStruckCapitalK]\>"}, \
\[IndentingNewLine]{"\<WienDisplacementLawConstant\>", \
\*"\"\<\!\(b\_W\)\>\"", 0.0000051\ 10\^\(-3\), 
            2.8977685\ 10\^\(-3\)\ "\<m\>"\ "\<\[DoubleStruckCapitalK]\>"}, \
\[IndentingNewLine]{"\<LoschmidtConstant\>", 2.6867773\ 10\^25, 
            0.0000047\ 10\^25\ "\<m\>"\^\(-3\)}, \[IndentingNewLine]\
\[IndentingNewLine]{"\<StandardTemperature\>", \*"\"\<\!\(T\_0\)\>\"", 0, 
            273.15\ "\<\[DoubleStruckCapitalK]\>"}, \
\[IndentingNewLine]{"\<StandardAtmosphere\>", \*"\"\<\!\(P\_0\)\>\"", 0, 
            101325\ "\<Pa\>"}, \[IndentingNewLine]{"\<IdealGasVolume\>", \
"\<MolarVolume\>", \*"\"\<\!\(V\_0\)\>\"", 0.000039\ 10\^\(-3\), 
            22.413996\ 10\^\(-3\)\ "\<m\>"\^3\ "\<mol\>"\^\(-1\)}, \
\[IndentingNewLine]{"\<IdealGasConstant\>", "\<MolarGasConstant\>", "\<R\>", 
            0.000015, 
            8.314472\ "\<J\>"\ "\<mol\>"\^\(-1\)\ \
"\<\[DoubleStruckCapitalK]\>"\^\(-1\)}, \
\[IndentingNewLine]\[IndentingNewLine]{ (*\ \(--\(-\ 
                      ATOMIC\)\)\ AND\ NUCLEAR\  - \ \(General\ --\) - \ \
*) \[IndentingNewLine]"\<FineStructureConstant\>", "\<\[Alpha]\>", 
            0.000000024\ 10\^\(-3\), 
            7.297352568\ 10\^\(-3\)}, \
\[IndentingNewLine]{"\<RydbergConstant\>", \*"\"\<\!\(R\_\[Infinity]\)\>\"", 
            0.000073, 
            10973731.568525\ "\<m\>"\^\(-1\)}, \
\[IndentingNewLine]{"\<BohrRadius\>", \*"\"\<\!\(a\_0\)\>\"", 
            0.0000000018\ 10\^\(-10\), 
            0.5291772108\ 10\^\(-10\)\ "\<m\>"}, \
\[IndentingNewLine]{"\<HartreeEnergy\>", \*"\"\<\!\(E\_h\)\>\"", 
            0.00000075\ 10\^\(-18\), 
            4.35974417\ 10\^\(-18\)\ "\<J\>"}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(\(--\(-\ A\)\) &\) 
                  N\  - \ \(Electron\  : \ \(\(\(e\^-\)\ --\)\(-\)\)\)\ \
*) \[IndentingNewLine]"\<ElectronMass\>", \*"\"\<\!\(m\_e\)\>\"", 
            0.0000016\ 10\^\(-31\), 
            
            9.1093826\ 10\^\(-31\)\ "\<kg\>"}, \
\[IndentingNewLine]{"\<ElectronComptonWavelength\>", \
\*"\"\<\!\(\[Lambda]\_\(C\_e\)\)\>\"", 0.000000016\ 10\^\(-12\), 
            2.426310238\ 10\^\(-12\)\ "\<m\>"}, \
\[IndentingNewLine]{"\<ClassicalElectronRadius\>", \*"\"\<\!\(r\_e\)\>\"", 
            0.000000028\ 10\^\(-15\), 
            2.817940325\ 10\^\(-15\)\ "\<m\>"}, \
\[IndentingNewLine]{"\<ThomsonCrossSection\>", \*"\"\<\!\(\[Sigma]\_e\)\>\"", 
            0.000000013\ 10\^\(-28\), 
            0.665245873\ 10\^\(-28\)\ "\<m\>"\^2}, \
\[IndentingNewLine]{"\<ElectronMagneticMoment\>", \*"\"\<\!\(\[Mu]\_e\)\>\"", 
            0.000080\ 10\^\(-26\), \(-928.476412\)\ 10\^\(-26\)\ "\<J\>"\ \
"\<T\>"\^\(-1\)}, \[IndentingNewLine]{"\<ElectronMagneticMomentAnomaly\>", \
\*"\"\<\!\(a\_e\)\>\"", 0.0000000038\ 10\^\(-3\), 
            1.1596521859\ 10\^\(-3\)}, \[IndentingNewLine]{"\<ElectronGFactor\
\>", \*"\"\<\!\(g\_e\)\>\"", 
            0.0000000000075, \(-2.0023193043718\)}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(\(--\(-\ A\)\) &\) 
                  N\  - \ \(Muon\  : \ \(\(\(\[Mu]\^-\)\ --\)\(-\)\)\)\ \
*) \[IndentingNewLine]"\<MuonMass\>", \*"\"\<\!\(m\_\[Mu]\)\>\"", 
            0.00000033\ 10\^\(-28\), 
            1.88353140\ 10\^\(-28\)\ "\<kg\>"}, \
\[IndentingNewLine]{"\<MuonComptonWavelength\>", \*"\"\<\!\(\[Lambda]\_\(C\_\
\[Mu]\)\)\>\"", 0.00000030\ 10\^\(-15\), 
            11.73444105\ 10\^\(-15\)\ "\<m\>"}, \
\[IndentingNewLine]{"\<MuonMagneticMoment\>", \*"\"\<\!\(\[Mu]\_\[Mu]\)\>\"", 
            0.00000040\ 10\^\(-26\), \(-4.49044799\)\ 10\^\(-26\)\ "\<J\>"\ "\
\<T\>"\^\(-1\)}, \[IndentingNewLine]{"\<MuonMagneticMomentAnomaly\>", \*"\"\<\
\!\(a\_\[Mu]\)\>\"", 0.00000062\ 10\^\(-3\), 
            1.16591981\ 10\^\(-3\)}, \[IndentingNewLine]{"\<MuonGFactor\>", \
\*"\"\<\!\(g\_\[Mu]\)\>\"", 
            0.0000000012, \(-2.0023318396\)}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(\(--\(-\ A\)\) &\) 
                  N\  - \ \(Tau\  : \ \(\(\(\[Tau]\^-\)\ --\)\(-\)\)\)\ \
*) \[IndentingNewLine]"\<TauMass\>", \*"\"\<\!\(m\_\[Tau]\)\>\"", 
            0.00052\ 10\^\(-27\), 
            
            3.16777\ 10\^\(-27\)\ "\<kg\>"}, \
\[IndentingNewLine]{"\<TauComptonWavelength\>", \*"\"\<\!\(\[Lambda]\_\(C\_\
\[Tau]\)\)\>\"", 0.69772\ 10\^\(-15\), 
            0.00011\ 10\^\(-15\)\ "\<m\>"}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(\(--\(-\ A\)\) &\) 
                  N\  - \ \(Proton\  : \ \(\(p\ --\)\(-\)\)\)\ \
*) \[IndentingNewLine]"\<ProtonMass\>", \*"\"\<\!\(m\_p\)\>\"", 
            0.00000029\ 10\^\(-27\), 
            1.67262171\ 10\^\(-27\)\ "\<kg\>"}, \
\[IndentingNewLine]{"\<ProtonComptonWavelength\>", \
\*"\"\<\!\(\[Lambda]\_\(C\_p\)\)\>\"", 0.0000000088\ 10\^\(-15\), 
            1.3214098555\ 10\^\(-15\)\ "\<m\>"}, \
\[IndentingNewLine]{"\<ProtonMagneticMoment\>", \*"\"\<\!\(\[Mu]\_p\)\>\"", 
            0.00000012\ 10\^\(-26\), 
            1.41060671\ 10\^\(-26\)\ "\<J\>"\ "\<T\>"\^\(-1\)}, \
\[IndentingNewLine]{"\<ProtonGFactor\>", \*"\"\<\!\(g\_p\)\>\"", 0.000000056, 
            5.585694701}, \[IndentingNewLine]{"\<ProtonGyromagneticRatio\>", \
\*"\"\<\!\(\[Gamma]\_p\)\>\"", 0.00000023\ 10\^8, 
            2.67522205\ 10\^8\ "\<s\>"\^\(-1\)\ "\<T\>"\^\(-1\)}, \
\[IndentingNewLine]\[IndentingNewLine]{ (*\ \(\(--\(-\ A\)\) &\) 
                  N\  - \ \(Neutron\  : \ \(\(n\ --\)\(-\)\)\)\ \
*) \[IndentingNewLine]"\<NeutronMass\>", \*"\"\<\!\(m\_n\)\>\"", 
            0.00000029\ 10\^\(-27\), 
            1.674\ 92728\ 10\^\(-27\)\ "\<kg\>"}, \
\[IndentingNewLine]{"\<NeutronComptonWavelength\>", \*"\"\<\!\(\[Lambda]\_\(C\
\_n\)\)\>\"", 0.0000000088\ 10\^\(-15\), 
            1.3195909067\ 10\^\(-15\)\ "\<m\>"}, \
\[IndentingNewLine]{"\<NeutronMagneticMoment\>", \*"\"\<\!\(\[Mu]\_n\)\>\"", 
            0.00000024\ 10\^\(-26\), \(-0.96623645\)\ 10\^\(-26\)\ "\<J\>"\ "\
\<T\>"\^\(-1\)}, \[IndentingNewLine]{"\<NeutronGFactor\>", \
\*"\"\<\!\(g\_n\)\>\"", 
            0.00000090, \(-3.82608546\)}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(\(--\(-\ A\)\) &\) 
                  N\  - \ \(Deuteron\  : \ \(\(d\ --\)\(-\)\)\)\ \
*) \[IndentingNewLine]"\<DeuteronMass\>", \*"\"\<\!\(m\_d\)\>\"", 
            0.00000057\ 10\^\(-27\), 
            3.34358335\ 10\^\(-27\)\ "\<kg\>"}, \
\[IndentingNewLine]{"\<DeuteronMagneticMoment\>", \*"\"\<\!\(\[Mu]\_d\)\>\"", 
            0.000000038\ 10\^\(-26\), 
            0.433073482\ 10\^\(-26\)\ "\<J\>"\ "\<T\>"\^\(-1\)}, \
\[IndentingNewLine]\[IndentingNewLine]{ (*\ \(\(--\(-\ A\)\) &\) 
                  N\  - \ \(Helion\  : \ \(\(h\ --\)\(-\)\)\)\ \
*) \[IndentingNewLine]"\<HelionMass\>", \*"\"\<\!\(m\_h\)\>\"", 
            0.00000086\ 10\^\(-27\), 
            5.00641214\ 10\^\(-27\)\ "\<kg\>"}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(\(--\(-\ A\)\) &\) 
                  N\  - \ \(Alpha\  : \ \(---\)\)\ \
*) \[IndentingNewLine]"\<AlphaParticleMass\>", \*"\"\<\!\(m\_\[Alpha]\)\>\"", 
            0.0000011\ 10\^\(-27\), 
            6.6446565\ 10\^\(-27\)\ "\<kg\>"}\[IndentingNewLine]\
\[IndentingNewLine]};\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(Unit[Constant, All] = 
        Module[{list}, \[IndentingNewLine]ListToRules[
              list @@ constants /. {a__, b_, c_} \[RuleDelayed] {a, c}] /. 
            list \[Rule] List];\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(UCR\)], "SubsubsectionIcon"],

Cell["Relative Uncertainty of constants", "Text"],

Cell[BoxData[{
    \(\(UCR[p_Symbol\_q__] := 
        UCR[Evaluate@
            ToString[p\_q, StandardForm]]\ ;\)\), "\[IndentingNewLine]", 
    \(\(UCR[x_Symbol\^m_. ] := 
        UCR[Evaluate@ts[x]];\)\), "\[IndentingNewLine]", 
    \(\({ListToRules[\(list @@ 
                  constants /. \[IndentingNewLine]{a___, b_, 
                    c_} \[RuleDelayed] {a, \((b /. \((0 \[Rule] 0. )\))\)}\) /. 
              list \[Rule] List] /. \[IndentingNewLine]\((a_ \[Rule] 
                b_)\) \[RuleDelayed] Set[UCR[a], UCR[b]]};\)\)}], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Unit[Table, All]\)], "SubsubsectionIcon"],

Cell[BoxData[
    \(\(Unit[Table, 
          All] = \[IndentingNewLine]Unit[Prefix, 
            All] \[Union] \[IndentingNewLine]Unit["\<Angle\>", 
            All] \[Union] \[IndentingNewLine]Unit["\<Temperature\>", 
            All] \[Union] \[IndentingNewLine]Unit[Constant, 
            All] \[Union] \[IndentingNewLine]ListToRules[\(\(\({\
\[IndentingNewLine]\[IndentingNewLine]{ (*\ \(\(--\(-\ 
                                  MKS\)\)\ \(DERIVED\ --\)\)\(-\)\ \
*) \[IndentingNewLine]"\<Farad\>", "\<F\>", "\<m\>"\^\(-2\)\ "\<kg\>"\^\(-1\)\
\ "\<s\>"\^4\ "\<A\>"\^2}, \[IndentingNewLine]{"\<Siemens\>", "\<mho\>", \
"\<Mho\>", "\<S\>", "\<m\>"\^\(-2\)\ "\<kg\>"\^\(-1\)\ "\<s\>"\^3\ \
"\<A\>"\^2}, \[IndentingNewLine]{"\<Volt\>", "\<V\>", \("\<m\>"\^2\) "\<kg\>"\
\ "\<s\>"\^\(-3\)\ "\<A\>"\^\(-1\)}, \[IndentingNewLine]{"\<Ohm\>", \
"\<Omega\>", "\<\[CapitalOmega]\>", "\<m\>"\^2\ "\<kg\>"\ "\<s\>"\^\(-3\)\ \
"\<A\>"\^\(-2\)}, \[IndentingNewLine]{"\<Joule\>", "\<J\>", "\<m\>"\^2\ "\<kg\
\>"\ "\<s\>"\^\(-2\)}, \[IndentingNewLine]{"\<Newton\>", "\<N\>", "\<m\>"\ \
"\<kg\>"\ "\<s\>"\^\(-2\)}, \[IndentingNewLine]{"\<Hertz\>", "\<Hz\>", \
"\<s\>"\^\(-1\)}, \[IndentingNewLine]{"\<Lux\>", "\<lx\>", \
\("\<m\>"\^\(-2\)\) "\<cd\>"\ "\<sr\>"\^\(-2\)}, \[IndentingNewLine]{"\<Lumen\
\>", "\<lm\>", "\<cd\>"\ "\<sr\>"}, \[IndentingNewLine]{"\<Weber\>", \
"\<Wb\>", "\<m\>"\^2\ "\<kg\>"\ "\<s\>"\^\(-2\)\ "\<A\>"\^\(-1\)}, \
\[IndentingNewLine]{"\<Tesla\>", "\<T\>", "\<kg\>"\ "\<s\>"\^\(-2\)\ \
"\<A\>"\^\(-1\)}, \[IndentingNewLine]{"\<Henry\>", "\<Hy\>", "\<H\>", "\<m\>"\
\^2\ "\<kg\>"\ "\<s\>"\^\(-2\)\ "\<A\>"\^\(-2\)}, \[IndentingNewLine]{"\<Watt\
\>", "\<W\>", "\<m\>"\^2\ "\<kg\>"\ "\<s\>"\^\(-3\)}, \
\[IndentingNewLine]{"\<Pascal\>", "\<Pa\>", "\<m\>"\^\(-1\)\ "\<kg\>"\ \
"\<s\>"\^\(-2\)}, \[IndentingNewLine]{"\<Couloumb\>", "\<C\>", "\<s\>"\ \
"\<A\>"}, \ \[IndentingNewLine]\[IndentingNewLine]{ (*\ \(\(--\(-\ 
                                  CGS\)\)\ \(DERIVED\ --\)\)\(-\)\ \
*) \[IndentingNewLine]"\<Galileo\>", "\<Gal\>", "\<gal\>", "\<cm\>"\ \
"\<s\>"\^\(-2\)}, \[IndentingNewLine]{"\<Erg\>", "\<erg\>", "\<cm\>"\^2\ \
"\<gr\>"\ "\<s\>"\^\(-2\)}, \[IndentingNewLine]{"\<Dyne\>", "\<dyn\>", \
"\<cm\>"\ "\<gr\>"\ "\<s\>"\^\(-2\)}, \[IndentingNewLine]{"\<Hertz\>", \
"\<Hz\>", "\<s\>"\^\(-1\)}, \[IndentingNewLine]{"\<Barye\>", "\<cm\>"\^\(-1\)\
\ "\<gr\>"\ "\<s\>"\^\(-2\)}, \[IndentingNewLine]{"\<Kyne\>", "\<cm\>"\ \
"\<s\>"\^\(-1\)}, \[IndentingNewLine]{"\<Poise\>", "\<P\>", "\<dyn\>"\ \
"\<s\>"\ "\<cm\>"\^\(-2\)}, \[IndentingNewLine]{"\<Stokes\>", "\<St\>", "\<cm\
\>"\^2\ "\<s\>"\^\(-1\)}, \[IndentingNewLine]{"\<Phot\>", "\<ph\>", "\<cd\>" \
"\<cm\>"\^\(-2\)\ "\<sr\>"\^\(-2\)}, \[IndentingNewLine]{"\<Stilb\>", \
"\<sb\>", "\<cd\>"\ "\<cm\>"\^\(-2\)}, \[IndentingNewLine]{"\<abWeber\>", \
"\<abWb\>", "\<Maxwell\>", "\<Mx\>", 
                        10\ "\<cm\>"\^2\ "\<gr\>"\ "\<s\>"\^\(-2\)\ "\<A\>"\^\
\(-1\)}, \[IndentingNewLine]{"\<abTesla\>", "\<abT\>", "\<Gauss\>", "\<Gs\>", \
"\<Mx\>"\ "\<cm\>"\^\(-2\)}, \[IndentingNewLine]{"\<Oersted\>", "\<Oe\>", \ 
                        0.79577472\ "\<A\>" "\<cm\>"\^\(-1\)}, \
\[IndentingNewLine]\[IndentingNewLine]{ (*\ \(\(--\(-\ 
                                  FPS\)\)\ \(DERIVED\ --\)\)\(-\)\ \
*) \[IndentingNewLine]"\<Horsepower\>", "\<HP\>", 
                        0.745700\ 10\^3\ "\<W\>"}, \
\[IndentingNewLine]{"\<PoundWeight\>", "\<PoundForce\>", "\<lbf\>", 
                        4.44822\ "\<N\>"}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(--\(-\ \(TIME\ --\)\)\)\(-\)\ \
*) \[IndentingNewLine]"\<Minute\>", "\<min\>", 
                        60\ "\<s\>"}, \[IndentingNewLine]{"\<Hour\>", \
"\<hr\>", "\<h\>", 60\ "\<min\>"}, \[IndentingNewLine]{"\<Day\>", "\<d\>", 
                        24\ "\<h\>"}, \[IndentingNewLine]{"\<Week\>", 
                        7\ "\<d\>"}, \[IndentingNewLine]{"\<Fortnight\>", 
                        2\ "\<Week\>"}, \[IndentingNewLine]{"\<Year\>", "\<yr\
\>", 365\ "\<d\>"}, \[IndentingNewLine]{"\<Month\>", "\<yr\>"/
                          12}, \[IndentingNewLine]{"\<Decade\>", 
                        10\ "\<yr\>"}, \[IndentingNewLine]{"\<Century\>", 
                        100\ "\<yr\>"}, \[IndentingNewLine]{"\<Millennium\>", 
                        1000\ "\<yr\>"}, \
\[IndentingNewLine]{"\<SiderealYear\>", 
                        365.25636\ "\<d\>"}, \
\[IndentingNewLine]{"\<TropicalYear\>", 
                        365.24219\ "\<d\>"}, \
\[IndentingNewLine]{"\<SiderealSecond\>", 
                        0.9972696\ "\<s\>"}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(--\(-\ \(ANGLES\ --\)\)\)\(-\)\ \
*) \[IndentingNewLine]"\<Degree\>", "\<deg\>", \[Pi]/
                            180\ "\<rad\>"}, \[IndentingNewLine]{"\<ArcMinute\
\>", 1/60\ "\<deg\>"}, \[IndentingNewLine]{"\<ArcSecond\>", 
                        1/60\ "\<ArcMinute\>"}, \
\[IndentingNewLine]{"\<ArcHour\>", \[Pi]/
                            12\ "\<rad\>"}, \[IndentingNewLine]{"\<Gon\>", \
\[Pi]/200\ "\<rad\>"}, \[IndentingNewLine]{"\<Revolution\>", "\<rev\>", 
                        2  \[Pi]\ "\<rad\>"}, \
\[IndentingNewLine]{"\<Circle\>", 
                        2\ \[Pi]\ "\<rad\>"}, \
\[IndentingNewLine]{"\<Semicircle\>", \[Pi]\ "\<rad\>"}, \
\[IndentingNewLine]{"\<Quadrant\>", "\<RightAngle\>", \[Pi]/
                            2\ "\<rad\>"}, \[IndentingNewLine]{"\<Point\>", \
\[Pi]/16\ "\<rad\>"}, \[IndentingNewLine]{"\<AngularMil\>", 
                        1/1000\ "\<rad\>"}, \[IndentingNewLine]{"\<MilitarMil\
\>", \[Pi]/
                            3200\ "\<rad\>"}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(--\(-\ \(LENGTH\ --\)\)\)\(-\)\ \
*) \[IndentingNewLine]"\<Angstrom\>", "\<\[CapitalARing]\>", \(10\^\(-10\)\) \
"\<m\>"}, \[IndentingNewLine]{"\<Fermi\>", \(10\^\(-15\)\) "\<m\>"}, \
\[IndentingNewLine]{"\<Micron\>", \(10\^\(-6\)\) "\<m\>"}, \
\[IndentingNewLine]{"\<AstronomicalUnit\>", "\<AU\>", 
                        1.4959787066\ 10\^11\ "\<m\>"}, \[IndentingNewLine]{"\
\<Parsec\>", "\<pc\>", 
                        30857\ 10\^12\ "\<m\>"}, \
\[IndentingNewLine]{"\<LightYear\>", "\<ly\>", 
                        9.46073\ 10\^15\ "\<m\>"}, \
\[IndentingNewLine]{"\<DidotPoint\>", "\<Didot\>", "\<m\>"/
                          2660}, \[IndentingNewLine]{"\<Cicero\>", 
                        12\ "\<Didot\>"}, \[IndentingNewLine]{"\<Inch\>", \
"\<in\>", 2.54\ "\<cm\>"}, \[IndentingNewLine]{"\<Mil\>", "\<in\>"/
                          1000}, \[IndentingNewLine]{"\<Caliber\>", "\<in\>"/
                          100}, \[IndentingNewLine]{"\<Hand\>", 
                        4\ "\<in\>"}, \[IndentingNewLine]{"\<Link\>", 
                        7.92\ "\<in\>"}, \[IndentingNewLine]{"\<Span\>", 
                        9\ "\<in\>"}, \[IndentingNewLine]{"\<Cubit\>", 
                        18\ "\<in\>"}, \[IndentingNewLine]{"\<Ell\>", 
                        45\ "\<in\>"}, \[IndentingNewLine]{"\<Point\>", 
                        1/72\ "\<in\>"}, \[IndentingNewLine]{"\<Pica\>", 
                        12\ "\<Point\>"}, \
\[IndentingNewLine]{"\<PrintersPoint\>", 
                        0.013837\ "\<in\>"}, \
\[IndentingNewLine]{"\<Fathom\>", 
                        6\ "\<ft\>"}, \[IndentingNewLine]{"\<Rope\>", 
                        20\ "\<ft\>"}, \[IndentingNewLine]{"\<Chain\>", 
                        66\ "\<ft\>"}, \[IndentingNewLine]{"\<Cable\>", 
                        720\ "\<ft\>"}, \[IndentingNewLine]{"\<Skein\>", 
                        360\ "\<ft\>"}, \[IndentingNewLine]{"\<Stadion\>", 
                        622\ "\<ft\>"}, \[IndentingNewLine]{"\<Yard\>", "\<yd\
\>", 3\ "\<ft\>"}, \[IndentingNewLine]{"\<Bolt\>", 
                        40\ "\<yd\>"}, \[IndentingNewLine]{"\<Furlong\>", 
                        220\ "\<yd\>"}, \[IndentingNewLine]{"\<Stadium\>", 
                        202\ "\<yd\>"}, \[IndentingNewLine]{"\<Rod\>", 
                        5.5\ "\<yd\>"}, \[IndentingNewLine]{"\<Pole\>", \
"\<Rod\>"}, \[IndentingNewLine]{"\<Perch\>", "\<Rod\>"}, \
\[IndentingNewLine]{"\<SurveyMile\>", 
                        320\ "\<Rod\>"}, \
\[IndentingNewLine]{"\<StatuteMile\>", "\<Mile\>", "\<mi\>", 
                        5280\ "\<ft\>"}, \[IndentingNewLine]{"\<League\>", 
                        3\ "\<Mile\>"}, \
\[IndentingNewLine]{"\<NauticalMile\>", "\<nm\>", 
                        1.852\ 10\^3\ "\<m\>"}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(--\(-\ \(AREA\ --\)\)\)\(-\)\ \
*) \[IndentingNewLine]"\<Barn\>", 
                        10\^\(-28\)\ "\<m\>"\^2}, \[IndentingNewLine]{"\<Shed\
\>", \(10\^\(-52\)\) "\<m\>"\^2}, \[IndentingNewLine]{"\<Are\>", 
                        100\ "\<m\>"\^2}, \[IndentingNewLine]{"\<Hectare\>", \
"\<ha\>", 100\ "\<Are\>"}, \[IndentingNewLine]{"\<CircularMile\>", \[Pi]/
                            4\ \(10\^\(-6\)\) "\<in\>"\^2}, \
\[IndentingNewLine]{"\<Rood\>", 
                        1/4\ "\<Acre\>"}, \[IndentingNewLine]{"\<Acre\>", 
                        10\ "\<Chain\>"\^2}, \[IndentingNewLine]{"\<Lot\>", 
                        1/10\ "\<mi\>"\^2}, \
\[IndentingNewLine]{"\<Section\>", "\<mi\>"\^2}, \
\[IndentingNewLine]{"\<Township\>", 
                        36 "\<mi\>"\^2}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(--\(-\ \(VOLUME\ --\)\)\)\(-\)\ \
*) \[IndentingNewLine]"\<Liter\>", "\<L\>", "\<l\>", \(10\^\(-3\)\) \
"\<m\>"\^3}, \[IndentingNewLine]{"\<Stere\>", "\<st\>", "\<m\>"\^3}, \
\[IndentingNewLine]{"\<Barrel\>", "\<bbl\>", 
                        0.1590\ "\<m\>"\^3}, \[IndentingNewLine]{"\<Drop\>", 
                        0.03\ 10\^\(-6\)\ "\<m\>"\^3}, \
\[IndentingNewLine]{"\<Cord\>", 
                        128\ "\<ft\>"\^3}, \[IndentingNewLine]{"\<RegisterTon\
\>", 100\ "\<ft\>"\^3}, \[IndentingNewLine]{"\<BoardFoot\>", 
                        144\ "\<in\>"\^3}, \[IndentingNewLine]{"\<UKPint\>", \
"\<ImperialPint\>", "\<ipt\>", 
                        0.568261\ "\<L\>"}, \[IndentingNewLine]{"\<WineBottle\
\>", 0.7576778\ "\<L\>"}, \[IndentingNewLine]{"\<Last\>", 
                        2909.414\ "\<L\>"}, \
\[IndentingNewLine]{"\<UKGallon\>", "\<ImperialGallon\>", "\<impgal\>", 
                        4.54609\ "\<L\>"}, \[IndentingNewLine]{"\<Firkin\>", 
                        9\ "\<UKGallon\>"}, \[IndentingNewLine]{"\<Cup\>", 
                        0.236588\ "\<L\>"}, \[IndentingNewLine]{"\<Pint\>", "\
\<pt\>", 2\ "\<Cup\>"}, \[IndentingNewLine]{"\<FluidOunce\>", "\<Shot\>", 
                        1/16\ "\<Pint\>"}, \[IndentingNewLine]{"\<Minim\>", "\
\<FluidOunce\>"/480}, \[IndentingNewLine]{"\<Jigger\>", 
                        1.5\ "\<Shot\>"}, \[IndentingNewLine]{"\<Pony\>", 
                        0.5\ "\<Jigger\>"}, \
\[IndentingNewLine]{"\<FluidDram\>", 
                        1/8\ "\<FluidOunce\>"}, \
\[IndentingNewLine]{"\<Tablespoon\>", 
                        4\ "\<FluidDram\>"}, \
\[IndentingNewLine]{"\<Teaspoon\>", "\<Tablespoon\>"/
                          3}, \[IndentingNewLine]{"\<Noggin\>", "\<Gill\>", 
                        1/4\ "\<Pint\>"}, \[IndentingNewLine]{"\<Quart\>", 
                        2\ "\<Pint\>"}, \[IndentingNewLine]{"\<Fifth\>", 
                        4/5\ "\<Quart\>"}, \[IndentingNewLine]{"\<Magnum\>", 
                        2\ "\<Quart\>"}, \[IndentingNewLine]{"\<Gallon\>", \
"\<gal\>", 4\ "\<Quart\>"}, \[IndentingNewLine]{"\<Jeroboam\>", 
                        4/5\ "\<Gallon\>"}, \[IndentingNewLine]{"\<Bucket\>", 
                        4\ "\<Gallon\>"}, \[IndentingNewLine]{"\<Puncheon\>", 
                        84\ "\<Gallon\>"}, \[IndentingNewLine]{"\<Butt\>", 
                        126\ "\<Gallon\>"}, \
\[IndentingNewLine]{"\<Hogshead\>", "\<Butt\>"/
                          2}, \[IndentingNewLine]{"\<Tun\>", 
                        4\ "\<Hogshead\>"}, \[IndentingNewLine]{"\<Peck\>", 
                        8.810\ "\<L\>"}, \[IndentingNewLine]{"\<Omer\>", 
                        0.45\ "\<Peck\>"}, \[IndentingNewLine]{"\<Ephah\>", 
                        10\ "\<Omer\>"}, \[IndentingNewLine]{"\<Bushel\>", 
                        4\ "\<Peck\>"}, \[IndentingNewLine]{"\<Seam\>", 
                        8\ "\<Bushel\>"}, \[IndentingNewLine]{"\<Bag\>", 
                        3\ "\<Bushel\>"}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(--\(-\ \(MASS\ --\)\)\)\(-\)\ \
*) \[IndentingNewLine]"\<Quintal\>", 
                        100000\ "\<gr\>"}, \
\[IndentingNewLine]{"\<SolarMass\>", 
                        1.9891\ 10\^33\ "\<gr\>"}, \
\[IndentingNewLine]{"\<Dalton\>", "\<AtomicMassUnit\>", "\<AMU\>", 
                        1.6605402\ 10\^\(-24\)\ "\<gr\>"}, \
\[IndentingNewLine]{"\<AssayTon\>", 
                        29.167\ "\<gr\>"}, \[IndentingNewLine]{"\<Grain\>", 
                        64.799\ 10\^\(-3\)\ "\<gr\>"}, \
\[IndentingNewLine]{"\<Carat\>", 
                        0.2\ "\<gr\>"}, \[IndentingNewLine]{"\<Shekel\>", 
                        14.1\ "\<gr\>"}, \[IndentingNewLine]{"\<Obolos\>", 
                        715.38\ 10\^\(-3\)\ "\<gr\>"}, \
\[IndentingNewLine]{"\<Drachma\>", 
                        4.2923\ "\<gr\>"}, \[IndentingNewLine]{"\<Libra\>", 
                        325.971\ "\<gr\>"}, \
\[IndentingNewLine]{"\<TroyOunce\>", 
                        31.103\ "\<gr\>"}, \[IndentingNewLine]{"\<Pennyweight\
\>", 1.555\ "\<gr\>"}, \[IndentingNewLine]{"\<MetricTon\>", "\<Tonne\>", "\<t\
\>", 10\^6\ "\<gr\>"}, \[IndentingNewLine]{"\<Pondus\>", 
                        0.71864\ "\<lb\>"}, \[IndentingNewLine]{"\<Stone\>", 
                        14\ "\<lb\>"}, \[IndentingNewLine]{"\<Wey\>", 
                        252\ "\<lb\>"}, \[IndentingNewLine]{"\<Bale\>", 
                        500\ "\<lb\>"}, \[IndentingNewLine]{"\<Ton\>", 
                        2240\ "\<lb\>"}, \[IndentingNewLine]{"\<Cental\>", \
"\<NetHundredweight\>", "\<ShortHundredweight\>", 
                        100\ "\<lb\>"}, \
\[IndentingNewLine]{"\<GrossHundredweight\>", "\<Hundredweight\>", "\<cwt\>", 
                        112\ "\<lb\>"}, \[IndentingNewLine]{"\<ShortTon\>", 
                        2000\ "\<lb\>"}, \[IndentingNewLine]{"\<Mina\>", 
                        0.9463\ "\<lb\>"}, \[IndentingNewLine]{"\<Talent\>", 
                        60\ "\<Mina\>"}, \
\[IndentingNewLine]{"\<AvoirdupoisOunce\>", "\<Ounce\>", "\<oz\>", 
                        28.3495\ "\<gr\>"}, \
\[IndentingNewLine]{"\<Geepound\>", "\<Slug\>", 
                        
                        14.5939\ "\<kg\>"}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(--\(-\ \(FORCE\ --\)\)\)\(-\)\ \
*) \[IndentingNewLine]"\<TonForce\>", 
                        9.96402\ 10\^3\ "\<N\>"}, \
\[IndentingNewLine]{"\<KilogramWeight\>", "\<KilogramForce\>", 
                        9.80665\ "\<N\>"}, \
\[IndentingNewLine]{"\<GramWeight\>", "\<GramForce\>", "\<KilogramWeight\>"/
                          1000}, \[IndentingNewLine]{"\<Poundal\>", \
"\<pdl\>", 
                        0.138255\ "\<N\>"}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(--\(-\ \(PRESSURE\ --\)\)\)\(-\)\ \
*) \[IndentingNewLine]"\<Atmosphere\>", "\<atm\>", 
                        0.101325\ 10\^6\ "\<Pa\>"}, \
\[IndentingNewLine]{"\<InchMercury\>", "\<inHg\>", 
                        3.38639\ 10\^3\ "\<Pa\>"}, \[IndentingNewLine]{"\<Bar\
\>", 10\^5\ "\<Pa\>"}, \[IndentingNewLine]{"\<PoundsPerSquareInch\>", \
"\<PSI\>", 
                        6.894757\ 10\^3\ "\<Pa\>"}, \
\[IndentingNewLine]{"\<MillimeterMercury\>", "\<mmHg\>", "\<Torricheli\>", \
"\<Tor\>", 
                        1.33322\ 10\^2\ "\<Pa\>"}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(--\(-\ \(ENERGY\ --\)\)\)\(-\)\ \
*) \[IndentingNewLine]"\<Rydberg\>", 
                        2.1799\ 10\^\(-11\)\ "\<erg\>"}, \
\[IndentingNewLine]{"\<ElectronVolt\>", "\<eV\>", 
                        0.160217733\ 10\^\(-18\)\ "\<J\>"}, \
\[IndentingNewLine]{"\<Calorie\>", "\<cal\>", 
                        4.1868\ "\<J\>"}, \
\[IndentingNewLine]{"\<BritishThermalUnit\>", "\<BTU\>", "\<Btu\>", 
                        1.05506\ 10\^3\ "\<J\>"}, \
\[IndentingNewLine]{"\<Therm\>", 
                        10\^5\ "\<BTU\>"}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(--\(-\ \(POWER\ --\)\)\)\(-\)\ \
*) \[IndentingNewLine]"\<ChevalVapeur\>", "\<CV\>", 
                        0.735499\ 10\^3\ "\<W\>"}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(\(--\(-\ 
                                  VISCOSITY\)\)\ \(variet\[EAcute]e\ \
--\)\)\(-\)\ *) \[IndentingNewLine]"\<Rhes\>", "\<Poise\>"\^\(-1\)}, \
\[IndentingNewLine]{"\<Reyn\>", "\<lbf\>"\ "\<s\>"\ "\<in\>"\^\(-2\)}, \
\[IndentingNewLine]\[IndentingNewLine]{ (*\ \(\(--\(-\ 
                                  LIGHT\)\)\ \(variet\[EAcute]e\ --\)\)\(-\)\ \
*) \[IndentingNewLine]"\<Nit\>", "\<cd\>"\ "\<m\>"\^\(-2\)}, \
\[IndentingNewLine]{"\<Hefner\>", 
                        0.92\ "\<cd\>"}, \[IndentingNewLine]{"\<Candle\>", \
"\<cd\>"}, \[IndentingNewLine]{"\<FootCandle\>", "\<lx\>"\ "\<m\>"\^2\ \
"\<ft\>"\^\(-2\)}, \[IndentingNewLine]{"\<Lambert\>", \((10\^4/
                              Pi)\)\ "\<lm\>"\ "\<m\>"\^\(-2\)}, \
\[IndentingNewLine]{"\<Apostilb\>", 
                        10\^\(-4\)\ "\<Lambert\>"}, \
\[IndentingNewLine]{"\<Talbot\>", "\<lm\>"\ "\<s\>"}, \
\[IndentingNewLine]{"\<Lumerg\>", "\<Talbot\>"}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(\(--\(-\ 
                                  ESU\)\)\  &\)\ EMU\ *) \[IndentingNewLine]"\
\<Gilbert\>", "\<Gb\>", 
                        1/\((4\ Pi)\)\ 10\ "\<A\>"}, \
\[IndentingNewLine]{"\<AbAmpere\>", "\<abA\>", "\<Biot\>", "\<Bi\>", 
                        10\ "\<A\>"}, \[IndentingNewLine]{"\<StatAmpere\>", "\
\<statA\>", 
                        3.335635\ 10\^\(-10\)\ "\<A\>"}, \
\[IndentingNewLine]{"\<AbOhm\>", "\<abOhm\>", "\<ab\[CapitalOmega]\>", 
                        10\^\(-9\)\ "\<\[CapitalOmega]\>"}, \
\[IndentingNewLine]{"\<StatOhm\>", "\<statOhm\>", "\<stat\[CapitalOmega]\>", 
                        8.987584\ 10\^11\ "\<\[CapitalOmega]\>"}, \
\[IndentingNewLine]{"\<AbMho\>", "\<abmho\>", "\<abSiemens\>", "\<abS\>", 
                        10\^9\ "\<S\>"}, \[IndentingNewLine]{"\<StatMho\>", "\
\<statmho\>", "\<statSiemens\>" "\<StatS\>", 
                        1.1126\ 10\^\(-12\)\ "\<S\>"}, \
\[IndentingNewLine]{"\<AbCoulomb\>", "\<abC\>", 
                        10\ "\<C\>"}, \[IndentingNewLine]{"\<StatCoulomb\>", \
"\<statC\>", 
                        3.335635\ 10\^\(-10\)\ "\<C\>"}, \
\[IndentingNewLine]{"\<AbFarad\>", "\<abF\>", 
                        10\^9\ "\<F\>"}, \[IndentingNewLine]{"\<StatFarad\>", \
"\<statF\>", 
                        1.112646\ 10\^\(-12\)\ "\<F\>"}, \
\[IndentingNewLine]{"\<AbHenry\>", "\<abH\>", "\<abHy\>", 
                        10\^\(-9\)\ "\<H\>"}, \
\[IndentingNewLine]{"\<StatHenry\>", "\<statH\>", "\<statHy\>", 
                        8.987584\ 10\^11\ "\<H\>"}, \
\[IndentingNewLine]{"\<AbVolt\>", "\<abV\>", 
                        10\^\(-8\)\ "\<V\>"}, \[IndentingNewLine]{"\<StatVolt\
\>", "\<statV\>", 299.7930\ "\<V\>"}, \[IndentingNewLine]{"\<Gamma\>", 
                        10\^\(-9\)\ "\<T\>"}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(--\(-\ \(INFORMATION\ --\)\)\)\(-\)\ \
*) \[IndentingNewLine]"\<Byte\>", 
                        8\ "\<Bit\>"}, \[IndentingNewLine]{"\<Nibble\>", 
                        4\ "\<Bit\>"}, \[IndentingNewLine]{"\<Baud\>", "\<Bit\
\>"/"\<Second\>"}, \[IndentingNewLine]\[IndentingNewLine]{ (*\ \(\(\(--\(-\ 
                                    RADIOACTIVITY\)\)\  &\)\ MEDICAL\ \
\(variet\[EAcute]e\ --\)\)\(-\)\ *) \[IndentingNewLine]"\<Rad\>", 
                        0.01\ "\<Gray\>"}, \[IndentingNewLine]{"\<Gray\>", \
"\<gy\>", "\<J\>"\ "\<kg\>"\^\(-1\)}, \[IndentingNewLine]{"\<Rutherford\>", 
                        10\^6\ "\<s\>"\^\(-1\)}, \
\[IndentingNewLine]{"\<Becquerel\>", "\<s\>"\^\(-1\)}, \
\[IndentingNewLine]{"\<Curie\>", "\<Ci\>", 
                        37\ 10\^9\ "\<Becquerel\>"}, \
\[IndentingNewLine]{"\<Rontgen\>", "\<Roentgen\>", 
                        0.258\ 10\^\(-3\)\ "\<C\>" "\<kg\>"\^\(-1\)}, \
\[IndentingNewLine]{"\<GramsRadiation\>", "\<rd\>", \(10\^\(-2\)\) "\<gy\>"}, \
\[IndentingNewLine]{"\<Sievert\>", "\<Sv\>", "\<J\>"\ "\<kg\>"\^\(-1\)}, \
\[IndentingNewLine]{"\<Rems\>", \(10\^\(-2\)\) "\<Sv\>"}, \[IndentingNewLine]\
\[IndentingNewLine]{ (*\ \(\(--\(-\ 
                                  ANGULAR\)\)\ \(SPEED\ --\)\)\(-\)\ \
*) \[IndentingNewLine]"\<RevolutionsPerMinute\>", "\<rpm\>", 
                        2  \[Pi]\ "\<rad\>"\ "\<min\>"\^\(-1\)}, \
\[IndentingNewLine]\[IndentingNewLine]{ (*\ \(--\(-\ \(FITNESS\ --\)\)\)\(-\)\
\ *) \[IndentingNewLine]"\<Denier\>", 
                        1/9000\ "\<gr\>"\ "\<m\>"\^\(-1\)}, \
\[IndentingNewLine]\[IndentingNewLine]{ (*\ \(--\(-\ \(SPEED\ --\)\)\)\(-\)\
*) \[IndentingNewLine]"\<Knot\>", "\<NauticalMile\>"/"\<h\>"}, \
\[IndentingNewLine]\[IndentingNewLine]{ (*\ \(\(--\(-\ 
                                  INVERSE\)\)\ \(LENGTH\ --\)\)\(-\)\ \
*) \[IndentingNewLine]"\<Kayser\>", 
                        100\ "\<m\>"\^\(-1\)}, \[IndentingNewLine]{"\<Diopter\
\>", "\<m\>"\^\(-1\)}, \[IndentingNewLine]\[IndentingNewLine]{ (*\ \(--\(-\ \
\(ACTION\ --\)\)\)\(-\)\ *) \[IndentingNewLine]"\<Planck\>", "\<J\>"\ \
"\<s\>"}\[IndentingNewLine]\[IndentingNewLine]} //. "\<ft\>" \[Rule] \
\(1524\/5000\) "\<m\>"\) //. "\<lb\>" \[Rule] \(5000000\/11023113\) \
"\<kg\>"\) //. \[IndentingNewLine]"\<cm\>" \[Rule] \(10\^\(-2\)\) "\<m\>"\) //. \
"\<gr\>" \[Rule] \(10\^\(-3\)\) "\<kg\>"];\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Unit - Simplify\ rules\)], "SubsubsectionIcon"],

Cell[BoxData[
    \(\(\( (*\ \(===\)\(\ \)\(Some\ little\ simplifications\)\ *) \)\(\
\[IndentingNewLine]\)\(\[IndentingNewLine]\)\( (*\ \(--\(-\ 
            CoDomain\)\)\ of\ Unit\ function\ \
*) \)\(\[IndentingNewLine]\)\(\(Unit /: Unit[_] \[Element] Reals := 
        True;\)\[IndentingNewLine]
    \(Unit /: Unit[_] > 0 := True;\)\[IndentingNewLine]
    \(Unit /: Unit[_] \[GreaterEqual] 0 := True;\)\[IndentingNewLine]
    \(Unit /: Unit[_] < 0 := False;\)\[IndentingNewLine]
    \(Unit /: Unit[_] \[LessEqual] 0 := 
        False;\)\[IndentingNewLine]\[IndentingNewLine] (*\ \(--\(-\ 
            Test\)\)\ Functions\ *) \[IndentingNewLine]
    \(Unit /: Positive[Unit[_]] := True;\)\[IndentingNewLine]
    \(Unit /: NonNegative[Unit[_]] := True;\)\[IndentingNewLine]
    \(Unit /: Negative[Unit[_]] := False;\)\[IndentingNewLine]
    \(Unit /: NonPositive[Unit[_]] := 
        False;\)\[IndentingNewLine]\[IndentingNewLine] (*\ \(===\)\(\ \
\)\(Mathematical\ Functions\)\ *) \[IndentingNewLine]\[IndentingNewLine] (*\ \
\(--\(-\ Numerical\)\)\ Functions\ *) \[IndentingNewLine]
    \(Unit /: Abs[Unit[x_]] := Unit[x];\)\[IndentingNewLine]
    \(Unit /: Sign[Unit[x_]] := 1;\)\[IndentingNewLine]
    \(Unit /: Round[Unit[x_]] := Unit[x];\)\[IndentingNewLine]
    \(Unit /: IntegerPart[Unit[x_]] := Unit[x];\)\[IndentingNewLine]
    \(Unit /: FractionalPart[Unit[x_]] := Unit[x];\)\[IndentingNewLine]
    \(Unit /: Ceiling[Unit[x_]] := Unit[x];\)\[IndentingNewLine]
    \(Unit /: Floor[Unit[x_]] := Unit[x];\)\[IndentingNewLine]
    \(Unit /: Re[Unit[x_]] := Unit[x];\)\[IndentingNewLine]
    \(Unit /: Conjugate[Unit[x_]] := Unit[x];\)\[IndentingNewLine]
    \(Unit /: Im[Unit[x_]] := 0;\)\[IndentingNewLine]
    \(Unit /: Arg[Unit[x_]] := 
        0;\)\[IndentingNewLine]\[IndentingNewLine] (*\ \(--\(-\ 
            Vectorial\)\)\ Functions\ *) \[IndentingNewLine]
    \(Unit /: Norm[Unit[x_]] := Unit[x];\)\[IndentingNewLine]
    \(Unit /: Dot[a_, Unit[x_]] := a\ Unit[x];\)\[IndentingNewLine]
    \(Unit /: Dot[Unit[x_], a_] := a\ Unit[x];\)\[IndentingNewLine]
    \(Unit /: Cross[a_, Unit[x_]] := a\ Unit[x];\)\[IndentingNewLine]
    \(Unit /: Cross[Unit[x_], a_] := a\ Unit[x];\)\)\)\)], "Input",
  InitializationCell->True]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Package Endings", "SubsectionIcon"],

Cell[CellGroupData[{

Cell[BoxData[
    \($unit\)], "SubsubsectionIcon"],

Cell[TextData[{
  Cell[BoxData[
      \($unit\)]],
  " give the default unit system. Here to be ",
  Cell[BoxData[
      \($unit\)]],
  " clean symbol"
}], "Text"],

Cell[BoxData[
    \(\(\( (*\ \(--\(-\ $unit\)\)\ *) \)\(\[IndentingNewLine]\)\(\
\[IndentingNewLine]\)\(\(Unit["\<System\>", 
          Default] := $unit;\)\[IndentingNewLine]
    \($unit := \[IndentingNewLine]If[
          ValueQ[$Unit] \[And] 
            UnitQ[$Unit, "\<System\>"], \[IndentingNewLine]$Unit, \
\[IndentingNewLine]Unit[Set, UnitMKS]; $Unit];\)\)\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Call\ Unit[Set, All]\)], "SubsubsectionIcon"],

Cell[BoxData[{
    \(\(table = Dispatch@Unit[Table, All];\)\), "\[IndentingNewLine]", 
    \(\(Unit[Set, All];\)\)}], "Input",
  InitializationCell->True,
  FormatType->TraditionalForm]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(End\ Private\)], "SubsubsectionIcon"],

Cell[BoxData[
    \(\(End[];\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Protect\ functions\)], "SubsubsectionIcon"],

Cell[BoxData[{
    \(\(\(SetAttributes[#, {ReadProtected, 
              Protected}] &\) /@ {\[IndentingNewLine]Unit, $Unit, 
          UnitQ, \[IndentingNewLine]UnitD, UnitN, UnitK, UnitS, 
          UnitI, \[IndentingNewLine]UnitConvert, 
          UnitSimplify, \[IndentingNewLine]UnitFullSimplify, UnitPowerExpand, 
          UnitComplexExpand, \[IndentingNewLine]UnitDIM, UnitMKS, UnitCGS, 
          UnitFPS};\)\), "\[IndentingNewLine]", 
    \(\(\(SetAttributes[#, {Protected}] &\) /@ {\[IndentingNewLine]Angle, 
          Temperature, \[IndentingNewLine]Base, Derived, 
          Combined, \[IndentingNewLine]Equivalence, 
          System, \[IndentingNewLine]Author};\)\)}], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(End\ the\ Package\)], "SubsubsectionIcon"],

Cell[BoxData[{
    \(\(\(EndPackage[ (*"\<adMath`Unit`\>"*) ];\)\(\[IndentingNewLine]\)
    \)\), "\[IndentingNewLine]", 
    \( (*\ \(\(--\(-\ \((c)\)\)\)\ 2004\ Alvaro\ D\[IAcute]az\ \(Falconi\ \
--\)\)\(-\)\ *) \)}], "Input",
  InitializationCell->True]
}, Closed]]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"5.0 for Microsoft Windows",
ScreenRectangle->{{0, 800}, {0, 547}},
AutoGeneratedPackage->Automatic,
WindowSize->{704, 346},
WindowMargins->{{27, Automatic}, {Automatic, 71}},
ShowCellLabel->False,
StyleDefinitions -> "HelpBrowser.nb"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "Message"->{
    Cell[18216, 504, 241, 5, 49, "Input",
      InitializationCell->True,
      CellTags->"Message"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"Message", 136695, 3004}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 46, 0, 64, "Subtitle"],
Cell[1825, 55, 65, 0, 25, "Packages"],

Cell[CellGroupData[{
Cell[1915, 59, 44, 0, 39, "SubsectionIcon"],

Cell[CellGroupData[{
Cell[1984, 63, 57, 1, 26, "SubsubsectionIcon"],
Cell[2044, 66, 56, 3, 51, "Input"],
Cell[2103, 71, 78, 3, 51, "Input"],
Cell[2184, 76, 109, 3, 51, "Input"],
Cell[2296, 81, 59, 3, 51, "Input"],
Cell[2358, 86, 62, 3, 51, "Input"],
Cell[2423, 91, 73, 3, 51, "Input"],
Cell[2499, 96, 274, 10, 191, "Input"],
Cell[2776, 108, 326, 9, 151, "Input"],
Cell[3105, 119, 6535, 92, 1389, "Input"],
Cell[9643, 213, 1605, 37, 691, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[11285, 255, 59, 1, 22, "SubsubsectionIcon"],
Cell[11347, 258, 102, 2, 29, "Input",
  InitializationCell->True],
Cell[11452, 262, 120, 4, 25, "Text"],
Cell[11575, 268, 414, 9, 89, "Input",
  InitializationCell->True],
Cell[11992, 279, 21, 0, 25, "Text"],
Cell[12016, 281, 277, 7, 69, "Input",
  InitializationCell->True],
Cell[12296, 290, 59, 0, 25, "Text"],
Cell[12358, 292, 527, 9, 189, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[12922, 306, 59, 1, 22, "SubsubsectionIcon"],
Cell[12984, 309, 72, 4, 25, "Text"],
Cell[13059, 315, 486, 10, 189, "Input",
  InitializationCell->True],
Cell[13548, 327, 73, 4, 25, "Text"],
Cell[13624, 333, 568, 12, 209, "Input",
  InitializationCell->True],
Cell[14195, 347, 73, 4, 25, "Text"],
Cell[14271, 353, 142, 3, 29, "Input",
  InitializationCell->True],
Cell[14416, 358, 73, 4, 25, "Text"],
Cell[14492, 364, 208, 4, 49, "Input",
  InitializationCell->True],
Cell[14703, 370, 73, 4, 25, "Text"],
Cell[14779, 376, 187, 3, 49, "Input",
  InitializationCell->True],
Cell[14969, 381, 73, 4, 25, "Text"],
Cell[15045, 387, 201, 4, 69, "Input",
  InitializationCell->True],
Cell[15249, 393, 73, 4, 25, "Text"],
Cell[15325, 399, 194, 4, 69, "Input",
  InitializationCell->True],
Cell[15522, 405, 73, 4, 25, "Text"],
Cell[15598, 411, 329, 6, 109, "Input",
  InitializationCell->True],
Cell[15930, 419, 79, 4, 25, "Text"],
Cell[16012, 425, 251, 4, 89, "Input",
  InitializationCell->True],
Cell[16266, 431, 80, 4, 25, "Text"],
Cell[16349, 437, 234, 4, 69, "Input",
  InitializationCell->True],
Cell[16586, 443, 84, 4, 25, "Text"],
Cell[16673, 449, 256, 5, 69, "Input",
  InitializationCell->True],
Cell[16932, 456, 83, 4, 25, "Text"],
Cell[17018, 462, 206, 4, 69, "Input",
  InitializationCell->True],
Cell[17227, 468, 85, 4, 25, "Text"],
Cell[17315, 474, 335, 6, 89, "Input",
  InitializationCell->True],
Cell[17653, 482, 75, 4, 25, "Text"],
Cell[17731, 488, 191, 3, 69, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[17959, 496, 59, 1, 22, "SubsubsectionIcon"],
Cell[18021, 499, 192, 3, 69, "Input",
  InitializationCell->True],
Cell[18216, 504, 241, 5, 49, "Input",
  InitializationCell->True,
  CellTags->"Message"]
}, Closed]],

Cell[CellGroupData[{
Cell[18494, 514, 65, 1, 22, "SubsubsectionIcon"],
Cell[18562, 517, 85, 2, 29, "Input",
  InitializationCell->True],
Cell[18650, 521, 135, 4, 25, "Text"],
Cell[18788, 527, 439, 7, 109, "Input",
  InitializationCell->True],
Cell[19230, 536, 500, 9, 149, "Input",
  InitializationCell->True],
Cell[19733, 547, 86, 2, 29, "Input",
  InitializationCell->True]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{
Cell[19868, 555, 41, 0, 39, "SubsectionIcon"],

Cell[CellGroupData[{
Cell[19934, 559, 63, 1, 26, "SubsubsectionIcon"],
Cell[20000, 562, 88, 2, 29, "Input",
  InitializationCell->True],
Cell[20091, 566, 757, 14, 189, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[20885, 585, 52, 1, 22, "SubsubsectionIcon"],
Cell[20940, 588, 198, 4, 69, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[21175, 597, 113, 6, 21, "SubsubsectionIcon"],
Cell[21291, 605, 389, 8, 109, "Input",
  InitializationCell->True],
Cell[21683, 615, 181, 3, 53, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[21901, 623, 50, 1, 22, "SubsubsectionIcon"],
Cell[21954, 626, 167, 3, 49, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[22158, 634, 56, 1, 22, "SubsubsectionIcon"],
Cell[22217, 637, 408, 7, 89, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[22662, 649, 56, 1, 22, "SubsubsectionIcon"],
Cell[22721, 652, 438, 9, 69, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[23196, 666, 48, 1, 22, "SubsubsectionIcon"],
Cell[23247, 669, 87, 4, 25, "Text"],
Cell[23337, 675, 246, 6, 69, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[23620, 686, 86, 1, 22, "SubsubsectionIcon"],
Cell[23709, 689, 26, 0, 25, "Text"],
Cell[23738, 691, 252, 6, 49, "Input",
  InitializationCell->True],
Cell[23993, 699, 43, 1, 25, "Text"],
Cell[24039, 702, 1840, 31, 309, "Input",
  InitializationCell->True],
Cell[25882, 735, 43, 1, 25, "Text"],
Cell[25928, 738, 522, 11, 109, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[26487, 754, 57, 1, 22, "SubsubsectionIcon"],
Cell[26547, 757, 78, 4, 25, "Text"],
Cell[26628, 763, 106, 2, 29, "Input",
  InitializationCell->True],
Cell[26737, 767, 78, 4, 25, "Text"],
Cell[26818, 773, 107, 2, 29, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[26962, 780, 47, 1, 22, "SubsubsectionIcon"],
Cell[27012, 783, 62, 0, 25, "Text"],
Cell[27077, 785, 3774, 69, 709, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[30888, 859, 78, 4, 21, "SubsubsectionIcon"],
Cell[30969, 865, 61, 0, 25, "Text"],
Cell[31033, 867, 442, 9, 129, "Input",
  InitializationCell->True],
Cell[31478, 878, 65, 1, 29, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[31580, 884, 66, 1, 22, "SubsubsectionIcon"],
Cell[31649, 887, 97, 4, 25, "Text"],
Cell[31749, 893, 411, 8, 109, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[32197, 906, 54, 1, 22, "SubsubsectionIcon"],
Cell[32254, 909, 109, 6, 25, "Text"],
Cell[32366, 917, 316, 7, 109, "Input",
  InitializationCell->True]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{
Cell[32731, 930, 36, 0, 39, "SubsectionIcon"],

Cell[CellGroupData[{
Cell[32792, 934, 51, 1, 26, "SubsubsectionIcon"],
Cell[32846, 937, 339, 7, 109, "Input",
  InitializationCell->True]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{
Cell[33234, 950, 38, 0, 39, "SubsectionIcon"],

Cell[CellGroupData[{
Cell[33297, 954, 50, 1, 26, "SubsubsectionIcon"],
Cell[33350, 957, 2639, 51, 869, "Input",
  InitializationCell->True]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{
Cell[36038, 1014, 41, 0, 39, "SubsectionIcon"],

Cell[CellGroupData[{
Cell[36104, 1018, 50, 1, 26, "SubsubsectionIcon"],
Cell[36157, 1021, 92, 2, 29, "Input",
  InitializationCell->True],
Cell[36252, 1025, 963, 21, 249, "Input",
  InitializationCell->True],
Cell[37218, 1048, 2193, 35, 361, "Input",
  InitializationCell->True],
Cell[39414, 1085, 3910, 72, 1093, "Input",
  InitializationCell->True]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{
Cell[43373, 1163, 37, 0, 39, "SubsectionIcon"],

Cell[CellGroupData[{
Cell[43435, 1167, 48, 1, 26, "SubsubsectionIcon"],
Cell[43486, 1170, 37, 0, 25, "Text"],
Cell[43526, 1172, 909, 17, 169, "Input",
  InitializationCell->True],
Cell[44438, 1191, 2523, 48, 509, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[46998, 1244, 56, 1, 22, "SubsubsectionIcon"],
Cell[47057, 1247, 2541, 46, 605, "Input",
  InitializationCell->True]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{
Cell[49647, 1299, 38, 0, 39, "SubsectionIcon"],

Cell[CellGroupData[{
Cell[49710, 1303, 57, 1, 26, "SubsubsectionIcon"],
Cell[49770, 1306, 5346, 92, 1469, "Input",
  InitializationCell->True]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{
Cell[55165, 1404, 35, 0, 39, "SubsectionIcon"],

Cell[CellGroupData[{
Cell[55225, 1408, 50, 1, 26, "SubsubsectionIcon"],
Cell[55278, 1411, 387, 9, 74, "Input",
  InitializationCell->True]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{
Cell[55714, 1426, 35, 0, 39, "SubsectionIcon"],

Cell[CellGroupData[{
Cell[55774, 1430, 50, 1, 26, "SubsubsectionIcon"],
Cell[55827, 1433, 562, 12, 169, "Input",
  InitializationCell->True]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{
Cell[56438, 1451, 34, 0, 39, "SubsectionIcon"],

Cell[CellGroupData[{
Cell[56497, 1455, 62, 1, 26, "SubsubsectionIcon"],
Cell[56562, 1458, 106, 2, 29, "Input",
  InitializationCell->True],
Cell[56671, 1462, 288, 6, 89, "Input",
  InitializationCell->True],
Cell[56962, 1470, 333, 7, 109, "Input",
  InitializationCell->True],
Cell[57298, 1479, 164, 4, 49, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[57499, 1488, 58, 1, 22, "SubsubsectionIcon"],
Cell[57560, 1491, 2482, 48, 673, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[60079, 1544, 60, 1, 22, "SubsubsectionIcon"],
Cell[60142, 1547, 296, 5, 69, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[60475, 1557, 68, 1, 22, "SubsubsectionIcon"],
Cell[60546, 1560, 456, 9, 69, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[61039, 1574, 67, 1, 22, "SubsubsectionIcon"],
Cell[61109, 1577, 1357, 23, 429, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[62503, 1605, 59, 1, 22, "SubsubsectionIcon"],
Cell[62565, 1608, 350, 7, 109, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[62952, 1620, 55, 1, 22, "SubsubsectionIcon"],
Cell[63010, 1623, 9710, 173, 2509, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[72757, 1801, 57, 1, 22, "SubsubsectionIcon"],
Cell[72817, 1804, 3359, 66, 1169, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[76213, 1875, 70, 1, 22, "SubsubsectionIcon"],
Cell[76286, 1878, 5500, 91, 2029, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[81823, 1974, 70, 1, 22, "SubsubsectionIcon"],
Cell[81896, 1977, 5957, 91, 1984, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[87890, 2073, 70, 1, 22, "SubsubsectionIcon"],
Cell[87963, 2076, 228, 8, 25, "Text"],
Cell[88194, 2086, 2703, 40, 584, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[90934, 2131, 70, 1, 22, "SubsubsectionIcon"],
Cell[91007, 2134, 1537, 26, 374, "Input",
  InitializationCell->True],
Cell[92547, 2162, 289, 4, 69, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[92873, 2171, 62, 1, 22, "SubsubsectionIcon"],
Cell[92938, 2174, 2127, 40, 589, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[95102, 2219, 61, 1, 22, "SubsubsectionIcon"],
Cell[95166, 2222, 242, 5, 69, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[95445, 2232, 67, 1, 22, "SubsubsectionIcon"],
Cell[95515, 2235, 1128, 18, 245, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[96680, 2258, 64, 1, 22, "SubsubsectionIcon"],
Cell[96747, 2261, 11643, 203, 1982, "Input",
  InitializationCell->True],
Cell[108393, 2466, 250, 5, 49, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[108680, 2476, 48, 1, 22, "SubsubsectionIcon"],
Cell[108731, 2479, 49, 0, 25, "Text"],
Cell[108783, 2481, 579, 11, 113, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[109399, 2497, 61, 1, 22, "SubsubsectionIcon"],
Cell[109463, 2500, 21783, 351, 5736, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[131283, 2856, 67, 1, 22, "SubsubsectionIcon"],
Cell[131353, 2859, 2237, 37, 729, "Input",
  InitializationCell->True]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{
Cell[133639, 2902, 41, 0, 39, "SubsectionIcon"],

Cell[CellGroupData[{
Cell[133705, 2906, 50, 1, 26, "SubsubsectionIcon"],
Cell[133758, 2909, 163, 7, 25, "Text"],
Cell[133924, 2918, 407, 8, 149, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[134368, 2931, 65, 1, 22, "SubsubsectionIcon"],
Cell[134436, 2934, 185, 4, 49, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[134658, 2943, 57, 1, 22, "SubsubsectionIcon"],
Cell[134718, 2946, 71, 2, 29, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[134826, 2953, 63, 1, 22, "SubsubsectionIcon"],
Cell[134892, 2956, 720, 12, 229, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[135649, 2973, 62, 1, 22, "SubsubsectionIcon"],
Cell[135714, 2976, 256, 5, 69, "Input",
  InitializationCell->True]
}, Closed]]
}, Open  ]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

